C                   --------------------------------
                     SUBROUTINE AXEQB (A1,X,B1,JJJ)
C                   --------------------------------
C
C                   BEARBEITET: 201719 DEC 95 (HUNDT)
C
      IMPLICIT NONE
      INTEGER *4 JJJ
      REAL    *4 A1(3,3),X(3,3),B1(3,3)
C
C     ***** SOLUTION OF MATRIX EQUATION AX=B FOR X *****
C     ***** USES METHOD OF TRIANGULAR ELIMINATION *****
C     ***** B AND X HAVE DIMENSIONS (3,JJJ),A IS ALWAYS (3,3)
C     ***** TO INVERT A MAKE B 3 BY 3 IDENITY MATRIX *****
C
      INTEGER *4 I,J,NV,L,IPO,K,N,M
      REAL    *4 A(3,3),B(3,3),S,R,TEM
C
      NV=JJJ
C
C     ***** TRANSFER DATA *****
C
      DO  I=1,3
        DO  J=1,3
          IF (NV .GE. J) B(I,J)=B1(I,J)
          A(I,J)=A1(I,J)
        ENDDO
      ENDDO
C
C     ***** TRIANGULARIZE MATRIX A *****
C
      DO  I=1,2
        S=0.0
        DO  J=I,3
          R=ABS(A(J,I))
          IF (R .GE. S) THEN
            S=R
            L=J
          ENDIF
        ENDDO
        IF (L .NE. I) THEN
          DO  J=I,3
            S=A(I,J)
            A(I,J)=A(L,J)
            A(L,J)=S
          ENDDO
          DO  J=1,NV
            S=B(I,J)
            B(I,J)=B(L,J)
            B(L,J)=S
          ENDDO
        ENDIF
        TEM=A(I,I)
        IF (TEM .NE. 0.) THEN
          IPO=I+1
          DO  J=IPO,3
            IF (A(J,I) .NE. 0.) THEN
              S=A(J,I)/TEM
              A(J,I)=0.0
              DO  K=IPO,3
                A(J,K)=A(J,K)-A(I,K)*S
              ENDDO
              DO  K=1,NV
                B(J,K)=B(J,K)-B(I,K)*S
              ENDDO
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C
C     ***** MODIFY SINGULAR MATRIX *****
C
      DO  I=1,3
        IF (A(I,I) .EQ. 0.)
     1    A(I,I)=AMAX1(1.E-25,AMAX1(A(1,1),A(2,2),A(3,3))*1.E-15)
      ENDDO
      DO  K=1,NV
        DO  I=1,3
          N=4-I
          M=N+1
          TEM=B(N,K)
          IF (3 .GE. M) THEN
            DO  J=M,3
              TEM=TEM-A(N,J)*B(J,K)
            ENDDO
          ENDIF
          B(N,K)=TEM/A(N,N)
          X(N,K)=B(N,K)
        ENDDO
      ENDDO
      RETURN
      END
