C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                   -------------------------------
                     SUBROUTINE AXES (U,V,X,ITYPE)
C                   -------------------------------
C
      IMPLICIT NONE
      INTEGER *4 ITYPE
      REAL    *4 U(3),V(3),X(3,3)
C
C     ***** STORE THREE ORTHOGONAL VECTORS EACH 1 ANGSTROM LONG *****
C     ***** ITYPE .GT.0 FOR CARTESIAN,.LE.0 FOR TRICLINIC *****
C     *****IABSF(ITYPE)=1 W(1)=U,W(2)=(UXV),W(3)=UX(UXV) *****
C     *****IABSF(ITYPE)=2 W(1)=U,W(2)=(UXV)XU,W(3)=(UXV) *****
C     ***** ITYPE=0 W(1)=A,W(2)=(AXB)XA,W(3)=(AXB), ABC=CELL VECTORS ***
C
      INTEGER *4 I,IC,IT,J
      REAL    *4 W(3,3)
C
      IT=ITYPE
      IF (IT .EQ. 0) THEN
        U(1)=1.
        U(2)=0.
        U(3)=0.
        V(1)=0.
        V(2)=1.
        V(3)=0.
      ENDIF
      DO  J=1,3
        W(J,1)=U(J)
      ENDDO
      IF (IABS(IT) .EQ. 1) THEN
        CALL NORM (U,V,W(1,2),IT)
        CALL NORM (U,W(1,2),W(1,3),IT)
      ELSE
        CALL NORM (U,V,W(1,3),IT)
        CALL NORM (W(1,3),U,W(1,2),IT)
      ENDIF
      DO  I=1,3
        IF (IT .LE. 0) THEN
          IC=-1
        ELSE
          IC=1
        ENDIF
        CALL UNIT (W(1,I),X(1,I),IC)
      ENDDO
      RETURN
      END
