C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                --------------------------------------
                      SUBROUTINE decsym (BUF,IRC)
C                --------------------------------------
C
C--- Decodes symbolically given symmetry. (Original version:
C    KPSYDC from KPLOT, written by R. Hundt)
C
C     IRC
C       1:  Missing x, y or z.
C       3:  Translation not allowed.
C       5.  Invalid character.
C       6.  Multiple translations.
C       7.  Sign error.
C       8.  Multiple signs.
C       9.  Incomplete symmetry.
C       10. Prefactor not allowed.
C
C                --------------------------------------
C
      COMMON /KPFLIN/ KARTE(20),KARPOI
C
      INTEGER *1 LSTR(40),LH(4),ITAB(23),LTYP(4),KARTE1(80)
C
      INTEGER BUF(12),MTYP,MPOI,NZBUF(2)
C
      DIMENSION ITRANS(11),IFLG(4)
C
      EQUIVALENCE (LH(1),IH),(LTYP(1),MTYP)
      EQUIVALENCE (KARTE(1),KARTE1(1))
C
      DATA ITAB/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H,,1H+,1H-,
     1 1H ,1H.,1H/,1HX,1HY,1HZ,1Hx,1Hy,1Hz,1H'/
C      14
      DATA ITRANS/112,16,14,13,512,12,712,23,34,56,1112/,MTYP/1/
C
C
C                            What machine do we have?
      MPOI=1
      IF (LTYP(1) .EQ. 0) MPOI=4
C
C                            Search for legal character
      DO  I=KARPOI+1,80
        DO  J=1,22
          IF (KARTE1(I) .EQ. ITAB(J)) THEN
            IF (J .EQ. 14) GO TO 10
            GO TO 20
          ENDIF
        ENDDO
        GO TO 60
   10   CONTINUE
      ENDDO
      GO TO 60
C                          Convert without quotes
   20 KARPOI=I
      DO  J=1,40
        LSTR(J)=ITAB(14)
      ENDDO
      J=1
      DO  I=KARPOI,80
        DO  K=1,22
          IF (KARTE1(I) .EQ. ITAB(K)) GO TO 30
        ENDDO
        GO TO 50
   30   LSTR(J)=KARTE1(I)
        IF (J .GE. 40) GO TO 40
        J=J+1
      ENDDO
   40 I=40
      J=40
   50 LENG=J+1
      KARPOI=I
      GO TO 70
   60 CONTINUE
      CALL FLES (LSTR,NZBUF,4H10AE,10HSymmetry?$)
C
C                            CLEAR BUFFER AND FLAGS
      LENG=40
   70 DO 80 I=1,12
C  20 BUF(I)=0.
   80 BUF(I)=0
       IH=ITAB(14)
      IRC=0
      LINC=0
      IWDH=0
      LPOI=0
C
   90 DO 100 I=1,4
  100 IFLG(I)=0
C
  110 ITYP=0
      IVORZ=0
      IZFF=0
      KBUF=0
      IPKT=0
C                            GET (NEXT) CHARACTER
  120 IF (IWDH) 130,140,130
  130 IWDH=0
      GO TO 150
  140 LPOI=LPOI+1
  150 IF (LPOI-LENG) 160,240,500
  160 LH(MPOI)=LSTR(LPOI)
C                            IDENTIFY CHARACTER
  170 DO 180 IZCH=1,22
      IF (IH-ITAB(IZCH)) 180,190,180
  180 CONTINUE
C                            NOT FOUND, IF HERE
      IRC=5
      GO TO 999
C                            TEST IF DIGIT
  190 IF (IZCH-10) 200,200,230
C                            SET SIGN POSITIVE, IF NOT YET DONE
  200 IF (IVORZ) 220,210,220
  210 IVORZ=1
  220 IZFF=1
      KBUF=KBUF*10+IZCH-1
      IPKT=IPKT*10
      GO TO 120
C                            NOT A DIGIT
  230 IGO=IZCH-10
      IF (IGO .GT. 9) IGO=IGO-3
      GO TO (240,370,370,120,510,420,430,430,430),IGO
C            ,   +   -      .   /   X   Y   Z
C
C                            COMMA OR END OF BUFFER
  240 IF (ITYP) 280,250,280
  250 IF (IVORZ) 260,270,260
C                            X, Y OR Z MISSING
  260 IRC=1
      GO TO 999
C                            INCREMENT SEGMENT COUNTER
  270 LINC=LINC+4
      IF (LINC-8) 90,90,999
C                            TRANSLATION DONE
  280 IF (IFLG(1)) 290,300,290
C                            TRANSLATION DUBLICATE
  290 IRC=6
      GO TO 999
  300 IFLG(1)=1
C                            TEST SIGN
      IF (IVORZ) 310,310,320
  310 IRC=7
      GO TO 999
  320 IWDH=1
      IF (ITYP) 330,999,340
C                            CALCULATE IN TWELFTH
  330 ITYP=1
      I=(KBUF*12+IPKT/2)/IPKT
      GO TO 360
C                            SEARCH TRANSLATION IN TABLE
  340 DO 350 I=1,11
      IF (KBUF-ITRANS(I)) 350,360,350
  350 CONTINUE
C                            NOT FOUND
      IRC=3
      GO TO 999
C                            STORE TRANSLATION
  360 BUF(LINC+1)=I
C 260 BUF(LINC+1)=FLOAT(I)/12.
      GO TO 110
C                            SIGN
  370 IF (IVORZ) 380,400,380
  380 IF (ITYP) 280,390,280
C                            MULTIPLE SIGN
  390 IRC=8
C                            SET SIGN
  400 IVORZ=1
      IF (IGO-3) 120,410,120
  410 IVORZ=-1
      GO TO 120
C                            SLASH
  420 ITYP=1
      GO TO 120
C                            X, Y OR Z
  430 IF (ITYP) 280,440,280
  440 ITYP=IGO-5
C                            TEST FLAG
      IF (IFLG(ITYP)) 290,450,290
  450 IFLG(ITYP)=1
      IF (IVORZ) 470,460,470
  460 IVORZ=1
  470 IF (IZFF) 480,480,490
  480 KBUF=1
  490 BUF(LINC+ITYP)=KBUF*IVORZ
C 390 BUF(LINC+ITYP)=FLOAT(KBUF*IVORZ)
      GO TO 110
C                            SYMMETRY INCOMPLETE
  500 IRC=9
      GO TO 999
C                            DOT
  510 IPKT=1
      ITYP=-1
      IF (IVORZ) 120,520,120
  520 IVORZ=1
      GO TO 120
C
  999 RETURN
      END
