C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CFLES          ---------------------------------------
                SUBROUTINE FLES (AIN,NZBUF,LFRM,LTXT)
C  CY-ENG-     ---------------------------------------
C
C           Dieses Programm fuehrt das formatfreie Lesen aus.
C
C                 Geschrieben:  16.6.1981  (Hundt)
C                 Geaendert: 091455 NOV 98 (Hundt)
C
C              ---------------------------------------
C
      IMPLICIT NONE
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI,KAREND,KARBEG
      COMMON /KPFLIN/ KARTE,KARPOI
      INTEGER *4 NZBUF(*),INIT,IBLK,NTIN,NTOUT,ITSOFL,IPROTF,IBLKIG
      INTEGER *4 IRC,L1,L2,L3,L4,L5,L6,L7,L8,IBUBLK,IH,IBUK,NRET,IBUO
      INTEGER *4 I,LEER,KDEND,IRC2,KARCOU,NTSCR,IBUE,IBUS,J,JJ,JJJ,IERR
      INTEGER *4 STDIN
      PARAMETER (STDIN=5)
      REAL    *4 AIN(*)
      CHARACTER*1 DLR
      CHARACTER*1 LFRM(*),LTXT(*)
      INTEGER*1 KARTE1(80)
C     BYTE      KARTE1(80)
C
      SAVE INIT,NTIN,NTOUT,NTSCR,ITSOFL,IPROTF
      SAVE KARBEG,KAREND,KARCOU,IRC,IERR
C
C
      EQUIVALENCE (KARTE(1),KARTE1(1))
C
      DATA INIT/-1/,IBLK/4H    /
      DATA NTIN/5/,NTOUT/6/,NTSCR/0/,ITSOFL/0/,IPROTF/0/
      DATA IBLKIG/0/,KARBEG/1/,KAREND/80/,IH/0/,KARCOU/0/
      DATA IRC/0/,DLR/'$'/,IERR/0/,KDEND/4HEND /
      DATA L1/1/,L2/2/,L3/3/,L4/4/,L5/5/,L6/6/,L7/7/,L8/8/
C
      DATA IBUBLK/32/,IBUE/69/,IBUS/83/,IBUK/75/,IBUO/79/
C
C                            Test FERR/FOPT
C
      IH=ICHAR(LFRM(1))
      IF (IH-IBUK) 40,10,20
C                            Entry FERR
   10 ASSIGN 994 TO NRET
      GO TO 320
C
   20 IF (IH-IBUO) 40,30,40
C                            Entry FOPT (IOPT)
C
   30 IF (NZBUF(L1) .GT. 0) NTIN=NZBUF(L1)
      IF (NZBUF(L2) .GT. 0) NTOUT=NZBUF(L2)
      IF (NZBUF(L3) .GT. 0) NTSCR=NZBUF(L3)
      ITSOFL=NZBUF(L4)
      IPROTF=NZBUF(L5)
      IBLKIG=NZBUF(L6)
      IF (NZBUF(L7) .GT. 0) KARBEG=NZBUF(L7)
      IF (NZBUF(L8) .GT. 0) KAREND=NZBUF(L8)
      IF (INIT .NE. 0) THEN
        DO  I=1,20
          KARTE(I)=IBLK
        ENDDO
        INIT=0
        KARPOI=KAREND+1
      ENDIF
      GO TO 999
C
C                            Teste, ob noch Info vorhanden
   40 CONTINUE
      LEER=100
      IF (INIT .NE. 0) THEN
        KARPOI=KAREND+1
        INIT=0
      ENDIF
C
      IF (KARPOI .LE. KAREND) GO TO 230
      IF (ITSOFL) 250,130,250
C                            Schreibe Aufforderung
   80 DO  I=1,20
        KARTE(I)=IBLK
      ENDDO
      LEER=LEER-1
      IF (LEER .GT. 0) GO TO 95
      KARTE(1)=KDEND
      GO TO 185
C
   95 WRLINE=' '
      DO  I=1,72
        IF (LTXT(I) .EQ. '$') GO TO 110
        WRLINE(I:I)=LTXT(I)
      ENDDO
  110 CALL KPWRTE (-NTOUT)
C      WRITE (NTOUT,120) (LTXT(JJJ),JJJ=1,I)
C  120 FORMAT (72A1)
C                            Lies neue Karte
C
  130 IF (IRC .NE. -3) GO TO 170
      ASSIGN 150 TO NRET
      GO TO 320
  150 WRITE (WRLINE,160)
CYENG1
  160 FORMAT ('Schliessender Apostroph fehlt.')
CYENG2
CYENGY  160 FORMAT (' Missing closing quote.')
      CALL KPWRTE (NTOUT)
  170 CALL KPRDLN (NTIN,IRC2)
      IF (IRC2 .NE. 0) GO TO 990
      READ (RDLINE,180) KARTE
  180 FORMAT (20A4)
  185 KARCOU=KARCOU+1
      IF (IPROTF .NE. 0) THEN
        WRITE (WRLINE,390) KARCOU,KARTE
        CALL KPWRTE (NTOUT)
      ENDIF
      IF (NTSCR .GT. 0) THEN
        WRITE (WRLINE,180) KARTE
        CALL KPWRTE (NTSCR)
      ENDIF
      IF (NTOSYS .GT. 0 .AND. NTIN .EQ. STDIN) THEN
        WRITE (WRLINE,180) KARTE
        CALL KPWRTE (NTOSYS)
      ENDIF
      KARPOI=KARBEG-1
C                            Teste, ob Karte leer, wenn unter TSO
  230 IF (ITSOFL) 250,300,250
  240 IH=KARTE1(I)
      IF (IH-IBUBLK) 300,260,300
  250 I=KARPOI
  260 I=I+1
      IF (I-KAREND) 240,240,270
C
C                            Teste, ob innerhalb einer Apo- oder
C                            Klammerstruktur
  270 IF (IRC) 300,280,280
C                            Teste, ob nur auf Ende positioniert wird
C
  280 IH=ICHAR(LFRM(1))
      IF (IH-IBUE) 80,996,290
  290 IF (IH-IBUS) 80,996,80
C
C                            Werte Karte aus
C
  300 CALL FCNV (AIN,NZBUF,LFRM,KARTE,KARPOI,KAREND,IRC)
      IF (IRC) 130,999,310
  310 ASSIGN 410 TO NRET
C                            Schreibe Fehlermeldung.
C                            Kehre zum letzten nicht blanken Zeichen
C                            zurueck, wenn am Ende des Puffers.
C
  320 J=KARPOI
      JJ=KAREND
      GO TO 350
  330 IF (JJ-1) 360,360,340
  340 JJ=JJ-1
  350 IH=KARTE1(JJ)
      IF (IH-IBUBLK) 360,330,360
C
  360 IF (JJ-J) 370,380,380
  370 J=JJ
  380 JJ=(JJ+3)/4
      WRITE (WRLINE,390) KARCOU,(KARTE(JJJ),JJJ=1,JJ)
CYENG1
  390 FORMAT ('Zeile',I5,'->',20A4)
CYENG2
CYENGY  390 FORMAT (' Line ',I5,'->',20A4)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,400) (IBLK,I=1,J),DLR
CYENG1
  400 FORMAT ('**** Fehler',82A1)
CYENG2
CYENGY  400 FORMAT (' **** Error ',82A1)
      CALL KPWRTE (NTOUT)
      GO TO NRET,(150,410,994)
C
  410 GO TO (420,440,460,480,500,520,540),IRC
C
  420 WRITE (WRLINE,430) (LFRM(J),J=1,8)
CYENG1
  430 FORMAT ('Format-Fehler: ',8A1)
CYENG2
CYENGY  430 FORMAT (' Format error: ',8A1)
      CALL KPWRTE (NTOUT)
      GO TO 999
C
CYENG1
  440 WRLINE='Unerwartete Information.'
CYENG2
CYENGY  440 WRLINE=' Unexpected information.'
      CALL KPWRTE (NTOUT)
      GO TO 560
C
CYENG1
  460 WRLINE='String zu lang.'
CYENG2
CYENGY  460 WRLINE=' String too long.'
      CALL KPWRTE (NTOUT)
      GO TO 300
C
CYENG1
  480 WRLINE='Illegales Zeichen in Integerzahl.'
CYENG2
CYENGY  480 WRLINE=' Illegal character in integer number.'
      CALL KPWRTE (NTOUT)
      GO TO 560
C
CYENG1
  500 WRLINE='Illegales Zeichen in Gleitkommazahl.'
CYENG2
CYENGY  500 WRLINE=' Illegal character in floating point number.'
      CALL KPWRTE (NTOUT)
      GO TO 560
C
CYENG1
  520 WRLINE='Zahl zu gross.'
CYENG2
CYENGY  520 WRLINE=' Number too large.'
      CALL KPWRTE (NTOUT)
      GO TO 560
C
  540 WRITE (WRLINE,550) KARPOI
CYENG1
  550 FORMAT ('Ill. Adr. auf Puffer:',I6)
CYENG2
CYENGY  550 FORMAT (' Ill. adr. on buffer:',I6)
      CALL KPWRTE (NTOUT)
      GO TO 999
C
  560 IF (ITSOFL) 996,570,996
  570 CALL FCNV (AIN,NZBUF,1HS,KARTE,KARPOI,KAREND,IRC)
      GO TO 999
C
  990 CONTINUE
C
  992 WRITE (WRLINE,993) KARCOU
CYENG1
  993 FORMAT (15('*'),' Ende des Files.',I6,
     1 ' Zeilen gelesen. ',15('*'))
CYENG2
CYENGY  993 FORMAT (' ',15('*'),' End of file.',I6,
CYENGY     1 ' lines read. ',15('*'))
      CALL KPWRTE (NTOUT)
      IF (IERR .GT. 5) STOP
      IERR=IERR+1
      IF (NTIN .EQ. STDIN) STOP
      NZBUF(1)=-1
      GO TO 999
C
  994 IF (ITSOFL) 996,999,996
  996 KARPOI=KAREND+1
C
  999 RETURN
      END
