C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                      --------------------------
                        subroutine kprgs (KPIRC)
c                      --------------------------
c
c--- Das programm liest symmetrien ein und versucht daraus eine
c    raumgruppe abzuleiten.
c
c                 geschrieben: 110927 apr 1997 (Hundt)
c                   geaendert: 071513 sep 2005 (Hundt)
c
c                           ----------------
c
      IMPLICIT NONE
c
      include 'mispg.inc'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 i,j,k,l,iopt(8),ntout,iain(72),nzbuf(8),kdo,ntdis
      INTEGER *4 itt,itta,irc,iachse(3),kdz,kdend,kds,kdst,kdf,kdi
      INTEGER *4 kdrgs,kdes,kdos,kdsy,kdosy,kdhelp,kdrstr,kdost
      INTEGER *4 kdanal,kdmore,kdtz,kdtzur,kdc,kdtol,kdeof,kdget
      INTEGER *4 kdspg,kdg,orsz2e(3,24),kdfs,iskp15,kdsel,kdidg,kdrg
      INTEGER *4 kdoct,kdrtho,kdrdz,kdmkg,ntin,kdhotr,kdtzc,kdhtp
      INTEGER *4 filnam(21),ntfil,kdrtf,kdur,kdeds,irgz(35),nkndg(12)
      INTEGER *4 nsteu,KPIRC,kdrpfl
      REAL    *4 ain(72),hub(3),pkt(3),temp,temp2,x1(3)
      REAL    *4 rm(3,3),s1(3,3),tol,tol2,rtho(9),hotr(9),htp(9,3)
      LOGICAL *4 exist
      CHARACTER *80 cilnam
      EQUIVALENCE (ain(1),iain(1)),(ain(3),iachse(1))
      EQUIVALENCE (filnam(1),cilnam)
c
      DATA iopt/5,6,0,1, 0,0,0,0/,ntout/6/,tol/0.001/,ntfil/3/
      DATA (irgz(I),I=1,35)/48,50,59,68,70,85,86,88,125,126,129,130,
     1 133,134,137,138,141,142,201,203,222,224,227,228,31,33,61,62,
     2 146,148,155,160,161,166,167/
      data orsz2e/2,2,2, 2,2,0, 2,2,0, 0,2,2, -1,-1,-1, -2,2,0,
     + -2,-2,-2, 0,-2,-1, -2,-2,0, -2,-2,-2, -2,2,0, -2,2,0,
     + -2,2,-2, -2,2,-2, -2,2,-2, -2,2,-2, 0,2,-1, 0,2,-1,
     + -2,-2,-2, -1,-1,-1, -2,-2,-2, -2,-2,-2, -1,-1,-1, -3,-3,-3/
      DATA rtho/-1.,0.,1., 1.,-1.,0., 1.,1.,1./
      DATA hotr/-.33333333,.33333333,.33333333, -.33333333,-.66666666,
     + .33333333, .66666666,.33333333,.33333333/
      DATA htp/.66666666,.33333333,.0,-.33333333,.33333333,.0,.0,.0,1.,
     + .33333333,-.33333333,.0,.33333333,.66666666,.0,.0,.0,1.,
     + -.33333333,-.66666666,.0,.66666666,.33333333,.0,.0,.0,1./
      DATA kdz/4hZ   /,kdend/4hEND /,kds/4hS   /,kdst/4hST  /
      DATA rm/1.,0.,0., 0.,1.,0., 0.,0.,1./,kdrgs/4hRGS /,tol2/0.01/
      DATA kdes/4hES  /,kdos/4hOS  /,kdsy/4hSY  /kdosy/4hOSY /
      DATA kdhelp/4hHELP/,kdrstr/4hRSTR/,kdanal/4hANAL/,kdi/4hI   /
      DATA kdmore/4hMORE/,kdtz/4hTZ  /,kdtzur/4hTZUR/,kdc/4hC   /
      DATA kdtol/4hTOL /,kdeof/4hEOF /,kdget/4hGET /,kdost/4hOST /
      DATA kdrtf/4hRTF /,kdur/4hUR  /,kdeds/4hEDS /,kdf/4hF   /
      DATA kdspg/4hSPG /,kdg/4hG   /,kdfs/4hFS  /,filnam/20*0,1/
      DATA kdsel /4hSEL /,kdidg/4hIDG /,kdrg/4hRG  /,kdoct/4hOCT /
      DATA kdrtho/4hRTHO/,kdrdz/4hRDZ /,kdmkg/4hMKG /,ntin/5/
      DATA kdhotr/4hHOTR/,kdtzc/4hTZC /,kdhtp/4hHTP /,kdrpfl/4hRPFL/
      DATA nkndg/202,203,209,210,216,219,225,226,227,228,229,230/
C
c                   Set more-flag, not first setting
      iskp(2)=0
      iskp(15)=0
      nsteu=kpirc
      kpirc=0
c
    5 nsymdm=192
      call fles (iopt,iopt,1hO,2h?$)
      lptx=ntout
      ntdis=ntout
      do  i=1,3
        do  j=1,4
          sym(i,j,1)=0.
        enddo
        sym(i,i,1)=1.
      enddo
      isytyp(1,1)=1
      nsym=1
      iskp(1)=0
c                   Reset  'G'-flag
      iskp(13)=0
      if (nsteu .gt. 0) then
        iskp(13)=1
        call mihini
        filnam(21)=1
        cilnam='FOR007.DAT'
        if (nsteu .gt. 1) iskp(20)=1
        go to 375
      else
        call mihini
      endif
c
   10 iskp(16)=0
      call fles (kdo,nzbuf,2hAR,5hRGS>$)
      if (nzbuf(1) .le. 0) go to 10
      call cnvtup (kdo,1,4)
      if (kdo .eq. kdz   ) go to 100
      if (kdo .eq. kds   ) go to 110
      if (kdo .eq. kdst  ) go to 120
      if (kdo .eq. kdrgs ) go to 210
      if (kdo .eq. kdes  ) go to 220
      if (kdo .eq. kdos  ) go to 250
      if (kdo .eq. kdosy ) go to 250
      if (kdo .eq. kdost ) go to 250
      if (kdo .eq. kdsy  ) go to 260
      if (kdo .eq. kdhelp) go to 280
      if (kdo .eq. kdrstr) go to 5
      if (kdo .eq. kdanal) go to 290
      if (kdo .eq. kdmore) go to 300
      if (kdo .eq. kdtz  ) go to 310
      if (kdo .eq. kdtzc ) go to 310
      if (kdo .eq. kdrtho) go to 305
      if (kdo .eq. kdhotr) go to 306
      if (kdo .eq. kdhtp ) go to 307
      if (kdo .eq. kdtzur) go to 320
      if (kdo .eq. kdc   ) go to 340
      if (kdo .eq. kdtol ) go to 350
      if (kdo .eq. kdeof ) go to 360
      if (kdo .eq. kdget ) go to 370
      if (kdo .eq. kdrtf ) go to 380
      if (kdo .eq. kdur  ) go to 390
      if (kdo .eq. kdeds ) go to 400
      if (kdo .eq. kdspg ) go to 410
      if (kdo .eq. kdrg  ) go to 405
      if (kdo .eq. kdg   ) go to 420
      if (kdo .eq. kdfs  ) go to 430
      if (kdo .eq. kdsel ) go to 440
      if (kdo .eq. kdidg ) go to 450
      if (kdo .eq. kdoct ) go to 460
      if (kdo .eq. kdrdz ) go to 470
      if (kdo .eq. kdmkg ) go to 480
      if (kdo .eq. kdrpfl) go to 490
      if (kdo .eq. kdend ) go to 999
      write (WRLINE,'(a,a4,a)') 'No such command ''',kdo,'''.'
      CALL KPWRTE (ntdis)
   20 call fles (ain,nzbuf,1hE,2h?$)
      go to 10
c                            Z - Zelle
  100 call fles (zelle,nzbuf,3h6FE,24ha,b,c,alpha,beta,gamma?$)
      if (nzbuf(1) .gt. 0) then
        call miz
        if (iskp(14) .ne. 0) go to 380
        iskp(1)=1
      else
        write (WRLINE,'(a,6f10.5)') 'Cell constants:',zelle
        CALL KPWRTE (ntdis)
      endif
      go to 10
c                            S - Symmetrie
  110 call fles (ain,nzbuf,4h12FE,16ht1,s11,...,s33?$)
      if (nzbuf(1) .lt. 12) then
        write (WRLINE,'(a)') 'Too few parameters.'
        CALL KPWRTE (ntdis)
        go to 10
      endif
  112 nsym=nsym+1
      k=1
      do  i=1,3
        sym(i,4,nsym)=ain(k)
        k=k+1
        do  j=1,3
          sym(i,j,nsym)=ain(k)
          k=k+1
        enddo
      enddo
  111 call misyan (nsym,itt,iachse,hub,pkt,irc)
      if (irc .gt. 0) then
        nsym=nsym-1
        go to 10
      endif
      go to 125
c                            ST - Symmetrie durch typ
  120 do  i=1,11
        iain(i)=0
      enddo
      iain(2)=1
      call fles (ain,nzbuf,5h5I6FE,24htype,no,axis,pnt,glide?$)
      if (iain(1) .eq. 0 .or. abs(iain(1)) .eq. 5 .or.
     +  abs(iain(1)) .gt. 6) then
        write (WRLINE,'(a,i3,a)')
     +  'Type of symmetry',iain(1),' not allowed.'
        CALL KPWRTE (ntdis)
        go to 10
      endif
      itt=iain(1)
  125 itta=abs(itt)
c                            Teste, ob symmetrie schon vorhanden
      do  l=1,nsym-1
        do  j=1,4
          do  k=1,3
            if (abs(sym(k,j,l)-sym(k,j,nsym)) .gt. tol2) go to 126
          enddo
        enddo
        write (WRLINE,'(a,i3,a)')
     +  'Duplicate symmetry',nsym,' not accepted.'
        CALL KPWRTE (ntdis)
        nsym=nsym-1
        go to 10
  126   continue
      enddo

c                            Trage symmetrie-analyse ein
      if (kdo .ne. kdst) then
        do  i=1,3
          iachsr(i,nsym)=iachse(i)
          aupkt(i,nsym)=pkt(i)
          gleitk(i,nsym)=hub(i)
        enddo
        isytyp(1,nsym)=itt
        isytyp(2,nsym)=0
        if (abs(hub(1))+abs(hub(2))+abs(hub(3)) .gt. 0.1)
     +  isytyp(2,nsym)=1
      endif
c                            Teste vorsichtshalber, ob die zelle
c                            eingegeben wurde.
c
      if (iskp(1) .eq. 0) then
        if (itta .eq. 3 .or. itta .eq. 6) then
          do  i=1,3
            j=id2(i)
            k=id2(j)
            if (iachse(i) .ne. 0 .and. iachse(j) .eq. 0 .and.
     +        iachse(k) .eq. 0) then
              zelle(i+3)=120.
              call miz
              write (WRLINE,'(a,i2,a)')
     +        'Angle',i,' of cell parameters set to 120.'
              CALL KPWRTE (ntdis)
              iskp(1)=1
              if (kdo .ne. kdst) go to 10
              go to 127
            endif
          enddo
        endif
      endif
      if (kdo .ne. kdst) go to 10
c
  127 if (itta .eq. 1) then
        iain(3)=1
        iain(4)=0
        iain(5)=0
      endif
      if (abs(iain(3))+abs(iain(4))+abs(iain(5)) .eq. 0) go to 200
      do  i=3,5
        if (abs(iain(i)) .gt. 2) go to 200
      enddo
c
c--- Berechne kartesische koordinaten der achse.
c
      do  i=1,3
        x1(i)=iain(i+2)
      enddo
      temp=1000.
      k=1
      do  i=1,3
        temp2=dgt(i,1)*x1(1)+dgt(i,2)*x1(2)+dgt(i,3)*x1(3)
        dreh(1,i)=temp2
        if (abs(temp2) .lt. temp) then
          k=i
          temp=abs(temp2)
        endif
      enddo
      i=id2(k)
      j=id2(i)
      dreh(3,k)=0.
      dreh(3,i)=-dreh(1,j)
      dreh(3,j)=dreh(1,i)
      do  i=1,3
        j=id2(i)
        k=id2(j)
        dreh(2,i)=dreh(3,j)*dreh(1,k)-dreh(3,k)*dreh(1,j)
      enddo
c                            Normiere
      do  i=1,3
        temp2=0.
        do  j=1,3
          temp=dreh(i,j)
          temp2=temp2+temp*temp
        enddo
        temp=sqrt(temp2)
        if (temp .le. 0.) then
          write (WRLINE,'(a,i2,a)')
     +    'Nullvector',i,' found.'
          CALL KPWRTE (lptx)
          go to 10
        endif
        do  j=1,3
          dreh(i,j)=dreh(i,j)/temp
        enddo
      enddo
C                            Berechne die Transformationsmatrix
C                            sowie ihre Inverse.
      do  i=1,3
        do  j=1,3
          tra(i,j)=dreh(i,1)*dgt(1,j)+dreh(i,2)*dgt(2,j)+
     1             dreh(i,3)*dgt(3,j)
          trainv(j,i)=dreh(i,1)*dginv(j,1)+dreh(i,2)*dginv(j,2)
     1               +dreh(i,3)*dginv(j,3)
        enddo
      enddo
c                            Rotationsmatrix
      if (itta .eq. 1) then
        temp=0.
      else
        temp2=iain(2)
        temp=6.2831853*temp2/float(itta)
      endif
      rm(1,1)=1.
      temp2=cos(temp)
      rm(2,2)=temp2
      rm(3,3)=temp2
      temp2=sin(temp)
      rm(2,3)=-temp2
      rm(3,2)=temp2
      if (itt .lt. 0 .and. mod(iain(2),2) .ne. 0) then
        do  i=1,3
          do  j=1,3
            rm(i,j)=-rm(i,j)
          enddo
        enddo
      endif
c                            Matrixprodukte
      do  i=1,3
        do  j=1,3
          s1(i,j)=rm(i,1)*tra(1,j)+rm(i,2)*tra(2,j)+rm(i,3)*tra(3,j)
        enddo
      enddo
      nsym=nsym+1
      isytyp(1,nsym)=itt
      isytyp(2,nsym)=0
      do  i=1,3
        iachsr(i,nsym)=iain(i+2)
        aupkt(i,nsym)=ain(i+5)
        do  j=1,3
          sym(i,4,nsym)=0.
          sym(i,j,nsym)=trainv(i,1)*s1(1,j)+trainv(i,2)*s1(2,j)+
     +    trainv(i,3)*s1(3,j)
        enddo
      enddo
      if (itt .eq. -2 .or. itt .gt. 0) then
        if (abs(ain(9))+abs(ain(10))+abs(ain(11)) .ne. 0) then
          isytyp(2,nsym)=1
c
c                            Teste, ob der hub richtig liegt.
          do  i=1,3
            x1(i)=tra(i,1)*ain(9)+tra(i,2)*ain(10)+tra(i,3)*ain(11)
            gleitk(i,nsym)=ain(i+8)
          enddo
          if (itt .eq. -2) then
            if (abs(x1(1)) .gt. tol) then
              write (WRLINE,'(a,3f10.5)')
     +        'Glide vector not in mirror plane:',x1
              CALL KPWRTE (ntdis)
              go to 130
            endif
          else
            if (itt .gt. 1) then
              if (abs(x1(2))+abs(x1(3)) .gt. tol) then
                write (WRLINE,'(a,3f10.5)')
     +          'Skrew direction not direction of axis.',x1
                CALL KPWRTE (ntdis)
                go to 130
              endif
            endif
          endif
          do  i=1,3
            sym(i,4,nsym)=ain(i+8)
          enddo
  130     continue
        endif
      endif
      if (itt .ne. 1) then
        do  i=1,3
          x1(i)=ain(i+5)
        enddo
        do  i=1,3
          sym(i,4,nsym)=sym(i,4,nsym)+x1(i)-sym(i,1,nsym)*x1(1)-
     +                  sym(i,2,nsym)*x1(2)-sym(i,3,nsym)*x1(3)
        enddo
      endif
c                            Normiere translationsvektor
      do  i=1,3
        go to 150
  140   sym(i,4,nsym)=sym(i,4,nsym)+1.
  150   if (sym(i,4,nsym) .lt. 0.) go to 140
        go to 170
  160   sym(i,4,nsym)=sym(i,4,nsym)-1.
  170   if (sym(i,4,nsym) .ge. 1.) go to 160
      enddo
      if (iskp(2) .gt. 0) then
        write (wrline,'(a)') 'Symmetry generated:'
        CALL KPWRTE (ntout)
        write (WRLINE,'(i3,a,3(f10.5,3f5.1))')
     +   nsym,')',(sym(i,4,nsym),(sym(i,j,nsym),j=1,3),i=1,3)
        CALL KPWRTE (ntout)
      endif
      go to 10
c
  200 write (WRLINE,'(a,3i3,a)')
     +  'Axis',(iain(i),i=3,5),' not allowed.'
      CALL KPWRTE (ntdis)
      go to 10
c                            RGS - Raumgruppe suchen
  210 iskp(16)=0
      call mkgrp
      if (iskp(14) .ne. 0) go to 380
      call spgdt
      if (iskp(17) .eq. 1 .and. iskp(14) .eq. 0) then
        call rgrdz
        iskp(17)=2
        go to 290
      endif
      if (iskp(13) .ne. 0 .or. iskp(14) .ne. 0) go to 380
      go to 10
c                            ES - Entferne symmetrie
  220 iain(1)=0
      call fles (ain,nzbuf,3h2IE,9hfrom,to?$)
      if (nzbuf(1) .lt. 2) iain(2)=iain(1)
      i=iain(1)
      j=iain(2)
      if (i .le. 0 .or. i .gt. nsym .or. i .gt. j) then
        write (WRLINE,'(a)') 'Data incomplete or unusable.'
        CALL KPWRTE (ntdis)
        go to 10
      endif
c
      go to 240
  230 do  k=1,4
        do  l=1,3
          sym(l,k,i)=sym(l,k,j)
        enddo
      enddo
      i=i+1
  240 j=j+1
      if (j .le. nsym) go to 230
      nsym=i-1
      go to 10
c                            OS - Symmtrien ausgeben
  250 iain(1)=1
      iain(2)=nsym
      call fles (ain,nzbuf,3h2IE,9hfrom,to?$)
      if (iain(1) .le. 0 .or. iain(2) .gt. nsym .or.
     +  iain(1) .gt. iain(1)) then
        write (WRLINE,'(a)') 'Data incomplete or unusable.'
        CALL KPWRTE (ntdis)
        go to 10
      endif
      if (kdo .eq. kdosy) go to 270
      if (kdo .eq. kdost) go to 275
      do  i=iain(1),iain(2)
        write (WRLINE,'(i4,a,3(f9.5,3f5.1))')
     +  i,')',(sym(j,4,i),(sym(j,k,i),k=1,3),j=1,3)
        CALL KPWRTE (ntout)
      enddo
      go to 10
c                            SY - Symmetrie symbolisch
c
  260 call decsym (iain(11),i)
      if (i .ne. 0) then
        write (WRLINE,'(a)') 'Error in symmetry:'
        go to (261,10,263,10,265,266,267,268,269,271),i
  261   write (WRLINE(20:80),'(a)') 'Missing x, y or z.'
        go to 272
  263   write (WRLINE(20:80),'(a)') 'Translation not allowed.'
        go to 272
  265   write (WRLINE(20:80),'(a)') 'Invalid character.'
        go to 272
  266   write (WRLINE(20:80),'(a)') 'Multiple translations.'
        go to 272
  267   write (WRLINE(20:80),'(a)') 'Sign error.'
        go to 272
  268   write (WRLINE(20:80),'(a)') 'Multiple signs.'
        go to 272
  269   write (WRLINE(20:80),'(a)') 'Incomplete symmetry.'
        go to 272
  271   write (WRLINE(20:80),'(a)') 'Prefactor not allowed.'
  272   CALL KPWRTE (ntdis)
        go to 10
      endif
      nsym=nsym+1
      k=11
      do  i=1,3
        sym(i,4,nsym)=float(iain(k))/12.
        k=k+1
        do  j=1,3
          sym(i,j,nsym)=float(iain(k))
          k=k+1
        enddo
      enddo
      go to 111
c                            OSY - Symmetrien symbolisch ausgeben
  270 do  i=iain(1),iain(2)
        l=3
        do  j=1,3
          ain(l)=sym(j,4,i)
          l=l+1
          do  k=1,3
            ain(l)=sym(j,k,i)
            l=l+1
          enddo
        enddo
        call symenc (ain(3),ain(15),k)
        if (k .eq. 0) then
          write (WRLINE,'(i4,a,10a4)') i,') ',(ain(j),j=15,24)
          CALL KPWRTE (ntout)
        else
          write (WRLINE,'(i4,a,3(f9.5,3f5.1))')
     +    i,')',(sym(j,4,i),(sym(j,k,i),k=1,3),j=1,3)
          CALL KPWRTE (ntout)
          write (WRLINE,'(7x,a,i2,a)') 'Error',k
          CALL KPWRTE (ntout)
        endif
      enddo
      go to 10
c                            OST - Symmetrietypen ausgeben
  275 do  i=iain(1),iain(2)
        write (WRLINE,'(i3,a,i3,i2,a,3i3,a,3f8.5,a,3f8.5)')
     +  i,')',(ISYTYP(j,i),j=1,2),' [',(iachsr(j,i),j=1,3),
     +  ' ] P:',(aupkt(j,i),j=1,3),'; G:',(gleitk(j,i),j=1,3)
        CALL KPWRTE (lptx)
      enddo
      go to 10
c                            HELP - Drucke kommandos
  280 write (WRLINE,'(a)') 'Commands provided:'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'Z a b c alpha beta gamma  [10 10 10 90 90 90] (Cell constants)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     + 'S t1 s11 s12 s13 t2 ... s33 (Symmetry as matrix)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'SY ''symb. symmetry''  (Symmetry symbolically)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'ST type nr axis pnt gld  [- 1  0 0 0  0 0 0  0 0 0]  (Sy.-type)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'C  x y z  (Centering)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'ES from to  (Delete symmetries)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'OS  from to (List symmetries)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'OSY from to (List symmetries)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'ANAL (Analyse symmetries)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'MORE [0] (Amount of output)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'RGS (Search space group)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'RTF name  (Result to file)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'G name,A-flag  (GET/ANAL/RGS/RTF)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'TZ s11 s21 ... s33  (Transform cell)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'TZUR  x y z  (Transform cell origin)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'RDZ  (Reduce cell)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'TOL a e w (Toleranes for axis, planes, and angles)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)')
     +'GET filename (Information from file)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'EOF  (End of file)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'UR x,y,z  (Set origin and fix it)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'EDS  (Remove double symmetries)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'RSTR  (Restart program)'
      CALL KPWRTE (ntdis)
      write (wrline,'(a)') '... hit <CR> to continue'
      CALL KPWRTE (ntdis)
c      read (ntin,'(A4)') i
      call kprdln (5,i)
      write (WRLINE,'(a)') 'SPG no or symbol (Load generators of space g
     +roup)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'RG no or symbol  (Load complete space group
     +)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'FS   (First setting)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'SEL  (Select certain symmetries)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'MKG  (Make group)'
      CALL KPWRTE (ntdis)
      write (WRLINE,'(a)') 'END  (Terminate program)'
      CALL KPWRTE (ntdis)
      go to 20
c                            ANAL  - Symmetrien analysieren
  290 do  i=1,nsym
        call misyan (i,isytyp(1,i),iachsr(1,i),
     +               gleitk(1,i),aupkt(1,i),irc)
        if (irc .gt. 0) then
          isytyp(1,i)=0
        else
          isytyp(2,i)=-irc
        endif
      enddo
      call micksy (i)
      if (iskp(17) .eq. 2) go to 210
      if (iskp(14) .ne. 0) go to 380
      if (iskp(13) .ne. 0) go to 210
      go to 20
c                            MORE - mehr output
c
  300 call fles (iskp(2),nzbuf,2hIE,12h0,1,2 or 3?$)
      go to 10
c                            RTHO - Rhomboedrisch nach hexagonal obvers
  305 call mitz (rtho,irc)
      go to 20
c                            HOTR - Hexagonal obvers nach rhomboedrisch
  306 call mitz (hotr,irc)
      go to 20
c                            HTP - H nach primitiv
  307 iain(1)=1
      call fles (ain,nzbuf,2hIE,5hno.?$)
      if (iain(1) .le. 0 .or. iain(1) .gt. 3) go to 330
      call mitz (htp(1,iain(1)),irc)
      go to 10
c                            TZ - Transformiere zelle
c
  310 call fles (ain,nzbuf,3h9FE,16hs11,s21,..,s33?$)
      if (nzbuf(1) .lt. 9) go to 330
      call mitz (ain,irc)
      go to 10
c                            TZUR - Transformiere zellursprung
c
  320 do  i=1,3
        ain(i)=0.
      enddo
      call fles (ain,nzbuf,3h3FE,7hx,y,z?$)
      i=iskp(11)
      iskp(11)=0
      call miexso (ain)
      iskp(11)=i
      go to 10
c
  330 write (WRLINE,'(a)') 'Data incomplete or unusable.'
      CALL KPWRTE (ntdis)
      go to 10
c                            C - Zentrierung
c
  340 do  i=1,15
        ain(i)=0.
      enddo
      call fles (ain(13),nzbuf,3h3FE,7hx,y,z?$)
      k=1
      j=2
      do  i=13,15
        ain(k)=ain(i)
        ain(j)=1.
        k=k+4
        j=j+5
      enddo
      go to 112
c                            TOL - Toleranzen
c
  350 call fles (const(5),nzbuf,3h3FE,16htolv,tolp,tola?$)
      if (nzbuf(1) .gt. 0) go to 10
      write (WRLINE,'(3(a,f10.5))')
     + 'Tolv:',const(5),' Tolp:',const(6),' Tola:',const(7)
      CALL KPWRTE (ntdis)
      go to 10
c                            EOF - End of file
  360 if (iopt(1) .ne. 5) then
        iopt(1)=5
        iopt(4)=1
        call fles (ain,iopt,1hO,2h?$)
        close (ntfil)
        if (iskp(13) .ne. 0) then
          if (filnam(21) .ne. 0) go to 290
          go to 210
        endif
      endif
      go to 20
c                            GET - Get a file
c
  370 filnam(21)=1
      cilnam='FOR007.DAT'
      call fles (filnam,nzbuf,5h20AIE,16hName,A-Flag[1]?$)
      if (filnam(21) .lt. 0) then
        iskp(13)=0
        go to 10
      endif
  375 if (iskp(18) .ne. 0) go to 10
      inquire (file=cilnam,exist=exist)
      if (exist) then
        open (ntfil,file=cilnam,status='OLD')
        iskp(18)=1
        iopt(1)=ntfil
        iopt(4)=0
        call fles (ain,iopt,1hO,2h?$)
      else
        write (WRLINE,'(a,a)') 'File not found: ',cilnam
        CALL KPWRTE (ntdis)
        iskp(13)=0
      endif
      go to 10
c                            RTF - Result to file
c
  380 cilnam='RGS.OUT'
      if (iskp(13) .eq. 0) then
        call fles (filnam,nzbuf,4h20AE,6hName?$)
        if (iskp(14) .ne. 0) then
          write (WRLINE,'(a)') 'No file written due to errors.'
          CALL KPWRTE (ntdis)
          go to 10
        endif
      else
        iskp(13)=0
      endif
      open (ntfil,file=cilnam,status='UNKNOWN')
      if (iskp(9) .le. 0 .or. iskp(9) .gt. 230) then
        write (WRLINE,'(a)') 'No valid space group available.'
        CALL KPWRTE (ntdis)
        iskp(14)=5
      endif
      if (iskp(14) .ne. 0) then
        write (wrline,'(a,i2,a)') 'ECHO ''RGS: Error',iskp(14),'.'''
        CALL KPWRTE (ntfil)
        kpirc=iskp(14)
        go to 387
      endif
      write (wrline,'(a)') 'NDLG'
      CALL KPWRTE (ntfil)
      if (iskp(19) .ne. 0) then
        write (wrline,'(a)') 'MTRI;'
        CALL KPWRTE (ntfil)
      endif
      write (WRLINE,'(a,3f10.5)') 'TZUR',(orgsh(i),i=1,3)
      CALL KPWRTE (ntfil)
      write (WRLINE,'(a,3f12.7,a)') 'TZ ',(trabij(i,1),i=1,3),' ='
      CALL KPWRTE (ntfil)
      write (WRLINE,'(3x,3f12.7,a)') (trabij(i,2),i=1,3),' ='
      CALL KPWRTE (ntfil)
      write (WRLINE,'(3x,3f12.7)') (trabij(i,3),i=1,3)
      CALL KPWRTE (ntfil)
      i=iskp(9)
      k=0
      iskp15=iskp(15)
      if (i .lt. 3 .or. i .gt. 15) then
        do  j=1,24
          if (i .eq. irgz(j)) then
            k=j
            go to 385
          endif
        enddo
        j=0
      else
        j=1
        iskp15=0
      endif
  385 if (j .ne. 0) then
        if (iskp15 .eq. 0) then
          i=i*100+2
        else
          i=i*100+1
          iskp15=1
        endif
      else
        do  j=29,35
          if (i .eq. irgz(j)) then
            if (iskp15 .eq. 0) then
              i=i*100+1
            else
              if (j .gt. 28) then
                i=i*100+2
                iskp15=2
              else
                iskp15=0
              endif
            endif
            go to 386
          endif
        enddo
        iskp15=0
      endif
  386 continue
      if (iskp15 .eq. 1) then
        do  l=1,3
          x1(l)=float(orsz2e(l,k))/8.
        enddo
        write (WRLINE,'(a,3f10.5)') 'TZUR',(x1(l),l=1,3)
        CALL KPWRTE (ntfil)
      endif
      if (iskp15 .eq. 2) then
        write (WRLINE,'(a)') 'RTHO'
        CALL KPWRTE (ntfil)
      endif
      if (iskp(20) .ne. 0) then
        if (i .gt. 300 .and. i .lt. 1599) then
          i=i-1
          write (wrline,'(a,i6)') 'TZ 0 0 1  1 0 0  0 1 0; RG',i
          go to 388
        endif
      endif
      write (wrline,'(a,i6,a,2a4,a)')                        
     + 'RG',i,' (Following Int. Tables 3rd edition; HMS: ',  
     + (ISKP(I),I=6,7),')'                                   
c
  388 CALL KPWRTE (ntfil)
      if (iskp(19) .eq. 1) then
        write (wrline,'(a)') 'RPSY * * -2.0 -1; NPZ * *'
        CALL KPWRTE (ntfil)
      endif
c      do  i=1,12
c        if (iskp(9) .eq. nkndg(i)) then
c          j=kdf
c          if (i .gt. 10) j=kdi
c          write (wrline,'(a,a2,a,a,a2,a)')
c     +    'GTYA ',j,'; RPSY * * * * 1 ; NPZ ; NGLP ;',
c     +    'ECHO ''Lattice type ',j,'applied to atoms.'''
c         CALL KPWRTE (ntfil)
c        endif
c      enddo
  387 write (wrline,'(a)') 'CLSE;DLG'
      CALL KPWRTE (ntfil)
      close (ntfil)
      iskp(18)=0
      iskp(14)=0
      if (nsteu .ne. 0) go to 999
      go to 10
c                            UR - Ursprung fest
c
  390 call fles (x1,nzbuf,3h3FE,7hx,y,z?$)
      call miexso (x1)
      iskp(11)=1
      go to 10
c                            EDS - Entferne doppelte symmetrien
  400 call mirmsy (0)
      go to 20
c                            SPG oder RG - Raumgruppe laden
  405 iskp(16)=-1
  410 iskp(13)=1
      call mihini
      iskp(13)=0
      do  i=1,3
        do  j=1,4
          sym(i,j,1)=0.
        enddo
        sym(i,i,1)=1.
      enddo
      nsym=1
      call fles (iain(2),nzbuf,3h2AE,14HSpace group? $)
      i=0
      j=0
      call fcnv (iain,nzbuf,2hIE,iain(2),i,8,j)
      call cnvtup (iain(2),1,8)
      irc=-2
      if (j .ne. 0) go to 415
      if (iain(1) .le. 0 .or. iain(1) .gt. 230) then
        write (wrline,'(a)') 'Invalid space group number.'
        CALL KPWRTE (ntdis)
        go to 10
      endif
      irc=-1
  415 call spgcmp (iain,1,iain(2),irc)
      if (irc .ne. 0) then
        write (wrline,'(a)') 'Loading generators failed.'
        CALL KPWRTE (ntdis)
      else
        write (wrline,'(a,2a4,a,i4)') 'Generators loaded for HMS ',
     1  iain(3),iain(4),' No.',iain(2)
        CALL KPWRTE (ntdis)
        if (iain(2) .ge. 143 .and. iain(2) .le. 194) then
          do  i=29,35
            if (iain(2) .eq. irgz(i)) go to 416
          enddo
          zelle(6)=120.
          call miz
        endif
  416   if (iskp(16) .lt. 0) then
          call mkgrp
          if (iskp(14) .ne. 0) go to 380
        endif
      endif
      go to 10
c                            G - automatic on
  420 iskp(13)=1
      nsym=1
      call mihini
      go to 370
c                            FS - first setting always
  430 iskp(15)=1
      go to 20
c                            KEEP - Keep selected symmetries
  440 call mirmsy (1)
      go to 10
c                            IDG - Identifiziere untergruppe.
c
  450 call fles (iain(2),nzbuf,3h2AE,14HSpace group? $)
      i=0
      j=0
      call fcnv (iain,nzbuf,2hIE,iain(2),i,8,j)
      call cnvtup (iain(2),1,8)
      if (j .eq. 0) then
        iskp(16)=iain(1)
      else
        irc=-4
        call spgcmp (iain,1,iain(2),irc)
        iskp(16)=irc
      endif
      if (iskp(16) .le. 0 .or. iskp(16) .gt. 230) then
        write (wrline,'(a)') 'Invalid space group.'
        CALL KPWRTE (ntdis)
        go to 10
      endif
      call mkgrp
      if (iskp(14) .ne. 0) go to 380
      call spgdt
      go to 10
c                            OCT - Drucke koordinatentransformation.
  460 do  i=1,3
        do  j=1,3
          rm(j,i)=trabij(j,i)
        enddo
      enddo
      call minv (rm,3,ain(1),ain(2),ain(5))
      do  i=1,3
        write (wrline,'(3f10.6,5x,f10.6)') (rm(i,j),j=1,3),orgsh(i)
        CALL KPWRTE (ntdis)
      enddo
      go to 20
c                            RDZ - Reduziere zelle
  470 call rgrdz
      go to 20
c                            MKG - Erzeuge gruppe
  480 iskp(16)=-1
      call mkgrp
      if (iskp(14) .ne. 0) go to 380
      go to 20
c                            RPFL
c
  490 call fles (iskp(19),nzbuf,2hIE,17h0 / 1: no / yes?$)
      go to 10
c
  999 return
      END
