C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                      -------------------------
                        subroutine micksy (irc)
c                      -------------------------
c
      IMPLICIT NONE
      INTEGER *4 irc
c
c--- Programm zum testen, ob die von MISSYM produzierten symmetrien
c    eine "komische" lage haben. In dem fall wird versucht, sie
c    durch transformation in eine vernuenftige lage zu bringen.
c
c                 geschrieben: 301515 apr 1997 (Hundt)
c                   geaendert: 071517 may 2001 (Hundt)
c
c                      -------------------------
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
c
      INTEGER *4 NATDM
      PARAMETER (NATDM=3)
      INTEGER *4 i,j,k,jhs,jhsa,n,nhsa,n1,n2,n3,ianr,iz2
      INTEGER *4 nat,it1(3),it2(3),l,natlm,iwflg,jhz
      REAL    *4 temp,vx(3),vz(3),vyk(3),tol,rmccnt(9)
      REAL    *4 arccos,tmat(9),temp2,vy(3),vtt(5),tolcen(3)
      REAL    *4 att(3,NATDM),atk(4,NATDM),x(3,7),fsr,rzyl,x1(3),x2(3)
      REAL    *4 temp3,temp4,temp5,tlng,tstknd(3,4)
      EQUIVALENCE (tmat(1),vx(1)),(tmat(4),vy(1)),(tmat(7),vz(1))
      DATA vtt/0.,1.,-1.,2.,-2./,tol/0.01/
      DATA rmccnt/.5,.5,0., -.5,.5,0., 0.,0.,1./
c
      iskp(4)=1
      irc=0
      iwflg=0
      do  i=1,3
        tolcen(i)=const(5)/zelle(i)
      enddo
      if (iskp(2) .gt. 1) then
        write (WRLINE,'(a)') 'Symmetries given:'
        CALL KPWRTE (lptx)
        do  i=1,nsym
          write (WRLINE,'(i3,a,i3,i2,a,3i3,a,3f8.5,a,3f8.5)')
     +    i,')',(ISYTYP(j,i),j=1,2),' [',(iachsr(j,i),j=1,3),
     +    ' ] P:',(aupkt(j,i),j=1,3),'; G:',(gleitk(j,i),j=1,3)
          CALL KPWRTE (lptx)
        enddo
        write (WRLINE,'('' '')')
        CALL KPWRTE (lptx)
      endif
c
c--- Suche nach trivialer zellvergroesserung. Lehne dann analyse ab.
c
      j=0
      do  i=1,nsym
        if (isytyp(1,i) .eq. 1 .and. isytyp(2,i) .eq. 1) then
          do  n1=1,3
            n2=id2(n1)
            n3=id2(n2)
            if (sym(n1,4,i) .gt. 0.001 .and. sym(n2,4,i) .lt. 0.001
     +        .and. sym(n3,4,i) .lt. 0.001) then
              write (WRLINE,'(a,i2,a,i3)')
     +        'Unit-cell must be reduced first. Direction:',n1,
     +        ' symmetry nr:',i
              CALL KPWRTE (lptx)
              j=i
            endif
          enddo
        endif
      enddo
      if (j .ne. 0) then
        write (WRLINE,'(a)') 'No analyzation of symmetries.'
        CALL KPWRTE (lptx)
        irc=2
        go to 995
      endif
c
c--- Lege liste mit kandidaten an, die aus dem nullpunkt und
c    moeglicherweise vorhandenen zentrierungen besteht.
c
      do  i=1,3
        tstknd(i,1)=0.
      enddo
      iz2=1
      do  j=1,nsym
        if (isytyp(1,j) .eq. 1 .and. isytyp(2,j) .eq. 1) then
          if (iz2 .lt. 4) then
            iz2=iz2+1
            do  i=1,3
              tstknd(i,iz2)=gleitk(i,j)
            enddo
          else
            write (wrline,'(a)') 'More than 3 centering symmetries.'
            CALL KPWRTE (lptx)
            irc=2
            go to 995
          endif
        endif
      enddo
c
c--- Suche die achse hoechster zaehligkeit. Bei gleichrangigkeit
c    nimm die mit der einfachsten achsenrichtung.
c
   10 jhs=0
      jhz=0
      j=0
      n=100
      do  i=1,nsym
        k=abs(iachsr(1,i))+abs(iachsr(2,i))+abs(iachsr(3,i))
        jhsa=abs(isytyp(1,i))
        if (jhsa .gt. j .or. (jhsa .eq. j .and. k .lt. n)) then
          jhs=i
          j=jhsa
          n=k
        endif
      enddo
   20 jhz=isytyp(1,jhs)
      jhsa=abs(jhz)
      if (jhs .le. 1 .or. jhsa .le. 1) then
        irc=1
        go to 995
      endif
      if (iskp(2) .gt. 1) then
        write (WRLINE,'(a,i3,a,i3,a)')
     +  'Axis of symmetry:',jhsa,' no.',jhs,' chosen for direction z.'
        CALL KPWRTE (lptx)
      endif
c
c--- If the axis chosen is .le. 3, test the possibility that an
c    axis of higher symmetry could be generated.
c
      if (jhsa .le. 3) then
        n1=0
        n2=nsym
        do  i=2,nsym-1
          if (iabs(isytyp(1,i)) .le. 3) then
            do  j=i+1,nsym
              if (iabs(isytyp(1,j)) .le. 3) then
                irc=3
                call misprd (i,j,irc)
                if (iskp(14) .ne. 0) go to 999
                if (irc .eq. 0) then
                  n3=iabs(isytyp(1,nsym))
                  if (n3 .gt. n1) n1=n3
                endif
                irc=3
                call misprd (j,i,irc)
                if (iskp(14) .ne. 0) go to 999
                if (irc .eq. 0) then
                  n3=iabs(isytyp(1,nsym))
                  if (n3 .gt. n1) n1=n3
                endif
              endif
            enddo
          endif
        enddo
        n2=nsym-n2
        if (iskp(2) .gt. 1 .and. n2 .gt. 0) then
          write (WRLINE,'(i3,a)')
     +    n2,' new symmetries generated.'
          CALL KPWRTE (lptx)
        endif
        if (iwflg .eq. 0 .and. n1 .gt. jhsa) then
          if (iskp(2) .gt. 0) then
            write (WRLINE,'(a)')
     +      'Axis of higher symmetry detected. Process restarted.'
            CALL KPWRTE (lptx)
          endif
          go to 10
        endif
      endif
c
c--- Berechne transformationsmatrix
c
      do  i=1,3
        vz(i)=iachsr(i,jhs)
      enddo
      call mik (vz,vx,0,irc)
      if (irc .ne. 0) then
         write (WRLINE,'(a,3f12.8)') 'Nullvector given:',vz
         CALL KPWRTE (lptx)
         irc=2
         go to 995
      endif
      if (iwflg .ne. 0) go to 40
c
c--- Fange moeglichen kubischen fall ab.
c
      n=0
      if (jhsa .eq. 4) n=3
      if (jhsa .eq. 3) n=2
      if (n .ne. 0) then
c
c--- Suche n-achse, die mit der achse hoechster zaehligkeit
c    einen winkel von 54.73 grad bildet.
c
        do  k=2,nsym
          if (iabs(isytyp(1,k)) .eq. n) then
            do  j=1,3
              x1(j)=iachsr(j,k)
              x2(j)=iachsr(j,jhs)
            enddo
            temp=0.
            temp4=0.
            temp5=0.
            do  j=1,3
              temp2=tra(j,1)*x1(1)+tra(j,2)*x1(2)+tra(j,3)*x1(3)
              temp=temp+temp2*temp2
              temp3=tra(j,1)*x2(1)+tra(j,2)*x2(2)+tra(j,3)*x2(3)
              temp4=temp4+temp3*temp3
              temp5=temp5+temp2*temp3
            enddo
            temp2=temp*temp4
            if (abs(temp2) .lt. 0.00001) go to 30
            temp2=arccos(temp5/sqrt(temp2))
            if (abs(temp2-54.7356) .le. const(7) .or.
     +        abs(temp2-125.2644) .le. const(7)) then
c
c--- "Magischen" winkel gefunden; setze flag und testlaenge.
c
              if (iskp(2) .gt. 1) then
                write (WRLINE,'(a)') 'System must be cubic.'
                CALL KPWRTE (lptx)
              endif
              iskp(10)=1
              iwflg=1
              if (jhsa .ne. 3) then
                tlng=sqrt(temp4)
                go to 40
              else
                jhs=k
                tlng=sqrt(temp)
c
c--- Teste, ob die dreizaehlige achse durch den nullpunkt geht;
c    andernfalls muss transformiert werden.
c
                if (abs(aupkt(1,jhs))+abs(aupkt(1,jhs))+
     +            abs(aupkt(1,jhs)) .gt. 0.001) then
                  do  i=1,3
                    x1(i)=aupkt(i,jhs)
                  enddo
                  call miexso (x1)
                endif
                go to 20
              endif
            endif
          endif
   30     continue
        enddo
      endif
      if (jhsa .ge. 3) go to 40
c
c--- Suche weitere kandidaten fuer eine erneute transformation.
c
      n=0
      k=0
      temp2=1.E6
      do  i=2,nsym
        do  j=1,3
          vy(j)=iachsr(j,i)
        enddo
        do  j=1,3
          vx(j)=tra(j,1)*vy(1)+tra(j,2)*vy(2)+tra(j,3)*vy(3)
        enddo
        nhsa=iabs(isytyp(1,i))
        if (nhsa .gt. 1 .and. abs(vx(3)) .lt. const(6) .and.
     +    i .ne. jhs .and. nhsa .ne. 3) then
          if (nhsa .gt. k) then
            k=nhsa
            n=i
          else
            if (nhsa .eq. k) then
              temp=vx(1)*vx(1)+vx(2)*vx(2)
              if (temp .lt. temp2) then
                temp2=temp
                k=nhsa
                n=i
              endif
            endif
          endif
        endif
      enddo
      if (iskp(2) .gt. 1) then
        if (k .gt. 0) then
          write (WRLINE,'(a,i3,a,i3,a)')
     +    'Axis:',k,' no.',n,' chosen for direction x.'
        else
          write (WRLINE,'(a,i3,a,i3,a)')
     +    'No suitable axis found for direction x.'
        endif
        CALL KPWRTE (lptx)
      endif
      if (n .ne. 0) then
        do  j=1,3
          vx(j)=iachsr(j,n)
        enddo
        call mik (vz,vx,-1,irc)
        if (irc .ne. 0) then
           write (WRLINE,'(a)') 'Nullvector or parallel vectors:'
           CALL KPWRTE (lptx)
           write (WRLINE,'(6f12.8)') vz,vx
           CALL KPWRTE (lptx)
           irc=2
           go to 995
        endif
c
c--- Teste, ob ein punkt vom typ 0,y,0 existiert.
c
        do  n1=1,5
          vy(1)=vtt(n1)
          do  n2=1,5
            vy(2)=vtt(n2)
            do  n3=1,5
              if (n1+n2+n3 .gt. 3) then
                vy(3)=vtt(n3)
                do  j=1,3
                  vyk(j)=tra(j,1)*vy(1)+tra(j,2)*vy(2)+tra(j,3)*vy(3)
                enddo
                if (abs(vyk(1)) .lt. const(6) .and.
     +            vyk(2) .gt. const(6) .and.
     +            abs(vyk(3)) .lt. const(6)) then
c
c--- Dritten kandidaten gefunden. Transformiere
c
                  if (iskp(2) .gt. 1) then
                    write (WRLINE,'(a,3f10.5,a)')
     +              'Point',vy,' chosen for y.'
                    CALL KPWRTE (lptx)
                  endif
c
c--- Bei einer drei- oder sechszaehligen achse ignoriere moegliche
c    andere symmetrien.
c
                  if (jhsa .eq. 3 .or. jhsa .eq. 6) go to 40
                  go to 280
                endif
              endif
            enddo
          enddo
        enddo
c                            Keinen dritten kandidaten gefunden.
      endif
c
c--- Teste, ob nicht moeglicherweise kubisch.
c
      if (jhsa .eq. 3 .and. n .eq. 0) then
        do  i=1,nsym
          if (iabs(isytyp(1,i)) .eq. 2) then
            if (iskp(2) .gt. 1) then
              write (WRLINE,'(a)') 'System seems to be cubic.'
              CALL KPWRTE (lptx)
            endif
            jhs=i
            iskp(10)=-1
            go to 20
          endif
        enddo
      endif
c
c--- Nichts brauchbares gefunden. Rastere den raum in einem zylinder ab.
c
   40 if (iskp(2) .gt. 1) then
        write (WRLINE,'(a)')
     +  'The plain perpendicular to z is searched for grid points.'
        CALL KPWRTE (lptx)
      endif
      fsr=0.3
      nat=0
      natlm=2
      if (jhsa .eq. 3 .or. jhsa .eq. 6) natlm=3
   50 rzyl=fsr*(zelle(1)+zelle(2)+zelle(3))
c
C--- Bestimme trikline Einschlussbox
c
      do  i=1,3
        x(i,6)=rzyl  ! Abmessung in kartesischen koordinaten
        x(i,1)=0.    ! Ursprung in triklinen koordinaten
        x(i,7)=0.
      enddo
      x(3,6)=const(6)
      do  i=-1,1,2
        x1(1)=float(i)*x(1,6)
        do  j=-1,1,2
          x1(2)=float(j)*x(2,6)
          do  k=-1,1,2
            x1(3)=float(k)*x(3,6)
            do  l=1,3
              x(l,7)=amax1(abs(trainv(l,1)*x1(1)+trainv(l,2)*x1(2)+
     +        trainv(l,3)*x1(3)),x(l,7))
            enddo
          enddo
        enddo
      enddo
c
C--- Bestimme obere und untere Grenze.
c
      do  i=1,3
        x(i,2)=x(i,1)-x(i,7)-.00001
        x(i,3)=x(i,1)+x(i,7)+.00001
      enddo
C                            Durchlaufe nullpunkt und
C                            ggf. zentrierungen.
      DO 250 IANR=1,IZ2
      do  i=1,3
        x(i,4)=tstknd(i,ianr)
      enddo
C                            Bestimme Grenzen.
      DO 170 I=1,3
      J=5
      TEMP=X(I,4)
      GO TO 70
C
   60 TEMP=TEMP-1.
      J=J-1
   70 IF (TEMP-1.-X(I,2)) 90,60,60
   80 TEMP=TEMP+1.
      J=J+1
   90 IF (TEMP-X(I,2)) 80,100,100
  100 K=J
      X(I,5)=TEMP
      GO TO 120
C
  110 TEMP=TEMP+1.
      K=K+1
  120 IF (TEMP+1.-X(I,3)) 110,110,140
  130 TEMP=TEMP-1.
      K=K-1
  140 IF (TEMP-X(I,3)) 150,150,130
  150 IF (K-J) 260,160,160
  160 IT1(I)=J
      IT2(I)=K
  170 CONTINUE
C                            Durchlaufe alle Translationen.
  180 X(1,4)=X(1,5)
      DO 240 I=IT1(1),IT2(1)
      X(2,4)=X(2,5)
      DO 230 J=IT1(2),IT2(2)
      X(3,4)=X(3,5)
      DO 220 K=IT1(3),IT2(3)
C                            Kartesische Box
  190 DO  L=1,3
        X2(L)=TRA(L,1)*X(1,4)+TRA(L,2)*X(2,4)+TRA(L,3)*X(3,4)
        IF (ABS(X2(L)) .GT. X(L,6)) GO TO 210
      ENDDO
      temp=x2(1)*x2(1)+x2(2)*x2(2)+x2(3)*x2(3)
      if (temp .lt. 0.001) go to 210
      temp=sqrt(temp)
c
c--- Im kubischen fall lasse nur die richtige groesse durch.
c
      if (iwflg .ne. 0) then
        if (abs(temp-tlng) .gt. const(5)) go to 210
      endif
c
C--- Teste, ob es bereits ein atom in der gleichen oder
c    umgekehrten richtung gibt. Merke das mit der kleinsten laenge.
c
      IF (NAT .GT. 0) THEN
        do  n=1,nat
          temp2=atk(1,n)*x2(1)+atk(2,n)*x2(2)+atk(3,n)*x2(3)
          if (abs(abs(temp2)-temp*atk(4,n)) .lt. 0.1) then
            if (temp .ge. atk(4,n)) go to 210
            go to 200
          endif
        enddo
      endif
c                            Nicht gefunden. Nimm auf.
      if (nat .ge. natlm) then
c
c                            Ueberschreibe ggf das mit der groessten laenge.
        n=1
        do  l=2,nat
          if (atk(4,l) .gt. atk(4,n)) n=l
        enddo
        if (temp .ge. atk(4,n)) go to 210
        go to 200
      endif
      nat=nat+1
      n=nat
  200 do  l=1,3
        att(l,n)=x(l,4)
        atk(l,n)=x2(l)
      enddo
      atk(4,n)=temp
      if (iskp(2) .gt. 1) then
        write (WRLINE,'(a,i2,a,3f10.5,a,f10.5)')
     +  'New point no.',n,'. ',(att(l,n),l=1,3),' length:',atk(4,n)
        CALL KPWRTE (lptx)
      endif
c
C                            Schleifenende
  210 X(3,4)=X(3,4)+1.
  220 CONTINUE
      X(2,4)=X(2,4)+1.
  230 CONTINUE
      X(1,4)=X(1,4)+1.
  240 CONTINUE
c                            Ende der "testkandidaten"
  250 continue
c                            Teste, ob transformation moeglich.
c
  260 if (nat .lt. natlm) then
        if (fsr .lt. 2.) then
c                            Versuche es mit vergroessertem bereich.
          fsr=fsr*1.5
          go to 50
        else
          write (WRLINE,'(a)') 'Not enough points found.'
          CALL KPWRTE (lptx)
          go to 995
        endif
      endif
c                            Bei 6-zaehliger achse suche winkel
c                            von 120 grad.
c
      if (jhsa .eq. 6 .or. jhsa .eq. 3) then
        do  i=1,nat-1
          do  j=i+1,nat
            temp=arccos((atk(1,i)*atk(1,j)+atk(2,i)*atk(2,j)+
     +      atk(3,i)*atk(3,j))/(atk(4,i)*atk(4,j)))
            if (abs(temp-120.) .lt. const(7)) then
            go to 270
            endif
          enddo
        enddo
      endif
      i=1
      j=2
  270 if (atk(1,i)*atk(2,j)-atk(2,i)*atk(1,j) .lt. 0.) then
        k=i
        i=j
        j=k
      endif
      do  k=1,3
        vx(k)=att(k,i)
        vy(k)=att(k,j)
      enddo
  280 continue
c
c--- Vermeide transformationen, die eine achse invertieren.
c
      if (jhsa .ne. 3 .and. jhsa .ne. 6) then
        temp=tmat(7)+tmat(8)+tmat(9)
        if (temp .lt. 0.) then
          do  i=4,9
            tmat(i)=-tmat(i)
          enddo
        endif
        temp=vx(1)+vx(2)+vx(3)
        temp2=vy(1)+vy(2)+vy(3)
        if (temp .lt. 0. .or. temp2 .lt. 0.) then
          if (temp .lt. 0. .and. temp2 .lt. 0.) then
            do  i=1,6
              tmat(i)=-tmat(i)
            enddo
          else
            do  i=1,3
              temp3=vx(i)
              vx(i)=vy(i)
              vy(i)=temp3
              if (temp .lt. temp2) then
                vy(i)=-vy(i)
              else
                vx(i)=-vx(i)
              endif
            enddo
          endif
        endif
      endif
      call mitz (tmat,irc)
      if (iskp(14) .ne. 0) go to 999
c
c--- Buegele ggf. zelle
c
      if (jhsa .eq. 4) then
        zelle(1)=(zelle(1)+zelle(2))*.5
        zelle(2)=zelle(1)
        do  i=4,6
          zelle(i)=90.
        enddo
c
c--- Suche bei abwesenheit eine dreizaehligen achse nach einer
c    nicht erlaubten zentrierung und eleminiere diese.
c
        do  i=2,nsym
          if (abs(isytyp(1,i)) .eq. 3) go to 290
        enddo
        do  i=2,nsym
          if (isytyp(1,i) .eq. 1 .and. isytyp(2,i) .eq. 1) then
            if ((abs(sym(1,4,i)-0.5) .lt. tol) .and.
     +        (abs(sym(2,4,i)-0.5) .lt. tol) .and.
     +        (abs(sym(3,4,i)) .lt. tol)) then
              call mitz (rmccnt,irc)
              if (iskp(14) .ne. 0) go to 999
              go to 290
            endif
          endif
        enddo
      endif
      if (jhsa .eq. 6 .or. jhsa .eq. 3) then
        zelle(1)=(zelle(1)+zelle(2))*.5
        zelle(2)=zelle(1)
        zelle(4)=90.
        zelle(5)=90.
        zelle(6)=120.
      endif
      if (jhsa .eq. 2) then
        zelle(4)=90.
        zelle(5)=90.
      endif
  290 if (iskp(2) .gt. 0) then
        write (WRLINE,'(a)') 'Unit-cell idealized; new values used now:'
        CALL KPWRTE (lptx)
        write (WRLINE,'(3f10.4,3f10.3)') zelle
        CALL KPWRTE (lptx)
      endif
      call miz
      if (iskp(14) .ne. 0) go to 999
c                            Mache optional rotationsmatrizen
c                            ganzzahlig.
      if (iskp(5) .ne. 0) then
        do  i=1,nsym
          do  j=1,3
            do  k=1,3
              do  n=-2,2
                temp=float(n)
                if (abs(sym(k,j,i)-temp) .lt. const(8)) then
                  sym(k,j,i)=temp
                  go to 300
                endif
              enddo
  300         continue
            enddo
          enddo
        enddo
      endif
  990 irc=0
      iskp(12)=1
      call mirmsy (0)
  995 iskp(4)=0
  999 return
      END
