C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                      --------------------------
                        subroutine miexso (vekt)
c                      --------------------------
c
c--- Ausfuehrung einer ursprungsverschiebung bei den symmetrien sym
c    um den vektor vekt.
c
c                 geschrieben: 211435 feb 1997 (Hundt)
c
c                      --------------------------
c
      implicit none
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
c
      integer *4 i,k
      real    *4 vekt(3)
c
      if (iskp(11) .ne. 0) return
      do  i=2,nsym
        do  k=1,3
          sym(k,4,i)=sym(k,4,i)-vekt(k)+sym(k,1,i)*vekt(1)+
     1     sym(k,2,i)*vekt(2)+sym(k,3,i)*vekt(3)
          go to 20
   10     sym(k,4,i)=sym(k,4,i)+1.
   20     if (sym(k,4,i) .lt. .0) go to 10
          go to 40
   30     sym(k,4,i)=sym(k,4,i)-1.
   40     if (sym(k,4,i) .gt. .96) go to 30
          if (sym(k,4,i) .lt. .0) sym(k,4,i)=0.
          aupkt(k,i)=aupkt(k,i)-vekt(k)
        enddo
      enddo
      do  i=1,3
        orgsh(i)=orgsh(i)-vekt(i)
      enddo
      if (iskp(2) .gt. 1) then
        write (WRLINE,'(a,3f10.6)') 'New origin ',(orgsh(i),i=1,3)
        CALL KPWRTE (lptx)
      endif
      return
      END
