C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                  ----------------------------------
                     subroutine miftra (ispgs,irc)
c                  ----------------------------------
c
c--- Findet fuer monokline raumgruppen die transformationsmatrix,
c    die erforderlich ist, um die gefundene raumgruppe in die
c    standardaufstellung zu bringen.
c
c                 geschrieben: 211442 feb 1997 (Hundt)
c                   geaendert: 071018 aug 1998 (Hundt)
c
c                  ----------------------------------
c
      IMPLICIT NONE
C
      integer *4 ispgs(*),irc
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
c
      INTEGER *4 ispgnr,i,j,j1,j2,j3
      INTEGER *1 mgtyp(16)
      REAL    *4 tmat(3,3),vekt(3),bestmf(9),rch(3,3),temp,temp2
      REAL    *4 dumc(9),duma(9),arccos
      DATA mgtyp/0,0,0,0,1,0,2,1,3,0,0,1,2,2,3,0/
c                        5   7 8 9    12    15
      DATA bestmf/-1.,0.,0., 0.,-1.,0., 0.,0.,1./
      DATA rch/1.,0.,0., 0.,0.,1., -1.,0.,-1./
      DATA duma/1.,0.,0., 0.,-1.,0., -1.,0.,-1./
      DATA dumc/-1.,0.,-1., 0.,-1.,0., 0.,0.,1./
c
      irc=0
      ispgnr=ispgs(1)
      if (ispgnr .le. 2 .or. ispgnr .gt. 15) go to 999
      do  i=1,3
        do  j=1,3
          tmat(i,j)=0.
        enddo
      enddo
c
c--- Teste, ob b die ausgezeichnete achse ist.
c
      do  i=1,nsym
        if (abs(iachsr(1,i))+abs(iachsr(2,i))+
     1  abs(iachsr(3,i)) .ne. 0) go to 10
      enddo
      write (WRLINE,'(a)') 'Monoclinic without unique axis.'
      CALL KPWRTE (lptx)
      go to 999
c
   10 do  j1=1,3
        j2=id2(j1)
        j3=id2(j2)
        if ((iachsr(j1,i) .ne. 0) .and.(iachsr(j2,i) .eq. 0)
     1  .and.(iachsr(j3,i) .eq. 0)) go to 20
      enddo
      write (WRLINE,'(a)')
     + 'Transformation too complex. Unable to handle.'
      CALL KPWRTE (lptx)
      go to 999
c
   20 if (j1 .ne. 2) then
        if (j1 .eq. 1) then
          tmat(3,1)=1.
          tmat(1,2)=1.
          tmat(2,3)=1.
        else
          tmat(2,1)=1.
          tmat(3,2)=1.
          tmat(1,3)=1.
        endif
        call mitz (tmat,irc)
      endif
c
c--- Teste, ob der winkel beta stumpf ist.
c
      if (zelle(5) .lt. 90.) then
        call mitz (bestmf,irc)
      endif
c
c--- Teste, ob standardaufstellung.
c
      j3=mgtyp(ispgnr)
      j1=0
      j2=0
c                          Gleitspiegelebene vorhanden?
      if (j3 .ge. 2) then
c                          Suche die Richtung.
        do  i=1,nsym
          if ((isytyp(1,i) .eq. -2) .and. (isytyp(2,i) .eq. 1)) then
c
c                          Bei den raumgruppen 9 und 15 gibt es
c                          zwei gleitspiegelebenen. Nimm nicht die,
c                          die auch die zentrierung enthaelt.
c
            if (j3 .eq. 3 .and. sym(1,4,i) .ne. 0.
     +            .and. sym(3,4,i) .ne. 0.) go to 30
            if (sym(1,4,i) .eq. 0. .and. sym(3,4,i) .ne. 0.) then
              j2=2
              go to 40
            endif
            if (sym(1,4,i) .ne. 0. .and. sym(3,4,i) .eq. 0.) then
              j2=1
              go to 40
            endif
            j2=3
            go to 40
          endif
   30     continue
        enddo
   40 continue
      j3=j3-2
      endif
c                          Zentrierung vorhanden?
      if (j3 .gt. 0) then
c                          Suche die Richtung.
        do  i=1,nsym
          if ((isytyp(1,i) .eq. 1) .and. (isytyp(2,i) .eq. 1)) then
            if (sym(1,4,i) .ne. 0. .and. sym(3,4,i) .eq. 0.) then
              j1=1
              go to 50
            endif
            if (sym(1,4,i) .eq. 0. .and. sym(3,4,i) .ne. 0.) then
              j1=2
              go to 50
            endif
            j1=3
            go to 50
          endif
        enddo
   50   if (j2 .eq. 0) j2=id2(j1)
      else
        if (j2 .ne. 0) j1=id2(id2(j2))
      endif
c                          Muss ueberhaupt transformiert werden?
c
      if (j1 .eq. 0 .and. j2 .eq. 0) go to 70
      if (j1 .eq. 1 .and. j2 .eq. 2) go to 70
c
c--- Setze tmat
c
      do  i=1,3
        tmat(i,1)=rch(i,j1)
        tmat(i,2)=0.
        tmat(i,3)=rch(i,j2)
      enddo
      tmat(2,2)=1.
c                          Stehen die achsen richtig?
c
      if (j1 .eq. 2 .and. j2 .eq. 3) go to 60
      if (j1 .eq. 3 .and. j2 .eq. 1) go to 60
      tmat(2,2)=-1.
   60 continue
      call mitz (tmat,irc)
   70 continue
c
      j1=2
      j2=0
      if (ispgnr .eq. 3) go to 80
      if (ispgnr .eq. 4) then
        j2=1
        go to 80
      endif
      if (ispgnr .eq. 5) go to 80
c
c--- Bei raumgruppen zwischen 6 und 9 ursprung hinsichtlich b festlegen
c
      if ((ispgnr .ge. 6) .and. (ispgnr .le. 9)) then
        j2=1
        if (ispgnr .eq. 6) j2=0
        if (ispgnr .eq. 8) j2=0
        do  i=1,nsym
          if ((isytyp(1,i) .eq. -2) .and. (isytyp(2,i) .eq. j2)) then
            if (sym(2,4,i) .ne. 0.) then
              vekt(1)=0.
              vekt(2)=sym(2,4,i)/2.
              vekt(3)=0.
              write (WRLINE,'(a,3f10.5,a)') 'TZUR',vekt,' applied.'
              CALL KPWRTE (lptx)
              call miexso (vekt)
              go to 999
            endif
          endif
        enddo
      endif
      go to 90
c
   80 continue
      do  i=1,nsym
        if ((isytyp(1,i) .eq. j1) .and. (isytyp(2,i) .eq. j2)) then
          if ((sym(1,4,i) .ne. 0.) .or. (sym(3,4,i) .ne. 0.)) then
            vekt(1)=sym(1,4,i)/2.
            vekt(2)=0.
            vekt(3)=sym(3,4,i)/2.
            write (WRLINE,'(a,3f10.5,a)') 'TZUR',vekt,' applied.'
            CALL KPWRTE (lptx)
            call miexso (vekt)
            go to 999
          endif
        endif
      enddo
c                            Teste, ob bei nicht total festgelegten
c                            achsen eine intelligentere aufstellung
c                            gewaehlt werden sollte.
   90 continue
      j1=mgtyp(ispgnr)
      if (j1 .lt. 3) then
c
c                            Berechne den winkel zwischen c und -(a+c)
c
        vekt(1)=-dgt(1,1)-dgt(1,3)
        vekt(2)=-dgt(2,3)
        vekt(3)=-dgt(3,3)
        temp=sqrt(vekt(1)*vekt(1)+vekt(2)*vekt(2)+vekt(3)*vekt(3))
        if (j1 .eq. 0) then
          if (temp .lt. zelle(1) .or. temp .lt. zelle(3)) then
            j1=2
            if (zelle(1) .lt. zelle(3)) j1=1
          endif
        endif
        temp=arccos((vekt(1)*dgt(1,3)+vekt(2)*dgt(2,3)+
     +   vekt(3)*dgt(3,3))/(temp*zelle(3)))
        temp2=360.-zelle(5)-temp
        if (j1 .eq. 2) then
c                            Die c-achse ist festgelegt
c
          if (temp .lt. zelle(5)) call mitz (dumc,irc)
        endif
        if (j1 .eq. 1) then
c                            Die a-achse ist festgelegt
c
          if (temp2 .lt. zelle(5)) call mitz (duma,irc)
        endif
      endif
  999 return
      END
