C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                  ---------------------------------
                    subroutine mik (vz,vx,ntyp,irc)
c                  ---------------------------------
c
      IMPLICIT NONE
      INTEGER *4 ntyp,irc
      REAL    *4 vz(3),vx(3)
c
c--- Definition eines koordinatensystems. Ist ntyp=-1, wird der ueber
c    vx definierte vektor fuer die definition der x-richtung benutzt,
c    andernfalls sucht sich das programm selbst eine.
c
c                 geschrieben: 020930 may 1997 (Hundt)
c
c                     ----------------------------
c
      include 'mispg.inc'
      INTEGER *4 i,j,k
      REAL    *4 temp,temp2
c
c--- Berechne kartesische koordinaten der achse.
c
      irc=0
      temp=1000.
      k=1
      do  i=1,3
        temp2=dgt(i,1)*vz(1)+dgt(i,2)*vz(2)+dgt(i,3)*vz(3)
        dreh(3,i)=temp2
        if (abs(temp2) .lt. temp) then
          k=i
          temp=abs(temp2)
        endif
        dreh(1,i)=0.
      enddo
      if (ntyp .eq. 0) then
        dreh(1,k)=1.
      else
        do  i=1,3
          dreh(1,i)=dgt(i,1)*vx(1)+dgt(i,2)*vx(2)+dgt(i,3)*vx(3)
        enddo
      endif
      do  i=1,3
        j=id2(i)
        k=id2(j)
        dreh(2,i)=dreh(3,j)*dreh(1,k)-dreh(3,k)*dreh(1,j)
      enddo
      do  i=1,3
        j=id2(i)
        k=id2(j)
        dreh(1,i)=dreh(2,j)*dreh(3,k)-dreh(2,k)*dreh(3,j)
      enddo
c                            Normiere
      do  i=1,3
        temp2=0.
        do  j=1,3
          temp=dreh(i,j)
          temp2=temp2+temp*temp
        enddo
        temp=sqrt(temp2)
        if (temp .lt. 0.000001) then
          irc=1
          return
        endif
        do  j=1,3
          dreh(i,j)=dreh(i,j)/temp
        enddo
      enddo
c                            Berechne die Transformationsmatrix
C                            sowie ihre Inverse.
      do  i=1,3
        do  j=1,3
          tra(i,j)=dreh(i,1)*dgt(1,j)+dreh(i,2)*dgt(2,j)+
     1             dreh(i,3)*dgt(3,j)
          trainv(j,i)=dreh(i,1)*dginv(j,1)+dreh(i,2)*dginv(j,2)
     1               +dreh(i,3)*dginv(j,3)
        enddo
      enddo
c
      return
      END
