C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
      SUBROUTINE minv (a,n,det,iv,iw)
c
c--- Inversion einer (quadratischen) Matrix
c
      IMPLICIT NONE
      INTEGER *4 n,iv(n),iw(n),NMAX
      REAL    *4 a(n,n),det,TINY
      PARAMETER (NMAX= 4,TINY=1.0E-20)
C
      INTEGER *4 i,j
      REAL    *4 b(NMAX,NMAX)
C
      if (n .gt. NMAX) then
        det=0.
        go to 999
      endif
      do  i=1,n
        do  j=1,n
          b(i,j)=a(i,j)
          a(i,j)=0.
        enddo
        a(i,i)=1.
      enddo
C
      call ludcmp (b,n,NMAX,iv,det)
      if (det .eq. 0.) go to 999
      do i=1,n
        det=det*b(i,i)
      enddo
      if (abs(det) .lt. TINY) then
        det=0.
        go to 999
      endif
      do i=1,n
        call lubksb (b,n,NMAX,iv,a(1,i))
      enddo
  999 return
      END
