C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                      --------------------------
                        subroutine mirmsy (ntyp)
c                      --------------------------
c
c             Entfernt die doppelt vorhandenen symmetrien.
c
c                 geschrieben: 150925 may 1997 (Hundt)
c                   geaendert: 100941 may 2001 (Hundt)
c
c                         -------------------
c
      IMPLICIT NONE
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
c
      INTEGER *4 iflg(192),i1,i2,l,m,j,k,symbuf(10),irc,ntyp
      REAL    *4 tol,s(12)
      DATA tol/0.01/
c
      if (iskp(14) .ne. 0) go to 999
      if (ntyp .ne. 0) then
        do  l=1,192
          iflg(l)=0
        enddo
        call fles (iflg,symbuf,5H192IE,10Hn1,..,nm?$)
c
c                            Bringe zahlen auf die richtigen plaetze
        k=1
        do  l=k,192
   10     if (iflg(l) .ne. 0) then
            i1=l
            if (iflg(i1) .ne. i1) then
              i2=iflg(iflg(i1))
              if (iflg(i1) .eq. i2) then
                write (WRLINE,'(a)')
     +          'There may be no two equal numbers.'
                CALL KPWRTE (lptx)
                iflg(iflg(i1))=0
              else
                iflg(iflg(i1))=iflg(i1)
                iflg(i1)=i2
              endif
              go to 10
            endif
          endif
   20     continue
        enddo
      else
        do  l=1,nsym
          iflg(l)=1
        enddo
        do  l=1,nsym-1
          if (iflg(l) .ne. 0) then
            do  m=l+1,nsym
              if (iflg(m) .ne. 0) then
                do  i1=1,4
                  do  i2=1,3
                    if (abs(sym(i2,i1,l)-sym(i2,i1,m)) .gt. tol)
     +                go to 30
                  enddo
                enddo
                iflg(m)=0
                go to 30
              endif
   30         continue
            enddo
          endif
        enddo
      endif
      m=0
      do  l=1,nsym
        if (iflg(l) .ne. 0) then
          m=m+1
          do  i2=1,3
            do  i1=1,4
              sym(i2,i1,m)=sym(i2,i1,l)
            enddo
            iachsr(i2,m)=iachsr(i2,l)
            gleitk(i2,m)=gleitk(i2,l)
            aupkt(i2,m)=aupkt(i2,l)
          enddo
          isytyp(1,m)=isytyp(1,l)
          isytyp(2,m)=isytyp(2,l)
        endif
      enddo
      if (m .ne. nsym) then
        nsym=m
        if (iskp(2) .gt. 0) then
          write (WRLINE,'(i4,a)') m,' symmetries kept.'
          CALL KPWRTE (lptx)
          do  k=1,nsym
            do  m=1,3
              do  j=1,3
                s((m-1)*4+j+1)=sym(m,j,k)
              enddo
              s((m-1)*4+1)=sym(m,4,k)
            enddo
            call symenc (s,symbuf,irc)
            if (irc .eq. 0) then
              write (WRLINE,'(i3,a,6a4,a,2i2,a,2(i3,'',''),i3,a)')
     1        k,') ',(symbuf(m),m=1,6),' Typ:',(isytyp(m,k),m=1,2),
     2        ' [',(iachsr(m,k),m=1,3),']'
              CALL KPWRTE (lptx)
            else
              write (WRLINE,'(i3,a,3(f6.3,3f5.1),a,2i2)')
     1        k,')',(s(m),m=1,12),' Typ:',(isytyp(m,k),m=1,2)
              CALL KPWRTE (lptx  )
            endif
          enddo
        endif
      endif
  999 return
      END
