C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                     ---------------------------
                       subroutine mitsgz (i,irc)
c                     ---------------------------
c
      IMPLICIT none
      INTEGER *4 i,irc
      REAL    *4 temp,aidn(9)
c
c--- Es wird getestet, ob die i-te symmetrie anlass zu einer zell-
c    verkleinerung gibt. Sollte das der fall sein, wird diese
c    durchgefuehrt.
c
c                geschrieben: 241659 aug 1998  (Hundt)
c
c                     ---------------------------
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
c
      INTEGER *4 j,k,l
c                            Teste den rotationsteil auf identitaet.
      do  j=1,3
        do  k=1,3
          temp=0.
          if (j .eq. k) temp=1.
          if (abs(sym(j,k,i)-temp) .gt. 0.01) go to 20
        enddo
      enddo
c                            Zaehle im translationsteil die zahlen
c                            ungleich null.
      k=0
      do  j=1,3
        if (abs(sym(j,4,i)) .gt. 0.01) k=k+1
      enddo
      if (k .ne. 1) go to 20
c                            Genau eine gefunden. Stelle fest welche
C                            stelle.
      do  j=1,3
        if (abs(sym(j,4,i)) .gt. 0.01) go to 10
      enddo
   10 continue
      if (iskp(2) .gt. 0) then
        write (wrline,'(A,I4,A,f8.5,a,f8.5,a,f8.5,a)')
     +  'Cell reducing symmetry found at',i,':',
     +  sym(1,4,i),'+x,',sym(2,4,i),'+y,',sym(3,4,i),'+z'
        call kpwrte (lptx)
      endif
c                            Konstruiere transformantionsmatrix ...
      k=sym(j,4,i)*12.+0.1
      k=min0(k,12-k)
      if (k .eq. 0) go to 20
      if (k .eq. 5) k=1
      do  l=1,9
        aidn(l)=0.
      enddo
      aidn(1)=1.
      aidn(5)=1.
      aidn(9)=1.
      aidn((j-1)*4+1)=float(k)/12.
c
c                            ... und transformiere.
      call mitz (aidn,irc)
      irc=1
      return
c
   20 irc=0
      return
      END
