C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
c                 -----------------------------------
                   subroutine mkaetr (tmat,sym,nsym)
c                 -----------------------------------
c
c--- Fuehrt mit der matrix tmat bei den symmetrien 1..nsym eine
c    aehnlichkeitstransformation durch
c
c                       geschrieben: Hundt
c
c                 -----------------------------------
c
      implicit none
c
      real    *4 tmat(3,3),sym(3,4,*)
      integer *4 nsym
c
      integer *4 i,j,m,ib1(3),ib2(3)
      real    *4 al(3,3),sh(3,4),det
c
c                            Invertiere tmat
c
      do  i=1,3
        do  j=1,3
          al(i,j)=tmat(i,j)
        enddo
      enddo
      call minv (al,3,det,ib1,ib2)
      do  m=1,nsym
        do  i=1,3
          do  j=1,4
            sh(i,j)=al(i,1)*sym(1,j,m)+al(i,2)*sym(2,j,m)+
     1      al(i,3)*sym(3,j,m)
          enddo
        enddo
        do  i=1,3
          do  j=1,3
            sym(i,j,m)=sh(i,1)*tmat(1,j)+sh(i,2)*tmat(2,j)+
     1      sh(i,3)*tmat(3,j)
          enddo
          sym(i,4,m)=sh(i,4)
        enddo
        do  i=1,3
          go to 20
   10     sym(i,4,m)=sym(i,4,m)+1.
   20     if (sym(i,4,m) .lt. .0) go to 10
          go to 40
   30     sym(i,4,m)=sym(i,4,m)-1.
   40     if (sym(i,4,m) .gt. .96) go to 30
          if (sym(i,4,m) .lt. .0) sym(i,4,m)=0.
        enddo
      enddo
      return
      end
