C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                ------------------------------------
                  SUBROUTINE PERMUT (IARR,IP,JP,IRC)
C                ------------------------------------
C
C  Es wird die naechst-hoehere permutation auf dem bereich iarr
C  hergestellt, der bei ip beginnt und bei jp-1 endet. irc hat den
C  wert +1, wenn eine permutation durchgefuehrt wurde und am ende
C  den wert 0. Der bereich wird aber wieder auf seine kleinst-
C  moegliche anordnung gebracht.
C
C                 geschrieben: 281601 feb 2005  (Hundt)
C
C                ------------------------------------
C
      IMPLICIT NONE
      INTEGER *4 IARR(*),IP,JP,IRC,I,J,M
C
      IF (JP-IP .LT. 2) THEN
        IRC=0  ! Der bereich hat nur ein element.
        GO TO 999
      ENDIF
C
      IRC=1
      IF (IARR(JP-1) .GT. IARR(JP-2)) THEN
        M=IARR(JP-1)  ! Die letzten beiden elemente stehen schon
        IARR(JP-1)=IARR(JP-2)  ! nicht richtig. Vertausche sie.
        IARR(JP-2)=M
      ELSE
        DO  I=JP-2,IP,-1  ! Suche bruch.
          IF (IARR(I) .LT. IARR(I+1)) GO TO 10
        ENDDO
  10    IF (I .LT. IP) THEN
          IRC=0  ! Stelle anfangssituation wieder her.
          GO TO 20
        ENDIF
        M=IARR(I)  ! Bringe kleinsm�gliches nach vorne.
        DO  J=JP-1,I+1,-1
          IF (IARR(J) .GT. M) THEN
            IARR(I)=IARR(J)
            IARR(J)=M
            GO TO 20
          ENDIF
        ENDDO
  20    I=I+1
        J=JP
  30    J=J-1
        IF (I .LT. J) THEN
          M=IARR(I)
          IARR(I)=IARR(J)
          IARR(J)=M
          I=I+1
          GO TO 30
        ENDIF
      ENDIF
  999 RETURN
      END
