C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                        -------------------
                          SUBROUTINE SYMENC (SYM,AIN,IRC)
C                        -------------------
C
C     Das Programm codiert Symmetrien in symbolische SHELX-Form.
C
C                   Geschrieben: 011601 OCT 90 Hundt
C
C                        -------------------
C
      IMPLICIT NONE
c
      INTEGER*4 ITPOI(12),ITTAB(10),IZTAB(4)
c     INTEGER*4 ITPOI(12),ITTAB(19),IZTAB(4)
      INTEGER*4 IXTAB,I,i0,i1,i2,j0,j1,j2,IRC,iopoi
      REAL   *4 TOL,AIN(10),blank,temp,sym(*)
C
      DATA ITPOI/1,5,8,11,14,18,21,25,28,31,34,39/
      DATA ITTAB/4H1/12,4H1/61,4H/41/,4H35/1,4H21/2,4H7/12,4H2/33,
     1 4H/45/,4H611/,4H12  /
c     DATA ITPOI/1,9,17,21,29,37,40,48,56,60,68,76/
c     DATA ITTAB/4H0.08,4H3333,4H0.06,4H6667,4H0.25,4H0.33,4H3333,
c    +    4H0.41,4H6667,4H0.50,4H.583,4H3330,4H.666,4H6670,4H.750,
c    +    4H.833,4H3330,4H.916,4H667 /
      DATA IZTAB/4H0123,4H4567,4H89+-,4H,   /,IXTAB/4HXYZ /
       DATA TOL/0.0083/,BLANK/4H    /
C
C                            Init
      IRC=0
      IOPOI=0
      DO 20 I=1,10
   20 AIN(I)=BLANK
C                            Schleife durch Segmente
      DO 250 I0=1,9,4
      I1=0
      TEMP=SYM(I0)*12.
      I2=TEMP+TOL
      IF (ABS(FLOAT(I2)-TEMP)-TOL) 40,30,30
C
C                            Translation negativ oder >=1
   30 IRC=1
      GO TO 999
   40 IF (I2) 30,80,50
   50 IF (I2-12) 60,30,30
   60 J1=ITPOI(I2)
      J2=ITPOI(I2+1)-1
      DO 70 I=J1,J2
      IOPOI=IOPOI+1
      CALL COPYCH (ITTAB,I,1, AIN,IOPOI)
   70 CONTINUE
      I1=1
C
   80 SYM(I0)=FLOAT(I2)/12.
      DO 210 J0=1,3
      TEMP=SYM(I0+J0)
      I2=ABS(TEMP)+TOL
      IF (TEMP) 90,210,100
   90 I2=-I2
  100 IF (ABS(FLOAT(I2)-TEMP)-TOL) 120,110,110
C
C                            Nicht ganzzahlig
  110 IRC=3
      GO TO 999
  120 SYM(I0+J0)=I2
      IF (I2) 150,210,130
  130 IF (I1) 140,160,140
  140 IOPOI=IOPOI+1
      CALL COPYCH (IZTAB,11,1, AIN,IOPOI)
      GO TO 160
  150 IOPOI=IOPOI+1
      CALL COPYCH (IZTAB,12,1, AIN,IOPOI)
      I2=-I2
  160 I1=1
      IF (I2-9) 180,180,170
C                            Koeffizient > 9
  170 IRC=2
      GO TO 999
  180 IF (I2-1) 170,200,190
  190 IOPOI=IOPOI+1
      CALL COPYCH (IZTAB,I2+1,1, AIN,IOPOI)
  200 IOPOI=IOPOI+1
      CALL COPYCH (IXTAB,J0,1, AIN,IOPOI)
  210 CONTINUE
      IF (I1) 230,220,230
  220 IOPOI=IOPOI+1
      CALL COPYCH (IZTAB,1,1, AIN,IOPOI)
  230 IF (I0-5) 240,240,250
  240 IOPOI=IOPOI+2
      CALL COPYCH (IZTAB,13,2, AIN,IOPOI-1)
  250 CONTINUE
C
  300 IOPOI=(IOPOI+3)/4
C
  999 RETURN
      END
