C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C            -------------------------------
              SUBROUTINE UPLINX (AR,NSTEUS)
C CY-ENG-    -------------------------------
C
C       Interface fuer HP-LASERJET PII von Atari
C        geschrieben: 020733 MAY 1991  (Hundt)
C        erweitert fuer HP Desk Jet 550C 011112 NOV 1993 (Hundt)
C        geaendert:   060902 DEC 1996  (Hundt)
C        geaendert:   151113 MAY 2000  (Hundt)
C
C            -------------------------------
C
      IMPLICIT NONE
      INCLUDE 'WRBFR.INC'
C                            Zahl der Farbebenen
      INTEGER *4 NFRBEB,NFRBMD
      PARAMETER (NFRBEB=4,NFRBMD=16)
C
C                            Headerlaenge beim .PCX file
      INTEGER *4 IHDRLN,I1DRLN
      PARAMETER (IHDRLN=64,I1DRLN=2*IHDRLN)
      CHARACTER*8 YPOS8
C
      INTEGER*4 IAND,IOR,IEOR
      INTEGER*4 LENZL,LENSP,LENPLY,MATDIM,IXMAXD,IYMAXD,IFLDIM,KNEGZ
      INTEGER*4 MATIGS
      PARAMETER (LENZL=74,LENSP=3200,LENPLY=150,IFLDIM=1024)
      PARAMETER (MATDIM=LENZL*LENSP, IXMAXD=LENZL*32-1, IYMAXD=LENSP-1)
      PARAMETER (KNEGZ=-2147483647-1, MATIGS=MATDIM*NFRBEB)
C
      REAL*4    AR(*),XNEU,YNEU
      REAL*4    XZER,XFAKT,YZER,YFAKT,GENFKT
      REAL*4    POLYGN(2,LENPLY),BFX,BFY,FLAKT,FLMST(IFLDIM),AI
C
      INTEGER*4 NSTEUS,NSTEU
      INTEGER*4 IX,IY,INC,ITAB(36),ITABR(32),ITABL(32),IBITM(40)
      INTEGER*4 IXT,IYT,IXMAX,IYMAX,ITEMP,NRET2,NRET3
      INTEGER*4 NPEN,NPENH,I,J,K,L,IXWRT,IXBIT
      INTEGER*4 IPRSTR,IGRPLY(2,0:LENSP-1),IPOLPO
      INTEGER*4 IYWRT,IYBIT,IFLAKT,IFLPOI(11),IPERIM
      INTEGER*4 IFLMST(IFLDIM),IFLSTA,IFLSTW,IFLWPL,IFLADR,IFLEFP
      INTEGER*4 M,N,IPRLNE,ILSOLL,IEOL,IPOI,OPOI,JC,ILIST
      INTEGER*4 IXTP,IXTM,IYTT,IFRBTT(NFRBMD,3),IAKTPL(NFRBEB)
      INTEGER*4 IFARBE,SFARBE,IBLL,IFMT,IPLSOL,NTOUT,IFLAG
      INTEGER*4 IAKTLN,IPOIS,EOL,IVRCNT,IBTCOU
      INTEGER*4 I4BYTE,LLINE(0:79),FRBCOD,KEYIN,ISW
      INTEGER*4 IXA(2),IXN(2),IDEL(2),IQ(2),IPOIL,IPOIK,INCK,INCL
C
      INTEGER*4 MATRIX(0:MATDIM-1,NFRBEB),MAT(0:MATIGS-1)
      INTEGER*2 IHDR(IHDRLN)
      INTEGER*1 M1TRIX(0:4*MATDIM-1,NFRBEB),I1TEMP(4),LQ(40)
      INTEGER*1 YPOS(8),RGEND(6),TCHAR,OLINE(320),I1HDR(I1DRLN)
      INTEGER*1 I1RCNT(4),I1TCOU(4),I1BYTE(4)
C
      SAVE XZER,YZER,XFAKT,YFAKT,BFX,BFY,IXA
      SAVE NPEN,NPENH,MATRIX,IXMAX,IYMAX,POLYGN,IPOLPO,IFLMST,IFLPOI
      SAVE IFLEFP,IPERIM,IFRBTT,IAKTPL,IFARBE,SFARBE,IFMT,NTOUT,IFLAG
      SAVE IHDR,FRBCOD
c     save
C
      EQUIVALENCE (MATRIX(0,1),M1TRIX(0,1),MAT(0)),(ITEMP,I1TEMP(1))
      EQUIVALENCE (IFLAKT,FLAKT),(IFLMST(1),FLMST(1)),(AI,I)
      EQUIVALENCE (YPOS(1),YPOS8),(IHDR(1),I1HDR(1))
      EQUIVALENCE (IVRCNT,I1RCNT(1)),(IBTCOU,I1TCOU(1))
      EQUIVALENCE (I4BYTE,I1BYTE(1)),(LLINE(0),OLINE(1))
C
c     DATA IHDR/Z050A,Z0101,4*0,300,300,ZFFFF,ZFFFF,
c    1 0,ZFF00,ZFF00,Z00FF,0,ZFFFF,ZFF00,ZFF00,Z00FF,0,ZAAAA,
c    2 Z66AA,Z6666,Z66FF,Z6699,Z99FF,Z9999,Z99FF,ZFFFF,ZAAFF,ZFF00,
c    3 ZFF99,Z0400,Z0008,Z0001,29*0/
      DATA IHDR/1290,257,0,0,0,0,300,300,-1,-1,0,-256,
     1 -256,255,0,-1,-256,-256,255,0,-21846,26282,26214,26367,26265,
     2 -26113,-26215,-26113,-1,-21761,-256,-103,1024,8,1,29*0/
      DATA IXA/0,0/,NPEN/1/,NPENH/0/
      DATA XZER,YZER/0.,0./, XFAKT,YFAKT/118.11,118.11/
      DATA IXMAX/IXMAXD/,IYMAX/IYMAXD/,IPERIM/1/
      DATA GENFKT/1./,IFMT/1/,NTOUT/6/
C                  0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
      DATA IFRBTT/14, 6,10, 2,12, 4, 8, 1,14, 6,10, 2,12, 4, 8, 0,
C                  0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
     1             7, 4, 2, 6, 1, 5,14, 8, 9,12,11,13,10,15, 3, 0,
     2             7, 4, 2, 6, 1, 5,14, 8, 9,12,11,13,10,15, 3, 0/
      DATA IAKTPL/NFRBEB*0/,IFARBE/-1/,SFARBE/15/
C
      DATA LQ/27,69,
C           <ESC> E  RESET
     1 27,38,108,48,79,
C    <ESC> &   l  0  O         PORTRAIT ORIENTATION
     2 27,38,108,48,76,
C    <ESC> &   l  0  L         SKIP PERF OFF
     3 27,42,114,98,67,
C    <ESC> *   r  b  C         End Raster Graphics
     4 27,42,114,45,52,85,
C    <ESC> *   r  -  4  U      4 Plane CMY Palette
     5 27,42,116,51,48,48,82,
C    <ESC> *   t  3  0  0  R   Set Raster Graphics Resolution
     6 27,42,114,48,65,
C    <ESC> *   r  0  A         Start Raster Graphics
     7 27,42,98,50,77/
C    <ESC> *  b  2  M          Set Compression Mode TIFF
C
      DATA YPOS/27,42,112,48,48,48,48,89/
C             <ESC> *   p  0  0  0  0  Y
      DATA RGEND/27,42,114,98,67, 12/
C              <ESC> *   r  b  C <FF>
      DATA BFX,BFY/118.11,118.11/
      DATA FRBCOD/2/
      DATA (IFLMST(I),I=1,12)/1,1,0, 1,1,-1,
C                             1      4
     1 1,4,-2004318072,0, 572662306, 0/
C      7                               13
      DATA IFLPOI/1,4,7,13,7*0/,IFLEFP/3/,IFLAG/1/
C
      DATA ITAB/0,0,0,0,128,64,32,16,8,4,2,1,32768,16384,8192,4096,2048,
     1 1024,512,256,8388608,4194304,2097152,1048576,524288,262144,
     2 131072,65536,KNEGZ,1073741824,536870912,268435456,134217728,
     3 67108864,33554432,16777216/
      DATA ITABL/128,192,224,240,248,252,254,255,33023,49407,57599,
     1 61695,63743,64767,65279,65535,8454143,12648447,14745599,15794175,
     2 16318463,16580607,16711679,16777215,-2130706433,-1056964609,
     3 -520093697,-251658241,-117440513,-50331649,-16777217,-1/
      DATA ITABR/-1,-129,-193,-225,-241,-249,-253,-255,-256,-33024,
     1 -49408,-57600,-61696,-63744,-64768,-65280,-65536,-8454144,
     2 -12648448,-14745600,-15794176,-16318464,-16580608,-16711680,
     3 -16777216,2130706432,1056964608,520093696,251658240,117440512,
     4 50331648,16777216/
      DATA IBITM/251658240,117440512,50331648,16777216,128,64,32,16,8,
     1 4,2,1,32768,16384,8192,4096,2048,1024,512,256,8388608,4194304,
     2 2097152,1048576,524288,262144,131072,65536,KNEGZ,1073741824,
     3 536870912,268435456,134217728,67108864,33554432,16777216,
     4 128,192,224,240/
C
C            -------------------------------
C
      NSTEU=NSTEUS
      IF (NSTEU) 9999,9999,10
   10 IF (NSTEU .GT. 24) GO TO 9999
      GO TO (20,50,50,330,340,20,9999,9999,9999,360,370,9999,350,9999,
C             1  2  3   4   5  6    7    8    9  10  11   12  13   14
     1      1130,420,430,9999,440,450,960,950,940,1160), NSTEU
C             15  16  17   18  19  20  21  22  23   24
C
C                       Initialisiere (1)
   20 IF (IFLAG .EQ. 0) GO TO 40
      DO 30 I=0,MATIGS-1
   30 MAT(I)=0
      IFLAG=0
   40 I=5
      GO TO 380
C                       Point (3) und Line (2)
C
   50 XNEU=AR(1)
      YNEU=AR(2)
      IFLAG=1
      ASSIGN 180 TO NRET2
      ASSIGN 9999 TO NRET3
C
   60 XNEU=XNEU*XFAKT+XZER
      YNEU=YNEU*YFAKT+YZER
C
C                       IFMT 0: Quer-, 1: Hochformat
C
      IF (IFMT .EQ. 0) THEN
        IXN(1)=YNEU
        IXN(2)=XNEU
      ELSE
        IXN(1)=XNEU
        IXN(2)=IYMAX-IFIX(YNEU)
      ENDIF
C
      IPOIL=1
      IPOIK=2
      IF (NSTEU .EQ. 3) THEN
        IQ(1)=IXN(1)
        IQ(2)=IXN(2)
        IF (IFARBE .NE. SFARBE) THEN
          IFARBE=SFARBE
          I=MOD(SFARBE,NFRBMD)
          I=IFRBTT(I+1,FRBCOD)
          DO 70 J=1,NFRBEB
            IAKTPL(J)=MOD(I,2)
            I=I/2
   70     CONTINUE
        ENDIF
        GO TO 150
      ENDIF
C
      IDEL(1)=IABS(IXN(1)-IXA(1))
      IDEL(2)=IABS(IXN(2)-IXA(2))
      IF (IDEL(1)+IDEL(2) .LE. 0) GO TO 120
      IQ(1)=IXA(1)
      IQ(2)=IXA(2)
      IF (IDEL(1) .LE. IDEL(2)) THEN
        IPOIK=1
        IPOIL=2
      ENDIF
      ISW=(IDEL(IPOIL)+1)/2
      INCK=1
      IF (IXN(IPOIK) .LT. IXA(IPOIK)) INCK=-1
      INCL=1
      IF (IXN(IPOIL) .LT. IXA(IPOIL)) INCL=-1
C
C                            Generiere Pixels
C
  100 IF (IQ(IPOIL) .EQ. IXN(IPOIL)) GO TO 110
      IQ(IPOIL)=IQ(IPOIL)+INCL
      ISW=ISW-IDEL(IPOIK)
      IF (ISW .GT. 0) GO TO 150
      ISW=ISW+IDEL(IPOIL)
      IF (IQ(IPOIK) .EQ. IXN(IPOIK)) GO TO 150
  105 IQ(IPOIK)=IQ(IPOIK)+INCK
      GO TO 150
  110 IF (IQ(IPOIK) .NE. IXN(IPOIK)) GO TO 105
      IXA(1)=IXN(1)
      IXA(2)=IXN(2)
  120 GO TO NRET3, (990,1020,1050,1110,9999)
C
  150 IXT=IQ(1)
      IYT=IQ(2)
      IF (IXT .LT. NPENH) IXT=NPENH
      IF (IXT .GT. IXMAX) IXT=IXMAX
      IF (IYT .LT. NPENH) IYT=NPENH
      IF (IYT .GT. IYMAX) IYT=IYMAX
      GO TO NRET2, (180,990)
  180 CONTINUE
C     IXBIT=(IXT .AND. 31)+5
      IXBIT=IAND(IXT,31)+5
      IXWRT=IXT/32
      I=LENZL*IYT+IXWRT
      DO 200 N=1,NFRBEB
      IF (IAKTPL(N) .EQ. 0) GO TO 190
C     MATRIX(I,N)=MATRIX(I,N) .OR. IBITM(IXBIT)
      MATRIX(I,N)=IOR(MATRIX(I,N),IBITM(IXBIT))
      GO TO 200
  190 CONTINUE
C     MATRIX(I,N)=MATRIX(I,N) .AND. (.NOT. IBITM(IXBIT))
      MATRIX(I,N)=IAND(MATRIX(I,N),IEOR(IBITM(IXBIT),-1))
  200 CONTINUE
C
C                       Teste Ueberhang
C
      IF (NPENH .LE. 0) GO TO 100
      J=IXBIT-NPENH
      IF (J .GT. 4) GO TO 230
      DO 220 N=1,NFRBEB
      IF (IAKTPL(N) .EQ. 0) GO TO 210
C     MATRIX(I-1,N)=MATRIX(I-1,N) .OR. IBITM(J)
      MATRIX(I-1,N)=IOR(MATRIX(I-1,N),IBITM(J))
      GO TO 220
  210 CONTINUE
C     MATRIX(I-1,N)=MATRIX(I-1,N) .AND. (.NOT. IBITM(J))
      MATRIX(I-1,N)=IAND(MATRIX(I-1,N),IEOR(IBITM(J),-1))
  220 CONTINUE
      GO TO 260
C
  230 J=IXBIT+NPENH
      IF (J .LT. 37) GO TO 260
      DO 250 N=1,NFRBEB
      IF (IAKTPL(N) .EQ. 0) GO TO 240
C     MATRIX(I+1,N)=MATRIX(I+1,N) .OR. IBITM(J)
      MATRIX(I+1,N)=IOR(MATRIX(I+1,N),IBITM(J))
      GO TO 250
  240 CONTINUE
C     MATRIX(I+1,N)=MATRIX(I+1,N) .AND. (.NOT. IBITM(J))
      MATRIX(I+1,N)=IAND(MATRIX(I+1,N),IEOR(IBITM(J),-1))
  250 CONTINUE
C
  260 K=I
      DO 290 J=1,NPENH
      K=K+LENZL
      I=I-LENZL
      DO 280 N=1,NFRBEB
      IF (IAKTPL(N) .EQ. 0) GO TO 270
C     MATRIX(I,N)=MATRIX(I,N) .OR. ITAB(IXBIT)
      MATRIX(I,N)=IOR(MATRIX(I,N),ITAB(IXBIT))
C     MATRIX(K,N)=MATRIX(K,N) .OR. ITAB(IXBIT)
      MATRIX(K,N)=IOR(MATRIX(K,N),ITAB(IXBIT))
      GO TO 280
  270 CONTINUE
C     MATRIX(I,N)=MATRIX(I,N) .AND. (.NOT. ITAB(IXBIT))
      MATRIX(I,N)=IAND(MATRIX(I,N),IEOR(ITAB(IXBIT),-1))
C     MATRIX(K,N)=MATRIX(K,N) .AND. (.NOT. ITAB(IXBIT))
      MATRIX(K,N)=IAND(MATRIX(K,N),IEOR(ITAB(IXBIT),-1))
  280 CONTINUE
  290 CONTINUE
      GO TO 100
C
C                       Set Origin (4)
  330 XZER=AR(1)*BFX
      YZER=AR(2)*BFY
      GO TO 9999
C                       Move Origin (5)
  340 XZER=XZER+AR(1)*BFX
      YZER=YZER+AR(2)*BFY
      GO TO 9999
C                       Define Factor (13)
  350 YNEU=AR(1)/GENFKT
      XFAKT=XFAKT*YNEU
      YFAKT=YFAKT*YNEU
      GENFKT=AR(1)
      GO TO 9999
C                       Farbe (10)
  360 AI=AR(1)
      SFARBE=I
      IF (SFARBE .NE. 16) GO TO 9999
      SFARBE=15
      IF (IFRBTT(1,1) .EQ. 0) SFARBE=0
      GO TO 9999
C                       Strichdicke (11)
  370 AI=AR(1)
  380 IF (I .EQ. NPEN) GO TO 9999
      IF (I .LE. 0) I=1
      IF (I .GT. 9) I=9
      NPENH=(I-1)/2
      NPEN=2*NPENH+1
C
      DO 410 I=1,32
      IX=I+NPENH
      IY=I-NPENH
      IF (IY .GT. 0) GO TO 390
      IBITM(I+4)=ITABL(IX)
      GO TO 410
C
  390 IF (IX .LT. 32) GO TO 400
      IBITM(I+4)=ITABR(IY)
      GO TO 410
C
  400 CONTINUE
C     IBITM(I+4)=ITABL(IX) .AND. ITABR(IY)
      IBITM(I+4)=IAND(ITABL(IX),ITABR(IY))
  410 CONTINUE
      IXMAX=32*LENZL-NPENH-1
      IYMAX=LENSP-NPENH-1
      GO TO 9999
C                      (16) 0: Quer- 1: Hochformat
  420 AI=AR(1)
      IFMT=I
      GO TO 9999
C                      (17) Report Treibertyp
  430 I=1
      AR(1)=AI
      GO TO 9999
C                      (19) Option fuer die Farbcodierung
C
  440 CONTINUE
C                      Restore PCX-Tabelle
      IF (AR(1) .EQ. 7.) THEN
        DO  J=1,16
          IFRBTT(J,2)=IFRBTT(J,3)
        ENDDO
        GO TO 9999
      ENDIF
C                      Neudefinition der PCX-Tabelle
      IF (AR(1) .EQ. 6.) THEN
        DO  J=1,16
          AI=AR(J+1)
          IF ((I .LT. 0) .OR. (I .GT. 15)) I=0
          IFRBTT(J,2)=I
        ENDDO
        GO TO 9999
      ENDIF
C                      Definition des Farbcode-Pointers
      IF (AR(1) .EQ. 4.) THEN
        AI=AR(2)
        IF (I .LT. 1) I=1
        IF (I .GT. 2) I=1
        FRBCOD=I
        GO TO 9999
      ENDIF
C                      Vertausche ggf. schwarz mit weiss
C
      IF (AR(1) .NE. 5.) GO TO 9999
      AI=AR(2)
      IF (I .EQ. 0) GO TO 442
      IFRBTT(1,1)=14
      IFRBTT(1,2)=7
      IFRBTT(16,1)=0
      IFRBTT(16,2)=0
      SFARBE=15
      GO TO 443
C
  442 IFRBTT(1,1)=0
      IFRBTT(1,2)=0
      IFRBTT(16,1)=14
      IFRBTT(16,2)=7
      SFARBE=0
  443 IFARBE=-1
      GO TO 9999
C                      Printe Matrix
  450 CONTINUE
      IF (IFLAG .EQ. 0) GO TO 9999
      AI=AR(1)
      IF (I .NE. 0) GO TO 740
C     WRITE (NTOUT,460) (I,I=1,3)
C 460 FORMAT (' ',3('----+----',I1),'--')
      CALL ZPRN (LQ,40)
  470 FORMAT ($,A)
C
      IPRLNE=0
      ILIST=0
      ILSOLL=0
      IBLL=1
      IPLSOL=0
      GO TO 690
C                            Zeile
  480 IPRLNE=IPRLNE+LENZL
      IF (KEYIN(0) .EQ. 27) GO TO 720
C                            Teste, ob Zeile leer
      DO 500 N=1,NFRBEB
      DO 490 J=1,LENZL
      IF (MATRIX(J+IPRLNE-1,N) .NE. 0) GO TO 510
  490 CONTINUE
  500 CONTINUE
      IBLL=IBLL+1
      IF (IBLL .LE. 1) GO TO 520
      ILSOLL=ILSOLL+1
      GO TO 690
C
  510 IBLL=0
  520 IXT=4*IPRLNE-1
C                            Komprimiere eine Zeile
      DO 680 N=1,NFRBEB
      IEOL=0
      IPOI=4*IPRSTR
      OPOI=7
C                            ermittle ...
  530 J=IPOI
      GO TO 550
C                            ... VERSCHIEDENARTIGE BYTES
  540 J=J+1
      IF (M1TRIX(J-1,N) .EQ. M1TRIX(J,N)) GO TO 560
  550 IF (J .LT. IXT) GO TO 540
      IEOL=1
      J=J+2
  560 JC=J-IPOI-1
      IF (JC .LE. 0) GO TO 600
C
C                            UND SCHREIBE BYTES AUF PUFFER,
  570 J=JC
      IF (J .GT. 128) J=128
      OPOI=OPOI+1
      OLINE(OPOI)=J-1
      DO 580 K=1,J
      OPOI=OPOI+1
      OLINE(OPOI)=M1TRIX(IPOI,N)
      IPOI=IPOI+1
  580 CONTINUE
      JC=JC-J
  590 IF (JC .GT. 0) GO TO 570
      IF (IEOL .NE. 0) GO TO 640
C
C                            ... ODER GLEICHARTIGE BYTES,
  600 J=IPOI
      TCHAR=M1TRIX(J,N)
C
  610 J=J+1
      IF (TCHAR .NE. M1TRIX(J,N)) GO TO 620
      IF (J .LT. IXT) GO TO 610
      IEOL=1
      IF (TCHAR .EQ. 0) GO TO 640
      J=J+1
  620 JC=J-IPOI
      IPOI=IPOI+JC
C                            UND SCHREIBE WIEDERHOLUNGSSEQUENZ.
  630 J=JC
      IF (J .GT. 128) J=128
      OPOI=OPOI+1
      OLINE(OPOI)=-J+1
      OPOI=OPOI+1
      OLINE(OPOI)=TCHAR
      JC=JC-J
      IF (JC .GT. 0) GO TO 630
      IF (IEOL .EQ. 0) GO TO 530
C
C                            Zeile ist fertig.
  640 IX=OPOI-7
      IF (IX .GT. 0) GO TO 650
      OPOI=OPOI+2
      OLINE(OPOI-1)=0
      OLINE(OPOI)=0
      IX=2
C                            Konvertiere Laengenzaehler.
  650 I=1
      IF (IX .LT. 100) I=I+1
      IF (IX .LT. 10) I=I+1
      ITEMP=IX/100
      OLINE(4)=I1TEMP(1)+48
      IX=IX-100*ITEMP
      ITEMP=IX/10
      OLINE(5)=I1TEMP(1)+48
      ITEMP=IX-10*ITEMP
      OLINE(6)=I1TEMP(1)+48
      OLINE(7)=86
      IF (N .EQ. NFRBEB) OLINE(7)=87
      OLINE(I)=27
      OLINE(I+1)=42
      OLINE(I+2)=98
      IF (ILSOLL .EQ. ILIST) GO TO 670
C
C                            Generiere Tabulator. Istzeile ist
C                            nicht Sollzeile.
C
      WRITE (YPOS8(4:7),660) ILSOLL
  660 FORMAT (I4)
      CALL ZPRN (YPOS,8)
      ILIST=ILSOLL
C
  670 CALL ZPRN (OLINE(I),OPOI-I+1)
  680 CONTINUE
      ILIST=ILIST+1
      ILSOLL=ILIST
C
  690 IPRSTR=IPRLNE
      IF (ILSOLL .LT. IPLSOL) GO TO 710
C     WRITE (NTOUT,700)
C 700 FORMAT ($,'*')
      IPLSOL=IPLSOL+100
  710 IF (KEYIN(0) .EQ. 27) GO TO 720
      IF (IPRSTR .LT. MATDIM-1) GO TO 480
  720 CALL ZPRN (RGEND,6)
C     WRITE (NTOUT,730)
C 730 FORMAT (' ')
      GO TO 9999
C                       Erzeuge einen .PCX - File
  740 CONTINUE
C                       Suche Start- und Endzeile, ...
      IY=LENSP
      IYT=-1
      DO 750 I=0,LENZL-1
  750 LLINE(I)=0
      DO 760 I=0,LENSP-1
      M=I*LENZL
      DO 760 N=1,NFRBEB
      DO 760 J=0,LENZL-1
      K=MATRIX(M+J,N)
      IF (K .EQ. 0) GO TO 760
      IY=MIN0(IY,I)
      IYT=I
C     LLINE(J)=(LLINE(J) .OR. K)
      LLINE(J)=IOR(LLINE(J),K)
  760 CONTINUE
      IF (IY .LE. IYT) GO TO 780
      WRITE (WRLINE,770)
CYENG1
  770 FORMAT ('Das Bild ist leer.')
CYENG2
CYENGY  770 FORMAT ('Image empty.')
      CALL KPWRTE (NTOUT)
      GO TO 9999
C
C                       ... Start- und Endbyte
  780 IX=296
      DO 790 I=1,4*LENZL
      IF (OLINE(I) .EQ. 0) GO TO 790
      IX=MIN0(IX,I)
      IXT=I
  790 CONTINUE
      IX=IX-1
      IXT=IXT-1
C     WRITE (NTOUT,800) IY,IYT,IX,IXT
C 800 FORMAT (' Zeilen Start/Ende',2I6,' Start-/Endbyte',2I10)
C
C                       Erzeuge Header
      ITEMP=IXT-IX+1            ! Zahl der Bytes in der Zeile
      IF (MOD(ITEMP,2) .EQ. 0) GO TO 820
      ITEMP=ITEMP+1
      IF (IX .LE. 0) GO TO 810
      IX=IX-1
      GO TO 820
  810 IXT=IXT+1
  820 INC=IX+NFRBEB*LENZL-IXT   ! Increment zur naechsten Zeile
      IHDR(34)=ITEMP            ! BYTES pro Zeile
      IHDR(5)=ITEMP*8-1         ! NR DES LETZTEN PIXELS
      IHDR(6)=IYT-IY            ! Anzahl der Zeilen
      CALL ZPRN (IHDR,I1DRLN)
C
C                       Setze Startwerte
      I4BYTE=0
      IAKTLN=IY
C                       Komprimiere Zeile
C
  830 IPOIS=IAKTLN*LENZL*NFRBEB+IX
      EOL=IPOIS+ITEMP-1
      DO 930 N=1,NFRBEB
      IPOI=IPOIS
      I=IPOIS
  840 I1BYTE(1)=M1TRIX(I,N)
  850 I=I+1
      IF (I .GT. EOL) GO TO 860
      IF (M1TRIX(I,N) .EQ. I1BYTE(1)) GO TO 850
  860 IBTCOU=I-IPOI
  870 IF (IBTCOU .LT. 64) GO TO 880
      CALL ZPRN (-1,1)
      CALL ZPRN (I1BYTE,1)
      IBTCOU=IBTCOU-63
      GO TO 870
C
  880 IF (IBTCOU-1) 920,890,900
  890 IF (I4BYTE .LT. 192) GO TO 910
  900 IBTCOU=IBTCOU+192
      CALL ZPRN (I1TCOU,1)
  910 CALL ZPRN (I1BYTE,1)
C
  920 IPOI=I
      IF (IPOI .LE. EOL) GO TO 840
C
  930 CONTINUE
      IAKTLN=IAKTLN+1
      IF (IAKTLN .LE. IYT) GO TO 830
      GO TO 9999
C                       Polygon-Befehle
C                       (23) Point
  940 IPOLPO=0
C                       (22) Line
C
  950 IF (IPOLPO .GE. LENPLY) GO TO 9999
      IPOLPO=IPOLPO+1
      POLYGN(1,IPOLPO)=AR(1)
      POLYGN(2,IPOLPO)=AR(2)
      GO TO 9999
C                       (21) Polygon ist fertig
C
  960 IF (IPOLPO-2) 9999,1100,970
C
C                       1. Durchgang. Ermittle Grenzen ...
C
  970 ASSIGN 990 TO NRET2
      ASSIGN 1020 TO NRET3
      IFLAG=1
      FLAKT=AR(1)
      IFLAKT=IFLAKT+1
      IF ((IFLAKT .LE. 0) .OR. (IFLAKT .GT. IFLEFP)) IFLAKT=1
      J=IXMAX+1
      DO 980 I=0,LENSP-1
      IGRPLY(1,I)=J
      IGRPLY(2,I)=-1
  980 CONTINUE
      L=1
      NSTEU=3
      GO TO 1030
C
  990 IXTP=IXT+NPENH
      IXTM=IXT-NPENH
      IGRPLY(1,IYT)=MIN0(IGRPLY(1,IYT),IXTM)
      IGRPLY(2,IYT)=MAX0(IGRPLY(2,IYT),IXTP)
      IF (NPENH .EQ. 0) GO TO 100
      DO 1010 I=1,NPENH
      IYTT=IYT-I
 1000 IGRPLY(1,IYTT)=MIN0(IGRPLY(1,IYTT),IXTM)
      IGRPLY(2,IYTT)=MAX0(IGRPLY(2,IYTT),IXTP)
      IF (IYTT .GT. IYT) GO TO 1010
      IYTT=IYT+I
      GO TO 1000
 1010 CONTINUE
      GO TO 100
 1020 NSTEU=2
      L=L+1
      IF (L .GT. IPOLPO) GO TO 1040
 1030 XNEU=POLYGN(1,L)
      YNEU=POLYGN(2,L)
      GO TO 60
C
 1040 ASSIGN 1050 TO NRET3
      L=1
      GO TO 1030
C                       ... und loesche das Innere des Polygons.
C
 1050 IFLADR=IFLPOI(IFLAKT)
      IFLWPL=IFLMST(IFLADR)
      DO 1090 I=0,LENSP-1
      IXT=IGRPLY(1,I)
      J=IGRPLY(2,I)
      IF (IXT .GT. J) GO TO 1090
C     IXBIT=(IXT .AND. 31)+1
      IXBIT=IAND(IXT,31)+1
      IXWRT=IXT/32
C     IYBIT=(J .AND. 31)+1
      IYBIT=IAND(J,31)+1
      IYWRT=J/32
      K=LENZL*I+IXWRT
C
      IFLSTA=MOD(I,IFLMST(IFLADR+1))*IFLWPL+2+IFLADR
      IFLSTW=MOD(IXWRT,IFLWPL)
      DO 1080 J=IXWRT,IYWRT
      IYT=0
      IF (J .EQ. IXWRT) IYT=ITABL(IXBIT)
C     IF (J .EQ. IYWRT) IYT=IYT .OR. ITABR(IYBIT)
      IF (J .EQ. IYWRT) IYT=IOR(IYT,ITABR(IYBIT))
      DO 1070 N=1,NFRBEB
      IF (IAKTPL(N) .NE. 0) GO TO 1060
C     MATRIX(K,N)=(MATRIX(K,N) .AND. IYT)
      MATRIX(K,N)=IAND(MATRIX(K,N),IYT)
      GO TO 1070
 1060 CONTINUE
C     MATRIX(K,N)=(MATRIX(K,N) .AND. IYT) .OR.
C    1          ((.NOT. IYT) .AND. IFLMST(IFLSTA+IFLSTW))
      MATRIX(K,N)=IOR(IAND(MATRIX(K,N),IYT),
     1            IAND(IEOR(IYT,-1),IFLMST(IFLSTA+IFLSTW)))
 1070 CONTINUE
      K=K+1
      IFLSTW=IFLSTW+1
      IF (IFLSTW .GE. IFLWPL) IFLSTW=0
 1080 CONTINUE
 1090 CONTINUE
C                       Zeichne jetzt das Polygon.
C
 1100 IF (IPERIM .EQ. 0) GO TO 9999
      ASSIGN 180 TO NRET2
      ASSIGN 1110 TO NRET3
      L=1
      NSTEU=3
      GO TO 1120
 1110 L=L+1
      IF (L .GT. IPOLPO) GO TO 9999
      NSTEU=2
 1120 XNEU=POLYGN(1,L)
      YNEU=POLYGN(2,L)
      GO TO 60
C                       Definition von Fuellmustern.
 1130 FLAKT=AR(1)
      AI=AR(2)
      J=IFLAKT*I+2
      IF (IFLEFP .GE. 10) GO TO 9999
      IFLEFP=IFLEFP+1
      L=IFLPOI(IFLEFP)
      IF (L+J-1 .LE. IFLDIM) GO TO 1140
      IFLEFP=IFLEFP-1
      GO TO 9999
C
 1140 DO 1150 K=1,J
      FLMST(L)=AR(K)
      L=L+1
 1150 CONTINUE
      IFLPOI(IFLEFP+1)=L
      AR(1)=0.
      GO TO 9999
C                         (24) 0: Polygon ohne Umrisslinie
 1160 AI=AR(1)
      IPERIM=I
C
 9999 RETURN
      END
