// KPLOT - A Program for Plotting and Analyzing Crystal Structures 
// Copyright (C) 1979-2019 Rudolf Hundt 
// KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
// as published by the Free Software Foundation, version 3.
// KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
// See the GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see https://www.gnu.org/licenses/
// Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
// Co-Programmer, mailto:k.pleuger@t-online.de


#ifndef WOOD_H
#define WOOD_H

#include <qmotifstyle.h>
#include <qpushbutton.h>

class NorwegianWoodStyle : public QMotifStyle
{
public:
    NorwegianWoodStyle();
    void polish( QApplication*);
    void polish( QWidget* );
    void unPolish( QWidget* );
    void unPolish( QApplication*);

    void drawButton( QPainter *p, int x, int y, int w, int h,
			     const QColorGroup &g, bool sunken = FALSE,
			     const QBrush *fill = 0 );
    void drawBevelButton( QPainter *p, int x, int y, int w, int h,
			  const QColorGroup &g, bool sunken = FALSE,
			  const QBrush *fill = 0 );
    QRect buttonRect( int x, int y, int w, int h);
    void drawButtonMask( QPainter *p, int x, int y, int w, int h);


    void drawPushButton( QPushButton* btn, QPainter *p);
    void drawPushButtonLabel( QPushButton* btn, QPainter *p);
    
private:
    QPalette oldPalette;

};

#endif
