C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CZVADD    02             ------------------
                          SUBROUTINE ZVADD
C  CY-ENG-               ------------------
C
C                    Geschrieben: 1979  (Hundt)
C                Geaendert: 070856 MAY 2004  (Hundt)
C
C  Dieses Unterprogramm soll die in dem spezifizierten Abschnitt
C  gelegenen Atome suchen und zur Atomliste hinzufuegen.
C
C                        ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 I,NCDE,IT1(3),IT2(3),IAT(8,PARDIM,2),IAT1,IAT2,IS
      INTEGER *4 IERR1,I1,I2,J1,J2,K1,K2,L,M,LL,II,KEYIN,J,K
      INTEGER *4 NCHBRN
      REAL    *4 XUR(3),XU(3),XO(3),XAKT(3),XSTRT(3),XKRT(3),XDIM(3)
      REAL    *4 T1,T2,TEMP
C
C
      EQUIVALENCE (IT1(1),I1),(IT1(2),J1),(IT1(3),K1)
      EQUIVALENCE (IT2(1),I2),(IT2(2),J2),(IT2(3),K2)
      EQUIVALENCE (XUR(1),X(1,1)),(XU(1),X(1,2)),(XO(1),X(1,3))
      EQUIVALENCE (XAKT(1),X(1,4)),(XSTRT(1),X(1,5))
      EQUIVALENCE (XKRT(1),X(1,6)),(XDIM(1),X(1,7))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1))
C
      DATA T1/0./
C
      IF (NSYM(NS) .LE. 0) THEN
C
C                            Keine Symmetrien.
        IERR=2 0036 05
        GO TO 999
      ENDIF
C                            Berechne die triklinen Koordinaten aller
C                            bisher gefundenen Atome, soweit noch
C                            nicht geschehen.
      NCDE=NCD(NS)
      K9(NS)=0
      NC=5
      NTRY=40
      IC=K8(NS)
      GO TO 20
   10 IC=IC+1
      CALL ZVDEK
      DO  I=1,3
        ATOMS(I,IC,NS)=XSTRT(I)
      ENDDO
   20 IF (IC .LT. NCD(NS)) GO TO 10
      K8(NS)=NCD(NS)
C                            Bestimme obere und untere Grenze.
      DO  I=1,3
        XU(I)=XUR(I)-XDIM(I)-.00001
        XO(I)=XUR(I)+XDIM(I)+.00001
      ENDDO
C                            Durchlaufe Zielatome.
      DO  IANR=IZ1,IZ2
        IF (IANR .LE. 0 .OR. IANR .GT. NAT(NS)) THEN
C
C                            Atomnummer illegal.
          IERR=2 0065 04
          GO TO 999
        ENDIF
C                            Bestimme die Stelle, von der ab ge-
C                            sucht werden muss.
        IAT1=IANR*200000
        IAT2=IAT1+199999
        I=NCDA(NS)
C                            Teste, welche Option aktiv ist
C
        IF (ISKP(15)) 30,40,50
C
C                            AGLP, d.h., es braucht nicht getestet
C                            zu werden
   30   I=NCDDM
        GO TO 50
C                            GLP, ermittle Anfang
C
   40   IF (I .LE. NCD(NS)) THEN
          IF (ICD(I,NS) .GT. IAT1 .AND. ICD(I,NS) .LT. IAT2) GO TO 50
          I=I+1
          GO TO 40
        ENDIF
   50   IS=I
C                            Durchlaufe Symmetrien.
        DO  ISYNR=1,NSYM(NS)
          NTRY=8
          DO  I=1,3
            IT(I)=5
          ENDDO
          NC=4
          CALL ZVDEK
C                            Bestimme Grenzen.
          IERR1=0
          DO  I=1,3
            J=5
            TEMP=XAKT(I)
            GO TO 80
   60       IF (J .LE. 0) THEN
              IERR1=1
              GO TO 100
            ENDIF
C
   70       TEMP=TEMP-1.
            J=J-1
   80       IF (TEMP-1.-XU(I)) 100,60,60
   90       TEMP=TEMP+1.
            J=J+1
  100       IF (TEMP .LT. XU(I)) GO TO 90
            K=J
            XSTRT(I)=TEMP
            GO TO 120
C
  110       IF (K .GE. 9) THEN
              IERR1=1
              GO TO 140
            ENDIF
C
            TEMP=TEMP+1.
            K=K+1
  120       IF (TEMP+1.-XO(I)) 110,110,140
  130       TEMP=TEMP-1.
            K=K-1
  140       IF (TEMP .GT. XO(I)) GO TO 130
            IF (K .LT. J) GO TO 280
            IT1(I)=J
            IT2(I)=K
          ENDDO
          IF (IERR1 .NE. 0 .AND. ISKP(66) .EQ. 0) THEN
          WRITE (WRLINE,'(A)')
CYENG1
     +     'ZVADD0156 - Code-Ueberlauf. Abgeschnitten.'
CYENG2
CYENGY     +     'ZVADD0156 - Code overflow. Truncated.'
          CALL KPWRTE (NTDISP)
          ENDIF
C
C                            Durchlaufe alle Translationen.
  150     XAKT(1)=XSTRT(1)
          DO  I=I1,I2
            XAKT(2)=XSTRT(2)
            DO  J=J1,J2
              XAKT(3)=XSTRT(3)
              DO  K=K1,K2
                IF (NTYP-2) 180,170,160
C
C                            Kugel-Sphaere.
  160           NTRY=2
                NC=4
                CALL ZVDEK
C                            Teste Zusatzbedingung bei AUW
C
                IF (CONST(19) .GT. 0.) THEN
                  T1=0.
                  DO  L=1,3
                    TEMP=X1(L)-CONST(15+L)
                    T1=T1+TEMP*TEMP
                  ENDDO
                  IF (T1 .GT. CONST(19)) GO TO 270
                ENDIF
C
                T1=0.
                DO  L=1,3
                  TEMP=X1(L)-X2(L)
                  T1=TEMP*TEMP+T1
                ENDDO
                IF (T1 .GT. DQ .OR. T1 .LT. CONST(20)) GO TO 270
                CONST(37)=T1
                GO TO 180
C                            Kartesische Box
  170           NTRY=4
                NC=4
                CALL ZVDEK
                DO  L=1,3
                  IF (ABS(X2(L)) .GT. XKRT(L)) GO TO 270
                ENDDO
C                            Teste, ob Atome bereits vorhanden.
C
  180           DO  M=IS,NCD(NS)
                  IF (ISKP(15) .GT. 0 .OR.
     +              (ICD(M,NS) .GT. IAT1 .AND. ICD(M,NS) .LT. IAT2))THEN
                    DO  L=1,3
                      IF (ABS(ATOMS(L,M,NS)-XAKT(L)) .GT. CONST(21))
     +                GO TO 190
                    ENDDO
C                            Atom schon vorhanden, wenn hier.
                    GO TO 270
                  ENDIF
  190             CONTINUE
                ENDDO
C                            Teste Zusatzbedingung bei AUS
C
  200           IF (NTYP .NE. 7) GO TO 240
C
                NCHBRN=ISKP(28)
                L=ISKP(30)
                GO TO 220
C
  210           L=L+1
C                            Richtiger Name?
C
                M=ICD(L,NS)/200000
                M=IAT(5,M,NS)
                CALL CNVTUP (M,1,4)
                IF (M .NE. ISKP(29)) GO TO 230
C
C                            Berechne Abstand.
                DO  LL=1,3
                  X1(LL)=XAKT(LL)-ATOMS(LL,L,NS)
                ENDDO
C
                T1=0.
                DO  LL=1,3
                  T2=DG(LL,1,NS)*X1(1)+DG(LL,2,NS)*X1(2)+
     +            DG(LL,3,NS)*X1(3)
                  T1=T1+T2*T2
                  IF (T1 .GT. DQ) GO TO 230
                ENDDO
C                            Abstandsbedingung erfuellt.
C
  220           NCHBRN=NCHBRN-1
C
C                            Teste, ob die geforderte Anzahl
C                            an Nachbarn gefunden wurde.
C
                IF (NCHBRN .LE. 0) GO TO 240
  230           IF (L .LT. NCD(NS)) GO TO 210
                GO TO 270
C                            Schon vorhanden?
C
  240           LL=(((IANR*10+I)*10+J)*10+K)*200+ISYNR
                IF (ISKP(15) .LT. 0) THEN
                  DO  L=NCDA(NS),NCD(NS)
                    IF (ICD(L,NS) .EQ. LL) GO TO 270
                  ENDDO
                ENDIF
C                            Speichere Atom.
C
                IF (NCD(NS) .GE. NCDDM) THEN
C
C                            Tabellen-Ueberlauf
C
                  IERR=2 0233 01
                  GO TO 999
                ENDIF
C
                K8(NS)=K8(NS)+1
                NCD(NS)=NCD(NS)+1
                DO  L=1,3
                  ATOMS(L,K8(NS),NS)=XAKT(L)
                ENDDO
                ICD(NCD(NS),NS)=LL
C
C                            ISKP(84)=-1: Ein Atom genuegt
C                            ISKP(84)=+1: Kein Output
C
C               IF (ISKP(84)) 770,690,720
C
C                            Optional Output
C
  250           IF (ISKP(5) .NE. 0) THEN
                  T1=SQRT(T1)
                  CALL KPCDST (ISKP(80),1,ICD(NCD(NS),NS))
                  WRITE (WRLINE,260) NCD(NS),AT(5,IANR,NS),
     1            AT(6,IANR,NS),(ISKP(II),II=80,82),XAKT,T1
  260             FORMAT ('(',I4,' ) ',2X,2A4,1X,3A4,3F10.5,
     +            '   D =',F8.4)
                  CALL KPWRTE (NTOUT)
                ENDIF
C                            Schleifenende Translationen
C
  270           XAKT(3)=XAKT(3)+1.
              ENDDO
              XAKT(2)=XAKT(2)+1.
            ENDDO
            XAKT(1)=XAKT(1)+1.
          ENDDO
C                            Ende Symmetrieschleife
  280     CONTINUE
        ENDDO
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 999
        ENDIF
C                            Ende Atomnummernschleife
  290   CONTINUE
      ENDDO
C
  999 RETURN
      END
