C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         82    ---------------------------------------
                  SUBROUTINE ZVAFND (IACHSV,IPOI,IRC)
C  CY-ENG-      ---------------------------------------
C
      IMPLICIT NONE
      INTEGER *4 IACHSV,IPOI,IRC
C
C--- Es wird eine achse der zaehligleit IACHSV in richtung IRCHTG
C    gesucht. IRC enthaelt bei aufruf den namen der referenzsorte,
C    beim return einen wert <>0, welche achse gefunden wurde.
C
C                geschrieben: 300909 APR 1998  (Hundt)
C                  geaendert: 181618 APR 2005  (Hundt)
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
      INCLUDE 'RDBFR.INC'
C
      INTEGER *4 I,J,IREF1,IREF2,I1,I2,IVER,IAIN(72),NA,NE
      INTEGER *4 J1,J2,K1,K2,IACHSE,IRVER,KART1,KART2,IAV,IINV
      INTEGER *4 IRESLT(2),LIT(3),KEYIN,K,L,IRCHTG,IATCNT
      REAL    *4 W,ROT(3,3),AREF2,DRAK(3),DRAK2(3),V(3),URA(3)
      REAL    *4 TOL,SK(3,3),GLEIT(3),TEMP,TOLK(3),ABWX
      REAL    *4 TANTAB(6),ROTV(3,3,3),RESULT(8),ROTSV(3,3)
      REAL    *4 TOLABB,E32,ABWV(3)
      EQUIVALENCE (IREF2,AREF2),(AIN(1),IAIN(1))
      DATA TANTAB/0.,0.,.577350269,1.,1.37638192,1.732050808/
      DATA TOL/0.010/,LIT/4HS   ,4H =  ,4H    /
      DATA TOLABB/0.001/,E32/0.03125/
C
      IRCHTG=IDIRSV(IPOI)
C                            Einschlussbox, in die die kugel vom
C                            radius AIN(1) hineinpasst.
      DO  I=1,3
        TOLK(I)=RK(I,NS)*AIN(1)
      ENDDO
      IREF1=IRC
      IRC=0
      IACHSE=IABS(IACHSV)
      IINV=IACHSV
      NA=NCD(NS)+1
      NE=2*NCD(NS)
      IF (NE .GT. NCDDM) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'ZVAFND0033 - Nicht genug Platz.'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'ZVAFND0041 - Not enough workspace.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      IRESLT(1)=0
      IRESLT(2)=IRCHTG
      RESULT(7)=100.
      RESULT(8)=100.
C                            Stelle das koordinatensystem in die
C                            gewuenschte richtung.
      ICDS(1)=2
      ICDS(2)=2
      ICDS(3)=400001+IRCHTG*200
      ICDS(4)=0
      NTYP=1
      ISKP(14)=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 999
C
C                            Sortiere codeliste nach x.
      ISKP(14)=1
      IAIN(1)=1
      NTYP=2
      CALL ZVSRT
      IF (IERR .NE. 0) GO TO 999
C
C                            Berechne freie Koordinaten. Hinterlege
C                            dabei auch die triklinen koordinaten
C                            und die namen der atome.
      K8(NS)=0
      NTRY=44
      NC=1
      GO TO 20
C
   10 K9(NS)=K9(NS)+1
      IC=K9(NS)
      CALL ZVDEK
      J=K9(NS)+NCD(NS)
      DO  I=1,3
        ATOMS(I,J,NS)=X(I,1)
      ENDDO
      AREF2=AT(7,IANR,NS)
      ICD(J,NS)=IREF2
      DO  I=1,3
        ATOMS(I,K9(NS),NS)=X2(I)
      ENDDO
   20 IF (K9(NS) .LT. NCD(NS)) GO TO 10
C
C                            Berechne die drehmatrizen der
C                            pseudosymmetrie:
      DO  I=1,3
        DO  J=1,3
          SK(J,I)=0.
        ENDDO
      ENDDO
      W=CONST(2)/FLOAT(IACHSE)
      SK(1,1)=1.
      SK(2,2)=COS(W)
      SK(3,3)=SK(2,2)
      SK(3,2)=SIN(W)
      SK(2,3)=-SK(3,2)
C                            Drehung links herum, ...
      CALL MM (SK,TRA(1,1,NS),X)
      CALL MM (TRAINV(1,1,NS),X,ROTV(1,1,1))
C
C                            ... drehinversion und ...
      DO  I=1,3
        DO  J=1,3
          ROTV(J,I,3)=-ROTV(J,I,1)
        ENDDO
      ENDDO
C                            ... drehung rechts herum.
      SK(3,2)=-SK(3,2)
      SK(2,3)=-SK(3,2)
      CALL MM (SK,TRA(1,1,NS),X)
      CALL MM (TRAINV(1,1,NS),X,ROTV(1,1,2))
C
C                            Setze eine zweifachschleife auf.
C                            Jeweils zwei atome definieren die lage
C                            der der achse und die translations-
C                            komponente.
C
   30 IF (ISKP(58) .GT. 0) THEN
        WRITE (WRLINE,'(A,2I4,A,A4)')
CYENG1
     +  'Untersuche: ',IINV,IRCHTG,' Ref: ',IREF1
CYENG2
CYENGY     +  'Testing: ',IINV,IRCHTG,' Ref: ',IREF1
        CALL KPWRTE (NTDISP)
      ENDIF
      I1=NA-1
   40 IF (I1 .GE. NE) GO TO 240
      I1=I1+1
      IF (IREF1 .NE. ICD(I1,NS)) GO TO 40
C
      KART1=I1-NCD(NS)
      I2=I1-1
   50 IF (I2 .GE. NE) GO TO 40
      I2=I2+1
      IF (IREF1 .NE. ICD(I2,NS)) GO TO 50
      KART2=I2-NCD(NS)
      IVER=0
C                            Bestimme die lage der drehachse(n).
C
      IF (IACHSE .GE. 3) THEN
        DO  I=1,3
          V(I)=ATOMS(I,KART2,NS)-ATOMS(I,KART1,NS)
        ENDDO
        IF (ABS(V(2))+ABS(V(3)) .GT. TOL) THEN
          W=TANTAB(IACHSE)
          IF (IINV .LT. 0) THEN
            IF (IACHSE .EQ. 6) W=TANTAB(3)
            IF (IACHSE .EQ. 3) W=TANTAB(6)
          ENDIF
          DRAK(2)=ATOMS(2,KART1,NS)+(V(2)-V(3)*W)*0.5
          DRAK(3)=ATOMS(3,KART1,NS)+(V(3)+V(2)*W)*0.5
          DRAK(1)=(ATOMS(1,KART1,NS)+ATOMS(1,KART2,NS))*0.5
          DRAK2(2)=ATOMS(2,KART1,NS)+(V(2)+V(3)*W)*0.5
          DRAK2(3)=ATOMS(3,KART1,NS)+(V(3)-V(2)*W)*0.5
          DRAK2(1)=DRAK(1)
          GO TO 60
        ENDIF
      ENDIF
      DO  I=1,3
        DRAK(I)=(ATOMS(I,KART1,NS)+ATOMS(I,KART2,NS))*.5
        DRAK2(I)=DRAK(I)
      ENDDO
      IVER=1
C                            Schleife ueber die beiden moeglichen
C                            drehachsen.
C
   60 IF (IVER .GE. 2) GO TO 50
      IVER=IVER+1
C                            IVER: Nummer des aktuell untersuchten
C                            drehpunktes. Bei uebereinander liegenden
C                            punkten oder im fall zweizaehliger
C                            achsen ist das schon 2.
      IF (IVER .EQ. 2) THEN
        DO  I=1,3
          DRAK(I)=DRAK2(I)
        ENDDO
      ENDIF
C                            Bestimme den drehpunkt.
      DO  I=1,3
        URA(I)=TRAINV(I,1,NS)*DRAK(1)+TRAINV(I,2,NS)*DRAK(2)+
     +  TRAINV(I,3,NS)*DRAK(3)
      ENDDO
C                            Schleife ueber die rotationen.
      IRVER=0
   70 IF (IRVER .GE. 2) GO TO 60
      IRVER=IRVER+1
C                            Fange sonderfaelle ab.
C
      IF (IRVER .EQ. 1 .AND. IACHSE .LT. 3) IRVER=2
      IAV=IRVER
      IF (IINV .LT. 0) IAV=3
   80 DO  I=1,3
        DO  J=1,3
          ROT(J,I)=ROTV(J,I,IAV)
        ENDDO
      ENDDO
C
C                            Bestimme den translationsvektor.
C
      IF (IAV .EQ. 3) THEN
        IF (IACHSE .NE. 2) THEN
C
C                            Rotoinversion
          DO  I=1,3
            GLEIT(I)=0.
          ENDDO
        ELSE
C                            Spiegelebene
          DO  I=2,3
            X1(I)=ATOMS(I,KART2,NS)-ATOMS(I,KART1,NS)
          ENDDO
          DO  I=1,3
            W=TRAINV(I,2,NS)*X1(2)+TRAINV(I,3,NS)*X1(3)
            GO TO 100
   90       W=W+1.
  100       IF (W .LT. 0.) GO TO 90
            GO TO 120
  110       W=W-1.
  120       IF (W .GT. 0.99999) GO TO 110
            IF (W .LT. 0.) W=0.
            GLEIT(I)=W
          ENDDO
        ENDIF
      ELSE
C                            Schraubenachse
C
        TEMP=ATOMS(1,KART2,NS)-ATOMS(1,KART1,NS)
        IF (ABS(TEMP) .LT. TOL) THEN
          DO  I=1,3
            GLEIT(I)=0.
          ENDDO
          IF (IRVER .EQ. 1) GO TO 70
        ELSE
          DO  I=1,3
            W=TRAINV(I,1,NS)*TEMP
            GO TO 140
  130       W=W+1.
  140       IF (W .LT. 0.) GO TO 130
            GO TO 160
  150       W=W-1.
  160       IF (W .GT. 0.99999) GO TO 150
            IF (W .LT. 0.) W=0.
            GLEIT(I)=W
          ENDDO
          IF (ABS(GLEIT(1))+ABS(GLEIT(2))+ABS(GLEIT(3))
     +      .LT. TOL) THEN
            IF (IRVER .EQ. 1) GO TO 70
          ENDIF
        ENDIF
      ENDIF
C                            Teste, ob diese angenommene Symmetrie
C                            fuer alle atome gueltig ist.
      ABWX=0.
      DO  J1=NA,NE
        IREF2=ICD(J1,NS)
        K1=J1-NCD(NS)
        DO  I=1,3
          T(I)=ATOMS(I,J1,NS)-URA(I)
        ENDDO
        DO  I=1,3
          W=ROT(I,1)*T(1)+ROT(I,2)*T(2)+ROT(I,3)*T(3)+GLEIT(I)+URA(I)
          GO TO 180
  170     W=W+1.
  180     IF (W .LT. 0.) GO TO 170
          GO TO 200
  190     W=W-1.
  200     IF (W .GT. 0.99999) GO TO 190
          IF (W .LT. 0.) W=0.
          V(I)=W
        ENDDO
        IATCNT=0
        DO  J2=NA,NE
          K2=J2-NCD(NS)
          ABWV(1)=0.
          ABWV(2)=0.
          ABWV(3)=0.
          DO  L=1,3
            DO  K=-1,1
              TEMP=ABS(ATOMS(L,J2,NS)-V(L)+FLOAT(K))
              IF (TEMP .LT. TOLK(L)) THEN
                ABWV(L)=AMAX1(ABWV(L),TEMP)
                GO TO 210
              ENDIF
            ENDDO
            GO TO 220
  210       CONTINUE
          ENDDO
          IF (ICD(J2,NS) .NE. IREF2) THEN
C
C                            Teste, ob fremdatome toleriert werden.
C
            IF (ISKP(76) .EQ. 0) GO TO 70
            GO TO 220
          ENDIF
          IATCNT=IATCNT+1
          ABWX=AMAX1(ABWX,ABWV(1)/RK(1,NS),ABWV(2)/RK(2,NS),
     +    ABWV(3)/RK(3,NS))
  220     CONTINUE
        ENDDO
C                            Gegenbeispiel gefunden, wenn kein
C                            atom gefunden.
C
        IF (IATCNT .LT. 1) GO TO 70
      ENDDO
      IRC=IACHSE
      IF (IAV .EQ. 3) IRC=-IRC
      IF (ISKP(58) .GT. 1) THEN
        WRITE (WRLINE,'(A,I3,A,3F10.5,A,3F10.5)')
     +   'A:',IRC,' P:',URA,' G:',GLEIT
        CALL KPWRTE (NTDISP)
        WRITE (WRLINE,'(A,I2,A,F10.6)')
CYENG1
     +   'Matrix:',IAV,' maximale Abweichung:',ABWX
CYENG2
CYENGY     +   'Matrix:',IAV,' max. deviation:',ABWX
        CALL KPWRTE (NTDISP)
      ENDIF
      IF (ABWX .LT. RESULT(8)) THEN
        DO  I=1,3
          RESULT(I)=URA(I)
          W=GLEIT(I)
          DO  J=0,12
            TEMP=FLOAT(J)/12.
            IF (ABS(W-TEMP) .LT. E32) THEN
              IF (J .EQ. 12) THEN
                W=0.
              ELSE
                W=TEMP
              ENDIF
              GO TO 230
            ENDIF
          ENDDO
  230     RESULT(I+3)=W
          DO  J=1,3
            ROTSV(J,I)=ROT(J,I)
          ENDDO
        ENDDO
        RESULT(8)=ABWX
        IRESLT(1)=IRC
        IF (ABWX .LT. TOLABB) GO TO 240
      ENDIF
      GO TO 70
C                            Gibt es schon ein ergebnis?
  240 CONTINUE
      IF (KEYIN(0) .EQ. ISKP(20)) THEN
        IERR=-1
        GO TO 999
      ENDIF
      IF (IRESLT(1) .NE. 0) THEN
        WRITE (WRLINE,'(A,I3,A,I4,A,3F8.4,A,3F8.4,A,F8.5,A)')
     +   'A:',IRESLT(1),' R:',IRESLT(2),' P:',(RESULT(I),I=1,3),
     +   ' G:',(RESULT(I),I=4,6),' (',RESULT(8),')'
        CALL KPWRTE (NTOUT)
C                            Hinterlege ergebnis
        DO  I=1,3
          PKTSV(I,IPOI)=RESULT(I)
          HUBSV(I,IPOI)=RESULT(I+3)
        ENDDO
        IF (ISKP(65) .NE. 0) THEN
          WRLINE(1:1)='!'
          CALL KPWRTE (NTPCH)
        ENDIF
C       WRITE (WRLINE,'(A,F10.6,A,F10.6)')
C    +   'Mittlere quadr. Abweichung:',RESULT(7),
C    +   ' maximale quadr. Abweichung:',RESULT(8)
C       CALL KPWRTE (NTOUT)
        IF (ISKP(65) .NE. 0) THEN
C
C                            Wandle in 'S'-matrixform
          DO  I=1,3
            W=RESULT(I+3)+RESULT(I)-ROTSV(I,1)*RESULT(1)-
     +                    ROTSV(I,2)*RESULT(2)-ROTSV(I,3)*RESULT(3)
C           IF (W .GE. 0.) THEN
C             W=(AINT((W+E24)*12.))/12.
C           ELSE
C             W=(AINT((-W-E24)*12.))/12.
C           ENDIF
            GO TO 260
  250       W=W+1.
  260       IF (W .LT. 0.) GO TO 250
            GO TO 280
  270       W=W-1.
  280       IF (W .GT. 0.99999) GO TO 270
            IF (W .LT. 0.) W=0.
            X2(I)=W
          ENDDO
          I1=LIT(1)
          I2=LIT(2)
          DO  I=1,3
            WRITE (WRLINE,'(A2,4F10.6,A2)')
     +      I1,X2(I),(ROTSV(I,J),J=1,3),I2
            CALL KPWRTE (NTPCH)
            I1=LIT(3)
            IF (I .GE. 2) I2=LIT(3)
          ENDDO
        ENDIF
        GO TO 999
      ENDIF
C                            Rotoinversion schon probiert?
      IF (IINV .GT. 0) THEN
        IINV=-IINV
        GO TO 30
      ENDIF
C
  999 ISKP(14)=0
      RETURN
      END
