C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         74              ------------------
                           SUBROUTINE ZVAPK
C  CY-ENG-                ------------------
C
C               Programm zum aendern der plotkommandos.
C                 geschrieben: 241445 JUL 1986 (Hundt)
C                   geaendert: 291644 OCT 1998 (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 I,J,N,LEN,IPOI,IAIN(72),IBEFS(22),IBLANK,IBEFN(4)
      INTEGER *4 IBF
      REAL    *4 VQ(IPKDIM,2)
C
      EQUIVALENCE (AIN(1),IAIN(1)),(IPK(1,1),VQ(1,1))
C
      DATA IBEFS/4HVB  ,2,4HVBS ,3,4HVBR ,4,4HVEH ,8,4HVEU ,9,
     1 4HVE  ,10,4HPFU ,15,4HPF  ,16,4HVD  ,12,4HVDS ,13,4HVDR ,14/
      DATA IBEFN/2,8,18,24/,IBLANK/4H    /
C
C
C                            APK und APBF
C
CYENG1
      CALL FLES (N,ISKP(31),2HIR,9HNummer? $)
CYENG2
CYENGY      CALL FLES (N,ISKP(31),2HIR,6HNo.? $)
      IF (N .LE. 0) GO TO 990
      I=1
      IPOI=1
   10 IF (IPOI .LE. IPKP(NS)) THEN
        LEN=IPK(IPOI,NS)
        IF (I .LT. N) THEN
          I=I+1
          IPOI=IPOI+LEN
          GO TO 10
        ENDIF
C                            Gefunden, wenn hier. Teste, ob der Befehl
C                            selbst geaendert wird.
      IBF=IPK(IPOI+1,NS)
      IF (NTYP .GT. 1) GO TO 60
C
C                            Fange BA ab.
C
        IF (IBF .EQ. 5) THEN
          CALL FLES (IPK(IPOI+2,NS),ISKP(31),4H2IFR,
CYENG1
     1     30HFarbe,Strichst.,Schrifthoehe?$)
CYENG2
CYENGY     1    27HColor,thicknes,char-size? $)
C
C                            Sage jetzt jeweils vor.
          J=IPOI+LEN
          IPOI=IPOI+5
   20     WRITE (WRLINE,'('' '',I10,2F10.5)')
     +     IPK(IPOI,NS),VQ(IPOI+1,NS),VQ(IPOI+2,NS)
          CALL KPWRTE (NTDISP)
          CALL FLES (IPK(IPOI,NS),ISKP(31),4HC2FR,16Hcode,xoff,yoff?$)
          IF (ISKP(31) .EQ. 0) GO TO 999
          IPOI=IPOI+3
          IF (IPOI .LT. J) GO TO 20
          GO TO 999
        ENDIF
C                            Fange VD, VDS und VDR ab.
C
        IF ((IBF .GE. 12) .AND. (IBF .LE. 14)) THEN
          CALL FLES (IPK(IPOI+2,NS),ISKP(31),4HF4IE,
     1     17Hr, fr,sr, ff,nf?$)
           GO TO 999
        ENDIF
C                            Kopiere Befehl heraus.
        J=IPOI
        DO  I=1,LEN
          IAIN(I)=IPK(J,NS)
          J=J+1
        ENDDO
C                            Analysiere.
C
        IF (IAIN(2) .EQ. 1) THEN
          IF (IAIN(1) .EQ. 5) IAIN(6)=0
CYENG1
          CALL FLES (IAIN(3),ISKP(31),3H4IE,20Hvon,bis,npkte,ndcb?$)
CYENG2
CYENGY          CALL FLES (IAIN(3),ISKP(31),3H4IE,20Hfrom,to,npnts,ndcb?$)
          IF (ISKP(31) .GT. 3) IAIN(1)=6
          IF (IABS(IAIN(5)) .GT. 60 .OR. IABS(IAIN(5)) .LT. 2) GO TO 990
          GO TO 40
        ENDIF
        IF ((IAIN(2) .GE. 2) .AND. (IAIN(2) .LE. 4)) THEN
C         WRITE (NTDISP,'(12I3)') (IAIN(I),I=1,LEN)
C         CALL KPWRTE (NTDISP)
          CALL FLES (IAIN(3),ISKP(31),7H4I3F4IE,
     +    30Hu1,u2,z1,z2,dmin,dmax,r,natf?$)
          GO TO 50
        ENDIF
        IF (IAIN(2) .EQ. 6) THEN  ! BT
          J=26-IAIN(1)
          IF (J .NE. 0) THEN      ! Expandiere
            DO  I=26,25,-1
              IAIN(I)=IAIN(I-J)
            ENDDO
            DO  I=9+IAIN(8),24
              IAIN(I)=IBLANK
            ENDDO
          ENDIF
          CALL FLES (IAIN(3),ISKP(31),5H2C3FR,
CYENG1
     1    42Hc1,c2,xoff,yoff,schrh,text,Farbe,Str-st.?$)
CYENG2
CYENGY     1    42Hc1,c2,xoff,yoff,charh,text,color,thickn.?$)
          CALL FLES (IAIN(9),ISKP(31),6H16A2IE,
CYENG1
     1    20Htext,Farbe,Str-st.?$)
CYENG2
CYENGY     1    20Htext,color,thickn.?$)
C                           Bestimme Textlaenge neu ...
          DO  I=24,10,-1
            IF (IAIN(I) .NE. IBLANK) THEN
              J=I-8
              GO TO 30
            ENDIF
          ENDDO
          J=1             ! ... setze aber mindestens 1.
   30     IAIN(8)=J
          IAIN(1)=J+10
          IAIN(9+J)=IAIN(25)
          IAIN(10+J)=IAIN(26)
          GO TO 40
        ENDIF
        IF (((IAIN(2) .GE. 8) .AND. (IAIN(2) .LE. 10)) .OR.
     1  ((IAIN(2) .GE. 15) .AND. (IAIN(2) .LE. 16))) THEN
          CALL FLES (IAIN(3),ISKP(31),11H4I2F2I3F2IE,
     1    55Hu1,u2, z1,z2, dmin,dmax, c1,c2, dn,dx, tol, ndcb, opt?$)
          GO TO 50
        ENDIF
        IF ((IAIN(2) .GE. 12) .AND. (IAIN(2) .LE. 14)) THEN
          CALL FLES (IAIN(3),ISKP(31),4HF4IE,
     1    17Hr, fr,sr, ff,nf?$)
          GO TO 50
        ENDIF
        IF (IAIN(2) .EQ. 17) THEN  ! PFD
          CALL FLES (IAIN(3),ISKP(31),4H10CE,19Hndcb,c0,c1,...,cn?$)
          GO TO 50
        ENDIF
      ENDIF
      GO TO 990
C                            Teste, ob sich die Laenge veraendert hat.
C
   40 J=IAIN(1)-LEN
      IF (J .NE. 0) THEN
        IF (J .GT. 0) THEN
          IF (IPKP(NS)+J .GT. IPKDM) THEN
            IERR=74 0157 11
            GO TO 999
          ENDIF
          IPKP(NS)=IPKP(NS)+J
          DO  I=IPKP(NS),IPOI+J,-1
            IPK(I,NS)=IPK(I-J,NS)
          ENDDO
        ELSE
          DO  I=IPOI-J,IPKP(NS)
            IPK(I+J,NS)=IPK(I,NS)
          ENDDO
          IPKP(NS)=IPKP(NS)+J
        ENDIF
      ENDIF
C                            Schreibe zurueck.
   50 J=IPOI
      DO  I=1,IAIN(1)
        IPK(J,NS)=IAIN(I)
        J=J+1
      ENDDO
      GO TO 999
C                            APBF
   60 IAIN(1)=IPK(IPOI+1,NS)
CYENG1
      CALL FLES (IAIN(2),ISKP(31),2HAE,5HBef?$)
CYENG2
CYENGY      CALL FLES (IAIN(2),ISKP(31),2HAE,9HCommand?$)
      CALL CNVTUP (IAIN(2),1,4)
C
C                            Ersetze Symbol durch Zahl.
C
      DO  I=1,21,2
        IF (IAIN(2) .EQ. IBEFS(I)) THEN
          IAIN(3)=I+1
          IAIN(4)=IBEFS(I+1)
          GO TO 70
        ENDIF
      ENDDO
      GO TO 990
C                            Teste, ob aus der selben gruppe.
   70 DO  I=2,22,2
        IF (IAIN(1) .EQ. IBEFS(I)) THEN
          IAIN(5)=I
          GO TO 80
        ENDIF
      ENDDO
      GO TO 990
C
   80 DO  I=1,3
        IF ((IAIN(3) .GE. IBEFN(I)).AND.(IAIN(3) .LT. IBEFN(I+1)))THEN
          IF ((IAIN(5) .GE. IBEFN(I)).AND.(IAIN(5) .LT. IBEFN(I+1)))THEN
            IPK(IPOI+1,NS)=IAIN(4)
            GO TO 999
          ENDIF
        ENDIF
      ENDDO
C
  990 IERR=74 0214 16
  999 RETURN
      END
