C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPASCI   03             -------------------
                          SUBROUTINE ZVASCI
C  CY-ENG-               -------------------
C
C                      Geschrieben: 1979  (Hundt)
C                 Geaendert: 150858 JUN 2004  (Hundt)
C
C
C            Dieses Programm fuehrt folgende Befehle aus:
C            KDO   NTYP   Bedeutung
C            ACI     1    Addiere Code(s) unmittelbar
C            SCI     2    Entferne Code(s) unmittelbar
C            EN      3    Entferne Code(s) nach Nummern
C            ACIM    4    Addiere mehrere Codes unmittelbar
C            DCN     5    Delete Code(s) mit Atomnummer(n)
C            DCS     6    Delete Code(s) mit Symbol
C            ACT     7    Addiere Code(s) durch Translation
C            ACIZ    8    Addiere Code(s) fuer Zelle
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),I,I1,I2,I3,I4,I5,J,K,K1,K2,K3,K4,K5,IVON,IBIS
      INTEGER *4 L,L1,L2,L3,L4,L5,M,N,NA,NB,ND,INBFR(5),NTYPS
C
      SAVE INBFR
C
      EQUIVALENCE (IANR,K1),(IT(1),K2),(IT(2),K3),(IT(3),K4),(ISYNR,K5)
      EQUIVALENCE (AIN(1),IAIN(1),IVON),(AIN(2),IBIS)
C
      DATA INBFR/5*0/
C
      NTYPS=NTYP
      IF (NTYPS .EQ. 8) NTYP=1
      IF (NTYP-3) 10,290,370
   10 IF (ISKP(14) .NE. 0) GO TO 40
      CALL FLES (ICDS,ISKP(31),3H2CE,10Hc1 <,c2>?$)
      IF (ISKP(31)-1) 20,30,40
   20 IERR=3 0043 16
      GO TO 999
C
   30 ICDS(2)=ICDS(1)
   40 NTRY=16
C                            ACI - Addiere Codes unmittelbar
   50 NC=1
      CALL ZVDEK
      IF (IERR) 999,60,999
   60 I1=K1
      I2=K2
      I3=K3
      I4=K4
      I5=K5
      NC=2
      CALL ZVDEK
      IF (IERR) 999,70,999
   70 IF (NTYPS-8) 80,810,80
   80 IF (NTYP-2) 90,160,90
   90 DO 150 I=I1,K1
      DO 150 J=I2,K2
      DO 150 K=I3,K3
      DO 150 L=I4,K4
      DO 150 M=I5,K5
C                           Teste, ob Code schon vorhanden ist
C
      NB=(((I*10+J)*10+K)*10+L)*200+M
      IF (ISKP(14) .NE. 0) GO TO 120
      ND=NCDA(NS)-1
      GO TO 110
  100 ND=ND+1
      IF (ICD(ND,NS) .EQ. NB) GO TO 150
  110 IF (ND .LT. NCD(NS)) GO TO 100
C
  120 IF (NCD(NS)-NCDDM) 140,130,130
  130 IERR=3 0078 01
      GO TO 999
C
  140 NCD(NS)=NCD(NS)+1
      ICD(NCD(NS),NS)=NB
  150 CONTINUE
      IF (NTYP-3) 999,999,420
C                            SCI
  160 L1=IANR
      L2=IT(1)
      L3=IT(2)
      L4=IT(3)
      L5=ISYNR
      IF (NCD(NS)-NCDA(NS)) 999,170,170
  170 NTRY=32
      J=NCDA(NS)-1
      DO 280 IC=NCDA(NS),NCD(NS)
      CALL ZVDEK
      IF (I1-IANR) 180,180,270
  180 IF (IANR-L1) 190,190,270
  190 IF (I5-ISYNR) 200,200,270
  200 IF (ISYNR-L5) 210,210,270
  210 IF (I2-IT(1)) 220,220,270
  220 IF (IT(1)-L2) 230,230,270
  230 IF (I3-IT(2)) 240,240,270
  240 IF (IT(2)-L3) 250,250,270
  250 IF (I4-IT(3)) 260,260,270
  260 IF (IT(3)-L4) 280,280,270
  270 J=J+1
      ICD(J,NS)=ICD(IC,NS)
  280 CONTINUE
      GO TO 690
C                            EN - Entferne Nummern
C
  290 CALL FLES (AIN,ISKP(31),3H2IE,10Hn1 <,n2>?$)
      IF (ISKP(31)-1) 300,310,320
  300 IERR=3 0114 16
      GO TO 999
C
  310 IBIS=IVON
  320 IF (IBIS .GT. NCD(NS)) IBIS=NCD(NS)
      IF (IVON) 300,300,330
  330 IF (IBIS-IVON) 300,350,350
C
  340 ICD(IVON,NS)=ICD(IBIS,NS)
      IVON=IVON+1
  350 IBIS=IBIS+1
      IF (IBIS-NCD(NS)) 340,340,360
  360 J=IVON-1
      GO TO 690
C                            ACIM - Addiere Codes mehrfach
  370 IF (NTYP-5) 380,540,550
  380 N=0
      NTRY=16
      IF (ISKP(14)) 410,400,390
  390 NA=ISKP(14)
      GO TO 420
  400 CALL FLES (AIN,ISKP(31),4H72CE,7Hcodes?$)
      NA=ISKP(31)
      IF (NA) 410,410,420
  410 IERR=03 0138 16
      GO TO 999
C
  420 IF (N-NA) 430,999,999
  430 N=N+1
      ICDS(1)=IAIN(N)
      IF (N-NA) 440,470,470
  440 N=N+1
      IF (IAIN(N)) 450,460,460
  450 ICDS(2)=-IAIN(N)
      GO TO 50
  460 N=N-1
  470 NC=1
      CALL ZVDEK
      IF (IERR) 999,480,999
C                           Teste, ob Code schon vorhanden ist
C
  480 NB=(((IANR*10+IT(1))*10+IT(2))*10+IT(3))*200+ISYNR
      IF (ISKP(14) .NE. 0) GO TO 510
      ND=NCDA(NS)-1
      GO TO 500
  490 ND=ND+1
      IF (ICD(ND,NS) .EQ. NB) GO TO 420
  500 IF (ND .LT. NCD(NS)) GO TO 490
  510 IF (NCD(NS)-NCDDM) 530,520,520
  520 IERR=03 0163 01
      GO TO 999
C
  530 NCD(NS)=NCD(NS)+1
      ICD(NCD(NS),NS)=NB
      GO TO 420
C                            DCN - Delete Codes nach Nummern
  540 IBIS=0
      CALL FLES (IAIN,ISKP(31),3H2IE,10Hn1 <,n2>?$)
      GO TO 570
C                            DCS - Delete Codes nach Symbol
  550 IF (NTYP-7) 560,700,999
  560 IAIN(4)=1
      IAIN(5)=NAT(NS)
      CALL FLES (IAIN(3),ISKP(31),4HA2IE,17Hsymbol <,n1,n2>?$)
      CALL CNVTUP (IAIN(3),1,4)
      IVON=IAIN(4)
      IBIS=IAIN(5)
  570 IF (IBIS) 580,580,590
  580 IBIS=IVON
  590 IF (IVON-IBIS) 610,610,600
  600 IAIN(6)=IVON
      IVON=IBIS
      IBIS=IAIN(6)
  610 IF (IBIS .GT. NAT(NS)) IBIS=NAT(NS)
      IF (IVON .GT. 0) GO TO 620
      IERR=03 0189 16
      GO TO 999
C
  620 IVON=IVON*200000
      IBIS=IBIS*200000+199999
      I=NCDA(NS)-1
      J=I
      GO TO 680
  630 I=I+1
C                            Teste Nummer
C
      IF (ICD(I,NS)-IVON) 670,640,640
  640 IF (ICD(I,NS)-IBIS) 650,650,670
  650 IF (NTYP-5) 660,680,660
C
C                            Teste auch das Symbol
  660 IANR=ICD(I,NS)/200000
      AIN(6)=AT(7,IANR,NS)
C      CALL CNVTUP (IAIN(6),1,4)
      IF (IAIN(6) .EQ. IAIN(3)) GO TO 680
C
  670 J=J+1
      ICD(J,NS)=ICD(I,NS)
  680 IF (I-NCD(NS)) 630,690,690
C
  690 NCD(NS)=J
      K8(NS)=0
      K9(NS)=0
      GO TO 999
C                            ACT - Addiere Codes durch Translation
C
CYENG1
  700 CALL FLES (INBFR,ISKP(31),3H5IE,18Hvon,bis,ta,tb,tc?$)
CYENG2
CYENGY  700 CALL FLES (INBFR,ISKP(31),3H5IE,18Hfrom,to,ta,tb,tc?$)
      IF (INBFR(1) .LE. 0) GO TO 710
      IF (INBFR(2) .GT. NAT(NS)) GO TO 710
      IF (INBFR(1) .LE. INBFR(2)) GO TO 720
  710 IERR=3 0227 16
      GO TO 999
C                            Durchlaufe Codeliste
  720 M=NCD(NS)
      IC=NCDA(NS)-1
      NTRY=32
      L=0
      GO TO 790
  730 IC=IC+1
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      IF (IANR .LT. INBFR(1)) GO TO 790
      IF (IANR .GT. INBFR(2)) GO TO 790
      DO 740 I=1,3
      IT(I)=IT(I)+INBFR(I+2)
      IF (IT(I) .LT. 0) GO TO 770
      IF (IT(I) .GT. 9) GO TO 770
  740 CONTINUE
      K=(((IANR*10+IT(1))*10+IT(2))*10+IT(3))*200+ISYNR
C
C                            Teste, ob bereits vorhanden.
      DO 750 I=NCDA(NS),NCD(NS)
      IF (ICD(I,NS) .EQ. K) GO TO 790
  750 CONTINUE
C                            Nimm auf, falls noch aufnahmefaehig.
C
      IF (NCD(NS)-NCDDM) 780,760,760
  760 IERR=03 0254 01
      GO TO 999
C                            Setze Overflow-flag.
  770 L=1
      GO TO 790
C
  780 NCD(NS)=NCD(NS)+1
      ICD(NCD(NS),NS)=K
C
  790 IF (IC .LT. M) GO TO 730
      IF (L .EQ. 0) GO TO 999
      WRITE (WRLINE,800)
CYENG1
  800 FORMAT ('ZVASCI0780 - Overflows ignoriert.')
CYENG2
CYENGY  800 FORMAT ('ZVASCI0780 - Overflows ignored.')
      CALL KPWRTE (NTDISP)
      GO TO 999
C                            ACIZ - Codes fuer Zelle.
  810 DO  J=I2,K2
        DO  K=I3,K3
          DO  L=I4,K4
            DO  M=I5,K5
              I=K1
              IF (MOD(J+K+L,2) .NE. 0) I=I1
              NB=(((I*10+J)*10+K)*10+L)*200+M
C
C                            Teste, ob Code schon vorhanden ist
C
              DO  IC=NCDA(NS),NCD(NS)
                IF (NB .EQ. ICD(IC,NS)) GO TO 820
              ENDDO
              IF (NCD(NS) .LT. NCDDM) THEN
                NCD(NS)=NCD(NS)+1
                ICD(NCD(NS),NS)=NB
              ELSE
                IERR=3 0290 01
                GO TO 999
              ENDIF
  820         CONTINUE
            ENDDO
          ENDDO
        ENDDO
      ENDDO
C
  999 RETURN
      END
