C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPAVBR   04             -------------------
                          SUBROUTINE ZVAVBR
C  CY-ENG-               -------------------
C
C                     Geschrieben: 1979  (Hundt)
C                  Geaendert: 071547 jul 2006  (Hundt)
C
C         Das Programm fuehrt folgende Kommandos aus:
C         KDO   NTYP   Bedeutung
C         ATB     1    Addiere trikline Box
C         AKB     2    Addiere kartesische Box
C         AKS     3    Addiere Kugelsphaehre
C         AU      4    Addiere Umgebung
C         AUW     5    Addiere Umgebung mit Wiederholung
C         AUZ     6    Addiere Umgebung in Zyklen
C         AUS     7    Addiere Umgebung nach Symbolen
C         MTRI    8    Mache triklin
C        (MTRI)   9    Mache triklin ohne input
C         AUF    10    Addiere Umgebung fremder Atome
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),IAINH(6),ISVBFR(6),IV1,IV2,IATNAM,NRET,IGRNR
      INTEGER *4 I,J,JJ,K,L,NCDE,II,IK,NATS,MTRBUF(2),NATB,M,KDP1
      INTEGER *4 NSSV,NSF,ICT,ICTA,ICTE,ICTAE
C
      REAL    *4 AINH(6),ATNAM,TOL(3),A(3,3),QSUM,TEMP,DMAX
C
      SAVE AINH
C
      EQUIVALENCE (AIN(1),IAIN(1),IV1),(AIN(2),IV2),(AINH(1),IAINH(1))
      EQUIVALENCE (ATNAM,IATNAM)
C
      DATA KDP1/4HP1  /
C
      NRET=0
      IGRNR=0
      GO TO ( 10, 60, 70,  120,120,220,240, 290,290,370),NTYP
C            ATB AKB  AKS   AU AUW AUZ AUS MTRI     AUF
C     NTYP=   1   2    3    4   5   6    7   8   9   10
C
C                            ATB
   10 IF (ISKP(14) .NE. 0) GO TO 20
      IAIN(1)=1
      IAIN(2)=ISKP(53)
      IAIN(3)=NAT(NS)
      DO  I=4,6
        AIN(I)=.5
      ENDDO
      CALL FLES (IAIN,ISKP(31),6HC2I3FE,
CYENG1
     1 21Hur,von,bis,dx,dy,dz?$)
CYENG2
CYENGY     1 22Horg,from,to,dx,dy,dz?$)
C
   20 ISKP(14)=0
      IF (IAIN(1) .NE. 0) GO TO 40
      DO  I=1,6
        ISVBFR(I)=IAIN(I)
      ENDDO
      NRET=-1
   30 IGRNR=IGRNR+1
      DO  I=1,6
        IAIN(I)=ISVBFR(I)
      ENDDO
      IAIN(1)=IGRNR
      NTYP=7
      CALL ZVGC01 (IAIN(1))
      IF (IAIN(1) .EQ. 0) GO TO 999
      NTYP=1
C
   40 ICDS(1)=IAIN(1)
      IZ1=IAIN(2)
      IZ2=IAIN(3)
      DO  I=1,3
        X(I,7)=AIN(I+3)
      ENDDO
      NTRY=24
      NC=1
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
   50 CALL ZVADD
      IF (IERR .NE. 0) GO TO 999
      IF (NRET) 30,999,90
C                            AKB
   60 IF (ISKP(14) .EQ. 0) THEN
        ISKP(32)=0
        CALL FLES (IAIN,ISKP(31),5H2I3FE,
CYENG1
     1  18Hvon,bis,ax,ay,az?$)
CYENG2
CYENGY     1  18Hfrom,to,ax,ay,az?$)
        IF (ISKP(32) .LT. 3) THEN
          IERR=4 0096 16
          GO TO 999
        ENDIF
      ENDIF
C
      ISKP(14)=0
      IZ1=IAIN(1)
      IZ2=IAIN(2)
C                            Bestimme trikline Einschlussbox
      DO  I=1,3
        X(I,6)=AIN(I+2)
        X(I,1)=UR(I,NS)
        X(I,7)=0.
      ENDDO
      DO  I=1,3,2
        X1(1)=FLOAT(I-2)*X(1,6)
        DO  J=1,3,2
          X1(2)=FLOAT(J-2)*X(2,6)
          DO  K=1,3,2
            X1(3)=FLOAT(K-2)*X(3,6)
            DO  L=1,3
              X(L,7)=AMAX1(ABS(TRAINV(L,1,NS)*X1(1)+
     +         TRAINV(L,2,NS)*X1(2)+TRAINV(L,3,NS)*X1(3)),X(L,7))
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      GO TO 50
C                            AKS
   70 CONST(19)=0.
      NRET=0
      IF (ISKP(14) .EQ. -3) THEN
        ISKP(14)=0
        GO TO 80
      ENDIF
      ISKP(32)=0
      AIN(5)=0.
      IF (ISKP(14) .NE. 0) GO TO 110
      CALL FLES (IAIN,ISKP(31),6HC2I2FE,
CYENG1
     1 17Hur,von,bis,d,d2?$)
CYENG2
CYENGY     1 18Horg,from,to,d,d2?$)
   80 IF (ISKP(32) .LE. 0) THEN
        IERR=4 0140 16
        GO TO 999
      ENDIF
C
      IF (IAIN(1) .NE. 0) GO TO 100
      DO  I=1,5
        ISVBFR(I)=IAIN(I)
      ENDDO
      NRET=1
C
   90 IGRNR=IGRNR+1
      DO  I=1,5
        IAIN(I)=ISVBFR(I)
      ENDDO
      IAIN(1)=IGRNR
      NTYP=7
      CALL ZVGC01 (IAIN(1))
      IF (IAIN(1) .EQ. 0) GO TO 999
      NTYP=3
C
  100 ICDS(1)=IAIN(1)
      IZ1=IAIN(2)
      IZ2=IAIN(3)
      IF (AIN(4) .LE. AIN(5)) THEN
        CONST(20)=AIN(4)*AIN(4)
        DQ=AIN(5)
      ELSE
        CONST(20)=AIN(5)*AIN(5)
        DQ=AIN(4)
      ENDIF
C                            Bestimme trikline Einschlussbox
  110 DO  I=1,3
        X(I,7)=DQ*RK(I,NS)
      ENDDO
      DQ=DQ*DQ
      IF (NTYP .GE. 4) GO TO 140
      NTRY=26
      NC=1
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        X2(I)=X1(I)
      ENDDO
      GO TO 50
C                            AU und AUW
  120 CONST(20)=0.
      IF (ISKP(14) .EQ. 0) THEN
        IAIN(6)=0
        AIN(7)=AMAX1(ZELLE(1,NS),ZELLE(2,NS),ZELLE(3,NS))
        AIN(8)=0.
        ISKP(32)=0
        CALL FLES (IAIN,ISKP(31),7H4IFI2FE,
CYENG1
     1   41Hur1,ur2,zl1,zl2,dmax,czentr,dzentr,dmin?$)
CYENG2
CYENGY     1   45Horg1,org2,tar1,tar2,dmax,ccentr,dcentr,dmin?$)
        IF (ISKP(32) .LE. 0) THEN
          IERR=4 0197 16
          GO TO 999
        ENDIF
      ENDIF
C
  130 IZ1=IAIN(3)
      IZ2=IAIN(4)
      DQ=AIN(5)
      CONST(20)=AIN(8)*AIN(8)
      NCDE=NCD(NS)
      IV1=IV1*200000
      IV2=IV2*200000+199999
      CONST(19)=0.
C                            Setze Parameter, falls Zusatzbedingung
C                            angegeben.
C
      IF (IAIN(6) .LE. 0) GO TO 110
      ICDS(1)=IAIN(6)
      NC=1
      NTRY=26
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      CONST(16)=X1(1)
      CONST(17)=X1(2)
      CONST(18)=X1(3)
      CONST(19)=AIN(7)*AIN(7)
      GO TO 110
C
  140 IK=NCDA(NS)-1
  150 IK=IK+1
      IF (NTYP-5) 170,180,160
  160 IF (NTYP .EQ. 7) THEN
C                            AUS
C
        IF (IK .LE. NCDE) GO TO 200
        GO TO 270
      ENDIF
C                            AU/AUZ
C
  170 IF (IK .LE. NCDE) GO TO 190
      IF (NTYP .LE. 5) GO TO 999
      IAINH(6)=IAINH(6)-1
      IF (IAINH(6) .GT. 0) GO TO 230
      GO TO 999
C                            AUW
C
  180 IF (IK .GT. NCD(NS)) GO TO 999
C
C                            Bestimme Koordinaten des Ursprungspunkts
C
  190 IF (IV1 .GE. ICD(IK,NS)) GO TO 150
      IF (ICD(IK,NS) .GE. IV2) GO TO 150
  200 NTRY=42
      IC=IK
      NC=1
      CALL ZVDEK
      IF (ISKP(5) .NE. 0) THEN
        CALL KPCDST (ISKP(80),1,ICD(IC,NS))
        WRITE (WRLINE,210) IC,AT(5,IANR,NS),AT(6,IANR,NS),
     1  (ISKP(I),I=80,82),X(1,1),X(2,1),X(3,1)
        CALL KPWRTE (NTOUT)
  210    FORMAT ('#',I4,' #   ',A4,A2,2A4,A3,
CYENG1
     1    '----',3F10.5,' -- Ursprung --')
CYENG2
CYENGY     1  '----',3F10.5,' --- Origin ---')
      ENDIF
      DO  I=1,3
        X2(I)=X1(I)
      ENDDO
      CALL ZVADD
      IF (IERR .EQ. 0) GO TO 150
      GO TO 999
C                            AUZ
  220 IAINH(6)=2
      AINH(5)=CONST(31)
      CALL FLES (IAINH,ISKP(31),5H4IFIE,
CYENG1
     1 21Hu1,u2,z1,z2,d,nzykl?$)
CYENG2
CYENGY     1 29Horg1,org2,tar1,tar2,d,ncycl?$)
      DO  I=1,3,2
        IF (IAINH(I) .LE. 0 .OR. IAINH(I+1) .GT. NAT(NS) .OR.
     +    IAINH(I) .GT. IAINH(I+1)) THEN
          IERR=04 0280 16
          GO TO 999
        ENDIF
      ENDDO
C                            Uebertrage Parameter fuer AU
  230 DO  I=1,5
        IAIN(I)=IAINH(I)
      ENDDO
C                            Vertausche ur mit zl
      IAINH(1)=IAIN(3)
      IAINH(2)=IAIN(4)
      IAINH(3)=IAIN(1)
      IAINH(4)=IAIN(2)
      IAIN(6)=0
      AIN(8)=0.
      GO TO 130
C                            AUS - Addiere nach Symbolen
  240 IAINH(5)=ISKP(53)
      IAINH(6)=NAT(NS)
      IAINH(4)=1
      AINH(3)=0.
      CALL FLES (IAINH,ISKP(31),6HAAF3IE,
CYENG1
     1 30Hsur,szl,dmax <,nchb,von,bis>?$)
CYENG2
CYENGY     1 32Hsorg,star,dmax <,nghb,from,to>?$)
      IF (AINH(3) .LE. 0.) CALL ZVDTAB (IAINH(1),IAINH(2),AINH(3),2)
      IF (IAINH(5) .LE. 0 .OR. IAINH(6) .GT. NAT(NS) .OR.
     +  IAINH(5) .GT. IAINH(6)) THEN
        IERR=4 0308 16
        GO TO 999
      ENDIF
C                            Init
      NCDE=NCD(NS)
      CALL CNVTUP (IAINH,1,8)
      CONST(19)=0.
      CONST(20)=0.
      ISKP(28)=IAINH(4)
      ISKP(29)=IAINH(1)
      DO  I=1,3
        X(I,7)=AINH(3)*RK(I,NS)
      ENDDO
      DQ=AINH(3)*AINH(3)
C                            Starte Suchlaeufe
      IK=NCDA(NS)-1
      GO TO 280
  250 IK=IK+1
C                            Teste, ob erlaubte Nummer
      II=ICD(IK,NS)/200000
      IF (II .LT. IAINH(5) .OR. II .GT. IAINH(6)) GO TO 280
C
C                            Teste, ob das das gesuchte Symbol ist
      ATNAM=AT(7,II,NS)
C      CALL CNVTUP (IATNAM,1,4)
      IF (IATNAM .NE. IAINH(1)) GO TO 280
C
C                            Bestimme Koordinaten
      IC=IK
      ISKP(30)=IC
      NC=1
      NTRY=42
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        X2(I)=X1(I)
      ENDDO
      IF (ISKP(5) .NE. 0) THEN
        CALL KPCDST (ISKP(80),1,ICD(IC,NS))
        WRITE (WRLINE,210) IC,AT(5,IANR,NS),AT(6,IANR,NS),
     1           (ISKP(I),I=80,82),X(1,1),X(2,1),X(3,1)
        CALL KPWRTE (NTOUT)
      ENDIF
      JJ=IAINH(5)-1
      GO TO 270
C
  260 JJ=JJ+1
      ATNAM=AT(7,JJ,NS)
C      CALL CNVTUP (IATNAM,1,4)
      IF (IATNAM .NE. IAINH(2)) GO TO 270
      IZ1=JJ
      IZ2=JJ
      CALL ZVADD
      IF (IERR .NE. 0) GO TO 999
C
  270 IF (JJ .LT. IAINH(6)) GO TO 260
  280 IF (IK .LT. NCDE) GO TO 250
      GO TO 999
C                            MTRI - Mache triklin
  290 MTRBUF(1)=ISKP(53)
      MTRBUF(2)=NAT(NS)
      IF (NTYP .NE. 9) THEN
CYENG1
        CALL FLES (MTRBUF,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY        CALL FLES (MTRBUF,ISKP(31),3H2IE,9Hfrom,to?$)
      ENDIF
      IF ((MTRBUF(1) .LE. 0) .OR. (MTRBUF(2) .GT. NAT(NS)) .OR.
     +  (MTRBUF(1) .GT. MTRBUF(2))) THEN
        IERR=04 0374 16
        GO TO 999
      ENDIF
      IF (NAT(NS) .GE. NATDM) THEN
        IERR=04 0378 02
        GO TO 999
      ENDIF
      IF (NSYM(NS) .LE. 0) THEN
        IERR=04 0382 05
        GO TO 999
      ENDIF
      DO  I=1,3
        TOL(I)=RK(I,NS)*0.2
      ENDDO
      NATS=NAT(NS)
      NCD(NS)=0
      K8(NS)=0
      K9(NS)=0
C
      NC=1
      NTRY=24
      DO  I=MTRBUF(1),MTRBUF(2)
        NATB=NAT(NS)+1
        DO  J=1,NSYM(NS)
          ICDS(1)=I*200000+111000+J
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
          DO  K=1,3
            GO TO 310
  300       X(K,1)=X(K,1)+1.
  310       IF (X(K,1) .LT. 0.) GO TO 300
            GO TO 330
  320       X(K,1)=X(K,1)-1.
  330       IF (X(K,1) .GT. 0.99999) GO TO 320
            IF (X(K,1) .LT. 0.) X(K,1)=0.
          ENDDO
          DO  K=NATB,NAT(NS)
            DO  L=1,3
              IF (ABS(X(L,1)-AT(L,K,NS)) .GT. TOL(L)) GO TO 340
            ENDDO
            GO TO 350
  340       CONTINUE
          ENDDO
          IF (NAT(NS) .GE. NATDM) THEN
            IERR=04 0418 02
            GO TO 999
          ENDIF
          NAT(NS)=NAT(NS)+1
          DO  L=1,3
            AT(L,NAT(NS),NS)=X(L,1)
          ENDDO
          DO  L=4,8
            AT(L,NAT(NS),NS)=AT(L,I,NS)
          ENDDO
          ICLRP(NAT(NS),NS)=ICLRP(I,NS)
          IPFLG(NAT(NS),NS)=IPFLG(I,NS)
          IF (IPFLG(I,NS) .NE. 0) THEN
            DO  M=1,3
              K=1
              DO  L=1,3
                TFVKT(L,M,NAT(NS),NS)=SYM(K+1,J,NS)*TFVKT(1,M,I,NS)+
     +          SYM(K+2,J,NS)*TFVKT(2,M,I,NS)+
     +          SYM(K+3,J,NS)*TFVKT(3,M,I,NS)
                K=K+4
              ENDDO
            ENDDO
          ENDIF
  350     CONTINUE
        ENDDO
      ENDDO
C                            ... und entferne alte Atome.
      IAIN(1)=MTRBUF(1)
      IAIN(2)=MTRBUF(2)
      NTYP=14
      ISKP(14)=1
      CALL ZVFNIN
C                            Raumgruppe 1
      IAIN(1)=KDP1
      IAIN(2)=ISKP(24)
      NTYP=1
      CALL ZVHMS
      GO TO 990
C                            AUF - Addiere umgebung fremder atome.
  370 NSSV=NS
      NSF=3-NS
      IF (ISKP(14) .EQ. 0) THEN
        IAIN(1)=ISKP(53)
        IAIN(2)=NAT(NSF)
        IAIN(3)=ISKP(53)
        IAIN(4)=NAT(NS)
        AIN(5)=1.
        CALL FLES (IAIN,ISKP(31),4H4IFE,15Hu1,u2,z1,z2,d?$)
      ENDIF
      CONST(19)=0.
      CONST(20)=0.
      DQ=AIN(5)
      DO  I=1,3
        X(I,7)=DQ*RK(I,NS)
      ENDDO
      IV1=IAIN(1)*200000
      IV2=IAIN(2)*200000+199999
      IZ1=IAIN(3)
      IZ2=IAIN(4)
      DQ=DQ*DQ
C                        Berechne transformationsmatrix.
      DO  I=1,3
        DO  J=1,3
          A(I,J)=TRAINV(I,1,NSSV)*TRA(1,J,NSF)+
     +    TRAINV(I,2,NSSV)*TRA(2,J,NSF)+TRAINV(I,3,NSSV)*TRA(3,J,NSF)
        ENDDO
      ENDDO
      ICTA=NCDA(NSF)
      ICTE=NCD(NSF)
      QSUM=0.
      ICTAE=NCD(NS)
      DMAX=0.
      DO  ICT=ICTA,ICTE
C                            Hole fremden code ...
        NS=NSF
        ICDS(1)=ICD(ICT,NS)
        IF (ICDS(1) .LT. IV1 .OR. ICDS(1) .GT. IV2) GO TO 380
        NTRY=24
        NC=1
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 390
        IF (ISKP(5) .NE. 0) THEN
          CALL KPCDST (ISKP(80),1,ICDS(1))
          WRITE (WRLINE,210) ICT,AT(5,IANR,NS),AT(6,IANR,NS),
     1    (ISKP(I),I=80,82),X(1,1),X(2,1),X(3,1)
          CALL KPWRTE (NTOUT)
        ENDIF
C
C                    ... und rechne die triklinen koordinaten um.
        DO  I=1,3
          T(I)=X(I,1)-UR(I,NS)
        ENDDO
        DO  I=1,3
          X(I,1)=A(I,1)*T(1)+A(I,2)*T(2)+A(I,3)*T(3)+UR(I,NSSV)
        ENDDO
        NS=NSSV
        DO  I=1,3
          X2(I)=DG(I,1,NS)*X(1,1)+DG(I,2,NS)*X(2,1)+DG(I,3,NS)*X(3,1)
        ENDDO
        NTYP=3
        CALL ZVADD
        IF (IERR .NE. 0) GO TO 999
        DMAX=MAX(DMAX,CONST(37))
        QSUM=QSUM+CONST(37)
  380   CONTINUE
      ENDDO
      CONST(37)=QSUM
      IF (ISKP(5) .NE. 0) THEN
        TEMP=NCD(NSSV)-ICTAE
        IF (TEMP .GT. 0.) THEN
          QSUM=SQRT(QSUM/TEMP)
          DMAX=SQRT(DMAX)
          WRITE (WRLINE,'(A,F8.3,A,F8.3)')
CYENG1
     +    'RMS-Wert:',qsum,'; max. Abweichung:',dmax
CYENG2
CYENGY     +    'RMS value:',qsum,'; max. deviation:',dmax
          CALL KPWRTE (NTOUT)
        ENDIF
      ENDIF
  390 NS=NSSV
C                            Fertig.
  990 ISKP(14)=0
  999 RETURN
      END
