C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CZVBILF   37             -------------------
                          SUBROUTINE ZVBILF
CY-VAX-ENG-              -------------------
C
C                     Geschrieben: 1979  (Hundt)
C                 Geaendert: 291106 FEB 2008  (Hundt)
C
C  Das Programm soll Kommandos auf dem File NTBILF in KPLOT-lesbarer
C  Form abspeichern.
C
C           Kommando  NTYP   Bedeutung
C           QK         1     Frei definierbares Kdo ausgeben
C           QPK        2     Plotkommandos ausgeben
C           Q          3     Orientierung ausgeben
C           QC         4     Codes ausgeben
C           QT         5     Titel ausgeben
C           QZB        6     Zeichenfeld Definition ausgeben
C           QRW        7     Rewind auf Q-Datei
C           QA         8     Atome ausgeben
C           QSY        9     Symmetrien symbolisch ausgeben
C           QAE       10     FORTRAN Nummer der Q-Datei
C           QBS       11     Backspace auf Q-Datei
C           QFK       12     Freie Koordinaten ausgeben
C           QZ        13     Zelle ausgeben
C           QUP       14     Ursprungspunkt ausgeben
C           QTF       15     Temperaturfaktoren ausgeben
C           PUT       20     Alles ausgeben
C           PUTC      21     Alles ausgeben und close
C           SRGS      22     Symmetrien an RGS ausgeben
C           PUKC      23     Wie PUTC, aber nur Parameter in kart. K.
C
C                        -------------------
      IMPLICIT NONE
C
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),KDOT(17),ITYPT(11),KONST(50),ITYP,ICLSFL
      INTEGER *4 IRLINE(30),NTYPS,I,J,K,N,JPKM,JPKP,NANZ,NANZL,MSK
      INTEGER *4 IGLZ,ISEMI,IA,IE,M,NTYPSS,NAMACH(3),NTBILS,NSSV
      REAL    *4 FMT1(10),FMT(5),AIPK(IPKDIM,2),CDS(7),TEMP
      REAL    *4 AATF(17,IATFDM)
CYVAX1
      INTEGER *1 I1AIN(288)
CYVAX2
CYVAXY      LOGICAL *1 I1AIN(288)
      CHARACTER*20 FMTC
C
      EQUIVALENCE (AIN(1),IAIN(1),I1AIN(1)),(IPK(1,1),AIPK(1,1))
      EQUIVALENCE (CONST(1),KONST(1)),(ICDS(1),CDS(1))
      EQUIVALENCE (FMT(1),FMTC),(IATF(1,1),AATF(1,1))
      EQUIVALENCE (WRLINE,IRLINE(1))
C
      DATA KDOT/4HPK  ,4HVB  ,4HVBS ,4HVBR ,4HBA  ,4HBT  ,4HPPFL,
     1   4HVEH ,4HVEU ,4HVE  ,4H????,4HVD  ,4HVDS ,4HVDR ,4HPFU ,
     2   4HPF  ,4HPFD /
      DATA IGLZ/4H =  /,ISEMI/4H ;  /,NAMACH/4HA   ,4HB   ,4HC   /
      DATA ITYPT/ 5,13,  9, 8, 15, 4,  6, 14,3,  2,  0/
C                QT QZ QSY QA QTF QC QZB QUR Q QPK END
      DATA FMT/4H(' ',4H,   ,4HXXA4,4H,1H ,4H2I3)/
      DATA FMT1/4H 1A4,4H 2A4,4H 3A4,4H 4A4,4H 5A4,4H 6A4,4H 7A4,
     1 4H 8A4,4H 9A4,4H10A4/
C
C                            Teste, ob die Nummer der
C                            Ausgabeeinheit erlaubt ist.
C
      NSSV=NS
      NS=1
      ITYP=-1
      ICLSFL=0
      NTYPS=NTYP
      NTBILS=NTBILF
      IF (NTYPS .EQ. 22) NTBILF=NTPCH
      IF (NTYPS .EQ. 1) GO TO 30
      IF (NTYPS .LT. 10) GO TO 10
      IF (NTYPS .LE. 12) GO TO 20
      IF (NTYPS .LT. 21) GO TO 10
      ICLSFL=1
C                            Schliesse vorsichtshalber NTBILF
      NTYP=NTBILF+100
      CALL ZVEAEH
      IERR=0
   10 NTYP=NTBILF
      CALL ZVEAEH
      IF (NTYPS-15) 20,20,730
   20 GO TO (30,50,390,420,430,470,500,510,610,660,670,690,450,370,580),
C            1  2  3   4   5   6   7   8   9   10  11  12  13  14  15
     1 NTYPS
C
C                            QK-Kommando
C
   30 NTYP=NTBILF
      CALL ZVEAEH
CYENG1
      CALL FLES (IAIN,ISKP(31),4H19AE,13HKommando(s)?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),4H19AE,12HCommand(s)?$)
      WRITE (WRLINE,40) (AIN(I),I=1,19)
      CALL KPWRTE (NTBILF)
   40 FORMAT (19A4)
      GO TO 999
C                            QPK- Plotkommandos
   50 JPKM=0
      I=0
      JPKP=1
      NANZ=0
      GO TO 80
C
   60 IF (MSK .GT. 0) GO TO 80
      WRITE (WRLINE,70) I
      CALL KPWRTE (NTBILF)
   70 FORMAT ('MPK',I4)
   80 I=I+1
      JPKP=JPKP+NANZ
      IF(JPKP-IPKP(NS)) 100,90,90
   90 IF (NTYP) 750,750,990
  100 NANZ=IPK(JPKP,NS  )
      NANZL=NANZ-1
      MSK=IPK(JPKP+1,NS)
      N=IABS(MSK)
      IF (N-5) 110,170,230
  110 IF (N-1) 120,120,130
C
  120 WRITE (WRLINE,160) KDOT(1),(IPK(JPKP+J,NS),J=2,NANZL)
      CALL KPWRTE (NTBILF)
      GO TO 60
C
  130 AIN(5)=AIPK(JPKP+6,NS)
      IF (AIN(5)) 140,150,150
  140 AIN(5)=0.
  150 AIN(6)=AIPK(JPKP+7,NS)
      AIN(7)=AIPK(JPKP+8,NS)
      WRITE (WRLINE,160) KDOT(N),(IPK(JPKP+J,NS),J=2,5),
     1 (AIN(J),J=5,7),(IPK(JPKP+J,NS),J=9,NANZL-3)
      CALL KPWRTE (NTBILF)
  160 FORMAT (A4,4I5,3F10.3,I4)
      GO TO 60
C
  170 WRITE (WRLINE,180) KDOT(N),(IPK(JPKP+J,NS),J=2,3),AIPK(JPKP+4,NS)
      CALL KPWRTE (NTBILF)
  180 FORMAT (A4,2I4,F6.2,' =')
      J=7
      K=IGLZ
      GO TO 220
  190 K=ISEMI
  200 WRITE (WRLINE,210) AIPK(JPKP+J-1,NS),AIPK(JPKP+J,NS),K
      CALL KPCDST (IRLINE,3,IPK(JPKP+J-2,NS))
      CALL KPWRTE (NTBILF)
  210 FORMAT (12X,2F10.5,A4)
      J=J+3
  220 IF (J-NANZL) 200,190,60
C
  230 IF (N-7) 240,260,280
C                            BT
C
  240 DO 250 K=1,10
        IAIN(K)=ISKP(24)
  250 CONTINUE
      CALL ADDAPO (IPK(JPKP+8,NS),(9-NANZL)*4,AIN,K)
      K=(K+3)/4
      FMT(3)=FMT1(K)
      WRITE (WRLINE,'(A,20X,2F6.2,F6.3,A)')
     1 'BT',(AIPK(JPKP+J,NS),J=4,6),' ='
      CALL KPCDST (IRLINE, 3,IPK(JPKP+2,NS))
      CALL KPCDST (IRLINE,13,IPK(JPKP+3,NS))
      CALL KPWRTE (NTBILF)
      WRITE (WRLINE,FMTC) (AIN(J),J=1,K),
     1 (IPK(JPKP+J,NS),J=NANZL-1,NANZL)
      CALL KPWRTE (NTBILF)
      GO TO 60
C
  260 WRITE (WRLINE,270) KDOT(N),(IPK(JPKP+J,NS),J=2,4),
     1 (AIPK(JPKP+J,NS),J=5,10),(IPK(JPKP+J,NS),J=11,NANZL)
      CALL KPWRTE (NTBILF)
  270 FORMAT (A4,3I10,6F7.2,2I4)
      GO TO 60
C
  280 IF (N-12) 300,340,290
  290 IF (N-14) 340,340,320
C                            VE,VEH,VEU,PF,PFU
C
  300 WRITE (WRLINE,310) KDOT(N),(IPK(JPKP+J,NS),J=2,5),
     1 (AIPK(JPKP+J,NS),J=6,7),(IPK(JPKP+J,NS),J=8,9),
     2 (AIPK(JPKP+J,NS),J=10,12),(IPK(JPKP+J,NS),J=13,NANZL)
      CALL KPWRTE (NTBILF)
  310 FORMAT (A4,4I5,2F6.2,2I5,3F6.2,2I4)
      GO TO 60
C                            PFD
C
  320 IF (N .LT. 17) GO TO 300
      IF (N .GT. 17) GO TO 60
      WRITE (WRLINE,330) KDOT(N),IPK(JPKP+2,NS),IPK(JPKP+3,NS)
      CALL KPWRTE (NTBILF)
  330 FORMAT (A4,I3,I10,' =')
      IA=4
      GO TO 360
C                            VD, VDS und VDR
  340 NANZL=NANZL-1
      WRITE (WRLINE,350) KDOT(N),AIPK(JPKP+2,NS),
     1 (IPK(JPKP+IA,NS),IA=3,6)
      CALL KPWRTE (NTBILF)
  350 FORMAT (A4,F9.2,4I5,' =')
      IA=8
  360 IE=IA+5
      IF (IE .GT. NANZL) IE=NANZL
      WRLINE=' '
      M=5
      DO  J=IA,IE
        CALL KPCDST (IRLINE,M,IPK(JPKP+J,NS))
        M=M+10
      ENDDO
      IF (IE .LT. NANZL) WRLINE(66:66)='='
      CALL KPWRTE (NTBILF)
      IF (IE .GE. NANZL) GO TO 60
      IA=IA+6
      GO TO 360
C                            QUR - Ursprung
C
  370 DO  I=1,3
        IF (ABS(UR(I,NS)) .GT. CONST(21)) GO TO 375
      ENDDO
      GO TO 385
  375 DO  I=1,3
        IF (ABS(UR(I,NS)-AT(I,1,NS)) .GT. CONST(21)) GO TO 377
      ENDDO
      WRITE (WRLINE,'(A)') 'K  1'
      CALL KPWRTE (NTBILF)
      GO TO 385
  377 WRITE (WRLINE,380) (UR(I,NS),I=1,3)
      CALL KPWRTE (NTBILF)
  380 FORMAT ('PT ',3F10.5,' ; KUP')
  385 IF (NTYP) 750,750,990
C                            Q - Orientierung
  390 IF (NS .EQ. 1) THEN
        CALL ZVORTN
        DO  I=1,3
          WRITE (WRLINE,'(A,I2,F8.2)') 'DK',I,CDS(I)
          CALL KPWRTE (NTBILF)
        ENDDO
      ENDIF
      IF (NTYP) 750,750,990
C                            QC-Codes
C
  420 IF(NCD(NS) .LE. 0) GO TO 90
      DO  J=1,NCD(NS),7
        K=J+6
        IF (K .GT. NCD(NS)) K=NCD(NS)
        WRLINE='ACIM'
        N=6
        DO  M=J,K
          CALL KPCDST (IRLINE,N,ICD(M,NS))
          N=N+10
        ENDDO
        CALL KPWRTE (NTBILF)
      ENDDO
      IF (NTYP) 750,750,990
C                            QT-Titel
C
  430 CALL ADDAPO (TITEL(1,NS),-72,AIN,K)
      WRITE (WRLINE,440) (I1AIN(I),I=1,K)
      CALL KPWRTE (NTBILF)
  440 FORMAT ('T ',77A1)
      IF (NTYP) 750,750,990
C                            QZ - Gitterkonstanten
C
  450 IF ((NSYM(3-NS) .EQ. 0 .AND. NAT(3-NS) .EQ. 0) .OR.
     +  (ABS(DG(2,1,NS))+ABS(DG(3,1,NS))+ABS(DG(3,2,NS))) .EQ. 0.) THEN
        WRITE (WRLINE,'(A,3F10.5,3F10.4)') 'Z ',(ZELLE(I,NS),I=1,6)
        CALL KPWRTE (NTBILF)
        WRITE (WRLINE,'(A,3F10.5,A)') '!ZBAS ',(DG(I,1,NS),I=1,3),' ='
        CALL KPWRTE (NTBILF)
        WRITE (WRLINE,'(A,5X,6F10.5)') '!',((DG(I,J,NS),I=1,3),J=2,3)
        CALL KPWRTE (NTBILF)
      ELSE
        WRITE (WRLINE,'(A,3F10.5,3F10.4)') '!Z ',(ZELLE(I,NS),I=1,6)
        CALL KPWRTE (NTBILF)
        WRITE (WRLINE,'(A,3F10.5,A)') 'ZBAS ',(DG(I,1,NS),I=1,3),' ='
        CALL KPWRTE (NTBILF)
        WRITE (WRLINE,'(5X,6F10.5)') ((DG(I,J,NS),I=1,3),J=2,3)
        CALL KPWRTE (NTBILF)
      ENDIF
      IF (NTYP) 750,750,990
C                            QZB - Zeichenbedingungen
C
  470 IF (ISKP(43)+NTYP) 480,490,480
  480 WRITE (WRLINE,'(A,2F7.2,F6.2)') 'ZF',(CONST(I),I=8,10)
      CALL KPWRTE (NTBILF)
      WRITE (WRLINE,'(A,2F7.2)') 'UR',(CONST(I),I=11,12)
      CALL KPWRTE (NTBILF)
      WRITE (WRLINE,'(A,F7.2)') 'F',O9
      CALL KPWRTE (NTBILF)
  490 IF (HOE .NE. 60.) THEN
        WRITE (WRLINE,'(A,E10.2)') 'H',HOE
        CALL KPWRTE (NTBILF)
      ENDIF
      IF (CONST(13) .NE. 6.) THEN
      WRITE (WRLINE,'(A,F7.3)') 'SW',CONST(13)
      CALL KPWRTE (NTBILF)
      ENDIF
      IF (FKGL .NE. 1.) THEN
        WRITE (WRLINE,'(A,F7.2)') 'KF',FKGL
        CALL KPWRTE (NTBILF)
      ENDIF
      IF (KONST(36) .NE. 0) THEN
        WRITE (WRLINE,'(A,I4)') 'BST',KONST(36)
        CALL KPWRTE (NTBILF)
      ENDIF
      IF (NTYP) 750,750,990
C                            QRW - Rewind
  500 REWIND NTBILF
      GO TO 990
C                            QA - Atome
  510 NTYPSS=NTYP
      I=0
      GO TO 540
  520 I=I+1
      DO  J=1,6
        IAIN(J)=ISKP(24)
      ENDDO
      CALL ADDAPO (AT(5,I,NS),4,I1AIN(1),J)
      CALL ADDAPO (AT(6,I,NS),4,I1AIN(12),J)
      WRITE (WRLINE,530) I,(I1AIN(J),J=1,21),
     1 (AT(J,I,NS),J=1,4),ICLRP(I,NS)
  530 FORMAT ('ATOM (',I4,') ',21A1,3F10.6,F10.4,I5)
      CALL KPWRTE (NTBILF)
      IF (ISKP(63) .NE. 0 .AND. IPFLG(I,NS) .EQ. 8) THEN
        IANR=I
        ISYNR=1
        NTYP=5
        CALL ZVTFHN
        AIN(12)=8.
        WRITE (WRLINE,'(A,6F10.6,F3.0)') 'TL ',(AIN(J),J=6,12)
        CALL KPWRTE (NTBILF)
      ENDIF
  540 IF (I .LT. NAT(NS)) GO TO 520
      NTYP=NTYPSS
C
C                           Punche Atomfarben
  550 IF (NS .EQ. 1) THEN
      DO  I=1,IATFDM
        IAIN(I)=0
      ENDDO
C                          Teste, ob Farbe erwaehnt.
  555 DO  J=1,NAT(NS)
        IF (ICLRP(J,NS) .GT. 0 .AND. ICLRP(J,NS) .LE. IATFDM)
     +    IAIN(ICLRP(J,NS))=1
      ENDDO
      J=1
  560 IF (J .LT. IPKP(NS)) THEN
        IF (IPK(J+1,NS) .GE. 2 .AND. IPK(J+1,NS) .LE. 4) THEN
          K=IPK(J+9,NS)
          IF (K .GE. 0 .AND. K .LE. IATFDM) IAIN(K)=1
        ENDIF
        IF (IPK(J+1,NS) .GE. 12 .AND. IPK(J+1,NS) .LE. 14) THEN
          K=IPK(J+3,NS)
          IF (K .GE. 0 .AND. K .LE. IATFDM) IAIN(K)=1
        ENDIF
        J=J+IPK(J,NS)
        GO TO 560
      ENDIF
      IF (NS .EQ. 1) THEN
        NS=2
        GO TO 555
      ELSE
        NS=1
      ENDIF
      DO  I=1,IATFDM
        IF (IAIN(I) .NE. 0) THEN
          WRITE (WRLINE,570) I,(IATF(J,I),J=1,14),(AATF(J,I),J=15,17)
  570     FORMAT ('ATF',I3,3X,6I3,2I5,6I3,2F8.4,F7.2)
          CALL KPWRTE (NTBILF)
        ENDIF
      ENDDO
      ENDIF
      IF (NTYP) 750,750,990
C                            QTF - Anisotrope Tf's
  580 NTYPSS=NTYP
      IF (ISKP(63) .NE. 0) GO TO 600
      DO  I=ISKP(53),NAT(NS)
        IF (IPFLG(I,NS) .EQ. 8) THEN
          DO  J=ISKP(53),I-1
            IF (IPFLG(J,NS) .EQ. 8 .AND. AT(5,I,NS) .EQ. AT(5,J,NS)
     1      .AND. AT(6,I,NS) .EQ. AT(6,J,NS)) GO TO 590
          ENDDO
          DO  J=1,6
            IAIN(J)=ISKP(24)
          ENDDO
          CALL ADDAPO (AT(5,I,NS),4,I1AIN(1),J)
          CALL ADDAPO (AT(6,I,NS),4,I1AIN(12),J)
          WRITE (WRLINE,'(A,21A1)') 'TF ',(I1AIN(J),J=1,21)
          IANR=I
          ISYNR=1
          NTYP=5
          CALL ZVTFHN
          AIN(12)=8.
          WRITE (WRLINE(25:75),'(6F8.5,F3.0)') (AIN(J),J=6,12)
          CALL KPWRTE (NTBILF)
        ENDIF
  590   CONTINUE
      ENDDO
      NTYP=NTYPSS
  600 IF (NTYP) 750,750,990
C                            QSY - Symmetrien
C
  610 IF (NHMSNR(3,NS)) 640,640,620
  620 WRITE (WRLINE,630) NHMSNR(1,NS),NHMSNR(2,NS),NHMSNR(3,NS)
      CALL KPWRTE (NTBILF)
  630 FORMAT ('HMS ''',2A4,''' (',I5,')')
      GO TO 650
C
  640 ISKP(14)=NTBILF
      CALL ZVSYOU
  650 ISKP(14)=0
      IF (NTYP) 750,750,990
C                            Ausgabe-Einheit
C
CYENG1
  660 CALL FLES (NTBILF,ISKP(31),2HIE,4HNr?$)
CYENG2
CYENGY  660 CALL FLES (NTBILF,ISKP(31),2HIE,4HNo?$)
      GO TO 999
C                            Backspace
  670 NANZ=1
CYENG1
      CALL FLES (NANZ,ISKP(31),2HIE,6HAnz.?$)
CYENG2
CYENGY
      CALL FLES (NANZ,ISKP(31),2HIE,8HNumber?$)
      DO 680 I=1,NANZ
  680 BACKSPACE NTBILF
      GO TO 999
C                            QFK - Freie Koordinaten
  690 IAIN(1)=NCDA(NS)
      IAIN(2)=NCD(NS)
CYENG1
      CALL FLES (IAIN,ISKP(31),3H2JR,25Hvon,bis (Nrn Codeliste)?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),3H2JR,28Hfrom,to (Nos in code list)?$)
      I=IAIN(1)
      NTYP=NTBILF
      CALL ZVEAEH
      NTRY=44
      NC=1
      IC=I-1
      GO TO 720
  700 IC=IC+1
      CALL ZVDEK
      WRITE (WRLINE,710) X2,AT(5,IANR,NS),AT(6,IANR,NS)
      CALL KPWRTE (NTBILF)
  710 FORMAT (3F15.6,4X,2A4)
  720 IF (IC-IAIN(2)) 700,999,999
C
  730 IF (NTYPS .EQ. 22) GO TO 820
C
C                            QALL - Alles abspeichern
  735 ITYP=0
      NTYP=0
      IF (NS .EQ. 1) THEN
        WRITE (WRLINE,'(A)') 'NDLG'
        CALL KPWRTE (NTBILF)
      ELSE
        WRITE (WRLINE,'(A)') 'NS;'
        CALL KPWRTE (NTBILF)
      ENDIF
      IF (NTYPS .EQ. 23) GO TO 830
  750 ITYP=ITYP+1
      NTYPS=ITYPT(ITYP)
      IF (NTYPS) 760,760,20
  760 IF ((ISKP(44) .NE. 1) .OR. (CONST(35) .NE. 0.1) .OR.
     +  (CONST(40) .NE. 0.) .OR. (ISKP(50) .NE. 0)) THEN
        WRITE (WRLINE,770) ISKP(44),CONST(35),CONST(40),ISKP(50)
  770   FORMAT ('VEO',I4,F8.5,F11.3,I4)
        CALL KPWRTE (NTBILF)
      ENDIF
      NTYP=-3
      CALL ZVPLDR (NTYP)
      NTYP=7
      CALL ZVEXPU
      NTYP=9
      CALL ZVEXPU
      NTYP=15
      CALL ZVGE04
      IF (NS .EQ. 1) THEN
        IF (ISKP(27) .NE. 0) THEN
          WRITE (WRLINE,'(A,2F10.3,I3)')
     +    'UDST',CONST(23),CONST(24),ISKP(27)
          CALL KPWRTE (NTBILF)
        ENDIF
        IF (ISKP(53) .NE. 3) THEN
          WRITE (WRLINE,'(A,I5)') 'SPST',ISKP(53)
          CALL KPWRTE (NTBILF)
        ENDIF
        IF (ISKP(10) .NE. 0) THEN
          WRITE (WRLINE,'(A,I3)') 'BSF',ISKP(10)
          CALL KPWRTE (NTBILF)
        ENDIF
        WRITE (WRLINE,'(A,I4)') 'PR',ISKP(3)
        CALL KPWRTE (NTBILF)
        IF (ISKP(61) .NE. 0) THEN
          WRITE (WRLINE,'(A,I3)') 'ORTP',ISKP(60)
          CALL KPWRTE (NTBILF)
        ENDIF
        IF (ISKP(63) .NE. 0) THEN
          WRITE (WRLINE,'(A,I3)') 'TFL',ISKP(63)
          CALL KPWRTE (NTBILF)
        ENDIF
        IF (ABS(CONST(43)-1.54) .GT. 0.001) THEN
          WRITE (WRLINE,'(A,F10.5)') 'WFKT',CONST(43)
          CALL KPWRTE (NTBILF)
        ENDIF
        IF (CONST(44) .GT. 0.) THEN
          WRITE (WRLINE,'(A,F10.5)') 'DISP',CONST(44)
          CALL KPWRTE (NTBILF)
        ENDIF
        IF (ISKP(86) .NE. 0) THEN
          DO  I=1,9
            NTYP=3
            ISKP(14)=I
            CALL ZVEXMC
          ENDDO
        ENDIF
        IF (ISKP(15) .NE. 0) THEN
          WRITE (WRLINE,'(A)') 'NGLP'
          CALL KPWRTE (NTBILF)
        ENDIF
        CALL ZVDTAB (IAIN(1),IAIN(2),AIN(3),6)
        NTYP=7
        CALL ZVMDLS
      ENDIF
      ISKP(14)=0
      IF (NS .EQ. 1) THEN
        IF (ISKP(59) .EQ. 3) THEN
          WRITE (WRLINE,'(A)') 'HF;BF;ECHO ''... stpu'''
          CALL KPWRTE (NTBILF)
        ENDIF
        IF (ISKP(59) .EQ. 4) THEN
          WRITE (WRLINE,'(A)') 'BF;ECHO ''... epu'''
          CALL KPWRTE (NTBILF)
        ENDIF
      ENDIF
  790 IF (NS .EQ. 1 .AND. (NSYM(2) .NE. 0 .OR. NAT(2) .NE. 0)) THEN
        NS=2
        GO TO 735
      ENDIF
      IF (ICLSFL .EQ. 0) THEN
        WRITE (WRLINE,'(A)') 'EAE 5 ; DLG'
      ELSE
        WRITE (WRLINE,'(A)') 'CLSE ; DLG'
      ENDIF
      CALL KPWRTE (NTBILF)
      IF (ICLSFL .EQ. 0) GO TO 810
C                            Schliesse NTBILF
  800 NTYP=NTBILF+100
      CALL ZVEAEH
  810 NTYP=NTYPS
      NTBILF=NTBILS
      GO TO 990
C                            SRGS - Symmetrien an RGS
C
  820 CONTINUE
      NS=NSSV
C     WRITE (WRLINE,'(A)') 'RSTR'
C     CALL KPWRTE (NTBILF)
      WRITE (WRLINE,'(A,3F10.5,3F10.4,A)')
     + 'Z',(ZELLE(I,NS),I=1,6),'; ES 1 192'
      CALL KPWRTE (NTBILF)
      I=NHMSNR(3,NS)
      NHMSNR(3,NS)=0
      ISKP(14)=NTBILF
      CALL ZVSYOU
      ISKP(14)=0
      WRITE (WRLINE,'(A)') 'EOF'
      CALL KPWRTE (NTBILF)
      NHMSNR(3,NS)=I
      GO TO 800
C                            Atome in kart. koordinaten
C
  830 WRITE (WRLINE,'(A)') 'NPCK'
      CALL KPWRTE (NTBILF)
      IF (ISKP(89) .GT. 0) THEN
C
C                            Auch die zelle als atome ausgeben
        DO  I=1,3
          WRITE (WRLINE,'(A,A2,A,3F10.5,A)')
     +    'AKRT ',NAMACH(I),''' ''',(DG(J,I,NS),J=1,3),' 0.01'
          CALL KPWRTE (NTBILF)
        ENDDO
      ENDIF
      NC=1
      NTRY=44
      DO  IC=NCDA(NS),NCD(NS)
        CALL ZVDEK
        DO  J=1,6
          IAIN(J)=ISKP(24)
        ENDDO
        CALL ADDAPO (AT(5,IANR,NS),4,I1AIN(1),J)
        CALL ADDAPO (AT(6,IANR,NS),4,I1AIN(12),J)
        TEMP=AT(4,IANR,NS)
        IF (ISKP(91) .GT. 0 .AND. IC .GT. ISKP(91)) TEMP=0.001
        WRITE (WRLINE,'(A,I4,A,21A1,3F10.5,F10.4,I5)')
     +  'AKRT (',IC,') ',(I1AIN(J),J=1,21),X2,TEMP,ICLRP(IANR,NS)
        CALL KPWRTE (NTBILF)
      ENDDO
      ISKP(91)=0
      GO TO 790
C
C                            Skip to Kartenende
C
  990 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
  999 NS=NSSV
      RETURN
      END
