C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPEIGN   41         ---------------------------
                      SUBROUTINE ZVEIGN (A,B,N)
C CY-ENG-            ---------------------------
C
C                      Geschrieben: Ohlendorf
C                 Geaendert: 041039 FEB 2000  (Hundt)
C
C                    ---------------------------
C
      IMPLICIT NONE
      INTEGER *4 I,IA,IB,IND,IR,J,K,N
      REAL    *4 A(N,N),ANORM,B(N,N),CO,FLN,GEN,SI,TA,TAU,TEMP
      REAL    *4 TEST,THR,X,Y
C
C                            A WIRD DIAGONALISIERT,B WIRD DIE
C                            EIGENVEKTORMATRIX
      FLN=N
      DO 20 I=1,N
      DO 10 J=1,N
   10 B(I,J)=0.
   20 B(I,I)=1.
C                            DIE GENAUIGKEIT WIRD FESTGELEGT
      GEN=.1E-8
C                            DIE AUSSENNORM WIRD BERECHNET
      ANORM=0.
      IA=N-1
      DO 30 I=1,IA
      IB=I+1
      DO 30 J=IB,N
      TEMP=A(I,J)
   30 ANORM=ANORM+2.*TEMP*TEMP
C
C                            IST DIE AUSSENNORM GLEICH NULL?
      IF(ANORM) 999,999,40
   40 ANORM=SQRT(2.*ANORM)
      TEST=ANORM*GEN/FLN
      IND=0
      THR=ANORM
C                            JETZT WIRD GEROEDELT
C                            EIN NIVEAU WIRD GESETZT (THR)
   50 THR=THR/FLN
C                            ES WIRD NUR DIE OBERE HAELFTE BENUTZT
C                            K IST IMMER GROESSER ALS J
   60 J=1
   70 K=J+1
C                            TRANSFORMATION NUR,WENN A(J,K)>THR
C
   80 IF(ABS(A(J,K))-THR)  160,160,90
C
C                            TAN SIN UND COS WERDEN BERECHNET
   90 IND=1
      X=(A(J,J)-A(K,K))*.5/A(J,K)
      TA =SIGN(1.,X)/(ABS(X)+SQRT(1.+X*X))
      CO =1./SQRT(1.+TA *TA )
      SI =TA *CO
C                            DIE ZU DEM INDEXPAAR GEHOERENDEN ELEMENTE
C                            WERDEN BERECHNET
      TEMP=A(J,K)*TA
      A(J,J)=A(J,J)+TEMP
      A(K,K)=A(K,K)-TEMP
      A(J,K)=0.
C                            DER REST DER J-TEN UND K-TEN ZEILE UND
C                            SPALTE MUSZ NOCH BEHANDELT WERDEN
      TAU=SI /(1.+CO )
      DO 150 IR=1,N
      IF(IR-J)  100,140,110
C                            IR IST KLEINER ALS J UND AUCH KLEINER ALS K
  100 X=A(IR,J)
      Y=A(IR,K)
      A(IR,J)=X+SI *(Y-TAU*X)
      A(IR,K)=Y-SI *(X+TAU*Y)
      GOTO 140
C                            IR IST GROESSER ALS J
  110 IF(IR-K) 120,140,130
C                            IR IST KLEINER ALS K,ZU BERECHNEN IST DAS
C                            NEUE ELEMENT A(J,IR) DER J-TEN ZEILE UND
C                            DAS ELEMENT A(IR,K) DER K-TEN SPALTE
  120 X=A(J,IR)
      Y=A(IR,K)
      A(J,IR)=X+SI *(Y-TAU*X)
      A(IR,K)=Y-SI *(X+TAU*Y)
      GOTO 140
C                            IR IST GROESSER ALS K,ZU BERECHNEN IST
C                            A(J,IR) UND A(K,IR)
  130 X=A(J,IR)
      Y=A(K,IR)
      A(J,IR)=X+SI *(Y-TAU*X)
      A(K,IR)=Y-SI *(X+TAU*Y)
C                            DIE EIGENVEKTOREN WERDEN AUFGERECHNET
  140 X=B(IR,J)
      B(IR,J)=X*CO +SI *B(IR,K)
  150 B(IR,K)=-SI *X+CO *B(IR,K)
C
C                            IST K DIE LETZTE SPALTE?
  160 IF(K-N) 170,180,170
  170 K=K+1
      GOTO 80
C                            IST J DIE VORLETZTE SPALTE?
  180 IF(J-N+1) 190,200,190
  190 J=J+1
      GOTO 70
C                            INDIKATOR ABFRAGEN
  200 IF (IND) 220,220,210
  210 IND=0
      GOTO 60
C                            DIE TESTGROESSE WIRD VERGLICHEN
  220 IF(THR-TEST) 999,999,50
  999 RETURN
      END
