C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C     68                 -------------------
                          SUBROUTINE ZVEXMC
C    CY-VAX-ENG-         -------------------
C
C              Unterprogramm zur Ausfuehrung von Macros
C
C                MACR      01   Definition
C                OMAC      02   Makro Zeigen
C                QMAC      03   Makro auf File
C                MACC      04   Makro continue
C                1         05   Makro 1 ausfuehren
C                ...
C                9         13   Makro 9 ausfuehren
C                EMAC      14   Makros loeschen
C                DFMA      15   Defaults fuer Makroargumente
C
C                geschrieben: 200912 OCT 1991  (Hundt)
C                geaendert:   040956 APR 2008  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INTEGER *4 MACDIM,MACEFL
      PARAMETER (MACDIM=5000,MACEFL=MACDIM-1)
      INTEGER *4 MACANZ
      PARAMETER (MACANZ=9)
      INTEGER *4 STDIN
      PARAMETER (STDIN=5)
      INTEGER *4 NTYPS,MACPOI(MACANZ),MACEFP,I,J,K,K1,L,NR,KEYIN
      INTEGER *4 KDENDM,ISTK(8),ISTPOI,KDMACC,KARTE,KARPOI
      INTEGER *4 IARGS(3,9),IARGL(9),KDO,KDMVTO,IADR,KDSETC,KDDMNZ
      INTEGER *4 ICNT,KDMLEG,IAIN(72),ISTKA(8),LCOMPS
      INTEGER *4 KDWAIT,IRC,IERRFL,KK,KDINC,KDVDGR,KDIMLE,ISTPSV
      INTEGER *4 KDFADD,KDFMUL
CYVAX1
      INTEGER *1 LCHR(24),MACBFR(MACDIM),KARTE1(80),IARGS1(12,9)
CYVAX2
CYVAXY      LOGICAL *1 LCHR(20),MACBFR(MACDIM),KARTE1(80),IARGS1(12,9)
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
C
      COMMON /KPFLIN/ KARTE(20),KARPOI
C
      EQUIVALENCE (KARTE(1),KARTE1(1)),(IARGS(1,1),IARGS1(1,1))
      EQUIVALENCE (AIN(1),IAIN(1)),(ISKP(45),ISTPOI)
      EQUIVALENCE (ISKP(85),ISTPSV)
C
      SAVE MACPOI,MACEFP,MACBFR,ISTK,ISTKA,IARGS,IARGL,ICNT
C     SAVE
C
CYVAX1
      DATA LCHR/1H ,  0 ,  4 ,1H;,1H%,
CYVAX2
CYVAXY      DATA LCHR/1H ,Z'0',Z'4',1H;,1H%,
     + 1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H$,1HP,1Hp,1H-,1H&,
C                                              16  17  18  19  20
     + 1H.,1HC,1Hc,1H /
C      21  22  23  24  
      DATA MACPOI/MACANZ*0/,KDMACC/4HMACC/
      DATA KDENDM/4HENDM/,MACEFP/1/
      DATA IARGS/27*4H    /,KDMVTO/4HMVTO/,KDSETC/4HSETC/
      DATA KDDMNZ/4HDMNZ/,KDMLEG/4HMLEG/,KDFADD/4HFADD/
      DATA KDWAIT/4HWAIT/,KDINC/4HINC /,KDVDGR/4HVDGR/,KDIMLE/4HIMLE/
      DATA KDFMUL/4HFMUL/
C
      NTYPS=NTYP
      IF (NTYPS .EQ. 14) GO TO 1030
      IF (NTYPS-4) 10,580,500
C
C                            Macro-Definition
C
   10 IF (ISKP(14) .NE. 0) THEN
        NR=ISKP(14)
      ELSE
CYENG1
        CALL FLES (NR,ISKP(31),2HIE,8HNummer?$)
CYENG2
CYENGY        CALL FLES (NR,ISKP(31),2HIE,6HNo.? $)
      ENDIF
      IF (NR .LE. 0 .OR. NR .GT. MACANZ) THEN
        IERR=69 0076 16
        GO TO 9999
      ENDIF
C
      IF (NTYPS-2) 50,320,310
C                            Teste, ob nicht innerhalb eines Makros.
   50 IF (ISTPSV .NE. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVEXMC0085 - Versuch, Makro innerhalb eines Makros zu aendern.'
CYENG2
CYENGY     +  'ZVEXMC0085 - Attempt to change macro within a macro.'
        CALL KPWRTE (NTDISP)
        IF (NTYPS .EQ. 14) THEN
          IERR=-1
          ISTPSV=0
          GO TO 9999
        ENDIF
        IERRFL=-1
        GO TO 160
      ENDIF
C                            Loesche ggf. vorhandenes Macro.
      I=MACPOI(NR)
   55 K=I
      J=I
      IF (I) 150,150,70
C                            Suche Macro-Ende
   60 J=J+1
   70 IF (LCOMPS(MACBFR,J,1, LCHR,3) .NE. 0) GO TO 60
      K1=J-K+1
      GO TO 100
   90 MACBFR(I)=MACBFR(J)
      I=I+1
  100 J=J+1
      IF (J .LT. MACEFP) GO TO 90
      MACEFP=I
      DO  I=1,MACANZ
        J=MACPOI(I)
        IF (J .GT. 0 .AND. J .GT. K) MACPOI(I)=J-K1
      ENDDO
      IF (NTYP .NE. 14) GO TO 150
      MACPOI(NR)=0
      GO TO 1040
C
  150 MACPOI(NR)=MACEFP
      IERRFL=0
  160 CALL KPRDLN (NTIN,IRC)
      IF (IRC .NE. 0) GO TO 280
      READ (RDLINE,170) KARTE
  170 FORMAT (20A4)
      IF (NTOSYS .GT. 0 .AND. NTIN .EQ. STDIN) THEN
        WRITE (WRLINE,170) KARTE
        CALL KPWRTE (NTOSYS)
      ENDIF
C                       Schiebe Info ggf. nach links
C
      IF (KARTE1(1) .NE. LCHR(1)) GO TO 210
      J=1
      I=2
  180 IF (KARTE1(I) .NE. LCHR(1)) GO TO 190
      I=I+1
      IF (I .LE. 80) GO TO 180
      GO TO 160
C
  190 KARTE1(J)=KARTE1(I)
      I=I+1
      J=J+1
      IF (I .LE. 80) GO TO 190
  200 KARTE1(J)=LCHR(1)
      J=J+1
      IF (J .LE. 80) GO TO 200
C
  210 I=KARTE(1)
      CALL CNVTUP (I,1,4)
      IF (I .EQ. KDENDM) GO TO 300
      DO  J=80,1,-1
        IF (LCOMPS(KARTE1,J,1, LCHR,1) .NE. 0) GO TO 230
      ENDDO
      GO TO 160
C                            Uebertrage Zeile.
C
  230 IF (IERRFL .NE. 0) GO TO 160
      DO  I=1,J
        MACBFR(MACEFP)=KARTE1(I)
        IF (MACEFP .GE. MACEFL) GO TO 260
        MACEFP=MACEFP+1
      ENDDO
      MACBFR(MACEFP)=LCHR(2)
      IF (MACEFP .LT. MACEFL) THEN
        MACEFP=MACEFP+1
        GO TO 160
      ENDIF
C
  260 WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVEXMC0162 - Macro-Puffer voll.'
CYENG2
CYENGY     + 'ZVEXMC0162 - Macro-buffer full.'
      CALL KPWRTE (NTDISP)
      IERRFL=1
      MACEFP=MACPOI(NR)
      MACPOI(NR)=0
      GO TO 160
C
  280 WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVEXMC0173 - Dateiende.'
CYENG2
CYENGY     + 'ZVEXMC0173 - End of file.'
      CALL KPWRTE (NTDISP)
  300 IF (IERRFL .NE. 0) GO TO 9999
      MACBFR(MACEFP)=LCHR(3)
      MACEFP=MACEFP+1
      GO TO 9999
C                            Macro auf File (QMAC)
  310 NTYP=NTBILF
      CALL ZVEAEH
      GO TO 330
C                            Liste Macro.
  320 NTYP=NTOUT
  330 I=MACPOI(NR)
      IF (I .GT. 0) GO TO 360
  340   IF (ISKP(14) .NE. 0) GO TO 9999
        WRITE (WRLINE,'(A,I2,A)')
CYENG1
     + 'ZVEXMC0192 - Kein Macro',NR,' definiert.'
CYENG2
CYENGY     + 'ZVEXMC0192 - No macro',NR,' defined.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 9999
C
  360 IF (NTYPS .GT. 2) THEN
        WRITE (WRLINE,'(A,I2)') 'MACR',NR
        CALL KPWRTE (NTBILF)
      ENDIF
  390 J=I
      IF (LCOMPS(MACBFR,I,1, LCHR,3) .EQ. 0) THEN
        IF (NTYPS .GT. 2) THEN
          WRITE (WRLINE,'(A)') 'ENDM'
          CALL KPWRTE (NTBILF)
        ENDIF
        GO TO 9999
      ENDIF
  400 J=J+1
      IF (LCOMPS(MACBFR,J,1, LCHR,2) .NE. 0) GO TO 400
      J=J-1
      WRITE (WRLINE,'(80A1)') (MACBFR(K),K=I,J)
      CALL KPWRTE (NTYP)
      I=J+2
      GO TO 390
C
C                       Macro-Aufruf
C
  500 IF (ISKP(14) .NE. 0) THEN
        ISKP(14)=0
      ELSE
        CALL FLES (IARGS,ISKP(31),17H3A3A3A3A3A3A3A3AE,
     +  11Hp1,...,p8?$)
      ENDIF
C
C                       Bestimme Laenge.
      DO  I=1,8
        K=0
        DO  J=1,12
          IF (LCOMPS(IARGS1(1,I),J,1, LCHR,1) .NE. 0) K=J
        ENDDO
        IARGL(I)=K
      ENDDO
      IF (NTYPS .GE. 14) GO TO 9999
C
      NR=NTYPS-4
      IF (MACPOI(NR) .LE. 0) GO TO 340
      IF (ISTPOI .GE. 8) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +   'ZVEXMC0242 - Stack-Overflow.'
CYENG2
CYENGY     +   'ZVEXMC0242 - Stack overflow.'
        CALL KPWRTE (NTDISP)
        GO TO 1010
      ENDIF
C
      ISTPOI=ISTPOI+1
      ISTPSV=ISTPOI
      ISTK(ISTPOI)=MACPOI(NR)
      ISTKA(ISTPOI)=MACPOI(NR)
C
C                       Loesche Zeile und bringe Macro drauf (MACC)
  580 DO  I=1,20
        KARTE(I)=ISKP(24)
      ENDDO
      KARPOI=0
      J=1
      IF (ISTPOI .LE. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +   'ZVEXMC0262 - Stack-leer.'
CYENG2
CYENGY     +   'ZVEXMC0262 - Stack empty.'
        CALL KPWRTE (NTDISP)
        GO TO 1010
      ENDIF
C
      I=ISTK(ISTPOI)
      IF (LCOMPS(MACBFR,I,1, LCHR,3)) 670,820,670
  630 IF (J .LT. 76) GO TO 660
  640 WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVEXMC0274 - Zeilenueberlauf.'
CYENG2
CYENGY     + 'ZVEXMC0274 - Overfull line.'
      CALL KPWRTE (NTDISP)
      GO TO 1010
C
  660 KARTE1(J)=MACBFR(I)
      J=J+1
      I=I+1
  670 IF (LCOMPS(MACBFR,I,1, LCHR,5) .EQ. 0) GO TO 710
C
C                            Test auf &
C
      IF (LCOMPS(MACBFR,I,1, LCHR,20) .EQ. 0) THEN
        I=I-1
        K=0
        CALL KPNTOS (ICNT,IARGS(1,9),K,0)
        IARGL(9)=K
        K=9
        GO TO 750
      ENDIF
C                            Test auf $C und $P
C
      IF (LCOMPS(MACBFR,I,1, LCHR,16) .NE. 0) GO TO 790
      IF (LCOMPS(MACBFR,I+1,1, LCHR,22) .EQ. 0) GO TO 675
      IF (LCOMPS(MACBFR,I+1,1, LCHR,23) .NE. 0) GO TO 679
  675 K1=NCD(NS)
      K=I+1
      GO TO 705
  679 IF (LCOMPS(MACBFR,I+1,1, LCHR,17) .EQ. 0) GO TO 680
      IF (LCOMPS(MACBFR,I+1,1, LCHR,18) .NE. 0) GO TO 790
C
C                            Konvertiere Zahl
  680 K1=0
      K=I+1
      IF (LCOMPS(MACBFR,I+2,1, LCHR,19) .NE. 0) GO TO 700
      IF (LCOMPS(MACBFR,I+3,1, LCHR, 5) .NE. 0) GO TO 690
C
C                            % ERKANNT
      K=I+3
      IRC=0
      CALL FCNV (KK,L,2HIR,MACBFR,K,MACEFL,IRC)
      IF (IRC .NE. 0) GO TO 730
      I=0
      IRC=0
      CALL FCNV (K1,L,2HIR,IARGS(1,KK),I,MACEFL,IRC)
      K1=-K1
      IF (IRC .NE. 0) GO TO 730
      GO TO 700
C
  690 IRC=0
      CALL FCNV (K1,L,2HIR,MACBFR,K,MACEFL,IRC)
      IF (IRC .NE. 0) GO TO 730
  700 K1=NAT(NS)+1+K1
  705 I=K-1
      K=0
      CALL KPNTOS (K1,IARGS(1,9),K,0)
      IARGL(9)=K
      K=9
      GO TO 750
C
C                       Substituiere Argument.
  710 DO  K=1,8
        IF (LCOMPS(MACBFR,I+1,1, LCHR,K+6) .EQ. 0) GO TO 750
      ENDDO
  730 WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVEXMC0336 - Illeg. Argument.'
CYENG2
CYENGY     + 'ZVEXMC0336 - Illegal argument.'
      CALL KPWRTE (NTDISP)
      WRITE (WRLINE,'(20A4)') KARTE
      CALL KPWRTE (NTDISP)
      GO TO 1010
C
  750 K1=IARGL(K)
      DO  L=1,K1
        IF (J .GE. 76) GO TO 640
        KARTE1(J)=IARGS1(L,K)
        J=J+1
      ENDDO
      I=I+2
      GO TO 670
C
  790 IF (LCOMPS(MACBFR,I,1, LCHR,2) .NE. 0) GO TO 630
C
C                       Teste, ob Befehl.
      I=I+1
      KARPOI=0
      CALL FLES (KDO,ISKP(31),2HAR,2H?$)
      CALL CNVTUP (KDO,1,4)
      IF (KDO .EQ. KDMVTO) GO TO 840
      IF (KDO .EQ. KDSETC) GO TO 940
      IF (KDO .EQ. KDDMNZ) GO TO 950
      IF (KDO .EQ. KDINC ) GO TO 961
      IF (KDO .EQ. KDIMLE) GO TO 962
      IF (KDO .EQ. KDMLEG) GO TO 970
      IF (KDO .EQ. KDFADD) GO TO 963
      IF (KDO .EQ. KDFMUL) GO TO 963
      IF (KDO .EQ. KDWAIT) GO TO 990
      KARPOI=0
  810 IF (LCOMPS(MACBFR,I,1, LCHR,3) .NE. 0) GO TO 1020
  820 ISTPOI=ISTPOI-1
      ISTPSV=ISTPOI
      IF (ISTPOI) 1010,825,830
  825 IF (ISKP(68) .NE. 0) THEN
        KARTE(20)=KDVDGR
        KARTE1(76)=LCHR(4)
        ISKP(68)=0
      ENDIF
      GO TO 9999
  830 I=ISTK(ISTPOI)
      GO TO 810
C                       Kommando MVTO
C
  840 CALL FLES (IADR,ISKP(31),2HIE,2H?$)
  850 I=ISTKA(ISTPOI)
      IF (IADR-1) 860,920,890
  860 WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVEXMC0388 - Ungueltiger Parameter in Macro.'
CYENG2
CYENGY     + 'ZVEXMC0388 - Invalid parameter in macro.'
      CALL KPWRTE (NTDISP)
      GO TO 1010
C                       Vorwaerts
  880 I=I+1
  890 IF (LCOMPS(MACBFR,I,1, LCHR,2) .NE. 0) GO TO 880
      I=I+1
      IADR=IADR-1
      IF (IADR .GT. 1) THEN
        IF (LCOMPS(MACBFR,I,1, LCHR,3)) 890,860,890
      ENDIF
C                       Update Stack
C
  920 IF (LCOMPS(MACBFR,I,1, LCHR,3) .EQ. 0) GO TO 820
  930 ISTK(ISTPOI)=I
      GO TO 580
C                       SETC
C
CYENG1
  940 CALL FLES (ICNT,ISKP(31),2HIE,5HNr? $)
CYENG2
CYENGY  940 CALL FLES (ICNT,ISKP(31),2HIE,5HNo? $)
      GO TO 920
C                       DMNZ
  950 ICNT=ICNT-1
      IF (ICNT .NE. 0) GO TO 840
      KARPOI=80
      GO TO 930
C                       INC
  961 ICNT=ICNT+1
      GO TO 930
C                       IMLE
  962 ICNT=ICNT+1
      CALL FLES (IAIN,ISKP(31),3H2IE,13HNumber,line?$)
      IADR=IAIN(2)
      IF (ICNT-IAIN(1)) 850,850,930
C
C                       FADD
  963 IAIN(1)=0
      AIN(2)=0.
      CALL FLES (IAIN,ISKP(31),3HIFE,13HArgNo,value?$)
      IF (IAIN(1) .LT. 1 .OR. IAIN(1) .GT. 8) GO TO 860
C
C                       Zaehle nachkommastellen
      K=KARPOI
  964 K=K-1
      IF (KARTE1(K) .EQ. LCHR(1)) GO TO 964
      J=K
  965 IF (KARTE1(J) .EQ. LCHR(21)) GO TO 966
      J=J-1
      GO TO 965
  966 IAIN(3)=K-J
      DO  K=1,12
        IF (IARGS1(K,IAIN(1)) .EQ. LCHR(21)) THEN
          DO  J=K+1,12
            IF (IARGS1(J,IAIN(1)) .EQ. LCHR(1)) THEN
              IAIN(4)=J-K-1
              GO TO 967
            ENDIF
          ENDDO
        ENDIF
      ENDDO
      IAIN(4)=0
  967 IF (KDO .EQ. KDFADD) THEN
        IAIN(3)=MAX(IAIN(3),IAIN(4))
      ELSE
        IAIN(3)=MIN(8,IAIN(3)+IAIN(4))
      ENDIF
      K=0
      J=0
      CALL FCNV (IAIN(5),ISKP(31),2HFR,IARGS(1,IAIN(1)),K,12,J)
      IF (J .NE. 0) GO TO 860
      IF (KDO .EQ. KDFADD) THEN
        AIN(2)=AIN(2)+AIN(5)
      ELSE
        AIN(2)=AIN(2)*AIN(5)
      ENDIF
      J=NINT(AIN(2)*10.**IAIN(3))
      DO  K=1,3
        IARGS(K,IAIN(1))=ISKP(24)
      ENDDO
      K=0
      CALL KPNTOS (J,IARGS(1,IAIN(1)),K,IAIN(3))
      IARGL(IAIN(1))=K
      GO TO 930
C
C                       MLEG
C
  970 AIN(5)=0.000001
      DO  K=2,4
        IAIN(K)=0
      ENDDO
CYENG1
      CALL FLES (IAIN,ISKP(31),5HF3IFE,25HZahl,Z(<),Z(=),Z(>),Tol?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),5HFIFIE,27HNumber,L(<),L(=),L(>),Tol?$)
      IF (KEYIN(0) .EQ. ISKP(20)) GO TO 1010
      AIN(6)=CONST(39)-AIN(1)
      IADR=IAIN(3)
      IF (ABS(AIN(6)) .LT. AIN(5)) GO TO 980
      IADR=IAIN(2)
      IF (AIN(6)) 980,930,975
  975 IADR=IAIN(4)
  980 IF (IADR .GT. 0) GO TO 850
      GO TO 930
C
C                       Wait
C
  990 CALL KPRDLN (STDIN,IRC)
      READ (RDLINE,170) KARTE
      DO  J=1,20
        IF (KARTE(J) .NE. ISKP(24)) THEN
          IF (NTOSYS .GT. 0 .AND. NTIN .EQ. STDIN) THEN
            WRITE (WRLINE,170) KARTE
            CALL KPWRTE (NTOSYS)
          ENDIF
          KARPOI=0
          ISTPOI=0
          ISTPSV=0
          GO TO 9999
        ENDIF
      ENDDO
      GO TO 930
C
C                       Macro ist verunglueckt.
 1010 ISTPOI=0
      ISTPSV=0
      KARPOI=80
      GO TO 9999
C                       Kopiere "Return" auf KARTE
 1020 KARTE1(76)=LCHR(4)
      KARTE(20)=KDMACC
      ISTK(ISTPOI)=I
      GO TO 9999
C                            EMAC - Entferne Makro
 1030 IAIN(1)=0
      IAIN(2)=0
CYENG1
      CALL FLES (IAIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),3H2IE,9Hfrom,to?$)
      IF (IAIN(1) .LE. 0) IAIN(1)=1
      IF (IAIN(2) .GT. MACANZ) IAIN(2)=MACANZ
      IF (IAIN(2) .EQ. 0) IAIN(2)=IAIN(1)
      IF (ISTPSV .NE. 0) GO TO 50
      NR=IAIN(1)-1
 1040 NR=NR+1
      IF (NR .GT. IAIN(2)) GO TO 9999
      I=MACPOI(NR)
      IF (I .GT. 0) GO TO 55
      GO TO 1040
C
 9999 RETURN
      END
