C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CZVEXPU   07             -------------------
                          SUBROUTINE ZVEXPU
C  CY-ENG-               -------------------
C                           PIXEL-VERSION
C
C  Das Programm fuehrt die gespeicherten Plotbefehle aus.  Es wird
C  vorausgesetzt, dass die Codeliste sortiert ist in der Weise, dass die
C  z-Koordinaten der gespeicherten Atome steigen.  Beim Plotten werden
C  dann verdeckte Linien beruecksichtigt.
C
C                 geschrieben: 280820 FEB 1984  (Hundt)
C                 geaendert:   271540 JAN 2010  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
      INCLUDE 'WRBFR.INC'
C                            Parameter fuer Kugeln
      INTEGER *4 IDCBDM
      PARAMETER (IDCBDM=6)
      REAL    *4 DCB(9,IDCBDM)
      INTEGER *4 IDCB(9,IDCBDM)
C
      INTEGER *4 IAT(8,PARDIM,2),IAIN(72),ATMSYM,NST,NTYPS,I,IPEFLG
      INTEGER *4 IPOL,NN,IPKPNT,IPLTBF,IC1,IC1CD,IC2CD,IRC,KK
      INTEGER *4 ICDIR,J,NSTPKT,NCOLPO,NCLR,NCOLFL
      INTEGER *4 IPOLS,NCOLSR,NNT,ICNT1,ICNT2,LCOMPS,IBLANK,KEYIN
      INTEGER *4 IPOI,K,JM,IHDFLG,IVDFLG,IUDSAV,NSSV,ICS1(2),ICT2(2)
      REAL    *4 VQ(IPKDIM,2),TEMP,XK,YK,SCHRF,ZUSCH,IRLINE(30)
      REAL    *4 POL,CDS(7),TEMPFK,XORG,YORG,DMAX,TEMP2,AINCR,AI
      REAL    *4 ANG,TEMX,AATF(17,IATFDM),ZKOORD(2)
C
      EQUIVALENCE (AIN(1),IAIN(1)),(IDCB(1,1),DCB(1,1))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1)),(IPK(1,1),VQ(1,1))
      EQUIVALENCE (X(1,1),XK),(X(2,1),YK),(POL,IPOL)
      EQUIVALENCE (ICDS(1),CDS(1)),(IATF(1,1),AATF(1,1))
      EQUIVALENCE (WRLINE,IRLINE(1))
C
      SAVE IDCB
C     SAVE
C
      DATA IBLANK/4H    /
C
C  NTYP:  Kommando:
C   1      EXP/EXPU  Plotbefehle ausfuehren
C   2      LNP       Loesche Nicht-Plot-Liste
C   3      NP        Nicht plotten (Codes)
C   4      NPN       Nicht plotten (Nummern in Codeliste)
C   5      SKG       Schraffiere Kugeln
C   6      OSKG      Schreibe Kontrollbloecke
C   7      QSKG      Schreibe Kontrollbloecke auf File
C   8      NPM       Nicht plotten (Codes aus Mausliste)
C   9      QNP       Nicht plotten (Nummern in Codeliste)
C  10      ATF       Atomfarbe definieren
C  11      OATF      Atomfarbe listen
C  12      QATF      Atomfarbe punchen
C  13      -         Initialisierung
C  14      XC        Farbzahlen tauschen
C
      NTYPS=NTYP
      NSSV=NS
      IUDSAV=ISKP(27)
      IF (ISKP(60) .LT. 0) ISKP(27)=0
      NCOLPO=1
      GO TO (10,1250,1270,1270,1410,1480,1510,1570,1540,1590,
C             1    2    3    4    5    6    7    8    9   10
     1 1650,1680,1630,1710), NTYPS
C        11   12   13   14
C                            EXP/EXPU Berechne freie Koordinaten,
C                            soweit noch nicht geschehen.
C
   10 IF (IPKP(NS) .LE. 0) GO TO 9993
      VIEW=HOE*O9
   15 K8(NS)=0
      NTRY=44
      NC=1
      GO TO 40
C
   20 K9(NS)=K9(NS)+1
      IC=K9(NS)
      CALL ZVDEK
      DO  I=1,3
        ATOMS(I,IC,NS)=X2(I)
      ENDDO
   40 IF (K9(NS) .LT. NCD(NS)) GO TO 20
C
C  Wenn ein ueberlagerungsbild hergestellt werden soll, muessen auch
C  die freien Koordinaten des anderen Systems berechnet werden.
C
      IF (ISKP(7) .EQ. 2 .AND. NS .EQ. NSSV) THEN
        NS=3-NS
        GO TO 15
      ENDIF
      NS=NSSV
C
C                            Versorge 3D-graphik mit
C                            atom-koordinaten.
C
      IF (ISKP(60) .LT. 0) THEN
   45   DO  I=1,NCD(NS)
          DO  J=1,3
            AIN(J)=ATOMS(J,I,NS)
          ENDDO
          IAIN(4)=I
          CALL UPLINF (AIN,36)
        ENDDO
          IF (ISKP(7) .EQ. 2 .AND. NS .EQ. NSSV) THEN
            NS=3-NS
          GO TO 45
        ENDIF
        NS=NSSV
      ENDIF
C                            Suche nach Polyedercode
      IPEFLG=0
      IPKPNT=1
      GO TO 80
C
   50 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF .LT. 8) GO TO 70
      IF (IPLTBF .LE. 10) GO TO 90
      IF (IPLTBF .LT. 15) GO TO 70
      IF (IPLTBF .LE. 17) GO TO 90
C
   70 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
   80 IF (IPKPNT-IPKP(NS)) 50,100,100
C
C                            Polyedercode gefunden.  Initialisiere.
   90 CALL ZVPLDR (IPEFLG)
      IF (IERR) 9993,100,9993
C
C                            Setze Konstanten fuer die Abschattung.
C
  100 IF (ISKP(7) .EQ. 2) THEN
        IF (NCDA(1) .GT. NCD(1) .OR. NCDA(2) .GT. NCD(2)) GO TO 9990
        TEMX=MIN(ATOMS(3,NCDA(1),1),ATOMS(3,NCDA(2),2))
        TEMP=MAX(ATOMS(3,NCD(1),1),ATOMS(3,NCD(2),2))-TEMX
        IF (TEMP) 130,120,130
      ENDIF
      IF (NCDA(NS)-NCD(NS)) 110,110,9990
  110 TEMX=ATOMS(3,NCDA(NS),NS)
      TEMP=ATOMS(3,NCD(NS),NS)-TEMX
      IF (TEMP) 130,120,130
  120 CONST(26)=0.
      CONST(25)=(CONST(23)+CONST(24))*.5
      GO TO 140
  130 CONST(26)=(CONST(24)-CONST(23))/TEMP
      CONST(25)=CONST(23)-CONST(26)*TEMX
C
C                            Starte Lauf.
  140 IF (ISKP(7) .EQ. 2) THEN
       ICS1(1)=0
       ICS1(2)=0
       ZKOORD(1)=ATOMS(3,1,1)
       ZKOORD(2)=ATOMS(3,1,2)
      ELSE
       IC1=0
      ENDIF
C                            Setze Atom 1 um eins weiter
C
  150 IF (ISKP(7) .EQ. 2) THEN
C
C                            Pruefe, welches Atom weitergesetzt wird.
        NS=2
        IF (ZKOORD(1) .LT. ZKOORD(2)) NS=1
        IF (ICS1(NS) .LT. NCD(NS)) THEN
          ICS1(NS)=ICS1(NS)+1
          IC1=ICS1(NS)
          ZKOORD(NS)=ATOMS(3,ICS1(NS),NS)
          GO TO 165
        ELSE
          NS=3-NS
          IF (ICS1(NS) .LT. NCD(NS)) THEN
            ICS1(NS)=ICS1(NS)+1
            IC1=ICS1(NS)
            ZKOORD(NS)=ATOMS(3,ICS1(NS),NS)
            GO TO 165
          ELSE
            NS=NSSV
            GO TO 910
          ENDIF
        ENDIF
      ENDIF
      IF (IC1-NCD(NS)) 160,910,910
  160 IC1=IC1+1
  165 IC1CD=ICD(IC1,NS)
      IZ1=IC1CD/200000
C                            Hole Farbparameter
      NCOLPO=ICLRP(IZ1,NS)
      IF ((NCOLPO .LT. 1) .OR. (NCOLPO .GT. IATFDM)) NCOLPO=1
      NCLR=IATF(1,NCOLPO)
      NCOLFL=IATF(3,NCOLPO)
      IPOLS=IATF(4,NCOLPO)
      NCOLSR=IATF(5,NCOLPO)
      IHDFLG=ISKP(25)
      IF (IPOLS .LT. 0) THEN
        IHDFLG=0
        IPOLS=0
      ENDIF
      ICDIR=1
      IF (KEYIN(0) .NE. ISKP(20)) GO TO 170
      IERR=-1
      GO TO 9990
C                            Atom2 = Atom1;  Auftrag: Plotte Kreis
  170 IC=IC1
C
C                            Berechne Plotkoordinaten. hinterlege dabei
C                            die Parameter fuer Verbindungen.
      X(3,1)=ATOMS(3,IC1,NS)
      TEMPFK=HOE/(HOE-X(3,1))
      X(3,2)=TEMPFK
      XK=ATOMS(1,IC1,NS)*TEMPFK
      YK=ATOMS(2,IC1,NS)*TEMPFK
      TEMP=AT(4,IZ1,NS)*TEMPFK*FKGL
      ATMSYM=IAT(5,IZ1,NS)
C
C--- ISKP(10) > 0 hat folgende Bedeutung:
C    1: Beschriften mit Atomsymbol, 2. Buchstabe klein
C    2: Beschriften mit Unterscheider
C    3: Beschriften mit Atomsymbol, unveraendert
C    4: Beschriften mit Platznummer; wenn > 100, dann geht es mit
C       Buchstaben weiter, A0 = 100,...,Z9 = 359.
C    5: Wie 4, aber nur Codes xx55501
C    6: Wie 5, aber nur Codes xx555yy
C
      IF (ISKP(10) .EQ. 2) ATMSYM=IAT(6,IZ1,NS)
      IF (ISKP(10) .EQ. 4 .OR. ISKP(10) .EQ. 5
     1  .OR. ISKP(10) .EQ. 6) THEN
        ATMSYM=IBLANK
        IF (ISKP(10) .EQ. 4 .OR.
     +    (ISKP(10) .EQ. 5 .AND. IZ1*200000+111001 .EQ. IC1CD) .OR.
     +    (ISKP(10) .EQ. 6 .AND. IZ1*2000+1110 .EQ. IC1CD/200)) THEN
          IF (IZ1 .LT. 360) THEN
            J=0
            CALL KPNTOS (IZ1,ATMSYM,J,0)
            IF (IZ1 .GE. 100) THEN
              CALL COPYCH (ATMSYM,2,2, ATMSYM,1)
              I=IZ1/10+55
              CALL COPYCH (I,1,1, ATMSYM,1)
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      T(2)=CONST(26)*ATOMS(3,IC1,NS)+CONST(25)
      T(1)=T(2)/O9
      X(1,2)=TEMP
      IF (ISKP(27) .GE. 0) GO TO 470
      TEMP=X(1,2)+T(1)
      IPKPNT=1
      ICDS(6)=0
      GO TO 220
C                            Zeichne ggf. Polyeder
C
  200 ICDS(6)=1
      CALL UPLINF (ICDS(6),24)
      IF (IPEFLG .EQ. 0) GO TO 210
      CALL ZVPLDR (IC1)
      IF (IERR .NE. 0) GO TO 9990
  210 IPKPNT=1
      TEMP=X(1,2)
C
  220 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF .NE. 1) GO TO 450
C
C                            Plotbefehl: Plotte Kreis. Teste Range.
C
       IF (IZ1 .LT. IPK(IPKPNT+2,NS) .OR. IZ1 .GT. IPK(IPKPNT+3,NS))
     + GO TO 450
C
C                            Teste, ob Atom in Verbotsliste steht.
      IF (NPPOI(NS) .GT. 0) THEN
        DO  I=1,NPPOI(NS),2
          IF (IC1CD .EQ. NPLST(I,NS) .AND. NPLST(I+1,NS) .EQ. 0)
     +     GO TO 450
        ENDDO
      ENDIF
      NSTPKT=IPK(IPKPNT+4,NS)
      NST=IABS(NSTPKT)
C                            Erzeuge optional Output.
C
      IF (ICDS(6) .NE. 0) GO TO 330
      IF (ISKP(7) .EQ. 0) GO TO 470
C
C                            Putzen ist angesagt!
C
      IF (IHDFLG .EQ. 0) GO TO 470
      IPOL=0
      CALL UPLINF (IPOL,24)
      NN=22
      GO TO 380
C
  330 IF (ISKP(6)) 340,360,340
  340 AIN(61)=XK*O9+CONST(11)
      AIN(62)=YK*O9+CONST(12)
      WRITE (WRLINE,350)
     1 IAT(5,IZ1,NS),IAT(6,IZ1,NS),IC1,IC1CD,AIN(61),AIN(62),TEMP
      CALL KPWRTE (NTOUT)
  350 FORMAT ('Atom ',2A4,' (',I5,',',I10,')  xp=',F8.3,' yp=',F8.3,
     1 ' r=',F6.3)
C                            Hole Radius und plotte Kreis.
C
  360 IF (ISKP(7) .EQ. 0) GO TO 470
      IF (ISKP(60) .LT. 0) THEN
        IAIN(1)=IC1
        AIN(2)=AT(4,IZ1,NS)*FKGL
        DO  J=1,6
          IAIN(J+2)=IATF(J,NCOLPO)
        ENDDO
        CALL UPLINF (AIN,34)
        GO TO 470
      ENDIF
C
      J=0
      IF (IPK(IPKPNT,NS) .LE. 5) GO TO 365
      J=IPK(IPKPNT+5,NS)
C
  365 IF (IHDFLG .NE. 0) GO TO 372
  371 NN=2
      CALL UPLINF (NCLR,10)
      ISKP(42)=NCLR
      GO TO 380
C
  372 NN=22
      CALL UPLINF (NCOLFL,10)
      ISKP(42)=NCOLFL
      IPOL=IPOLS
C
  380 IF (ISKP(60) .GT. 0 .AND. IPFLG(IZ1,NS) .NE. 0) THEN
        ISKP(61)=NCOLPO
        CALL ZVORPA (IC1,IRC)
        GO TO 389
      ENDIF
      CALL UPLINF (IATF(2,NCOLPO),11)
      NNT=NN+1
      I=0
      AINCR=CONST(2)/FLOAT(NST)
      ZUSCH=AATF(17,NCOLPO)*CONST(3)
  381 ICNT1=IATF(7,NCOLPO)
      ICNT2=IATF(8,NCOLPO)
      NNT=NN+1
      IF (NN .LE. 2) GO TO 382
      ICNT1=NST+2
  382 IF (ICNT1 .LE. 0) GO TO 383
      AI=FLOAT(I)*AINCR+ZUSCH
      AIN(61)=(XK+TEMP*COS(AI))*O9+CONST(11)
      AIN(62)=(YK+TEMP*SIN(AI))*O9+CONST(12)
      CALL UPLINF (AIN(61),NNT)
      NNT=NN
      ICNT1=ICNT1-1
      GO TO 390
C
  383 ICNT2=ICNT2-1
      IF (ICNT2 .LT. 2) GO TO 381
  390 I=I+1
      IF (I .LE. NST) GO TO 382
      IF (NN .EQ. 2) GO TO 391
      CALL UPLINF (IPOL,21)
  389 IF (ICDS(6) .EQ. 0) GO TO 470
C
C                       Wenn Farbe Fuellmuster und Farbe Rand
C                       verschieden, muessen wir noch einmal
C                       drueber zeichnen (falls nicht ORTEP).
C
      IF (ISKP(42) .NE. NCLR .AND.
     + (ISKP(60) .EQ. 0 .OR. IPFLG(IZ1,NS) .EQ. 0)) GO TO 371
C
C
  391 IF (J .LE. 0 .OR. J .GT. IDCBDM) GO TO 395
      X(3,2)=TEMPFK
      CALL ZVSHKG (IDCB(1,J))
  395 IF (IATF(6,NCOLPO) .LE. 0) GO TO 450
      IF (ISKP(10) .LE. 0 .AND. NSTPKT .GT. 0) GO TO 450
C
C                            Beschrifte Atom.
      SCHRF=1.0
      IF (NST .LT. 6) SCHRF=0.8
      IF (LCOMPS(ATMSYM,2,1, IBLANK,1) .NE. 0) GO TO 420
      AIN(63)=TEMP*0.9*SCHRF
      XORG=AIN(63)*.357143
      AIN(64)=1.
      GO TO 430
C
  420 AIN(63)=TEMP*0.8*SCHRF
      XORG=AIN(63)*.85
      IF (ISKP(10) .LE. 1) CALL CNVTLO (ATMSYM,2,1)
      AIN(64)=2.
  430 YORG=AIN(63)*.5
      AIN(61)=(XK-XORG)*O9+CONST(11)
      AIN(62)=(YK-YORG)*O9+CONST(12)
      AIN(63)=AIN(63)*O9
      CALL UPLINF (IATF(5,NCOLPO),10)
      ISKP(42)=IATF(5,NCOLPO)
      CALL UPLINF (IATF(6,NCOLPO),11)
      CALL SYMBQL (AIN(61),AIN(62),AIN(63),ATMSYM,1,0.,ISKP(69))
C
C                            Skip zum naechsten Plotbefehl
C
  450 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
  460 IF (IPKPNT-IPKP(NS)) 220,470,470
  470 CONTINUE
      IF (ICDIR .LT. 0) GO TO 150
C
C                            Jetzt umschalten auf Zeichnen
      ICDS(6)=1
      ICDIR=-1
      IC=0
      CALL UPLINF (CDS(6),24)
C                            Auftrag: Verbinde
  520 IF (IC .GE. NCD(NS)) GO TO 200
      IC=IC+1
      IF (IC .NE. IC1) GO TO 525
      IF ((ISKP(27) .EQ. 0) .OR. (IHDFLG .EQ. 0)) GO TO 200
C
C                            Umschalten auf Putzen
      ICDS(6)=0
      CALL UPLINF (ICDS(6),24)
      GO TO 520
C
  525 IC2CD=ICD(IC,NS)
      IZ2=IC2CD/200000
      IPKPNT=1
      GO TO 900
C
  530 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF-2) 890,620,540
  540 IF (IPLTBF-5) 620,550,550
  550 IF (IPLTBF-12) 890,570,560
  560 IF (IPLTBF-14) 570,570,890
C
C                            Verbinde direkt.  Teste, ob Paar
C                            im Befehl vorkommt.
  570 J=IPK(IPKPNT,NS)
      I=5
  580 IF (IPK(IPKPNT+I,NS) .EQ. IC1CD) GO TO 600
  590 I=I+1
      IF (I .LT. J) GO TO 580
      GO TO 890
C
  600 IF (IPK(IPKPNT+I+1,NS) .EQ. IC2CD) GO TO 610
      IF (IPK(IPKPNT+I-1,NS) .NE. IC2CD) GO TO 590
  610 T(3)=VQ(IPKPNT+2,NS)
      IVDFLG=1
      GO TO 705
C
C                            Fuehre Plotbefehl aus.  Teste, ob Nummer
C                            in Frage kommt.
C                                        1. Atom = ur?
  620 IF (IZ1-IPK(IPKPNT+2,NS)) 660,640,630
  630 IF (IZ1-IPK(IPKPNT+3,NS)) 640,640,660
C                                        2. Atom = zl?
  640 IF (IZ2-IPK(IPKPNT+4,NS)) 660,700,650
  650 IF (IZ2-IPK(IPKPNT+5,NS)) 700,700,660
C                                        1. Atom = zl?
  660 IF (IZ1-IPK(IPKPNT+4,NS)) 890,680,670
  670 IF (IZ1-IPK(IPKPNT+5,NS)) 680,680,890
C                                        2. Atom = ur?
  680 IF (IZ2-IPK(IPKPNT+2,NS)) 890,700,690
  690 IF (IZ2-IPK(IPKPNT+3,NS)) 700,700,890
C
C                            Teste, ob Bindung verboten.
  700 IVDFLG=0
  705 IF (NPPOI(NS)) 770,770,710
  710 I=1
C
  720 IF (IC1CD-NPLST(I,NS)) 740,730,740
  730 IF (IC2CD-NPLST(I+1,NS)) 740,890,740
C
  740 IF (IC1CD-NPLST(I+1,NS)) 760,750,760
  750 IF (IC2CD-NPLST(I,NS)) 760,890,760
C
  760 I=I+2
      IF (I-NPPOI(NS)) 720,770,770
  770 IF (IVDFLG .GT. 0) GO TO 820
C
C                            Teste Abstandsintervall.
      DMAX=VQ(IPKPNT+7,NS)
      TEMP=0.
      DO 790 I=1,3
      TEMP2=ABS(ATOMS(I,IC1,NS)-ATOMS(I,IC,NS))
      IF (TEMP2-DMAX) 780,780,890
  780 TEMP=TEMP+TEMP2*TEMP2
  790 CONTINUE
C
      IF (TEMP-DMAX*DMAX) 800,800,890
  800 IF (TEMP-VQ(IPKPNT+6,NS)*VQ(IPKPNT+6,NS)) 890,810,810
  810 CONTINUE
C                            Fuehre Verbindung aus.
C
      T(3)=VQ(IPKPNT+8,NS)
  820 X(2,2)=TEMPFK*T(3)
      NTYP=IPLTBF
      IF (ISKP(6) .EQ. 0) GO TO 840
      IF (ICDS(6) .EQ. 0) GO TO 840
      TEMP=SQRT(TEMP)
      WRITE (WRLINE,830) IAT(5,IZ2,NS),IAT(6,IZ2,NS),IC2CD,TEMP
      CALL KPWRTE (NTOUT)
CYENG1
  830 FORMAT ('Bindung nach ',2A4,' (',I9,') d=',F8.4)
CYENG2
CYENGY  830 FORMAT (' Bond to ',2A4,' (',I9,') d=',F8.4)
C     WRITE (WRLINE,830)
C    1 IAT(5,IZ1,NS),IAT(6,IZ1,NS),IAT(5,IZ2,NS),IAT(6,IZ2,NS),TEMP
C     CALL KPWRTE (NTOUT)
C 830 FORMAT ('DISTAN ',A4,A2,2X,A4,A2,1X,F10.5)
  840 IF (ISKP(7)) 850,890,850
  850 IF (NTYP .LE. 4) GO TO 860
      NTYP=NTYP-10
      IPOI=IPKPNT+3
      GO TO 880
C
  860 IPOI=IPKPNT+9
  880 I=IPK(IPOI,NS)
      IF (I .LE. 0 .OR. I .GT. IATFDM) I=1
      IF (ISKP(60) .LT. 0) THEN
        IAIN(1)=IC1
        IAIN(2)=IC
        AIN(3)=T(3)
        IAIN(4)=NTYP
        DO  J=1,4
          IAIN(J+4)=IATF(J,I)
        ENDDO
        CALL UPLINF (AIN,35)
      ELSE
        IF (ISKP(60) .EQ. 0 .OR. IPFLG(IZ1,NS) .EQ. 0 .OR.
     +    IPFLG(IZ2,NS) .EQ. 0 .OR. VQ(IPOI-1,NS) .GT. 20.) THEN
          CALL ZVVBU (I)
        ELSE
          CALL BOND (IC1,IC,I)
        ENDIF
      ENDIF
      IF (IERR .NE. 0) GO TO 9990
      GO TO 520
C                            Skip zum naechsten Plotbefehl.
C
  890 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
  900 IF (IPKPNT-IPKP(NS)) 530,520,520
C
C                            Raeume ggf. letzte Polyederflaeche
C
  910 IF (IPEFLG .EQ. 0) GO TO 915
      CALL ZVPLDR (NCD(NS)+1)
      IF (ISKP(7) .EQ. 2 .AND. NS .EQ. NSSV) THEN
        NS=3-NS
        GO TO 910
      ENDIF
      NS=NSSV
C
C                            Beschriftung ausfuehren.
  915 IPKPNT=1
      GO TO 1150
C
  920 NTYP=IPK(IPKPNT+1,NS)
      IF (NTYP-5) 1140,940,930
  930 IF (NTYP-6) 1140,990,1210
C
C    ##                        Kommando BA - Beschrifte Atom(e).
C
  940 IF (ISKP(7)) 950,1140,950
  950 ISKP(42)=IPK(IPKPNT+2,NS)
      CALL UPLINF (ISKP(42),10)
      CALL UPLINF (IPK(IPKPNT+3,NS),11)
C
      J=IPKPNT+5
      K=IPKPNT+IPK(IPKPNT,NS)
      NC=1
      NTRY=28
  952 ICDS(1)=IPK(J,NS)
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 9980
      TEMP=HOE/(HOE-X2(3))
      AIN(61)=(X2(1)+VQ(J+1,NS))*TEMP*O9+CONST(11)
      AIN(62)=(X2(2)+VQ(J+2,NS))*TEMP*O9+CONST(12)
      AIN(63)=VQ(IPKPNT+4,NS)*O9*TEMP
      IF (ISKP(26)) 970,960,970
  960 AIN(64)=4.
      AIN(65)=AT(5,IANR,NS)
      CALL UPLINF (AIN(61),18)
      GO TO 1140
  970 CALL KPCVNM (AT(5,IANR,NS),CONST(36),AIN(66),IAIN(68))
      CALL SYMBQL (AIN(61),AIN(62),AIN(63),IAIN(66),1,0.,IAIN(68))
      J=J+3
      IF (J .LT. K) GO TO 952
      GO TO 1140
C                            BT - Beschrifte mit Text
C
  990 J=IPK(IPKPNT+7,NS)
      IF (ISKP(7) .EQ. 0) GO TO 1140
      NTRY=28
      DO  I=1,2
        NC=I
        ICDS(NC)=IPK(IPKPNT+I+1,NS)
        IF (I .EQ. 2 .AND. ICDS(2) .EQ. 0) ICDS(2)=ICDS(1)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9980
        DO  K=1,3
          X(K,NC)=X2(K)
        ENDDO
      ENDDO
      DO  I=1,3
        X2(I)=(X(I,1)+X(I,2))*.5
      ENDDO
      DO  K=1,2
        AIN(61)=HOE/(HOE-X(3,K))
        X(1,K)=X(1,K)*AIN(61)*O9+CONST(11)
        X(2,K)=X(2,K)*AIN(61)*O9+CONST(12)
      ENDDO
C                       Ermittle Drehwinkel
      ANG=0.
      X1(1)=X(1,2)-X(1,1)
      X1(2)=X(2,2)-X(2,1)
      IF (X1(1) .NE. 0.) GO TO 1080
      IF (X1(2)) 1060,1090,1070
 1060 ANG=-90.
      GO TO 1090
 1070 ANG=90.
      GO TO 1090
 1080 ANG=CONST(4)*ATAN(X1(2)/X1(1))
      IF (X1(1) .LT. 0.) ANG=ANG+180.
C
C                       Rechne Offset um
C
 1090 AIN(63)=COS(ANG*CONST(3))
      AIN(64)=SIN(ANG*CONST(3))
      X1(1)=AIN(63)*VQ(IPKPNT+4,NS)-AIN(64)*VQ(IPKPNT+5,NS)
      X1(2)=AIN(64)*VQ(IPKPNT+4,NS)+AIN(63)*VQ(IPKPNT+5,NS)
      TEMP=HOE/(HOE-X2(3))
      AIN(61)=(X2(1)+X1(1))*TEMP*O9+CONST(11)
      AIN(62)=(X2(2)+X1(2))*TEMP*O9+CONST(12)
      AIN(63)=VQ(IPKPNT+6,NS)*O9*TEMP
      IAIN(64)=4*J
      IF (ISKP(26) .EQ. 0) THEN
        JM=MAX0(J,8)
        DO  I=1,JM
          AIN(I+64)=VQ(IPKPNT+I+7,NS)
        ENDDO
        AIN(64)=FLOAT(IAIN(64))
        CALL UPLINF (AIN(61),18)
      ELSE
        I=IPK(IPKPNT+7,NS)+8+IPKPNT
        ISKP(42)=IPK(I,NS)
        CALL UPLINF (ISKP(42),10)
        CALL UPLINF (IPK(I+1,NS),11)
        CALL SYMBQL (AIN(61),AIN(62),AIN(63),IPK(IPKPNT+8,NS),
     +  1,ANG,IAIN(64))
      ENDIF
C
C                            Erhoehe Pointer
 1140 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
 1150 IF (IPKPNT .LT. IPKP(NS)) GO TO 920
C                            PR - Plotte Rahmen
C
      IF (ISKP(88) .NE. 0) THEN
        NTYP=6
        CALL ZVPNCD(NS)
      ENDIF
      CALL UPLINF (ISKP(41),10)
      ISKP(42)=ISKP(41)
      CALL UPLINF (ISKP(49),11)
      IF (ISKP(7) .EQ. 0) GO TO 1160
      IF (ISKP(3) .EQ. 0) GO TO 1160
      DO  J=1,10
        AIN(J)=0.
      ENDDO
      IF (ISKP(3) .EQ. 1) THEN
        AIN(3)=CONST(8)
        AIN(5)=CONST(8)
        AIN(6)=CONST(9)
        AIN(8)=CONST(9)
C
        I=3
        DO  J=1,9,2
          CALL UPLINF (AIN(J),I)
          I=2
        ENDDO
        GO TO 1160
      ENDIF
      AIN(2)=CONST(9)
      AIN(3)=CONST(8)
      DO  I=1,3,2
        CALL UPLINF (AIN(I),3)
        CALL UPLINF (AIN(I),2)
      ENDDO
 1160 CONTINUE
      IF (ISKP(7) .EQ. 2 .AND. NS .EQ. NSSV) THEN
        NS=3-NS
        GO TO 915
      ENDIF
      NS=NSSV
      GO TO 9990
C                            Plotte Pfeil
C
 1210 IF (NTYP-7) 1140,1220,1140
 1220 IF (ISKP(7)) 1230,1140,1230
 1230 DO 1240 I=1,10
 1240 IAIN(I)=IPK(IPKPNT+I+1,NS)
C     CALL KPPPFL   <--- IN DIESER VERS. STILLGELEGT
      IF (IERR) 9990,1140,9990
C
C                            LNP
 1250 NPPOI(NS)=0
 1260 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
      GO TO 9990
C                            NP  - Addiere Nicht-Plot-Befehl(e)
C
 1270 DO  I=1,72
        IAIN(I)=0
      ENDDO
      CALL FLES (IAIN,ISKP(31),4H72CE,11Hc1,c2,...?$)
      J=ISKP(31)
      I=0
      GO TO 1390
C
 1290 IF (NPPOI(NS) .LT. NPDIM) GO TO 1320
 1300 CALL FLES (IAIN,IAIN,1HK,1HK)
CYENG1
      WRITE (WRLINE,'(A)') ' ZVEXPU0593 - Tabelle NPLST voll.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') ' KPEXPU0593 - Table NPLST full.'
      CALL KPWRTE (NTDISP)
      GO TO 9990
C
 1320 NPPOI(NS)=NPPOI(NS)+1
      K=IAIN(I)
      IF (K) 1400,1380,1330
 1330 IF (NTYP-4) 1360,1340,1360
 1340 IF (K-NCDDM) 1350,1350,1400
 1350 K=ICD(K,NS)
 1360 IF (K-NATDM) 1370,1370,1380
 1370 K=K*200000+111001
 1380 NPLST(NPPOI(NS),NS)=K
 1390 I=I+1
      IF (I-J) 1290,1290,9990
 1400 IERR=7061616
      NPPOI(NS)=NPPOI(NS)-1
      GO TO 9990
C                     Definition der Kugel-Kontroll-Bloecke
C
CYENG1
 1410 CALL FLES (I,ISKP(31),2HIR,4HNr?$)
CYENG2
CYENGY 1410 CALL FLES (I,ISKP(31),2HIR,4HNo?$)
      IF (I .LE. 0 .OR. I .GT. IDCBDM) THEN
        IERR=7062316
        GO TO 9993
      ENDIF
C
      IF (IDCB(1,I) .GE. 0) THEN
        DO  J=1,9
          IAIN(J)=IDCB(J,I)
        ENDDO
      ELSE
        DO  J=3,9
          IAIN(J)=0
        ENDDO
        IAIN(1)=ISKP(41)
        IAIN(2)=ISKP(49)
      ENDIF
C
      CALL FLES (IAIN,ISKP(31),8H3I3FI2FE,
CYENG1
     1 44HFarbe,Str.-St.,Iflag,D,Wst,Winc,Irep,L1,L2?$)
CYENG2
CYENGY     1 45HColor,thickness,Iflag,D,Wst,Winc,Irep,L1,L2?$)
C
      IF (AIN(4) .LE. 0.) AIN(4)=0.1
      AIN(8)=ABS(AIN(8))
      AIN(9)=ABS(AIN(9))
      DO  J=1,9
        IDCB(J,I)=IAIN(J)
      ENDDO
      GO TO 9993
C                       OSKG
 1480 DO  I=1,IDCBDM
        IF (IDCB(1,I) .GE. 0) THEN
          WRITE (WRLINE,1490) I,(IDCB(J,I),J=1,3),
     +    (DCB(J,I),J=4,6),IDCB(7,I),(DCB(J,I),J=8,9)
 1490     FORMAT ('(',I1,')',3I3,F5.2,2F7.2,I3,2F5.2)
          CALL KPWRTE (NTOUT)
        ENDIF
      ENDDO
      GO TO 1260
C                       QSKG
 1510 NTYP=NTBILF
      CALL ZVEAEH
      DO  I=1,IDCBDM
        IF (IDCB(1,I) .GE. 0) THEN
          WRITE (WRLINE,1520) I,(IDCB(J,I),J=1,3),
     +    (DCB(J,I),J=4,6),IDCB(7,I),(DCB(J,I),J=8,9)
          CALL KPWRTE (NTBILF)
 1520     FORMAT ('SKG ',I1,3I3,F5.2,2F7.2,I3,2F5.2)
        ENDIF
      ENDDO
      GO TO 9993
C                       QNP
 1540 NTYP=NTBILF
      CALL ZVEAEH
      I=1
 1550 KK=4
      IF (I .GT. NPPOI(NS)) GO TO 9993
      J=I+5
      IF (J .GT. NPPOI(NS)) J=NPPOI(NS)
      WRLINE="NP "
      DO  K=I,J
        CALL KPCDST(IRLINE,KK,NPLST(K,NS))
        KK=KK+10
      ENDDO
      CALL KPWRTE (NTBILF)
      I=I+6
      GO TO 1550
C                       NPM
 1570 NTYP=7
      I=1
 1580 J=I
      CALL ZVGC01 (J)
      IF (J .EQ. 0) GO TO 1260
      K=I+1
      CALL ZVGC01 (K)
      IF (K .EQ. 0) GO TO 1260
      IF (K .EQ. J) K=0
      IF (NPPOI(NS)+2 .GT. NPDIM) GO TO 1300
      NPPOI(NS)=NPPOI(NS)+2
      NPLST(NPPOI(NS)-1,NS)=J
      NPLST(NPPOI(NS),NS)=K
      I=I+2
      GO TO 1580
C                           Atom-Farben
 1590 I=1
      CALL FLES (I,ISKP(31),2HIR,
CYENG1
     1 61HNr, fr,sr, fm,nm, fs,ss, ns,nl, fi,si, n1,n2,n3,n4, a0,a1,z?$)
CYENG2
CYENGY     1 61HNo, fr,sr, fm,nm, fs,ss, ns,nl, fi,si, n1,n2,n3,n4, a0,a1,z?$)
      IF (I .LE. 0 .OR. I .GT. IATFDM) THEN
        IERR=7070416
      ELSE
        CALL FLES (IATF(1,I),ISKP(31),6H14I3FE,
     1  57Hfr,sr, fm,nm, fs,ss, ns,nl, fi,si, n1,n2,n3,n4, a0,a1,z?$)
      ENDIF
      GO TO 9993
C                           Initialisierung
 1630 DO  I=1,IDCBDM
        IDCB(1,I)=-2
      ENDDO
      GO TO 9993
C                           Liste Atomfarben
 1650 IAIN(1)=1
      IAIN(2)=IATFDM
CYENG1
      CALL FLES (IAIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),3H2IE,9Hfrom,to?$)
      IF (ISKP(31) .EQ. 1) IAIN(2)=IAIN(1)
      IF (IAIN(2) .LE. 0) IAIN(2)=IAIN(1)
      IF (IAIN(2) .GT. IATFDM) IAIN(2)=IATFDM
      IF (IAIN(1) .LE. 0 .OR. IAIN(1) .GT. IAIN(2)) THEN
        IERR=7073216
        GO TO 9993
      ENDIF
      DO  I=IAIN(1),IAIN(2)
        WRITE (WRLINE,1660) I,(IATF(J,I),J=1,14),(AATF(J,I),J=15,17)
 1660   FORMAT ('(',I2,') ',6I3,2I5,6I3,2F7.3,F7.2)
        CALL KPWRTE (NTOUT)
      ENDDO
      GO TO 9993
C                           Punche Atomfarben
 1680 CONTINUE
C                            Jetzt in KPBILF
      GO TO 1260
C                           Tausche Farbzahlen
 1710 DO  I=1,IATFDM
        IF (IATF(1,I) .EQ. IAIN(1)) IATF(1,I)=IAIN(2)
      ENDDO
C
      DO  I=1,IDCBDM
        IF (IDCB(1,I) .EQ. IAIN(1)) IDCB(1,I)=IAIN(2)
      ENDDO
      GO TO 9993
C                            Es ist ein Fehler passiert
 9980 WRITE (WRLINE,9981)
      CALL KPWRTE (NTDISP)
CYENG1
 9981 FORMAT ('ZVEXPU0752 - Illegaler Code bei Plotkommandos.')
CYENG2
CYENGY 9981 FORMAT (' KPEXPU0752 - Illegal code within plotcommands.')
      IERR=-1
C
 9990 NTYP=NTYPS
      IF (ISKP(41) .EQ. ISKP(42)) GO TO 9993
      IAIN(61)=ISKP(41)
      CALL UPLINF (AIN(61),10)
      ISKP(42)=ISKP(41)
 9993 ISKP(27)=IUDSAV
      NS=NSSV
      RETURN
      END
