C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C           64         ----------------------------
                        SUBROUTINE ZVGC01 (IGRPIN)
C  CY-ENG-             ----------------------------
C
C   Dieses Unterprogramm handhabt eine Gruppe von Codes, die bei
C   speziellen Befehlen eingesetzt werden kann
C
C   NTYP  Kommando
C     1   LGC   Lade Gruppenliste
C     2   AGC   Addiere in Gruppenliste
C     3   OGC   Liste Gruppenliste
C     4   M     Lade Gruppenliste mit Maus
C     5   AGCM  Addiere in Gruppenliste mit Maus
C     6   DGCC  Delete Gruppe von Codes aus Codeliste
C     7         Tauscht Position IGRPIN gegen Inhalt, wenn vorhanden.
C     8   SPGC  Schwerpunkt ueber Gruppe mit Codes
C     9   LGCC  Loesche und lade Gruppe von Codes in Codeliste
C    10   AGCA  Addiere Gruppe von Codes als Atome in Parameterliste
C    11   OGCF  Liste Gruppe von Codes wie OC
C    12   FGC   Farbzeiger fuer Gruppenliste
C    13   -     Wie 7 + entferne ersten Code von der Liste
C    14   AGCC  Gegenteil zu DGCC
C    15   CTGC  Codes to GC-Liste
C    16   DGCP  Delete Codes in Parameterliste
C    17   AGCT  Addiere codes des trees
C
C                geschrieben: 170751 JUN 1989  (Hundt)
C                geaendert:   171055 JAN 2007  (Hundt)
C
C                          -------------------
      IMPLICIT  NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER*4 IGCDIM
      PARAMETER (IGCDIM=120)
      INTEGER*4 IGCPOI,IGCWRK(IGCDIM),KEYIN,IRLINE(30),NTYPS
      INTEGER*4 IAIN(72),I,J,K,L,M,INBFR(3),IGRPIN,ITR(3)
      INTEGER*4 IPKPNT,IPLTBF,NSSV
      REAL*4    TOL,XQ,YP,TEMP,TEMP3,HITMRK(8),AINBFR(3),VQ(IPKDIM,2)
      REAL*4    TEMP2,DMAX
      CHARACTER *40 TMPLNE
C
      SAVE IGCWRK,INBFR
C
      EQUIVALENCE (AIN(1),IAIN(1)),(AINBFR(1),INBFR(1))
      EQUIVALENCE (IGCPOI,ISKP(54)),(WRLINE,IRLINE(1))
      EQUIVALENCE (IPK(1,1),VQ(1,1))
C
      DATA HITMRK/-1.,0., 1.,0., 0.,1., 0.,-1./
C
      NTYPS=NTYP
      NSSV=NS
      GO TO (10,20,60,200,210,310,90,110,350,390,430,500,90,
C             1  2  3   4   5   6  7   8   9  10  11  12 13
     +  530,550,560,650),NTYPS
C        14  15  16  17
C                             Lade Gruppenliste
   10 IGCPOI=0
   20 IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (IAIN,ISKP(31),4H40CE,11Hc1,c2,...?$)
      ENDIF
C
      IF (ISKP(31) .LE. 0) GO TO 999
      ISKP(14)=ISKP(31)
      J=NCD(NS)
      NTYP=4
      CALL ZVASCI
      IF (IERR .NE. 0) GO TO 55
      K=J
      GO TO 30
C
   25 IF (IGCPOI .GE. IGCDIM) GO TO 40
      IGCPOI=IGCPOI+1
      IGCWRK(IGCPOI)=ICD(K,NS)
   30 K=K+1
      IF (K .LE. NCD(NS)) GO TO 25
      GO TO 55
C
   35 J=NCD(NS)
   40 WRITE (WRLINE,50)
CYENG1
   50 FORMAT ('ZVGC010073 - Gruppenliste fuer Codes ist voll.')
CYENG2
CYENGY   50 FORMAT ('ZVGC010073 - List for group of codes full.')
      CALL KPWRTE (NTDISP)
   55 NCD(NS)=J
      ISKP(14)=0
      GO TO 999
C                               OGC - Liste Codes
   60 WRITE (WRLINE,70)
CYENG1
   70 FORMAT ('Aktuelle Gruppe von Codes:')
CYENG2
CYENGY   70 FORMAT ('Current group of codes:')
      CALL KPWRTE (NTOUT)
      IF (IGCPOI .LE. 0) GO TO 480
      DO  J=1,IGCPOI,5
        K=J+4
        IF (K .GT. IGCPOI) K=IGCPOI
        WRITE (WRLINE,'(5('' '',I3,10X))') (I,I=J,K)
        M=5
        DO  L=J,K
          CALL KPCDST (IRLINE,M,IGCWRK(L))
          M=M+14
        ENDDO
        CALL KPWRTE (NTOUT)
      ENDDO
      GO TO 480
C                           Tausche Position gegen Inhalt
   90 CONTINUE
      IF (IGRPIN .LE. 0) GO TO 100
      IF (IGRPIN .GT. IGCPOI) GO TO 100
      IGRPIN=IGCWRK(IGRPIN)
      IF (NTYPS .EQ. 13) GO TO 520
      GO TO 999
C
  100 IGRPIN=0
      GO TO 999
C                            Schwerpunkt ueber Gruppe von Codes
  110 CONTINUE
      IF (ISKP(14) .EQ. 0) THEN
        ICDS(1)=0
        WRITE (TMPLNE,'(A,I1,A)')
CYENG1
     +  'Ohne (0) oder mit (1) Gewicht [',ICDS(1),']? $'
CYENG2
CYENGY     +  'Without (0) or with (1) weights [',ICDS(1),']? $'
        CALL FLES (ICDS,ISKP(31),2HIE,TMPLNE)
      ELSE
        ISKP(14)=0
      ENDIF
      IF (IGCPOI .LE. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVGC010111 - Gruppe von Codes ist leer.'
CYENG2
CYENGY     +  'ZVGC010111 - List for group of codes empty.'
        CALL KPWRTE (NTDISP)
        IERR=-1
      GO TO 999
      ENDIF
      NC=2
      NTRY=24
      TEMP=1.
      TEMP3=0.
      DO  J=1,3
        PTRIKL(J)=0.
      ENDDO
      DO  I=1,IGCPOI
        ICDS(2)=IGCWRK(I)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        IF (ICDS(1) .NE. 0) TEMP=AT(4,IANR,NS)
        DO  J=1,3
          PTRIKL(J)=PTRIKL(J)+X(J,2)*TEMP
        ENDDO
        TEMP3=TEMP3+TEMP
      ENDDO
      IF (TEMP3 .EQ. 0) THEN
        IERR=64 0123 16
        GO TO 999
      ENDIF
C
      DO  J=1,3
        PTRIKL(J)=PTRIKL(J)/TEMP3
      ENDDO
      NTYP=16
      CALL ZVGE01
      GO TO 999
C
C                            Hole die Koordinaten des graph. Cursors
  200 IGCPOI=0
  210 CONTINUE
      CALL UPLINF (AIN,8)
C                            Abbruch bei rechter Maustaste
C
      IF (IAIN(4) .EQ. 33) THEN
        WRITE (WRLINE,'(A)') ' '
        CALL KPWRTE (NTOUT)
        GO TO 999
      ENDIF
C                            Durchsuche Code-Liste
C
      XQ=(AIN(1)-CONST(11))/O9
      YP=(AIN(2)-CONST(12))/O9
  220 I=NCD(NS)
      IF (NCDA(NS) .GT. NCD(NS)) THEN
        IERR=64 0153 12
        GO TO 999
      ENDIF
C
  260 TEMP=HOE/(HOE-ATOMS(3,I,NS))
      IANR=ICD(I,NS)/200000
      TOL=AT(4,IANR,NS)*TEMP*FKGL
      TEMP2=ABS(ATOMS(1,I,NS)*TEMP-XQ)
      IF (TEMP2 .GT. TOL) GO TO 265
      TEMP3=ABS(ATOMS(2,I,NS)*TEMP-YP)
      IF (TEMP3 .GT. TOL) GO TO 265
      IF (TEMP2*TEMP2+TEMP3*TEMP3 .LE. TOL*TOL) GO TO 280
  265 I=I-1
      IF (I .GE. NCDA(NS)) GO TO 260
      IF (ISKP(7) .GT. 1) THEN
        NS=3-NS
        IF (NS .NE. NSSV) GO TO 220
      ENDIF
CYENG1
      WRITE (WRLINE,'(A)') ' >>>>>>>>>>>>>>>>>>>>>> Kein Atom in der Nae
     1he. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') '>>>>>>>>>>>>>>>>>>>>>>>>>>>> No atom in vici
CYENGY     +nity. <<<<<<<<<<<<<<<<<<<<<<<<'
      CALL KPWRTE (NTDISP)
      GO TO 210
C
  280 IAIN(1)=I
      IAIN(2)=I
      ISKP(14)=2
      ISKP(32)=0
      NTYP=4
      CALL ZVO
      NC=1
      NTRY=1
      CALL ZVDEK
      ISKP(14)=0
      IF (IGCPOI .GE. IGCDIM) THEN
        NS=NSSV
        GO TO 35
      ENDIF
      IGCPOI=IGCPOI+1
      IGCWRK(IGCPOI)=ICDS(1)
C                            Markiere Punkt
  290 TEMP=HOE/(HOE-X2(3))
      I=3
      CALL UPLINF (ISKP(41),10)
      CALL UPLINF (ISKP(49),11)
      DO  J=1,7,2
        AIN(1)=(X2(1)+HITMRK(J)*TOL)*TEMP*O9+CONST(11)
        AIN(2)=(X2(2)+HITMRK(J+1)*TOL)*TEMP*O9+CONST(12)
        CALL UPLINF (AIN,I)
        I=5-I
      ENDDO
      CALL UPLINF (T,0)
      NS=NSSV
      GO TO 210
C                       Delete Gruppe von Codes aus Codeliste
  310 I=NCDA(NS)-1
      J=I
      IF (IGCPOI .GT. 0) GO TO 340
      GO TO 480
C
  320 DO  K=1,IGCPOI
        IF (ICD(I,NS) .EQ. IGCWRK(K)) GO TO 340
      ENDDO
      J=J+1
      ICD(J,NS)=ICD(I,NS)
  340 I=I+1
      IF (I .LE. NCD(NS)) GO TO 320
      NCD(NS)=J
      K8(NS)=0
      K9(NS)=0
      GO TO 480
C                       Loesche Codeliste und ersetze durch Gruppe
  350 NCD(NS)=NCDA(NS)-1
      I=0
      GO TO 380
C
  360 IF (NCD(NS) .GE. NCDDM) THEN
        IERR=64 0220 01
        GO TO 480
      ENDIF
C
      NCD(NS)=NCD(NS)+1
      ICD(NCD(NS),NS)=IGCWRK(I)
  380 I=I+1
      IF (I .LE. IGCPOI) GO TO 360
      GO TO 480
C                       AGCA - Addiere Gruppe als Atome
  390 CONTINUE
      IAIN(1)=0
      IAIN(2)=NAT(NS)+1 
      CALL FLES (IAIN,ISKP(31),2HIE,5HOpt?$)
      ICDS(1)=0
      IF (IGCPOI .LE. 0) GO TO 999
      NC=2
      NTRY=24
      DO  I=1,IGCPOI
        ICDS(2)=IGCWRK(I)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 480
        IF (NAT(NS) .GE. NATDM) THEN
          IERR=64 0239 02
          GO TO 999
        ENDIF
C
        NAT(NS)=NAT(NS)+1
        DO  J=1,3
          AT(J,NAT(NS),NS)=X(J,2)
          AT(J+3,NAT(NS),NS)=AT(J+3,IANR,NS)
        ENDDO
        AT(7,NAT(NS),NS)=AT(7,IANR,NS)
        ICLRP(NAT(NS),NS)=ICLRP(IANR,NS)
        IPFLG(NAT(NS),NS)=IPFLG(IANR,NS)
        IF (IPFLG(NAT(NS),NS) .NE. 0) THEN
        DO  M=1,3
          K=1
          DO  L=1,3
            TFVKT(L,M,NAT(NS),NS)=SYM(K+1,ISYNR,NS)*TFVKT(1,M,IANR,NS)+
     +      SYM(K+2,ISYNR,NS)*TFVKT(2,M,IANR,NS)+
     +      SYM(K+3,ISYNR,NS)*TFVKT(3,M,IANR,NS)
            K=K+4
          ENDDO
        ENDDO
        ENDIF
      IF (IAIN(1) .NE. 0) IGCWRK(I)=NAT(NS)*200000+111001
      ENDDO
      WRITE (WRLINE,'(A,I4,A,I4)')
CYENG1
     + 'Atome erzeugt:',IAIN(2),' -',NAT(NS)
CYENG2
CYENGY     + 'Atoms generated:',IAIN(2),' -',NAT(NS)
      CALL KPWRTE (NTOUT )
      NTYP=21
      CALL ZVGE03
      GO TO 999
C                       OGCF - Liste Gruppe voll
  430 NTRY=28
      NC=1
      WRITE (WRLINE,440)
      CALL KPWRTE (NTOUT)
CYENG1
  440 FORMAT ('  Nr   Name       Code      trikline Koordinaten',
     1 '         freie Koordinaten')
CYENG2
CYENGY  440 FORMAT ('  Nr   Name       Code      Triclinic coordinates',
CYENGY     1 '        Free coordinates')
      IF (IGCPOI .LE. 0) GO TO 480
      DO  IC=1,IGCPOI
        ICDS(1)=IGCWRK(IC)
        CALL ZVDEK
        IF (IERR) 999,450,999
  450   CALL KPCDST (ISKP(80),1,ICDS(1))
        WRITE (WRLINE,460) IC,AT(5,IANR,NS),AT(6,IANR,NS),
     1  (ISKP(I),I=80,82),(X(I,1),I=1,3),(X2(I),I=1,3)
        CALL KPWRTE (NTOUT)
  460   FORMAT (I4,2X,2A4,3A4,3F8.5,3X,3F8.3)
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 480
        ENDIF
C
      ENDDO
  480 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
      GO TO 999
C
C                               FGC - Farbzeiger fuer Gruppenliste
  500 IAIN(1)=0
CYENG1
      CALL FLES (IAIN,ISKP(31),2HIE,4HNr?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),2HIE,4HNo?$)
      IF (IGCPOI .LE. 0) GO TO 999
      DO  I=1,IGCPOI
        J=IGCWRK(I)/200000
        ICLRP(J,NS)=IAIN(1)
      ENDDO
      GO TO 999
C                            Entferne ersten Code von der Liste
  520 IF (IGCPOI .GT. 1) THEN
        DO  I=2,IGCPOI
          IGCWRK(I-1)=IGCWRK(I)
        ENDDO
        IGCPOI=IGCPOI-1
      ELSE
        IGCPOI=0
      ENDIF
      GO TO 999
C                            AGCC - Addiere Gruppenliste in Codeliste
  530 IAIN(1)=555
      IAIN(2)=0
CYENG1
      CALL FLES (IAIN,ISKP(31),3H2IE,29HVerschiebung [555], Opt [0]?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),3H2IE,22HShift [555], opt [0]?$)
      DO  I=3,1,-1
        ITR(I)=MOD(IAIN(1),10)-5
        IAIN(1)=IAIN(1)/10
      ENDDO
      NC=1
      NTRY=16
      DO  I=1,IGCPOI
        ICDS(1)=IGCWRK(I)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  J=1,3
          IT(J)=IT(J)+ITR(J)
          IF (IT(J) .LT. 0 .OR. IT(J) .GT. 9) THEN
            CALL FLES (AIN,ISKP(31),1HK,2H?$)
            WRITE (WRLINE,'(A)')
CYENG1
     +      'ZVGC010318 - Es entsteht ungueltiger Code.'
CYENG2
CYENGY     +      'ZVGC010318 - Would generate invalid code.'
            CALL KPWRTE (NTDISP)
            IERR=-1
            GO TO 999
          ENDIF
        ENDDO
        ICDS(1)=(((IANR*10+IT(1))*10+IT(2))*10+IT(3))*200+ISYNR
        IF (IAIN(2) .NE. 0) IGCWRK(I)=ICDS(1)
        DO  J=NCDA(NS),NCD(NS)
          IF (ICD(J,NS) .EQ. ICDS(1)) GO TO 540
        ENDDO
        IF (NCD(NS) .GE. NCDDM) THEN
          IERR=64 0335 01
          GO TO 999
        ENDIF
        NCD(NS)=NCD(NS)+1
        ICD(NCD(NS),NS)=ICDS(1)
  540   CONTINUE
      ENDDO
      GO TO 999
C                            CTGC - Codes auf die Gruppenliste bringen
  550 IAIN(1)=ISKP(53)
      IAIN(2)=NAT(NS)
      WRITE (TMPLNE,'(A,I2,A,I4,A)')
CYENG1
     + 'von [',IAIN(1),'], bis [',NAT(NS),']? $'
CYENG2
CYENGY     + 'from [',IAIN(1),'], to [',NAT,']? $'
      CALL FLES (IAIN,ISKP(31),3H2IE,TMPLNE)
      IF (IAIN(2) .EQ. 0) IAIN(2)=IAIN(1)
      IGCPOI=0
      NC=1
      NTRY=32
      DO  IC=NCDA(NS),NCD(NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        IF (IANR .GE. IAIN(1) .AND. IANR .LE. IAIN(2)) THEN
          IF (IGCPOI .LT. IGCDIM) THEN
            IGCPOI=IGCPOI+1
            IGCWRK(IGCPOI)=ICD(IC,NS)
          ELSE
            WRITE (WRLINE,'(A)')
CYENG1
     +      'ZVGC010355 - Gruppenliste fuer Codes ist voll.'
CYENG2
CYENGY     +      'ZVGC010355 - Group list for codes full.'
            CALL KPWRTE (NTDISP)
            IERR=-1
            GO TO 999
          ENDIF
        ENDIF
      ENDDO
      GO TO 999
C                            DGCP - Delete Gruppe von Codes in
C                                   Parameterliste
C
  560 CALL FLES (AIN,ISKP(31),1HE,2H?$)
      IF (IGCPOI .LE. 0) GO TO 999
C
C                            Ersetze in der Gruppenliste die Codes
C                            durch Nummern.
      DO  I=1,IGCPOI
        IGCWRK(I)=IGCWRK(I)/200000
      ENDDO
C                            Sortiere in absteigender Reihenfolge ...
      I=1
      GO TO 610
  570 J=I
      I=I+1
      M=IGCWRK(I)
      GO TO 590
  580 IGCWRK(J+1)=IGCWRK(J)
      J=J-1
      IF (J .LE. 0) GO TO 600
  590 IF (M .GT. IGCWRK(J)) GO TO 580
  600 IGCWRK(J+1)=M
  610 IF (I .LT. IGCPOI) GO TO 570
C
C                            ... und eliminiere die doppelten.
      I=1
      J=1
      GO TO 630
  620 IF (IGCWRK(I) .NE. IGCWRK(J)) THEN
        J=J+1
        IGCWRK(J)=IGCWRK(I)
      ENDIF
  630 I=I+1
      IF (I .LE. IGCPOI) GO TO 620
C
C                            Entferne jetzt via EPL die Parameter.
      DO  I=1,J
        IAIN(1)=IGCWRK(I)
        IAIN(2)=IGCWRK(I)
        ISKP(14)=1
        NTYP=14
        CALL ZVFNIN
        IF (IERR .NE. 0) GO TO 640
      ENDDO
  640 ISKP(14)=0
      IGCPOI=0
      GO TO 999
C                            LGCT - Load GC-tree
  650 ICDS(1)=0
      ICDS(2)=0
      CALL FLES (ICDS,ISKP(31),3H2CE,7Hc1,c2?$)
      DO  NC=1,2
        IF (ICDS(NC) .NE. 0) THEN
          NTRY=17
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
          IGCWRK(NC)=ICDS(NC)
        ELSE
          IF (IGCPOI .LT. NC) THEN
            IERR=64 0492 16
            GO TO 999
          ENDIF
        ENDIF
      ENDDO
      IGCPOI=2
C
C                            Berechne freie koordinaten, soweit noch
C                            nicht geschehen.
      NTRY=44
      NC=1
      K8(NS)=0
      DO  IC=K9(NS)+1,NCD(NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  I=1,3
          ATOMS(I,IC,NS)=X2(I)
        ENDDO
      ENDDO
      K9(NS)=NCD(NS)
C                            Baue jetzt am letzten vorhandenen atom
C                            in der gruppenliste an.
      L=2
      M=IGCPOI
  655 ICDS(1)=IGCWRK(M)
      ICDS(2)=ICDS(1)/200000
      NTRY=28
      NC=1
      CALL ZVDEK
C                            Durchsuche die codeliste nach nachbarn.
      DO  IC=NCDA(NS),NCD(NS)
        ICDS(3)=ICD(IC,NS)
C                            Schon vorhanden?
        DO  I=L,IGCPOI
          IF (ICDS(3) .EQ. IGCWRK(I)) GO TO 730
        ENDDO
C                            Berechne nummern ...
        ICDS(4)=ICDS(3)/200000
C                            ... und suche einen geeigneten plotbefehl.
        IPKPNT=1
        GO TO 720
  660   IPLTBF=IPK(IPKPNT+1,NS)
        IF (IPLTBF .GE. 2 .AND. IPLTBF .LE. 4) THEN
C
C                            Bindung auf verbotsliste?
        DO  I=1,NPPOI(NS),2
          IF ((ICDS(3) .EQ. NPLST(I,NS) .AND. ICDS(1) .EQ.
     +    NPLST(I+1,NS)) .OR. (ICDS(3) .EQ. NPLST(I+1,NS) .AND.
     +    ICDS(1) .EQ. NPLST(I,NS))) GO TO 730
        ENDDO
C                            Nummern korrekt?
C
          IF ((ICDS(2) .GE. IPK(IPKPNT+2,NS) .AND.
     +         ICDS(2) .LE. IPK(IPKPNT+3,NS) .AND.
     +         ICDS(4) .GE. IPK(IPKPNT+4,NS) .AND.
     +         ICDS(4) .LE. IPK(IPKPNT+5,NS)) .OR.
     +        (ICDS(4) .GE. IPK(IPKPNT+2,NS) .AND.
     +         ICDS(4) .LE. IPK(IPKPNT+3,NS) .AND.
     +         ICDS(2) .GE. IPK(IPKPNT+4,NS) .AND.
     +         ICDS(2) .LE. IPK(IPKPNT+5,NS))) THEN
C
C                            Stimmt der Abstand?
            DMAX=VQ(IPKPNT+7,NS)
            TEMP=0.
            DO  I=1,3
              TEMP2=ABS(X2(I)-ATOMS(I,IC,NS))
              IF (TEMP2 .GT. DMAX) GO TO 710
              TEMP=TEMP+TEMP2*TEMP2
            ENDDO
C
            IF (TEMP .GT. DMAX*DMAX) GO TO 710
            IF (TEMP .LT. VQ(IPKPNT+6,NS)*VQ(IPKPNT+6,NS)) GO TO 710
            GO TO 700
          ENDIF
          GO TO 710
        ENDIF
        IF (IPLTBF .GE. 12 .AND. IPLTBF .LE. 14) THEN
C
C                            Verbinde direkt.  Teste, ob Paar
C                            im Befehl vorkommt.
          J=IPK(IPKPNT,NS)
          I=5
  670     IF (IPK(IPKPNT+I,NS) .EQ. ICDS(1)) GO TO 690
  680     I=I+1
          IF (I .LT. J) GO TO 670
          GO TO 710
C
  690     IF (IPK(IPKPNT+I+1,NS) .EQ. ICDS(3)) GO TO 700
          IF (IPK(IPKPNT+I-1,NS) .NE. ICDS(3)) GO TO 680
          GO TO 700
        ENDIF
        GO TO 710
C                            Nimm code auf, wenn noch moeglich.
C
  700   IF (IGCWRK(1) .EQ. ICDS(3)) THEN
          IF (M .LE. 2) GO TO 730
CYENG1
          WRITE (WRLINE,'(A)') 'Warnung! Auf Startatom getroffen.'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') 'Warning! Starting atom met.'
          CALL KPWRTE (NTDISP)
          L=1
          GO TO 730
        ENDIF
        IF (IGCPOI .GE. IGCDIM) GO TO 35
        IGCPOI=IGCPOI+1
        IGCWRK(IGCPOI)=ICDS(3)
        GO TO 730
C
  710   IPKPNT=IPKPNT+IPK(IPKPNT,NS)
  720   IF (IPKPNT .LT. IPKP(NS)) GO TO 660
  730   CONTINUE
      ENDDO
      M=M+1
      IF (M .LE. IGCPOI) GO TO 655
      IF (L .EQ. 1) IERR=-1
C
  999 RETURN
      END
