C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C          71             -------------------
                           SUBROUTINE ZVGC02
C CY-ENG-                 -------------------
C
C  NTYP  Funktion
C    1   VGC   Verschiebe Gruppe von Codes
C    2   VM    Verschiebe Gruppe von Codes mit Maus
C    3   EGCB  Entferne Codes aus der Beschriftungsliste
C    4   VGCT  Verschiebe Gruppe von Codes triklin
C    5   PM    Punkt durch Maus
C    6   DGC   Drehe Gruppe von Codes um Achse des freien Systems
C    7   DGCV  Drehe Gruppe von Codes um Vektor
C    8   VSFT  Verschiebe Schrift
C    9   DTG   Definiere und/oder transformiere Gruppe
C    10-11     dto, Parameter von IAIN
C
C                geschrieben: 100810 APR 1993  (Hundt)
C                geaendert:   211625 FEB 2005  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 MPKDM,MPKST
      PARAMETER (MPKDM=16*PARDIM)
      INTEGER *2 MPKBF(MPKDM)
C
      INTEGER *4 NTYPS,I,J,K,L,MPKT,IAIN(72),INBFR(2),IRLINE(30)
      INTEGER *4 INBFR2(3),IPLPOI(3)
C
      REAL    *4 V(3),VTR(3),TEMP,ANBFR(2),TRMAT(3,3),TRUR(3)
      REAL    *4 ANBFR2(3),VQ(IPKDIM,2)
C
      EQUIVALENCE (AIN(1),IAIN(1)),(INBFR(1),ANBFR(1))
      EQUIVALENCE (INBFR2(1),ANBFR2(1)),(IPK(1,1),VQ(1,1))
      EQUIVALENCE (AT(1,1,1),MPKBF(1)),(WRLINE,IRLINE(1))
C
      SAVE V,INBFR,IPLPOI
C
      NTYPS=NTYP
      K8(NS)=0
      K9(NS)=0
      GO TO (10,140,160,10,290,300,340,420),NTYPS
C             1   2   3  4   5   6   7   8
C
C                 Kommando VGC - Verschiebe Gruppe von Codes
C
   10 IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (V,ISKP(31),3H3FE,7Hx,y,z?$)
      ELSE
        DO  I=1,3
          V(I)=AIN(I)
        ENDDO
        ISKP(14)=0
      ENDIF
      IF (NTYPS .NE. 4) GO TO 30
C
C               Kommando VGCT - Verschiebe Gruppe laengs
C               eines triklinen Vektors
C
      DO  I=1,3
        VTR(I)=V(I)
      ENDDO
      GO TO 50
C                            Berechne triklinen Vektor
   30 DO  I=1,3
        VTR(I)=TRAINV(I,1,NS)*V(1)+TRAINV(I,2,NS)*V(2)+
     +  TRAINV(I,3,NS)*V(3)
      ENDDO
C
C                            Hole aus Mausliste Punkte
   50 I=0
      MPKT=16*NAT(1)
      MPKST=MPKT+1
      NC=1
   60 I=I+1
      ICDS(1)=I
      NTYP=7
      CALL ZVGC01 (ICDS(1))
      IF (ICDS(1) .EQ. 0) GO TO 999
C
C                            Hatten wir das Atom schon?
      NTRY=16
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  J=MPKST,MPKT
        IF (MPKBF(J) .EQ. IANR) GO TO 60
      ENDDO
C                            Atom war noch nicht da; merken.
C
      IF (MPKT .GE. MPKDM) THEN
        IERR=71 0096 20
        GO TO 999
      ENDIF
      MPKT=MPKT+1
      MPKBF(MPKT)=IANR
      IF (NTYPS .LT. 5) GO TO 85
      NTRY=8
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
C
C                            Wir brauchen jetzt die inverse
C                            Matrix der bezeichneten Symmetrie ...
   85 DO  J=1,3
        S(1,J)=SYM(J+1,ISYNR,NS)
        X(1,J+3)=S(1,J)
        S(2,J)=SYM(J+5,ISYNR,NS)
        X(2,J+3)=S(2,J)
        S(3,J)=SYM(J+9,ISYNR,NS)
        X(3,J+3)=S(3,J)
      ENDDO
      CALL MINV (S,3,AIN(41),AIN(42),AIN(45))
      IF (AIN(41) .NE. 0.) GO TO 110
      WRITE (WRLINE,100) ISYNR
CYENG1
  100 FORMAT ('ZVGC020116 - Symmetrie',I3,' fehlerhaft.')
CYENG2
CYENGY  100 FORMAT ('ZVGC020116 - Error in symmetry',I3,'.')
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 999
C
  110 IF (NTYPS .GE. 5) THEN
C
C                            Der Verschiebungsvektor muss erst
C                            einmal bestimmt werden.
        DO  J=1,3
          T(J)=X(J,1)-TRUR(J)
        ENDDO
        DO  J=1,3
          VTR(J)=TRMAT(J,1)*T(1)+TRMAT(J,2)*T(2)+TRMAT(J,3)*T(3)
     1    +TRUR(J)-X(J,1)
        ENDDO
      ENDIF
C                            ... um sie auf den Verschiebungs-
C                            vektor anwenden zu koennen.
      DO  J=1,3
        T(J)=S(J,1)*VTR(1)+S(J,2)*VTR(2)+S(J,3)*VTR(3)
      ENDDO
C
C                            Sodann wird dieser Betrag dem
C                            bezeichneten Atom zugeschlagen.
      DO  J=1,3
        AT(J,IANR,NS)=AT(J,IANR,NS)+T(J)
      ENDDO
      IF (NTYPS .GE. 5 .AND. IPFLG(IANR,NS) .EQ. 8) THEN
C
C                            Bei Drehungen werden die Auslenkungs-
C                            parameter ebenfalls beruecksichtigt.
C
        CALL MM (X(1,4),TFVKT(1,1,IANR,NS),X)
        CALL MM (TRMAT,X,X(1,4))
        CALL MM (S,X(1,4),TFVKT(1,1,IANR,NS))
      ENDIF
      GO TO 60
C                            VGCM - Verschiebe Gruppe mit Maus.
C                            Hole Mauskoordinaten ...
  140 CALL UPLINF (AIN,8)
C                            ... und teste auf Abbruch, ...
C
      IF (IAIN(4) .EQ. 33) GO TO 999
C
C                            ... akzeptiere aber nur linke Maustaste.
C
      IF (IAIN(4) .NE. 32) GO TO 140
C
C                            Dto. 2. Punkt.
C
  150 CALL UPLINF (AIN(3),8)
      IF (IAIN(6) .EQ. 33) GO TO 999
      IF (IAIN(6) .NE. 32) GO TO 150
C
C                            Berechne den Zuschlags-Vektor.
C
      V(3)=(HOE-PFREI(3))/HOE
      V(1)=(AIN(3)-AIN(1))*V(3)/O9
      V(2)=(AIN(4)-AIN(2))*V(3)/O9
      V(3)=0.
      IF (NTYPS .EQ. 8) GO TO 460
      GO TO 30
C                            EGCB - Entferne Codes aus BA-Liste
  160 CONTINUE
C                            Hole aus Mausliste Punkte
      I=0
      NC=1
  170 I=I+1
      ICDS(1)=I
      NTYP=7
      CALL ZVGC01 (ICDS(1))
      IF (ICDS(1) .EQ. 0) GO TO 999
C
C                            Suche BA-Befehl
  180 MPKT=1
      GO TO 280
  190 K=MPKT+IPK(MPKT,NS)
      IF (IPK(MPKT+1,NS) .NE. 5) GO TO 270
C
C                            Gefunden. Suche nach Code.
      J=MPKT+5
      GO TO 260
  200 IF (IPK(J,NS) .NE. ICDS(1)) GO TO 250
C
C                            Code gefunden. Delete.
      L=J+3
      GO TO 220
  210 IPK(L-3,NS)=IPK(L,NS)
      L=L+1
  220 IF (L .LE. IPKP(NS)) GO TO 210
      IPKP(NS)=IPKP(NS)-3
      IPK(MPKT,NS)=IPK(MPKT,NS)-3
      K=K-3
C                           ? War es der letzte Code ?
C
      IF (IPK(MPKT,NS) .GT. 5) GO TO 260
C
C                           Delete auch noch den Rest.
      L=MPKT+5
      GO TO 240
  230 IPK(L-5,NS)=IPK(L,NS)
      L=L+1
  240 IF (L .LE. IPKP(NS)) GO TO 230
      IPKP(NS)=IPKP(NS)-5
      GO TO 280
C
  250 J=J+3
  260 IF (J .LT. K) GO TO 200
  270 MPKT=K
  280 IF (MPKT .LT. IPKP(NS)) GO TO 190
      GO TO 170
C                            PM - Punkt durch Maus
  290 TEMP=HOE/(HOE-PFREI(3))
      CALL UPLINF (AIN,8)
      IF (IAIN(4) .EQ. 32) THEN
        PFREI(1)=(AIN(1)-CONST(11))/(TEMP*O9)
        PFREI(2)=(AIN(2)-CONST(12))/(TEMP*O9)
        NTYP=15
        CALL ZVGE01
        NTYP=5
      ELSE
        IERR=-1
      ENDIF
      GO TO 999
C                            DGC - Drehe Gruppe um Achse
  300 IF (ISKP(14) .EQ. 0) THEN
        ANBFR(2)=CONST(6)
CYENG1
        CALL FLES (INBFR,ISKP(31),3HIFE,12HAchse,Grad?$)
CYENG2
CYENGY        CALL FLES (INBFR,ISKP(31),3HIFE,11HAxis,deg.?$)
      ELSE
        INBFR(1)=IAIN(1)
        INBFR(2)=IAIN(2)
        ISKP(14)=0
      ENDIF
      CONST(6)=ANBFR(2)
      IF (INBFR(1) .LE. 0) GO TO 310
      IF (INBFR(1) .LE. 3) GO TO 360
  310 IERR=71 0262 16
      GO TO 999
C                            DGCV - Drehe Gruppe um Vektor
C
  340 IF (ISKP(14) .EQ. 0) THEN
        ANBFR2(3)=CONST(6)
CYENG1
        CALL FLES (INBFR2,ISKP(31),4H2CFE,12Hc1,c2,Grad?$)
CYENG2
CYENGY        CALL FLES (INBFR2,ISKP(31),4H2CFE,12Hc1,c2,deg.?$)
      ELSE
        DO  I=1,3
          INBFR2(I)=IAIN(I)
        ENDDO
        ISKP(14)=0
      ENDIF
      CONST(6)=ANBFR2(3)
C                            Baue Koordinatensystem auf.
      DO  NC=2,3
        ICDS(NC)=INBFR2(NC-1)
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=NC-1
          NTYP=7
          CALL ZVGC01 (ICDS(NC))
        ENDIF
      ENDDO
      ICDS(1)=ICDS(2)
      ICDS(4)=0
C                            Save Koordinatensystem ...
      ISKP(14)=1
      NTYP=4
      CALL ZVK
C                            ... berechne neue Basisvektoren ...
      NTYP=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 410
C
C                            ... und merke Ursprung.
  360 DO  L=1,3
        TRUR(L)=UR(L,NS)
      ENDDO
C                             Drehmatrix.
      I=1
      IF (NTYPS .EQ. 6) I=INBFR(1)
      DO  J=1,3
        DO  K=1,3
          S(J,K)=0.
        ENDDO
      ENDDO
      S(I,I)=1.
      J=ID2(I)
      K=ID2(J)
      AIN(1)=CONST(6)*CONST(3)
      TEMP=COS(AIN(1))
      S(J,J)=TEMP
      S(K,K)=TEMP
      TEMP=SIN(AIN(1))
      S(K,J)=TEMP
      S(J,K)=-TEMP
C                             Berechne Transformationsmatrix.
      DO  I=1,3
        DO  J=1,3
          X(I,J)=S(I,1)*TRA(1,J,NS)+S(I,2)*TRA(2,J,NS)+
     +    S(I,3)*TRA(3,J,NS)
        ENDDO
      ENDDO
      DO  I=1,3
        DO  J=1,3
          TRMAT(I,J)=TRAINV(I,1,NS)*X(1,J)+
     1                     TRAINV(I,2,NS)*X(2,J)+TRAINV(I,3,NS)*X(3,J)
        ENDDO
      ENDDO
      IF (ISKP(58) .LT. 1) GO TO 403
      WRITE (WRLINE,404)
      CALL KPWRTE (NTOUT)
CYENG1
  404 FORMAT ('Drehmatrix:')
CYENG2
CYENGY  404 FORMAT (' Rotation matrix:')
      DO  I=1,3
        WRITE (WRLINE,402) (TRMAT(J,I),J=1,3)
  402   FORMAT (3F12.6)
        CALL KPWRTE (NTOUT)
      ENDDO
C
C                             Restore ggf. Koordinatensystem.
C
  403 IF (NTYPS .NE. 7) GO TO 50
  410 NTYP=5
      CALL ZVK
      ISKP(14)=0
      IF (IERR .NE. 0) GO TO 999
      GO TO 50
C                            VSFT - Verschiebe Schrift.
C
CYENG1
  420 CALL FLES (IPLPOI,ISKP(31),3H2IE,11HNr.,Platz?$)
CYENG2
CYENGY  420 CALL FLES (IPLPOI,ISKP(31),3H2IE,14HNo.,position?$)
C
C                            Suche den Plotbefehl.
      I=1
      J=1
      IF (IPLPOI(1) .EQ. 0) THEN
  425   IF (J .GE. IPKP(NS)) THEN
         IERR=71 0366 16
         GO TO 999
        ENDIF
        IF (IPK(J+1,NS) .EQ. 6) THEN
          IPLPOI(1)=I
          GO TO 430
        ENDIF
        J=J+IPK(J,NS)
        I=I+1
        GO TO 425
      ENDIF
C
  430 IF (J .GE. IPKP(NS) .OR. I .GT. IPLPOI(1)) THEN
        IERR=71 0379 16
        GO TO 999
      ENDIF
      IF (I .LT. IPLPOI(1)) THEN
        J=J+IPK(J,NS)
        I=I+1
        GO TO 430
      ENDIF
C                            Handelt es sich um einen BA- oder
C                            einen BT-befehl?
C
      IF (IPK(J+1,NS) .EQ. 5) THEN
C
C                            Suche die entsprechende Stelle.
        L=J+IPK(J,NS)
        J=J+6
        I=1
  440   IF (J .GT. L .OR. I .GT. IPLPOI(2)) THEN
          IERR=71 0397 16
          GO TO 999
        ENDIF
        IF (I .LT. IPLPOI(2)) THEN
          J=J+3
          I=I+1
          GO TO 440
        ENDIF
        GO TO 450
      ENDIF
      IF (IPK(J+1,NS) .EQ. 6) THEN
        J=J+4
        GO TO 450
      ENDIF
      IERR=71 0411 16
      GO TO 999
C
  450 IPLPOI(3)=J
      NC=1
      ICDS(1)=IPK(J-1,NS)
      NTRY=28
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        PFREI(I)=X2(I)
        PTRIKL(I)=X(I,1)
      ENDDO
      GO TO 140
C                            Verarbeite Zuschlag.
  460 J=IPLPOI(3)
      VQ(J,NS)=VQ(J,NS)+V(1)
      J=J+1
      VQ(J,NS)=VQ(J,NS)+V(2)
      GO TO 999
C
  999 NTYP=NTYPS
      RETURN
      END
