C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         75             ----------------------
                           SUBROUTINE ZVGC03
C  CY-ENG-               ----------------------
C
C--- NTYP=1: Die auf der mausliste gespeicherten atome werden auf
C            auf eine ebene des freien koordinatensystems proji-
C            ziert. (PGCE)
C    NTYP=2: Aus VD-kommandos werden FACE-anweisungen gemacht. (MFCE)
C    NTYP=3: In VD-kommandos zeichenparameter aendern. (CVDP)
C    NTYP=4: MVPK - Plotkommandos umsortieren.
C    NTYP=5: NPZ  - Normalisiere parameter auf zelle
C    NTYP=6: VDGC - Verschiebe und drehe gruppenliste
C    NTYP=7: VDGR - VDGC fortsetzen
C    NTYP=8: AFG  - Affine Gruppe
C    NTYP=9: AFGC - Affine Gruppe vollstaendig
C
C                 geschrieben: 210906 SEP 1996 (Hundt)
C                   geaendert: 230904 DEC 2003 (Hundt)
C
C                        ----------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
      INCLUDE 'RDBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
      INTEGER *4 I,J,K,INR,NTYPS,INBFR(9),IADR,NATS,IAIN(72),IPOI,L,LM
      INTEGER *4 IM,JM,ICPOIA,ICPOI,KDM,KDNEUN,KDD,KDS,KDNULL,KDEINS
      INTEGER *4 IAKT(3),IDBFR(11),KDSTPU,KD0,KD9,KDBLNK,IVOPT,KDSEMI
      INTEGER *4 KDSTRN,II,KDR,IAIM(3),IAINC(11),ISYMB(2),ICBMRK,M
      INTEGER *4 IAT(8,PARDIM,2),ITCDS(9,PARDIM)
      INTEGER *1 I1AIN(288)
      REAL    *4 AIDBFR(11),URSAV(3),E(4,4),EE(4,3),G1(4),G2(3)
      REAL    *4 AINBFR(9),C,DI,DJ,AI,AJ,DM,SAVH(3),AINC(11),AIM(3)
      SAVE IDBFR,IAKT,IVOPT,IAIM,IAINC
      EQUIVALENCE (INBFR(1),AINBFR(1)),(AIN(1),IAIN(1),I1AIN(1))
      EQUIVALENCE (IDBFR(1),AIDBFR(1)),(IAINC(1),AINC(1))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1)),(TFVKT(1,1,1,1),ITCDS(1,1))
      EQUIVALENCE (IAIM(1),AIM(1))
      DATA IDBFR/0,555,0,0,0,0,4HEPU ,0,0,0,0/,IAKT/3*0/,KDSTPU/4HSTPU/
      DATA KD0/48/,KD9/57/,KDBLNK/4H    /,IVOPT/1/,KDS/4HS   /
      DATA KDM/45/,KDNEUN/4H9   /KDD/4HD** /,KDNULL/4H   0/
      DATA KDEINS/4H   1/,KDSEMI/4H;   /,KDSTRN/4H   */,KDR/4HR   /
      DATA IAIM/0,0,4HR   /
      DATA AINC(5)/.4/,AINC(6)/.2/,IAINC(7)/20/,IAINC(8)/-1/
C
      NTYPS=NTYP
      GO TO (10,30,30,100,170,220,235,260,300),NTYPS
C             1  2  3   4   5   6   7   8   9
   10 INR=3
CYENG1
      CALL FLES (INR,ISKP(31),2HIE,15HNr. der Achse?$)
CYENG2
CYENGY      CALL FLES (INR,ISKP(31),2HIE,13HNo. of axis?$)
      IF ((INR .LT. 1) .OR. (INR .GT. 3)) THEN
        IERR=75 0059 07
        GO TO 999
      ENDIF
      K8(NS)=0
      K9(NS)=0
C
C                            Hole aus Mausliste Punkte
      K=0
      NC=1
   20 K=K+1
      ICDS(1)=K
      NTYP=7
      CALL ZVGC01 (ICDS(1))
      IF (ICDS(1) .EQ. 0) GO TO 999
C
C                            Berechne die freien Koordinaten
      NTRY=28
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
C
C                            Wir brauchen jetzt die inverse
C                            Matrix der bezeichneten Symmetrie ...
      DO  I=1,3
        S(1,I)=SYM(I+1,ISYNR,NS)
        S(2,I)=SYM(I+5,ISYNR,NS)
        S(3,I)=SYM(I+9,ISYNR,NS)
      ENDDO
      CALL MINV (S,3,AIN(41),AIN(42),AIN(45))
      IF (AIN(41) .EQ. 0.) THEN
        WRITE (WRLINE,'(A,I3,A)')
CYENG1
     1  ' ZVGC030090 - Symmetrie',ISYNR,' fehlerhaft.'
CYENG2
CYENGY     1  ' KPGC030090 - Error in symmetrie',ISYNR,'.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
C                            Setze die angegebene koordinate auf 0.
      X2(INR)=0.
C                            Berechne hieraus wieder die triklinen
C                            koordinaten.
      DO  I=1,3
        X1(I)=TRAINV(I,1,NS)*X2(1)+TRAINV(I,2,NS)*X2(2)+
     +  TRAINV(I,3,NS)*X2(3)+UR(I,NS)-FLOAT(IT(I)-5)
      ENDDO
      DO  I=1,3
        AT(I,IANR,NS)=S(I,1)*X1(1)+S(I,2)*X1(2)+S(I,3)*X1(3)
      ENDDO
      GO TO 20
C                            MFCE - Mache FACE-karten.
C                            CVDP - Change VD-parameter
   30 INBFR(1)=1
      INBFR(2)=999
      INBFR(3)=50
      AINBFR(4)=0.05
      DO  I=5,9
        INBFR(I)=-1
      ENDDO
      IF (NTYPS .EQ. 2) THEN
CYENG1
        CALL FLES (INBFR,ISKP(31),4H3IFE,19Hvon,bis,ordn.,tol?$)
CYENG2
CYENGY        CALL FLES (INBFR,ISKP(31),4H3IFE,19Hfrom,to,order,tol?$)
      ELSE
        INBFR(3)=2
        CALL FLES (INBFR,ISKP(31),7H3C2F5IE,
CYENG1
     +  31Hvon,bis,cur,tol,r,fr,sr,ff,nf?$)
CYENG2
CYENGY     +  31Hfrom,to,cur,tol,r,fr,sr,ff,nf?$)
        DO  I=1,3
          SAVH(I)=TRAINV(I,3,NS)*HOE+UR(I,NS)
        ENDDO
        ICPOI=NCD(NS)
        ICPOIA=ICPOI+1
      ENDIF
C                            Save koordinatensystem.
      NTYP=19
      CALL ZVK
C                            Schleife ueber die plotbefehle.
      NATS=NAT(NS)
      INR=0
      IADR=1
   40 INR=INR+1
      IF (IADR .GT. IPKP(NS)) GO TO 80
      IF ((INR .GE. INBFR(1)) .AND. (INR .LE. INBFR(2))) THEN
C
C                            Handelt es sich um einen VD-Befehl?
C
        IF (IPK(IADR+1,NS) .EQ. 12) THEN
C
C                            Erzeuge neue atome.
C
          NAT(NS)=NATS
          NC=1
          NTRY=24
          IPOI=9
   50     ICDS(1)=IPK(IADR+IPOI,NS)
          IF (ICDS(1) .EQ. 0) GO TO 60
          IF (NAT(NS) .LT. NATDM) THEN
            NAT(NS)=NAT(NS)+1
            CALL ZVDEK
            DO  J=1,3
              AT(J,NAT(NS),NS)=X(J,1)
            ENDDO
            AT(4,NAT(NS),NS)=0.3
          ELSE
            IERR=75 0167 02
            GO TO 80
          ENDIF
          IPOI=IPOI+1
          GO TO 50
C
   60     ISKP(14)=1
          NTYP=1
          IAIN(1)=NATS+1
          IAIN(2)=NAT(NS)
          CALL ZVEFIT
          IF (IERR .NE. 0) GO TO 80
          IF (NTYPS .EQ. 3) THEN
C
C                            CVDP: Teste, ob der urspruengliche
C                            betrachtungspunkt und der innere punkt
C                            auf der gleichen seite liegen.
            DO  I=1,3
              X1(I)=SAVH(I)-UR(I,NS)
            ENDDO
            X(1,1)=TRA(3,1,NS)*X1(1)+TRA(3,2,NS)*X1(2)+TRA(3,3,NS)*X1(3)
            ICDS(2)=INBFR(3)
            NC=2
            NTRY=28
            CALL ZVDEK
            IF (IERR .NE. 0) GO TO 80
            IF (X(1,1)*X2(3) .GT. 0.) THEN
              DO  I=5,9
                IF (INBFR(I) .GE. 0) IPK(IADR+I-3,NS)=INBFR(I)
              ENDDO
              IF (ICPOI .LT. NCDDM) THEN
                ICPOI=ICPOI+1
                ICD(ICPOI,NS)=INR
              ENDIF
            ENDIF
            GO TO 75
          ENDIF
C
C                            Berechne die Millerschen Indices.
          DO  I=1,3
            X2(I)=TRA(3,I,NS)
            X1(I)=ABS(X2(I))
          ENDDO
          C=TRA(3,1,NS)*UR(1,NS)+TRA(3,2,NS)*UR(2,NS)+
     +    TRA(3,3,NS)*UR(3,NS)
C
          IF (C .LT. 0) THEN
            DO  I=1,3
              X2(I)=-X2(I)
            ENDDO
            C=-C
          ENDIF
C                            Mache ganzzahlig.
C
          I=1
          K=1
          DO  J=2,3
            IF (X1(J) .LT. X1(I)) I=J
            IF (X1(J) .GT. X1(K)) K=J
          ENDDO
          IF (I .EQ. K) THEN
            DO  J=1,3
              IT(J)=1
            ENDDO
          ELSE
            J=6-I-K
            LM=0
            DM=10.
            DO  L=1,INBFR(3)
              AI=X1(I)/X1(K)*FLOAT(L)
              IT(I)=AI+0.5
              AJ=X1(J)/X1(K)*FLOAT(L)
              IT(J)=AJ+0.5
              IT(K)=L
              DI=ABS(FLOAT(IT(I))-AI)
              DJ=ABS(FLOAT(IT(J))-AJ)
              IF ((DI .LT. AINBFR(4)) .AND. (DJ .LT. AINBFR(4))) THEN
                GO TO 70
              ELSE
                IF (DI+DJ .LT. DM) THEN
                  LM=L
                  DM=DI+DJ
                  IM=IT(I)
                  JM=IT(J)
                ENDIF
              ENDIF
            ENDDO
            IT(I)=IM
            IT(J)=JM
            IT(K)=LM
          ENDIF
   70     CONTINUE
          DO  L=1,3
            IF (X2(L) .LT. 0.) IT(L)=-IT(L)
          ENDDO
          C=C/CONST(42)
          ISKP(14)=0
          NTYP=NTPCH
          CALL ZVEAEH
          WRITE (WRLINE,'(A,3I4,F10.5)') 'FACE',IT,C
          CALL KPWRTE (NTPCH)
        ENDIF
      ENDIF
   75 IADR=IADR+IPK(IADR,NS)
      GO TO 40
C                            Aufraeumen.
   80 NAT(NS)=NATS
      ISKP(14)=0
C                            Restore Koordinatensystem.
      NTYP=20
      CALL ZVK
      IF (NTYPS .NE. 3) GO TO 999
C
C                            Sortiere liste mit plotkommandos um.
      IM=0
      JM=ICPOIA-1
      GO TO 90
   85 JM=JM+1
      IAIN(1)=ICD(JM,NS)-IM
      IAIN(2)=IAIN(1)
      IAIN(3)=999
      IM=IM+1
      GO TO 105
   90 IF (JM .LT. ICPOI) GO TO 85
      GO TO 999
C                            MVPK - Move plotkommandos
C
CYENG1
  100 CALL FLES (IAIN,ISKP(31),3H3IE,15Hvon<,bis>,vor?$)
CYENG2
CYENGY  100 CALL FLES (IAIN,ISKP(31),3H3IE,18Hfrom<,to>,before?$)
      IF (ISKP(31) .LT. 2) THEN
        IERR=75 0298 16
        GO TO 999
      ENDIF
      IF (ISKP(31) .EQ. 2) THEN
        IAIN(3)=IAIN(2)
        IAIN(2)=IAIN(1)
      ENDIF
C                            Ersetze die nummern durch adressen.
C
  105 DO  I=4,6
        IAIN(I)=0
      ENDDO
      INR=0
      IADR=1
  110 INR=INR+1
      IF (IADR .GT. IPKP(NS)) GO TO 120
      DO  I=1,3
        IF (IAIN(I+3) .EQ. 0) THEN
          IF (IAIN(I) .EQ. INR) THEN
            IF (I .EQ. 2) THEN
              IAIN(2)=IADR+IPK(IADR,NS)-1
            ELSE
              IAIN(I)=IADR
            ENDIF
            IAIN(I+3)=1
          ENDIF
        ENDIF
      ENDDO
      IADR=IADR+IPK(IADR,NS)
      GO TO 110
C                            Spezialfall: ans ende.
C
  120 IF (IAIN(6) .EQ. 0 .AND. IAIN(3) .GE. INR) THEN
        IAIN(3)=IPKP(NS)+1
        IAIN(6)=1
      ENDIF
      IF (IAIN(4)+IAIN(5)+IAIN(6) .NE. 3) THEN
        IERR=75 0335 16
        GO TO 999
      ENDIF
  130 IF (IAIN(1) .GT. IAIN(2)) THEN
        IERR=75 0339 16
        GO TO 999
      ENDIF
      IF (IAIN(3) .LE. IAIN(2)) THEN
C
C                            Parameter umstellen.
        IAIN(4)=IAIN(3)
        IAIN(3)=IAIN(2)+1
        IAIN(2)=IAIN(1)-1
        IAIN(1)=IAIN(4)
        GO TO 130
      ENDIF
C
      IAIN(3)=IAIN(3)-1
      IF (IAIN(2) .GT. IAIN(3)) THEN
        IERR=75 0354 16
        GO TO 999
      ENDIF
      IF (IAIN(2) .EQ. IAIN(3)) GO TO 999
      IF (IAIN(3) .GT. IPKP(NS)+1) THEN
        IERR=75 0359 16
        GO TO 999
      ENDIF
C                            up/down
      IAIN(7)=IAIN(1)-1
      IAIN(10)=IAIN(3)-IAIN(7)
      IAIN(5)=IAIN(2)-IAIN(7)
      IAIN(4)=IAIN(3)-IAIN(2)
      IAIN(6)=0
C
  140 IAIN(7)=IAIN(7)+1
      IAIN(8)=IAIN(7)
      IAIN(17)=IPK(IAIN(7),NS)
      GO TO 160
C                            Ring
  150 IPK(IAIN(8),NS)=IPK(IAIN(9),NS)
      IAIN(8)=IAIN(9)
  160 IAIN(6)=IAIN(6)+1
      IAIN(9)=IAIN(8)+IAIN(5)
      IF (IAIN(9) .GT. IAIN(3)) IAIN(9)=IAIN(8)-IAIN(4)
      IF (IAIN(9) .NE. IAIN(7)) GO TO 150
C
      IPK(IAIN(8),NS)=IAIN(17)
      IF (IAIN(6) .LT. IAIN(10)) GO TO 140
      IF (NTYPS .EQ. 3) GO TO 90
      GO TO 999
C                            NPZ - Normalisiere parameter auf zelle.
  170 IAIN(1)=ISKP(53)
      IAIN(2)=NAT(NS)
      IF (ISKP(14) .EQ. 0) THEN
CYENG1
        CALL FLES (IAIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY        CALL FLES (IAIN,ISKP(31),3H2IE,9Hfrom,to?$)
      ENDIF
      IF (IAIN(1) .LE. 0 .OR. IAIN(2) .GT. NAT(NS) .OR.
     +  IAIN(1) .GT. IAIN(2)) THEN
        IERR=75 0394 16
        GO TO 999
      ENDIF
      DO  I=IAIN(1),IAIN(2)
        DO  J=1,3
          GO TO 190
  180     AT(J,I,NS)=AT(J,I,NS)+1.
  190     IF (AT(J,I,NS) .LT. 0.) GO TO 180
          GO TO 210
  200     AT(J,I,NS)=AT(J,I,NS)-1.
  210     IF (AT(J,I,NS) .GT. 0.99999) GO TO 200
        ENDDO
      ENDDO
      K8(NS)=0
      K9(NS)=0
      GO TO 999
C                            VDGC - Verschiebe und drehe gruppe
C                            von Codes.
C
  220 IF (IVOPT .EQ. 4) AIDBFR(1)=-AIDBFR(1)
      IDBFR(2)=555
      IDBFR(4)=0
      IDBFR(7)=0
      IF (ISKP(59) .EQ. 3) IDBFR(7)=KDSTPU
      CALL FLES (IDBFR,ISKP(31),9HFIF3CA4IE,
CYENG1
     + 57Hshift,rchtg,winkel,a,c1,c2,EPU/STPU,opt1,opt2,opt3,macr?$)
CYENG2
CYENGY     + 60Hshift,direction,angle,a,c1,c2,EPU/STPU,opt1,opt2,opt3,macr?$)
      IF (IDBFR(4) .LT. 0 .OR. IDBFR(4) .GT. 4) THEN
        IERR=75 0424 07
      ENDIF
      CALL CNVTUP (IDBFR(7),1,4)
      IF (IDBFR(7) .EQ. KDS) IDBFR(7)=KDSTPU
      IAKT(1)=MOD(IDBFR(2)/100,10)-5
      IAKT(2)=MOD(IDBFR(2)/10,10)-5
      IAKT(3)=MOD(IDBFR(2),10)-5
      IVOPT=1
      IF (AIDBFR(1) .LT. 0.) THEN
        IVOPT=4
        AIDBFR(1)=-AIDBFR(1)
      ENDIF
C
C                            Teste, ob verschoben werden soll.
C
  230 IF (ABS(IAKT(1))+ABS(IAKT(2))+ABS(IAKT(3)) .NE. 0) THEN
        DO  I=1,3
          AIN(I)=AIDBFR(1)*FLOAT(IAKT(I))
        ENDDO
        ISKP(14)=1
        NTYP=IVOPT
        CALL ZVGC02
        IF (IERR .NE. 0) GO TO 999
      ENDIF
C                            Teste, ob gedeht wird
C
      IF (IDBFR(4) .NE. 0) THEN
C
C                            Vektor ...
C
        IF (IDBFR(4) .GT. 3) THEN
          IAIN(1)=IDBFR(5)
          IAIN(2)=IDBFR(6)
          AIN(3)=AIDBFR(3)
          NTYP=7
          ISKP(14)=1
          CALL ZVGC02
        ELSE
C                            ... oder achse?
C                            Verwende als drehpunkt c1.
          ICDS(1)=IDBFR(5)
          IF (ICDS(1) .EQ. 0) THEN
            ICDS(1)=1
            NTYP=7
            CALL ZVGC01 (ICDS(1))
          ENDIF
          NC=1
          NTRY=24
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
C
C                            Setze koordinatensystem um ...
          DO  I=1,3
            URSAV(I)=UR(I,NS)
            UR(I,NS)=X(I,1)
          ENDDO
C                            ... fuehre die drehung aus ...
          IAIN(1)=IDBFR(4)
          AIN(2)=AIDBFR(3)
          NTYP=6
          ISKP(14)=1
          CALL ZVGC02
C                            ... und restore den ursprung.
          DO  I=1,3
            UR(I,NS)=URSAV(I)
          ENDDO
        ENDIF
        IF (IERR .NE. 0) GO TO 999
      ENDIF
C                            BF ?
C
      IF (IDBFR(8) .NE. 0) THEN
        NTYP=1
        CALL ZVFKTR
      ENDIF
C
      NTYP=4
      IF (IDBFR(7) .EQ. KDSTPU) NTYP=3
      CALL ZVMACR
      IF (IERR .NE. 0) GO TO 999
C
C                            OPT2 - BUFN 0,0
C
      IF (IDBFR(9) .NE. 0) THEN
        IAIN(1)=0
        IAIN(2)=0
        CALL UPLINF (AIN,31)
      ENDIF
C                            Soll noch ein Macro ausgefuehrt werden?
C
      IF (IDBFR(11) .GT. 0) THEN
        DO  I=1,20
          KARTE(I)=KDBLNK
        ENDDO
        I=1
        CALL KPNTOS (IDBFR(11),KARTE,I,0)
        KARTE(2)=KDSEMI
        KARPOI=0
        ISKP(68)=1
        GO TO 999
      ENDIF
C                            Warte jetzt auf input.
  235 CALL KPRDLN (NTIN,I)
      READ (RDLINE,'(20A4)') KARTE
      IAIN(1)=KARTE(1)
      CALL CNVTUP (IAIN,1,4)
      IF (IAIN(1) .EQ. KDBLNK) GO TO 230
      IF (IAIN(1) .EQ. KDNEUN) THEN
C
C                            Wechsele ins dreh-makro.
        DO  I=1,20
          KARTE(I)=KDBLNK
        ENDDO
        KARTE(1)=KDD
        KARTE(2)=IDBFR(7)
        KARTE(3)=KDSTRN
        KARTE(4)=KDNULL
        IF (IDBFR(9) .NE. 0) KARTE(4)=KDEINS
        KARPOI=0
        GO TO 999
      ENDIF
      IF (I1AIN(1) .EQ. KDM) THEN
        AIDBFR(3)=-AIDBFR(3)
        I1AIN(1)=I1AIN(2)
        I1AIN(2)=I1AIN(3)
        IF (IAIN(1) .EQ. KDBLNK) THEN
          IAIN(2)=IDBFR(4)
          I=2
          GO TO 240
        ENDIF
      ENDIF
      DO  I=1,3
        IF (I1AIN(I) .GE. KD0 .AND. I1AIN(I) .LE. KD9) THEN
          IAIN(I+1)=I1AIN(I)-KD0
        ELSE
          GO TO 240
        ENDIF
      ENDDO
      IDBFR(2)=(IAIN(2)*10+IAIN(3))*10+IAIN(4)
      DO  I=1,3
        IAKT(I)=IAIN(I+1)-5
      ENDDO
C                            Streiche optional das drehen.
C
      IF (IDBFR(10) .EQ. 0) IDBFR(4)=0
      GO TO 230
  240 IF (I .EQ. 2) THEN
        IF (IAIN(2) .GT. 4) GO TO 250
        IDBFR(4)=IAIN(2)
C
C                            Streiche optional das verschieben.
C
        IF (IDBFR(10) .EQ. 0) THEN
          IDBFR(2)=555
          DO  I=1,3
            IAKT(I)=0
          ENDDO
        ENDIF
        GO TO 230
      ENDIF
  250 CONTINUE
      KARPOI=0
      go to 999
C                            AFG - Affine gruppe.
C
  260 AIM(3)=CONST(38)
      CALL FLES (IAIM,ISKP(31),4H2IAE,11Hn1,n2,opt?$)
      CALL CNVTUP(IAIM(3),1,4)
      IF (IAIM(1) .LE. 0 .OR. IAIM(2) .GT. NAT(NS) .OR.
     +  IAIM(1) .GT. IAIM(2)) THEN
        IERR=75 0594 16
        GO TO 999
      ENDIF
C                            Initialisiere
      DO  J=1,4
        DO  K=1,4
          E(K,J)=0.
        ENDDO
        DO  I=1,3
          EE(J,I)=0.
        ENDDO
      ENDDO
C                            Durchlaufe die mausliste
      II=1
  270   ntyp=7
        ICDS(1)=II
        CALL ZVGC01 (ICDS(1))
        IF (ICDS(1) .EQ. 0) GO TO 280
        ICDS(2)=II+1
        CALL ZVGC01 (ICDS(2))
        IF (ICDS(2) .EQ. 0) GO TO 280
        NTRY=24
        DO  NC=1,2
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
        ENDDO
        DO  I=1,3
          G1(I)=X(I,1)
          G2(I)=X(I,2)
        ENDDO
        G1(4)=1.
        DO  J=1,4
          DO  K=1,4
            E(K,J)=E(K,J)+G1(K)*G1(J)
          ENDDO
          DO  K=1,3
            EE(J,K)=EE(J,K)+G1(J)*G2(K)
          ENDDO
        ENDDO
      II=II+2
      go to 270
  280 IF (II .LT. 9) THEN
        IERR=75 0636 16
        GO TO 999
      ENDIF
  290 CALL LUDCMP (E,4,4,X(1,3),X(2,4))
      IF (ABS(X(2,4)) .LT. 1.E-6) THEN
        WRITE (WRLINE,'(A,E12.5)')
CYENG1
     +  'ZVGC030643 - Determinante',X(2,4)
CYENG2
CYENGY     +  'ZVGC030643 - Determinant',X(2,4)
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      DO  I=1,3
        CALL LUBKSB (E,4,4,X(1,3),EE(1,I))
      ENDDO
      IF (ISKP(58) .GT. 0) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'Affine Abbildung:'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'Affine mapping:'
        CALL KPWRTE (NTDISP)
        DO  J=1,3
          WRITE (WRLINE,'(4F12.4)') (EE(I,J),I=1,4)
          CALL KPWRTE (NTDISP)
        ENDDO
      ENDIF
C                            Fuehre abbildung aus.
      DO  II=IAIM(1),IAIM(2)
        DO  I=1,3
          T(I)=EE(1,I)*AT(1,II,NS)+EE(2,I)*AT(2,II,NS)+
     +    EE(3,I)*AT(3,II,NS)+EE(4,I)
        ENDDO
        IF (IAIM(3) .EQ. KDR) THEN
          DO  I=1,3
            AT(I,II,NS)=T(I)
          ENDDO
        ELSE
          IF (NAT(NS) .LT. NATDM) THEN
            NAT(NS)=NAT(NS)+1
            DO  I=1,3
              AT(I,NAT(NS),NS)=T(I)
              AT(I+3,NAT(NS),NS)=AT(I+3,II,NS)
            ENDDO
            ICLRP(NAT(NS),NS)=ICLRP(II,NS)
            IPFLG(NAT(NS),NS)=0
          ELSE
            IERR=75 0684 02
            GO TO 999
          ENDIF
        ENDIF
      ENDDO
      IF (NTYPS .NE. 9 .OR. IAIM(3) .NE. KDR) GO TO 999
C
C                            Berechne noch den RMS-wert.
      L=0
      C=0.
      DO  II=IAIM(1),IAIM(2)
        I=ITCDS(1,II)
        IF (I .GT. 0) THEN
          L=L+1
          ICDS(1)=II
          ICDS(2)=I
          NTRY=26
          DO  NC=1,2
            CALL ZVDEK
            IF (IERR .NE. 0) GO TO 999
            IF (NC .EQ. 1) THEN
              DO  I=1,3
                X2(I)=X1(I)
              ENDDO
            ENDIF
          ENDDO
          C=C+(X1(1)-X2(1))**2+(X1(2)-X2(2))**2+(X1(3)-X2(3))**2
        ENDIF
      ENDDO
      C=SQRT(C/FLOAT(L))
CYENG1
      WRITE (WRLINE,'(A,F10.5)') 'RMS-Wert:',C
CYENG2
CYENGY      WRITE (WRLINE,'(A,F10.5)') 'RMS value:',C
      CALL KPWRTE (NTOUT)
      GO TO 999
c                            AFGC - Affine gruppe vollstaendig
  300 IAINC(11)=0
      AINC(9)=CONST(38)
      CALL FLES (IAINC,ISKP(31),8H4I2F2IAE,
     + 31Hu1,u2,z1,z2,d,dinc,nz,opt,A/R?$)
      IF (IAINC(1) .LE. 0 .OR. IAINC(2) .GT. NAT(NS) .OR.
     +  IAINC(1) .GT. IAINC(2) .OR.
     +  IAINC(3) .LE. 0 .OR. IAINC(4) .GT. NAT(NS) .OR.
     +  IAINC(3) .GT. IAINC(4)) THEN
        IERR=75 0699 16
        GO TO 999
      ENDIF
      CALL CNVTUP (IAINC(9),1,4)
      AINC(10)=AINC(5)
C                            Initialisiere ...
      DO  J=1,4
        DO  K=1,4
          E(K,J)=0.
        ENDDO
        DO  I=1,3
          EE(J,I)=0.
        ENDDO
      ENDDO
C                            ... und loesche bereich fuer codes.
      DO  I=IAINC(1),IAINC(2)
        ITCDS(1,I)=0
      ENDDO
C                            Durchlaufe die liste.
      K9(NS)=0
      ICBMRK=NCD(NS)
      NCDA(NS)=ICBMRK+1
      L=0
      IF (IAINC(8) .GT. 0) L=IAINC(8)
  310 M=0
      DO  I=IAINC(1),IAINC(2)
        IF (ITCDS(1,I) .EQ. 0) THEN
          M=M+1
          ICDS(1)=I
          ISYMB(1)=IAT(5,I,NS)
          CALL CNVTUP (ISYMB,1,4)
          IZ1=IAINC(3)
          IZ2=IAINC(4)
          DQ=AINC(10)
          CONST(20)=0.
          NTYP=3
          ISKP(14)=1
C                            AKS
          CALL ZVAVBR
          IF (IERR .NE. 0) GO TO 340
C
C                            Etwas gefunden?
C
          IF (NCD(NS)-ICBMRK .GT. 0) THEN
            DO  IC=ICBMRK+1,NCD(NS)
              IF (IAINC(8) .NE. 0) THEN
                ISYMB(2)=IAT(5,ICD(IC,NS)/200000,NS)
                CALL CNVTUP (ISYMB,5,4)
                IF (ISYMB(1) .NE. ISYMB(2)) GO TO 315
              ENDIF
              DO  J=IAINC(1),IAINC(2)
                IF (ITCDS(1,J) .EQ. ICD(IC,NS)) GO TO 315
              ENDDO
              ITCDS(1,I)=ICD(IC,NS)
              M=M-1
              GO TO 320
  315         CONTINUE
            ENDDO
          ENDIF
  320     CONTINUE
          NCD(NS)=ICBMRK
        ENDIF
      ENDDO
      IF (M .GT. L) THEN
        AINC(10)=AINC(10)+AINC(6)
        IAINC(11)=IAINC(11)+1
        IF (IAINC(11) .LT. IAINC(7)) GO TO 310
        WRITE (WRLINE,'(A,I4)')
CYENG1
     +   'ZVGC030768 - Liste unvollstaendig.'
CYENG2
CYENGY     +   'ZVGC030768 - List incomplete.'
        CALL KPWRTE (NTOUT)
        IERR=-1
        GO TO 340
      ENDIF
C                            Durchlaufe jetzt die liste.
      II=IAINC(1)
  330   ICDS(1)=II
        ICDS(2)=ITCDS(1,II)
        IF (ICDS(2) .GT. 0) THEN
          NTRY=24
          DO  NC=1,2
            CALL ZVDEK
            IF (IERR .NE. 0) GO TO 340
          ENDDO
          DO  I=1,3
            G1(I)=X(I,1)
            G2(I)=X(I,2)
          ENDDO
          G1(4)=1.
          DO  J=1,4
            DO  K=1,4
              E(K,J)=E(K,J)+G1(K)*G1(J)
            ENDDO
            DO  K=1,3
              EE(J,K)=EE(J,K)+G1(J)*G2(K)
            ENDDO
          ENDDO
        ENDIF
      II=II+1
      IF (II .LE. IAINC(2)) GO TO 330
      IF (IAINC(2)-IAINC(1) .LT. 3) THEN
        IERR=75 0802 16
        GO TO 340
      ENDIF
  340 NCDA(NS)=1
      K8(NS)=0
      K9(NS)=0
      IF (IERR .NE. 0) GO TO 999
      IAIM(1)=IAINC(1)
      IAIM(2)=IAINC(2)
      IAIM(3)=IAINC(9)
      GO TO 290
C
  999 RETURN
      END
