C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         84              -------------------
                           SUBROUTINE ZVGC04
C  CY-ENG-                -------------------
C
C  NTYP=1  FDGC - Faktor direkt auf gruppe von codes
C  NTYP=2  FRGC - Faktor reziprok auf gruppe von codes
C  NTYP=3  FLGC - Force length for group of codes
C  NTYP=4  SEL  - Selektiere bestimmte symmetrien
C  NTYP=5  VGDP - Verschiebe gruppe gemaess dreier punkte
C  NTYP=6  PVOL - Volumen eines polyeders
C  NTYP=7  (YCR)  - frei
C  NTYP=8  TGL  - Teste gleiche lagebesetzung
C  NTYP=9  WSU  - Wigner-Seitz umgebung
C
C                geschrieben: 181513 MAR 1999  (Hundt)
C                  geaendert: 221525 APR 2008  (Hundt)
C
C                         -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
      INTEGER *4 ISBEG,ISEND,ISPOI,IAIN(72)
      PARAMETER (ISEND=6*PARDIM)
      INTEGER *4 NTYPS,INBFR(6),I,IM,J,K,ISTACK(ISEND),M,N,KDR,NATSV
      INTEGER *4 ICBUF(26),ISADR,IEADR,IPOI,LEN,NANZ,IRLINE(30)
      INTEGER *4 NCDSV,NCDASV,K8SV,IVON,INACH,IN1,IFLAG,IA,IE,j4
      integer *4 iaim(8),nats,inr,iadr,ibua
      REAL    *4 AINBFR(6),PZ(3),D,TEMP,V(3),F,A(3,3,2),B(3,3),TR(3,2)
      REAL    *4 AICBUF(26),SUM,GSUM,aim(8),cds(7),ebnam,c,x0(3),temp2
      SAVE ICBUF
      EQUIVALENCE (AIN(1),IAIN(1)),(ICBUF(1),AICBUF(1))
      EQUIVALENCE (INBFR(1),AINBFR(1)),(AT(1,1,1),ISTACK(1))
      EQUIVALENCE (WRLINE,IRLINE(1)),(aim(1),iaim(1)),(icds(1),cds(1))
      DATA KDR/4HR   /,ebnam/4hGEBN/,ibua/4hA   /
C
      IF (NTYP .EQ. 9) GO TO 130
      IF (NTYP .EQ. 6) GO TO 90
      IF (NTYP .EQ. 8) GO TO 80
      IF (NTYP .EQ. 5) GO TO 70
      IF (NTYP .EQ. 4) THEN
C                            SEL
C
        CALL FLES (IAIN,ISKP(31),4H48IE,11Hs1,s2,...?$)
        DO  I=1,NSYM(NS)
C                            Wird diese Symmetrie erwaehnt?
          DO  J=1,ISKP(31)
            IF (I .EQ. IAIN(J)) GO TO 10
          ENDDO
C                            Flag to delete.
          SYM(1,I,NS)=10.
   10     CONTINUE
        ENDDO
        J=0
        DO  I=1,NSYM(NS)
          IF (SYM(1,I,NS) .LT. 10.) THEN
            J=J+1
            DO  K=1,12
              SYM(K,J,NS)=SYM(K,I,NS)
            ENDDO
          ENDIF
        ENDDO
        NSYM(NS)=J
        NHMSNR(3,NS)=0
        GO TO 999
      ENDIF
C                            FDGC, FRGC UND FLGC
      ISBEG=8*NAT(NS)+1
      ISPOI=ISBEG-1
      NTYPS=NTYP
      INBFR(1)=0
      AINBFR(2)=CONST(5)
      CALL FLES (INBFR,ISKP(31),3HCFE,6Hc,f? $)
      IF (AINBFR(2) .EQ. 0.) THEN
        IERR=84 0090 16
        GO TO 999
      ENDIF
      IF (INBFR(1) .EQ. 0) THEN
        INBFR(1)=1
        NTYP=7
        CALL ZVGC01 (INBFR)
      ENDIF
      ICDS(1)=INBFR(1)
      NC=1
      NTRY=28
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        PZ(I)=X2(I)
      ENDDO
      IF (NTYPS-2) 20,30,40
   20   F=AINBFR(2)-1.
        GO TO 40
   30   F=1./AINBFR(2)-1.
   40 CONTINUE
C                            Durchlaufe die mausliste
      IM=1
      NC=2
   50 ICDS(2)=IM
      NTYP=7
      CALL ZVGC01 (ICDS(2))
      IF (ICDS(2) .EQ. 0) GO TO 999
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
C
C                            Hatten wir dieses atom schon?
      DO  I=ISBEG,ISPOI
        IF (ISTACK(I) .EQ. IANR) GO TO 60
      ENDDO
      IF (ISPOI .LT. ISEND) THEN
        ISPOI=ISPOI+1
        ISTACK(ISPOI)=IANR
      ELSE
        IERR=84 0129 20
        GO TO 999
      ENDIF
C                            Berechne abstand.
      D=0.
      DO  I=1,3
        TEMP=X2(I)-PZ(I)
        D=D+TEMP*TEMP
        V(I)=TEMP
      ENDDO
      IF (D .GT. 0.) THEN
        D=SQRT(D)
        IF (NTYPS .EQ. 3) F=AINBFR(2)/D-1.
C
C                            Berechne vektor ...
        DO  I=1,3
          X1(I)=V(I)*F
        ENDDO
C                            ... und diesen im triklinen system.
        DO  I=1,3
          T(I)=TRAINV(I,1,NS)*X1(1)+TRAINV(I,2,NS)*X1(2)+
     +    TRAINV(I,3,NS)*X1(3)
        ENDDO
C                            Invertiere symmetriematrix
        DO  J=1,3
          S(1,J)=SYM(J+1,ISYNR,NS)
          S(2,J)=SYM(J+5,ISYNR,NS)
          S(3,J)=SYM(J+9,ISYNR,NS)
        ENDDO
        CALL MINV (S,3,D,AIN(1),AIN(4))
        IF (D .EQ. 0.) THEN
          WRITE (WRLINE,'(A,A,I3,A)') 'ZVGC040101 - ',
CYENG1
     +    'Symmetrie',ISYNR,' fehlerhaft.'
CYENG2
CYENGY     +    'Error in symmetry',ISYNR,'.'
          CALL KPWRTE (NTDISP)
          IERR=-1
          GO TO 999
        ENDIF
C                            Ueberschreibe originalkoordinaten.
        DO  I=1,3
          AT(I,IANR,NS)=AT(I,IANR,NS)+S(I,1)*T(1)+
     +    S(I,2)*T(2)+S(I,3)*T(3)
        ENDDO
      ENDIF
   60 IM=IM+1
      GO TO 50
C                             VGDP - Verschiebe gruppe gemaess
C                             dreier punkte.
C
   70 IF (ISKP(14) .EQ. 0) THEN
        DO  I=1,8
          IAIN(I)=0
        ENDDO
        AIN(9)=CONST(38)
        CALL FLES (IAIN,ISKP(31),6H6C2IAE,20Hc1,..,c6,n1,n2,opt?$)
      ENDIF
      ISKP(14)=0
      IF (IAIN(7) .LE. 0 .OR. IAIN(8) .GT. NAT(NS) .OR.
     +  IAIN(7) .GT. IAIN(8)) THEN
        IERR=84 0186 16
        GO TO 999
      ENDIF
      CALL CNVTUP (IAIN(9),1,4)
      DO  I=1,3
        TR(I,1)=0.
        TR(I,2)=0.
      ENDDO
      N=1
      NC=1
      NTRY=26
      DO  I=1,6
        ICDS(NC)=IAIN(I)
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=I
          NTYP=7
          CALL ZVGC01(ICDS(NC))
        ENDIF
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  J=1,3
          TR(J,N)=TR(J,N)+X(J,NC)
          X(J,NC)=X1(J)
        ENDDO
        IF (NC .LT. 4) THEN
          N=2
          NC=NC+3
        ELSE
          N=1
          NC=NC-2
        ENDIF
      ENDDO
C                         Orthogonalisiere matrices.
      N=0
      DO  M=1,2
        DO  I=1,3
          A(1,I,M)=X(I,N+2)-X(I,N+1)
          X1(I)=X(I,N+3)-X(I,N+1)
          TR(I,M)=TR(I,M)/3.
        ENDDO
        DO  I=1,3
          J=ID2(I)
          K=ID2(J)
          A(3,I,M)=A(1,J,M)*X1(K)-A(1,K,M)*X1(J)
          X2(I)=0.
        ENDDO
        DO  I=1,3
          J=ID2(I)
          K=ID2(J)
          A(2,I,M)=A(3,J,M)*A(1,K,M)-A(3,K,M)*A(1,J,M)
          DO  J=1,3
            X2(J)=A(J,I,M)**2+X2(J)
          ENDDO
        ENDDO
C                         Normiere
        DO  I=1,3
          TEMP=SQRT(X2(I))
          IF (TEMP .LE. 0.) THEN
            IERR=84 0244 06
            GO TO 999
          ENDIF
          DO  J=1,3
            A(I,J,M)=A(I,J,M)/TEMP
          ENDDO
        ENDDO
        N=3
      ENDDO
C                       "TRA" und "TRAINV"
      DO  I=1,3
        DO  J=1,3
          S(I,J)=A(I,1,1)*DG(1,J,NS)+A(I,2,1)*DG(2,J,NS)+
     +    A(I,3,1)*DG(3,J,NS)
          X(J,I)=A(I,1,2)*RG(1,J,NS)+A(I,2,2)*RG(2,J,NS)+
     +    A(I,3,2)*RG(3,J,NS)
        ENDDO
      ENDDO
C                       Multipliziere die beiden matrices miteinander.
      DO  I=1,3
        DO  J=1,3
          B(J,I)=X(J,1)*S(1,I)+X(J,2)*S(2,I)+X(J,3)*S(3,I)
        ENDDO
      ENDDO
C                       Berechne gedrehten schwerpunkt.
      DO  I=1,3
        T(I)=B(I,1)*TR(1,1)+B(I,2)*TR(2,1)+B(I,3)*TR(3,1)
      ENDDO
      DO  I=1,3
        TR(I,1)=TR(I,2)-T(I)
      ENDDO
      IF (ISKP(58) .GT. 0) THEN
        DO  I=1,3
          WRITE (WRLINE,'(3F10.5,3X,F10.5)') (B(I,J),J=1,3),TR(I,1)
          CALL KPWRTE (NTOUT)
        ENDDO
      ENDIF
C                       Kopiere gedrehte atome
C
      NATSV=NAT(NS)
      IF (IAIN(9) .EQ. KDR) NAT(NS)=IAIN(7)-1
      DO  I=IAIN(7),IAIN(8)
        DO  J=1,3
          T(J)=B(J,1)*AT(1,I,NS)+B(J,2)*AT(2,I,NS)+
     +    B(J,3)*AT(3,I,NS)+TR(J,1)
        ENDDO
        IF (NAT(NS) .LT. NATDM) THEN
          NAT(NS)=NAT(NS)+1
          DO  J=1,3
            AT(J,NAT(NS),NS)=T(J)
            AT(J+3,NAT(NS),NS)=AT(J+3,I,NS)
          ENDDO
          ICLRP(NAT(NS),NS)=ICLRP(I,NS)
          IPFLG(NAT(NS),NS)=0
        ELSE
          IERR=84 0296 02
          GO TO 999
        ENDIF
      ENDDO
      IF (NATSV .GT. NAT(NS)) NAT(NS)=NATSV
      GO TO 999
C                            TGL - Teste gleiche lagebesetzung
   80 INBFR(1)=ISKP(53)
      INBFR(2)=NAT(NS)
      INBFR(3)=ISKP(53)
      INBFR(4)=NAT(NS)
      AINBFR(5)=0.0001
      INBFR(6)=0
      CALL FLES (INBFR,ISKP(31),5H4IFIE,21Hu1,u2,z1,z2,tol,opt?$)
      IF (INBFR(1) .LE. 0 .OR. INBFR(3) .LE. 0 .OR.
     + INBFR(2) .GT. NAT(NS) .OR. INBFR(4) .GT. NAT(NS)) THEN
        IERR=84 0465 16
        GO TO 999
      ENDIF
      IFLAG=0
      IF (INBFR(1) .EQ. INBFR(3) .AND. INBFR(2) .EQ. INBFR(4)) IFLAG=1
C
C                            Save pointer
      NCDSV=NCD(NS)
      NCDASV=NCDA(NS)
      NCDA(NS)=NCD(NS)+1
      K8SV=K8(NS)
C                            (Naechstes) ursprungsatom.
C
      DO  IVON=INBFR(1),INBFR(2)
        K8(NS)=K8SV
C                            Naechstes zielatom.
C
        IN1=IVON+1
        IF (IFLAG .EQ. 0) IN1=INBFR(3)
        DO  INACH=IN1,INBFR(4)
          IF (IVON .NE. INACH) THEN
C
C                          Setze ein AKS auf.
            ICDS(1)=IVON
            IZ1=INACH
            IZ2=INACH
            DQ=AINBFR(5)
            CONST(20)=0.
            NTYP=3
            ISKP(14)=1
            CALL ZVAVBR
            IF (IERR .NE. 0) GO TO 990
            IF (NCD(NS)-NCDA(NS) .GE. 0) THEN
              WRITE (WRLINE,'(I4,A,2A4,A,I4,A,2A4)')
     +        IVON,': ',AT(5,IVON,NS),AT(6,IVON,NS),' == ',
     +        INACH,': ',AT(5,INACH,NS),AT(6,INACH,NS)
              CALL KPWRTE (NTOUT)
              IF (INBFR(6) .NE. 0) ISKP(76)=1
              NCD(NS)=NCDA(NS)-1
            ENDIF
          ENDIF
        ENDDO
      ENDDO
      GO TO 990
C                            PVOL - Polyedervolumen
   90 ICDS(1)=2
      CALL FLES (ICDS,ISKP(31),2HCE,4Hcz?$)
      NC=1
      NTRY=26
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        X(I,1)=X1(I)
      ENDDO
C
      GSUM=0.
      IPOI=1
      NANZ=0
      GO TO 120
  100 NANZ=IPK(IPOI,NS)
      IF (IPK(IPOI+1,NS) .LT. 12 .OR. IPK(IPOI+1,NS) .GT. 14) GO TO 120
      ISADR=IPOI+7
      DO  I=1,100
        IF (IPK(ISADR+I,NS) .EQ. 0) THEN
          IEADR=ISADR+I-2
          GO TO 110
        ENDIF
      ENDDO
  110 LEN=IEADR-ISADR
      IF (LEN .LT. 3) GO TO 120
C
C                            Durchlaufe die ecken.
      ICDS(2)=IPK(ISADR+1,NS)
      DO  I=3,LEN
        ICDS(3)=IPK(ISADR+I-1,NS)
        ICDS(4)=IPK(ISADR+I,NS)
        DO  NC=2,4
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
          DO  J=1,3
            X(J,NC)=X1(J)
          ENDDO
        ENDDO
        DO  J=1,3
          X(J,5)=X(J,2)-X(J,3)
          X(J,6)=X(J,4)-X(J,3)
          X(J,7)=X(J,1)-X(J,3)
        ENDDO
C                            Berechne das spatprodukt.
        SUM=0.
        DO  M=1,3
          J=ID2(M)
          K=ID2(J)
          SUM=SUM+(X(J,5)*X(K,6)-X(K,5)*X(J,6))*X(M,7)
        ENDDO
        GSUM=GSUM+ABS(SUM)
      ENDDO
  120 IPOI=IPOI+NANZ
      IF (IPOI .LT. IPKP(NS)) GO TO 100
      GSUM=GSUM/6.
      WRITE (WRLINE,'(A,F12.4,A)')
CYENG1
     + 'Volumen:',GSUM,' A**3'
CYENG2
CYENGY     + 'Volume:',GSUM,' A**3'
      CALL KPWRTE (NTOUT)
      GO TO 999
C                            WSU - Wigner-Seitz umgebung
  130 CONTINUE
      NATSV=NAT(NS)
      IAIM(1)=ISKP(53)
      IAIM(2)=NAT(NS)
      IAIM(3)=ISKP(53)
      IAIM(4)=NAT(NS)
      AIM(5)=3.
      AIM(6)=0.
      aim(7)=0.001
      aim(8)=0.3
      CALL FLES (IAIM,ISKP(31),5H4I4FE,
     +33Hu1,u2,z1,z2,dmax,dmin,tolg,tola?$)
      IF (AIM(5) .LT. AIM(6)) THEN
        TEMP=AIM(5)
        AIM(5)=AIM(6)
        AIM(6)=TEMP
      ENDIF
      DO  M=IAIM(1),IAIM(2)
        NAT(NS)=NATSV
        NCD(NS)=1
        ICD(1,NS)=M*200000+111001
        K8(NS)=0
        K9(NS)=0
C                          Setze ein AKS auf.
        ICDS(1)=M   
        IZ1=IAIM(3)
        IZ2=IAIM(4)
        DQ=AIM(5)
        CONST(20)=AIM(6)
        NTYP=3
        ISKP(14)=1
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 999
C
C                            Generiere ebenen (ENP).
        ISKP(33)=1
        DO  I=2,NCD(NS)
          ICDS(1)=ICD(1,NS)
          ICDS(2)=ICD(I,NS)
          CDS(3)=0.
          J=ICD(I,NS)/200000
          CDS(4)=AT(5,J,NS)
          CDS(5)=AT(6,J,NS)
          ICDS(6)=NAT(NS)+1
          ISKP(14)=1
          NTYP=15
          CALL ZVEHND
          IF (IERR .NE. 0) GO TO 999
          AT(7,NAT(NS),NS)=EBNAM
        ENDDO
C                            Berechne Ebenenschnittpunkte (GESP)
        IAIN(1)=M
        IAIN(2)=NATSV+1
        IAIN(3)=NAT(NS)
        AIN(4)=AIM(7)
        ISKP(14)=1
        NTYP=7
        CALL ZVEHND
        IF (IERR .NE. 0) GO TO 999
C
C                            Generiere plotkommandos (GPOL).
        IAIN(1)=ISKP(64)
        IAIN(2)=NAT(NS)
        WRITE (WRLINE,'(A,I5,3F10.6,A,2I5)') 
CYENG1
     +  'Ursprung:',M,(AT(I,M,NS),I=1,3),'   Flaeche',IAIN(1),IAIN(2)
CYENG2
CYENGY     +  'Origin:  ',M,(AT(I,M,NS),I=1,3),'      Area',IAIN(1),IAIN(2)
        CALL KPWRTE (NTOUT )
        AIN(3)=AIM(7)
        IAIN(4)=-1
        IAIN(5)=-1
        IAIN(6)=0
        IAIN(7)=0
        ISKP(14)=1
        NTYP=1
        CALL ZVPYER
        IF (IERR .NE. 0) GO TO 999
        NCD(NS)=0
        K8(NS)=0
        K9(NS)=0
C                            Save koordinatensystem
        NTYP=19
        CALL ZVK
C                            Schleife ueber die plotbefehle.
        NATS=NAT(NS)
        INR=0
        IADR=1
  140   INR=INR+1
        IF (IADR .GT. IPKP(NS)) GO TO 180
C
C                            Handelt es sich um einen VD-Befehl?
C
        IF (IPK(IADR+1,NS) .EQ. 12) THEN
C
C                            Erzeuge neue atome.
C
          NAT(NS)=NATS
          NC=1
          NTRY=24
          IPOI=9
  150     ICDS(1)=IPK(IADR+IPOI,NS)
          IF (ICDS(1) .EQ. 0) GO TO 160
          IF (NAT(NS) .LT. NATDM) THEN
            NAT(NS)=NAT(NS)+1
            CALL ZVDEK
            DO  J=1,3
              AT(J,NAT(NS),NS)=X(J,1)
            ENDDO
            AT(4,NAT(NS),NS)=0.3
          ELSE
            IERR=75 0167 02
            GO TO 180
          ENDIF
          IPOI=IPOI+1
          GO TO 150
C
  160     ISKP(14)=1
          NTYP=1
          IAIN(1)=NATS+1
          IAIN(2)=NAT(NS)
          CALL ZVEFIT
          IF (IERR .NE. 0) GO TO 999
          TEMP=0.
          DO  I=1,3
            X2(I)=TRA(3,I,NS)
            TEMP=TEMP+X2(I)**2
          ENDDO
          TEMP=SQRT(TEMP)
          C=TRA(3,1,NS)*UR(1,NS)+TRA(3,2,NS)*UR(2,NS)+
     +    TRA(3,3,NS)*UR(3,NS)
          DO  I=1,3
            X2(I)=X2(I)/TEMP
          ENDDO
C
          IF (C .LT. 0) THEN
            DO  I=1,3
              X2(I)=-X2(I)
            ENDDO
            C=-C
          ENDIF
C                            'Ebene:',x2,c
          IAIN(1)=M
          IAIN(2)=M
          IAIN(3)=3
          IAIN(4)=IBUA
          ISKP(14)=1
          NTYP=10
C                            Fuehre SPG aus
          CALL ZVGE01
C                            Setze ein AKS auf.
          ICDS(1)=NAT(NS)               
          IZ1=IAIM(3)
          IZ2=IAIM(4)                  
          DQ=AIM(8)                  
          CONST(20)=0.                  
          NTYP=3                        
          ISKP(14)=1                    
          I=NCD(NS)
          CALL ZVAVBR
          IF (IERR .NE. 0) GO TO 999
          NAT(NS)=NAT(NS)-1
          IF (I+1 .NE. NCD(NS)) THEN
          WRITE (WRLINE,'(A,I3)') 
CYENG1
     +      'Falsche Zahl an Umgebungsatomen:',NCD(NS)-I
CYENG2
CYENGY     +      'Wrong number of surr. atoms:',NCD(NS)-I
            CALL KPWRTE (NTOUT )
          ENDIF
C                            Berechne fl�che des polygons.
          NTRY=26
          NC=1
          ICDS(1)=NATS+1
          CALL ZVDEK
          DO  I=1,3
            X0(I)=X1(I)
          ENDDO
          NC=2
          ICDS(2)=NATS+2
          CALL ZVDEK
          DO  I=1,3
            X2(I)=X1(I)-X0(I)
          ENDDO
          NC=3
          TEMP2=0.
          DO  IC=NATS+3,NAT(NS)
            ICDS(3)=IC
            CALL ZVDEK
            DO  I=1,3
              X1(I)=X1(I)-X0(I)
            ENDDO
            TEMP=0.
            DO  J=1,3
              K=ID2(J)
              TEMP=TEMP+(X1(J)*X2(K)-X1(K)*X2(J))**2
            ENDDO
            TEMP2=TEMP2+SQRT(TEMP)
            DO  I=1,3
              X2(I)=X1(I)
            ENDDO
          ENDDO
          TEMP2=TEMP2/2.
          WRITE (WRLINE,'(I4,10X,3F10.6,F10.2)')
     +    NCD(NS),(ATOMS(I,NCD(NS),NS),I=1,3),TEMP2
          CALL KPCDST (IRLINE,5,ICD(NCD(NS),NS))
          CALL KPWRTE (NTOUT )
        ENDIF
        IADR=IADR+IPK(IADR,NS)
        GO TO 140
C                            Aufraeumen.
  180   NAT(NS)=NATS
        ISKP(14)=0
C                            Restore Koordinatensystem.
        NTYP=20
        CALL ZVK
C
      ENDDO
      NAT(NS)=NATSV
      GO TO 999
C                            Restore
  990 NCD(NS)=NCDSV
      NCDA(NS)=NCDASV
      K8(NS)=K8SV
      ISKP(14)=0
  999 RETURN
      END
