C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         95              -------------------
                           SUBROUTINE ZVGC05
C                         -------------------
C
C                     Anwendung der normalisatoren
C  ntyp=1 CNRM - Kopiere symmetrieliste der aktuellen struktur.
C       2 ONRM - Liste normalisatoren.
C       3 TNRM - Wende eine normalisatorsymmetrie an.
C
C       4 VZDP - Verschiebe zelle gemaess dreier Punkte.
C       5 DZV  - Drehe zelle um einen vektor.
C       6 VZ   - Verschiebe zelle um einen vektor (A)
C       7 VZV  - Verschiebe zelle um einen vektor (Vektorlaenge)
C       8 VDZ  - Verschiebe und drehe zelle (makro)
C       9      - wie 4 aber ohne input.
C
C                  Geschrieben: 291702 MAR 2004  (Hundt)
C                    Geaendert: 191518 MAY 2005  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
      INTEGER *4 NSDIM
      PARAMETER (NSDIM=24)
C
      INTEGER *4 I,J,K,IRLINE(30),NSPOI,KEYIN,NSSV,INBUF(4),INDZV(3)
      INTEGER *4 INVZ(3),INVDZ(8),IACTN,iacbuf(9),KDEPU,STDIN
C
      REAL    *4 SYMN(12,NSDIM),TEMP,V(3,3),SP(3,2),AINDZV(3),AINVZ(3)
      REAL    *4 TEMP2,AINVDZ(8),SK(3,10)
C
      SAVE SYMN,NSPOI,INDZV,INVZ,INVDZ
C
      EQUIVALENCE (WRLINE,IRLINE(1)),(INDZV(1),AINDZV(1))
      EQUIVALENCE (INVZ(1),AINVZ(1)),(INVDZ(1),AINVDZ(1))
C
      DATA NSPOI/0/,INBUF/4*0/,AINVDZ(1)/0./,AINVDZ(2)/0./
      DATA INVDZ(3)/4HSTPU/,INVDZ(4)/1/,INVDZ(5)/1/,INVDZ(6)/331001/
      DATA INVDZ(7)/0/,INVDZ(8)/0/,KDEPU/4HEPU /,STDIN/5/
      DATA IACBUF/4H1   ,4H2   ,4H3   ,4H-1  ,4H-2  ,
     + 4H-3  ,4H-   ,4H+   ,4H    /
C
      NSSV=NS
      GO TO (10,20,30,40,50,70,70,80,45),NTYP
C             1  2  3  4  5  6  7  8  9
C
c                            Uebernimm symmetrien
C
   10 NSPOI=MIN(NSDIM,NSYM(NS))
      DO  J=1,NSPOI
        DO  I=1,12
          SYMN(I,J)=SYM(I,J,NS)
        ENDDO
      ENDDO
      IF (NSYM(NS) .GT. NSDIM) THEN
        IERR=95 0037 03
      ENDIF
      GO TO 999
C                            OS
   20 IF (NSPOI .LE. 0) THEN
C                            Keine Symmetrien.
        IERR=95 0043 05
        GO TO 990
      ENDIF
C
      WRITE (WRLINE,'(A)')
CYENG1
     + 'Normalisatoren:'
CYENG2
CYENGY     + 'Normalizors:'
      CALL KPWRTE (NTOUT)
      WRLINE=' Nr ---------X---------  ---------Y---------  ---------Z--
     1-------'
      CALL KPWRTE (NTOUT)
      DO  ISYNR=1,NSPOI
        WRITE (WRLINE,'(I3,3(F7.3,3F4.1,2X))')
     +  ISYNR,(SYMN(I,ISYNR),I=1,12)
        CALL KPWRTE (NTOUT)
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 990
        ENDIF
      ENDDO
      GO TO 990
C                            Fuehre transformation aus
C
   30 INBUF(1)=1
      INBUF(2)=ISKP(53)
      INBUF(4)=(ISKP(53)+NAT(NS)+1)/2
      INBUF(3)=INBUF(4)-1
      CALL FLES (INBUF,ISKP(31),3H4IE,15Hnsym,n1,n2,s1?$)
      IC=INBUF(4)-INBUF(2)
      IF (INBUF(2) .LE. 0 .OR. INBUF(3)+IC .GT. NAT(NS) .OR.
     +  IC .LE. 0) THEN
        IERR=95 0073 16
        GO TO 999
      ENDIF
      ISYNR=INBUF(1)
      DO  J=INBUF(2),INBUF(3)
        IANR=J+IC
        AT(1,J,NS)=SYMN(1,ISYNR)+SYMN( 2,ISYNR)*AT(1,IANR,NS)+
     +  SYMN( 3,ISYNR)*AT(2,IANR,NS)+SYMN( 4,ISYNR)*AT(3,IANR,NS)
        AT(2,J,NS)=SYMN(5,ISYNR)+SYMN( 6,ISYNR)*AT(1,IANR,NS)+
     +  SYMN( 7,ISYNR)*AT(2,IANR,NS)+SYMN( 8,ISYNR)*AT(3,IANR,NS)
        AT(3,J,NS)=SYMN(9,ISYNR)+SYMN(10,ISYNR)*AT(1,IANR,NS)+
     +  SYMN(11,ISYNR)*AT(2,IANR,NS)+SYMN(12,ISYNR)*AT(3,IANR,NS)
      ENDDO
      GO TO 999
C                            VZDP - Verschiebe zelle wie drei punkte.
   40 DO  I=1,6
        ICDS(I)=0
      ENDDO
      CALL FLES (ICDS,ISKP(31),3H6CE,20Hp1,p2,p3, q1,q2,q3?$)
C
C                            Berechne vektoren ...
   45 NTRY=26
      DO  J=1,2
        DO  I=1,3
          SP(I,J)=0.
        ENDDO
      ENDDO
      J=1
      DO  NC=1,6
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=NC
          NTYP=7
          CALL ZVGC01 (ICDS(NC))
        ENDIF
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  I=1,3
          SP(I,J)=SP(I,J)+X(I,NC)
          X(I,NC)=X1(I)
        ENDDO
        IF (NC .EQ. 3) THEN
          NS=3-NS
          J=2
        ENDIF
      ENDDO
      DO  I=1,3
        TEMP=X(I,2)-X(I,1)
        X(I,2)=X(I,3)-X(I,1)
        X(I,1)=TEMP
        TEMP=X(I,5)-X(I,4)
        X(I,5)=X(I,6)-X(I,4)
        X(I,4)=TEMP
        SP(I,1)=SP(I,1)/3.
        SP(I,2)=SP(I,2)/3.
      ENDDO
C                            ... orthogonalisiere ...
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        X(I,3)=X(J,1)*X(K,2)-X(K,1)*X(J,2)
        X(I,6)=X(J,4)*X(K,5)-X(K,4)*X(J,5)
      ENDDO
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        X(I,2)=X(J,3)*X(K,1)-X(K,3)*X(J,1)
        X(I,5)=X(J,6)*X(K,4)-X(K,6)*X(J,4)
      ENDDO
C                            ... und normiere.
      DO  NC=1,6
        TEMP=0.
        DO  I=1,3
          TEMP=TEMP+X(I,NC)**2
        ENDDO
        IF (TEMP .LT. 1.E-6) THEN
          IERR=95 0148 06
          GO TO 999
        ENDIF
        TEMP=SQRT(TEMP)
        DO  I=1,3
          X(I,NC)=X(I,NC)/TEMP
        ENDDO
      ENDDO
C                            Invertiere 2. matrix ...
C
      CALL MINV (X(1,4),3,TEMP,X1,X2)
      IF (ABS(TEMP) .LT. 1.E-6) THEN
        IERR=95 0160 06
        GO TO 999
      ENDIF
C                            ... und berechne transformationsmatrix.
      DO  I=1,3
        DO  J=1,3
          V(I,J)=X(I,1)*X(1,J+3)+X(I,2)*X(2,J+3)+X(I,3)*X(3,J+3)
        ENDDO
      ENDDO
C                            Definiere jetzt die fremde zelle neu.
      DO  I=1,3
        DO  J=1,3
          S(I,J)=V(I,1)*DG(1,J,NS)+V(I,2)*DG(2,J,NS)+V(I,3)*DG(3,J,NS)
        ENDDO
      ENDDO
      DO  I=1,3
        DO  J=1,3
          DG(J,I,NS)=V(J,I)
        ENDDO
      ENDDO
      ISKP(14)=1
      NTYP=20
      CALL ZVZ
      IF (IERR .NE. 0) GO TO 999
C
C                            Bestimme jetzt noch den ursprungspunkt.
      DO  I=1,3
        SP(I,1)=SP(I,1)-UR(I,NSSV)
      ENDDO
      DO  I=1,3
        X1(I)=DG(I,1,NSSV)*SP(1,1)+DG(I,2,NSSV)*SP(2,1)+
     +  DG(I,3,NSSV)*SP(3,1)
      ENDDO
      DO  I=1,3
        UR(I,NS)=-RG(1,I,NS)*X1(1)-RG(2,I,NS)*X1(2)-
     +  RG(3,I,NS)*X1(3)+SP(I,2)
      ENDDO
      GO TO 999
C                            DZV - Drehe zelle um vektor
   50 CONTINUE
      if (iskp(14) .eq. 0) then
        CALL FLES (INDZV,ISKP(31),4H2CFE,9Hc1,c2,w?$)
      else
        do  i=1,3
          aindzv(i)=ain(i)
        enddo
        iskp(14)=0
      endif
      IACTN=0
C                            Save Koordinatensystem ...
   55 DO  I=1,3
        DO  J=1,3
          SK(J,I)=TRA(J,I,NS)
          SK(J,I+3)=TRAINV(J,I,NS)
          SK(J,I+6)=DREH(J,I)
        ENDDO
        SK(I,10)=UR(I,NS)
      ENDDO
C                            ... und baue neues auf.
      ICDS(1)=2
      ICDS(2)=INDZV(1)
      ICDS(3)=INDZV(2)
      ICDS(4)=0
      DO  NC=2,3
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=NC-1
          NTYP=7
          CALL ZVGC01 (ICDS(NC))
        ENDIF
      ENDDO
      NC=2
      NTRY=28
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        SP(I,1)=X(I,2)
        SP(I,2)=X2(I)
      ENDDO
      ISKP(14)=1
      NTYP=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 999
C
C                            Baue drehmatrix auf ...
      DO  I=1,3
        DO  J=1,3
          V(I,J)=0.
        ENDDO
      ENDDO
      V(1,1)=1.
      V(2,2)=COS(AINDZV(3)*CONST(3))
      V(3,3)=V(2,2)
      V(3,2)=SIN(AINDZV(3)*CONST(3))
      V(2,3)=-V(3,2)
C                      ... und multipliziere hiermit das gitter.
C
      CALL MM (V,DREH,X)
      CALL TMM (DREH,X,V)
      CALL MM (V,DG(1,1,NS),S)
C
C                            Restore Koordinatensystem.
      DO  I=1,3
        DO  J=1,3
          TRA(J,I,NS)=SK(J,I)
          TRAINV(J,I,NS)=SK(J,I+3)
          DREH(J,I)=SK(J,I+6)
        ENDDO
        UR(I,NS)=SK(I,10)
      ENDDO
      ISKP(14)=1
      NTYP=20
      CALL ZVZ
      IF (IERR .NE. 0) GO TO 999
C
C                   Berechne noch die ursprungsverschiebung.
      DO  I=1,3
        UR(I,NS)=-TRAINV(I,1,NS)*SP(1,2)-TRAINV(I,2,NS)*SP(2,2)-
     +  TRAINV(I,3,NS)*SP(3,2)+SP(I,1)
      ENDDO
      IF (IACTN .NE. 0) GO TO 90
      GO TO 999
C                            Verschiebe Zelle um vektor
   70 CONTINUE
      CALL FLES (INVZ,ISKP(31),4H2CFE,9Hc1,c2,d?$)
      IACTN=0
C
C                            Berechne die laenge des vektors
   75 ICDS(1)=INVZ(1)
      ICDS(2)=INVZ(2)
      NTRY=28
      DO  NC=1,2
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=NC
          NTYP=7
          CALL ZVGC01 (ICDS(NC))
        ENDIF
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  I=1,3
          SP(I,NC)=X2(I)
        ENDDO
      ENDDO
      TEMP=0.
      DO  I=1,3
        TEMP=TEMP+(SP(I,2)-SP(I,1))**2
      ENDDO
      IF (TEMP .LT. 1.E-6) THEN
        IERR=95 0328 06
        GO TO 999
      ENDIF
      TEMP=SQRT(TEMP)
      IF (NTYP .EQ. 6) THEN
        TEMP2=AINVZ(3)/TEMP
      ELSE
        TEMP2=AINVZ(3)
      ENDIF
      DO  I=1,3
        UR(I,NS)=UR(I,NS)+(X(I,1)-X(I,2))*TEMP2
      ENDDO
      IF (IActn .NE. 0) GO TO 90
      GO TO 999
C                            VDZ - Verschiebe und drehe zelle
   80 CONTINUE
      CALL FLES (INVDZ,ISKP(31),5H2FAIE,'d,w,EPU/STPU,opt?$')
      CALL CNVTUP (INVDZ(3),1,4)
   90 IF (INVDZ(4) .NE. 0) THEN
        NTYP=1
        CALL ZVFKTR
        IF (IERR .NE. 0) GO TO 999
      ENDIF
      NTYP=3
      IF (INVDZ(3) .EQ. KDEPU) NTYP=4
      ISKP(14)=1
      CALL ZVMACR
      CALL KPRDLN (STDIN,I)
      IF (I .NE. 0) GO TO 999
      READ (RDLINE,'(20A4)') KARTE
      IACTN=KARTE(1)
      KARPOI=0
      DO  I=1,9
        IF (IACTN .EQ. IACBUF(I)) THEN
          IACTN=I
          GO TO 100
        ENDIF
      ENDDO
      CALL FCNV (IACTN,ISKP(31),2HIE,KARTE,KARPOI,80,I)
      KARPOI=0
      IF (I .NE. 0) GO TO 999
      IF (IACTN .GT. 100 .AND. IACTN .LT. 999) THEN
        INVDZ(5)=1
        INVDZ(6)=200001+200*IACTN
      ENDIF
      GO TO 160
  100 GO TO (110,120,130,110,120,130,105,145,150),IACTN
C              1   2   3  -1  -2  -3   -   +  BL
C
  105 AINVDZ(INVDZ(5))=-AINVDZ(INVDZ(5))
      GO TO 150
C                            Definition der drehachse
  110 INVDZ(6)=331001
      GO TO 140
  120 INVDZ(6)=313001
      GO TO 140
  130 INVDZ(6)=311201
  140 IF (IACTN .GE. 4 .AND. IACTN .LE. 6) AINVDZ(2)=-AINVDZ(2)
  145 INVDZ(5)=2
C
  150 IF (INVDZ(5) .EQ. 2) THEN
        INDZV(1)=1
        INDZV(2)=INVDZ(6)
        INDZV(3)=INVDZ(2)
        GO TO 55
      ENDIF
 160  INVZ(1)=1
      INVZ(2)=INVDZ(6)
      INVZ(3)=INVDZ(1)
      NTYP=6
      GO TO 75
C
  990 CALL FLES (I,ISKP(31),1HE,2H?$)
  999 NS=NSSV
      RETURN
      END
