C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         70              -------------------
                           SUBROUTINE ZVGE04
C  CY-ENG-                -------------------
C
C               geschrieben: 161750 APR 1993  (Hundt)
C               geaendert:   241500 JAN 2016  (Hundt)
C     NTYP
C      1   MVOL   Berechnung des Molekuelvolumens.
C      2   VDG    Verschiebe und drehe Gruppe.
C      3   GOMX   Generiere Orientierungsmatrix.
C      4   SVE    Schnittpunkt Vektor - Ebene.
C      5   LAF    Loesche ausserhalb des Fensters.
C      6   LAF    Kommando fuer Ortep ausgeben.
C      7   VZG    Verzerre Gruppe.
C      8   FD     Force distance.
C      9   SSI    Suche symmetrien und idealisiere.
C     10   SSR    Return
C     11   -      Init
C     12          frei
C     13   VDGD   Daten fuer DGV
C     14   OVDD   Daten fuer DGV listen
C     15   QVDD   Daten fuer DGV auf datei
C     16   ISST   Idealisiere struktur durch ST-kommando
C     17   IDA    Idealisiere struktur durch richtung
C
C                         -------------------
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER*4 KARTE
      COMMON /KPFLIN/ KARTE(21)
C
      INTEGER *4 IRLINE(30),LDTAB,NDTAB
      PARAMETER (LDTAB=16)
      INTEGER *4 IPOI,JPOI,I,J,IAIN(72),IANRJ,NTYPS,INBFR(9),KDR
      INTEGER *4 ICBFR(2),INBFR2(4),K,I1,I2,ISTKP,ISBFR(12),ITOLBF(4)
      INTEGER *4 IDTAB(3,LDTAB),IAT(8,PARDIM,2),ISTSYM(8),ITCNT
C
      REAL    *4 VOL,VDP,EDPI,RI,RJ,RS,TEMP,TEMP2,H,ANBFR(9),TOLBFR(4)
      REAL    *4 DTAB(3,LDTAB),STSYM(8)
C
      SAVE INBFR,INBFR2,ISTKP,TOLBFR,DTAB,NDTAB,ITCNT
C
      EQUIVALENCE (AIN(1),IAIN(1)),(INBFR(1),ANBFR(1))
      EQUIVALENCE (ITOLBF(1),TOLBFR(1)),(WRLINE,IRLINE(1))
      EQUIVALENCE (DTAB(1,1),IDTAB(1,1)),(AT(1,1,1),IAT(1,1,1))
      EQUIVALENCE (STSYM(1),ISTSYM(1))
C
      DATA VDP/4.188790/,EDPI/1.047197/,KDR/4HR   /,NDTAB/0/
      DATA INBFR/8*0,1HA/,INBFR2/0,0,15,3/,ISTKP/0/
      DATA ISBFR/4H;SSR,4HSSFD,4H ** ,4H *  ,4H ***,4H 3 0,
     1 4H 3 1,4H;;  ,4HITS ,4HZIDL,4HMACC,4HTSZ;/
C                                           12
      NTYPS=NTYP
      GO TO (10,90,250,290,310,340,350,360,370,380,450,999,
C             1  2   3   4   5   6   7   8   9  10  11  12
     + 460,470,470,500,500),NTYPS
C       13  14  15  16  17
C
C                       MVOL - Molekuelvolumen
   10 IAIN(1)=1
      IAIN(2)=NAT(NS)
CYENG1
      CALL FLES (IAIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),3H2IE,9Hfrom,to?$)
C
      VOL=0.
      IF (NCD(NS) .LT. NCDA(NS)) GO TO 70
C
C                       Berechne freie Koordinaten.
      NTYP=9
      CALL ZVGE02
      IF (IERR .NE. 0) GO TO 999
C
C                       Durchlaufe Codeliste
C
      DO 60 IPOI=NCDA(NS),NCD(NS)
C
C                       Ist dieses Atom gemeint?
C
      IANR=ICD(IPOI,NS)/200000
      IF (IANR .LT. IAIN(1)) GO TO 60
      IF (IANR .GT. IAIN(2)) GO TO 60
C
C                       Addiere Eigenvolumen
      RI=AT(4,IANR,NS)
      VOL=VOL+VDP*RI*RI*RI
C
      DO 50 JPOI=NCDA(NS),NCD(NS)
C
C                       Identisch mit anderem Atom?
C
      IF (IPOI .EQ. JPOI) GO TO 50
      IANRJ=ICD(JPOI,NS)/200000
      IF (IANRJ .LT. IAIN(1)) GO TO 50
      IF (IANRJ .GT. IAIN(2)) GO TO 50
      RJ=AT(4,IANRJ,NS)
      RS=RI+RJ
C                       Berechne Abstand.
      TEMP=0.
      DO 20 I=1,3
      TEMP2=ATOMS(I,IPOI,NS)-ATOMS(I,JPOI,NS)
      IF (ABS(TEMP2) .GT. RS) GO TO 50
      TEMP=TEMP+TEMP2*TEMP2
   20 CONTINUE
      TEMP=SQRT(TEMP)
C                       Teste, ob zu weit auseinander.
C
      IF (TEMP .GT. RS) GO TO 50
C
C                       Abstand darf nicht kleiner sein,
C                       als ein Radius.
C
      IF (ABS(RI-RJ) .LT. TEMP) GO TO 40
      WRITE (WRLINE,30)
CYENG1
   30 FORMAT ('Die Kugeln von',12X,'und',12X,'sitzen ineinander.')
CYENG2
CYENGY   30 FORMAT ('     The balls',12X,'and',12X,'are in each other.')
      CALL KPCDST (IRLINE,16,ICD(IPOI,NS))
      CALL KPCDST (IRLINE,31,ICD(JPOI,NS))
      CALL KPWRTE (NTDISP)
      GO TO 999
C                       Berechne die Kappe, die abgezogen werden muss.
C
   40 H=RI-(TEMP*TEMP+RI*RI-RJ*RJ)/(2.*TEMP)
      VOL=VOL-EDPI*H*H*(3.*RI-H)
   50 CONTINUE
   60 CONTINUE
C
   70 WRITE (WRLINE,80) VOL
      CALL KPWRTE (NTOUT)
CYENG1
   80 FORMAT ('Molekuelvolumen:',F12.2)
CYENG2
CYENGY   80 FORMAT ('Volume of molecule:',F12.2)
      GO TO 999
C                            VDG - Verschiebe und drehe Gruppe
   90 INBFR(3)=0
      INBFR(4)=0
      ANBFR(7)=CONST(5)
      CALL FLES (INBFR,ISKP(31),6H6CFIAE,
     1 36Hn1,n2, cz1,cz2,cu1,cu2, d, opt,A/R?$)
      IF (ANBFR(7) .NE. 0.) CONST(5)=ANBFR(7)
C
C                            Teste Gueltigkeit
C
      IF (INBFR(1) .LE. 0) GO TO 100
      IF (INBFR(2) .GT. NAT(NS)) GO TO 100
      IF (INBFR(1) .GT. INBFR(2)) GO TO 100
C
C                            Neue Gruppe
      IANRJ=0
      IF (INBFR(9) .NE. KDR) IANRJ=NAT(NS)+1-INBFR(1)
      IPOI=INBFR(1)+IANRJ
      IF (INBFR(2)+IANRJ .LE. NATDM) GO TO 110
C
  100 IERR=70 0126 16
      GO TO 999
C                            Besorge ggf. Codes aus Mausliste
  110 NTYP=7
      DO  NC=3,6
        IF (INBFR(NC) .EQ. 0) THEN
          INBFR(NC)=NC-2
          CALL ZVGC01 (INBFR(NC))
          IF (INBFR(NC) .EQ. 0) THEN
            IERR=70 0166 16
            GO TO 999
          ENDIF
        ENDIF
      ENDDO
C                            Setze beim Abstand ggf. Wert aus Tabelle
C
      IF (ANBFR(7) .LE. 0.) THEN
        ICDS(1)=INBFR(3)
        ICDS(2)=INBFR(5)
        NTRY=16
        DO  NC=1,2
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
          ICDS(NC)=IAT(5,IANR,NS)
        ENDDO
        CALL CNVTUP (ICDS,1,8)
        DO  I=1,NDTAB
          IF ((ICDS(1) .EQ. IDTAB(1,I) .AND. ICDS(2) .EQ. IDTAB(2,I))
     +      .OR. (ICDS(2) .EQ. IDTAB(1,I) .AND. ICDS(1) .EQ.
     +      IDTAB(2,I))) THEN
            ANBFR(7)=DTAB(3,I)
            CONST(5)=ANBFR(7)
            GO TO 120
          ENDIF
        ENDDO
        WRITE (WRLINE,'(A,A4,A,A4,A)')
CYENG1
     +  'Kein Wert fuer das Paar ',ICDS(1),',',ICDS(2),' gefunden.'
CYENG2
CYENGY     +  'No value for pair ',ICDS(1),',',ICDS(2),' found.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
C                            Lade Punkt
  120 ICDS(1)=INBFR(3)
      NC=1
      NTRY=28
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        PTRIKL(I)=X(I,1)
        PFREI(I)=X2(I)
      ENDDO
C                            Verschiebe Punkt
      ICDS(2)=INBFR(4)
      ICDS(3)=INBFR(7)
      ISKP(14)=1
      NTYP=3
      CALL ZVGE03
      IF (IERR .NE. 0) GO TO 240
C
C                            Save Koordinatensystem
  140 NTYP=19
      CALL ZVK
C                            Koordinatensystem in Startgruppe
      ICDS(1)=INBFR(5)
      ICDS(2)=INBFR(6)
      ICDS(3)=INBFR(5)
      ICDS(4)=0
      NTYP=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 210
C                            Fuehre SK aus
      NTYP=4
      CALL ZVK
C                            Koordinatensystem in die Zielgruppe
      ICDS(1)=INBFR(4)
      ICDS(2)=INBFR(3)
      ICDS(3)=INBFR(4)
      ICDS(4)=0
      NTYP=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 210
      INBFR(3)=ICDS(2)
      INBFR(4)=ICDS(3)
C
C                            KUP
      DO 170 I=1,3
  170 UR(I,NS)=PTRIKL(I)
      I=NAT(NS)
C                            KTG
      IAIN(1)=INBFR(1)
      IAIN(2)=INBFR(2)
      IAIN(3)=INBFR(9)
      NTYP=10
      CALL ZVK
      IF (IERR .NE. 0) GO TO 210
C
C                            Wenn sich die Atome vermehrt haben,
C                            erzeuge neue Codes ...
C
      IF (NAT(NS) .LE. I) GO TO 210
      ICDS(1)=IPOI
      ICDS(2)=NAT(NS)
      NTYP=1
      CALL ZVASCI
C                            ... entferne aber die "Spitzen".
      ICDS(1)=INBFR(4)
      ICDS(2)=INBFR(4)
      NTYP=2
      CALL ZVASCI
      ICDS(1)=INBFR(6)
      NTRY=16
      NC=1
      CALL ZVDEK
      ICDS(1)=IANR+IANRJ
      ICDS(2)=ICDS(1)
      NTYP=2
      CALL ZVASCI
      J=INBFR(4)
      IF (J .GT. NAT(NS)) J=J/200000
      IF (INBFR(8) .NE. 0) GO TO 190
C
C                            EPL
      IAIN(1)=ICDS(1)
      IAIN(2)=IAIN(1)
      NTYP=14
      CALL ZVFNIN
      IAIN(1)=J
      IAIN(2)=J
      NTYP=14
      CALL ZVFNIN
      DO 180 J=3,6
  180 IF (INBFR(J) .GT. NAT(NS)) INBFR(J)=INBFR(J)/200000
      IF (INBFR(3) .GT. INBFR(4)) INBFR(3)=INBFR(3)-1
      J=1
      IF (INBFR(6) .LT. INBFR(5)) J=2
      INBFR(4)=INBFR(5)-J+IANRJ
      IPOI=IPOI-1
C                            Hinterlege Parameter fuer VDGC
  190 ISKP(14)=1
      NTYP=1
      IAIN(1)=INBFR(3)
      IAIN(2)=INBFR(4)
      ISKP(31)=2
      CALL ZVGC01 (J)
      ISKP(31)=1
      DO  I=IPOI,NAT(NS)
        IF (I .NE. INBFR(3) .AND. I .NE. INBFR(4)) THEN
          NTYP=2
          IAIN(1)=I
          ISKP(14)=1
          CALL ZVGC01 (J)
          IF (IERR .NE. 0) GO TO 999
        ENDIF
      ENDDO
C                            Restore Koordinatensystem.
  210 NTYP=20
      CALL ZVK
  240 ISKP(14)=0
      GO TO 999
C                            GOMX - Orientierungsmatrix generieren
  250 I=0
CYENG1
      CALL FLES (I,ISKP(31),2HIR,4HNr?$)
CYENG2
CYENGY      CALL FLES (I,ISKP(31),2HIR,4HNo?$)
      IF ((I .GT. 0) .AND. (I .LE. NAT(NS)-2)) GO TO 260
      IERR=70 0260 16
      GO TO 999
C
  260 NTYP=NTPCH
      CALL ZVEAEH
      NTRY=28
      NC=1
      DO 270 J=1,3
      ICDS(1)=I
      I=I+1
      CALL ZVDEK
      AIN(J  )=X2(1)
      AIN(J+3)=X2(2)
      AIN(J+6)=X2(3)
  270 CONTINUE
      J=31
      WRITE (WRLINE,280) J,(AIN(I),I=1,6)
      CALL KPWRTE (NTPCH)
  280 FORMAT (I4,2X,3F9.6,2X,3F9.6)
      J=J+1
      WRITE (WRLINE,280) J,(AIN(I),I=7,9)
      CALL KPWRTE (NTPCH)
      GO TO 999
C                            SVE - Schnittpunkt Vektor - Ebene
C
  290 CALL FLES (ICBFR,ISKP(31),3H2CE,7Hc1,c2?$)
C
C                            Besorge ggf. Codes aus der Mausliste
      DO  I=1,2
        IF (ICBFR(I) .EQ. 0) THEN
          ICBFR(I)=1
          NTYP=13
          CALL ZVGC01 (ICBFR(I))
        ENDIF
      ENDDO
C                            Save Koordinatensystem
      NTYP=19
      CALL ZVK
C                            EFTG
      NTYP=5
      CALL ZVEFIT
      IF (IERR .NE. 0) GO TO 300
C
C                            Berechne Schnittpunkt
      NTRY=28
      DO  NC=1,2
        ICDS(NC)=ICBFR(NC)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 300
        DO  I=1,3
          X(I,NC)=X2(I)
        ENDDO
      ENDDO
      TEMP=X(3,1)-X(3,2)
      IF (ABS(TEMP) .LT. 1.E-6) THEN
        IERR=-1
CYENG1
        WRITE (WRLINE,'(A)') ' ZVGE04 - Es existiert keine Loesung.'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'ZVGE040320 - There is no solution.'
        CALL KPWRTE (NTDISP)
        GO TO 300
      ENDIF
      TEMP=X(3,1)/TEMP
      DO  I=1,3
        PFREI(I)=(X(I,2)-X(I,1))*TEMP+X(I,1)
      ENDDO
C                            Berechne hierzu PTRIKL.
      NTYP=15
      CALL ZVGE01
C                            Restore Koordinatensystem ...
  300 NTYP=20
      CALL ZVK
C                            ... und gleiche PFREI an.
      NTYP=16
      CALL ZVGE01
      GO TO 999
C                            LAF
  310 CONTINUE
      CALL FLES (INBFR2,ISKP(31),3H4CE,14Hc1,c2,fr,sr? $)
      NTRY=28
      DO  NC=1,2
        IF (INBFR2(NC) .EQ. 0) THEN
          NTYP=7
          INBFR2(NC)=NC
          CALL ZVGC01 (INBFR2(NC))
        ENDIF
        ICDS(NC)=INBFR2(NC)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
C
C                            Berechne die proj. Koordinaten
        TEMP=HOE/(HOE-X2(3))
        X(1,NC)=X2(1)*TEMP*O9+CONST(11)
        X(2,NC)=X2(2)*TEMP*O9+CONST(12)
      ENDDO
      DO  K=1,2
        X1(K)=MIN(X(K,1),X(K,2))
        X2(K)=MAX(X(K,1),X(K,2))
      ENDDO
C                            Hole Treibertyp
      CALL UPLINF (IPOI,17)
      IF (IPOI .LT. 0) GO TO 330
C
  320 CALL UPLINF (0,24)
      I1=1
      I2=2
      DO  K=1,2
        X(I1,3)=-99.
        X(I1,4)=+99.
        X(I1,5)=+99.
        X(I1,6)=-99.
        X(I1,7)=X(I1,3)
C
        X(I2,3)=X2(I2)
        X(I2,5)=+99.
C
        DO  J=1,2
          X(I2,4)=X(I2,3)
          X(I2,6)=X(I2,5)
          X(I2,7)=X(I2,3)
          I=23
          DO  NC=3,7
            CALL UPLINF (X(1,NC),I)
            I=22
          ENDDO
          CALL UPLINF (0,21)
          X(I2,3)=X1(I2)
          X(I2,5)=-99.
        ENDDO
        I1=2
        I2=1
      ENDDO
      CALL UPLINF (1,24)
      IF (IPOI .LT. 0) GO TO 335
  330 IF (INBFR2(4) .GT. 0) THEN
        CALL UPLINF (INBFR2(3),10)
        CALL UPLINF (INBFR2(4),11)
        CALL UPLINF (X1,3)
        X(1,3)=X2(1)
        X(2,3)=X1(2)
        CALL UPLINF (X(1,3),2)
        CALL UPLINF (X2,2)
        X(1,3)=X1(1)
        X(2,3)=X2(2)
        CALL UPLINF (X(1,3),2)
        CALL UPLINF (X1,2)
      ENDIF
      IF (IPOI .LT. 0) GO TO 320
  335 CALL UPLINF (X,0)
      GO TO 999
C                            LAF fuer ORTEP
  340 CONTINUE
      IF ((INBFR2(1) .EQ. 0) .OR. (INBFR2(2) .EQ. 0)) GO TO 999
      WRITE (WRLINE,'(''  218'',2I10,2I4)') INBFR2
      CALL KPWRTE (NTPCH)
      GO TO 999
C                            VZG - Verzerre Gruppe
  350 AIN(4)=CONST(5)
      IAIN(5)=ISKP(38)
CYENG1
      CALL FLES (AIN,ISKP(31),5H3IFAE,24Hvon,bis, achse, f,opt? $)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),5H3IFAE,23Hfrom,to, axis, f,opt? $)
      CALL CNVTUP (IAIN(5),1,4)
      IF (IAIN(1) .LE. 0 .OR. IAIN(2) .GT. NAT(NS) .OR.
     +  IAIN(1) .GT. IAIN(2)) THEN
        IERR=70 0433 16
        GO TO 999
      ENDIF
      IF (IAIN(3) .LE. 0 .OR. IAIN(3) .GT. 3) THEN
        IERR=70 0437 07
        GO TO 999
      ENDIF
C
      DO  I=IAIN(1),IAIN(2)
        DO  J=1,3
          X(J,1)=AT(J,I,NS)
        ENDDO
        NC=1
        NTRY=4
        CALL ZVDEK
        X2(IAIN(3))=X2(IAIN(3))*AIN(4)
        K=I
        IF (IAIN(5) .NE. KDR) THEN
          IF (NAT(NS) .LT. NATDM) THEN
            NAT(NS)=NAT(NS)+1
            K=NAT(NS)
          ELSE
            IERR=70 0455 02
            GO TO 999
          ENDIF
        ENDIF
        DO  J=1,3
          AT(J,K,NS)=TRAINV(J,1,NS)*X2(1)+TRAINV(J,2,NS)*X2(2)+
     +    TRAINV(J,3,NS)*X2(3)+UR(J,NS)
          AT(J+3,K,NS)=AT(J+3,I,NS)
        ENDDO
        ICLRP(K,NS)=ICLRP(I,NS)
        IPFLG(K,NS)=0
      ENDDO
      GO TO 999
C                            FD - Force distance
  360 AIN(1)=CONST(5)
      CALL FLES (AIN,ISKP(31),2HFE,4Hd? $)
      TEMP=PFREI(1)*PFREI(1)+PFREI(2)*PFREI(2)+PFREI(3)*PFREI(3)
      IF (TEMP .LT. 1.E-10) THEN
        IERR=70 0495 06
        GO TO 999
      ELSE
        TEMP=AIN(1)/SQRT(TEMP)
        DO  I=1,3
          PFREI(I)=PFREI(I)*TEMP
        ENDDO
        NTYP=15
        CALL ZVGE01
      ENDIF
      GO TO 999
C                            SSI - Suche symmetrie und idealisiere.
C
  370 CALL FLES (TOLBFR,ISKP(31),4H3FAE,20HTols,Tolt,Tolg,Ref?$)
      IF (NSYM(NS) .NE. 1) THEN
C                            MTRI
        NTYP=9
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 999
      ENDIF
      IF (ISKP(31) .LT. 2 .OR. TOLBFR(2) .EQ. 0.) TOLBFR(2)=TOLBFR(1)
C
C                            TSZ - Suche translationssymmetrien
      IAIN(1)=ISKP(53)
      IAIN(2)=NAT(NS)
      IAIN(3)=0
      AIN(4)=TOLBFR(2)
      IAIN(5)=4
      NTYP=2
      CALL ZVTSZR
      IF (IERR .NE. 0) GO TO 999
C
C                            Gab es translationssymmetrie?
C
      IF (ISKP(77) .NE. 0) THEN
C
C                            Ja. Fuehre ITS aus.
        NTYP=7
        CALL ZVTSZR
        IF (IERR .NE. 0) GO TO 999
      ENDIF
      ISTKP=1
C                            Initialisiere 'SFND'
      DO  I=1,3
        AIN(ID2(I))=TOLBFR(I)
      ENDDO
      NTYP=5
      CALL ZVSFND
      ISTKP=1
      ISKP(79)=1
C                            Die verwaltung erfolgt ueber ISTKP:
C                            0: Fertig
C                            1: SFND vor idealisierung
C                            2: ITS falls erforderlich
C                            3: SFND nach Idealisierung
C                            4: ZIDL
C
  380 IF (ISTKP .LE. 0) GO TO 999
      DO  I=1,20
        KARTE(I)=ISKP(24)
      ENDDO
      KARTE(21)=0
      KARTE(20)=ISBFR(1)
      GO TO (390,400,390,410),ISTKP
C
C                            Kopiere SSFD ... auf karte.
  390 DO  I=1,5
        KARTE(I)=ISBFR(I+1)
      ENDDO
      KARTE(3)=ITOLBF(4)
      IF (ISTKP .EQ. 3) THEN
        ITCNT=NSYM(NS)-1
        KARTE(5)=ISBFR(7)
        KARTE(6)=ISBFR(8)
        ISTKP=4
      ELSE
        ISTKP=2
      ENDIF
      GO TO 999
C                            Gab es translationssymmetrie?
C
  400 IF (ISKP(77) .NE. 0) THEN
C
C                            Ja. Setze ITS auf.
        KARTE(1)=ISBFR( 9)
        ISTKP=1
      ELSE
C
C  Wenn bisher nur nach translations-symmetrie gesucht wurde, wird jetzt
C  nach achsen gesucht. Transformiere zuerst auf das referenzatom.
C
        IF (ISKP(79) .EQ. 1) THEN
          DO  I=ISKP(53),NAT(NS)
            IF (ISKP(16) .EQ. IAT(7,I,NS)) GO TO 406
          ENDDO
          I=ISKP(53)
  406     DO  J=1,3
            AIN(J)=AT(J,I,NS)
          ENDDO
          ISKP(14)=1
          NTYP=4
          CALL ZVZ
          IF (IERR .NE. 0) GO TO 999
C
          ITCNT=0
          ISKP(79)=4
          ISTKP=1
          GO TO 380
        ENDIF
C                            Ist ueberhaupt etwas herausgekommen?
        ISKP(79)=7
        IF (ISKP(78) .EQ. 0) THEN
          ISKP(79)=2
          DO  I=1,4
            KARTE(I)=ISBFR(I+1)
          ENDDO
          KARTE(3)=ITOLBF(4)
          KARTE(5)=ISBFR(7)
          KARTE(6)=ISBFR(8)
          WRITE (WRLINE,'(A)')
CYENG1
     1    'Keine Idealisierung.'
CYENG2
CYENGY     1 'No idealisation.'
          CALL KPWRTE (NTDISP)
          GO TO 430
        ELSE
          KARTE(1)=ISBFR(10)
          ISTKP=3
        ENDIF
      ENDIF
      GO TO 999
C
  410 ITCNT=MAX(ITCNT,NSYM(NS)-1)
C                            Ist vielleicht noch translationssymmetrie
C                            hinzugekommen?
C
      IF (ISKP(77) .GT. ITCNT) GO TO 400
C
C                            Stand der symmetrieanalyse?
C
      IF (ISKP(78)-1) 420,430,440
  420 WRITE (WRLINE,'(A)')
CYENG1
     1 'Nach der Idealisierung Symmetrie verloren.'
CYENG2
CYENGY     1 'Symmetry lost after idealisation.'
      CALL KPWRTE (NTDISP)
      IERR=-1
  430 KARTE(20)=ISKP(24)
      ISTKP=0
C                            Falls noch ein makro anhaengig ist ...
C
      IF (ISKP(45) .NE. 0) KARTE(20)=ISBFR(11)
      GO TO 999
  440 ISTKP=2
      ITCNT=ISKP(77)
      ISKP(77)=0
      GO TO 380
c                            Init
  450 TOLBFR(1)=0.25
      TOLBFR(2)=0.25
      TOLBFR(3)=0.1
      ITOLBF(4)=ISBFR(4)
      NDTAB=0
      GO TO 999
C                            VDGD - VDG Daten
C
  460 CALL FLES (IAIN,ISKP(31),4HAAFE,9Hs1,s2,d?$)
      CALL CNVTUP (IAIN,1,8)
      DO  I=1,NDTAB
        IF ((IAIN(1) .EQ. IDTAB(1,I) .AND. IAIN(2) .EQ. IDTAB(2,I)) .OR.
     +    (IAIN(2) .EQ. IDTAB(1,I) .AND. IAIN(1) .EQ. IDTAB(2,I))) THEN
          DTAB(3,I)=AIN(3)
          GO TO 999
        ENDIF
      ENDDO
      IF (NDTAB .LT. LDTAB) THEN
        NDTAB=NDTAB+1
        DO  I=1,3
          IDTAB(I,NDTAB)=IAIN(I)
        ENDDO
      ELSE
        IERR=70 0647 20
      ENDIF
      GO TO 999
C                            OVDD
  470 CONTINUE
      DO  I=1,NDTAB
        IF (NTYPS .EQ. 14) THEN
          WRITE (WRLINE,'(I2,A,1X,2A4,F6.3)')
     +    I,')',IDTAB(1,I),IDTAB(2,I),DTAB(3,I)
          CALL KPWRTE (NTDISP)
        ELSE
          WRITE (WRLINE,'(A,1X,A4,1X,A4,F6.3)')
     +    'VDGD',IDTAB(1,I),IDTAB(2,I),DTAB(3,I)
          CALL KPWRTE (NTBILF)
        ENDIF
      ENDDO
      IF (NTYPS .EQ. 14) CALL FLES (AIN,ISKP(31),1HE,2H?$)
      GO TO 999
C                            ISST und IDA
  500 DO  I=11,21
        IAIN(I)=0
      ENDDO
      DO  I=1,8
        ISTSYM(I)=0
      ENDDO
      ISTSYM(2)=556
      IF (NTYP .EQ. 16) THEN
CYENG1
        CALL FLES (ISTSYM,ISKP(31),5H2I6FE,19Htyp,rchtg,pkt,hub?$)
CYENG2
CYENGY        CALL FLES (ISTSYM,ISKP(31),5H2I6FE,18Htype,dir,pnt,gld?$)
        IPOI=-ISTSYM(2)
      ELSE
CYENG1
        CALL FLES (ISTSYM(2),ISKP(31),2HIE,7Hrchtg?$)
CYENG2
CYENGY        CALL FLES (ISTSYM(2),ISKP(31),2HIE,11Hdirection?$)
C
C                            Suche bei hinterlegten symmetrien.
        IPOI=-ISTSYM(2)
C                            Zentrum?
        IF (IPOI .GT. 0) THEN
          IF (IPOI .GT. IZEPOI) THEN
            IERR=70 0727 16
            GO TO 999
          ENDIF
          GO TO 505
        ENDIF
C                            Achse.
        DO  I=1,ISYPOI
          IF (ISTSYM(2) .EQ. IDIRSV(I) .AND. IROTSV(I) .NE. 0) THEN
            ISTSYM(1)=IROTSV(I)
            DO  J=1,3
              STSYM(J+2)=PKTSV(J,I)
              STSYM(J+5)=HUBSV(J,I)
            ENDDO
            GO TO 505
          ENDIF
        ENDDO
        WRITE (WRLINE,'(A,I4,A)')
CYENG1
     +  'ZVGE040735 - Achse',ISTSYM(2),' ungeeignet.'
CYENG2
CYENGY     +  'ZVGE040735 - Axis',ISTSYM(2),' not suitable.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
  505 IF (NSYM(NS) .NE. 1) THEN
        NTYP=9
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 999
      ENDIF
      IF (IPOI .GT. 0) THEN
        DO  J=13,21
          IAIN(J)=0
        ENDDO
        IAIN(11)=-1
        IAIN(12)=1
        DO  J=1,3
          AIN(J+15)=ZENSV(J,IPOI)
        ENDDO
        K=ISKP(62)
        ISKP(62)=1
        ISKP(14)=1
        NTYP=1
        CALL ZVST
        IF (IERR .NE. 0) GO TO 510
        GO TO 508
      ENDIF
      J=ABS(ISTSYM(1))-1
      IF (J .LT. 1) J=1
      ICDS(1)=400001+200*ISTSYM(2)
      NC=1
      NTRY=16
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        IAIN(I+12)=IT(I)-5
      ENDDO
      K=ISKP(62)
      ISKP(62)=1
      DO  I=1,J
        IAIN(11)=ISTSYM(1)
        IAIN(12)=I
        DO  I1=3,8
          IAIN(I1+13)=ISTSYM(I1)
        ENDDO
C     write (6,'(5i3,6f10.5)') (iain(j),j=11,15),(ain(j),j=16,21)
        ISKP(14)=1
        NTYP=1
        CALL ZVST
        IF (IERR .NE. 0) GO TO 510
      ENDDO
  508 ISKP(14)=0
      NTYP=4
      CALL ZVRPSY
      IF (IERR .NE. 0) GO TO 510
      NTYP=9
      CALL ZVAVBR
  510 ISKP(62)=K
C
  999 NTYP=NTYPS
      RETURN
      END
