C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPGOML   54             -------------------
                          SUBROUTINE ZVGOML
C  CY-VAX-ENG-           -------------------
C
C  Das Programm soll organische Molekuele zusammenstellen oder
C  einen Zellinhalt finden.
C
C   Kommando  NTYP  Bedeutung
C   FMA         1   Finde Molekuel und addiere
C   FM          2   Finde Molekuel
C   FMDP        3*  Atom Distanz-Paar
C   FMDR        4*  Reset Atomdistanz Tabelle
C   FZ          5   Finde Zellinhalt
C   FMMC        6   Maximalzahl der Codes
C   OFMD        7*  Liste Atomdistanztabelle
C   FMOP        8   Definition der Optionsbits
C                * jetzt nicht mehr hier
C
C                  Geschrieben: 240831 MAY 1984 (Hundt)
C                  Geaendert:   061622 SEP 2005 (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 INBFR(4),IAIN(72),IAT(8,PARDIM,2),IATSRT(6),IOPTT(5)
      INTEGER *4 I,J,IELMH,NTYPS,IOPT,ITMP,ITMP1,ITMP2,IASRPO,IZFLG
      INTEGER *4 IPLFLG,MOLCNT,MOLSTR,NCDSTR,NCDPOI,IANRUR,ISYNUR
      INTEGER *4 IZLPOI,NRATMS,K,K2,K3,IBLANK,IHFLG,LCOMPS,IAND
      REAL    *4 CDS(7)
C
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1)),(AIN(1),IAIN(1))
      EQUIVALENCE (CDS(1),ICDS(1))
C
      DATA IELMH/4HH   /,IBLANK/4H    /
      DATA IOPTT/4HF A ,4HP S ,4HZ NF,4HNANP,4HNSNZ/
C
      NTYPS=NTYP
      IOPT=ISKP(1)
      IF (NTYP .GT. 2) GO TO 970
C
C                            Hole Vorgaben.
      INBFR(3)=ISKP(53)
      INBFR(4)=NAT(NS)
      INBFR(2)=0
      INBFR(1)=0
CYENG1
      CALL FLES (INBFR,ISKP(31),5HIA2IE,18HRes-Nr,Opt,n1,n2?$)
CYENG2
CYENGY      CALL FLES (INBFR,ISKP(31),5HIA2IE,18HRes-No,opt,n1,n2?$)
      IF (INBFR(3) .LE. 0 .OR. INBFR(4) .LT. INBFR(3) .OR.
     +  INBFR(4) .GT. NAT(NS)) THEN
        IERR=54 0055 16
        GO TO 9999
      ENDIF
C
      CALL CNVTUP (INBFR,5,4)
C                            Reset, falls optiert
      IF (NTYP .LT. 2) GO TO 70
   60 NCD(NS)=NCDA(NS)-1
      K8(NS)=0
      K9(NS)=0
C                            Lege Tabelle mit den Atomsorten an.
C                            Teste dabei, ob gleiche Atomsymbole zu-
C                            sammenstehen.
   70 ITMP2=0
      IASRPO=0
      ITMP=0
      ISKP(14)=-2
      DO  J=INBFR(3),INBFR(4)
        ITMP1=IAT(5,J,NS)
        I=IASRPO
        GO TO 120
   80   IF (LCOMPS(IATSRT,2*I-1,2, ITMP1,1) .EQ. 0) THEN
          IF (I .NE. IASRPO) ITMP2=1
          GO TO 160
        ENDIF
        I=I-1
  120   IF (I .GT. 0) GO TO 80
        IF (IASRPO .GE. 12) GO TO 160
C
C                            Nimm Wasserstoff nur auf, wenn ent-
C                            sprechende Option aktiv.
C
        IF (ITMP1 .NE. IELMH .OR. ITMP1 .EQ. INBFR(2)) THEN
          IASRPO=IASRPO+1
          CALL COPYCH (ITMP1,1,2, IATSRT,2*IASRPO-1)
        ENDIF
  160   CONTINUE
      ENDDO
C                            Setze option: zelle generieren.
      IZFLG=0
      IF (IOPT .GE. 16) THEN
        IOPT=IOPT-16
        IF (NTYPS .EQ. 5) IZFLG=1
      ENDIF
C                            Sortiere nach Namen, falls gleiche
C                            Atomsymbole nicht zusammenstehen und
C                            entsprechende Option gesetzt.
C
      IF (IOPT .GE. 8) THEN
        IOPT=IOPT-8
        IF (ITMP2 .NE. 0) THEN
          IAIN(1)=INBFR(3)
          IAIN(2)=INBFR(4)
          NTYP=5
          CALL ZVSRT
          IF (IERR .NE. 0) GO TO 9990
        ENDIF
      ENDIF
C                            Struktur ist (hoffentlich) nicht polymer.
      IPLFLG=0
      MOLCNT=0
      NCDSTR=NCD(NS)+1
C                            Verzweigung Zelle / Molekuel
C
      IF (NTYPS .EQ. 5) THEN
        NTYP=1
        CALL ZVADD
        IPLFLG=1
        GO TO 610
      ENDIF
C                            Verwende nicht Wasserstoff als Ursprung.
      IC=INBFR(3)
  220 IF (IAT(5,IC,NS) .NE. IELMH) GO TO 230
      IC=IC+1
      IF (IC-INBFR(4)) 220,220,9990
C
C                            Setze erstes Atom in Codeliste.
  230 ITMP=IC*200000+111001
      IF (NCD(NS) .GE. NCDDM) THEN
        IERR=54 0134 02
        GO TO 9999
      ENDIF
C
      NCD(NS)=NCD(NS)+1
      MOLCNT=MOLCNT+1
      IF (INBFR(1) .GT. 0 .AND. INBFR(1) .GE. MOLCNT) MOLSTR=NCD(NS)
      ICD(NCD(NS),NS)=ITMP
C                            Startposition
      NCDPOI=NCD(NS)
      GO TO 340
C                            Suche zum (naechsten) Atom die Umgebung.
C                            Pruefe, ob dieses Atom in Liste bereits
C                            mit gleicher Symmetrie vorkommt.
  290 IC=NCDPOI+1
      NTRY=32
      CALL ZVDEK
      IF (IERR) 9990,300,9990
C                            Verwende nicht Wasserstoff als Ursprung.
C
  300 IF (IAT(5,IANR,NS) .EQ. IELMH) GO TO 450
      IANRUR=IANR
      ISYNUR=ISYNR
C                            Teste, ob polymer
      DO  IC=1,NCDPOI
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9990
        IF (IANR .EQ. IANRUR .AND. ISYNR .EQ. ISYNUR) GO TO 440
      ENDDO
      NCDPOI=NCDPOI+1
C                            Baue Kommando 'AKS' zusammen.
  340 IZLPOI=INBFR(3)
  350 ICDS(1)=ICD(NCDPOI,NS)
      IANRUR=ICDS(1)/200000
      IZ1=IZLPOI
      IZ2=IZLPOI
      CALL ZVDTAB (IAT(5,IANRUR,NS),IAT(5,IZLPOI,NS),DQ,2)
C
C                            Verwende hier Wasserstoff nur
C                            optional als Zielatom.
C
      IF (IAT(5,IZLPOI,NS) .EQ. IELMH .AND.INBFR(2) .NE. IELMH)GO TO 400
C
C                            Fuehre AKS aus.
  390 NTYP=3
      CONST(20)=0.
      ISKP(14)=1
      CALL ZVAVBR
      IF (IERR) 9990,400,9990
C                            Teste, ob Abbruchbedingung erfuellt
C
  400 IF (NCD(NS)-NCDSTR+1 .GT. ISKP(23)) THEN
CYENG1
  410 WRITE (WRLINE,'(A,I4,A)') ' Suche abgebrochen.',NCD(NS),
     + ' Atome gefunden.'
CYENG2
CYENGY  410 WRITE (WRLINE,'(A,I4,A)') 'Search terminated.',NCD,' atoms found.'
      CALL KPWRTE (NTDISP)
CYENG1
      WRITE (WRLINE,'(A)')
     + ' Abbruchsgrenze kann mit FMMC umgesetzt werden.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'Limit may be changed by ''FMMC''.'
      GO TO 610
      ENDIF
C                            Naechstes Zielatom
      IZLPOI=IZLPOI+1
      IF (IZLPOI .LE. INBFR(4)) GO TO 350
      GO TO 460
C                            Struktur ist polymer. Benutze dieses
C                            Atom nicht mehr als Ursprungsatom.
  440 IPLFLG=1
  450 NCDPOI=NCDPOI+1
C                            Naechstes Ursprungsatom.
C
  460 IF (NCDPOI .LT. NCD(NS)) GO TO 290
C
C                            Durch.  Teste, ob dies das gewuenschte
C                            Molekuel war.
C
      IF (INBFR(1) .GT. 0 .AND. MOLCNT .GE. INBFR(1)) GO TO 540
C
C                            Teste, ob alle Atome vorgekommen.
      ISKP(14)=1
      NTYP=3
      NCDA(NS)=NCDSTR
      CALL ZVSRT
      NCDA(NS)=1
      IC=ICD(NCDSTR,NS)/200000
      DO  K=NCDSTR,NCD(NS)
        J=ICD(K,NS)/200000
        IF (J-IC .GT. 1) THEN
  500     IC=IC+1
          IF (IAT(5,IC,NS) .NE. IELMH) GO TO 230
          IF (IC .LT. J-1) GO TO 500
        ENDIF
        IC=J
      ENDDO
      GO TO 520
  510 IC=IC+1
      IF (IAT(5,IC,NS) .NE. IELMH) GO TO 230
  520 IF (IC .LT. INBFR(4)) GO TO 510
C
C                            Teste, ob komprimiert werden muss.
C
  540 IF (INBFR(1) .LE. 1) GO TO 610
      IF (MOLCNT .LT. INBFR(1)) THEN
        WRITE (WRLINE,570) INBFR(1)
        CALL KPWRTE (NTDISP)
CYENGY  570   FORMAT ('ZVGOML0560 - Residue Nr.',I3,' not found.')
CYENG1
  570   FORMAT ('ZVGOML0560 - Molekuel Nr.',I3,' nicht gefunden.')
CYENG2
        GO TO 610
      ENDIF
      K8(NS)=0
      K9(NS)=0
      J=NCDSTR
      DO  I=MOLSTR,NCD(NS)
        ICD(J,NS)=ICD(I,NS)
        J=J+1
      ENDDO
      NCD(NS)=J-1
      MOLCNT=1
C                            Durch.  Teste, ob Struktur polymer.
C
  610 NRATMS=NCD(NS)-NCDSTR+1
      IF (IPLFLG .NE. 0) THEN
        WRITE (WRLINE,630) NRATMS
        CALL KPWRTE (NTDISP)
CYENGY  630   FORMAT ('Polymeric structure.',I4,
CYENGY     1   ' atoms will be plotted.')
CYENG1
  630   FORMAT ('Die Struktur ist polymer.',I4,
     1   ' Atome werden gezeichnet.')
CYENG2
        GO TO 660
      ENDIF
C                            Drucke Zahl der gefundenen Molekuele.
C
      WRITE (WRLINE,650) MOLCNT,NRATMS
      CALL KPWRTE (NTDISP)
CYENGY  650 FORMAT (I3,' Residues found (',I3,' atoms).')
CYENG1
  650 FORMAT (I3,' Molekuele gefunden (',I3,' Atome).')
CYENG2
C
C                            Erzeuge VB-Kommandos.  Erzeuge keine H-H-
C                            Bindungen.  Abstand von H =1.2
C
  660 IF (IOPT .LT. 4) GO TO 790
      IOPT=IOPT-4
      IPKP(NS)=0
      ISKP(14)=1
      IF (IASRPO .LE. 0) GO TO 9990
C
      DO  I=1,IASRPO
C
        DO  K=I,IASRPO
          ITMP2=IBLANK
          CALL COPYCH (IATSRT,2*I-1,2, ITMP2,1)
          IHFLG=-1
          IF (ITMP2 .EQ. IELMH) IHFLG=0
          ITMP1=IBLANK
          CALL COPYCH (IATSRT,2*K-1,2, ITMP1,1)
          IF (ITMP1 .EQ. IELMH) IHFLG=IHFLG+1
          CALL ZVDTAB (ITMP1,ITMP2,AIN(6),2)
          IAIN(3)=ITMP1
          IAIN(4)=ITMP2
          AIN(5)=0.
          AIN(7)=0.06
          IAIN(8)=11
          IAIN(9)=0
          IAIN(10)=0
          IAIN(11)=0
          IAIN(12)=INBFR(3)
          IAIN(13)=INBFR(4)
          ISKP(34)=6
          NTYP=8
          CALL ZVLPK
          IF (IERR .NE. 0) GO TO 9990
        ENDDO
      ENDDO
C                            PK-Kommandos
      ITMP1=IBLANK
      IF (ISKP(10) .EQ. 0) ISKP(10)=1
      DO  I=1,IASRPO
        CALL COPYCH (IATSRT,2*I-1,2, ITMP1,1)
        IAIN(1)=ITMP1
        IAIN(2)=ISKP(8)
        AIN(3)=0.
        IF (ITMP1 .EQ. IELMH) AIN(3)=.2
        IAIN(4)=INBFR(3)
        IAIN(5)=INBFR(4)
        ISKP(34)=2
        NTYP=11
        CALL ZVLPK
        IF (IERR .NE. 0) GO TO 9990
      ENDDO
C                            Ebenenfit.
C
  790 IF (IOPT .LT. 2) GO TO 850
      IOPT=IOPT-2
      IF (NRATMS-2) 810,805,830
  805 ICDS(1)=ICD(1,NS)
      ICDS(2)=ICD(1,NS)
      ICDS(3)=ICD(2,NS)
      ICDS(4)=0
      NTYP=1
      ISKP(14)=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 9990
      GO TO 845
C
  810 WRITE (WRLINE,820) NRATMS
      CALL KPWRTE (NTDISP)
CYENGY  820 FORMAT ('ZVGOML0820 - Only',I2,
CYENGY     1 ' atoms found. No best plane searched for.')
CYENG1
  820 FORMAT ('ZVGOML0820 - Nur',I2,
     1 ' Atome gefunden. Keine beste Ebene.')
CYENG2
      GO TO 9990
C
  830 IAIN(1)=INBFR(3)
      IAIN(2)=INBFR(4)
      NTYP=2
      CALL ZVEFIT
      IF (IERR .NE. 0) GO TO 9990
C
C                 Ursprung auf Schwerpunkt oder gemaess CMPZ
C
      IF (ISKP(94) .EQ. 0) THEN
        ISKP(14)=1
        NTYP=19
        CALL ZVGE01
        NTYP=6
        CALL ZVK
      ELSE
        NTYP=3
        CALL ZVCMPC
      ENDIF
C                            Minimalisiere Overlap.
      AIN(11)=6.
      IAIN(12)=2
      AIN(13)=.35
      CALL ZVMINO
      IF (IERR .NE. 0) GO TO 9990
C
C                            Wenn das Seitenverhaeltnis des Zeichenfeldes
C                            hochformatig, drehe um 90 Grad.
C
  845 IF (CONST(8) .LE. CONST(9)) THEN
        IAIN(1)=3
        AIN(2)=90.
        NTYP=2
        CALL ZVK
C                            DKSV
        NTYP=13
        CALL ZVK
C                            Wenn jetzt die achse nach hinten geneigt
C                            ist, drehe um die y-achse um 180 grad.
        NTRY=28
        DO  NC=2,3
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 9990
          X(3,NC)=X2(3)
        ENDDO
        IF (X2(3) .LT. X(3,2)) THEN
          IAIN(1)=2
          AIN(2)=180.
          NTYP=2
          ISKP(14)=1
          CALL ZVK
        ENDIF
      ENDIF
C                            Soll zelle generiert werden?
  850 CONTINUE
      IF (IZFLG .NE. 0) THEN
        ISKP(14)=1
        CALL ZVGNZL
      ENDIF
C                            Bestimme Faktor.
C
      IF (IOPT .LE. 0) GO TO 9990
C
  860 NTYP=1
      CALL ZVFKTR
      GO TO 9990
C                            Finde Zellinhalt.
C
  970 IF (NTYP-6) 980,1040,1100
  980 ICDS(4)=1
      ICDS(5)=ISKP(53)
      ICDS(6)=NAT(NS)
      CDS(1)=.5
      CDS(2)=.5
      CDS(3)=.5
CYENG1
      CALL FLES (ICDS,ISKP(31),5H3F3CE,22Hdx,dy,dz,c(ur),n1,n2?$)
CYENG2
CYENGY      CALL FLES (ICDS,ISKP(31),5H3F3CE,22Hdx,dy,dz,c(or),n1,n2?$)
      DO  I=1,3
        X(I,7)=CDS(I)
      ENDDO
      IZ1=ICDS(5)
      IZ2=ICDS(6)
      ICDS(1)=ICDS(4)
      INBFR(3)=ICDS(5)
      INBFR(4)=ICDS(6)
      IF (INBFR(3) .LE. 0 .OR. INBFR(4) .GT. NAT(NS) .OR.
     +  INBFR(3) .GT. INBFR(4)) THEN
        IERR=54 0423 16
        GO TO 9999
      ENDIF
C
      INBFR(2)=IELMH
      NTRY=24
      NC=1
      CALL ZVDEK
      IF (IERR .EQ. 0) GO TO 60
      GO TO 9999
C                            Kommando FMMC - Maximalzahl an Codes
C
CYENG1
 1040 CALL FLES (ISKP(23),ISKP(31),2HIE,10HMax. Nr.?$)
CYENG2
CYENGY 1040 CALL FLES (ISKP(23),ISKP(31),2HIE,10HMax. No.?$)
      GO TO 9999
C                            FMOP - Optionsbits
 1100 DO  I=1,5
        IAIN(I)=IBLANK
      ENDDO
      CALL FLES (IAIN,ISKP(31),6HAAAAAE,
     1 32HOpt (Z/NZ,S/NS,P/NP,A/NA,F/NF)?$)
      CALL CNVTUP (IAIN,1,16)
      I=0
      J=0
      CALL FCNV (IAIN(6),ISKP(31),2HIE,AIN,I,4,J)
      IF (J .EQ. 0) THEN
        ISKP(1)=IAIN(6)
        GO TO 9999
      ENDIF
      DO  I=1,5
        K=1
        DO  J=1,5
          K2=31-K
          K3=K
          IF (LCOMPS(IAIN(I),1,2, IOPTT,2*J-1)) 1120,1140,1120
 1120     IF (LCOMPS(IAIN(I),1,2, IOPTT,2*J+9)) 1150,1130,1150
 1130     K3=0
 1140     CONTINUE
CYVAX1
C         ISKP(1)=ISKP(1).AND.K2
CYVAX2
CYVAXY
          ISKP(1)=IAND(ISKP(1),K2)
          ISKP(1)=ISKP(1)+K3
 1150     K=K*2
        ENDDO
      ENDDO
      GO TO 9999
C
 9990 ISKP(14)=0
C
 9999 RETURN
      END
