C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPGUMN   56             -------------------
                          SUBROUTINE ZVGUMN
C  CY-ENG-               -------------------
C
C                Geschrieben:  231515 JAN 1986  (Hundt)
C                Geaendert:    141557 JUN 2004  (Hundt)
C
C   Das Programm generiert verschiedene Umgebungen (Tetraeder, ...)
C
C   NTYP = 1  GDTU - Generiere drei Atome in tetraedrischer Umgebung
C   NTYP = 2  GZTU - Generiere zwei Atome in tetraedrischer Umgebung
C   NTYP = 3  GPHU - Generiere Atome in Phenyl-Umgebung
C   NTYP = 4  GETU - Generiere ein Atom in tetraedrischer Umgebung
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 INBFR(10),IAIN(72),IEBFR(10),INPHE(9)
      INTEGER *4 I,ISKP14,J,NATS,NCDS,NCNT,NTYPS
      REAL    *4 BFR(10),CDS(7),ANPHE(9),AEBFR(10),TEMP,TEMP2
C
      EQUIVALENCE (INBFR(1),BFR(1)),(ICDS(1),CDS(1)),(AIN(1),IAIN(1))
      EQUIVALENCE (INPHE(1),ANPHE(1)),(IEBFR(1),AEBFR(1))
C
      SAVE INBFR,BFR,INPHE,ANPHE,IEBFR,AEBFR
C
      DATA INBFR(3)/4HH   /
      DATA INBFR(4)/4H    /
      DATA   BFR(5)/0.2/
      DATA   BFR(6)/1.08/
      DATA   BFR(7)/109.471/
      DATA INBFR(9)/3/
C
      DATA ANPHE(7)/4HH   /
      DATA ANPHE(8)/.2/
      DATA ANPHE(9)/1.08/
C
      DATA IEBFR(2)/4HH   /
      DATA IEBFR(3)/4H    /
      DATA AEBFR(4)/0.2/
      DATA AEBFR(5)/1.08/

C                            Hole Eingabe
      NTYPS=NTYP
C
      IF (NTYPS-2) 10,10,350
C                            GDTU, GZTU
   10 INBFR(1)=0
      INBFR(2)=0
      INBFR(8)=0
      INBFR(9)=ISKP(53)
      INBFR(10)=NAT(NS)
      CALL FLES (INBFR,ISKP(31),9H2CAA3F3CE,
CYENG1
     1 35HCz,Cn,Name,Untr.,r,l,w,Ch,von,bis?$)
CYENG2
CYENGY     1 34HCz,Cn,name,ext.,r,l,w,Ch,from,to?$)
C
C                            Teste Eingabe
      I=1
   11 J=I
   12 IF (INBFR(J) .EQ. 0) THEN
        NTYP=7
        INBFR(J)=I
        CALL ZVGC01 (INBFR(J))
      ENDIF
      I=I+1
      IF (I-3) 11,13,16
   13 J=8
      GO TO 12
C
   16 IF ((INBFR(9) .LE. 0) .OR. (INBFR(9) .GT. INBFR(10)) .OR.
     1 (INBFR(10) .GT. NAT(NS)) .OR. (INBFR(1) .EQ. 0)) THEN
        IERR=56005016
        GO TO 999
      ENDIF
C                            Save Koordinatensystem
   60 NTYP=19
      CALL ZVK
      ISKP14=ISKP(14)
      ISKP(14)=1
C                            Teste, ob ein Nachbar angegeben wurde
      IF (INBFR(2)) 130,90,130
C                            Nicht angegeben. Suche selber.
   90 NCDS=NCD(NS)+1
      ICDS(1)=INBFR(1)
      ICDS(2)=INBFR(1)
      ICDS(3)=INBFR(9)
      ICDS(4)=INBFR(10)
      CDS(5)=3.0
      CDS(6)=.001
      NTYP=3
      CALL ZVAWTB
      IF (ICDS(7)+NTYPS-1-NCDS) 100,120,120
  100 CALL KPCDST (ISKP(80),1,INBFR(1))
      WRITE (WRLINE,110) (ISKP(I),I=80,82)
      CALL KPWRTE (NTDISP)
  110 FORMAT ('ZVGUMN0110 - ',
CYENG1
     1 'Atom ',2A4,A3,'hat zu wenige Nachbarn.')
CYENG2
CYENGY     1 'Atom ',2A4,A3,'has not enough neigbours.')
      GO TO 320
C                            Das naechste gefundene:
  120 INBFR(2)=ICD(NCDS,NS)
C                            Definiere Koordinatensystem
  130 ICDS(1)=INBFR(1)
      ICDS(3)=INBFR(1)
      IF (NTYPS-2) 210,140,140
  140 IF (INBFR(8)) 150,150,160
  150 INBFR(8)=ICD(NCDS+1,NS)
C                            Bestimme Schwerpunkt
  160 ICDS(6)=INBFR(2)
      ICDS(7)=INBFR(8)
      NTRY=24
      DO 170 NC=6,7
  170 CALL ZVDEK
      IF (NAT(NS)-NATDM) 180,290,290
  180 NAT(NS)=NAT(NS)+1
      DO 190 I=1,3
  190 AT(I,NAT(NS),NS)=(X(I,6)+X(I,7))*.5
C
      ICDS(2)=NAT(NS)
      ICDS(4)=INBFR(2)
      ICDS(5)=INBFR(8)
      NTYP=1
      CALL ZVK
      NAT(NS)=NAT(NS)-1
      IF (IERR) 240,200,240
  200 IAIN(1)=2
      ICDS(7)=2
      CDS(6)=180.
      AIN(2)=BFR(7)*.5
      PFREI(1)=BFR(6)
      GO TO 270
C
  210 NCNT=0
      ICDS(2)=INBFR(2)
      ICDS(5)=INBFR(8)
      ICDS(4)=0
      IF (INBFR(8)) 220,230,220
  220 ICDS(4)=INBFR(1)
C
  230 NTYP=1
      CALL ZVK
      IF (IERR) 240,260,240
  240 WRITE (WRLINE,250)
      CALL KPWRTE (NTDISP)
  250 FORMAT ('ZVGUMN0250 - ',
CYENG1
     1 'Koordinatensystem kann nicht definiert werden.')
CYENG2
CYENGY     1 'Unable to define a coordinate system.')
      GO TO 320
C                            Koordinatensystem ist definiert.
  260 IAIN(1)=3
      ICDS(7)=3
      CDS(6)=120.
      AIN(2)=BFR(7)
      PFREI(1)=-BFR(6)
  270 PFREI(2)=0.
      PFREI(3)=0.
      I=1
  280 NTYP=5
      CALL ZVGE01
      IAIN(1)=1
      AIN(2)=CDS(6)
      IF (NAT(NS)-NATDM) 300,290,290
  290 IERR=56029002
      GO TO 990
C
  300 NAT(NS)=NAT(NS)+1
      DO 310 J=1,3
  310 AT(J,NAT(NS),NS)=PTRIKL(J)
      AT(4,NAT(NS),NS)=BFR(5)
      AT(5,NAT(NS),NS)=BFR(3)
      AT(6,NAT(NS),NS)=BFR(4)
      AT(7,NAT(NS),NS)=BFR(3)
      CALL CNVTUP (AT(7,NAT(NS),NS),1,4)
      ICLRP(NAT(NS),NS)=0
      IPFLG(NAT(NS),NS)=0
      I=I+1
      IF (I-ICDS(7)) 280,280,320
C
C                            Restore Koordinatensystem
  320 NTYP=20
      CALL ZVK
      GO TO 990
C
C                            GPHU - Generiere Phenyl-Wasserstoffe
  350 IF (NTYPS-4) 355,500,999
  355 DO  I=1,6
        INPHE(I)=0
      ENDDO
      CALL FLES (INPHE,ISKP(31),6H6CA2FE,
     1 23Hc1,c2,...,c6,name,r,l?$)
      IF (ISKP(31) .LT. 6) THEN
        IERR=56037016
        GO TO 999
      ENDIF
C                            Berechne Schwerpunkt
      NATS=NAT(NS)
      NAT(NS)=NAT(NS)+6
      IF (NAT(NS) .GT. NATDM) THEN
        IERR=56040002
        NAT(NS)=NATS
        GO TO 999
      ENDIF
C
      NTRY=24
      DO  NC=1,6
        IF (INPHE(NC) .EQ. 0) THEN
          NTYP=7
          INPHE(NC)=NC
          CALL ZVGC01 (INPHE(NC))
        ENDIF
        ICDS(NC)=IABS(INPHE(NC))
        CALL ZVDEK
        IF (IERR .NE. 0) THEN
          NAT(NS)=NATS
          GO TO 999
        ENDIF
      ENDDO
      DO  I=1,3
        TEMP=0.
        DO  J=1,6
          TEMP=TEMP+X(I,J)
        ENDDO
        AT(I,NAT(NS),NS)=TEMP*0.166667
      ENDDO
C
      ISKP14=ISKP(14)
      ISKP(14)=1
      DO  I=1,6
        IF (INPHE(I) .GT. 0) THEN
          NC=2
          ICDS(NC)=INPHE(I)
          NTRY=28
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 490
          DO  J=1,3
            PFREI(J)=X2(J)
          ENDDO
          NATS=NATS+1
          AT(4,NATS,NS)=ANPHE(8)
          AT(5,NATS,NS)=ANPHE(7)
          AT(6,NATS,NS)=AT(6,IANR,NS)
          AT(7,NATS,NS)=ANPHE(7)
          CALL CNVTUP (AT(7,NATS,NS),1,4)
          ICLRP(NATS,NS)=0
          IPFLG(NATS,NS)=0
          ICDS(1)=NAT(NS)
          CDS(3)=ANPHE(9)
          NTYP=3
          CALL ZVGE03
          DO  J=1,3
            AT(J,NATS,NS)=PTRIKL(J)
          ENDDO
          IF (IERR .NE. 0) GO TO 490
        ENDIF
      ENDDO
  490 NAT(NS)=NATS
      GO TO 990
C                       GETU - Generiere ein Atom in tetr. Umgebung
  500 IEBFR(6)=100000
      IEBFR(9)=ISKP(53)
      IEBFR(10)=NAT(NS)
      ISKP14=ISKP(14)
C
      CALL FLES (IEBFR,ISKP(31),8HCAA2F5CE,
CYENG1
     + 40HCz,Name,Unter.,r,l,ch1,ch2,ch3,von,bis?$)
C         1  2    3      4 5 6   7   8   9   10
CYENG2
CYENGY     + 38HCz,name,ext.,r,l,ch1,ch2,ch3,from,to?$)
      IF (ISKP(31)) 510,510,520
  510 IERR=56051016
      GO TO 999
C                       Nachbarn selber suchen
  560 NCDS=NCD(NS)
      ISKP(14)=1
      ICDS(1)=IEBFR(1)
      ICDS(2)=IEBFR(1)
      ICDS(3)=IEBFR(9)
      ICDS(4)=IEBFR(10)
      CDS(5)=3.0
      CDS(6)=.001
      NTYP=3
      CALL ZVAWTB
  561 CONTINUE
      IF (ICDS(7)-NCDS .GE. 3) GO TO 570
      CALL KPCDST (ISKP(80),1,ICDS(1))
      WRITE (WRLINE,110) (ISKP(I),I=80,82)
      CALL KPWRTE (NTDISP)
      GO TO 990
C
  570 NTRY=28
      DO 590 NC=6,8
      IEBFR(NC)=ICD(NCDS+NC-5,NS)
  590 CONTINUE
C
  520 I=1
      NTYP=7
      NTRY=28
      DO 550 NC=1,4
      ICDS(NC)=IEBFR(I)
      IF (ICDS(NC) .NE. 0) GO TO 530
      ICDS(NC)=NC
      CALL ZVGC01 (ICDS(NC))
      IEBFR(I)=ICDS(NC)
  530 CALL ZVDEK
      IF (IERR .NE. 0) GO TO 990
      DO 540 J=1,3
  540 X(J,NC)=X2(J)
      I=I+1
      IF (I .NE. 2) GO TO 550
      I=6
      IF (IEBFR(I) .LE. NATDM) GO TO 550
      IF (IEBFR(I) .LE. 100000) GO TO 560
  550 CONTINUE
C                       Berechne Vektoren und normiere
  600 DO 640 I=2,4
      TEMP2=0.
      DO 610 J=1,3
      TEMP=X(J,I)-X(J,1)
      X(J,I)=TEMP
      TEMP2=TEMP2+TEMP*TEMP
  610 CONTINUE
      IF (TEMP2 .GT. 0.) GO TO 620
      IERR=56061006
      GO TO 990
C
  620 TEMP2=1./SQRT(TEMP2)
      DO 630 J=1,3
  630 X(J,I)=X(J,I)*TEMP2
  640 CONTINUE
C
      TEMP2=0.
      DO 641 I=1,3
      TEMP=X(I,2)+X(I,3)+X(I,4)
      X1(I)=TEMP
      TEMP2=TEMP2+TEMP*TEMP
  641 CONTINUE
      IF (TEMP2 .GT. 0.) GO TO 642
      IERR=56064106
      GO TO 990
C
  642 TEMP=AEBFR(5)/SQRT(TEMP2)
      DO 650 I=1,3
  650 PFREI(I)=X(I,1)-X1(I)*TEMP
      NTYP=15
      CALL ZVGE01
C
      IF (NAT(NS) .LT. NATDM) GO TO 660
      IERR=56065002
      GO TO 990
C
  660 NAT(NS)=NAT(NS)+1
      AT(4,NAT(NS),NS)=AEBFR(4)
      AT(5,NAT(NS),NS)=AEBFR(2)
      AT(6,NAT(NS),NS)=AEBFR(3)
      AT(7,NAT(NS),NS)=AEBFR(2)
      CALL CNVTUP (AT(7,NAT(NS),NS),1,4)
      DO  I=1,3
        AT(I,NAT(NS),NS)=PTRIKL(I)
      ENDDO
      ICLRP(NAT(NS),NS)=0
      IPFLG(NAT(NS),NS)=0
C
  990 ISKP(14)=ISKP14
C
  999 RETURN
      END
