C                  ---------------------------------
                    SUBROUTINE UPLINF (ARRAY,NSTEU)
C                  ---------------------------------
C
C  Das Programm UPLINF (Neufassung von UDRAW) soll verhindern, dass
C  beim Plotten verdeckte Linien gezeichnet werden.  Hierzu wird das
C  Zeichenfeld mit einem Punktraster (gespeichert auf der Matrix
C  "MATRIX(IXDIM/KBIT,IYDIM)") von Bits ueberdeckt.  Die Bereiche,
C  auf denen die Bits auf 1 gesetzt sind, gelten als "gesperrt",
C  d.h., in diese Bereiche darf nicht hineingezeichnet werden.
C
C  Bei Polygonen wird waehrend des Zeichnens wird der Umriss der
C  Figur gespeichert.  Dieses muss konvex sein.  Am Ende (NSTEU=21)
C  wird dann der Umriss auf das Punktraster uebertragen.
C
C
C                 Geschrieben: 200857 FEB 84  (Hundt)
C                 Neufassung:  300855 JAN 93  (Hundt)
C                 Geaendert:   170804 FEB 93  (Hundt)
C
C                 ----------------------------------
C
C
      IMPLICIT NONE
C
      INTEGER*4 IXDIM,IYDIM,KBIT,NTOUT,NSTEU,IPOLDM,MATDIM
      PARAMETER (IXDIM=3200,IYDIM=3200,KBIT=32,IPOLDM=151)
      PARAMETER (MATDIM=IXDIM/KBIT*IYDIM)
      INTEGER*4 KNEGZ
      PARAMETER (KNEGZ=-2147483647-1)
C
      INTEGER*4 MATRIX(IXDIM/KBIT,IYDIM),MATPRT(2,IYDIM),MATEQ(MATDIM)
      INTEGER*4 L1,L2,L3,L4,NRET
      INTEGER*4 ITAB(KBIT),ITABL(KBIT),ITABR(KBIT)
      INTEGER*4 NPROT,IZCHN,I,J,JE,K,IXMIN,IYMIN,IXMAX,IYMAX
      INTEGER*4 IPENUP,IXV,IYV,IXN,IYN,IXED,IYED,IXD,IYD,IX1,IY1
      INTEGER*4 IXALT,IYALT,MATP1J,MATP2J,IW,IW2,IB,IB2,INC
      INTEGER*4 IERSTP,ITEMP,IPERIM,IPOLPO,IPOLGO,IPOLPI
C
      REAL*4    XDIM,YDIM,AI,PERIM
      REAL*4    ARRAY(1),AKOALT(2),AKONEU(2),AKOPNT(2)
      REAL*4    XALT,YALT,XNEU,YNEU,POLGN(2,IPOLDM)
      REAL*4    PNT1,PNT2,PNT,A1,A2,AA1,AA2,BB1,BB2
C
c     save
      SAVE MATRIX,MATPRT,A1,A2,IYMIN,IYMAX,AKOALT
      SAVE NPROT,IZCHN,ITAB,ITABL,ITABR,IXALT,IYALT
      SAVE IPERIM,POLGN,IPOLPO,XDIM,YDIM,IXV,IYV
C
      EQUIVALENCE (I,AI),(IPERIM,PERIM),(MATRIX(1,1),MATEQ(1))
      EQUIVALENCE (AKOALT(1),XALT),(AKOALT(2),YALT)
      EQUIVALENCE (AKONEU(1),XNEU),(AKONEU(2),YNEU)
      EQUIVALENCE (AKOPNT(1),PNT1),(AKOPNT(2),PNT2)
C
      DATA NTOUT/6/,L1/1/,L2/2/,L3/3/,L4/4/
      DATA XDIM/21.0/,YDIM/13.0/
C
      DATA ITAB/KNEGZ,1073741824,536870912,268435456,
     1 134217728,67108864,33554432,16777216,8388608,4194304,2097152,
     2 1048576,524288,262144,131072,65536,32768,16384,8192,4096,2048,
     3 1024,512,256,128,64,32,16,8,4,2,1/
C
      DATA ITABL/KNEGZ,-1073741824,-536870912,-268435456,
     1 -134217728,-67108864,-33554432,-16777216,-8388608,-4194304,
     2 -2097152,-1048576,-524288,-262144,-131072,-65536,-32768,-16384,
     3 -8192,-4096,-2048,-1024,-512,-256,-128,-64,-32,-16,-8,-4,-2,-1/
C
      DATA ITABR/-1,2147483647,1073741823,536870911,268435455,134217727,
     1 67108863,33554431,16777215,8388607,4194303,2097151,1048575,
     2 524287,262143,131071,65535,32767,16383,8191,4095,2047,1023,
     3 511,255,127,63,31,15,7,3,1/
C
C
      IF (NSTEU .LE. 0  .OR.  NSTEU .GT. 27) GO TO 990
      GO TO (10,170,110, 30, 30, 30,990,990,990,990,990,990,990,660,
C             1   2   3   4   5   6   7   8   9  10  11  12  13  14
     1 990,990,670,990,990,990,800,770,760,840,990,990,661), NSTEU
C       15  16  17  18  19  20  21  22  23  24  25  26  27
C
C                         ---------------------
C                          INITIALISIERUNG (1)
C                         ---------------------
C
C                            Generiere Tabellen
   10 CONTINUE
C                            Loesche MATRIX und MATPRT
   30 DO  I=1,MATDIM
        MATEQ(I)=0
      ENDDO
      DO  I=1,IYDIM
        MATPRT(1,I)=IXDIM+1
        MATPRT(2,I)=0
      ENDDO
      IYMIN=IYDIM+1
      IYMAX=0
      IF (NSTEU .GE. 4  .AND.  NSTEU .LE. 6) GO TO 990
C
C                            Polygon mit Umrisslinien.
      IPERIM=1
C                            Kein Polygon im Speicher.
      IPOLPO=0
C                            Berechne Transformationskonstanten fuer
C                            die Umrechnung Real -> Integer-Koordinaten
   60 IF (XDIM) 80,80,70
   70 A1=FLOAT(IXDIM-1)/XDIM
      IF (YDIM) 80,80,100
   80 WRITE (NTOUT,90) XDIM,YDIM
   90 FORMAT (' *UPLOT*   Feldbegrenzung unbrauchbar:',2F10.2)
      GO TO 999
C
  100 A2=FLOAT(IYDIM-1)/YDIM
      IF (NSTEU .EQ. 27) GO TO 999
      GO TO 990
C
C                       Setze bei ARRAY(1),ARRAY(2) auf.
C
C                            Uebernimm Koordinaten.
  110 IPOLGO=0
      XALT=ARRAY(L1)
      YALT=ARRAY(L2)
  120 IPENUP=1
C                            Berechne Integer-Koordinaten.
C                            Fange Randueberschreitung auf.
      IXV=IFIX(A1*XALT)+1
      IF (IXV .LE. 0) IXV=1
      IF (IXV .GT. IXDIM) IXV=IXDIM
      IYV=IFIX(A2*YALT)+1
      IF (IYV .LE. 0) IYV=1
      IF (IYV .GT. IYDIM) IYV=IYDIM
      IF (IPOLGO .EQ. 0) GO TO 999
      GO TO 810
C
C
C        Ziehe eine Linie zu dem Punkt mit den Koordinaten x,y.
C
C                            Uebernimm Koordinaten.
  170 IPOLGO=0
      IZCHN=1
      NPROT=0
      XNEU=ARRAY(L1)
      YNEU=ARRAY(L2)
C                            Berechne Integer-Koordinaten und fange
C                            Randueberschreitung auf.
  180 IXN=IFIX(A1*XNEU)+1
      IF (IXN .LE. 0) IXN=1
      IF (IXN .GT. IXDIM) IXN=IXDIM
      IYN=IFIX(A2*YNEU)+1
      IF (IYN .LE. 0) IYN=1
      IF (IYN .GT. IYDIM) IYN=IYDIM
C
C                            Berechne Differenzen
      IXED=IXN-IXV
      IXD=IXED
      IYED=IYN-IYV
      IYD=IYED
C                            Setze Incremente
      IX1=1
      IF (IXD) 250,260,260
  250 IX1=-1
      IXD=-IXD
  260 IXD=IXD+1
C                            dto. fuer y
      IY1=1
      IF (IYD) 270,280,280
  270 IY1=-1
      IYD=-IYD
  280 IYD=IYD+1
C                            Setze Erstpunkt-Flag
      IERSTP=1
C                            Mache Groessenvergleich
C
      IF (IXD-IYD) 330,290,310
C
C                            Teste bei Gleichheit ob nur ein Punkt
  290 IF (IXED) 310,300,310
  300 NRET=-1
      GO TO 440
C                            Delta x ist groesser
  310 INC=IYD
      NRET=0
C                            Teste, ob gezeichnet wird
      IF (IZCHN) 320,440,320
  320 PNT1=IXED
      PNT2=IXV
      GO TO 350
C                            Delta y ist groesser
  330 INC=IXD
      NRET=1
C                            Teste, ob gezeichnet wird
      IF (IZCHN) 340,440,340
  340 PNT1=IYED
      PNT2=IYV
C                            Transformationskonstanten fuer Rechnung
C                            Integer -> Real
  350 AA1=(XNEU-XALT)/PNT1
      AA2=(YNEU-YALT)/PNT1
      BB1=XALT-AA1*PNT2
      BB2=YALT-AA2*PNT2
      GO TO 440
C                            Erzeuge neue Kooedinaten
  360 IERSTP=0
  370 IF (NRET) 620,380,410
C                            Teste, ob fertig
C
  380 IF (IXV-IXN) 390,620,390
  390 IXV=IXV+IX1
      INC=INC+IYD
      ITEMP=INC-IXD
      IF (ITEMP) 440,440,400
  400 INC=ITEMP
      IYV=IYV+IY1
      GO TO 440
C                            Teste, ob fertig.
C
  410 IF (IYV-IYN) 420,620,420
  420 IYV=IYV+IY1
      INC=INC+IXD
      ITEMP=INC-IYD
      IF (ITEMP) 440,440,430
  430 INC=ITEMP
      IXV=IXV+IX1
C                            Teste, ob protokolliert wird.
  440 IF (NPROT) 450,460,450
C                            Merke kleinstes und groesstes x und y.
C
  450 MATPRT(1,IYV)=MIN0(MATPRT(1,IYV),IXV)
      MATPRT(2,IYV)=MAX0(MATPRT(2,IYV),IXV)
      IYMIN=MIN0(IYMIN,IYV)
      IYMAX=MAX0(IYMAX,IYV)
C                            Teste, ob gezeichnet wird.
  460 IF (IZCHN) 470,370,470
C                            Ja.  Teste, ob der Punkt besetzt ist.
  470 IW=(IXV-1)/KBIT
      IB=IXV-KBIT*IW
      IF (IAND(MATRIX(IW+1,IYV),ITAB(IB))) 550,480,550
C      IF ((MATRIX(IW+1,IYV) .AND. ITAB(IB))) 550,480,550
C
C                            Punkt nicht besetzt
  480 IF (IPENUP) 490,540,490
C                            Pen down hier
  490 IF (NRET) 500,510,520
C                            Keine Tr.-Konstanten bestimmt
  500 CALL UPLINV (AKOALT,3)
      IPENUP=0
      GO TO 640
C                            x umrechnen
  510 PNT=IXV
      GO TO 530
C                            y umrechnen
  520 PNT=IYV
C                            Posioniere Pen hier
  530 PNT1=AA1*PNT+BB1
      PNT2=AA2*PNT+BB2
      CALL UPLINV (AKOPNT,3)
      IPENUP=0
C                            Merke alte I-Koordinaten
  540 IXALT=IXV
      IYALT=IYV
      GO TO 360
C                            Punkt ist besetzt.  Pen oben?
  550 IF (IPENUP) 360,560,360
C                            Erster I-Punkt?
  560 IF (IERSTP) 610,570,610
C                            Pline zum letzten gemerkten Punkt
  570 IF (NRET) 610,580,590
C                            x umrechnen
  580 PNT=IXALT
      GO TO 600
C                            y umrechnen
  590 PNT=IYALT
C                            Linie hierhin
  600 PNT1=AA1*PNT+BB1
      PNT2=AA2*PNT+BB2
      CALL UPLINV (AKOPNT,2)
C                            Pen up
  610 IPENUP=1
      GO TO 360
C                            Alle I-Koordinaten abgearbeitet.
  620 IF (IZCHN) 630,650,630
  630 IF (IPENUP) 650,640,650
C                            Pline hierher
  640 CALL UPLINV (AKONEU,2)
C                            Merke Koordinaten
  650 XALT=XNEU
      YALT=YNEU
      IF (IPOLGO .EQ. 0) GO TO 999
      GO TO 810
C                            Zeichenfeldabmessung (14)
  660 XDIM=ARRAY(2)
      YDIM=ARRAY(4)
      GO TO 60
C                            Zeichenfeldabmessung (27)
  661 XDIM=ARRAY(1)
      YDIM=ARRAY(2)
      GO TO 60
C                            Report Treibertyp (17)
  670 I=-1
      ARRAY(1)=AI
      GO TO 999
C                            Sperre Matrixflaeche
C
  680 IF (IYMIN-IYMAX) 690,690,999
  690 DO 750 I=IYMIN,IYMAX
      J=MATPRT(1,I)
      K=MATPRT(2,I)
      IF (J-K) 700,700,750
  700 IW=(J-1)/KBIT
      IB=J-KBIT*IW
      IW2=(K-1)/KBIT
      IB2=K-KBIT*IW2
      IW2=IW2+1
      J=ITABR(IB)
      GO TO 730
C
  710 CONTINUE
      J=IAND(J,ITABL(IB2))
C      J=(J .AND. ITABL(IB2))
  720 CONTINUE
      MATRIX(IW,I)=IOR(J,MATRIX(IW,I))
C      MATRIX(IW,I)=(J .OR. MATRIX(IW,I))
      J=ITABR(1)
  730 IW=IW+1
      IF (IW-IW2) 720,710,740
C                            Clear an dieser Stelle
  740 MATPRT(1,I)=IXDIM+1
      MATPRT(2,I)=0
C
  750 CONTINUE
      IYMIN=IYDIM+1
      IYMAX=0
      IPOLPO=0
      GO TO 999
C                            Polygon entgegennehmen.
  760 IPOLPO=0
  770 IF (IPOLPO .LT. IPOLDM) GO TO 790
      WRITE (NTOUT,780)
  780 FORMAT (' UPLOT - Polygon hat zu viele Punkte.')
      GO TO 999
C
  790 IPOLPO=IPOLPO+1
      POLGN(1,IPOLPO)=ARRAY(L1)
      POLGN(2,IPOLPO)=ARRAY(L2)
      GO TO 999
C
  800 IF (IPOLPO .LE. 0) GO TO 999
      IPOLGO=1
      NPROT=1
      IZCHN=IPERIM
      IPOLPI=1
      XALT=POLGN(1,1)
      YALT=POLGN(2,1)
      GO TO 120
C
  810 IPOLPI=IPOLPI+1
      IF (IPOLPI-IPOLPO-1) 820,830,680
  820 XNEU=POLGN(1,IPOLPI)
      YNEU=POLGN(2,IPOLPI)
      GO TO 180
C
  830 XNEU=POLGN(1,1)
      YNEU=POLGN(2,1)
      GO TO 180
C                           Perimeter definieren (24)
  840 PERIM=ARRAY(1)
      GO TO 999
C
  990 CALL UPLINV (ARRAY,NSTEU)
  999 RETURN
      END
