C                    ------------------------------
                      SUBROUTINE ZVORPA (ITOM,IRC)
C                    ------------------------------
C
C                     V E K T O R V E R S I O N
C                GESCHRIEBEN: 131546 NOV 1997 (HUNDT)
C                GEAENDERT:   151043 SEP 2003 (HUNDT)
C
      IMPLICIT NONE
      INTEGER *4 IRC
C
C---- Das programm zeichnet ein Ellipsoid, das an der Etelle ITOM in
C     der Liste ATOMS steht.  Die Plotparameter werden dem Bereich
C     IATF entnommen.  Bei erfolgreichem Plot wird IRC
C     auf einen Wert ungleich Null gesetzt.
C
      INTEGER *4 NFIRST,NPLANE,NSOLID,NDOT,LINES,NDASH,ITYP
      INTEGER *4 I,J,K,L,M,N,ITOM,IT1,NRESOL,NBIS,NRES1,IIFLG
      INTEGER *4 II,II0,II1,II2,NCYCLE,NCOLPO,IRLINE(30)
      REAL    *4 EYE(3),VIEWV(3),XX(3),Z(3),T1,T2,T3,T4,T5
      REAL    *4 VV,VMV,H
C
      INCLUDE 'KPORC.INC'
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      REAL   *4 AATF(17,IATFDM)
C
      EQUIVALENCE (IATF(1,1),AATF(1,1)),(NCOLPO,ISKP(61))
      EQUIVALENCE (WRLINE,IRLINE(1))
C
C                            DEFINITION GRAPHISCHER EINZELHEITEN.
      ITILT=0
      NG=0
      NFIRST=1
C                            Wird nur geputzt?
C
      IF (ICDS(6) .EQ. 0) THEN
        IF (T(1) .LT. 0.) GO TO 870
        NPLANE=1
        NSOLID=0
        LINES=0
        NDASH=0
      ELSE
        NPLANE=IATF(11,NCOLPO)
        NSOLID=IATF(12,NCOLPO)
        LINES=IATF(13,NCOLPO)
        NDASH=IATF(14,NCOLPO)
      ENDIF
C
      IF (NPLANE .EQ. 1) THEN
        NFIRST=4
        NPLANE=4
      ENDIF
      NDOT=64/2**(IABS(NSOLID))
C
C---- DEFINITION DES AUGPUNKTES ALS REFERENZPUNKT.
C
      T1=1.E6
      IF (HOE .GT. 0.) T1=HOE
      DO  J=1,3
        EYE(J)=REFV(J,3,NS)*T1+UR(J,NS)
      ENDDO
C                            HOLE ATOM AUS LISTE
      IT1=ICD(ITOM,NS)
      CALL XYZ (IT1,XX,2)
      IF (NG .NE. 0) GO TO 190
      CALL PLTXY (XX,Z)
C
  260 IF (NPLANE .LE. 0.) GO TO 870
C
C---- HAUPTACHSEN DER ELLIPSOIDE IN RICHTUNG BETRACHTER.
C
      CALL PAXES (IT1,2)
      IF (NG .NE. 0) GO TO 190
      CALL DIFV (EYE,XT,VIEWV)
      CALL UNIT (VIEWV,VIEWV,-1)
      CALL VM (VIEWV,AA,V2)
      DO  I=1,3
        IF (VV(V2,PAT(1,I)) .LT. 0.) THEN
          DO  J=1,3
            PAC(J,I)=-PAC(J,I)
            PAT(J,I)=-PAT(J,I)
          ENDDO
        ENDIF
      ENDDO
      DO  J=1,3
        PAC(J,4)=PAC(J,1)
        PAC(J,5)=PAC(J,2)
      ENDDO
C
C---- V4 IST DER NORMALENVEKTOR ZUR POLAREBENE.
C
      CALL VM (VIEWV,AAWRK,V6)
      CALL UNIT (V6,V6,1)
      CALL MV (Q,V6,V4)
      CALL UNIT (V4,V4,1)
C
C---- SETZE DIE AUFLOESUNG FUER DIE STUETZPUNKTE ZUM ZEICHNEN DER
C     ELLIPSIODE.
C
      T3=RMS(3)*SCL
      NRESOL=1
      NBIS=5
      DO  J=1,3
        IF (T3 .GE. RES(J)) GO TO 380
        NBIS=NBIS-1
        NRESOL=NRESOL*2
      ENDDO
  380 NRES1=NRESOL+1
C
C---- SCHLEIFE DURCH DIE HAUPT- UND DIE POLAREBENEN.
C
      IIFLG=0
C      DO 860 II=NFIRST,NPLANE
  382 II=NFIRST-1
  381 II=II+1
      II0=MOD(II+2,3)+1
      II1=MOD(II,3)+1
      II2=MOD(II+1,3)+1
C
C---- ERZEUGE KONJUGIERTE DURCHMESSER.
C
      IF (.99938 .LE. ABS(VV(V4,PAC(1,II2)))) THEN
        T1=RMS(II0)*SCL
        T2=RMS(II1)*SCL
        DO  J=1,3
          DA(J,1)=PAC(J,II0)*T1
          DA(J,2)=PAC(J,II1)*T2
        ENDDO
        GO TO 490
      ENDIF
      CALL NORM (PAC(1,II0),PAC(1,II1),V1,1)
      CALL NORM (V1,V4,V2,1)
      CALL UNIT (V2,V2,1)
      CALL MV (Q,V2,V3)
      IF (II .LT. 4) THEN
        CALL NORM (V3,V1,V5,1)
      ELSE
        CALL NORM (V3,V4,V5,1)
      ENDIF
      CALL UNIT (V5,V5,1)
      H=VMV(V2,Q,V2)
      IF (H .LE. 1.E-5) GO TO 480
      T1=SCL/SQRT(H)
      H=VMV(V5,Q,V5)
      IF (H .LE. 1.E-5) GO TO 480
      T2=SCL/SQRT(H)
      DO  J=1,3
        DA(J,1)=V2(J)*T1
        DA(J,2)=V5(J)*T2
      ENDDO
      GO TO 490
C
  480 NG=18
      WRITE (WRLINE,'(A,10X,A)')
CYENG1
     1 'ZVORPA0155 - Skalierung von',' nicht durchfuehrbar.'
CYENG2
CYENGY     1 'KPORPA0155 - Scaling of    ',' impossible.'
      CALL KPCDST (IRLINE,30,IT1)
      CALL KPWRTE (NTDISP)
C
C---- ERZEUGE ELLIPSOIDE.
C
  490 CALL RADIAL (NBIS)
      IF (II .GE. 4) THEN
C
C---- ZEICHNE DIE RANDELLIPSE.
C
        CALL PROJ (D,DP,XX,XO,VIEW,1,129,NRESOL)
        IF (ICDS(6) .NE. 0) THEN
          CALL UPLINF (IATF(1,NCOLPO),10)
          CALL UPLINF (IATF(2,NCOLPO),11)
          CALL UPLINF (DP,3)
          DO  J=NRES1,129,NRESOL
            CALL UPLINF (DP(1,J),2)
          ENDDO
        ENDIF
        IF (IIFLG .EQ. 0) THEN
          IIFLG=1
          ITYP=22
          IF (IATF(4,NCOLPO) .LT. 0) THEN
            IF (ICDS(6) .EQ. 0) GO TO 870
            ITYP=2
          ENDIF
          CALL UPLINF (IATF(1,NCOLPO),10)
          CALL UPLINF (IATF(2,NCOLPO),11)
          CALL UPLINF (DP,ITYP+1)
          DO  J=NRES1,129,NRESOL
            CALL UPLINF (DP(1,J),ITYP)
          ENDDO
          IF (ICDS(6) .EQ. 0.) THEN
            CALL UPLINF (0,24)
            CALL UPLINF (0,21)
            CALL UPLINF (1,24)
            GO TO 870
          ELSE
            IF (ITYP .EQ. 22) CALL UPLINF (IATF(4,NCOLPO),21)
            GO TO 860
          ENDIF
        ENDIF
        IF (CONST(44) .LE. 0) GO TO 860
C
C---- DIE RANDDICKE SOLL EINE LINEARE FUNKTION DER HOEHE SEIN.
C
        CALL DIFV (XT,UR,V1)
        T5=VV(V1,AAREV(1,3,NS))*O9
        NCYCLE=.5+(AATF(15,NCOLPO)+T5*AATF(16,NCOLPO))/CONST(44)
        IF (NCYCLE .LE. 0) GO TO 860
        T3=(2.*CONST(44))/(T1+T2)
C
C---- ERHOEHE DIE RANDDICKE.
C
        DO  I=1,NCYCLE
          T4=T3*FLOAT(I)
          DO  J=1,129,NRESOL
            CALL DRAW (DP(1,J),D(1,J)*T4,D(2,J)*T4,2)
          ENDDO
        ENDDO
        GO TO 860
      ENDIF
C
      CALL PROJ (D,DP,XX,XO,VIEW,1,65,NRESOL)
C
C---- ZEICHNE EINE HAELFTE VON DER ELLIPSE.
C
      CALL UPLINF (IATF(9,NCOLPO),10)
      CALL UPLINF (IATF(10,NCOLPO),11)
      CALL UPLINF (DP,3)
      DO  J=NRES1,65,NRESOL
        CALL UPLINF (DP(1,J),2)
      ENDDO
      IF (CONST(44) .GT. 0.) THEN
C
C---- BETONE DIE VORDERE HAELFTE.
C
        DO  I=1,3,2
          T2=FLOAT(I-2)*CONST(44)
          DO  J=1,65,NRESOL
            K=66-J
            CALL DRAW (DP(1,K),CONST(44),T2,2)
          ENDDO
          DO  K=1,65,NRESOL
            CALL DRAW (DP(1,K),-CONST(44),-T2,2)
          ENDDO
        ENDDO
      ENDIF
      IF (NSOLID .EQ. 0) GO TO 700
      IF (NSOLID .LT. 0) THEN
        L=NRESOL
        GO TO 640
      ELSE
        L=NDOT
      ENDIF
      IF (NDOT .EQ. NRESOL) GO TO 640
      IF (NDOT .LT. NRESOL) THEN
        CALL RADIAL (NSOLID-1)
      ELSE
        L=NRESOL
      ENDIF
  640 CALL PROJ (D(1,65),DP(1,65),XX,XO,VIEW,1,65,L)
      IF (NSOLID .EQ. 0) GO TO 700
      IF (NSOLID .GT. 0) THEN
C
C---- ZEICHNE EINE PUNKTIERTE LINIE AUF DER RUECKSEITE.
C
          DO  J=65,129,NDOT
          CALL DRAW (DP(1,J),CONST(44),CONST(44),3)
          DO  I=1,3,2
            T1=FLOAT(I-2)*CONST(44)
            DO  K=1,3,2
              T2=FLOAT(K-2)*CONST(44)
              CALL DRAW (DP(1,J),T1,T2,2)
              IF (CONST(44) .LE. 0.) GO TO 670
              CONTINUE
            ENDDO
          ENDDO
  670     CONTINUE
        ENDDO
      ELSE
C
C---- ZEICHNE EINE EINFACHE, DURCHGEZOGENEN LINIE AUF DER RUECK-
C     SEITE.
C
        DO  J=65,129,NRESOL
          CALL DRAW (DP(1,J),0.,0.,2)
        ENDDO
      ENDIF
C
C---- FUEHRE DIE EINZELHEITEN FUER DIE INNEREN MOEGLICHKEITEN AUS.
C
  700 T2=NDASH*2
      DO  J=1,3
        T1=PAC(J,II0)*RMS(II0)*SCL
        DA(J,1)=T1
        DA(J,2)=PAC(J,II1)*RMS(II1)*SCL
        DA(J,3)=0.
        IF (NDASH .GT. 0) THEN
          V1(J)=-T1
          V2(J)=T1/T2
        ENDIF
      ENDDO
      IF (NDASH .GT. 0) THEN
C
C---- ZEICHNE GESTRICHELTE LINIEN FUER DIE RUECKWAERTIGEN ACHSEN.
C
        DO  J=1,NDASH
          DO  K=1,2
            L=4-K
            CALL PROJ (V1,DP,XX,XO,VIEW,1,1,1)
            CALL UPLINF (DP,L)
            DO  I=1,3
              V1(I)=V1(I)+V2(I)
            ENDDO
          ENDDO
        ENDDO
      ENDIF
C
C---- ZEICHNE DURCHGEZOGENE LINIEN FUER DIE NACH VORN GERICHTETEN
C     ACHSEN.
C
      IF (LINES .LE. 0) GO TO 860
      CALL PROJ (DA,DP,XX,XO,VIEW,1,3,1)
      T1=CONST(44)*.5
      DO  I=1,3,2
        T2=FLOAT(2-I)*T1
        CALL DRAW (DP,T1,T2,3)
        CALL DRAW (DP(1,3),T1,T2,2)
        IF (CONST(44) .LE. 0.) GO TO 790
        CALL DRAW (DP(1,3),-T1,T2,2)
        CALL DRAW (DP,-T1,T2,2)
      ENDDO
C
C---- SCHATTIERE DEN QUADRANTEN ZWISCHEN ZWEI HAUPTACHSEN.
C
  790 L=LINES-1
      IF (L .GT. 0) THEN
        T2=LINES
        DO  I=1,L
          T1=FLOAT(I)/T2
          T3=SQRT(ABS(1.-T1*T1))
          IF (MOD(I,2) .NE. 0) THEN
            M=I*2
            N=M-1
          ELSE
            N=I*2
            M=N-1
          ENDIF
          DO  J=1,3
            T4=DA(J,1)*T1
            D(J,M)=T4
            D(J,N)=DA(J,2)*T3+T4
          ENDDO
        ENDDO
        L=L*2
        CALL PROJ (D,DP,XX,XO,VIEW,1,L,1)
        DO  I=2,L,2
          CALL UPLINF (DP(1,I-1),3)
          CALL UPLINF (DP(1,I),2)
        ENDDO
      ENDIF
C
C                            NEXT II
  860 CONTINUE
      IF (IIFLG .GT. 1) GO TO 870
      IF (II .LT. NPLANE) GO TO 381
      IIFLG=2
      GO TO 382
C
  190 WRITE (WRLINE,'(A,I3,A)') 'ZVORPA0357 - NG=',NG,' IT1='
      CALL KPCDST (IRLINE,25,IT1)
      CALL KPWRTE (NTDISP)
      IRC=0
      GO TO 999
C
  870 IRC=1
C
  999 RETURN
      END
