C   66             ----------------------------
                    SUBROUTINE ZVPLDR (ITOPAT)
C                  ----------------------------
C
C  CY-VEC-RS6-VAX-ENG-
C
C                 Das Programm zeichnet Polyeder.
C
C             Geschrieben:  141145 JUL 1991  (Hundt)
C             Geaendert:    251700 MAR 2004  (Hundt)
C
C                  ----------------------------
C
C  Ein Polyeder wird folgendermassen verschluesselt:
C  1. Laenge des Codes
C  2. Typ: 8 VEH; 9 VEU; 10 VE; 15 PFU; 16 PF;
C  3. Pointer auf Nr. des Kontrollblocks PEDCB
C  4. Pointer auf Zentralatom
C  5. Pointer auf Atom, das Loeschung eines leeren Headers veranlasst
C     6. Laenge einer Flaeche   \
C     7. Assoziiertes Atom      I  mehrfach
C     8. Schraege der Flaeche   I
C     9. c1, c2, ..., cn        /
C
C  Aufbau des Polyederdescriptorblocks (PEDCB):
C  1. Farbe (Begrenzung)
C  2. Strichstaerke (Begrenzung)
C  3. Farbe (Schraffur)
C  4. Strichstaerke (Schraffur; <=0 keine Schraffur)
C  5. Farbe (Fuellmuster)
C  6. Nummer (Fuellmuster)
C  7. dist (Dichte der Streifen)
C  8-10. Vektor fuer Schattierungsrichtung triklin
C  11. Drehwinkel
C  12. Zahl der auszufuehrenden Drehungen
C  13. Erste Drehung, die geplottet wird
C  14-16. Vektor im freien System
C
C                  ----------------------------
C
      IMPLICIT NONE
C                            Puffer fuer die ebenen und kanten
C
      INTEGER *4 MAXPNT,ITMPOI,MAXERG,IERPOI,MAXKNT,IKNTEN
C     PARAMETER (MAXPNT=122, MAXERG=12, MAXKNT=360)
      PARAMETER (MAXPNT=60, MAXERG=12, MAXKNT=90)
      INTEGER *4 ITMPBF(MAXPNT),IERGBF(MAXERG),KANTEN(3,MAXKNT)
C
C                               Zahl der SF-Bloecke
      INTEGER*4 IDCBDM
      PARAMETER (IDCBDM=6)
C
C                               Laenge des Headers
      INTEGER *4 IHDRL
      PARAMETER (IHDRL=5)
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER*4 ITOPAT,IWRKA(2),IWRKP(2),IWRKPP,IWRKE,IPBFP,IERMSG
      INTEGER*4 I,J,K,K2,K3,L,L1,M,IPIINC,JPJINC,IDQ,IDQ1
      INTEGER*4 JZAT,JZAT1,KZAT,KZAT2,IPAT1,ISRTFL
      INTEGER*4 LA,IVEU,IVEH,IVE,IPF,MA,ME,JJ
      INTEGER*4 ICURPL,IERRNR(4),ICURFL,IPERIM(2)
      INTEGER*4 IAIN(72),NUTZFB(4),ISTRCH(2),IPLTNR(9),IPFU,IPFD
      INTEGER*4 ILWA(2),ILWP(2),ILWE,II,ITOL,N2,ICUREN
      INTEGER*4 IPEDCB(16,IDCBDM),IPLTBF,IAUSL,M2,M3,N1,M1,N3,N3STRT
      INTEGER*4 I3DBUF(12),IRLINE(30)
C
      PARAMETER (IVEH=8, IVEU=9, IVE=10, IPFU=15, IPF=16, IPFD=17)
C
      INTEGER*2 ILW(2,3*ATODIM,2)
      INTEGER*2 IWRK(16*PARDIM,2)
C
      REAL*4    DQ1,TEMP,TEMP2,VIJ(3),VIK(4),VN(4),PLTBF(2,9)
      REAL*4    PEDCB(16,IDCBDM),TBUF(7),STRCHL(2),TOL
C
      EQUIVALENCE (IDQ,DQ),(IDQ1,DQ1),(AT(1,1,1),IWRK(1,1))
      EQUIVALENCE (IPEDCB(1,1),PEDCB(1,1)),(AIN(1),IAIN(1))
      EQUIVALENCE (ATOMS(1,1,1),ILW(1,1,1)),(TOL,ITOL)
      EQUIVALENCE (WRLINE,IRLINE(1))
C
      SAVE IWRKA,IWRKE,IWRKP,IERMSG,IPEDCB,ILWA,ILWP,ILWE
      SAVE STRCHL,ISTRCH
C
      DATA IERRNR/158,286,547,741/
      DATA ISTRCH/0,0/,STRCHL/5.,1./,IPERIM/0,1/
      DATA ISRTFL/0/
C
      IF (ITOPAT) 10,140,230
C
C                       Definition des Polyeder-Kontrollblocks
C
   10 IF (ITOPAT+2) 15,40,20
   15 IF (ITOPAT+4) 132,131,90
   20 CONTINUE
CYENG1
      CALL FLES (I,ISKP(31),2HIR,
     1 50HNr, cr,sr, cs,ss, cf,nf, dist, v1,v2,v3, w,nz,ns?$)
CYENG2
CYENGY      CALL FLES (I,ISKP(31),2HIR,
CYENGY     1 50HNo, cr,sr, cs,ss, cf,nf, dist, v1,v2,v3, w,nz,ns?$)
      IF ((I .GT. 0) .AND. (I .LE. IDCBDM)) GO TO 30
      IERR=66 0020 16
      GO TO 9999
C
   30 CALL FLES (IPEDCB(1,I),ISKP(31),7H6I5F2IE,
     + 46Hcr,sr, cs,ss, cf,nf, dist, v1,v2,v3, w,nz,ns?$)
      GO TO 9999
C                       Listen
   40 DO  I=1,IDCBDM
       DO  J=2,6,2
         IF (IPEDCB(J,I) .GT. 0) GO TO 60
       ENDDO
       GO TO 80
C
   60  WRITE (WRLINE,70) I,(IPEDCB(J,I),J=1,6),(PEDCB(J,I),J=7,11),
     +  (IPEDCB(J,I),J=12,13)
       CALL KPWRTE (NTOUT)
   70  FORMAT ('(',I2,')',6I3,5F8.3,2I3)
   80  CONTINUE
      ENDDO
      NTYP=1
      GO TO 9999
C                       Fuer Bildfile
   90 NTYP=NTBILF
      CALL ZVEAEH
      DO  I=1,IDCBDM
        DO  J=2,6,2
          IF (IPEDCB(J,I) .GT. 0) GO TO 110
        ENDDO
        GO TO 130
C
  110   WRITE (WRLINE,120) I,(IPEDCB(J,I),J=1,6),(PEDCB(J,I),J=7,11),
     +    (IPEDCB(J,I),J=12,13)
        CALL KPWRTE (NTBILF)
  120   FORMAT ('SF',7I3,5F8.3,2I3)
  130   CONTINUE
      ENDDO
      GO TO 9999
C                       Tausche Zahlen fuer XC
  131 DO  I=1,IDCBDM
      IF (IPEDCB(1,I) .EQ. IAIN(1)) IPEDCB(1,I)=IAIN(2)
      IF (IPEDCB(3,I) .EQ. IAIN(1)) IPEDCB(3,I)=IAIN(2)
      ENDDO
      GO TO 9999
C                       Initialisierung der Kontrollbloecke
  132 DO  I=1,IDCBDM
        DO  J=1,16
          IPEDCB(J,I)=0
        ENDDO
        IPEDCB(1,I)=ISKP(41)
        IPEDCB(3,I)=ISKP(41)
        IPEDCB(5,I)=ISKP(41)
        PEDCB(7,I)=0.2
        PEDCB(9,I)=1.0
      ENDDO
      GO TO 9999
C                       Initialisierung (Arbeitet auf der ersten str.)
  140 IERMSG=0
      IWRKA(NS)=16*NAT(NS)+1
      IWRKP(NS)=IWRKA(NS)-1
      IWRKE=16*NATDM
      ILWA(NS)=NCD(NS)*3+1
      ILWP(NS)=ILWA(NS)-1
      ILWE=3*NCDDM
      IF ((IWRKE-IWRKA(NS) .GT. 100) .AND. 
     + (ILWE-ILWA(NS) .GT. 2)) GO TO 160
      WRITE (WRLINE,150) IERRNR(1)
      CALL KPWRTE (NTDISP)
CYENG1
  150 FORMAT ('ZVPLDR',I4,' - Unzureichende Arbeitsflaeche.')
CYENG2
CYENGY  150 FORMAT ('ZVPLDR',I4,' - Insufficient work space.')
      IERR=-1
      GO TO 9999
C
  160 DO  J=1,IDCBDM
        DO  I=1,3
          PEDCB(I+13,J)=TRA(I,1,NS)*PEDCB(8,J)+TRA(I,2,NS)*PEDCB(9,J)+
     +     TRA(I,3,NS)*PEDCB(10,J)
        ENDDO
      ENDDO
      ITOPAT=1
C                       Berechne Konstanten fuer Strichelung.
      ISTRCH(1)=0
      TEMP=ABS(CONST(40))
      IF (CONST(40)) 180,9999,190
  180 ISTRCH(1)=-1
      GO TO 200
C
  190 ISTRCH(1)=1
  200 ISTRCH(2)=IFIX(TEMP)/10
      TEMP2=TEMP-10.*FLOAT(ISTRCH(2))
      TEMP=FLOAT(ISTRCH(2))+FLOAT(ISTRCH(2)-1)*TEMP2
      IF (TEMP .GT. 0.) GO TO 220
      WRITE (WRLINE,210) CONST(40)
      CALL KPWRTE (NTDISP)
CYENG1
  210 FORMAT ('ZVPLDR0185 - Ungueltiger Strichelungsparameter',F10.5)
CYENG2
CYENGY  210 FORMAT ('ZVPLDR0185 - Invalid dashing parameter',F10.5)
      ISTRCH(1)=0
      GO TO 9999
C
  220 STRCHL(1)=1./TEMP
      STRCHL(2)=TEMP2*STRCHL(1)
      GO TO 9999
C                       Teste, ob dieses Atom die Spitze eines
C ++                    Polyeders ist.  Durchlaufe Plotbefehlsliste.
  230 IPBFP=1
      GO TO 1050
  240 IPLTBF=IPK(IPBFP+1,NS)
      IF (IPLTBF .LT. IVEH) GO TO 1040
      IF (IPLTBF .LE. IVE ) GO TO 249
      IF (IPLTBF .EQ. IPFD) GO TO 241
      IF (IPLTBF .LT. IPFU) GO TO 1040
      IF (IPLTBF .GT. IPF ) GO TO 1040
      GO TO 249
C
C                       PFD - Plotte Flaeche direkt.
C                       Dieser Befehl hinterlegt seine Parameter,
C                       wenn das aktuelle Atom = Ausloeser ist.
  241 J=IPBFP+3
      IF (IPK(J,NS) .NE. ICD(ITOPAT,NS)) GO TO 1040
      I=IPK(IPBFP,NS)+4
      IF (IWRKP(NS)+I .GT. IWRKE) GO TO 325
      IWRK(IWRKP(NS)+1,NS)=I
      IWRK(IWRKP(NS)+2,NS)=IVEU
      K=IPK(IPBFP+2,NS)
      IF (K .GE. 0) GO TO 244
      IWRK(IWRKP(NS)+2,NS)=IVE
      K=-K
  244 IWRK(IWRKP(NS)+3,NS)=K
      IWRK(IWRKP(NS)+4,NS)=ITOPAT
      IWRK(IWRKP(NS)+5,NS)=ITOPAT
C
      I=I-8
      IWRK(IWRKP(NS)+6,NS)=I+3
      IWRK(IWRKP(NS)+7,NS)=ITOPAT
      K=IWRKP(NS)+8
      IWRK(K,NS)=255
C                       Codiere um in Pointer
      DO   M=1,I
        K=K+1
        J=J+1
        L1=IPK(J,NS)
        DO  L=NCDA(NS),NCD(NS)
          IF (ICD(L,NS) .EQ. L1) GO TO 243
        ENDDO
C                       Atom nicht in Codeliste. Vergiss es.
        GO TO 1040
  243   IWRK(K,NS)=L
      ENDDO
      IWRKP(NS)=K
      GO TO 1040
C
  249 IPIINC=ICD(ITOPAT,NS)/200000
      IF (((IPIINC .LT. IPK(IPBFP+2,NS)) .OR. (IPIINC .GT.
     + IPK(IPBFP+3,NS))) .AND. ((IPIINC .LT. IPK(IPBFP+4,NS)) .OR.
     + (IPIINC .GT. IPK(IPBFP+5,NS)))) GO TO 1040
C
C                       Topatom passt ins Schema. Suche nach
C                       Zentralatom.
C
  270 KZAT=IPK(IPBFP+8,NS)*200000
      KZAT2=IPK(IPBFP+9,NS)*200000+199999
C
      JZAT=ITOPAT
      IF (IPLTBF .GE. IPFU) JZAT=NCD(NS)
      GO TO 1030
  280 IF (ICD(JZAT,NS) .LT. KZAT) GO TO 1020
      IF (ICD(JZAT,NS) .GT. KZAT2) GO TO 1020
C
C                       Zentralatom gefunden.
C                       Haben wir diesen Polyeder schon?
      JZAT1=IWRKA(NS)
      GO TO 310
  290 IF (IWRK(JZAT1+3,NS) .EQ. JZAT) GO TO 1020
  300 JZAT1=JZAT1+IWRK(JZAT1,NS)
  310 IF (JZAT1 .LT. IWRKP(NS)) GO TO 290
C
C                       Noch nicht.  Teste, ob der Abstand stimmt.
      IDQ=IPK(IPBFP+11,NS)
      DQ=DQ*DQ
      TEMP2=0.
      DO 320 L=1,3
      TEMP=ATOMS(L,ITOPAT,NS)-ATOMS(L,JZAT,NS)
      TEMP2=TEMP2+TEMP*TEMP
      IF (TEMP2 .GT. DQ) GO TO 1020
  320 CONTINUE
      IDQ1=IPK(IPBFP+10,NS)
      DQ1=DQ1*DQ1
      IF (TEMP2 .LT. DQ1) GO TO 1020
C
C                       Alles stimmt soweit.  Erzeuge Polyeder.
C
      IF (IWRKP(NS)+IHDRL .LE. IWRKE) GO TO 330
  325 IF (IERMSG .NE. 0) GO TO 1060
      WRITE (WRLINE,150) IERRNR(2)
      CALL KPWRTE (NTDISP)
      IERMSG=1
      IERR=-1
      GO TO 1060
C
  330 ICURPL=IWRKP(NS)+1
      IWRK(ICURPL,NS)=IHDRL
      M=IPLTBF
      IF (IPLTBF .GE. IPFU) M=M-6
      IWRK(IWRKP(NS)+2,NS)=M
      IWRK(IWRKP(NS)+3,NS)=IPK(IPBFP+13,NS)
      IWRK(IWRKP(NS)+4,NS)=JZAT
      IWRKP(NS)=IWRKP(NS)+IHDRL
      IWRK(IWRKP(NS),NS)=JZAT
C                       Suche betroffene Atome zusammen.
      ITOL=IPK(IPBFP+12,NS)
      ITMPOI=0
      M=ITOPAT
      IF (IPLTBF .GE. IPFU) M=NCD(NS)
  340 L=ICD(M,NS)/200000
      IF (((L .LT. IPK(IPBFP+2,NS)) .OR. (L .GT. IPK(IPBFP+3,NS)))
     + .AND. ((L .LT. IPK(IPBFP+4,NS)) .OR.
     + (L .GT. IPK(IPBFP+5,NS)))) GO TO 400
      TEMP2=0.
      DO  L=1,3
        TEMP=ATOMS(L,M,NS)-ATOMS(L,JZAT,NS)
        TEMP2=TEMP2+TEMP*TEMP
        IF (TEMP2 .GT. DQ) GO TO 400
      ENDDO
      IF (TEMP2 .LT. DQ1) GO TO 400
C
      IF (ITMPOI .LT. MAXPNT) GO TO 390
      IF (IERMSG .NE. 0) GO TO 410
      WRITE (WRLINE,380) MAXPNT
CYENG1
  380 FORMAT ('ZVPLDR0324 - Polyeder hat mehr als',I3,' Atome.')
CYENG2
CYENGY  380 FORMAT ('ZVPLDR0324 - Polyhedron has more than',I3,' atoms.')
      CALL KPWRTE (NTDISP)
      IERMSG=1
      GO TO 410
C
  390 ITMPOI=ITMPOI+1
      ITMPBF(ITMPOI)=M
  400 CONTINUE
      M=M-1
      IF (M .GE. NCDA(NS)) GO TO 340
C
C                       Setze Atom, das Headerloeschung ausloest
C
      IF (IPLTBF .GE. IPFU) THEN
        IWRK(IWRKP(NS),NS)=ITMPBF(ITMPOI)
        IF (ITMPOI .LT. 3) GO TO 410
      ENDIF
      IF (ITMPOI .GT. 3) GO TO 420
C
C                       Vergiss es. Das ist kein(e) Polyeder(flaeche).
  410 IWRKP(NS)=ICURPL-1
      GO TO 1020
C
C   Der polyeder ist jetzt zusammengesucht. Setze jetzt eine
C   dreifachschleife auf, um eine erste aussenflaeche zu finden.
C
  420 CONTINUE
C     PRINT *,ITMPOI,' PUNKTE IN POLYEDER'
      IKNTEN=0
      M1=ITMPBF(1)
      IERGBF(1)=M1
      N2=1
  430 N2=N2+1
      IF (N2 .GT. ITMPOI-1) GO TO 470
      N3STRT=N2+1
      M2=ITMPBF(N2)
  440 IERGBF(2)=M2
      DO  N3=N3STRT,ITMPOI
        M3=ITMPBF(N3)
        IERGBF(3)=M3
        IERPOI=3
C
C   Teste, ob diese flaeche bereits gefunden wurde. Das ist dann der
C   fall, wenn der punkt M3 der flaeche gehoert, zu der auch die
C   kante M1 - M2 gehoert.
C
        IF (N3STRT .EQ. 1) THEN
          DO  K=ICURFL,ICUREN
            IF (M3 .EQ. IWRK(K,NS)) THEN
C             PRINT *,'VERWORFEN, WEIL DRITTER PKT IN EBENE.'
              GO TO 460
            ENDIF
          ENDDO
        ENDIF
C
C                          Stelle ebenengleichung auf.
        DO  I=1,3
          VIJ(I)=ATOMS(I,M2,NS)-ATOMS(I,M1,NS)
          VIK(I)=ATOMS(I,M3,NS)-ATOMS(I,M1,NS)
        ENDDO
C
        TEMP2=0.
        DO  I=1,3
          J=ID2(I)
          K=ID2(J)
          TEMP=VIJ(J)*VIK(K)-VIJ(K)*VIK(J)
          VN(I)=TEMP
          TEMP2=TEMP*TEMP+TEMP2
        ENDDO
        IF (TEMP2 .LT. 0.01) THEN
CYENG1
          WRITE (WRLINE,'(A,30X,A)') 'ZVPLDR0398 - Die Atome',
     +    ' bilden keine Ebene.'
CYENG2
CYENGY          WRITE (WRLINE,'(A,30X,A)') 'ZVPLDR0398 - The atoms',
CYENGY     +    ' do not lie in a plane.'
          CALL KPCDST (IRLINE,23,ICD(M1,NS))
          CALL KPCDST (IRLINE,33,ICD(M2,NS))
          CALL KPCDST (IRLINE,43,ICD(M3,NS))
          CALL KPWRTE (NTDISP)
          IERR=-1
          GO TO 1009
        ENDIF
C                     Normiere. VN sind Koeff. d. Ebenengleichung.
C
        TEMP=1./SQRT(TEMP2)
        DO  I=1,3
          VN(I)=VN(I)*TEMP
        ENDDO
        VN(4)=VN(1)*ATOMS(1,M1,NS)+VN(2)*ATOMS(2,M1,NS)+
     +        VN(3)*ATOMS(3,M1,NS)
C
C                          Stelle fest, ob alle atome auf des
C                          polyeders auf der gleichen seite liegen.
C
        IF (IPLTBF .LT. IPFU) THEN
          TEMP=VN(1)*ATOMS(1,JZAT,NS)+VN(2)*ATOMS(2,JZAT,NS)+
     +         VN(3)*ATOMS(3,JZAT,NS)-VN(4)
          IF (ABS(TEMP) .LT. 0.01) GO TO 460
        ELSE
          TEMP=0.
        ENDIF
        DO  I=1,ITMPOI
          J=ITMPBF(I)
          IF (J .NE. M1 .AND. J .NE. M2 .AND. J .NE. M3) THEN
            TEMP2=VN(1)*ATOMS(1,J,NS)+VN(2)*ATOMS(2,J,NS)+
     +      VN(3)*ATOMS(3,J,NS)-VN(4)
            IF (ABS(TEMP2) .LT. TOL) THEN
C
C   Das atom liegt in der ebene. Stelle fest, ob dieses atom nicht
C   bereits vorhanden. Ignoriere es dann.
C
              DO  K=1,IERPOI
                IF (J .EQ. IERGBF(K)) GO TO 450
              ENDDO
              IF (IERPOI .LT. MAXERG) THEN
                IERPOI=IERPOI+1
                IERGBF(IERPOI)=J
                GO TO 450
              ELSE
                WRITE (WRLINE,'(A,30X,A)')
CYENG1
     +          'Zu viele Punkte in der Ebene:',' ...'
CYENG2
CYENGY     +          'Too many points in the plane:',' ...'
                CALL KPCDST (IRLINE,30,ICD(IERGBF(1),NS))
                CALL KPCDST (IRLINE,40,ICD(IERGBF(2),NS))
                CALL KPCDST (IRLINE,50,ICD(IERGBF(3),NS))
                CALL KPWRTE (NTDISP)
                IERR=-1
                GO TO 1009
              ENDIF
            ELSE
              IF (IPLTBF .GE. IPFU) GO TO 460
            ENDIF
            IF (TEMP*TEMP2 .LT. 0.) GO TO 460
          ENDIF
  450     CONTINUE
        ENDDO
        GO TO 480
  460   CONTINUE
      ENDDO
      IF (IPLTBF .GE. IPFU) THEN
        IF (IERPOI .LT. 3) GO TO 470
        GO TO 480
      ENDIF
      IF (N3STRT .NE. 1) GO TO 430
  470 WRITE (WRLINE,'(A)')
CYENG1
     +'ZVPLDR0464 - Keine Aussenflaeche gefunden.'
CYENG2
CYENGY     +'ZVPLDR0464 - No exterior plane found.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 1009
C
C   Aussenflaeche gefunden. Wenn es mehr als 3 punkte sind, muessen
C   diese zuerst umsortiert werden, um an die kanten zu kommen.
C
  480 CONTINUE
C                       Berechne Schraege der Flaeche.
C
      TEMP=VN(3)*HOE-VN(4)
      M=IWRK(ICURPL+3,NS)
      TEMP2=VN(1)*ATOMS(1,M,NS)+VN(2)*ATOMS(2,M,NS)+
     +      VN(3)*ATOMS(3,M,NS)-VN(4)
      L1=ABS(255.*TEMP/HOE)
      IF (L1 .GT. 255) L1=255
      IF (TEMP*TEMP2 .GT. 0.) L1=-L1
      IF (IPLTBF .GE. IPFU) L1=IABS(L1)
C
      IF (IERPOI .GT. 3) THEN
        DO  N1=1,IERPOI-2
          M1=IERGBF(N1)
          DO  N2=N1+1,IERPOI
            M2=IERGBF(N2)
            DO  I=1,3
              VIJ(I)=ATOMS(I,M2,NS)-ATOMS(I,M1,NS)
            ENDDO
            DO  I=1,3
              J=ID2(I)
              K=ID2(J)
              VIK(I)=VN(J)*VIJ(K)-VN(K)*VIJ(J)
            ENDDO
            VIK(4)=VIK(1)*ATOMS(1,M1,NS)+VIK(2)*ATOMS(2,M1,NS)+
     +            VIK(3)*ATOMS(3,M1,NS)
            TEMP=0.
            DO  N3=1,IERPOI
              IF (N3 .NE. N1 .AND. N3 .NE. N2) THEN
                M3=IERGBF(N3)
                TEMP2=VIK(1)*ATOMS(1,M3,NS)+VIK(2)*ATOMS(2,M3,NS)+
     +                VIK(3)*ATOMS(3,M3,NS)-VIK(4)
                IF (TEMP2 .EQ. 0.) THEN
                  WRITE (WRLINE,'(A,A)')
CYENG1
     +            'Folgende Atome einer Polyederflaeche liegen ',
     +            'auf einer Geraden:'
CYENG2
CYENGY     +            'Atoms that follow lie on an line:'
                  CALL KPWRTE (NTDISP)
                  WRLINE=' '
                  CALL KPCDST (IRLINE, 1,ICD(M1,NS))
                  CALL KPCDST (IRLINE,11,ICD(M2,NS))
                  CALL KPCDST (IRLINE,21,ICD(M3,NS))
                  CALL KPWRTE (NTDISP)
                  IERR=-1
                  GO TO 1009
                ENDIF
                IF (TEMP .EQ. 0) THEN
                  TEMP=TEMP2
                ELSE
                  IF (TEMP*TEMP2 .LT. 0.) GO TO 490
                ENDIF
              ENDIF
            ENDDO
C                          Aussenkante gefunden. Bringe an die
C                          richtige stelle.
            J=N1+1
            IF (J .NE. N2) THEN
              I=IERGBF(J)
              IERGBF(J)=IERGBF(N2)
              IERGBF(N2)=I
            ENDIF
            GO TO 500
  490       CONTINUE
          ENDDO
          WRITE (WRLINE,'(A,A)')
CYENG1
     +    'Polyederflaeche mit folgenden Atomen hat ',
     +    'einspringende Ecken.'
CYENG2
CYENGY     +    'Atoms within the plane',
CYENGY     +    ' do not form a convex polygon.'
          CALL KPWRTE (NTDISP)
          WRLINE=' '
          CALL KPCDST (IRLINE, 1,ICD(M1,NS))
          CALL KPCDST (IRLINE,11,ICD(M2,NS))
          CALL KPCDST (IRLINE,21,ICD(M3,NS))
          CALL KPWRTE (NTDISP)
          IERR=-1
          GO TO 1009
  500     CONTINUE
        ENDDO
      ENDIF
C
C   Trage das Ergebnis in den flaechenspeicher ein.
C
  900 CONTINUE
      M=IERPOI+3
      IF (IWRKP(NS)+M .LE. IWRKE) GO TO 910
      IF (IERMSG .NE. 0) GO TO 1060
      WRITE (WRLINE,150) IERRNR(3)
      CALL KPWRTE (NTDISP)
      IERMSG=1
      IERR=-1
      GO TO 1060
C
  910 ICURFL=IWRKP(NS)+4
      IWRK(IWRKP(NS)+1,NS)=M
      IWRK(IWRKP(NS)+3,NS)=L1
      IPAT1=NCD(NS)
      DO  I=1,IERPOI
        J=IERGBF(I)
        IWRK(IWRKP(NS)+3+I,NS)=J
        IF (J .LT. IPAT1) IPAT1=J
      ENDDO
      IWRK(IWRKP(NS)+2,NS)=IPAT1
      IWRKP(NS)=IWRKP(NS)+M
C
C                     Suche ggf. anderes assoz. Atom.
C
  950 IAUSL=IPK(IPBFP+14,NS)
      IF (IAUSL .EQ. 0) GO TO 1000
      IF (IAUSL .EQ. 1) GO TO 959
      IF (IAUSL .EQ. 3) GO TO 959
C
C                     Den rueckwaertigen Flaechen wird das
C                     Atom zugeordnet, das vom Betrachter am
C                     weitesten entfernt ist; den vorderen
C                     Flaechen das naechstgelegene
C
      DO 953 M=ICURFL,IWRKP(NS)
      L=IWRK(M,NS)
      IF (M .EQ. ICURFL) GO TO 952
      IF (L1 .LT. 0) GO TO 951
      IF (TEMP .GT. ATOMS(3,L,NS)) GO TO 953
      GO TO 952
  951 IF (TEMP .LT. ATOMS(3,L,NS)) GO TO 953
  952 J=M
      TEMP=ATOMS(3,L,NS)
  953 CONTINUE
      M=IWRK(J,NS)
      GO TO 990
C                     Den Flaechen wird ein dem Schwerpunkt
C                     nahegelegenes Atom zugeordnet.
  959 TEMP=0.
      M2=IWRK(ICURFL,NS)
      M3=M2
      DO 960 M=ICURFL,IWRKP(NS)
      L=IWRK(M,NS)
      IF (M2 .LT. L) M2=L
      IF (M3 .GT. L) M3=L
      TEMP=TEMP+ATOMS(3,L,NS)
  960 CONTINUE
      TEMP=TEMP/FLOAT(IWRKP(NS)-ICURFL+1)
C
      IF (IAUSL .NE. 3) GO TO 969
C
C                     Bestimme ausloesendes Atom durch Vergleich
C                     der z-Koordinaten Schwerpunkt/Zentralatom
      M=M3
      IF (TEMP .GT. ATOMS(3,IWRK(ICURPL+3,NS),NS)) GO TO 990
      M=M2
      GO TO 990
C
  969 M=IPAT1
      GO TO 980
  970 CONTINUE
      IF (ATOMS(3,M,NS) .LT. TEMP) GO TO 990
      M=M-1
  980 IF (M .GE. NCDA(NS)) GO TO 970
  990 CONTINUE
      IWRK(ICURFL-2,NS)=M
C                     Sonderfall PF/PFU: keine weitere Flaeche
C
 1000 IF (IPLTBF .GE. IPFU) GO TO 1009
C
C   Trage das ergebnis in die kantenliste ein. Vermerke bei den
C   bereits gespeicherten kanten, dass sie nicht mehr verwendet
C   werden.
C
      DO  I=1,IERPOI
        J=I+1
        IF (J .GT. IERPOI) J=1
        DO  K=1,IKNTEN
          IF (((KANTEN(1,K) .EQ. IERGBF(I)) .AND.
     +         (KANTEN(2,K) .EQ. IERGBF(J))) .OR.
     +        ((KANTEN(1,K) .EQ. IERGBF(J)) .AND.
     +         (KANTEN(2,K) .EQ. IERGBF(I)))) THEN
            IF (KANTEN(3,K) .EQ. 0) THEN
              CALL KPCDST (ISKP(80),1,ICD(JZAT,NS))
              WRITE (WRLINE,'(A,3A4,A)')
CYENG1
     +        'ZVPLDR0642 - Polyeder um',(ISKP(J),J=80,82),
     +        'zu stark verzerrt.'
CYENG2
CYENGY     +        'ZVPLDR0642 - Polyhedron around',(ISKP(J),J=80,82),
CYENGY     +        'too distorted.'
              CALL KPWRTE (NTDISP)
              IWRKP(NS)=ICURPL-1
              IERR=-1
              GO TO 9999
            ENDIF
            KANTEN(3,K)=0
            GO TO 510
          ENDIF
        ENDDO
        IF (IKNTEN .LT. MAXKNT) THEN
          IKNTEN=IKNTEN+1
          KANTEN(1,IKNTEN)=IERGBF(I)
          KANTEN(2,IKNTEN)=IERGBF(J)
          KANTEN(3,IKNTEN)=ICURFL
        ELSE
CYENG1
          WRITE (WRLINE,'(A)') 'Liste fuer Kanten ist voll.'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') 'List for edges full.'
          CALL KPWRTE (NTDISP)
          IERR=-1
          GO TO 1009
        ENDIF
  510   CONTINUE
      ENDDO
C
C   Suche jetzt eine erst einmal verwendete kante, um hieran eine
C   neue flaeche anzuschliessen.
C
      DO  I=1,IKNTEN
        IF (KANTEN(3,I) .NE. 0) THEN
          M1=KANTEN(1,I)
          IERGBF(1)=M1
          M2=KANTEN(2,I)
          ICURFL=KANTEN(3,I)
          ICUREN=ICURFL+IWRK(ICURFL-3,NS)-4
          N3STRT=1
          GO TO 440
        ENDIF
      ENDDO
C
C                       Teste, ob eine Flaeche zustandegekommen ist.
C
 1009 M=IWRKP(NS)-ICURPL+1
      IF (M .LE. IHDRL) GO TO 410
      IWRK(ICURPL,NS)=M
C                       Alle Flaechen dieses Polyeders sind erzeugt.
C                       Koennen unsichtbare Flaechen entfert werden?
C
      IF (ISKP(50) .NE. 0) GO TO 1014
      IF (IWRK(ICURPL+1,NS) .NE. IVEU) GO TO 1014
      I=ICURPL+IHDRL
      J=I
 1011 M=IWRK(J,NS)
      IF (IWRK(J+2,NS) .LE. 0) GO TO 1012
      DO  K=1,M
        IWRK(I,NS)=IWRK(J,NS)
        I=I+1
        J=J+1
        CONTINUE
      ENDDO
      GO TO 1013
C
 1012 J=J+M
 1013 IF (J .LT. IWRKP(NS)) GO TO 1011
      IWRKP(NS)=I-1
      M=I-ICURPL
      IF (M .LE. IHDRL) GO TO 410
      IWRK(ICURPL,NS)=M
C                       Sortiere die Flaechen so um, dass bei der
C                       Pixelversion (sonst umgekehrt) die
C                       hinteren zuerst kommen. Kopiere den Polyeder
C
 1014 IF (IWRKP(NS)+IWRK(ICURPL,NS) .GT. IWRKE) THEN
        WRITE (WRLINE,150) IERRNR(3)
        CALL KPWRTE (NTDISP)
        IERMSG=1
        IERR=-1
        GO TO 1020
      ENDIF
      I=ICURPL-1
      J=IWRKP(NS)
      DO  K=ICURPL,IWRKP(NS)
        J=J+1
        IWRK(J,NS)=IWRK(K,NS)
      ENDDO
C                       Kopiere jetzt die rueckwaertigen zurueck, ...
      I=ICURPL+IHDRL
      K=I+IWRK(ICURPL,NS)
      M=K
 1015 CONTINUE
      IF (IWRK(K+2,NS) .GE. 0) THEN
        K2=K+IWRK(K,NS)-1
        DO  K3=K,K2
          IWRK(I,NS)=IWRK(K3,NS)
          I=I+1
        ENDDO
      ENDIF
      K=K+IWRK(K,NS)
      IF (K .LT. J) GO TO 1015
C
C                       ... dann die vorderen (oder umgekehrt).
      K=M
 1016 CONTINUE
      IF (IWRK(K+2,NS) .LT. 0) THEN
        K2=K+IWRK(K,NS)-1
        DO  K3=K,K2
          IWRK(I,NS)=IWRK(K3,NS)
          I=I+1
        ENDDO
      ENDIF
      K=K+IWRK(K,NS)
      IF (K .LT. J) GO TO 1016
C
C                       Naechstes (moegliches) Zentralatom.
 1020 JZAT=JZAT-1
 1030 IF (JZAT .GE. NCDA(NS)) GO TO 280
C
 1040 IPBFP=IPBFP+IPK(IPBFP,NS)
 1050 IF (IPBFP .LT. IPKP(NS)) GO TO 240
C
C   ***************************************************************
C   Teste, ob eine oder mehrere Flaechen gezeichnet werden koennen.
C   ***************************************************************
C                       Durchlaufe Polyeder.
C                       Sammele zuerst die zu zeichnenden Flaechen ein.
 1060 I=IWRKA(NS)
      IF (IWRKP(NS) .LT. IWRKA(NS)) GO TO 9999
      IWRKPP=IWRKP(NS)
C
 1070 L1=IWRK(I,NS)
      IPIINC=L1+I
C                       Polyeder leer?
C
      IF (L1 .LE. IHDRL) GO TO 1140
C
C                       Durchlaufe Flaechen.
      J=I+IHDRL
 1080 JPJINC=IWRK(J,NS)+J
      IF (ITOPAT .NE. IWRK(J+1,NS)) GO TO 1130
      IF (IWRKPP+3 .LE. IWRKE) GO TO 1090
      WRITE (WRLINE,150) IERRNR(4)
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 1150
C                       Sortiere ggf. ein.
 1090 L=IWRKPP
      M=IWRK(J+2,NS)
      IF (ISRTFL) 1110,1120,1110
 1100 CONTINUE
      IF (M .LT. IWRK(L,NS)) GO TO 1120
      IWRK(L+3,NS)=IWRK(L,NS)
      IWRK(L+2,NS)=IWRK(L-1,NS)
      IWRK(L+1,NS)=IWRK(L-2,NS)
      L=L-3
 1110 IF (L .GT. IWRKP(NS)) GO TO 1100
C
 1120 IWRK(L+1,NS)=I
      IWRK(L+2,NS)=J
      IWRK(L+3,NS)=M
      IWRKPP=IWRKPP+3
C                       Naechste Flaeche.
 1130 J=JPJINC
      IF (J .LT. IPIINC) GO TO 1080
C
C                       Naechster Polyeder.
 1140 I=IPIINC
      IF (I .LT. IWRKP(NS)) GO TO 1070
C
C                       Teste, ob ueberhaupt Flaechen anstehen.
C
 1150 IF (IWRKPP .LE. IWRKP(NS)) GO TO 9999
C
C                       Durchlaufe Flaechen.
      L=IWRKP(NS)+1
 1160 I=IWRK(L,NS)
      J=IWRK(L+1,NS)
      JPJINC=J+IWRK(J,NS)
C                       Berechne Plotkoordinaten
      K=J+3
      K3=0
 1170 K2=IWRK(K,NS)
      TEMP=HOE/(HOE-ATOMS(3,K2,NS))
      IF (K3 .LT. 8) GO TO 1190
      WRITE (WRLINE,1180)
      CALL KPWRTE (NTDISP)
CYENG1
 1180 FORMAT ('ZVPLDR0789 - Flaeche hat mehr als 8 Punkte.')
CYENG2
CYENGY 1180 FORMAT ('ZVPLDR0789 - Plane has more than 8 points.')
      GO TO 1230
C
 1190 K3=K3+1
      I3DBUF(K3+3)=K2
      PLTBF(1,K3)=ATOMS(1,K2,NS)*TEMP*O9+CONST(11)
      PLTBF(2,K3)=ATOMS(2,K2,NS)*TEMP*O9+CONST(12)
      IPLTNR(K3)=K2
      IF (ISKP(6) .EQ. 0) GO TO 1210
      WRITE (WRLINE,1200) K2,PLTBF(1,K3),PLTBF(2,K3)
      CALL KPCDST (IRLINE,21,ICD(K2,NS))
      CALL KPWRTE (NTOUT)
CYENG1
 1200 FORMAT ('Flaechen-Atom (',I4,')',10X,2F10.3)
CYENG2
CYENGY 1200 FORMAT ('Atom on plane (',I4,')',10X,2F10.3)
 1210 K=K+1
      IF (K .LT. JPJINC) GO TO 1170
      IF (ISKP(6) .EQ. 0) GO TO 1230
      WRITE (WRLINE,1220)
      CALL KPWRTE (NTOUT)
CYENG1
 1220 FORMAT ('Flaeche fertig.')
CYENG2
CYENGY 1220 FORMAT ('Plane complete.')
C
 1230 PLTBF(1,K3+1)=PLTBF(1,1)
      PLTBF(2,K3+1)=PLTBF(2,1)
      IPLTNR(K3+1)=IPLTNR(1)
      I3DBUF(K3+4)=I3DBUF(4)
      I3DBUF(1)=K3+4
      IF (ISKP(7) .EQ. 0) GO TO 1420
C
C                       Setze aktuelle Farben
      LA=IWRK(I+2,NS)
      IF ((LA .GT. 0) .AND. (LA .LE. IDCBDM)) GO TO 1240
      NUTZFB(1)=ISKP(41)
      NUTZFB(2)=ISKP(49)
      NUTZFB(3)=ISKP(41)
      NUTZFB(4)=ISKP(47)
      GO TO 1250
C
 1240 NUTZFB(1)=IPEDCB(1,LA)
      NUTZFB(2)=IPEDCB(2,LA)
      NUTZFB(3)=IPEDCB(5,LA)
      NUTZFB(4)=IPEDCB(6,LA)
 1250 CONTINUE
      I3DBUF(2)=NUTZFB(3)
      I3DBUF(3)=NUTZFB(4)
      IF (ISKP(60) .LT. 0) THEN
C
C--- Der puffer enthaelt: laenge, ff, nm, i1,..,in,i1 (pos. in liste)
C
        CALL UPLINF (I3DBUF,37)
        GO TO 1420
      ENDIF
C
C                       Setze Strichfarbe und Strichstaerke
C
      CALL UPLINF(NUTZFB(1),10)
      ISKP(42)=NUTZFB(1)
      CALL UPLINF (NUTZFB(2),11)
C
C                       ? Plotbefehl VEH ?
C
      IF (IWRK(I+1,NS) .EQ. IVEH) GO TO 1260
C
C                       ? Plotbefehl VE ?
C
      IF (IWRK(I+1,NS) .NE. IVE) GO TO 1280
C
C                       ? hintere Flaeche ?
C
      IF (IWRK(J+2,NS) .GT. 0) GO TO 1300
C
C                       ? Stricheln ?
C
      IF (ISTRCH(1) .NE. 0) GO TO 1290
      GO TO 1300
C                       ? hintere Flaeche ?
C
 1260 IF (IWRK(J+2,NS) .GT. 0) GO TO 1300
C
C                       ? Stricheln ?
C
      IF (ISTRCH(1) .EQ. 0) GO TO 1280
C
 1270 ME=-22
      GO TO 1310
 1280 ME=+22
      GO TO 1310
 1290 ME=-2
      GO TO 1310
 1300 ME=+2
C                       Schraffiere ggf. die Flaeche.
C
 1310 IF (IWRK(J+2,NS) .LE. 0) GO TO 1320
      LA=IWRK(I+2,NS)
      IF ((LA .LE. 0) .OR. (LA .GT. IDCBDM)) GO TO 1320
      IF (IPEDCB(4,LA) .LE. 0) GO TO 1320
      CALL KPSHFL (IPEDCB(1,LA),J)
      IF (IERR .NE. 0) GO TO 9999
 1320 CONTINUE
C                       Zeichne oder strichele Flaeche.
      DO 1410 K=1,K3
C                       Untersuche, ob die Kante nicht
C                       schon einmal gezeichnet wurde.
      JJ=K
      MA=K+1
      IF (IPLTNR(JJ) .LE. IPLTNR(MA)) GO TO 1330
      JJ=K+1
      MA=K
 1330 II=ILWA(NS)
      GO TO 1360
 1340 IF (ILW(1,II,NS) .NE. IPLTNR(JJ)) GO TO 1350
      IF (ILW(2,II,NS) .NE. IPLTNR(MA)) GO TO 1350
      GO TO 1410
C
 1350 II=II+1
 1360 IF (II .LE. ILWP(NS)) GO TO 1340
C
C                       Noch nicht.
C
      IF (ILWP(NS) .LT. ILWE) ILWP(NS)=ILWP(NS)+1
C
C                       Kopiere nach hinten ...
      II=ILWP(NS)
      GO TO 1380
 1370 ILW(1,II+1,NS)=ILW(1,II,NS)
      ILW(2,II+1,NS)=ILW(2,II,NS)
 1380 II=II-1
      IF (II .GE. ILWA(NS)) GO TO 1370
C
C                       ... und fuege ein.
C
      ILW(1,ILWA(NS),NS)=IPLTNR(JJ)
      ILW(2,ILWA(NS),NS)=IPLTNR(MA)
C
      CALL UPLINF(NUTZFB(1),10)
      ISKP(42)=NUTZFB(1)
      CALL UPLINF (NUTZFB(2),11)
C
C                       Zeichne die Kante ...
C
      IF (ME .GE. 0) GO TO 1400
C
C                       ... gestrichelt.
C                       Berechne Konstanten.
      TBUF(2)=PLTBF(1,K)
      TBUF(1)=PLTBF(1,K+1)-TBUF(2)
      TBUF(4)=PLTBF(2,K)
      TBUF(3)=PLTBF(2,K+1)-TBUF(4)
C
      II=0
      TBUF(5)=0.
      M=2
      IF (ISTRCH(1) .LT. 0) M=3
      CALL UPLINF (PLTBF(1,K),3)
C
C                       Strich ...
C
 1390 TBUF(5)=TBUF(5)+STRCHL(1)
      TBUF(6)=TBUF(1)*TBUF(5)+TBUF(2)
      TBUF(7)=TBUF(3)*TBUF(5)+TBUF(4)
      CALL UPLINF (TBUF(6),M)
      II=II+1
      IF (II .GE. ISTRCH(2)) GO TO 1410
C
C                       ... und Luecke.
      M=5-M
      TBUF(5)=TBUF(5)+STRCHL(2)
      TBUF(6)=TBUF(1)*TBUF(5)+TBUF(2)
      TBUF(7)=TBUF(3)*TBUF(5)+TBUF(4)
      CALL UPLINF (TBUF(6),M)
      M=5-M
      GO TO 1390
C                       ... nicht gestrichelt.
C
 1400 CALL UPLINF (PLTBF(1,K),3)
      CALL UPLINF (PLTBF(1,K+1),2)
C
C                       next K
 1410 CONTINUE
C                       ? Muss Flaeche noch gesperrt werden ?
C
      IF (IABS(ME) .NE. 22) GO TO 1420
      CALL UPLINF (IPERIM(1),24)
      CALL UPLINF (PLTBF,23)
      DO 1415 K=2,K3+1
      CALL UPLINF (PLTBF(1,K),22)
 1415 CONTINUE
      CALL UPLINF (IPERIM(1),21)
      CALL UPLINF (IPERIM(2),24)
C
C                       Markiere fuer erledigt.
 1420 IWRK(J+1,NS)=0
      L=L+3
      IF (L .LT. IWRKPP) GO TO 1160
C
C                       Entferne abgearbeitete Flaechen und Polyeder
      I=IWRKA(NS)
      J=IWRKA(NS)
C                       Kopiere Polyeder.
 1430 IPIINC=I
C                       Kopiere den Header.
      K2=IWRK(J,NS)
      JPJINC=J+K2
C                       Ist der Header leer?
C
      IF (K2 .GT. IHDRL) GO TO 1440
      IF (ITOPAT .GT. IWRK(J+4,NS)) GO TO 1440
      J=JPJINC
      GO TO 1500
C
 1440 DO 1450 K=1,IHDRL
      IWRK(I,NS)=IWRK(J,NS)
      I=I+1
      J=J+1
 1450 CONTINUE
      IF (K2 .LE. IHDRL) GO TO 1500
C
C                       Kopiere den Rest bis auf die erledigten
C                       Flaechen.
C
C                       Ist diese Flaeche erledigt?
 1460 K2=IWRK(J,NS)
      IF (IWRK(J+1,NS) .EQ. 0) GO TO 1480
      DO 1470 K=1,K2
      IWRK(I,NS)=IWRK(J,NS)
      I=I+1
      J=J+1
 1470 CONTINUE
      GO TO 1490
C
 1480 J=J+K2
 1490 IF (J .LT. JPJINC) GO TO 1460
C
C                       Berechne Polyederlaenge neu.
C
      IWRK(IPIINC,NS)=I-IPIINC
C
C                       Fertig mit allen Polyedern?
C
 1500 IF (J .LE. IWRKP(NS)) GO TO 1430
C
C                       Bestimme IWRKP neu.
      IWRKP(NS)=I-1
C
 9999 CONTINUE
      RETURN
      END
