C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                         -------------------
                           SUBROUTINE ZVLCIF
C                         -------------------
C
C         Liest einen .CIF file ein, der aus der ICSD stammt.
C
C                geschrieben: 171117 JUN 2003  (Hundt)
C                  geaendert: 311609 MAR 2016  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
      INTEGER *4 NTY,I,J,K,LDIM,NMERK,IRC,ISTKRT,KC
      INTEGER *4 KST,KEND,IRGSUC
      PARAMETER (LDIM=20)
      INTEGER *4 LIST(2,LDIM),N,IPARL(7),M
      CHARACTER *80 CKARTE
      CHARACTER *32 TAB(32)
      CHARACTER *8  DABACO
      EQUIVALENCE (KARTE(1),CKARTE)
C
      SAVE NTY,NMERK,IPARL,ISTKRT,IRGSUC
C
      DATA NTY/0/
      DATA tab/' ','data_ ','_database_code_ICSD ',
     + '_chemical_formula_sum ','_symmetry_space_group_name ',
C       4
     + '_symmetry_space_group_name_H-M ','loop_','_cell_length_a ',
C       6                                7       8
     + '_cell_length_b ','_cell_length_c ','_cell_angle_alpha ',
C       9                 10               11
     + '_cell_angle_beta ','_cell_angle_gamma ',
C        12                13
     + '_ccdc_atom_site_atom_id_number','_atom_site_label ',
C        14                               15
     + '_atom_site_type_symbol ','_atom_site_fract_x ',
C        16                        17
     + '_atom_site_fract_y ','_atom_site_fract_z ',
C        18                    19
     + '_atom_site_symmetry_multiplicity','_atom_site_Wyckoff_symbol',
C        20                                 21
     + '_atom_site_occupancy','_atom_site_attached_hydrogens',
C        22                     23
     + '_atom_site_calc_flag','_atom_site_aniso_label',
C        24                    25
     + '_atom_site_aniso_U_11',
C        26
     + '_atom_site_aniso_U_22','_atom_site_aniso_U_33',
C        27
     + '_atom_site_aniso_U_12','_atom_site_aniso_U_13',
C        29
     + '_atom_site_aniso_U_23','_symmetry_equiv_pos_as_xyz'/
C        31                      32
C                             Oeffne ggf. file
      IF (NTY .EQ. 0) THEN
        NTYP=NTXR1
        CALL ZVEAEH
        IF (IERR .NE. 0) GO TO 350
        ISKP(15)=0
        NTY=1
      ENDIF
      GO TO (10,20,90,190,331,334),NTY
C             1  2  3   4   5   6
C                             Suche den anfang
   10 ISTKRT=KARTE(20)
      CALL KPRDLN (NTXR1,IRC)
      IF (IRC .NE. 0) GO TO 310
      IF (RDLINE(1:5) .NE. TAB(2)) GO TO 10
C
      KC=0
      DO  I=1,18
        TITEL(I,NS)=ISKP(24)
      ENDDO
      DO  I=1,7
        IPARL(I)=0
      ENDDO
      NAT(NS)=2
      DABACO=' '
      IRGSUC=1
   20 CALL KPRDLN (NTXR1,IRC)
      IF (IRC .NE. 0) GO TO 310
      IF (RDLINE(1:4) .EQ. '#End ') GO TO 320
      IF (RDLINE(1:1) .EQ. ';') THEN
C
C                            Lies kommentare weg
C
   30   CALL KPRDLN (NTXR1,IRC)
        IF (IRC .NE. 0) GO TO 310
        IF (RDLINE(1:1) .NE. ';') GO TO 30
        GO TO 20
      ENDIF
      N=0
      CALL ZVARSE (RDLINE,LIST,N)
      IF (N .EQ. 0) GO TO 20
      IF (RDLINE(1:5) .EQ. TAB(2)) GO TO 320
   40 IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(4)) THEN
C
C                            Formel (moeglicherweise auf folgezeile)
        IF (N .LT. 2) THEN
          CALL KPRDLN (NTXR1,IRC)
          CALL ZVARSE (RDLINE,LIST,N)
        ENDIF
        WRITE (CKARTE,'(A,A)') 'T ',RDLINE(LIST(1,2):LIST(2,2))
        I=3+LIST(2,2)-LIST(1,2)
        WRITE (CKARTE(I:),'(A,A,A)') ' COL= ',DABACO,''''
        NTY=2
        GO TO 340
      ENDIF
      IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(3)) THEN
C
C                            Databasecode
C
        DABACO=RDLINE(LIST(1,2):LIST(2,2))
      ENDIF
C                            HMS
C
      IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(6)) THEN
        J=LIST(1,2)-1
        DO  I=LIST(1,2),80
          IF (RDLINE(I:I) .NE. ' ') THEN
            J=J+1
            RDLINE(J:J)=RDLINE(I:I)
          ENDIF
        ENDDO
        WRITE (CKARTE,'(A,A)') 'HMSO 2;  HMS ',RDLINE(LIST(1,2):J)
        NTY=5
        GO TO 340
      ENDIF
C
C                            Gitterkonstanten
C
      DO  K=0,5
        IF (RDLINE(LIST(1,1):LIST(2,1)-1) .EQ. TAB(K+8)) THEN
          IF (KC .EQ. 0) CKARTE='Z'
          J=3+K*13
          CKARTE(J:J+12)=RDLINE(LIST(1,2):LIST(2,2))
          KC=KC+1
          IF (KC .EQ. 6) THEN
            NTY=2
            GO TO 340
          ENDIF
          CALL KPRDLN (NTXR1,IRC)
          IF (IRC .NE. 0) GO TO 310
          IF (RDLINE(1:4) .EQ. '#END ') GO TO 320
        ENDIF
      ENDDO
C                            loop_
C
   50 IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(7)) THEN
        M=0
        DO  I=1,7
          IPARL(I)=0
        ENDDO
   60   N=0
        CALL KPRDLN (NTXR1,IRC)
        IF (IRC .NE. 0) GO TO 310
        IF (RDLINE(1:4) .EQ. '#End ') GO TO 320
        CALL ZVARSE (RDLINE,LIST,N)
        IF (N .EQ. 0) GO TO 20
        IF (RDLINE(1:5) .EQ. TAB(2)) GO TO 320
        IF (RDLINE(1:5) .EQ. TAB(7)) GO TO 50
        IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(25)) THEN
C
C                            ANISO
          M=M+1
          IPARL(1)=M
          GO TO 170
        ENDIF
        IF (RDLINE(LIST(1,1):LIST(1,1)+9) .EQ. TAB(15)(1:10)) GO TO 80
        IF (RDLINE(LIST(1,1):LIST(1,1)+15) .EQ. TAB(14)(1:16)) GO TO 80
        if (irgsuc .eq. 0) then
        IF (RDLINE(LIST(1,1):LIST(1,1)+19) .EQ. TAB(32)(1:20)) GO TO 333
        endif
      ENDIF
      GO TO 20
C
   70 CALL KPRDLN (NTXR1,IRC)
      IF (IRC .NE. 0) GO TO 310
      IF (RDLINE(1:4) .EQ. '#End ') GO TO 320
      N=0
      CALL ZVARSE (RDLINE,LIST,N)
      IF (N .EQ. 0) GO TO 20
      IF (RDLINE(1:5) .EQ. TAB(2)) GO TO 320
      IF (RDLINE(1:5) .EQ. TAB(7)) GO TO 50
   80 continue
      IF (RDLINE(LIST(1,1):LIST(1,1)+9) .EQ. TAB(15)(1:10)) THEN
        IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(15)) THEN
          M=M+1
          IPARL(1)=M
          GO TO 70
        ENDIF
        IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(17)) THEN
          M=M+1
          IPARL(2)=M
          GO TO 70
        ELSE IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(18)) THEN
          M=M+1
          IPARL(3)=M
          GO TO 70
        ELSE IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(19)) THEN
          M=M+1
          IPARL(4)=M
          GO TO 70
        ELSE
          M=M+1
          GO TO 70
        ENDIF
      ENDIF
C                      _ccdc_atom_site_... wird auch ignoriert.
C
      IF (RDLINE(LIST(1,1):LIST(1,1)+15) .EQ. TAB(14)(1:16)) THEN
        M=M+1
        GO TO 70
      ENDIF
C
C                            Atomparameter
      DO  I=1,4
        IF (IPARL(I) .EQ. 0) GO TO 20
      ENDDO
      NAT(NS)=2
      GO TO 100
   90 CALL KPRDLN (NTXR1,IRC)
      IF (IRC .NE. 0) GO TO 310
      IF (RDLINE(1:4) .EQ. '#End ') GO TO 320
      IF (RDLINE(1:1) .EQ. '#') GO TO 90
      N=0
      CALL ZVARSE (RDLINE,LIST,N)
      IF (N .EQ. 0) GO TO 20
      IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(7)) GO TO 50
  100 CKARTE='ATOM'
      J=5
C
      I=LIST(1,IPARL(1))
  110   K=ICHAR(RDLINE(I:I))
C                           Name
        J=J+1
        IF (J .LE. 7) THEN
          IF ((K .LT. 65 .OR. K .GT. 122 .OR.
     +      (K .GT. 90 .AND. K .LT. 97))) THEN
            GO TO 120
          ELSE
            CKARTE(J:J)=RDLINE(I:I)
            I=I+1
            GO TO 110
          ENDIF
        ENDIF
  120   J=8
C                           Unterscheider
  130   J=J+1
        CKARTE(J:J)=''''
  140   J=J+1
        CKARTE(J:J)=RDLINE(I:I)
  150   I=I+1
        IF (CKARTE(J:J) .EQ. ' ') THEN
          CKARTE(J:J)=''''
          J=J+2
          GO TO 160
        ENDIF
        IF (RDLINE(I:I) .EQ. '''') GO TO 130
      GO TO 140
C                           Koordinaten
  160 DO  K=2,4
        DO  I=LIST(1,IPARL(K)),LIST(2,IPARL(K))
          J=J+1
          CKARTE(J:J)=RDLINE(I:I)
        ENDDO
        J=J+1
      ENDDO
      NTY=3
      GO TO 340
C                             Aniso TF's
C
  170 CALL KPRDLN (NTXR1,IRC)
      IF (IRC .NE. 0) GO TO 310
      IF (RDLINE(1:4) .EQ. '#End ') GO TO 320
      N=0
      CALL ZVARSE (RDLINE,LIST,N)
      IF (N .EQ. 0) GO TO 20
      IF (RDLINE(1:5) .EQ. TAB(2)) GO TO 320
      IF (RDLINE(1:5) .EQ. TAB(7)) GO TO 50
  180 IF (RDLINE(LIST(1,1):LIST(1,1)+16) .EQ. TAB(25)(1:17)) THEN
        M=M+1
        DO  I=2,7
          IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(I+24)) THEN
            IPARL(I)=M
            GO TO 170
          ENDIF
        ENDDO
        GO TO 170
      ENDIF
      NMERK=M
C
      DO  I=1,7
        IF (IPARL(I) .EQ. 0) GO TO 20
      ENDDO
      GO TO 210
  190 N=0
  200 CALL KPRDLN (NTXR1,IRC)
      IF (IRC .NE. 0) GO TO 310
      IF (RDLINE(1:4) .EQ. '#End ') GO TO 320
      CALL ZVARSE (RDLINE,LIST,N)
      IF (N .EQ. 0) GO TO 20
      IF (RDLINE(LIST(1,1):LIST(2,1)) .EQ. TAB(7)) THEN
        DO  I=1,7
          IPARL(I)=0
        ENDDO
        GO TO 20
      ENDIF
  210 CKARTE='TF'
      J=3
      I=LIST(1,IPARL(1))
  220   K=ICHAR(RDLINE(I:I))
C                           Name
        J=J+1
        IF (J .LE. 5) THEN
          IF ((K .LT. 65 .OR. K .GT. 122 .OR.
     +      (K .GT. 90 .AND. K .LT. 97))) THEN
            GO TO 230
          ELSE
            CKARTE(J:J)=RDLINE(I:I)
            I=I+1
            GO TO 220
          ENDIF
        ENDIF
  230   J=6
C                           Unterscheider
  240   J=J+1
        CKARTE(J:J)=''''
  250   J=J+1
        CKARTE(J:J)=RDLINE(I:I)
  260   I=I+1
        IF (CKARTE(J:J) .EQ. ' ') THEN
          CKARTE(J:J)=''''
          J=J+2
          KST=2
          GO TO 270
        ENDIF
        IF (RDLINE(I:I) .EQ. '''') GO TO 240
      GO TO 250
C
  270 KEND=7+N-NMERK
  280 DO  K=KST,KEND
        I=LIST(1,IPARL(K))
  290     J=J+1
C                           Entferne standardabweichung
C
          IF (RDLINE(I:I) .EQ. '(') THEN
  300       I=I+1
            IF (RDLINE(I:I) .NE. ')') GO TO 300
          ELSE
            CKARTE(J:J)=RDLINE(I:I)
          ENDIF
        I=I+1
        IF (I .LT. LIST(2,IPARL(K))) GO TO  290
        if (ckarte(j:j) .ne. ' ') then
          j=j+1
          ckarte(j:j)=' '
        endif
      ENDDO
      IF (KEND .LT. 7) THEN
C
C                           Offensichtlich gibt es eine folgezeile
C
        CALL KPRDLN (NTXR1,IRC)
        IF (IRC .NE. 0) GO TO 310
        CALL ZVARSE(RDLINE,LIST,N)
        KST=KEND+1
        KEND=7
        GO TO 280
      ENDIF
      CKARTE(J+1:J+1)='8'
      NTY=4
      GO TO 340
C
  310 WRITE (WRLINE,'(A,I3)') 'EOF on',NTXR1
      CALL KPWRTE(NTDISP)
      NTYP=NTXR1+100
      CALL ZVEAEH
      NTY=0
      GO TO 330
C
  320 NTY=1
  330 KARPOI=0
      CKARTE=' '
      KARTE(20)=ISTKRT
      GO TO 350
C                            Teste, ob raumgruppe bekannt.
  331 continue
      irgsuc=nsym(ns)
      if (irgsuc .eq. 0) then
        write (wrline,'(a)') 'versuche xyz auszuschlachten.'
        call kpwrte (ntout )
        nsym(ns)=1
      endif
      go to 20
c
  332 CALL KPRDLN (NTXR1,IRC)
      IF (IRC .NE. 0) GO TO 310
      IF (RDLINE(1:4) .EQ. '#End ') GO TO 320
      N=0
      CALL ZVARSE (RDLINE,LIST,N)
      IF (N .EQ. 0) GO TO 20
      IF (RDLINE(1:5) .EQ. TAB(2)) GO TO 320
      IF (RDLINE(1:5) .EQ. TAB(7)) GO TO 50
  333 m=m+1
      IF (RDLINE(LIST(1,1):LIST(1,1)+19) .EQ. TAB(32)(1:20)) then
        IF (RDLINE(LIST(1,1):LIST(1,1)+25) .EQ. TAB(32)(1:26)) nmerk=m
        go to 332
      endif
      nty=6
      go to 335
  334 CALL KPRDLN (NTXR1,IRC)
      IF (IRC .NE. 0) GO TO 310
      IF (RDLINE(1:4) .EQ. '#End ') GO TO 320
      N=0
      CALL ZVARSE (RDLINE,LIST,N)
      IF (N .EQ. 0) GO TO 20
      IF (RDLINE(1:5) .EQ. TAB(2)) GO TO 320
      IF (RDLINE(1:5) .EQ. TAB(7)) GO TO 50
  335 if (n .eq. 0) go to 20
      ckarte='SY '''
      j=4
      do  n=1,80
        if (rdline(n:n) .eq. '''') go to 336
      enddo
  336 do  i=n+1,80
        j=j+1
        ckarte(j:j)=rdline(i:i)
        if (ckarte(j:j) .eq. '''') go to 337
      enddo
  337 if (ckarte(4:j) .eq. '''x, y, z''') go to 334
      write (wrline,'(a)') ckarte
      call kpwrte (ntout )
c     call kprdln (5,i)
c
  340 CKARTE(79:80)=';V'
      KARPOI=0
  350 RETURN
      END
