C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CZVLPK    12             ------------------
                          SUBROUTINE ZVLPK
C  CY-ENG-               ------------------
C
C                 Das Programm laed die Plotkommandos.
C
C   Die Plotkommandos werden in folgender Weise gespeichert:
C   (1) Laenge des Kommandos in Worten
C   (2) Kommandocode
C         1   PK
C       2-4   VB, VBS, VBR
C       5-6   BA, BT
C         7   PPFL
C      8-10   VEH,VEU,VE
C        11   unbenutzt
C     12-14   VD, VDS, VDR
C     15-17   PFU,PF,PFD
C
C                         Geschrieben: Hundt
C                  Geaendert: 291229 AUG 1989 (Hundt)
C                  Geaendert: 251704 JUN 2004 (Hundt)
C
C                        ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
C
      INTEGER *4 IAIN(72),IAT(8,PARDIM,2),IPLD(4),IVDBEF(3),MPBF(9)
      INTEGER *4 I,ICDNR,ICURP,IE,II,IPOI,ISH,ISYMBL
      INTEGER *4 J,JPOI,K,LEN,NATPE,NATPS,NTYPS,JSYMBL
C
      EQUIVALENCE (AIN(1),IAIN(1)),(AT(1,1,1),IAT(1,1,1))
      EQUIVALENCE (CONST(27),IPLD(1)),(CONST(15),ISH)
C
      DATA IVDBEF/4HVD  ,4HVDS ,4HVDR /
      DATA MPBF/2,4,9, 5,5,2, 12,14,3/
C
      NTYPS=NTYP
      GO TO (10,120,120,120,220,300,590,590,590,830,
C             1   2   3   4   5   6   7   8   9  10
     1 940,1080,1080,1080,1170,1170,1170,1240,1300,
C       11   12   13   14   15   16   17   18   19
     2 1080,1080,1360,1370), NTYPS
C        20   21   22   23
C                            PK - Plotte Kugeln
C
   10 IF (ISKP(14)) 30,20,40
   20 IAIN(1)=ISKP(53)
      IAIN(2)=NAT(NS)
      IAIN(3)=ISKP(8)
      IAIN(4)=ISKP(41)
CYENG1
   30 CALL FLES (IAIN,ISKP(31),3H4IE,20Hvon,bis,npkte,ndcb?$)
CYENG2
CYENGY   30 CALL FLES (IAIN,ISKP(31),3H4IE,20Hfrom,to,npnts,ndcb?$)
   40 IF (IABS(IAIN(3)) .LT. 2 .OR. IABS(IAIN(3)) .GT. 60) THEN
        IERR=12 0058 16
        GO TO 9999
      ENDIF
C
      LEN=6
      IF (ISKP(31).LE.3 .OR. IAIN(4) .LE. 0 .OR. IAIN(4) .GT. 6) LEN=5
      IF (IPKP(NS)+6 .LE. IPKDM) GO TO 100
   90 IERR=12 0065 11
      GO TO 9999
C                            Speichere Plotkommando
  100 IPK(IPKP(NS)+1,NS)=LEN
      IPK(IPKP(NS)+2,NS)=1
      DO  I=1,4
        IPK(IPKP(NS)+I+2,NS)=IAIN(I)
      ENDDO
      IPKP(NS)=IPKP(NS)+LEN
      GO TO 9999
C
C
C                            VB, VBS und VBR
C
  120 IF (ISKP(14)) 140,130,170
  130 AIN(6)=0.
      AIN(7)=.06
      IAIN(8)=11
      IAIN(9)=0
      IAIN(10)=0
      IAIN(11)=0
  140 CALL FLES (IAIN,ISKP(31),7H4I3F4IE,
CYENG1
     1 30Hu1,u2,z1,z2,dmin,dmax,r,frbz?$)
CYENG2
CYENGY     1 30Hu1,u2,z1,z2,dmin,dmax,r,colp?$)
      IF (ISKP(31) .LT. 4) GO TO 160
      IF (ISKP(32) .GT. 0) GO TO 170
  160 IERR=12 0093 16
      GO TO 9999
C
  170 LEN=13
      IF (IPKP(NS)+LEN .GT. IPKDM) GO TO 90
C
C                            Speichere Befehl
C
      IF (AIN(6) .LT. AIN(5)) THEN
        AIN(12)=AIN(6)
        AIN(6)=AIN(5)
        AIN(5)=AIN(12)
      ENDIF
      IPK(IPKP(NS)+1,NS)=LEN
      IPK(IPKP(NS)+2,NS)=NTYPS
      DO  I=1,11
        IPK(IPKP(NS)+I+2,NS)=IAIN(I)
      ENDDO
      IPKP(NS)=IPKP(NS)+LEN
      GO TO 9999
C                            Speichere Beschriftungskommando
C
  220 IF (IPKP(NS)+8 .GT. IPKDM) GO TO 90
      ICURP=IPKP(NS)+1
      IPK(IPKP(NS)+1,NS)=5
      IPK(IPKP(NS)+2,NS)=5
      IPK(IPKP(NS)+3,NS)=ISKP(41)
      IPK(IPKP(NS)+4,NS)=ISKP(49)
      IPK(IPKP(NS)+5,NS)=ISH
      CALL FLES (IPK(IPKP(NS)+3,NS),ISKP(31),4H2IFR,
CYENG1
     1 30HFarbe,Strichst.,Schrifthoehe?$)
CYENG2
CYENGY     1 27Hcolor,thickness,char-size?$)
      IPKP(NS)=IPKP(NS)+5
      ISH=IPK(IPKP(NS),NS)
      IAIN(1)=IPLD(1)
      IAIN(2)=IPLD(3)
      IAIN(3)=IPLD(4)
      ICDNR=0
  230 CALL FLES (IAIN,ISKP(31),4HC2FR,16Hcode,xoff,yoff?$)
      IPLD(3)=IAIN(2)
      IPLD(4)=IAIN(3)
      IF (ISKP(31) .LE. 0) GO TO 290
      IF (IPKP(NS)+3 .GE. IPKDM) GO TO 90
      IF (IAIN(1)) 240,250,260
  240 IAIN(1)=-IAIN(1)
      IF ((IAIN(1) .LE. 0) .OR. (IAIN(1) .GT. NCD(NS))) GO TO 280
      IAIN(1)=ICD(IAIN(1),NS)
      GO TO 260
C
  250 ICDNR=ICDNR+1
      IAIN(1)=ICDNR
      NTYP=7
      CALL ZVGC01 (IAIN(1))
      IF (IAIN(1) .EQ. 0) GO TO 290
  260 IF (IAIN(1) .LE. NATDM) IAIN(1)=IAIN(1)*200000+111001
      DO  I=1,3
        IPKP(NS)=IPKP(NS)+1
        IPK(IPKP(NS),NS)=IAIN(I)
      ENDDO
      IPK(ICURP,NS)=IPK(ICURP,NS)+3
      GO TO 230
C
  280 IERR=12 0157 16
  290 IF (IPK(ICURP,NS) .GE. 8) GO TO 9999
      IPKP(NS)=ICURP-1
      IERR=12 0160 16
      GO TO 9999
C                            BT - Beschrifte mit Text
C
  300 IF (ISKP(14)) 340,310,370
  310 IAIN(1)=IPLD(1)
      IAIN(2)=IPLD(2)
      IF (ISKP(19) .EQ. 0) IAIN(2)=0
      IAIN(3)=IPLD(3)
      IAIN(4)=IPLD(4)
      AIN(5)=CONST(15)
      IAIN(22)=ISKP(41)
      IAIN(23)=ISKP(49)
  340 CALL FLES (IAIN,ISKP(31),10H2C3F16A2IE,
CYENG1
     1 42Hc1,c2,xoff,yoff,schrh,text,Farbe,Str-st.?$)
CYENG2
CYENGY     1 44Hc1,c2,xoff,yoff,schrh,text,color,thickness?$)
      IF (ISKP(14) .LT. 0 .OR. ISKP(33) .LE. 0) THEN
        ISKP(33)=ISKP(34)
        ISKP(34)=0
      ENDIF
  370 CONST(15)=AIN(5)
C
      IF (IAIN(1) .EQ. 0) THEN
        DO  I=1,2
          IF (IAIN(I) .EQ. 0) THEN
            IAIN(I)=I
            NTYP=7
            CALL ZVGC01 (IAIN(I))
          ENDIF
        ENDDO
      ENDIF
C
      IF (IAIN(2) .LE. 0) AIN(2)=AIN(1)
      NTRY=16
      DO  NC=1,2
        IPLD(NC+2)=IAIN(NC+2)
        IPLD(NC)=IAIN(NC)
        ICDS(NC)=IAIN(NC)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
        IAIN(NC)=ICDS(NC)
      ENDDO
      IF (ISKP(19) .GT. 0) THEN
        J=ISKP(19)
      ELSE
C
        J=ISKP(33)
        IF (J .LE. 0) THEN
          IERR=12 0210 16
          GO TO 9999
        ENDIF
      ENDIF
C                            Teste, ob noch aufnahmefaehig.
      LEN=10+J
      IF (IPKP(NS)+LEN .GT. IPKDM) THEN
        IERR=12 0217 11
        GO TO 9999
      ENDIF
C                            Speichere.
      IPK(IPKP(NS)+1,NS)=LEN
      IPK(IPKP(NS)+2,NS)=6
      DO  I=1,5
        IPK(IPKP(NS)+I+2,NS)=IAIN(I)
      ENDDO
      IPK(IPKP(NS)+8,NS)=J
      DO  I=1,J
        IPK(IPKP(NS)+8+I,NS)=IAIN(I+5)
      ENDDO
      IPK(IPKP(NS)+9+J,NS)=IAIN(22)
      IPK(IPKP(NS)+10+J,NS)=IAIN(23)
      IPKP(NS)=IPKP(NS)+LEN
      GO TO 9999
C                            Verbinde Symbole - VS, VSS und VSR
C
  590 IF (ISKP(14)) 610,600,620
  600 AIN(5)=0.
      AIN(6)=0.
      AIN(7)=.06
      IAIN(8)=11
      IAIN(9)=0
      IAIN(10)=0
      IAIN(11)=0
      IAIN(12)=1
      IAIN(13)=NAT(NS)
  610 CALL FLES (IAIN(3),ISKP(31),7HAA3F6IE,
CYENG1
     1 41Hsur,szl,dmin,dmax,r,frbz,x1,x2,x3,n1,n2?$)
CYENG2
CYENGY     1 41Hsur,szl,dmin,dmax,r,colp,x1,x2,x3,n1,n2?$)
      IF (AIN(5) .LE. 0.) CALL ZVDTAB (IAIN(3),IAIN(4),AIN(5),2)
  620 NTYPS=NTYPS-5
      NATPS=MAX0(IAIN(12),1)
      NATPE=MIN0(IAIN(13),NAT(NS))
      CALL CNVTUP (IAIN(3),1,8)
      IF (AIN(6) .LT. AIN(5)) THEN
        AIN(14)=AIN(6)
        AIN(6)=AIN(5)
        AIN(5)=AIN(14)
      ENDIF
C                            Suche Element
      ISYMBL=IAIN(3)
      JSYMBL=IAIN(4)
      IPOI=NATPS-1
      GO TO 680
  670 IPOI=IPOI+1
      II=IAT(5,IPOI,NS)
      CALL CNVTUP (II,1,4)
      IF (II .EQ. ISYMBL) THEN
        IAIN(1)=IPOI
        GO TO 700
      ENDIF
  680 IF (IPOI .LT. NATPE) GO TO 670
      GO TO 9999
C
  690 IPOI=IPOI+1
      II=IAT(5,IPOI,NS)
      CALL CNVTUP (II,1,4)
      IF (II .NE. ISYMBL) THEN
        IAIN(2)=IPOI-1
        GO TO 1660
      ENDIF
  700 IF (IPOI .LT. NATPE) GO TO 690
      IAIN(2)=IPOI
C
 1660 IF (ISYMBL .EQ. JSYMBL) THEN
        JPOI=IAIN(1)-1
      ELSE
        JPOI=NATPS-1
      ENDIF
      GO TO 1680
 1670 JPOI=JPOI+1
      II=IAT(5,JPOI,NS)
      CALL CNVTUP (II,1,4)
      IF (II .EQ. JSYMBL) THEN
        IAIN(3)=JPOI
        GO TO 1700
      ENDIF
 1680 IF (JPOI .LT. NATPE) GO TO 1670
      GO TO 680
C
 1690 JPOI=JPOI+1
      II=IAT(5,JPOI,NS)
      CALL CNVTUP (II,1,4)
      IF (II .NE. JSYMBL) THEN
        IAIN(4)=JPOI-1
        GO TO 1710
      ENDIF
 1700 IF (JPOI .LT. NATPE) GO TO 1690
      IAIN(4)=JPOI
C                            Erzeuge VB-Statement.
 1710 LEN=13
      IF (IPKP(NS)+LEN .GT. IPKDM) GO TO 90
      IPK(IPKP(NS)+1,NS)=LEN
      IPK(IPKP(NS)+2,NS)=NTYPS
      DO  K=1,11
        IPK(IPKP(NS)+K+2,NS)=IAIN(K)
      ENDDO
      IPKP(NS)=IPKP(NS)+LEN
      GO TO 1680
C
C                            PPFL
  830 IF (ISKP(14)) 860,840,870
  840 DO  I=1,4
        IAIN(I)=0
      ENDDO
      AIN(5)=20.
      AIN(6)=160.
      AIN(7)=15.
      AIN(8)=.08
      AIN(9)=.24
      IAIN(10)=10
      IAIN(11)=ISKP(41)
  860 CALL FLES (IAIN,ISKP(31),7H3C6F2IE,
CYENG1
     1 36Hc1,c2,c3,ra,w1,w2,w3,r1,r2,ns,npen?$)
CYENG2
CYENGY     1 36Hc1,c2,c3,ra,w1,w2,w3,r1,r2,ns,colp?$)
  870 DO  I=1,3
        IF (IAIN(I) .LE. 0) THEN
          IERR=12 0341 16
          GO TO 9999
        ENDIF
      ENDDO
      LEN=12
      IF (ISKP(33) .GT. 1) LEN=13
      IF (IPKP(NS)+13 .LE. IPKDM) GO TO 910
  890 IERR=12 0348 11
      GO TO 9999
C
  910 IPK(IPKP(NS)+1,NS)=LEN
      IPK(IPKP(NS)+2,NS)=7
  920 DO  I=1,11
        IPK(IPKP(NS)+I+2,NS)=IAIN(I)
      ENDDO
      IPKP(NS)=IPKP(NS)+LEN
      GO TO 9999
C                            PKS - Plotte Kugeln nach Symbolen
C
  940 IF (ISKP(14) .NE. 0) GO TO 970
C
C                            Hole Input
      IAIN(1)=ISKP(24)
      IAIN(2)=ISKP(8)
      AIN(3)=0.
      IAIN(4)=1
      IAIN(5)=NAT(NS)
      IAIN(6)=ISKP(41)
      CALL FLES (IAIN,ISKP(31),6HAIF3IE,25Hsymbol,nst,r,n1,n2,ndcb?$)
      IF (IABS(IAIN(2)) .LT. 2) GO TO 960
      IF (IABS(IAIN(2)) .LE. 60) GO TO 970
  960 IERR=12 0372 16
      GO TO 9999
C                            Starte Suche in der Liste
C
  970 CALL CNVTUP (IAIN(1),1,4)
      LEN=5
      IF (ISKP(34) .LE. 2) GO TO 980
      LEN=6
      IF (IAIN(6) .LE. 0 .OR. IAIN(6) .GT. 6) GO TO 960
  980 I=IAIN(4)-1
  990 I=I+1
      IF (I .GT. IAIN(5)) GO TO 9999
      II=IAT(5,I,NS)
      CALL CNVTUP (II,1,4)
      IF (IAIN(1) .NE. II) GO TO 990
C
      J=I
      GO TO 1030
C
 1010 J=J+1
      IF (J .GT. IAIN(5)) GO TO 1050
      II=IAT(5,J,NS)
      CALL CNVTUP (II,1,4)
      IF (IAIN(1) .NE. II) GO TO 1050
 1030 IF (AIN(3) .LE. 0.) GO TO 1010
      AT(4,J,NS)=AIN(3)
      GO TO 1010
C                            Generiere PK-Kommando.
C
 1050 IF (IPKP(NS)+6 .GT. IPKDM) THEN
        IERR=12 0402 11
        GO TO 9999
      ENDIF
C
      IPK(IPKP(NS)+1,NS)=LEN
      IPK(IPKP(NS)+2,NS)=1
      IPK(IPKP(NS)+3,NS)=I
      IPK(IPKP(NS)+4,NS)=J-1
      IPK(IPKP(NS)+5,NS)=IAIN(2)
      IPK(IPKP(NS)+6,NS)=IAIN(6)
      IPKP(NS)=IPKP(NS)+LEN
      I=J
      GO TO 990
C                            Vielecke VEH,VEU,VE,PFU,PF.
C
 1080 IF (ISKP(14)) 1100,1090,1130
 1090 AIN(10)=0.
      AIN(11)=CONST(35)
      DO  I=3,6
        IAIN(I)=0.
      ENDDO
      IAIN(12)=0
      IAIN(13)=ISKP(44)
 1100 CALL FLES (IAIN,ISKP(31),11H4I2F2I3F2IE,
     1 55Hu1,u2, z1,z2, dmin,dmax, c1,c2, dn,dx, tol, ndcb, opt?$)
      IF (ISKP(14) .EQ. 0 .AND. ISKP(34) .LE. 0) THEN
        IERR=12 0428 16
        GO TO 9999
      ENDIF
C
 1130 IF (AIN(10) .LT. AIN(9)) THEN
        AIN(14)=AIN(10)
        AIN(10)=AIN(9)
        AIN(9)=AIN(14)
      ENDIF
C
 1150 LEN=15
      IF (IPKP(NS)+LEN .GT. IPKDM) GO TO 890
      IPK(IPKP(NS)+1,NS)=LEN
      I=NTYPS-4
      IF (NTYPS .GE. 20) I=NTYPS-5
      IPK(IPKP(NS)+2,NS)=I
      DO  I=1,13
        IPK(IPKP(NS)+I+2,NS)=IAIN(I)
      ENDDO
      IPKP(NS)=IPKP(NS)+LEN
      GO TO 9999
C                       VD, VDS und VDR
C
 1170 IF (ISKP(14) .NE. 0) GO TO 1180
      AIN(1)=0.06
      IAIN(2)=11
      IAIN(3)=0
      IAIN(4)=0
      IAIN(5)=0
      CALL FLES (IAIN,ISKP(31),5HF71CE,
CYENG1
     1 28Hr,frbz,x1,x2,x3, c1,c2,...?$)
CYENG2
CYENGY     1 28Hr,colp,x1,x2,x3, c1,c2,...?$)
 1180 I=ISKP(32)+5
      IF (IPKP(NS)+I .GT. IPKDM) THEN
        IERR=12 0464 11
        GO TO 9999
      ENDIF
C
      IF (I .LT. 10) THEN
        IERR=12 0469 16
        GO TO 9999
      ENDIF
C
      IPK(IPKP(NS)+1,NS)=I
      IPK(IPKP(NS)+2,NS)=NTYPS-3
      DO  K=1,5
        IPK(IPKP(NS)+K+2,NS)=IAIN(K)
      ENDDO
      IPK(IPKP(NS)+8,NS)=0
      J=9
 1220 K=IAIN(J-3)
      IF (K) 1221,1230,1225
 1221 K=-K
      IF (K .GT. NCD(NS)) THEN
        IERR=12 0484 16
        GO TO 9999
      ENDIF
C
      K=ICD(K,NS)
 1225 IF (K .LE. NATDM) K=K*200000+111001
 1230 IPK(IPKP(NS)+J,NS)=K
      J=J+1
      IF (J .LT. I) GO TO 1220
      IPK(IPKP(NS)+J,NS)=0
      IPKP(NS)=IPKP(NS)+I
      GO TO 9999
C                       VDM - Verbinde Mausliste
 1240 IAIN(2)=IVDBEF(1)
      AIN(3)=0.06
      IAIN(4)=11
      IAIN(5)=0
      IAIN(6)=0
      IAIN(7)=0
      IAIN(8)=0
CYENG1
      CALL FLES (IAIN(2),ISKP(31),5HAF4IE,13HBef, r,frbz?$)
CYENG2
CYENGY      CALL FLES (IAIN(2),ISKP(31),5HAF4IE,17HCommand, r,colp?$)
      CALL CNVTUP (IAIN(2),1,4)
      DO  I=1,3
        IF (IAIN(2) .EQ. IVDBEF(I)) THEN
          NTYPS=14+I
          GO TO 1260
        ENDIF
      ENDDO
      IERR=12 0515 16
      GO TO 9999
C
 1260 IAIN(2)=I+11
      IAIN(1)=ISKP(54)+9
      IF (IPKP(NS)+IAIN(1) .GT. IPKDM) THEN
        IERR=12 0521 11
        GO TO 9999
      ENDIF
C
      DO  I=1,8
        IPK(IPKP(NS)+I,NS)=IAIN(I)
      ENDDO
      NTYP=7
      K=8
      DO  I=1,ISKP(54)
        J=I
        CALL ZVGC01 (J)
        IF (IPK(IPKP(NS)+K,NS) .EQ. J) J=0
        K=K+1
        IPK(IPKP(NS)+K,NS)=J
      ENDDO
      IPKP(NS)=IPK(IPKP(NS)+1,NS)+IPKP(NS)
      IPK(IPKP(NS),NS)=0
      GO TO 9999
C                            Durchsuche Plotbefehle fuer XC
 1300 I=1
      GO TO 1350
 1310 J=4
      IF (IPK(I+1,NS) .LT. MPBF(J)) GO TO 1320
      IF (IPK(I+1,NS) .GT. MPBF(J+1)) GO TO 1320
      IF (IPK(I+MPBF(J+2),NS) .EQ. IAIN(1)) IPK(I+MPBF(J+2),NS)=IAIN(2)
      GO TO 1340
 1320 CONTINUE
      IF (IPK(I+1,NS) .NE. 6) GO TO 1340
      J=I+IPK(I,NS)-2
      IF (IPK(J,NS) .EQ. IAIN(1)) IPK(J,NS)=IAIN(2)
 1340 I=I+IPK(I,NS)
 1350 IF (I .LT. IPKP(NS)) GO TO 1310
      GO TO 9999
C                       PFD - Plotte Flaeche direkt
 1360 IAIN(1)=0
      CALL FLES (IAIN,ISKP(31),4H10CE,19Hndcb,c0,c1,...,cn?$)
      IE=ISKP(31)
      IF (IE .LE. 4) THEN
        IERR=12 0560 16
        GO TO 9999
      ENDIF
C
      IF (IPKP(NS)+IE+3 .GT. IPKDM) THEN
        IERR=12 0565 11
        GO TO 9999
      ENDIF
C
      IPK(IPKP(NS)+1,NS)=IE+2
      IPK(IPKP(NS)+2,NS)=17
      J=IPKP(NS)+3
      IPK(J,NS)=IAIN(1)
      NC=1
      NTRY=17
      NTYP=7
      DO  I=2,IE
        ICDS(1)=IAIN(I)
        IF (ICDS(1) .EQ. 0) THEN
          ICDS(1)=I-1
          CALL ZVGC01 (ICDS(1))
        ENDIF
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
        J=J+1
        IPK(J,NS)=ICDS(1)
      ENDDO
      IPKP(NS)=J
      GO TO 9999
C                            AFZ - Aendere farbzeiger
 1370 ICDS(1)=0
      ICDS(2)=1
      ICDS(3)=999
CYENG1
      CALL FLES (ICDS,ISKP(31),3H3IE,12Hnr,von,bis?$)
CYENG2
CYENGY      CALL FLES (ICDS,ISKP(31),3H3IE,12Hno,from,to?$)
C
 1380 J=1
      K=0
 1390 K=K+1
      IF (J .LT. IPKP(NS)) THEN
        IF (K .GE. ICDS(2) .AND. K .LE. ICDS(3)) THEN
          IF (IPK(J+1,NS) .GE. 2 .AND. IPK(J+1,NS) .LE. 4) THEN
            IPK(J+9,NS)=ICDS(1)
          ELSE IF (IPK(J+1,NS) .GE. 12 .AND. IPK(J+1,NS) .LE. 14) THEN
            IPK(J+3,NS)=ICDS(1)
          ENDIF
        ENDIF
        J=J+IPK(J,NS)
        GO TO 1390
      ENDIF
C
 9999 RETURN
      END
