C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPMACR   34             -------------------
                          SUBROUTINE ZVMACR
C  CY-ENG-               -------------------
C
C                         Geschrieben: Hundt
C                  Geaendert:  261208 MAY 2017  (Hundt)
C
C
C     Kommando  NTYP  Bedeutung
C     EPU         4   Einzelbild ueberzeichnungsfrei
C     GP          2   Generiere Punkte
C     STP         1   Stereoplot
C     STPU        3   Stereoplot ueberzeichnugsfrei
C     D           5   Drehen und Einzel/Stereoplot ueberzeichnugsfrei
C     RDRW        6   Redraw
C     DRET        7   =D, aber kein wait
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
      INTEGER *4 STDIN
      PARAMETER (STDIN=5)
      INTEGER *4 IDBUF(5),KDOS(11),IEXFLG,KDVDGC(2),IAIN(72),INBF(8)
      INTEGER *4 I,IACHSE,IEND,IRC,ISTRT,IUNT,J,KDS,KDSTPU,KDUNDF
      INTEGER *4 NPKTE,NTYPS,NTYPT,NSSV
      REAL    *4 DBUF(5),ANBF(8),FLDORG(6),BLANK,URSAV(3)
C
      EQUIVALENCE (AIN(1),IAIN(1)),(DBUF(1),IDBUF(1))
      EQUIVALENCE (INBF(1),ANBF(1),NPKTE),(INBF(2),IACHSE)
      EQUIVALENCE (INBF(6),ISTRT),(INBF(7),IEND),(ISKP(24),BLANK)
C
      SAVE INBF,DBUF,IDBUF
C
      DATA KDUNDF/4HUNDF/
      DATA IDBUF(1)/2/,DBUF(2)/5./,IDBUF(3)/4HEPU /,KDS/4HS   /
      DATA IDBUF(4)/1/,IDBUF(5)/0/,KDSTPU/4HSTPU/,KDVDGC/4HVDGC,4H;   /
      DATA KDOS/4H1   ,4H2   ,4H3   ,4H4   ,
     + 4H-1  ,4H-2  ,4H-3  ,4H-4   ,4H-   ,4H    ,4H9   /
C
      NSSV=NS
      IF (NTYP .EQ. 6) THEN
        IF (ISKP(59) .EQ. 0 .OR. NCD(NS) .EQ. 0) GO TO 165
        NTYP=ISKP(59)
      ENDIF
      IF (NTYP .EQ. 3 .OR. NTYP .EQ. 4) ISKP(59)=NTYP
      IEXFLG=0
      NTYPT=NTYP
    5 NTYPS=NTYP
      ISKP(25)=0
      GO TO (20,170, 10,10,300,999,300), NTYPS
C             1   2   3  4   5   6   7
C
C                            Kommandos EPU/STPU
   10 ISKP(25)=1
C                            Kommando STP
   20 ISKP(14)=1
      ISKP(59)=NTYP
C
      DO  I=1,6
        FLDORG(I)=0.
      ENDDO
      IF (ISKP(13) .NE. 0) THEN
        FLDORG(4)=CONST(9)
        FLDORG(6)=-CONST(9)
      ELSE
        FLDORG(3)=CONST(8)
        FLDORG(5)=-CONST(8)
      ENDIF
C                            LS
      IF (ISKP(7) .NE. 0) CALL UPLINF (AIN,6)
C
C                            SRT 3
C
   30 NTYP=2
      IAIN(1)=3
      CALL ZVSRT
      NTYP=9
      CALL ZVSRT
      IF (ISKP(7) .EQ. 2 .AND. NS .EQ. NSSV) THEN
        NS=3-NS
        GO TO 30
      ENDIF
      NS=NSSV
      IF (NTYPS .GT. 3) GO TO 110
C
C                            DK 2 -SW/2  (r. Bild)
C
      CALL UPLINF (FLDORG(3),5)
      NTYP=18
      IAIN(1)=2
      AIN(2)=-CONST(13)*.5
      CALL ZVK
C                            EXP / EXPU
  110 NTYP=1
      CALL ZVEXPU
      IEXFLG=IERR
      IF (NTYPS .GT. 3) GO TO 160
C
C                            VF -XDIM 0
C
      CALL UPLINF (FLDORG(5),5)
C
C                            DK 2 +SW (l. Bild)
      NTYP=18
      IAIN(1)=2
      AIN(2)=CONST(13)
      CALL ZVK
C                            EXP / EXPU
C
      NTYP=1
      IF (IEXFLG .EQ. 0) CALL ZVEXPU
C
C                            DK 2 -SW/2
      NTYP=18
      IAIN(1)=2
      AIN(2)=-CONST(13)*.5
      CALL ZVK
C
  160 CALL UPLINF (AIN,0)
      IF (NTYPT .EQ. 5) GO TO 320
      IF (ISKP(57) .NE. 0) THEN
        NTYP=7
        CALL ZVO
        GO TO 290
      ENDIF
C
  165 IF (ISKP(14) .EQ. 0) CALL FLES (IAIN,ISKP(31),1HE,2H?$)
      GO TO 290
C                            GP - Generiere Punkte
  170 ISTRT=1
      IEND=0
      INBF(3)=KDUNDF
      INBF(4)=1
      ANBF(5)=.3
      CALL FLES (INBF,ISKP(31),8H2IAIF2IE,
CYENG1
     1 38Hnpkte,iachse,name,iuntr,r,istrt,iend?$)
CYENG2
CYENGY     1 37Hnpnts,iaxis,name,Iext.,r,istrt,iend?$)
      IUNT=INBF(4)
      INBF(8)=INBF(3)
      CALL CNVTUP(ANBF(8),1,4)
      IF (NPKTE .LE. 1 .OR. INBF(4) .LT. 0 .OR. INBF(4) .GT. 9900) THEN
        IERR=34 0147 16
        GO TO 999
      ENDIF
C
      IF (IEND .LE. 0) IEND=NPKTE
      AIN(2)=360./FLOAT(NPKTE)
      IAIN(1)=IACHSE
      ISKP(14)=1
      NTYP=5
C
      DO I=1,NPKTE
        IF (I .GE. ISTRT) THEN
          IF (NAT(NS) .GE. NATDM) THEN
            IERR=34 0161 02
            GO TO 290
          ENDIF
C
          NAT(NS)=NAT(NS)+1
          DO  J=1,3
            AT(J,NAT(NS),NS)=PTRIKL(J)
          ENDDO
          AT(4,NAT(NS),NS)=ANBF(5)
          AT(5,NAT(NS),NS)=ANBF(3)
          AT(6,NAT(NS),NS)=BLANK
          AT(7,NAT(NS),NS)=ANBF(8)
          J=0
          CALL KPNTOS (IUNT,AT(6,NAT(NS),NS),J,0)
          IUNT=IUNT+1
        ENDIF
        IF (I .GE. IEND) GO TO 290
        CALL ZVGE01
        IF (IERR .NE. 0) GO TO 290
      enddo
      GO TO 290
C                       Kommando D - Drehe und Plot
C
  300 CONTINUE
      IF (ISKP(59) .EQ. 3) IDBUF(3)=KDSTPU
      IF (ISKP(59) .EQ. 4) IDBUF(3)=0
      CALL FLES (IDBUF,ISKP(31),6HJGA2IE,
CYENG1
     + 31HAchse,Grad,EPU/STPU,Opt1,Opt2?$)
CYENG2
CYENGY     + 32HAxis,degr.,EPU/STPU,opt1,opt2? $)
      CALL CNVTUP (DBUF(3),1,4)
      IF (IDBUF(3) .EQ. KDS) IDBUF(3)=KDSTPU
      IF (NCD(NS) .EQ. 0) THEN
        IERR=34 0193 12
      ENDIF
      IF ((IDBUF(1) .GT. 0) .AND. (IDBUF(1) .LE. 4)) GO TO 310
      IERR=34 0196 16
      GO TO 999
C                            DK / DKV
  310 CONTINUE
      IF (IDBUF(1) .EQ. 4) THEN
        DO  I=1,3
          URSAV(I)=UR(I,NS)
        ENDDO
        NTYP=22
        IAIN(1)=0
        IAIN(2)=0
        AIN(3)=DBUF(2)
        CALL ZVGE01
        IF (IDBUF(4) .NE. 0) THEN
          DO  I=1,3
            UR(I,NS)=URSAV(I)
          ENDDO
        ENDIF
        IF (IERR .NE. 0) GO TO 999
      ELSE
        NTYP=2
        IAIN(1)=IDBUF(1)
        AIN(2)=DBUF(2)
        ISKP(14)=1
        CALL ZVK
      ENDIF
      IF (IDBUF(4) .NE. 0) THEN
        NTYP=1
        CALL ZVFKTR
      ENDIF
C
      NTYP=4
      IF (IDBUF(3) .EQ. KDSTPU) NTYP=3
      GO TO 5
C
  320 IF (IDBUF(5) .NE. 0) THEN
        IAIN(1)=0
        IAIN(2)=0
        CALL UPLINF (AIN,31)         ! BUFN 0,0
      ENDIF
      IF (NTYPS .EQ. 7) GO TO 290
C
C                            WAIT
      CALL KPRDLN (STDIN,IRC)
      READ (RDLINE,330) KARTE
  330 FORMAT (20A4)
      DO  I=1,11
        IF (KARTE(1) .EQ. KDOS(I)) THEN
          IF (I .EQ. 10) GO TO 310
          IF (I .EQ. 9) THEN
            DBUF(2)=-DBUF(2)
            GO TO 310
          ENDIF
          IF (I .LE. 4) THEN
            IDBUF(1)=I
            GO TO 310
          ENDIF
          IF (I .LE. 8) THEN
            IDBUF(1)=I-4
            DBUF(2)=-DBUF(2)
            GO TO 310
          ENDIF
          IF (I .EQ. 11) THEN
            DO  J=1,20
              KARTE(J)=KDOS(10)
            ENDDO
            KARTE(1)=KDVDGC(1)
            KARTE(2)=KDVDGC(2)
            KARPOI=0
            GO TO 290
          ENDIF
        ENDIF
      ENDDO
      IF (NTOSYS .GT. 0 .AND. NTIN .EQ. STDIN) THEN
        WRITE (WRLINE,'(20A4)') KARTE
        CALL KPWRTE (NTOSYS)
      ENDIF
      KARPOI=0
C
  290 ISKP(14)=0
C
  999 NS=NSSV
      RETURN
      END
