C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         76              -------------------
                           SUBROUTINE ZVMDLS
C  CY-ENG-                -------------------
C
C  Das programm produziert einen eingabefile fuer das programm DLS-76
C
C                 geschrieben: 120915 NOV 1996 (Hundt)
C                   geaendert: 150953 JUN 2004 (Hundt)
C
C   NTYP
C     1   MDLS   Mache DLS eingabefile
C     2   AR     Abstands-restraints
C     3   WR     Winkel-restraints
C     4   OR     Restraints listen
C     5   ARE    AR-Tabellenende
C     6   WRE    WR-Tabellenende
C     7          Abstands- und winkelrestraints auf NTBILF
C
C                         -------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),I,J,K,L,JPOI,IFLG,NCDSV,ISKP15,ID
      INTEGER *4 INBFR(5),ICL,ICJ,NATORG,IARDIM,IWRDIM
      INTEGER *4 JJJ,ISKP5,NATSV,NCDASV,NCE,ZVTBDG,IARPOI,IWRPOI
      PARAMETER (IARDIM=20,IWRDIM=40)
      REAL    *4 TEMP,V(3),BDGBF(3,3),ATAB(IARDIM)
      REAL    *4 WTAB(IWRDIM)
      INTEGER *4 IATAB(4,IARDIM),IWTAB(6,IWRDIM)
      CHARACTER *1 CH(3)
C
      EQUIVALENCE (AIN(1),IAIN(1))
C
      SAVE INBFR,NATORG,IARPOI,IWRPOI,IATAB,IWTAB,ATAB,WTAB
C
      DATA CH/'X','Y','Z'/,INBFR/0,0,1,4HX   ,1/
      DATA IARPOI/0/,IWRPOI/0/
C
      GO TO (10,200,210,230,240,240,250),NTYP
C             1   2   3   4   5   6   7
   10 CONTINUE
      NATORG=NAT(NS)
      CALL FLES (INBFR(3),ISKP(31),4HIAIE,12Hopt,name,n?$)
      CALL CNVTUP (INBFR(4),1,4)
      IF (NCD(NS) .LT. NCDA(NS)) THEN
        IERR=76 0047 18
        GO TO 999
      ENDIF
C                            Sortiere die codes, und zwar so, dass die
C                            xxx55501 nach vorne kommen.
      ISKP(14)=1
      NTYP=3
      CALL ZVSRT
      JJJ=0
      DO  I=1,NCD(NS)
        IF (MOD(ICD(I,NS),200000) .NE. 111001) THEN
          DO  J=I+1,NCD(NS)
            IF (MOD(ICD(J,NS),200000) .EQ. 111001) THEN
              ID=ICD(I,NS)
              ICD(I,NS)=ICD(J,NS)
              ICD(J,NS)=ID
              JJJ=I
              GO TO 15
            ENDIF
          ENDDO
        ELSE
          JJJ=I
        ENDIF
   15   CONTINUE
      ENDDO
      IF (JJJ .NE. 0) THEN
        IF (JJJ .LT. NCD(NS)-1) THEN
          NCDA(NS)=JJJ+1
          NTYP=3
          ISKP(14)=1
          CALL ZVSRT
          NCDA(NS)=1
        ENDIF
      ELSE
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVMDLS0078 - Vermisse Atome vom Typ xx55501.'
CYENG2
CYENGY     +  'ZVMDLS0078 - Missing atoms of type xx55501.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
C                            Vorspann
      NTYP=NTPCH
      CALL ZVEAEH
      WRITE (WRLINE,'(A,18A4)') 'TITLE  ',(TITEL(I,NS),I=1,18)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'DLS-76        99             0'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A,9X,6F10.4)') 'CELL   TRIC',(ZELLE(I,NS),I=1,6)
      CALL KPWRTE (NTPCH)
      IF (NHMSNR(3,NS) .NE. 0) THEN
        WRITE (WRLINE,'(A,4X,2A4,5H (NO.,I6,1H))')
     +  'HMS',(NHMSNR(I,NS),I=1,2)
        CALL KPWRTE (NTPCH)
      ENDIF
C                            Schleife ueber die Codeliste
      ISKP5=ISKP(5)
      ISKP(5)=0
      NCDSV=NCD(NS)
C
      DO  ID=1,JJJ
        IC=ID
        NC=1
        NTRY=40
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        CALL KPCVNM (AT(5,IANR,NS),1,AIN(5),AIN(7))
        CALL CNVTUP (AIN(5),1,8)
C
C                          Produziere ATOM anweisung.
C
        WRITE (WRLINE,'(A,A4,A2,3F8.5)')
     +   'ATOM   ',AIN(5),AIN(6),(X(J,1),J=1,3)
C
C                        Teste, ob in spezieller lage.
        NCDA(NS)=NCD(NS)+1
        ISKP15=ISKP(15)
        ISKP(15)=-1
        ICDS(1)=IANR
        IZ1=IANR
        IZ2=IANR
C                        Fuehre ATB aus.
        NTYP=1
        X(1,7)=CONST(21)
        X(2,7)=CONST(21)
        X(3,7)=CONST(21)
        CALL ZVADD
        J=NCD(NS)-NCDA(NS)+1
        IF (J .GT. 1) THEN
          WRITE (WRLINE(44:73),'(A,I3,A)')
CYENG1
     +     'Spezielle Lage (',NSYM(NS)/J,')'
CYENG2
CYENGY     +     'Special pos. (',NSYM(NS)/J,')'
        ENDIF
        NCD(NS)=NCDSV
        NCDA(NS)=1
        ISKP(15)=ISKP15
        CALL KPWRTE (NTPCH)
      ENDDO
C                          Jetzt die SYMEQ anweisungen.
      DO  ID=JJJ+1,NCD(NS)
        ICDS(1)=ICD(ID,NS)
        NC=1
        NTRY=26
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        CALL KPCVNM (AT(5,IANR,NS),1,AIN(5),AIN(7))
        CALL CNVTUP (AIN(5),1,8)
        DO  K=1,3
          X2(K)=X1(K)
        ENDDO
C                            Durchlaufe die xx55501 atome, um zu
C                            testen, ob dieses atom an eines gebunden
C                            ist.
        DO  IC=1,JJJ
          ICDS(2)=ICD(IC,NS)
          NC=2
          NTRY=26
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO  999
          DO  I=1,3
            V(I)=X2(I)-X1(I)
          ENDDO
          TEMP=V(1)*V(1)+V(2)*V(2)+V(3)*V(3)
          IF (ZVTBDG(TEMP) .NE. 0) GO TO 16
        ENDDO
        GO TO 20
   16   NC=1
        NTRY=32
        IC=ID
        CALL ZVDEK
        IF (INBFR(3) .NE. 0) THEN
C
C                        Falls die SYMEQ atome auch in die
C                        parameterliste uebernommen werden,
C                        erfinde neue namen.
C
          AIN(7)=AT(5,IANR,NS)
          CALL CNVTUP (AIN(7),1,4)
          IAIN(10)=INBFR(4)
          IAIN(11)=ISKP(24)
          IAIN(13)=0
          CALL KPNTOS (INBFR(5),IAIN(11),IAIN(13),0)
          IF (NAT(NS) .LT. NATDM) THEN
            NAT(NS)=NAT(NS)+1
            IAIN(8)=ISKP(24)
            CALL KPCVNM (AIN(10),1,IAIN(8),IAIN(13))
            AT(5,NAT(NS),NS)=AIN(7)
            AT(6,NAT(NS),NS)=AIN(8)
            AT(7,NAT(NS),NS)=AIN(7)
            CALL CNVTUP (AT(7,NAT(NS),NS),1,4)
            DO  I=1,3
              AT(I,NAT(NS),NS)=X(I,1)
            ENDDO
            AT(4,NAT(NS),NS)=AT(4,IANR,NS)
            ICLRP(NAT(NS),NS)=ICD(ID,NS)
            IPFLG(NAT(NS),NS)=IPFLG(IANR,NS)
            IF (IPFLG(NAT(NS),NS) .NE. 0) THEN
              DO  I=1,3
                K=2
                DO  J=1,3
                  TFVKT(I,J,NAT(NS),NS)=
     +            SYM(K,ISYNR,NS)*TFVKT(1,J,IANR,NS)+
     +            SYM(K+1,ISYNR,NS)*TFVKT(2,J,IANR,NS)+
     +            SYM(K+2,ISYNR,NS)*TFVKT(3,J,IANR,NS)
                  K=K+4
                ENDDO
              ENDDO
            ENDIF
          ELSE
            IERR=76 0217 02
            GO TO 140
          ENDIF
          INBFR(5)=INBFR(5)+1
        ELSE
          IAIN(7)=IAIN(5)
          IAIN(8)=IAIN(6)
        ENDIF
        CALL KPCVNM (AIN(7),1,AIN(12),AIN(11))
        WRITE (WRLINE,'(A,A4,A2,1X,A4,A2)')
     +   'SYMEQ  ',AIN(5),AIN(6),AIN(12),AIN(13)
C
C                        Jetzt fehlt noch die symmetrie.
        J=0
        JPOI=22
        DO  I=1,9,4
          IFLG=0
          J=J+1
          IAIN(7)=IFIX(SYM(I,ISYNR,NS)*12.+.5)+(IT(J)-5)*12
          IF (IAIN(7) .NE. 0) THEN
            IFLG=1
            IF (IAIN(7) .LT. 0) THEN
              WRLINE(JPOI:JPOI)='-'
              JPOI=JPOI+1
              IAIN(7)=-IAIN(7)
            ENDIF
            IF (MOD(IAIN(7),12) .EQ. 0) THEN
              WRITE (WRLINE(JPOI:JPOI+1),'(I2)') IAIN(7)/12
              JPOI=JPOI+2
            ELSE
              IAIN(8)=12
              DO  K=1,2
                IF (MOD(IAIN(7),2) .EQ. 0) THEN
                  IAIN(7)=IAIN(7)/2
                  IAIN(8)=IAIN(8)/2
                ENDIF
              ENDDO
              IF (MOD(IAIN(7),3) .EQ. 0) THEN
                IAIN(7)=IAIN(7)/3
                IAIN(8)=IAIN(8)/3
              ENDIF
              WRITE (WRLINE(JPOI:JPOI+4),'(I2,A,I2)')
     +         IAIN(7),'/',IAIN(8)
              JPOI=JPOI+5
            ENDIF
          ENDIF
          DO  K=1,3
            IF (SYM(I+K,ISYNR,NS) .NE. 0) THEN
              IF (SYM(I+K,ISYNR,NS) .LT. 0) THEN
                WRLINE(JPOI:JPOI)='-'
                JPOI=JPOI+1
              ELSE
                IF (IFLG .NE. 0) THEN
                  WRLINE(JPOI:JPOI)='+'
                  JPOI=JPOI+1
                ENDIF
              ENDIF
              WRLINE(JPOI:JPOI)=CH(K)
              JPOI=JPOI+1
              IFLG=1
            ENDIF
          ENDDO
          IF (I .NE. 9) THEN
            WRLINE(JPOI:JPOI)=','
            JPOI=JPOI+1
          ENDIF
        ENDDO
C                        Entferne ueberfluessige blanks.
        J=21
        DO  I=22,JPOI
          IF (WRLINE(I:I) .NE. ' ') THEN
            J=J+1
            WRLINE(J:J)=WRLINE(I:I)
          ENDIF
        ENDDO
        WRLINE(J+1:JPOI)=' '
        CALL KPWRTE (NTPCH)
   20   CONTINUE
      ENDDO
      ISKP(5)=ISKP5
C                            MDST - Make DISTAN anweisungen
  100 CONTINUE
      CALL FLES (AIN,ISKP(31),1HE,2H?$)
      NATSV=NAT(NS)+1
      NCDSV=NCD(NS)
C
C--- Stelle nun um jedes atom dessen umgebung zusammen.
C
      DO  I=1,NCDSV
        NCD(NS)=NCDSV
        NC=1
        ICDS(NC)=ICD(I,NS)
        NTRY=26
        CALL ZVDEK
        IF (NCD(NS) .GE. NCDDM) GO TO 990
        NCD(NS)=NCD(NS)+1
        ICD(NCD(NS),NS)=ICD(I,NS)
        DO  K=1,3
          V(K)=X1(K)
        ENDDO
C                            Zielatome.
        DO  J=1,NCDSV
          IF (I .NE. J) THEN
            NC=2
            ICDS(NC)=ICD(J,NS)
            NTRY=26
            CALL ZVDEK
            IF (NCD(NS) .GE. NCDDM) GO TO 990
            NCD(NS)=NCD(NS)+1
            ICD(NCD(NS),NS)=ICD(J,NS)
            DO  K=1,3
              X2(K)=V(K)-X1(K)
            ENDDO
C                            Berechne abstand ...
C
            TEMP=X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3)
C
C                            ... und teste, ob es hierzu einen
C                                verbinde-plotbefehl gibt.
C
            IF (ZVTBDG(TEMP) .EQ. 0) NCD(NS)=NCD(NS)-1
          ENDIF
        ENDDO
C                            Jetzt die abstands- und winkelrestraints
C
        IF (NCD(NS)-NCDSV .GT. 1) THEN
          JJJ=2
          NCE=NCD(NS)
          DO  J=NCDSV+1,NCE-1
            NC=1
            ICDS(1)=ICD(J,NS)
            NTRY=26
            CALL ZVDEK
            IF (IERR .NE. 0) GO TO 999
            ICJ=IANR
            IF (J .EQ. NCDSV+1) THEN
              AIN(5)=AT(5,IANR,NS)
              AIN(6)=AT(6,IANR,NS)
            ENDIF
            IF (ICDS(1) .NE. IANR*200000+111001) THEN
              DO  K=NATORG+1,NAT(NS)
                IF (ICLRP(K,NS) .EQ. ICDS(1)) THEN
                  ICJ=K
                  GO TO 102
                ENDIF
              ENDDO
            ENDIF
  102       DO  K=1,3
              BDGBF(K,1)=X1(K)
              BDGBF(K,3)=X(K,1)
            ENDDO
            DO  L=J+1,NCE
              NC=2
              ICDS(2)=ICD(L,NS)
              NTRY=26
              CALL ZVDEK
              IF (IERR .NE. 0) GO TO 999
              ICL=IANR
              IF (ICDS(2) .NE. IANR*200000+111001) THEN
                DO  K=NATORG+1,NAT(NS)
                  IF (ICLRP(K,NS) .EQ. ICDS(2)) THEN
                    ICL=K
                    GO TO 104
                  ENDIF
                ENDDO
              ENDIF
  104         DO  K=1,3
                BDGBF(K,2)=X1(K)
              ENDDO
C
C--- Teste, ob nicht schon vorhanden. Der schwerpunkt der bindung
C    ist referenz zur ermittlung symmetrieaequivalenter bindungen.
C    Teste, ob nicht schon vorhanden.
C
              IF (NAT(NS) .LT. NATDM) THEN
                NAT(NS)=NAT(NS)+1
                DO  K=1,3
                  AT(K,NAT(NS),NS)=(BDGBF(K,3)+X(K,2))*0.5
                ENDDO
C                            Suche punkt.
C
                IF (NAT(NS) .GT. NATSV) THEN
                  IZ1=NATSV
                  IZ2=NAT(NS)-1
C                            Fuehre AKS aus.
                  NTYP=1
                  DO  K=1,3
                    X(K,7)=0.2*RK(K,NS)
                    X(K,1)=AT(K,NAT(NS),NS)
                  ENDDO
                  NCDASV=NCDA(NS)
                  NCDA(NS)=NCD(NS)+1
                  CALL ZVADD
                  K=NCD(NS)-NCDA(NS)
                  NCD(NS)=NCDA(NS)-1
                  NCDA(NS)=NCDASV
                  IF (IERR .NE. 0) THEN
                    NAT(NS)=NATSV-1
                    GO TO 999
                  ENDIF
                  IF (K .GE. 0) THEN
C
C                            Diese bindung hatten wir schon.
C
                    NAT(NS)=NAT(NS)-1
                    GO TO 130
                  ENDIF
                ENDIF
              ENDIF
C                            Wenn JJJ=3 ist teste, ob es sich
C                            nicht vielleicht um eine bindung handelt.
              DO  K=1,3
                X2(K)=BDGBF(K,1)-BDGBF(K,2)
              ENDDO
              TEMP=X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3)
              IF (JJJ .EQ. 3 .AND. ZVTBDG(TEMP) .NE. 0) THEN
                NAT(NS)=NAT(NS)-1
                GO TO 130
              ENDIF
C
C--- Wenn fuer diese bindung werte hinterlegt wurden, nimm diese.
C
              AIN(1)=AT(5,ICJ,NS)
              AIN(2)=AT(6,ICJ,NS)
              AIN(3)=AT(5,ICL,NS)
              AIN(4)=AT(6,ICL,NS)
              CALL CNVTUP (AIN,1,16)
              IF (JJJ .EQ. 2) THEN
                DO  K=1,IARPOI
                  IF ((AIN(1) .EQ. IATAB(1,K)) .AND.
     +              (IAIN(3) .EQ. IATAB(3,K))) THEN
                    IF (((IATAB(2,K) .EQ. ISKP(24)) .OR.
     +                   (IATAB(2,K) .EQ. IAIN(2))) .AND.
     +                  ((IATAB(4,K) .EQ. ISKP(24)) .OR.
     +                   (IATAB(4,K) .EQ. IAIN(4)))) GO TO 110
                  ENDIF
                  IF ((IAIN(3) .EQ. IATAB(1,K)) .AND.
     +              (IAIN(1) .EQ. IATAB(3,K))) THEN
                    IF (((IATAB(2,K) .EQ. ISKP(24)) .OR.
     +                   (IATAB(2,K) .EQ. IAIN(4))) .AND.
     +                  ((IATAB(4,K) .EQ. ISKP(24)) .OR.
     +                   (IATAB(4,K) .EQ. IAIN(2)))) GO TO 110
                  ENDIF
                ENDDO
              ELSE
                DO  K=1,IWRPOI
                  IF ((IAIN(5) .EQ. IWTAB(3,K)) .AND.
     +              ((IAIN(6) .EQ. IWTAB(4,K)) .OR.
     +              (ISKP(24) .EQ. IWTAB(4,K)))) THEN
                    IF ((IAIN(1) .EQ. IWTAB(1,K)) .AND.
     +                (IAIN(3) .EQ. IWTAB(5,K))) THEN
                      IF (((IWTAB(2,K) .EQ. ISKP(24)) .OR.
     +                     (IWTAB(2,K) .EQ. IAIN(2))) .AND.
     +                    ((IWTAB(6,K) .EQ. ISKP(24)) .OR.
     +                     (IWTAB(6,K) .EQ. IAIN(4)))) GO TO 105
                    ENDIF
                    IF ((IAIN(3) .EQ. IWTAB(1,K)) .AND.
     +                (IAIN(1) .EQ. IWTAB(5,K))) THEN
                      IF (((IWTAB(2,K) .EQ. ISKP(24)) .OR.
     +                     (IWTAB(2,K) .EQ. IAIN(4))) .AND.
     +                    ((IWTAB(6,K) .EQ. ISKP(24)) .OR.
     +                     (IWTAB(6,K) .EQ. IAIN(2)))) GO TO 105
                    ENDIF
                  ENDIF
                ENDDO
              ENDIF
              TEMP=SQRT(TEMP)
              GO TO 120
C
  105         TEMP=WTAB(K)
              GO TO 120
  110         TEMP=ATAB(K)
  120         NTYP=NTPCH
              CALL ZVEAEH
              CALL KPCVNM (AT(5,ICJ,NS),1,AIN(12),AIN(11))
              CALL KPCVNM (AT(5,ICL,NS),1,AIN(14),AIN(11))
              CALL CNVTUP (AIN(12),1,16)
              WRITE (WRLINE,'(A,2(A4,A2,1X),2F10.5,11X,I2)')
     +         'DISTAN ',(AIN(K),K=12,15),TEMP,1.,JJJ
              CALL KPWRTE (NTPCH)
  130         CONTINUE
            ENDDO
            JJJ=3
          ENDDO
        ENDIF
      ENDDO
      WRITE (WRLINE,'(A)') 'END'
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') 'FINISH'
      CALL KPWRTE (NTPCH)
      NTYP=NTPCH+100
      CALL ZVEAEH
  140 NCD(NS)=NCDSV
      NAT(NS)=NATSV-1
      GO TO 999
C                            AR - Abstands-restraint
  200 CONTINUE
      IAIN(2)=ISKP(24)
      IAIN(4)=ISKP(24)
      AIN(5)=CONST(5)
      CALL FLES (IAIN,ISKP(31),6HAAAAFE,
CYENG1
     + 25Hname1,unt1,name2,unt2,d?$)
CYENG2
CYENGY     + 25Hname1,ext1,name2,ext2,d?$)
      CALL CNVTUP (IAIN,1,16)
      IF (IARPOI .LT. IARDIM) THEN
        IARPOI=IARPOI+1
        DO  I=1,4
          IATAB(I,IARPOI)=IAIN(I)
        ENDDO
        IF (AIN(5) .LE. 0. .AND. IARPOI .GT. 1) AIN(5)=ATAB(IARPOI-1)
        ATAB(IARPOI)=AIN(5)
      ELSE
        GO TO 220
      ENDIF
      GO TO 999
C                            WR - Winkel-restraint
  210 CONTINUE
      IAIN(2)=ISKP(24)
      IAIN(4)=ISKP(24)
      IAIN(6)=ISKP(24)
      AIN(7)=CONST(5)
      CALL FLES (IAIN,ISKP(31),8HAAAAAAFE,
CYENG1
     + 36Hname1,unt1,namez,untz,name2,unt2,d?$)
CYENG2
CYENGY     + 36Hname1,ext1,namec,extc,name2,ext2,d?$)
      CALL CNVTUP (AIN,1,24)
      IF (IWRPOI .LT. IWRDIM) THEN
        IWRPOI=IWRPOI+1
        DO  I=1,6
          IWTAB(I,IWRPOI)=IAIN(I)
        ENDDO
        IF (AIN(7) .LE. 0. .AND. IWRPOI .GT. 1) AIN(7)=WTAB(IWRPOI-1)
        WTAB(IWRPOI)=AIN(7)
      ELSE
        GO TO 220
      ENDIF
      GO TO 999
C
  220 CONTINUE
CYENG1
      WRITE (WRLINE,'(A)') 'ZVMDLS0394 - Tabelle voll.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'ZVMDLS0394 - Table full.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 999
C                            OR - Liste restraints
C
  230 WRITE (WRLINE,'(A)') 'Restraints:'
      CALL KPWRTE (NTOUT)
      DO  I=1,IARPOI
        WRITE (WRLINE,'(A,I3,A,2A4,'' - '',2A4,F10.5)')
     +  '(',I,') ',(IATAB(J,I),J=1,4),ATAB(I)
        CALL KPWRTE (NTOUT)
      ENDDO
      DO  I=1,IWRPOI
        WRITE (WRLINE,'(A,I3,A,2A4,'' - '',2A4,'' - '',2A4,F10.5)')
     +  '(',I,') ',(IWTAB(J,I),J=1,6),WTAB(I)
        CALL KPWRTE (NTOUT)
      ENDDO
      CALL FLES (IAIN,ISKP(31),1HE,2H?$)
      GO TO 999
C                            ARE UND WRE
  240 IAIN(1)=IARPOI
CYENG1
      CALL FLES (IAIN,ISKP(31),2HIE,4HNr?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),2HIE,4HNo?$)
      IF (IAIN(1) .LT. 0) IAIN(1)=0
      IF (NTYP .EQ. 5) THEN
        IF (IAIN(1) .GT. IARDIM) IAIN(1)=IARDIM
        IARPOI=IAIN(1)
      ELSE
        IF (IAIN(1) .GT. IWRDIM) IAIN(1)=IWRDIM
        IWRPOI=IAIN(1)
      ENDIF
      GO TO 999
C                            Abstands- und winkelrestraints auf NTBILF
  250 DO  I=1,IARPOI
        WRITE (WRLINE,'(A,2(2X,A4,1X,A4),F10.5)')
     +  'AR',(IATAB(J,I),J=1,4),ATAB(I)
        IF (IATAB(2,I) .EQ. ISKP(24)) WRLINE(10:10)='*'
        IF (IATAB(4,I) .EQ. ISKP(24)) WRLINE(21:21)='*'
        CALL KPWRTE (NTBILF)
      ENDDO
      DO  I=1,IWRPOI
        WRITE (WRLINE,'(A,3(2X,A4,1X,A4),F10.5)')
     +  'WR',(IWTAB(J,I),J=1,6),WTAB(I)
        IF (IWTAB(2,I) .EQ. ISKP(24)) WRLINE(10:10)='*'
        IF (IWTAB(4,I) .EQ. ISKP(24)) WRLINE(21:21)='*'
        IF (IWTAB(6,I) .EQ. ISKP(24)) WRLINE(32:32)='*'
        CALL KPWRTE (NTBILF)
      ENDDO
      GO TO 999
C
  990 IERR=76 0598 01
      NCD(NS)=NCDSV
C
  999 RETURN
      END
