C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CZVO     13              ----------------
                          SUBROUTINE ZVO
C  CY-ENG-               ----------------
C
C                Unterprogramm zum Ausdruck. (Hundt)
C                  Updated: 231519 MAR 2006  (Hundt)
C
C   Kommando  NTYP  Bedeutung
C   OZ          1   Drucke Gitterkonstantem
C   OS          2   Drucke Symmetrien (analytisch)
C   OA          3   Drucke Atomparameter
C   OC          4   Drucke Codes
C   OT          5   Drucke Titel
C   OCG         6   Drucke Codes in Gitterkoordinaten
C   U           7   Drucke Atom-Uebersicht
C   OPTR        8   Drucke Pointer
C   OOPT        9   Drucke Optionen
C   OMAT       10   Drucke Orientierungsmatrix
C   OSA        11   Drucke Symmetrieachsen
C   OAS        12   Drucke Atome einzeln
C
C                        ----------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),IAT(8,PARDIM,2),KOPT(36),KONST(50),I,IPOI
      INTEGER *4 J,J1,J2,KEYIN,K,N,IS,IRLINE(30)
C
      EQUIVALENCE (AIN(1),IAIN(1)),(AT(1,1,1),IAT(1,1,1))
      EQUIVALENCE (CONST(1),KONST(1)),(WRLINE,IRLINE(1))
C
      DATA KOPT/4HNOKD,3HOKD,4HNDLG,3HDLG,3HNAO,2HAO,3HNPO,2HPO,4HNPLT,
C                1      2     3      4     5     6    7     8    9
     1 3HPLT,4H    ,4H    ,3H   ,3HNOI,2HOI,4HAGLP,3HGLP,4HNGLP,4HCHHP,
C       10    11     12     13    14    15   16     17    18     19
     2 4HCHPL,3HNPR,2HPR,4HNZFQ,3HZFQ,4HNPCK,3HPCK,3HNIU,2HIU,4HTAPR,
C       20     21    22    23     24    25     26    27    28   29
     3 4HGPLT,4HNPLT,4HPLT ,4HKIG ,4HNRRI,4HCRRI,4HRRI /
C        30     31     32     33     34     35     36
C
      GO TO (10,40,120,230,420,440,530,710,730,750,760,220),NTYP
C            1  2  3   4   5   6   7   8   9   10   11  12
C
C                            OZ
C
CYENG1
   10 WRLINE='Gitterkonstanten:'
CYENG2
CYENGY   10 WRLINE='Cell constants:'
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,'(6F10.4,''   Vol ='',F10.2)') (ZELLE(I,NS),I=1,7)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,'(3(a,f8.5),3(a,f7.2))')' a* =',RK(1,NS),' b* =',
     1 RK(2,NS),' c* =',RK(3,NS),' al* =',RK(4,NS),' be* =',RK(5,NS),
     2 ' ga* =',RK(6,NS)
      CALL KPWRTE (NTOUT)
      GO TO 990
C                            OS
   40 IF (NSYM(NS) .LE. 0) THEN
C                            Keine Symmetrien.
        IERR=13 0063 05
        GO TO 999
      ENDIF
C
      WRITE (WRLINE,70) NHMSNR(3,NS),NHMSNR(1,NS),NHMSNR(2,NS)
      CALL KPWRTE (NTOUT)
CYENG1
   70 FORMAT ('Symmetrien: (Rg Nr',I6,2X,2A4,')')
CYENG2
CYENGY   70 FORMAT (' Symmetries: (Spg No',I6,2X,2A4,')')
      WRLINE=' Nr ---------X---------  ---------Y---------  ---------Z--
     1-------'
      CALL KPWRTE (NTOUT)
      DO  ISYNR=1,NSYM(NS)
        WRITE (WRLINE,'(I3,3(F7.3,3F4.1,2X))')
     +  ISYNR,(SYM(I,ISYNR,NS),I=1,12)
        CALL KPWRTE (NTOUT)
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 990
        ENDIF
      ENDDO
      GO TO 990
C                            OA
  120 IAIN(1)=ISKP(53)
      IAIN(2)=NAT(NS)
CYENG1
      CALL FLES (IAIN,ISKP(31),3H2IE,14H<von <,bis>>?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),3H2IE,14H<from <,to>>?$)
CYENG1
      WRLINE=' Atome:'
CYENG2
CYENGY      WRLINE=' Atoms:'
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,190)
CYENG1
  190 FORMAT ('   Nr  Name',10X,'x',9X,'y',9X,'z',9X,'r',4X,'Farbzg AN')
CYENG2
CYENGY  190 FORMAT ('   No  Name',10X,'x',9X,'y',9X,'z',9X,'r',4X,'Clrpnt WN')
      CALL KPWRTE (NTOUT)
      IF (ISKP(31) .EQ. 1) GO TO 222
      IAIN(2)=-IAIN(2)
      ISKP(31)=2
      GO TO 222
C                            OAS - Drucke atome einzeln
C
  220 CALL FLES (IAIN,ISKP(31),4H72IE,10Hn1,..,nm?$)
  222 J=0
  225 IF (J .LT. ISKP(31)) THEN
        J=J+1
        J1=IAIN(J)
        J2=J1
        IF (J .LT. ISKP(31)) THEN
          IF (IAIN(J+1) .LT. 0) THEN
            J=J+1
            J2=-IAIN(J)
          ENDIF
        ENDIF
        IF (J1 .LE. 0) J1=1
        IF (J2 .GT. NAT(NS)) J2=NAT(NS)
        DO  I=J1,J2
          WRITE (WRLINE,'(I5,2X,2A4,3F10.6,F9.4,I8,1X,A4)')
     +    I,AT(5,I,NS),AT(6,I,NS),(AT(K,I,NS),K=1,4),ICLRP(I,NS)
     +    ,AT(7,I,NS)
          CALL KPWRTE (NTOUT)
          IF (KEYIN(0) .EQ. ISKP(20)) THEN
            IERR=-1
            GO TO 990
          ENDIF
        ENDDO
        GO TO 225
      ENDIF
      GO TO 999
C                            OC - Drucke Codes
C
  230 IF (ISKP(14) .NE. 0) GO TO 330
      IAIN(1)=NCDA(NS)
      IAIN(2)=NCD(NS)
      DO  I=3,7
        IAIN(I)=ISKP(24)
      ENDDO
CYENG1
      CALL FLES (IAIN,ISKP(31),8H2JAAAAAE,25H<von <,bis>> <symb,...>?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),8H2JAAAAAE,25H<from <,to>> <symb,...>?$)
      IF (ISKP(31) .EQ. 1) IAIN(2)=IAIN(1)
      IF (IAIN(2) .GT. NCD(NS)) IAIN(2)=NCD(NS)
      CALL CNVTUP (IAIN(3),1,20)
      IF (IAIN(1) .LE. 0 .OR. IAIN(1) .GT. IAIN(2)) THEN
        IERR=13 0152 12
        GO TO 999
      ENDIF
C
  330 NTRY=44
      NC=1
      IF (ISKP(14) .EQ. 2) GO TO 345
      WRLINE=' Codes:'
      CALL KPWRTE (NTOUT)
CYENG1
      WRLINE='   Nr   Name       Code      trikline Koordinaten        f
     1reie Koordinaten'
CYENG2
CYENGY      WRLINE='   No   Name       Code      Triclinic coordinates       F
CYENGY     1ree coordinates'
      CALL KPWRTE (NTOUT)
  345 DO  IC=IAIN(1),IAIN(2)
        CALL ZVDEK
        AIN(9)=AT(7,IANR,NS)
C        CALL CNVTUP (IAIN(9),1,4)
        IF (ISKP(32) .GT. 0) THEN
          DO  I=3,7
            IF (IAIN(9) .EQ. IAIN(I)) GO TO 380
          ENDDO
          GO TO 410
        ENDIF
C
  380   CALL KPCDST (ISKP(80),1,ICD(IC,NS))
        WRITE (WRLINE,390) IC,AT(5,IANR,NS),AT(6,IANR,NS),
     1  (ISKP(I),I=80,82),(X(I,1),I=1,3),(X2(I),I=1,3)
  390   FORMAT (I5,2X,5A4,3F8.5,2X,3F8.3)
        CALL KPWRTE (NTOUT)
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 999
        ENDIF
  410   CONTINUE
      ENDDO
      GO TO 999
C                            OT
C
  420 WRITE (WRLINE,'(18A4)') (TITEL(I,NS),I=1,18)
      CALL KPWRTE (NTOUT)
      GO TO 990
C                            OCG
  440 IAIN(1)=NCDA(NS)
      IAIN(2)=NCD(NS)
CYENG1
      CALL FLES (IAIN,ISKP(31),3H2IE,14H<von <,bis>>?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),3H2IE,14H<from <,to>>?$)
      IF (ISKP(31) .EQ. 1) IAIN(2)=IAIN(1)
      IF (IAIN(1) .LT. NCDA(NS)) IAIN(1)=NCDA(NS)
      IF (IAIN(2) .GT. NCD(NS)) IAIN(2)=NCD(NS)
      IF (IAIN(1) .GT. IAIN(2)) THEN
        IERR=13 0207 16
        GO TO 999
      ENDIF
C
      NTRY=40
      NC=1
      WRLINE=' Codes:'
      CALL KPWRTE (NTOUT)
CYENG1
      WRLINE='  Nr   Name       Code      trikline Koordinaten         G
     1itterkoordinaten'
CYENG2
CYENGY      WRLINE='   No   Name       Code      Triclinic coordinates       F
CYENGY     1ree coordinates'
      CALL KPWRTE (NTOUT)
      DO  IC=IAIN(1),IAIN(2)
        CALL ZVDEK
        X2(1)=X(1,1)*GRID(1)
        X2(2)=X(2,1)*GRID(2)
        X2(3)=X(3,1)*GRID(3)
        CALL KPCDST (ISKP(80),1,ICD(IC,NS))
        WRITE (WRLINE,500) IC,AT(5,IANR,NS),AT(6,IANR,NS),
     1  (AIN(I),I=80,82),(X(I,1),I=1,3),(X2(I),I=1,3)
  500   FORMAT (I5,2X,5A4,3F8.5,3X,3F8.1)
        CALL KPWRTE (NTOUT)
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 999
        ENDIF
      ENDDO
      GO TO 999
C                            U - Uebersicht ueber Atome
  530 IPOI=0
      DO  I=1,NAT(NS)
        N=IAT(5,I,NS)
        CALL CNVTUP (N,1,4)
        DO  J=1,IPOI
          IF (N .EQ. IAIN(J)) GO TO 540
        ENDDO
        IF (IPOI .LT. 72) THEN
          IPOI=IPOI+1
          IAIN(IPOI)=N
        ELSE
CYENG1
      WRLINE='ZVO0251 - Tabelle voll.  Mit SRTN Parameter sortieren.'
CYENG2
CYENGY      WRLINE='ZVO0251 - Table full.  Use SRTN to sort parameters.'
            CALL KPWRTE (NTDISP)
            IERR=-1
            GO TO 990
        ENDIF
  540   CONTINUE
      ENDDO
C
      DO  I=1,IPOI
        WRITE (WRLINE,'(A4)') IAIN(I)
        IS=5
        J1=0
        J=0
  550   J=J+1
        N=IAT(5,J,NS)
        CALL CNVTUP (N,1,4)
        IF (N .EQ. IAIN(I)) THEN
          IF (J1 .EQ. 0) J1=J
          J2=J
          IF (J .LT. NAT(NS)) GO TO 550
        ENDIF
  560   IF (J1 .NE. 0) THEN
          IF (IS .GE. 70) GO TO 580
          CALL KPNTOS (J1,IRLINE,IS,0)
          IF (J1 .NE. J2) CALL KPNTOS (-J2,IRLINE,IS,0)
          IS=IS+1
          J1=0
        ENDIF
  570   IF (J .LT. NAT(NS)) GO TO 550
  580   CALL KPWRTE (NTDISP)
        WRLINE=' '
        IS=5
        IF (J .LT. NAT(NS)) GO TO 560
      ENDDO
      GO TO 990
C                            OPTR - Drucke Pointer
C
  710 WRLINE=  ' NTIN NTOUT NTPCH NTSCR NTXR1 NTXR2 NTBILF NTDTEI NTDISP
     1   AE   CE'
      CALL KPWRTE (NTDISP)
      WRITE (WRLINE,720) NTIN,NTOUT,NTPCH,NTSCR,NTXR1,NTXR2,NTBILF,
     1 NTDTEI,NTDISP,NAT(NS),NCD(NS)
  720 FORMAT  (I5,5I6,3I7,2I5)
      CALL KPWRTE (NTDISP)
      GO TO 990
C                            OOPT - Drucke Optionen
C
  730 WRITE (WRLINE,740) KOPT(ISKP(2)+1), KOPT(ISKP(4)+3),
     1 KOPT(ISKP(5)+5), KOPT(ISKP(6)+7), ISKP(24),
     2 KOPT(ISKP(11)+34), KOPT(ISKP(12)+14), KOPT(ISKP(15)+17),
     3 KOPT(ISKP(26)+19)
CYENG1
  740 FORMAT ('Gesetzte Optionen:',9(' ',A4))
CYENG2
CYENGY  740 FORMAT ('Options in effect:',9(' ',A4))
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,741) ISKP(23),ISKP(13),ISKP(1),KOPT(ISKP(3)+21),
     1 KONST(36),ISKP(41),KOPT(ISKP(43)+23),CONST(38)
  741 FORMAT ('FMMC=',I3,' STPO=',I2,' FMOPT=',I3,3X,A4,' BST=',I2,
     1 ' NPEN=',I3,'  ',A4,'  GOPT=',A4)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,742) ISKP(44),CONST(35),CONST(40),ISKP(50),
     1 CONST(23),CONST(24),ISKP(27),FKGL,ISKP(69)
  742 FORMAT ('VEOPT=',I2,F5.2,F8.2,I4,' UDST=',2F6.3,I2,' KF=',F6.2,
     1 ' BSN=',I3)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,743) KOPT(ISKP(48)+25),ISKP(49),KOPT(ISKP(57)+27),
     1 ISKP(58),CONST(41),ISKP(53),ISKP(10),ISKP(60)
  743 FORMAT (A4,' STRD=',I3,' ',A4,' MORE=',I2,' TAPR=',F5.2,
     1 ' SPST=',I4,' BSF=',I3,' ORTP=',I2)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,744) CONST(43),CONST(44),ISKP(62),ISKP(63),
     + CONST(42),ISKP(83)
  744 FORMAT ('WFKT=',F7.4,' DISP=',F7.4,' STA=',I2,' TFL=',I2,
     + ' FACF=',F9.4,'  HMSO=',I2)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,745) ISKP(76),ISKP(86),CONST(13),CONST(50),ISKP(7),
     + ISKP(95),ISKP(96)
  745 FORMAT ('IGFA=',I3,' MSAV=',I3,'  SW=',F7.4,'  BAS=',F4.1,
     + ' PLT=',I2,' SLAB=',I2,'  GSXF=',I2)
      CALL KPWRTE (NTOUT)
      GO TO 990
C                            Drucke Orientierug
C
  750 WRITE (WRLINE,'(A,3F10.6)') 'Matrix DREH:  ',(DREH(1,J),J=1,3)
      CALL KPWRTE (NTOUT)
      DO  I=2,3
        WRITE (WRLINE,'(14X,3F10.6)') (DREH(I,J),J=1,3)
        CALL KPWRTE (NTOUT)
      ENDDO
      GO TO 990
C                            OSA
  760 DO  J=1,ISYPOI
        IF (IROTSV(J) .NE. 0) THEN
          WRITE (WRLINE,'(A,I2,A,I1,A,I4,A,3F8.4,A,3F8.4)')
     +    'A:',IROTSV(J),' (',IROTGT(J),') R:',IDIRSV(J),
     +    ' P:',(PKTSV(I,I),I=1,3),' G:',(HUBSV(I,J),I=1,3)
          CALL KPWRTE (NTOUT)
        ENDIF
      ENDDO
      DO  J=1,IZEPOI
        WRITE (WRLINE,'(A,I2,A,3F10.6)') 'Z',J,':',(ZENSV(I,J),I=1,3)
        CALL KPWRTE (NTOUT)
      ENDDO
C
C                            Suche Trennzeichen
C
  990 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
C
  999 RETURN
      END
