C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPORT2   23             -------------------
                          SUBROUTINE ZVORT2
C  CY-ENG-               -------------------
C
C                 Geschrieben: 160806 SEP 1986  (Hundt)
C                 Geaendert:   201121 APR 2004  (Hundt)
C
C      Dieses Programm erzeugt einen Datensatz fuer ORTEP (formatfrei)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 ITFOPT(4),IAIN(72),I,I1,I2,IEMP1,IEMP2,IGLZ,II
      INTEGER *4 INSTR,IRLINE,ISLA,J,JPKP,K,N,NANZ,NANZL,NRET
      REAL    *4 CDS(7),VQ(IPKDIM,2),TEMP,TEMP1,XOFF,YOFF
C
      EQUIVALENCE (AIN(1),IAIN(1)),(IPK(1,1),VQ(1,1))
      EQUIVALENCE (ICDS(1),CDS(1))
C
      SAVE ITFOPT
C
      DATA ITFOPT/0,0,714,0/,ISLA/4H /  /,IGLZ/4H =  /
C
C                            Lies Option
C
      CALL FLES (ITFOPT,ISKP(31),3H4JR,
CYENG1
     + 38HOpt1(TF),Opt2(Stereo),PK-Zahl,Beschr?$)
CYENG2
CYENGY     + 43HOpt1(TF),opt2(Stereo),PK-number,label-opt?$)
C
C                            Oeffne ggf. File
      NTYP=NTPCH
      CALL ZVEAEH
C                            Titelkarte
      DO 10 I=1,20
        IAIN(I)=ISKP(24)
   10 CONTINUE
      CALL ADDAPO (TITEL(1,NS),-72,IAIN,J)
C     CALL CNVTUP (AIN,1,J)
      K=(J+3)/4
      WRITE (WRLINE,70) (IAIN(I),I=1,K)
      CALL KPWRTE (NTPCH)
   70 FORMAT (20A4)
C                            Zellparameter.
      WRITE (WRLINE,80) (ZELLE(I,NS),I=1,6)
      CALL KPWRTE (NTPCH)
   80 FORMAT (3F9.5,3F9.4)
C                            Symmetrien.
C
      IF (NSYM(NS) .EQ. 0) GO TO 110
      J=0
      DO 100 I=1,NSYM(NS)
      IF (I .EQ. NSYM(NS)) J=1
      WRITE (WRLINE,90) J,(SYM(K,I,NS),K=1,12)
      CALL KPWRTE (NTPCH)
   90 FORMAT (' ',I1,F9.6,3F4.0,2(F9.6,3F4.0))
  100 CONTINUE
      GO TO 130
C                            Nur Identitaet.
  110 WRITE (WRLINE,120)
      CALL KPWRTE (NTPCH)
  120 FORMAT (' 1   0 1 0 0   0 0 1 0   0 0 0 1')
C
C                            Atomparameter.
  130 I=0
      GO TO 210
  140 I=I+1
      AIN(1)=AT(5,I,NS)
      AIN(2)=AT(6,I,NS)
      CALL KPCVNM (AIN,CONST(36),AIN(5),AIN(7))
C
C                            Teste, ob anisotrope TF's ausgeg. werden
C
      IF (ITFOPT(1) .EQ. 0) GO TO 190
      IF (IPFLG(I,NS) .EQ. 0) GO TO 190
C
C                            Besorge Tensor.
      IANR=I
      ISYNR=1
      NTYP=5
      CALL ZVTFHN
      IF (AIN(5) .EQ. 0) GO TO 190
      AIN(12)=8.
C
      WRITE (WRLINE,'('' ('',I3,'') '''''',A4,A2,'''''''',3F9.6)')
     1 I,AIN(1),AIN(2),(AT(K,I,NS),K=1,3)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'('' 0 '',6F9.6,F9.4)') (AIN(K),K=6,12)
      CALL KPWRTE (NTPCH)
      GO TO 210
C
  190 WRITE (WRLINE,'('' ('',I3,'') '''''',A4,A2,'''''''',3F9.6,
     1 '' / 0'',F10.5)') I,AIN(1),AIN(2),(AT(K,I,NS),K=1,4)
      CALL KPWRTE (NTPCH)
  210 IF (I-NAT(NS)) 140,220,220
C                            Aktueller Origin
  220 WRITE (WRLINE,230) (UR(I,NS),I=1,3)
      CALL KPWRTE (NTPCH)
  230 FORMAT (' AKTORG  ',3F9.6,' / 1   0.01')
      CONST(14)=(NAT(NS)+1)*100000+55501
C
C                            Plotter-Start
      WRITE (WRLINE,240)
      CALL KPWRTE (NTPCH)
  240 FORMAT ('  201  ''KPLOT-VERSION''')
      WRITE (WRLINE,250)
      CALL KPWRTE (NTPCH)
  250 FORMAT ('  205  1')
C                            Feldbegrenzung
      TEMP1=CONST(10)
      TEMP=HOE*O9
      IF (TEMP .GT. 9999.) TEMP=0.
      WRITE (WRLINE,280) CONST(8),CONST(9),TEMP,TEMP1
      CALL KPWRTE (NTPCH)
  280 FORMAT ('  301',4(' ',F8.2))
C
C                            Wenn UDST-Option != 0: 304-Instruktion
C
      IF (ISKP(27) .NE. 0) THEN
        WRITE (WRLINE,281) CONST(23),CONST(24),ISKP(27)
        CALL KPWRTE (NTPCH)
  281   FORMAT ('  304',2F9.4,I10)
      ENDIF
C
C                            Instruktion 401
      IF (NCDA(NS) .GT. NCD(NS)) GO TO 330
      DO  I1=NCDA(NS),NCD(NS),7
        I2=I1+6
        IF (I2 .GT. NCD(NS)) I2=NCD(NS)
        WRLINE='  401'
        J=6
        DO  I=I1,I2
          CALL KPCDST (IRLINE,J,ICD(I,NS))
          J=J+10
        ENDDO
        CALL KPWRTE (NTPCH)
      ENDDO
C                            Koordinatensystem
  330 I=NAT(NS)+1
      WRITE (WRLINE,340) I
      CALL KPWRTE (NTPCH)
  340 FORMAT ('  501',I4,'55501   155501   165501   155501   156501')
C
C                            Instruktion 502
      CALL ZVORTN
      WRITE (WRLINE,350) (I,CDS(I),I=1,3)
      CALL KPWRTE (NTPCH)
  350 FORMAT ('  502',3(I10,F9.2))
C
C                            Skalierung
      TEMP=O9
      WRITE (WRLINE,360) CONST(11),CONST(12),TEMP,FKGL
      CALL KPWRTE (NTPCH)
  360 FORMAT ('  604 (',4F9.3,')')
C
C                            Plotbefehle
      NRET=0
      WRITE (WRLINE,361)
      CALL KPWRTE (NTPCH)
  361 FORMAT ('  303     0.01')
C
C                            Suche Zeichen- bzw. Beschriftungs-
C                            Instruktionen
  370 I=0
      JPKP=1
      NANZ=0
  380 I=I+1
      JPKP=JPKP+NANZ
      IF (JPKP-IPKP(NS)) 390,770,770
  390 NANZ=IPK(JPKP,NS)
      N=IPK(JPKP+1,NS)
      IF (N-6) 430,420,391
  391 IF (N-12) 380,541,392
  392 IF (N-14) 541,542,380
  420 K=IPK(JPKP+7,NS)
  430 IF (N-5) 440,550,600
  440 IF (NRET) 380,450,380
  450 GO TO (460,480,490,500),N
C
C                            PK
C
  460 WRITE (WRLINE,470) ITFOPT(3),IPK(JPKP+2,NS),IPK(JPKP+3,NS)
      CALL KPWRTE (NTPCH)
  470 FORMAT (' ',3I4)
      GO TO 380
C                            VB
  480 TEMP=.001
      INSTR=813
      GO TO 520
C                            VBS
  490 TEMP=.001
      GO TO 510
C
  500 TEMP=VQ(JPKP+8,NS)
  510 INSTR=812
  520 DO 530 J=1,6
  530 IAIN(J)=IPK(JPKP+J+1,NS)
      AIN(5)=AMAX1(.001,AIN(5))
      WRITE (WRLINE,540) INSTR,(IAIN(J),J=1,4),AIN(5),AIN(6),TEMP
      CALL KPWRTE (NTPCH)
  540 FORMAT (' ',5I4,'   1',3F8.3)
      GO TO 380
C                            VD, VDS und VDR
  541 TEMP=0.001
      GO TO 543
  542 TEMP=VQ(JPKP+2,NS)
  543 IF (NRET) 380,544,380
  544 WRITE (WRLINE,545) TEMP
      CALL KPWRTE (NTPCH)
  545 FORMAT ('  811   1',F8.3)
C
      J=9
      K=0
  546 IF (IPK(JPKP+J,NS) .EQ. 0) GO TO 551
      IF (K .GE. 6) GO TO 548
      K=K+2
  547 IAIN(K-1)=IPK(JPKP+J-1,NS)
      IAIN(K)=IPK(JPKP+J,NS)
      J=J+1
      GO TO 546
C
  548 WRITE (WRLINE,549) (IAIN(II),II=1,6),IGLZ
      CALL KPWRTE (NTPCH)
  549 FORMAT (' ',6I10,A4)
      K=2
      GO TO 547
C
  551 IF (J+1 .GE. NANZ) GO TO 552
      J=J+2
      GO TO 546
C
  552 WRITE (WRLINE,549) (IAIN(II),II=1,K)
      CALL KPWRTE (NTPCH)
      GO TO 380
C##                            BA
  550 IF (NRET .EQ. 0) GO TO 380
      IF (ITFOPT(4) .EQ. 0) THEN
        WRITE (WRLINE,561) VQ(JPKP+4,NS)
        CALL KPWRTE (NTPCH)
  561   FORMAT (' 1408  1',F6.2,' =')
        NANZL=IPK(JPKP,NS)-1
        J=7
        K=IGLZ
        GO TO 353
  352   K=ISLA
  354   WRITE (WRLINE,351) IPK(JPKP+J-2,NS),
     +  VQ(JPKP+J-1,NS),VQ(JPKP+J,NS),K
        CALL KPWRTE (NTPCH)
  351   FORMAT ('   ',I10,2F10.5,A4)
        J=J+3
  353   IF (J-NANZL) 354,352,380
C
      ENDIF
      TEMP=VQ(JPKP+4,NS)
      J=5+JPKP
      K=IPK(JPKP,NS)+JPKP
  565 XOFF=VQ(J+1,NS)+3.*TEMP
      YOFF=VQ(J+2,NS)+.5*TEMP
      IEMP1=IPK(J,NS)
      IF (IEMP1-1000 ) 570,570,580
  570 IEMP1=IEMP1*100000 +55501
  580 I=IEMP1/100000
      AIN(1)=AT(5,I,NS)
      AIN(2)=AT(6,I,NS)
      CALL KPCVNM (AIN,CONST(36),AIN(5),AIN(7))
      CALL CNVTUP (AIN,1,8)
      WRITE (WRLINE,590) IEMP1,TEMP,XOFF,YOFF,AIN(5),AIN(6)
      CALL KPWRTE (NTPCH)
  590 FORMAT ('  921',I10,3F9.3,' ! ',2A4)
      J=J+3
      IF (J-K) 565,380,380
C                            BT
  600 IF (NRET) 610,380,610
  610 TEMP=VQ(JPKP+6,NS)
      XOFF=VQ(JPKP+4,NS)+36.*TEMP
      YOFF=VQ(JPKP+5,NS)+.5*TEMP
      IEMP1=IPK(JPKP+2,NS)
      IEMP2=IPK(JPKP+3,NS)
      IF (IEMP2) 620,620,630
  620 IEMP2=IEMP1
  630 IF (IEMP1-1000 ) 640,640,650
  640 IEMP1=IEMP1*100000 +55501
  650 IF (IEMP2-1000 ) 660,660,670
  660 IEMP2=IEMP2*100000 +55501
  670 CALL ADDAPO (IPK(JPKP+8,NS),-4*K,AIN,K)
      K=(K+3)/4
C     CALL CNVTUP (IAIN,1,4*K)
      IF (ITFOPT(4) .EQ. 0) THEN
        WRITE (WRLINE,'('' 1409  1'',F9.3,2I10,2F9.3,'' ='')')
     +  TEMP,IEMP1,IEMP2,VQ(JPKP+4,NS),VQ(JPKP+5,NS)
        CALL KPWRTE (NTPCH)
        WRITE (WRLINE,'('' '',18A4)') (IAIN(J),J=1,K)
        CALL KPWRTE (NTPCH)
        GO TO 380
      ENDIF
      INSTR=923
      IF (IEMP1-IEMP2) 700,690,700
  690 INSTR=922
  700 WRITE (WRLINE,710) INSTR,(IAIN(J),J=1,K),IGLZ
      CALL KPWRTE (NTPCH)
  710 FORMAT (' ',I4,' ',18A4)
      IF (INSTR-923) 740,720,740
  720 WRITE (WRLINE,730) IEMP1,IEMP2,TEMP,XOFF,YOFF
      CALL KPWRTE (NTPCH)
  730 FORMAT (' ',2I10,3F9.3)
      GO TO 380
  740 WRITE (WRLINE,750) IEMP1,TEMP,XOFF,YOFF
      CALL KPWRTE (NTPCH)
  750 FORMAT (' ',I10,3F9.3)
      GO TO 380
C
  770 IF (NRET) 870,780,820
C
C                            Stereodrehung
  780 TEMP=CONST(13)*.5
      IF (ITFOPT(2)) 790,810,790
  790 WRITE (WRLINE,800) TEMP
      CALL KPWRTE (NTPCH)
  800 FORMAT ('  503   2 ',F9.3)
C
C                            Beschrifte
  810 NRET=1
      GO TO 370
C                            Ausfuehrung der Plotkommandos
  820 WRITE (WRLINE,880)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') ' 1212'
      CALL KPWRTE (NTPCH)
      NTYP=6
      CALL ZVGE04
      IF (ISKP(3)) 830,840,830
  830 WRITE (WRLINE,900)
      CALL KPWRTE (NTPCH)
  840 IF (ITFOPT(2)) 850,910,850
C
C                            Feldverschiebung und Stereodrehung
  850 TEMP=-CONST(13)*.5
      WRITE (WRLINE,'(''  202'',F9.3)') CONST(8)
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(''  503   2 '',F9.3)') TEMP
      CALL KPWRTE (NTPCH)
C
C                            Beschrifte
      NRET=-1
      GO TO 370
C                            Ausfuehrung der Plotkommandos
  870 WRITE (WRLINE,880)
  880 FORMAT ('  303     0.00')
      CALL KPWRTE (NTPCH)
      WRITE (WRLINE,'(A)') ' 1212'
      CALL KPWRTE (NTPCH)
      NTYP=6
      CALL ZVGE04
      IF (ISKP(3)) 890,910,890
  890 WRITE (WRLINE,900)
      CALL KPWRTE (NTPCH)
  900 FORMAT ('  207')
      GO TO 910
C                            Schliesse ORTEP-Datensatz
  910 WRITE (WRLINE,920)
      CALL KPWRTE (NTPCH)
  920 FORMAT ('   -1')
C
      WRITE (WRLINE,930)
      CALL KPWRTE (NTDISP)
CYENG1
  930 FORMAT (' ORTEP-Datensatz erzeugt.')
CYENG2
CYENGY  930 FORMAT ('ORTEP file generated.')
      RETURN
      END
