C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPPKED   36             -------------------
                          SUBROUTINE ZVPKED
C  CY-ENG-               -------------------
C
C  Das Programm listet (OPK) oder entfernt (EPK) Plotkommandos aus
C  der Liste der gespeicherten Plotkommandos.
C
C                     OPK   -   EPK   -   MPK  UMPK
C                      1    2    3    4    5    6
C
C                         geschrieben: Hundt
C                  geaendert: 050834 MAY 1985  (Hundt)
C                  geaendert: 270955 JAN 2000  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 ITEMP(2),IAIN(72),KDOT(17),IRLINE(30),KDGLZ,NTYPS
      INTEGER *4 IPKS,IVON,IBIS,I,J,K,I1,N1,N2,IPKM,NANZ,NANZL,KEYIN
      INTEGER *4 IFLG,KDSTRN,II,IA,IE,N
      REAL    *4 FMT1(10),FMT(15),VQ(IPKDIM,2)
      CHARACTER*60 FMTC
C
      EQUIVALENCE (ITEMP(1),IVON),(ITEMP(2),IBIS)
      EQUIVALENCE (AIN(1),IAIN(1)),(IPK(1,1),VQ(1,1))
      EQUIVALENCE (FMT(1),FMTC),(WRLINE,IRLINE(1))
C
      DATA KDOT/4HPK  ,4HVB  ,4HVBS ,4HVBR ,4HBA  ,4HBT  ,4HPPFL,
     1   4HVEH ,4HVEU ,4HVE  ,4H????,4HVD  ,4HVDS ,4HVDR ,4HPFU ,
     2   4HPF  ,4HPFD /
      DATA FMT/4H( '(,4H',I3,4H,') ,4H',A1,4H,A4,,4H 20X,4H,2F6,
     1 4H.2,F,4H6.3,,4H2H ',4H,   ,4HXXA4,4H,1H',4H,2I3,4H)   /
      DATA FMT1/4H 1A4,4H 2A4,4H 3A4,4H 4A4,4H 5A4,4H 6A4,4H 7A4,
     1 4H 8A4,4H 9A4,4H10A4/
      DATA KDGLZ/4H =  /,KDSTRN/4H*   /
C
C                            Save Parameter.
      NTYPS=NTYP
      IPKS=IPKP(NS)
C                            Setze Defaults und hole Input.
      IF (NTYPS .LT. 2) THEN
        IBIS=999
        IVON=1
      ELSE
        IBIS=0
        IVON=0
      ENDIF
      IF (ISKP(14) .EQ. 0) THEN
CYENG1
        CALL FLES (ITEMP,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY        CALL FLES (ITEMP,ISKP(31),3H2IE,9Hfrom,to?$)
      ENDIF
C
      IF (IBIS .LE. 0) IBIS=IVON
      IF (IVON .LE. 0 .OR. IVON .GT. IBIS) THEN
        IERR=36 0054 16
        GO TO 999
      ENDIF
C                            Angaben sind O.K.
C
C                            EPK
      IF (NTYPS .EQ. 3) THEN
        I=1
        I1=1
        N1=0
  131   IF (I1 .GT. IPKP(NS)) THEN
          N2=IPKP(NS)+1
          GO TO 132
        ENDIF
        IF (IVON .EQ. I) N1=I1
        IF (IBIS .EQ. I) THEN
          N2=I1+IPK(I1,NS)
          GO TO 132
        ENDIF
        I=I+1
        I1=I1+IPK(I1,NS)
        GO TO 131
C
  132   IF (N1 .EQ. 0) GO TO 999
        IF (N2 .LE. IPKP(NS)) THEN
          DO  I=N2,IPKP(NS)
            IPK(N1,NS)=IPK(I,NS)
            N1=N1+1
          ENDDO
        ENDIF
        IPKP(NS)=N1-1
        GO TO 999
      ENDIF
C                            Uebrige Kommandos.
      IPKM=0
      I=0
      IPKP(NS)=1
      NANZ=0
  140 IF (KEYIN(0) .EQ. ISKP(20)) GO TO 480
      I=I+1
      IPKP(NS)=IPKP(NS)+NANZ
      IF (IPKP(NS)-IPKS) 150,480,480
  150 NANZ=IPK(IPKP(NS)  ,NS)
      NANZL=NANZ-1
      NTYP=IPK(IPKP(NS)+1,NS)
      K=NANZ-8
C                            Ist dieses Kommando gemeint?
      IF (I-IVON) 140,160,160
  160 IF (I-IBIS) 170,170,480
C                            Dieses Kommando ist gemeint!
C
  170 IF (NTYP) 171,171,177
  171 IF (NTYPS-6) 172,181,140
  172 IF (NTYPS-1) 140,251,140
  177 IF (NTYPS-2) 250,999,180
  180 IF (NTYPS-5) 185,181,140
C                            MSK/UMSK - Maskiere
  181 IPK(IPKP(NS)+1,NS)=-NTYP
      GO TO 140
C
  185 IF (IPKM) 190,190,140
  190 IPKM=IPKP(NS)
      GO TO 140
C                            Nur listen.
C
  251 IFLG=KDSTRN
      NTYP=-NTYP
      GO TO 253
C
  250 IFLG=ISKP(24)
  253 IF (NTYP-5) 260,340,270
  260 IF (NTYP-2) 310,320,320
  270 IF (NTYP-7) 360,370,280
  280 IF (NTYP-10) 390,390,290
  290 IF (NTYP-12) 999,410,300
  300 IF (NTYP-14) 410,410,301
  301 IF (NTYP-16) 390,390,302
  302 IF (NTYP-17) 471,471,140
C
C                            PK
C
  310 WRITE (WRLINE,330) I,IFLG,KDOT(NTYP),
     + (IPK(IPKP(NS)+J,NS),J=2,NANZL)
      CALL KPWRTE (NTOUT)
      GO TO 140
C                            VB, VBS, VBR
C
  320 WRITE (WRLINE,330) I,IFLG,KDOT(NTYP),(IPK(IPKP(NS)+J,NS),J=2,5),
     + (VQ(IPKP(NS)+J,NS),J=6,8),IPK(IPKP(NS)+9,NS)
      CALL KPWRTE (NTOUT)
  330 FORMAT ('(',I3,') ',A1,A4,4I5,3F10.3,I4)
      GO TO 140
C                            BA
C
  340 WRITE (WRLINE,350) I,IFLG,KDOT(NTYP),
     1 (IPK(IPKP(NS)+J,NS),J=2,3),VQ(IPKP(NS)+4,NS)
      CALL KPWRTE (NTOUT)
  350 FORMAT ('(',I3,') ',A1,A4,2I4,F6.2,' =')
      J=7
      K=KDGLZ
      GO TO 353
  352 K=ISKP(24)
  354 CALL KPCDST (ISKP(80),1,IPK(IPKP(NS)+J-2,NS))
      WRITE (WRLINE,351) (ISKP(II),II=80,82),
     + VQ(IPKP(NS)+J-1,NS),VQ(IPKP(NS)+J,NS),K
      CALL KPWRTE (NTOUT)
  351 FORMAT ('    ',3A4,2F10.5,A4)
      J=J+3
  353 IF (J-NANZL) 354,352,140
C
C                            BT
  360 K=IPK(IPKP(NS)+7,NS)
      FMT(12)=FMT1(K)
      WRITE (WRLINE,FMTC) I,IFLG,KDOT(NTYP),
     1 (VQ(IPKP(NS)+J,NS),J=4,6),(IPK(IPKP(NS)+J,NS),J=8,NANZL)
      CALL KPCDST (IRLINE,12,IPK(IPKP(NS)+2,NS))
      CALL KPCDST (IRLINE,22,IPK(IPKP(NS)+3,NS))
      CALL KPWRTE (NTOUT)
      GO TO 140
C                            PPFL
C
  370 WRITE (WRLINE,380) I,IFLG,KDOT(NTYP),(IPK(IPKP(NS)+J,NS),J=2,4),
     1 (VQ(IPKP(NS)+J,NS),J=5,10),IPK(IPKP(NS)+11,NS)
      CALL KPWRTE (NTOUT)
  380 FORMAT ('(',I3,') ',A1,A4,3I10,3F6.1,F5.1,2F5.2,I3)
      GO TO 140
C                            VEH, VEU und VE, PF und PFU
C
  390 WRITE (WRLINE,400) I,IFLG,KDOT(NTYP),(IPK(IPKP(NS)+J,NS),J=2,5),
     1 (VQ(IPKP(NS)+J,NS),J=6,7),(IPK(IPKP(NS)+J,NS),J=8,9),
     2 (VQ(IPKP(NS)+J,NS),J=10,12),(IPK(IPKP(NS)+J,NS),J=13,NANZL)
      CALL KPWRTE (NTOUT)
  400 FORMAT ('(',I3,') ',A1,A4,4I5,2F6.2,2I5,3F6.2,2I3)
      GO TO 140
C                            VD, VDS und VDR
  410 NANZL=NANZL-1
      WRITE (WRLINE,420) I,IFLG,KDOT(NTYP),VQ(IPKP(NS)+2,NS),
     1 (IPK(IPKP(NS)+IA,NS),IA=3,6)
      CALL KPWRTE (NTOUT)
  420 FORMAT ('(',I3,') ',A1,A4,F9.2,4I5,' =')
      IA=8
  430 IE=IA+5
      IF (IE .GT. NANZL) IE=NANZL
      WRLINE=' '
      N=7
      DO  J=IA,IE
        CALL KPCDST (IRLINE,N,IPK(IPKP(NS)+J,NS))
        N=N+10
      ENDDO
      IF (IE .LT. NANZL) WRLINE(68:68)='='
      CALL KPWRTE (NTOUT)
      IF (IE .GE. NANZL) GO TO 140
      IA=IA+6
      GO TO 430
C                            PFD - Plotte Flaeche direkt
C
  471 WRITE (WRLINE,472) I,IFLG,KDOT(NTYP),
     + IPK(IPKP(NS)+2,NS),IPK(IPKP(NS)+3,NS)
      CALL KPWRTE (NTOUT)
  472 FORMAT ('(',I3,') ',A1,A4,I3,I10,' =')
      IA=4
      GO TO 430
C
  480 IF (NTYPS-2) 530,530,485
  485 IF (NTYPS-5) 490,530,530
C
C                            Delete
  490 IF (IPKM) 530,530,510
  500 IPK(IPKM,NS)=IPK(IPKP(NS),NS)
      IPKM=IPKM+1
      IPKP(NS)=IPKP(NS)+1
  510 IF (IPKP(NS)-IPKS) 500,500,520
  520 IPKP(NS)=IPKM-1
      GO TO 999
C                            Restore
  530 IPKP(NS)=IPKS
      GO TO 999
C
  999 RETURN
      END
