C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPPNCD   50             -------------------
                          SUBROUTINE ZVPNCD
C  CY-ENG-               -------------------
C
C   Das Programm beschriftet die Atome wahlweise mit Codes (NTYP=1)
C   oder Nummern (2), sucht nach Symbolen (3) und (4); (5) ZA; (6)
C   wie (5), aber ohne input.
C
C                 Geschrieben: 221622 JUL 1982  (Hundt)
C                 Geaendert:   150957 JUN 2004  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
C
      REAL    *4 AKTAB(6),FFACH(2),AINBFR(8),TEMP
      INTEGER *4 ICTAB(4),IAIN(72),INBFR(8),I,IBUBLK,IPOI,ITEMP
      INTEGER *4 J,NTYPS,NZAHL,NZAHLT
      INTEGER *1 I1ISKP(12),I1AIN(288)
C
      EQUIVALENCE (AIN(1),IAIN(1),I1AIN(1)),(INBFR(1),AINBFR(1))
      EQUIVALENCE (ISKP(80),I1ISKP(1))
C
      SAVE INBFR,FFACH
C
      DATA AINBFR/.3,.3,6*0./,FFACH/1.05,2./
      DATA ICTAB/1H0,1Hc,1Hb,1Ha/,AKTAB/0.,0.,0.,1.,0.,0./
      DATA IBUBLK/32/
C
      NTYPS=NTYP
      IF (NTYPS .GE. 5) THEN
C                            ZA - Zeige achsen.
C
        IF (NTYPS .EQ. 5) CALL FLES (FFACH,ISKP(31),3H2FE,7Haf,sf?$)
        CALL UPLINF (ISKP(41),10)
        ISKP(42)=ISKP(41)
        CALL UPLINF (ISKP(49),11)
        NC=1
        NTRY=4
        DO  I=1,4
          DO  J=1,3
            X(J,1)=AKTAB(I+J-1)*FFACH(1)
          ENDDO
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
          TEMP=HOE/(HOE-X2(3))
          AIN(7)=(X2(1)*TEMP)*O9+CONST(11)
          AIN(8)=(X2(2)*TEMP)*O9+CONST(12)
          AIN(9)=CONST(15)*O9*TEMP*FFACH(2)
          CALL SYMBQL (AIN(7),AIN(8),AIN(9),ICTAB(I),1,0.,1)
        ENDDO
        GO TO 310
      ENDIF
      K8(NS)=0
      NTRY=44
      NC=1
C                            Hole Eingabe
      IF (NTYPS .GT. 2) THEN
        DO  I=3,8
          INBFR(I)=ISKP(24)
        ENDDO
        CALL FLES (INBFR,ISKP(31),9H2GAAAAAAE,22H<xoff,yoff,>s1,s2,...$)
        CALL CNVTUP (INBFR,9,24)
        AIN(3)=AINBFR(1)
        AIN(4)=AINBFR(2)
        NTYP=NTYPS-2
        GO TO 90
      ENDIF
C
      IAIN(1)=1
      IAIN(2)=NAT(NS)
      AIN(3)=0.
      AIN(4)=0.
      CALL FLES (IAIN,ISKP(31),5H2I2FE,
CYENG1
     1 19Hvon,bis,xoff,yoff?$)
CYENG2
CYENGY     1 19Hfrom,to,xoff,yoff?$)
C
C                            Teste Eingabe
C
      IF (IAIN(1) .LE. 0 .OR. IAIN(2) .GT. NAT(NS) .OR.
     +  IAIN(1) .GT. IAIN(2)) THEN
        IERR=50 0083 16
        GO TO 999
      ENDIF
      GO TO 90
C                            Berechne freie Koordinaten, soweit noch
C                            nicht geschehen.
   70 K9(NS)=K9(NS)+1
      IC=K9(NS)
      CALL ZVDEK
      DO  I=1,3
        ATOMS(I,K9(NS),NS)=X2(I)
      ENDDO
   90 IF (K9(NS) .LT. NCD(NS)) GO TO 70
C
C                          Durchlaufe die Codeliste.
      DO  IC=NCDA(NS),NCD(NS)
        ITEMP=ICD(IC,NS)/200000
        IF (NTYPS .GT. 2) THEN
          AIN(11)=AT(7,ITEMP,NS)
C          CALL CNVTUP (IAIN(11),1,4)
          DO  I=3,8
            IF (IAIN(11) .EQ. INBFR(I)) GO TO 150
          ENDDO
C                            Nicht gefunden, wenn hier.
          GO TO 300
        ELSE
C                            Teste, ob das Atom die gewuenschte
C                            Nummer hat.
C
          IF (ITEMP .LT. IAIN(1) .OR. ITEMP .GT. IAIN(2)) GO TO 300
        ENDIF
C                            Das ist der Fall.  Uebertrage Nummer/Code.
  150   NZAHL=IC
        IF (NTYP .LE. 1) THEN
          NZAHL=ICD(IC,NS)
          NZAHLT=NZAHL/200000
          IF (NZAHL .EQ. 200000*NZAHLT+111001) NZAHL=NZAHLT
        ENDIF
C                            Konvertiere linksbuendig.
C
        CALL KPCDST (ISKP(80),1,NZAHL)
        IPOI=40
        IAIN(11)=ISKP(24)
        IAIN(12)=ISKP(24)
        IAIN(13)=ISKP(24)
        DO  I=1,12
          IF (I1ISKP(I) .NE. IBUBLK) THEN
            IPOI=IPOI+1
            I1AIN(IPOI)=I1ISKP(I)
          ENDIF
        ENDDO
C
C                            Berechne die Koordinaten und beschrifte.
C
        TEMP=HOE/(HOE-ATOMS(3,IC,NS))
        AIN(7)=(ATOMS(1,IC,NS)*TEMP+AIN(3))*O9+CONST(11)
        AIN(8)=(ATOMS(2,IC,NS)*TEMP+AIN(4))*O9+CONST(12)
        AIN(9)=CONST(15)*O9*TEMP
        IF (ISKP(26) .EQ. 0) THEN
          AIN(10)=IPOI-40
          CALL UPLINF (AIN(7),18)
        ELSE
          I=IPOI-40
          CALL UPLINF (ISKP(41),10)
          ISKP(42)=ISKP(41)
          CALL UPLINF (ISKP(49),11)
          CALL SYMBQL (AIN(7),AIN(8),AIN(9),AIN(11),1,0.,I)
        ENDIF
C
C                            Naechster Code IC.
  300   CONTINUE
      ENDDO
  310 CALL UPLINF (AIN,0)
C
  999 RETURN
      END
