C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPPRIM   15            -------------------
                         SUBROUTINE ZVPRIM
C                       -------------------
C
C                        Geschrieben: Hundt
C                 Geaendert: 151149 JUN 2004  (Hundt)
C
C                       -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
C
      INTEGER *4 I,IBLK,J,MTYP
      REAL    *4 BLK,GOPT,HA,HB,HC,HD
      INTEGER *1 LTYP(4)
C
      EQUIVALENCE (BLK,IBLK),(LTYP(1),MTYP)
C
      DATA BLK/4H    /,HA,HB/4HUNDE,4HFINI/,HC,HD/4HNULL,4HORGN/
      DATA GOPT/4HR   /,MTYP/1/
C
C                            General-Initialisierung.
      DO  I=1,3
        ZELLE(I,NS)=1.
        ZELLE(I+3,NS)=90.
        RK(I,NS)=1.
        RK(I+3,NS)=90.
        UR(I,NS)=0.
        DO  J=1,3
          DG(I,J,NS)=0.
          RG(I,J,NS)=0.
          TRA(I,J,NS)=0.
          TRAINV(I,J,NS)=0.
          DREH(I,J)=0.
        ENDDO
        DG(I,I,NS)=1.
        RG(I,I,NS)=1.
        TRA(I,I,NS)=1.
        TRAINV(I,I,NS)=1.
        DREH(I,I)=1.
      ENDDO
      HOE=60.
      CALL UPLINF (HOE,33)
      NSYM(NS)=0
      NSYMDM=192
      DO  I=1,12
        SYM(I,1,NS)=0.
      ENDDO
      SYM( 2,1,NS)=1.
      SYM( 7,1,NS)=1.
      SYM(12,1,NS)=1.
      NAT(NS)=0
      NCD(NS)=0
      NCDA(NS)=1
      K8(NS)=0
      K9(NS)=0
      O8=1.
      O9=1.
      IPKP(NS)=0
      NTPCH=7
      NTSCR=8
      NTXR1=1
      NTXR2=2
      NTBILF=12
      NTDTEI=4
      NTDISP=6
C                            NDLG/DLG
      ISKP(4)=1
C                            NPLT/PLT
      ISKP(7)=1
C                            Stuetzpunkte fuer Kreis ...
      ISKP(8)=30
C                            ... und Bindungsroehrchenende
      ISKP(9)=4
C                            Beschriftungsflag
      ISKP(10)=0
C                            OI
      ISKP(12)=1
C                            Plotoption
      ISKP(13)=0
C                            Blank
      ISKP(24)=IBLK
C                            NPEN default/current
      ISKP(41)=15
      ISKP(42)=-1
C                            VEO-Polyederoption
      ISKP(44)=1
C                            Nummer des Fuellmusters Default
      ISKP(47)=0
C                            Option PCK - Parametercheck
      ISKP(48)=1
C                            STRD - Zahl der Pixel fuer Strich
      ISKP(49)=3
C                            Max KPERR-Calls
      ISKP(51)=100
C                            Beginn der Parameter
      ISKP(53)=3
C                            Mausliste ist leer
      ISKP(54)=0
C                            Schwarzer Hintergrund
      ISKP(56)=1
C                            STA-Option
      ISKP(62)=0
C                            Maschinentyp (low/high byte addr.)
      ISKP(67)=1
      IF (LTYP(1) .EQ. 0) ISKP(67)=4
C
C                            Maximalzahl an Buchstaben beim Beschriften
C                            von Atomen
      ISKP(69)=2
C                            Flag, ob bei SFND Fremdatome toleriert w.
      ISKP(76)=0
C                            3. Wort bei codes
      ISKP(82)=IBLK
C                            CMPZ lief erfolgreich
      ISKP(94)=0
C
C                            Zeichenfeld-Abmessungen ORTEP
      XO(1)=CONST(11)
      XO(2)=CONST(12)
      XO(3)=0.
C                            Abstand und Winkel
      CONST(5)=0.
      CONST(6)=0.
C                            Stereowinkel, Schrifthoehe
      CONST(13)=6.
      CONST(15)=0.2
C                            Toleranz GLP / NGLP
      CONST(21)=.01
C                            Abstand fuer die Abschattung
      CONST(23)=0.
      CONST(24)=0.08
C                            Distanz fuer FMDD
      CONST(31)=2.7
C                            Parameter fuer Max. Plotfeld
      CONST(32)=100.
      CONST(33)=45.
C                            Bohrloch Resttiefe
      CONST(34)=.4
C                            Toleranz, mit der beim Plotten von
C                            Polyedern Atome, die zu einer Ebene ge-
C                            hoeren, aus dieser herausragen duerfen.
      CONST(35)=.1
C                            Beschriftungstyp BST
      CONST(36)=0.
C                            Volumen der Zelle
      ZELLE(7,NS)=1.
C                            Option GOPT
      CONST(38)=GOPT
C                            Taper
      CONST(41)=0.3
C                            Face-Faktor
      CONST(42)=10.0
C                            Wahrscheinlichkeitsfaktor
      CONST(43)=1.54
      SCL=CONST(43)
C                            Toleranz bei Abstaenden in SFND
      CONST(45)=0.25
C                            Toleranz bei Winkeln in SFND
      CONST(46)=4.0
C                            Toleranz bei Ebenen in SFND
      CONST(47)=0.7
C                            Kugelfaktor
      FKGL=1.
C                            Raumgruppen-Symbol und Nummer
      NHMSNR(1,NS)=ISKP(24)
      NHMSNR(2,NS)=ISKP(24)
      NHMSNR(3,NS)=0
      DO  I=1,18
        TITEL(I,NS)=ISKP(24)
      ENDDO
C                            Atomparameter
      DO  I=1,NATDM
        AT(4,I,NS)=.3
        AT(5,I,NS)=HA
        AT(6,I,NS)=HB
        AT(7,I,NS)=HA
        ICLRP(I,NS)=0
        IPFLG(I,NS)=0
      ENDDO
      AT(4,1,NS)=.01
      AT(5,1,NS)=HD
      AT(6,1,NS)=BLK
      AT(7,1,NS)=HD
      AT(4,2,NS)=.1
      AT(5,2,NS)=HC
      AT(6,2,NS)=BLK
      AT(7,2,NS)=HC
      DO  I=1,3
        AT(I,1,NS)=.5
        AT(I,2,NS)=0.
      ENDDO
      ICLRP(1,NS)=1
      ICLRP(2,NS)=1
C                            Loesche Verbotsliste.
      NPPOI(NS)=0
      NPDIM=100
      RETURN
      END
