C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPPYER   65             -------------------
                          SUBROUTINE ZVPYER
C  CY-ENG-               -------------------
C
C              Programm zur Verarbeitung von Polyedern.
C
C     Kommando  NTYP  Bedeutung
C     GPOL        1   Generiere Polyeder
C
C                 Geschrieben: 131437 AUG 1990 (Hundt)
C                 Geaendert:   221541 APR 2008 (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER*4 IAIN(72),ISTACK(3*ATODIM),IEPOI(3),IE1,IE2,ISTPOI,ISTDM
      INTEGER*4 I,J,K,L,M,MC,IGPOI(3),IG1,IG2,IG3,ICOPT,IPOPT,IERRSV
      INTEGER*4 IB1,IB2,IB3,ISH,I1,I2
C
      REAL*4    FLAGE,FLAG,TOL,TEMP,BLANK,FRAGEZ
C
      EQUIVALENCE (AIN(1),IAIN(1)),(ATOMS(1,1,1),ISTACK(1))
      EQUIVALENCE (IGPOI(1),IG1),(IGPOI(2),IG2),(IGPOI(3),IG3)
      EQUIVALENCE (CONST(15),ISH)
C
      DATA BLANK/4H    /,FRAGEZ/4H?   /
C
C                       Berechne Polyeder
      IERRSV=0
      IF (ISKP(14) .EQ. 0) THEN
      IAIN(1)=ISKP(64)
      IAIN(2)=NAT(NS)
      AIN(3)=0.001
      IAIN(4)=-1
      IAIN(5)=-1
      IAIN(6)=0
      IAIN(7)=0
      CALL FLES (AIN,ISKP(31),6H2IF4IE,
CYENG1
     1 31Hvon,bis,tol,copt,popt,en1,en2?$)
CYENG2
CYENGY     1 31Hfrom,to,tol,copt,popt,en1,en2?$)
      ENDIF
      IE1=IAIN(1)
      IE2=IAIN(2)
      TOL=AIN(3)
      ICOPT=IAIN(4)
      IPOPT=IAIN(5)
      IB1=IAIN(6)
      IB2=IAIN(7)
      IB3=0
      IF (IE1) 50,50,10
   10 IF (IE2-NATDM) 20,20,50
   20 IF (IE1+3-IE2) 30,30,50
   30 IF (IB1) 60,60,40
   40 IF (IB1 .GT. IB2) GO TO 50
      IF (IB2 .LE. NAT(NS)) GO TO 60
   50 IERR=65005016
      GO TO 999
C                       Save Koordinatensystem
   60 NTYP=19
      CALL ZVK
C                       Loesche optional Codeliste und Plotkommandos
C
      IF (ICOPT) 80,100,90
   80 NCD(NS)=NCDA(NS)-1
   90 ISKP(14)=2
      NTYP=4
      IAIN(2)=-IE2
      CALL ZVASCI
      IERRSV=IERR
      IF (IERR) 650,100,650
C
  100 IF (IPOPT .LT. 0) IPKP(NS)=0
C
C                       Loesche Stack
      ISTPOI=0
      ISTDM=3*NCDDM
      K8(NS)=0
      K9(NS)=0
      IF (ISKP(5) .EQ. 0) GO TO 120
      WRITE (WRLINE,110)
      CALL KPWRTE (NTOUT)
CYENG1
  110 FORMAT ('Aussenflaechen:')
CYENG2
CYENGY  110 FORMAT ('Outer plane:')
C
C                       Setze Dreifachschleife auf
  120 IEPOI(1)=IE1
  130 IEPOI(2)=IEPOI(1)+1
  140 IEPOI(3)=IEPOI(2)+1
C
C                       Teste, ob diese drei Punkte einer
C                       schon gespeicherten Ebene angehoeren.
  150 I=1
      GO TO 220
  160 J=ISTACK(I)
      IF (J-4) 210,210,170
  170 MC=3
  180 DO 200 K=2,J
      I=I+1
      L=ISTACK(I)
      IF (IEPOI(1) .EQ. L) GO TO 190
      IF (IEPOI(2) .EQ. L) GO TO 190
      IF (IEPOI(3) .NE. L) GO TO 200
  190 MC=MC-1
  200 CONTINUE
      IF (MC .LE. 0) GO TO 620
      J=1
C
  210 I=I+J
  220 IF (I .LE. ISTPOI) GO TO 160
C
C                       Definiere durch diese drei Punkte ein
C                       Koordinatensystem
      ICDS(1)=IEPOI(1)
      ICDS(2)=IEPOI(1)
      ICDS(3)=IEPOI(2)
      ICDS(4)=IEPOI(1)
      ICDS(5)=IEPOI(3)
      ISKP(14)=1
      NTYP=1
      CALL ZVK
      IERRSV=IERR
      IF (IERR) 620,230,620
C
C                       Teste, ob alle Punkte auf der gleichen
C                       Seite der x-y-Ebene liegen.
  230 NTRY=28
      NC=7
      FLAGE=0.
      MC=0
      DO 280 I=IE1,IE2
      IF (I .EQ. IEPOI(1)) GO TO 240
      IF (I .EQ. IEPOI(2)) GO TO 240
      IF (I .EQ. IEPOI(3)) GO TO 240
      ICDS(7)=I
      CALL ZVDEK
      IF (ABS(X2(3)) .GT. TOL) GO TO 250
  240 MC=MC+1
      IAIN(MC)=I
      GO TO 280
C
  250 IF (FLAGE) 270,260,270
  260 FLAGE=X2(3)
      GO TO 280
C
  270 IF (FLAGE*X2(3)) 620,620,280
  280 CONTINUE
C
C                       Aussenflaeche gefunden, wenn hier.
C                       Sortiere so, dass die Reihenfolge
C                       die zu verbindenden Kanten darstellt.
C
      IF (MC .LE. 3) GO TO 450
      IG1=1
  290 NC=1
      ICDS(1)=IAIN(IG1)
      CALL ZVDEK
      DO 300 K=1,3
  300 X(K,1)=X2(K)
  310 IG2=IG1+1
  320 NC=2
      ICDS(2)=IAIN(IG2)
      CALL ZVDEK
      DO 330 K=1,3
  330 X(K,2)=X2(K)
C                       Stelle Gradengleichung auf
C
      X(1,4)=X2(2)-X(2,1)
      X(2,4)=X(1,1)-X2(1)
      X(3,4)=-X(1,4)*X2(1)-X(2,4)*X2(2)
C
C                       Teste, ob alle Punkte auf der gleichen
C                       Seite liegen
      FLAG=0.
      DO 410 K=1,MC
      IF (K .EQ. IG1) GO TO 410
      IF (K .EQ. IG2) GO TO 410
      NC=3
      ICDS(3)=IAIN(K)
      CALL ZVDEK
      X1(1)=X(1,4)*X2(1)+X(2,4)*X2(2)+X(3,4)
      IF (ABS(X1(1)) .GT. TOL) GO TO 380
      WRITE (WRLINE,340) IAIN(IG1),IAIN(IG2),IAIN(K)
      CALL KPWRTE (NTDISP)
CYENG1
  340 FORMAT ('ZVPYER0330 - Die Punkte ',3I4,
     1 ' liegen auf einer Geraden.')
CYENG2
CYENGY  340 FORMAT ('ZVPYER0330 - The points ',3I4,
CYENGY     1 ' are lying on a line.')
      DO 350 I=1,3
  350 X(I,3)=X2(I)
      IG3=K
      FLAG=-1.
      DO 360 I=1,3
      J=ID2(I)
      L=ID2(J)
      X1(3)=(X(1,J)-X(1,L))**2+(X(2,J)-X(2,L))**2
      IF (X1(3) .LE. FLAG) GO TO 360
      FLAG=X1(3)
      M=I
  360 CONTINUE
      J=IGPOI(M)
      WRITE (WRLINE,370) IAIN(J)
      CALL KPWRTE (NTDISP)
CYENG1
  370 FORMAT ('ZVPYER0360 - Bitte Punkt',I4,' entfernen.')
CYENG2
CYENGY  370 FORMAT ('ZVPYER0360 - Removing of point',I4,' recomended.')
      GO TO 650
C
  380 IF (FLAG) 400,390,400
  390 FLAG=X1(1)
      GO TO 410
C
  400 IF (X1(1)*FLAG) 430,410,410
  410 CONTINUE
C                       Aussenkante gefunden.  Ordne hintereinander.
C
      IF (IG1+1 .EQ. IG2) GO TO 420
      K=IAIN(IG1+1)
      IAIN(IG1+1)=IAIN(IG2)
      IAIN(IG2)=K
C
  420 IG1=IG1+1
      IF (IG1 .LT. MC) GO TO 290
      GO TO 450
C
  430 IG2=IG2+1
      IF (IG2 .LE. MC) GO TO 320
      WRITE (WRLINE,440)
      CALL KPWRTE (NTDISP)
CYENG1
  440 FORMAT ('ZVPYER0430 - Keiner will Aussenkante sein.')
CYENG2
CYENGY  440 FORMAT ('ZVPYER0430 - No edge found.')
      GO TO 420
C
  450 IF (ISKP(5) .EQ. 0) GO TO 470
      DO  I1=1,MC,18
        I2=I1+17
        IF (I2 .GT. MC) I2=MC
        WRITE (WRLINE,'(18I4)') (IAIN(I),I=I1,I2)
        CALL KPWRTE (NTOUT)
      ENDDO
C
C                       Nimm in Stack auf
C
  470 IF (ISTPOI+MC .LT. ISTDM) GO TO 490
      WRITE (WRLINE,480)
      CALL KPWRTE (NTDISP)
  480 FORMAT ('ZVPYER0470 - Stack overflow.')
      GO TO 650
C
  490 ISTPOI=ISTPOI+1
      ISTACK(ISTPOI)=MC+1
      DO 500 I=1,MC
      ISTPOI=ISTPOI+1
      ISTACK(ISTPOI)=IAIN(I)
  500 CONTINUE
C                       Genriere ggf. Plotbefehl
C
      IF (IPOPT .EQ. 0) GO TO 470
      IF (MC .LE. 67) GO TO 520
      WRITE (WRLINE,510)
      CALL KPWRTE (NTDISP)
CYENG1
  510 FORMAT ('ZVPYER0500 - Aussenflaeche hat zu viele Punkte.')
CYENG2
CYENGY  510 FORMAT ('ZVPYER0500 - Outer plane has too much points.')
      GO TO 470
C                       Berechne (optional) Schwerpunkt der Flaeche.
C
  520 IF (IB1 .LE. 0) GO TO 600
      NC=1
      NTRY=24
      DO 530 I=1,3
  530 X(I,2)=0.
      DO 550 I=1,MC
      ICDS(NC)=IAIN(I)
      CALL ZVDEK
      DO 540 J=1,3
  540 X(J,2)=X(J,2)+X(J,1)
  550 CONTINUE
C                       Erzeuge neues Atom.
C
      IF (NAT(NS) .LT. NATDM) GO TO 560
      IERRSV=65055002
      GO TO 600
C
  560 NAT(NS)=NAT(NS)+1
      IF (IB3 .EQ. 0) IB3=NAT(NS)
      TEMP=FLOAT(MC)
      DO 570 J=1,3
  570 AT(J,NAT(NS),NS)=X(J,2)/TEMP
      AT(4,NAT(NS),NS)=0.3
      AT(5,NAT(NS),NS)=FRAGEZ
      AT(6,NAT(NS),NS)=BLANK
      AT(7,NAT(NS),NS)=FRAGEZ
      ICLRP(NAT(NS),NS)=0
      IPFLG(NAT(NS),NS)=0
C                            Suche Nummer des letzten Plotbefehls ...
      I=1
      J=1
      GO TO 576
  575 I=I+1
      J=J+IPK(J,NS)
  576 IF (J .LT. IPKP(NS)) GO TO 575
      J=1
C                            ... und setze mit ? als Namen.
      CALL KPNTOS (I,AT(5,NAT(NS),NS),J,0)
C
C                       Suche den Namen bei den Normalen.
      DO 590 I=IB1,IB2
      DO 580 J=1,3
  580 X1(J)=DREH(J,1)*AT(1,I,NS)+DREH(J,2)*AT(2,I,NS)+
     + DREH(J,3)*AT(3,I,NS)
      IF (FLAGE*X1(3) .GE. 0.) GO TO 590
      IF (ABS(X1(1)) .GT. TOL) GO TO 590
      IF (ABS(X1(2)) .GT. TOL) GO TO 590
      J=0
      AT(5,NAT(NS),NS)=BLANK
      CALL KPNTOS (I,AT(5,NAT(NS),NS),J,0)
      AT(7,NAT(NS),NS)=AT(5,NAT(NS),NS)
      GO TO 600
C
  590 CONTINUE
C                       Erzeuge Plotbefehl.
  600 DO 610 I=1,MC
      J=MC+1-I
      IAIN(J+5)=IAIN(J)
  610 CONTINUE
      AIN(1)=0.06
      IAIN(2)=11
      IAIN(3)=0
      IAIN(4)=0
      IAIN(5)=0
      IAIN(MC+6)=IAIN(6)
      NTYP=15
      ISKP(32)=MC+5
      CALL ZVLPK
C
  620 IERR=0
      IEPOI(3)=IEPOI(3)+1
      IF (IEPOI(3) .LE. IE2) GO TO 150
      IEPOI(2)=IEPOI(2)+1
      IF (IEPOI(2) .LT. IE2) GO TO 140
      IEPOI(1)=IEPOI(1)+1
      IF (IEPOI(1)+2 .LE. IE2) GO TO 130
C
C                       Generiere (optional) BA-Befehl
C
      IF (IB3 .EQ. 0) GO TO 650
      I=(NAT(NS)-IB3+1)*3+5
      IF (IPKP(NS)+I .LE. IPKDM) GO TO 630
      IERRSV=65063011
      GO TO 650
C
  630 IPK(IPKP(NS)+1,NS)=I
      IPK(IPKP(NS)+2,NS)=5
      IPK(IPKP(NS)+3,NS)=ISKP(41)
      IPK(IPKP(NS)+4,NS)=ISKP(49)
      IPK(IPKP(NS)+5,NS)=ISH
      J=IPKP(NS)+6
      DO 640 K=IB3,NAT(NS)
      IPK(J,NS)=K*200000+111001
      IPK(J+1,NS)=0
      IPK(J+2,NS)=0
      J=J+3
  640 CONTINUE
      IPKP(NS)=IPKP(NS)+I
C                       Restore Koordinatensystem
  650 NTYP=20
      CALL ZVK
      ISKP(14)=0
      IERR=IERRSV
C
  999 RETURN
      END
