C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPRPSY   48             -------------------
                          SUBROUTINE ZVRPSY
C  CY-ENG-               -------------------
C
C   Das Programm entfernt die Parameter aus der Parameterliste, die im
C   Sinne der Symmetrie identisch sind.
C
C   NTYP  Kommando
C    1    RPSY - Reduziere Parameter nach Symmetrien
C    2    SU   - Subtrahiere Umgebung
C    3    IPSY - Idealisiere Parameter nach Symmetrien
C    4           Wie 1 aber ohne input
C    5    CUTT - Schneide ab (triklin)
C    6    CNCL - Condense cluster
C
C                 Geschrieben: 221043 APR 1983  (Hundt)
C                 Geaendert:   141740 JUL 2001  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),INBUF(5),INBFR(3),I,J,K,L,NCDSV,ISKP15
      INTEGER *4 I1,I2,J1,J2,IPAR,ICS1,NTYPS,NCDDMS
C
      REAL    *4 AINBFR(3),TEMP,AINBUF(5),ASKP87
C
      EQUIVALENCE (AIN(1),IAIN(1)),(INBUF(1),I1),(INBUF(2),I2)
      EQUIVALENCE (INBFR(1),AINBFR(1)),(INBUF(1),AINBUF(1))
      EQUIVALENCE (ISKP(87),ASKP87)
C
      SAVE INBFR
C
      DATA INBFR(1)/0/,INBFR(2)/0/,AINBFR(3)/0.5/

C
      NTYPS=NTYP
      GO TO (10,230,410,10,430,10),NTYPS
C             1   2   3  4   5   6
C
   10 IF (ISKP(14) .NE. 0) THEN
        ISKP(14)=0
        DO  I=1,5
          INBUF(I)=IAIN(I)
        ENDDO
      ELSE
C                            Input-Defaults
        INBUF(1)=ISKP(53)
        INBUF(2)=NAT(NS)
        AINBUF(3)=0.5
        INBUF(4)=-1
        INBUF(5)=-1
        IF (NTYP .NE. 4) THEN
C                            Hole Input
C
          CALL FLES (INBUF,ISKP(31),6H2IF2IE,
CYENG1
     +    23Hvon,bis,tol,opt1,opt2?$)
CYENG2
CYENGY     +    23Hfrom,to,tol,opt1,opt2?$)
        ENDIF
      ENDIF
      IF ((INBUF(1) .LE. 0) .OR. (INBUF(1) .GT. INBUF(2)) .OR.
     +    (INBUF(2) .GT. NAT(NS))) THEN
        IERR=48 0066 16
        GO TO 999
      ENDIF
      IF (AINBUF(3) .LT. 0.) AINBUF(3)=-AINBUF(3)*ASKP87
C
      IF (INBUF(5) .GT. 0) THEN
        INBUF(5)=NSYM(NS)
        NSYM(NS)=1
      ENDIF
   30 ISKP(14)=-1
C                            Setze Option GLP oder AGLP
      ISKP15=ISKP(15)
      ISKP(15)=0
      IF (INBUF(4) .LT. 0) ISKP(15)=-1
      IF (INBUF(4) .NE. 0) ISKP(14)=-2
C
C                            Teste, ob Radien alle <>0
      DO  I=I1,I2
        IF (AT(4,I,NS) .EQ. 0.) AT(4,I,NS)=.01
      ENDDO
C
      IF (NTYPS .EQ. 6) GO TO 450
      IPAR=I1
      GO TO 210
C                            Loesche Liste und lade Atom
   60 NCD(NS)=1
      K8(NS)=0
      K9(NS)=0
      ICD(1,NS)=IPAR*200000+111001
C
C                            Suche Umgebung via 'AU'
      IAIN(1)=IPAR
      IAIN(2)=IPAR
      IF (INBUF(4) .NE. 0) THEN
        IAIN(3)=IPAR
      ELSE
        IAIN(3)=IPAR+1
      ENDIF
      IAIN(4)=I2
      AIN(5)=AINBUF(3)
      AIN(6)=0.
      AIN(7)=0.
      AIN(8)=0.
      NTYP=4
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 220
C
C                            Entferne optional die atome, die
C                            einen anderen namen haben.
C
      IF (INBUF(5) .LT. 0) THEN
        AIN(1)=AT(7,IPAR,NS)
C        CALL CNVTUP (AIN(1),1,4)
        J=1
        DO  I=2,NCD(NS)
          AIN(2)=AT(7,ICD(I,NS)/200000,NS)
C          CALL CNVTUP (AIN(2),1,4)
          IF (IAIN(1) .EQ. IAIN(2)) THEN
            J=J+1
            ICD(J,NS)=ICD(I,NS)
          ENDIF
        ENDDO
        NCD(NS)=J
      ENDIF
C
C                            Teste, ob etwas gefunden
C
   80 IF (NCD(NS) .LT. 2) GO TO 200
C
C                            Berechne optional den Schwerpunkt.
C
      IF (INBUF(4) .NE. 0) THEN
        IF (NCD(NS) .GT. 1) THEN
          NC=5
          NTRY=40
          DO  J=1,3
            X1(J)=0.
          ENDDO
          DO  IC=1,NCD(NS)
            CALL ZVDEK
            IF (IERR .NE. 0) GO TO 999
            DO  J=1,3
              X1(J)=X1(J)+X(J,NC)
            ENDDO
          ENDDO
          TEMP=1./FLOAT(NCD(NS))
C
C                            Ersetze die Originalkoordinaten durch
C                            die des Schwerpunktes.
          DO  J=1,3
            AT(J,IPAR,NS)=X1(J)*TEMP
          ENDDO
        ENDIF
      ENDIF
C                            Delete die Doppelten
      DO  I=2,NCD(NS)
        J=ICD(I,NS)/200000
        IF (J .NE. IPAR) AT(4,J,NS)=0.
      ENDDO
      J1=ICD(2,NS)/200000-1
      J2=J1
  110 IF (J2 .GE. I2) GO TO 150
      J2=J2+1
      IF (AT(4,J2,NS) .EQ. 0.) GO TO 110
      J1=J1+1
      DO  I=1,8
        AT(I,J1,NS)=AT(I,J2,NS)
      ENDDO
      ICLRP(J1,NS)=ICLRP(J2,NS)
      DO  I=1,3
        DO  J=1,3
          TFVKT(I,J,J1,NS)=TFVKT(I,J,J2,NS)
        ENDDO
      ENDDO
      IPFLG(J1,NS)=IPFLG(J2,NS)
      GO TO 110
  150 I2=J1
      GO TO 180
C                            Kopiere ggf. Rest
  160 J1=J1+1
      J2=J2+1
      DO  I=1,8
        AT(I,J1,NS)=AT(I,J2,NS)
      ENDDO
      ICLRP(J1,NS)=ICLRP(J2,NS)
      DO  I=1,3
        DO  J=1,3
          TFVKT(I,J,J1,NS)=TFVKT(I,J,J2,NS)
        ENDDO
      ENDDO
      IPFLG(J1,NS)=IPFLG(J2,NS)
  180 IF (J2 .LT. NAT(NS)) GO TO 160
      NAT(NS)=J1
C                            next IPAR
  200 IPAR=IPAR+1
  210 IF (IPAR .LE. I2) GO TO 60
C
  220 ISKP(14)=0
      ISKP(15)=ISKP15
      NCD(NS)=0
      K8(NS)=0
      K9(NS)=0
      IF (INBUF(5) .GT. 0) THEN
        NSYM(NS)=INBUF(5)
      ENDIF
      GO TO 999
C                            Kommando SU - Delete Codes, die zwischen
C                            z1 und z2 Nummern haben, wenn sich im
C                            Abstandsintervall r,r1 ein Code befindet,
C                            der zwischen u1 und u2 liegt.
  230 AIN(5)=0.
      AIN(6)=.01
      CALL FLES (IAIN,ISKP(31),5H4I2FE,20Hu1,u2,z1,z2,r<,r1>?$)
      IF (ISKP(31) .LT. 4) THEN
        IERR=48 0221 16
        GO TO 999
      ENDIF
C
      IF (AIN(5) .LT. AIN(6)) THEN
        AIN(7)=AIN(6)
        AIN(6)=AIN(5)
        AIN(5)=AIN(7)
      ENDIF
      AIN(5)=AIN(5)*AIN(5)
      AIN(6)=AIN(6)*AIN(6)
      IAIN(7)=IAIN(1)*200000
      IAIN(8)=IAIN(2)*200000+199999
      IAIN(9)=IAIN(3)*200000
      IAIN(10)=IAIN(4)*200000+199999
C
C                            Durchlaufe Liste fuer Zielatome.
      ICS1=NCD(NS)+1
      NTRY=42
      NC=1
      GO TO 400
C
  260 ICS1=ICS1-1
      IF ((ICD(ICS1,NS) .LT. IAIN(9)) .OR.
     +    (ICD(ICS1,NS) .GT. IAIN(10))) GO TO 400
      IC=ICS1
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,3
        X2(I)=X1(I)
      ENDDO
C                            Durchsuche Liste nach moelichen
C                            Ursprungsatomen.
      DO  IC=NCDA(NS),NCD(NS)
        IF ((IC .EQ. ICS1) .OR. (ICD(IC,NS) .LT. IAIN(7)) .OR.
     +  (ICD(IC,NS) .GT. IAIN(8))) GO TO 350
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        AIN(11)=0.
        DO  I=1,3
          AIN(12)=X1(I)-X2(I)
          AIN(11)=AIN(11)+AIN(12)*AIN(12)
          IF (AIN(11) .GT. AIN(5)) GO TO 350
          ENDDO
        IF (AIN(11) .GE. AIN(6)) GO TO 360
  350   CONTINUE
      ENDDO
      GO TO 400
C                            Entferne Code.
  360 IC=ICS1
      NCD(NS)=NCD(NS)-1
      GO TO 390
  370 DO  I=1,3
        ATOMS(I,IC,NS)=ATOMS(I,IC+1,NS)
      ENDDO
      ICD(IC,NS)=ICD(IC+1,NS)
      IC=IC+1
  390 IF (IC .LE. NCD(NS)) GO TO 370
  400 IF (ICS1 .GT. NCDA(NS)) GO TO 260
      GO TO 999
C
C                            IPSY - Idealisiere nach symmetrien
C
  410 IF (INBFR(1) .EQ. 0) INBFR(1)=ISKP(53)
      IF (INBFR(2) .EQ. 0) INBFR(2)=NAT(NS)
      AINBFR(3)=0.5
CYENG1
      CALL FLES (INBFR,ISKP(31),4H2IFE,13Hvon,bis,tol?$)
CYENG2
CYENGY      CALL FLES (INBFR,ISKP(31),4H2IFE,13Hfrom,to,tol?$)
      IF ((INBFR(1) .LE. 0) .OR. (INBFR(2) .GT. NAT(NS)) .OR.
     +    (INBFR(1) .GT. INBFR(2))) THEN
        IERR=48 0288 16
        GO TO 999
      ENDIF
C
      NCDSV=NCD(NS)
      ISKP15=ISKP(15)
      ISKP(15)=-1
      DO  I=INBFR(1),INBFR(2)
C                            Setze parameter ...
        IAIN(1)=I
        IAIN(2)=I
        IAIN(3)=I
        AIN(4)=AINBFR(3)
        AIN(5)=0.
        ISKP(32)=2
        ISKP(14)=-3
        NCD(NS)=NCDSV
        NCDA(NS)=NCDSV+1
C                              ... und fuehre AKS aus.
        NTYP=3
        CONST(20)=0.
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 420
        J=NCD(NS)-NCDA(NS)+1
        IF (J .GT. 1) THEN
          DO  L=1,3
            X1(L)=0.
          ENDDO
          DO  K=NCDSV+1,NCD(NS)
            DO  L=1,3
              X1(L)=X1(L)+ATOMS(L,K,NS)
            ENDDO
          ENDDO
          DO  L=1,3
            AT(L,I,NS)=X1(L)/FLOAT(J)
          ENDDO
        ENDIF
      ENDDO
  420 ISKP(14)=0
      ISKP(15)=ISKP15
      NCD(NS)=NCDSV
      NCDA(NS)=1
      GO TO 999
C                            CUTT - Schneide ab (triklin)
  430 IAIN(1)=1
      IAIN(2)=ISKP(53)
      IAIN(3)=NAT(NS)
      AIN(4)=1000.
      AIN(5)=1000.
      AIN(6)=1000.
      CALL FLES (IAIN,ISKP(31),6HC2I3FE,22Hcur,von,bis,dx,dy,dz?$)
      ICDS(2)=IAIN(1)
      NC=2
      NTRY=24
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
C
      DO  I=1,3
        X(I,3)=X(I,2)-AIN(I+3)
        X(I,4)=X(I,2)+AIN(I+3)
      ENDDO
      J=NCDA(NS)-1
      NC=1
      NTRY=40
      DO  IC=NCDA(NS),NCD(NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        IF (IANR .GE. IAIN(2) .AND. IANR .LE. IAIN(3)) THEN
          DO  I=1,3
            TEMP=X(I,1)
            IF (TEMP .LT. X(I,3) .OR. TEMP .GT. X(I,4)) GO TO 440
          ENDDO
        ENDIF
        J=J+1
        ICD(J,NS)=ICD(IC,NS)
  440   CONTINUE
      ENDDO
      NCD(NS)=J
      K8(NS)=0
      K9(NS)=0
      GO TO 999
C                            CNCL - Condense cluster.
  450 IF (NSYM(NS) .NE. 1) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'ZVRPSY0376 - Struktur nicht triklin.'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'ZVRPSY0376 - No triclinic structure.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
C                            SRTL ...
      IAIN(1)=INBUF(1)
      IAIN(2)=INBUF(2)
      DO  I=3,20
        IAIN(I)=0
      ENDDO
      ISKP(14)=1
      NTYP=10
      CALL ZVSRT
      IF (IERR .NE. 0) THEN
C                            ... oder, wenn's nicht funktioniert, SRTN
        IERR=0
        NTYP=5
        CALL ZVSRT
        IF (IERR .NE. 0) GO TO 999
      ENDIF
C                            Setze run auf
      NCDDMS=NCDDM
      NCDDM=48
      J1=I1
  460 AIN(1)=AT(7,J1,NS)
C      CALL CNVTUP (AIN,1,4)
      DO  I=J1,I2
        AIN(2)=AT(7,I,NS)
C        CALL CNVTUP (AIN,5,4)
        IF (IAIN(1) .EQ. IAIN(2)) J2=I
      ENDDO
C                            Teste, ob mindestens 2
      IF (J2 .GT. J1) THEN
        DO  IPAR=J1,J2
          IF (AT(4,IPAR,NS) .NE. 0.) THEN
C
C                              Ein atom in die codeliste ...
            NCD(NS)=1
            K8(NS)=0
            ICD(1,NS)=IPAR*200000+111001
C
C                                ... und AUW konstruieren.
            IAIN(1)=J1
            IAIN(2)=J2
            IAIN(3)=J1
            IAIN(4)=J2
            AIN(5)=AINBUF(3)
            IAIN(6)=0
            ISKP(14)=1
            NTYP=5
            CALL ZVAVBR
            IF (IERR .NE. 0) THEN
              NCDDM=NCDDMS
              GO TO 999
            ENDIF
C                                Berechne schwerpunkt falls mehr als
C                                ein atom gefunden.
            IF (NCD(NS) .GT. 1) THEN
              DO  I=1,3
                X1(I)=0.
              ENDDO
              DO  IC=1,NCD(NS)
                DO  J=1,3
                  X1(J)=X1(J)+ATOMS(J,IC,NS)
                ENDDO
              ENDDO
              TEMP=FLOAT(NCD(NS))
              DO  I=1,3
                AT(I,IPAR,NS)=X1(I)/TEMP
              ENDDO
C                                Markiere aequivalente zum loeschen.
              DO  IC=2,NCD(NS)
                I=ICD(IC,NS)/200000
                IF (I .NE. IPAR) AT(4,I,NS)=0.
              ENDDO
            ENDIF
          ENDIF
        ENDDO
      ENDIF
C                            Noch eine gruppe?
      J1=J2+1
      IF (J1 .LT. I2) GO TO 460
      NCDDM=NCDDMS
      J1=I1-1
      J2=J1
      IPAR=9999
      GO TO 110
C
  999 RETURN
      END
