C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                    --------------------------
                      SUBROUTINE ZVSHKG (IDCB)
C  CY-ENG-           --------------------------
C
C  Programm zum Schraffieren von Kugeln.
C
C  Belegplan IDCB:
C
C  1  Farbe der Linien; <0: keine Schraffur
C  2  Strichstaerke der Schraffur
C  3  IFLG 0: d ist Angroem; 1: d ist cm
C  4  d    Abstand der Linien
C  5  wst  Startwinkel
C  6  win  Increment
C  7  IREP Anzahl der Incrementierungen
C  8  sl   Strichelung, wenn <>0, Strichlaenge
C  9  sn   Laenge des Nicht-Strichs
C
C                geschrieben: 221740 FEB 1992 (Hundt)
C                geaendert:   121111 DEC 1999 (Hundt)
C
C                    --------------------------
C
      IMPLICIT NONE
C
      INTEGER*4 IDCB(*),IANG,IDIST,NPEN,I,IWINCR,IWDH
      INTEGER*4 ISL,ISN,IFLG
C
      REAL*4    ANG,DRMAT(2,2),DIST,PLKO(4),PLKOEF(2),RADI,TEMP,WINCR
      REAL*4    SL,SN,BR,ZPKT,XINC,YINC
C
      INCLUDE 'ZVCOM.INC'
C
      EQUIVALENCE (ANG,IANG),(DIST,IDIST),(WINCR,IWINCR)
      EQUIVALENCE (SL,ISL),(SN,ISN)
C
      I=IDCB(1)
      IF (I .LT. 0) GO TO 999
      CALL UPLINF (I,10)
      ISKP(42)=I
      I=IDCB(2)
      IF (I .LE. 0) GO TO 999
      CALL UPLINF (I,11)
C
   30 IANG=IDCB(5)
      IDIST=IDCB(4)
      IF (DIST .LE. 0.) GO TO 999
      IF (IDCB(3) .GT. 0) GO TO 40
      YINC=DIST*X(3,2)
      GO TO 50
C
   40 YINC=DIST/O9
C
   50 IWINCR=IDCB(6)
      IWDH=IDCB(7)
   60 IF (IANG .EQ. 0) GO TO 70
      DRMAT(1,1)=COS(ANG*CONST(3))
      DRMAT(2,1)=SIN(ANG*CONST(3))
      GO TO 80
C
   70 DRMAT(1,1)=1.
      DRMAT(2,1)=0.
   80 DRMAT(2,2)=DRMAT(1,1)
      DRMAT(1,2)=-DRMAT(2,1)
C
C                       Schraffiere ...
      TEMP=0.
      RADI=X(1,2)
      ISL=IDCB(8)
      IF (SL .GT. 0.) GO TO 140
C
C                       ... mit durchgezogenem Strich.
   90 NPEN=3
      PLKO(1)=-RADI
      PLKO(2)=TEMP
C
  100 DO 110 I=1,2
      PLKOEF(I)=
     1 (X(I,1)+DRMAT(I,1)*PLKO(1)+DRMAT(I,2)*PLKO(2))*O9+CONST(10+I)
  110 CONTINUE
      CALL UPLINF (PLKOEF,NPEN)
      IF (NPEN .EQ. 2) GO TO 120
      NPEN=2
      PLKO(1)=RADI
      GO TO 100
C
  120 TEMP=-TEMP
      IF (TEMP .LT. 0.) GO TO 90
      TEMP=TEMP+YINC
C
      RADI=X(1,2)*X(1,2)-TEMP*TEMP
      IF (RADI .LE. 0.) GO TO 130
      RADI=SQRT(RADI)
      GO TO 90
C
  130 IF (IWDH .LE. 0) GO TO 999
      IWDH=IWDH-1
      ANG=ANG+WINCR
      GO TO 60
C                       ... mit gestrichelter Linie.
  140 ISN=IDCB(9)
      ZPKT=0.
      XINC=SL+SN
      BR=SL*0.5
      IFLG=0
C
  150 NPEN=3
      PLKO(1)=ZPKT+BR
      PLKO(2)=TEMP
      PLKO(3)=ZPKT-BR
      IF (PLKO(1) .LE. RADI) GO TO 160
      PLKO(1)=RADI
      IF (PLKO(3) .GE. RADI) GO TO 200
C
  160 DO 170 I=1,2
      PLKOEF(I)=
     1 (X(I,1)+DRMAT(I,1)*PLKO(1)+DRMAT(I,2)*PLKO(2))*O9+CONST(10+I)
  170 CONTINUE
      CALL UPLINF (PLKOEF,NPEN)
      IF (NPEN .EQ. 2) GO TO 180
      NPEN=2
      PLKO(4)=PLKO(1)
      PLKO(1)=PLKO(3)
      GO TO 160
C
  180 NPEN=3
      ZPKT=-ZPKT
      PLKO(1)=-PLKO(4)
      PLKO(3)=-PLKO(3)
      IF (ZPKT .LT. 0.) GO TO 160
C
      PLKO(2)=-PLKO(2)
      IF (PLKO(2) .LT. 0) GO TO 160
C
  190 ZPKT=ZPKT+XINC
      GO TO 150
C
  200 IF (IFLG .EQ. 0) GO TO 210
      IFLG=0
      ZPKT=0.
      GO TO 220
C
  210 IFLG=1
      ZPKT=XINC*0.5
C
  220 TEMP=TEMP+YINC
      RADI=X(1,2)*X(1,2)-TEMP*TEMP
      IF (RADI .LE. 0.) GO TO 130
      RADI=SQRT(RADI)
      GO TO 150
C
  999 RETURN
      END
