C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPSPG    42             ------------------
                          SUBROUTINE ZVSPG
C CY-ENG-                ------------------
C
C         Es werden Spiegelebenen in einem Molekuel gesucht.
C
C                         geschrieben: Hundt
C                   geaendert: 151154 JUN 2004  (Hundt)
C
C                        ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),ITSV(3),IAT(8,PARDIM,2),I,IANRSV,IBIS
      INTEGER *4 ICB,ICV,INAM1,INAM2,IPKT1,IPKT2,IPOI,ISPGEB
      INTEGER *4 ISPGMX,ISYNSV,J,JVON,K,KEYIN,L,LC,NDURCH
      REAL    *4 VNORM(4),SPG(4,8),SUM(3),PKTGSP(3),VEKT(3)
      REAL    *4 ANAM1,ANAM2,DIST,DNORM,TEMP,TEMP2
C
      EQUIVALENCE (AIN(1),IAIN(1),ICV),(AIN(2),ICB),(ANAM1,INAM1)
      EQUIVALENCE (ANAM2,INAM2),(VNORM(4),DNORM)
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1))
C
      DATA ISPGMX/8/
C                            Hole Input
C
      IF (ISKP(14) .EQ. 0) THEN
        DO  I=1,6
          IAIN(I)=0
        ENDDO
        AIN(3)=.5
CYENG1
        CALL FLES (AIN,ISKP(31),6H2I3FIE,22Hvon,bis,tolx,y,z,nlk?$)
CYENG2
CYENGY        CALL FLES (AIN,ISKP(31),6H2I3FIE,25Hfrom,to,tolx,y,z,nholes?$)
        IF (AIN(4) .LE. 0.) AIN(4)=AIN(3)
        IF (AIN(5) .LE. 0.) AIN(5)=AIN(4)
      ENDIF
C
C                            Teste, ob genug Parameter in der Liste
C
      IF (NCD(NS) .LE. NCDA(NS)+1) THEN
        IERR=42004012
        GO TO 999
      ENDIF
C                            Berechne freie Koordinaten
      K8(NS)=0
      NC=1
      NTRY=44
      GO TO 80
   60 K9(NS)=K9(NS)+1
      IC=K9(NS)
      CALL ZVDEK
      DO  I=1,3
        ATOMS(I,K9(NS),NS)=X2(I)
      ENDDO
   80 IF (NCD(NS) .GT. K9(NS)) GO TO 60
C                            Anzahl der gefundenen Spiegelebenen
      ISPGEB=0
C                            Durchsuche Punkte;  je zwei Punkte
C                            definieren eine Spiegelebene
      IBIS=NCD(NS)-1
      DO 600 IPKT1=NCDA(NS),IBIS
      IF (KEYIN(0) .EQ. ISKP(20)) GO TO 605
      IANR=ICD(IPKT1,NS)/200000
      IF (IANR .LT. ICV .OR. IANR .GT. ICB) GO TO 600
      ANAM1=AT(7,IANR,NS)
      JVON=IPKT1+1
      DO 590 IPKT2=JVON,NCD(NS)
      IANR=ICD(IPKT2,NS)/200000
      IF (IANR .LT. ICV .OR. IANR .GT. ICB) GO TO 590
      ANAM2=AT(7,IANR,NS)
C                            Teste, ob Namen uebereinstimmen
C
      IF (INAM1 .NE. INAM2) GO TO 590
C
C                            Teste, ob Punkte nicht identisch
      TEMP=0.
      DO  I=1,3
        TEMP=TEMP+ABS(ATOMS(I,IPKT1,NS)-ATOMS(I,IPKT2,NS))
      ENDDO
      IF (TEMP .LE. 0.01) GO TO 590
C
C                            Bestimme Normalenvektor VNORM und
C                            Abstand DNORM fuer diese Punkte
      TEMP=0.
      DO  I=1,3
        TEMP2=ATOMS(I,IPKT2,NS)-ATOMS(I,IPKT1,NS)
        VNORM(I)=TEMP2
        TEMP=TEMP+TEMP2*TEMP2
      ENDDO
      TEMP=SQRT(TEMP)
      DNORM=0.
      DO  I=1,3
        VNORM(I)=VNORM(I)/TEMP
        DNORM=DNORM+(ATOMS(I,IPKT1,NS)+ATOMS(I,IPKT2,NS))*.5*VNORM(I)
      ENDDO
      IF (DNORM .LT. 0.) THEN
        DO  I=1,3
          VNORM(I)=-VNORM(I)
        ENDDO
        DNORM=-DNORM
      ENDIF
C                            Teste, ob diese Spiegelebene bereits
C                            untersucht wurde
      IF (ISPGEB .GT. 0) THEN
        DO  I=1,ISPGEB
          DO  J=1,4
            IF (ABS(SPG(J,I)-VNORM(J)) .GE. 0.1) GO TO 250
          ENDDO
C                                Gefunden.  Suche neue Spiegelebene.
          GO TO 590
  250     CONTINUE
        ENDDO
      ENDIF
C                            Spiegelebene war noch nicht da.
C                            3 Durchgaenge:
C                            (1) Optimierung des Normalenvektors
C                            (2) Optimierung des Abstandes
C                            (3) Ausdruck des Ergebnisses
C
      DO 540 NDURCH=1,3
      L=0
      LC=0
      DO  J=1,3
        SUM(J)=0.
      ENDDO
C                            Spiegele alle Punkte an der definierten
C                            Spiegelebene.
      K=NCDA(NS)
C                            Berechne Abstand ...
C
  280 DIST=VNORM(1)*ATOMS(1,K,NS)+VNORM(2)*ATOMS(2,K,NS)+
     + VNORM(3)*ATOMS(3,K,NS)-DNORM
C                            ... und Koordinaten ...
      DO  J=1,3
        PKTGSP(J)=ATOMS(J,K,NS)-2.*VNORM(J)*DIST
      ENDDO
C
C                            ... und suche in Tabelle.
      DO 420 IPOI=NCDA(NS),NCD(NS)
      DO  J=1,3
        IF (ABS(ATOMS(J,IPOI,NS)-PKTGSP(J)) .GT. AIN(J+2)) GO TO 420
      ENDDO
C                            Gefunden.
C
      IF (IAT(5,ICD(K,NS)/200000,NS) .NE.
     +    IAT(5,ICD(IPOI,NS)/200000,NS)) GO TO 420
C
      IF (NDURCH-2) 310,370,390
C
C                            1. Durchgang.  Optimiere Normalenvektor.
  310 DO  J=1,3
        VEKT(J)=ATOMS(J,K,NS)-ATOMS(J,IPOI,NS)
      ENDDO
C
C                            VEKT muss die gleiche Richtung haben
C                            wie VNORM.
C
      IF (VEKT(1)*VNORM(1)+VEKT(2)*VNORM(2)+VEKT(3)*VNORM(3) .GE. 0.)
     1  GO TO 350
      DO  J=1,3
        VEKT(J)=-VEKT(J)
      ENDDO
C                            Summiere auf.
  350 DO  J=1,3
        SUM(J)=SUM(J)+VEKT(J)
      ENDDO
      GO TO 470
C                            2. Durchgang  Optimiere Abstand.
  370 TEMP=0.
      DO  J=1,3
        TEMP=TEMP+(ATOMS(J,K,NS)+ATOMS(J,IPOI,NS))*.5*VNORM(J)
      ENDDO
      SUM(1)=SUM(1)+ABS(TEMP)
      LC=LC+1
      GO TO 470
C                            3. Durchgang  Drucke Ergebnis.
  390 TEMP=0.
      DO  J=1,3
        TEMP2=ATOMS(J,IPOI,NS)-PKTGSP(J)
        TEMP=TEMP+TEMP2*TEMP2
      ENDDO
      TEMP=SQRT(TEMP)
C
      NTRY=32
      IC=K
      CALL ZVDEK
      IANRSV=IANR
      ISYNSV=ISYNR
      ITSV(1)=IT(1)
      ITSV(2)=IT(2)
      ITSV(3)=IT(3)
C
      IC=IPOI
      CALL ZVDEK
      IF (ISKP(58) .LT. 1) GO TO 470
      WRITE (WRLINE,410) K,AT(5,IANRSV,NS),AT(6,IANRSV,NS),IANRSV,ITSV,
     1 ISYNSV,IPOI,AT(5,IANR,NS),AT(6,IANR,NS),IANR,IT,ISYNR,TEMP
      CALL KPWRTE (NTOUT)
  410 FORMAT ('(',I3,') ',2A4,I4,3I1,I2,' <-m-> (',I3,') ',2A4,I4,3I1,
CYENG1
     1 I2,' Abw.=',F6.3)
CYENG2
CYENGY     1 I2,' D =',F6.3)
      GO TO 470
C                            Nicht gefunden.  Teste, ob diese
C                            Luecke noch erlaubt.
  420 CONTINUE
      IF (NDURCH .GT. 2) GO TO 450
      IF (L .GE. IAIN(6)) GO TO 590
      L=L+1
      GO TO 470
C
  450 NTRY=32
      IC=K
      CALL ZVDEK
      WRITE (WRLINE,460) K,AT(5,IANR,NS),AT(6,IANR,NS),IANR,IT,ISYNR
      CALL KPWRTE (NTDISP)
CYENG1
  460 FORMAT ('(',I3,') ',2A4,I4,3I1,I2,' <-m-> *** Kein gespiegelter P
     1unkt. ***')
CYENG2
CYENGY  460 FORMAT (' (',I3,') ',2A4,I4,3I1,I2,' <-m-> *** No mirror point. **
CYENGY     1*')
C
C                            Naechstes K
  470 K=K+1
      IF (K .LE. NCD(NS)) GO TO 280
C
C                            Naechster Durchgang.
C
      IF (NDURCH-2) 490,520,540
C
C                            1. Durchgang
  490 TEMP=0.
      DO  J=1,3
        TEMP=TEMP+SUM(J)*SUM(J)
      ENDDO
      TEMP=SQRT(TEMP)
      DO  J=1,3
        VNORM(J)=SUM(J)/TEMP
      ENDDO
      GO TO 540
C                            Mittle D
  520 DNORM=SUM(1)/FLOAT(LC)
      WRITE (WRLINE,530) VNORM
      CALL KPWRTE (NTOUT)
CYENG1
  530 FORMAT ('***** Spiegelebene',4F10.5,' *****')
CYENG2
CYENGY  530 FORMAT (' ***** Mirror plane',4F10.5,' *****')
C
C                            NEXT NDURCH
  540 CONTINUE
C                            Speichere Spiegelebene, falls noch
C                            moeglich.
C
      IF (ISPGEB .LT. ISPGMX) THEN
        ISPGEB=ISPGEB+1
        DO  J=1,4
          SPG(J,ISPGEB)=VNORM(J)
        ENDDO
      ELSE
        WRITE (WRLINE,580)
CYENG1
  580   FORMAT ('ZVSPG0580 - Speicher fuer Spiegelebenen voll.')
CYENG2
CYENGY  580   FORMAT ('ZVSPG0580 - List for mirror planes full.')
        CALL KPWRTE (NTDISP)
        GO TO 999
      ENDIF
C                            NEXT IPKT2
  590 CONTINUE
C                            NEXT IPKT1
  600 CONTINUE
  605 IF (ISPGEB .GT. 0) GO TO 999
      WRITE (WRLINE,620)
      CALL KPWRTE (NTDISP)
CYENG1
  620 FORMAT ('Keine Spiegelebene gefunden.')
CYENG2
CYENGY  620 FORMAT ('No mirror plane found.')
C
  999 RETURN
      END
