C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
CKPSRT    24             ------------------
                          SUBROUTINE ZVSRT
C CY-ENG-                ------------------
C
C    Kommando  NTYP  Bedeutung
C    SRTF       11   Sortiere nach Farbzeiger
C    SRTL       10   Sortiere nach Liste
C    US          9   Sortiere gem. Umsortierliste um
C    UA          8   Addiere in Umsortierliste
C    UL          7   Loesche Umsortierliste
C    HNH         6   Wassersoffatome nach hinten
C    SRT         2   Sortiere freie Koordinaten
C    SRTC        3   Sortiere Codes
C    SRTN        5   Sortiere Namen (alphabetisch)
C    SRTP        4   Sortiere Parameter
C    SRTT        1   Sortiere nach triklinen Koordinaten
C
C                        geschrieben: Hundt
C                  geaendert: 041546 JUN 2004  (Hundt)
C
C                        ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
C
      INTEGER *4 JAT(8,PARDIM,2),JATS(10),IAIN(72)
      INTEGER *4 LCOMPS,IT1,IT2,IT3,JELEMH,K,I,J,ITM,JP1
      INTEGER *4 MERK,L,ITEMP,IR,JTEMP,J1,J2
C
      REAL    *4 H,TEMP,TEMP2,C(3,3),ATSV(8)
C
      EQUIVALENCE (AT(1,1,1),JAT(1,1,1))
      EQUIVALENCE (AIN(1),IT1,IAIN(1)),(AIN(2),IT2),(AIN(3),IT3)
C
      DATA JELEMH/4HH   /
C
      GO TO (10,10,310,380,510,510,999,999,999,1000,510),NTYP
C             1  2   3   4   5   6   7   8   9   10  11
C
C                            Lies Koordinate
   10 IF (ISKP(14) .EQ. 0) THEN
CYENG1
      CALL FLES (IAIN,ISKP(31),2HIE,20HKoordinate (1/2/3)?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),2HIE,20HCoordinate (1/2/3)?$)
      ENDIF
C
C                            Teste auf Gueltigkeit
C
      IF (IAIN(1) .LE. 0 .OR. IAIN(1) .GT. 3) THEN
        IERR=24 0050 16
        GO TO 999
      ENDIF
C
      IF (NCD(NS) .LT. NCDA(NS)) THEN
        IERR=24 0070 12
        GO TO 999
      ENDIF
C
      IT2=ID2(IT1)
      IT3=ID2(IT2)
C                            Berechne Koordinaten.
      NC=1
      IF (NTYP-2) 90,120,310
   90 K9(NS)=0
      NTRY=40
  100 IF (K8(NS) .GE. NCD(NS)) GO TO 150
      K8(NS)=K8(NS)+1
      IC=K8(NS)
      CALL ZVDEK
      ATOMS(IT1,K8(NS),NS)=X(IT1,1)
      GO TO 100
C                            Freie Koordinaten.
  120 K8(NS)=0
      NTRY=44
  130 IF (K9(NS) .GE. NCD(NS)) GO TO 150
      K9(NS)=K9(NS)+1
      IC=K9(NS)
      CALL ZVDEK
      ATOMS(IT1,K9(NS),NS)=X2(IT1)
      GO TO 130
C                            Koordinaten sind erzeugt.  Sortiere.
C
  150 IF (NCD(NS) .LE. NCDA(NS)) GO TO 300
      L=NCD(NS)/2+1
      IR=NCD(NS)
  151 CONTINUE
      IF (L .LE. 1) GO TO 152
      L=L-1
      H=ATOMS(IT1,L,NS)
      ITM=ICD(L,NS)
      GO TO 153
C
  152 H=ATOMS(IT1,IR,NS)
      ITM=ICD(IR,NS)
      ATOMS(IT1,IR,NS)=ATOMS(IT1,1,NS)
      ICD(IR,NS)=ICD(1,NS)
      IR=IR-1
      IF (IR .GT. 1) GO TO 153
      ATOMS(IT1,1,NS)=H
      ICD(1,NS)=ITM
C
  300 K8(NS)=0
      K9(NS)=0
      GO TO 999
C
  153 I=L
      J=L+L
  154 IF (J-IR) 155,156,158
  155 IF (ATOMS(IT1,J,NS) .LT. ATOMS(IT1,J+1,NS)) J=J+1
  156 IF (H .GE. ATOMS(IT1,J,NS)) GO TO 158
      ATOMS(IT1,I,NS)=ATOMS(IT1,J,NS)
      ICD(I,NS)=ICD(J,NS)
      I=J
      J=J+J
      GO TO 154
C
  158 ATOMS(IT1,I,NS)=H
      ICD(I,NS)=ITM
      GO TO 151
C                            Sortiere Codes
C
  310 IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (IAIN,ISKP(31),1HE,2H?$)
      ELSE
        ISKP(14)=0
      ENDIF
      I=NCDA(NS)
  320 IF (I .GE. NCD(NS)) GO TO 300
      I=I+1
      J=I
      JP1=J
      IT1=ICD(J,NS)
      GO TO 350
C
  340 ICD(JP1,NS)=ICD(J,NS)
      JP1=JP1-1
  350 J=J-1
      IF (J .GE. NCDA(NS)) THEN
        IF (IT1 .LT. ICD(J,NS)) GO TO 340
      ENDIF
      ICD(JP1,NS)=IT1
      GO TO 320
C                            Kommando SRTP - Sortiere nach Punkten.
C
  380 IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (IAIN,ISKP(31),3H3IE,10Hn1,n2,m1?$)
      ENDIF
      IF (ISKP(31)-2) 440,390,400
  390 IT3=IT2+1
  400 IF (IT1 .GT. IT2) GO TO 440
      IF (IT1 .LE. 0) GO TO 440
      IF (IT2 .GT. NATDM) GO TO 440
      IF (IT3 .GT. 0) GO TO 450
  440 IERR=24 0440 16
      GO TO 999
C
  450 K=IT3+IT2-IT1
      IF (K .GT. NATDM) GO TO 440
      DO  I=IT1,IT2
        TEMP2=999.
        DO  J=IT3,K
          TEMP=ABS(AT(1,I,NS)-AT(1,J,NS))+ABS(AT(2,I,NS)-AT(2,J,NS))+
     +    ABS(AT(3,I,NS)-AT(3,J,NS))
          IF (TEMP2 .GT. TEMP) THEN
            MERK=J
            TEMP2=TEMP
          ENDIF
        ENDDO
        DO  J=1,8
          TEMP=AT(J,IT3,NS)
          AT(J,IT3,NS)=AT(J,MERK,NS)
          AT(J,MERK,NS)=TEMP
        ENDDO
        IT3=IT3+1
      ENDDO
      GO TO 999
C
C                            SRTN - Sortiere nach Namen (NTYP=5)
C                            HNH - Wasserstoff nach hinten (NTYP=6)
C                            SRTF - Sortiere nach Farbzeiger (NTYP=11)
C
  510 IF (ISKP(14) .EQ. 0) THEN
        IT1=ISKP(53)
        IT2=NAT(NS)
CYENG1
        CALL FLES (IAIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY        CALL FLES (IAIN,ISKP(31),3H2IE,9Hfrom,to?$)
      ENDIF
      IF (IT1.LE.0 .OR. IT2.GT.NATDM) GO TO 560
      IF (IT1-IT2) 570,999,560
  560 IERR=24 0560 16
      GO TO 999
C
  570 I=IT1
  580 J=I
      I=I+1
      IF (NTYP .EQ. 6 .AND. JAT(7,I,NS) .EQ. JELEMH) GO TO 710
      DO  K=1,8
        JATS(K)=JAT(K,I,NS)
      ENDDO
      JATS(9)=ICLRP(I,NS)
      JATS(10)=IPFLG(I,NS)
      DO  J1=1,3
        DO  J2=1,3
          C(J1,J2)=TFVKT(J1,J2,I,NS)
        ENDDO
      ENDDO
      GO TO 640
C
  620 DO  K=1,8
        JAT(K,J+1,NS)=JAT(K,J,NS)
      ENDDO
      ICLRP(J+1,NS)=ICLRP(J,NS)
      IPFLG(J+1,NS)=IPFLG(J,NS)
      DO  J1=1,3
        DO  J2=1,3
          TFVKT(J1,J2,J+1,NS)=TFVKT(J1,J2,J,NS)
        ENDDO
      ENDDO
      J=J-1
      IF (J .LT. IT1) GO TO 690
  640 IF (NTYP-6) 660,650,675
  650 IF (JAT(7,J,NS)-JELEMH) 680,620,680
  660 IF (LCOMPS(JATS(7),1,4, JAT(7,J,NS),1)) 620,670,680
  670 IF (LCOMPS(JATS(6),1,4, JAT(6,J,NS),1)) 620,680,680
  675 IF (JATS(9)-ICLRP(J,NS)) 620,680,680
  680 IF (J+1-I) 690,710,690
  690 DO  K=1,8
        JAT(K,J+1,NS)=JATS(K)
      ENDDO
      ICLRP(J+1,NS)=JATS(9)
      IPFLG(J+1,NS)=JATS(10)
      DO  J1=1,3
        DO  J2=1,3
          TFVKT(J1,J2,J+1,NS)=C(J1,J2)
        ENDDO
      ENDDO
  710 IF (I-IT2) 580,300,300
C                            UL - Loesche Umsortierliste.
C                            UA - Addiere in Liste.
C                            US - Umsortieren stillgelegt
C
C                       SRTL - Sortiere nach Liste
C
 1000 IF (ISKP(14) .EQ. 0) THEN
        IT1=ISKP(53)
        IT2=NAT(NS)
        DO  J=3,20
          IAIN(J)=0
        ENDDO
        CALL FLES (IAIN,IAIN(31),21H2JAAAAAAAAAAAAAAAAAAE,
CYENG1
     1   16Hvon,bis,s1,...?$)
CYENG2
CYENGY     1   16Hfrom,to,s1,...?$)
      ENDIF
      IF ((IT1 .LE. 0) .OR. (IT2 .GT. NAT(NS)) .OR. (IT1 .GT. IT2)) THEN
        IERR=24 1040 16
        GO TO 999
      ENDIF
C                       Baue Liste ggf. selber auf
C
      IF (IAIN(3) .EQ. 0) THEN
        J2=2
        DO  J=IAIN(1),IAIN(2)
          AIN(21)=AT(7,J,NS)
c          CALL CNVTUP(AIN(21),1,4)
          DO  I=3,J2
            IF (IAIN(I) .EQ. IAIN(21)) GO TO 1010
          ENDDO
          IF (J2 .LT. 20) THEN
            J2=J2+1
            IAIN(J2)=IAIN(21)
          ELSE
            IERR=24 0327 20
            GO TO 999
          ENDIF
 1010     CONTINUE
        ENDDO
      ENDIF
      DO  J=3,20
        IF (IAIN(J) .EQ. 0) GO TO 1020
        CALL CNVTUP (IAIN(J),1,4)
      ENDDO
      J=21
 1020 J=J-1
C
C                          Sortiere Liste um
      ISKP(32)=J
      L=2
 1130 L=L+1
 1140 I=IT1
 1150 AIN(29)=AT(7,I,NS)
c      CALL CNVTUP (AIN(29),1,4)
      IF (IAIN(29) .NE. IAIN(L)) GO TO 1220
      IF (I .LE. IT1) THEN
        IT1=IT1+1
        IF (IT1 .LE. IT2) GO TO 1140
        GO TO 999
      ENDIF
C
      DO  J=1,8
        ATSV(J)=AT(J,I,NS)
      ENDDO
      ITEMP=ICLRP(I,NS)
      JTEMP=IPFLG(I,NS)
      DO  J1=1,3
        DO  J2=1,3
          C(J1,J2)=TFVKT(J1,J2,I,NS)
        ENDDO
      ENDDO
      K=I
 1185 DO  J=1,8
        AT(J,K,NS)=AT(J,K-1,NS)
      ENDDO
      ICLRP(K,NS)=ICLRP(K-1,NS)
      IPFLG(K,NS)=IPFLG(K-1,NS)
      DO  J1=1,3
        DO  J2=1,3
          TFVKT(J1,J2,K,NS)=TFVKT(J1,J2,K-1,NS)
        ENDDO
      ENDDO
      K=K-1
      IF (K .GT. IT1) GO TO 1185
      DO  J=1,8
        AT(J,K,NS)=ATSV(J)
      ENDDO
      ICLRP(K,NS)=ITEMP
      IPFLG(K,NS)=JTEMP
      DO  J1=1,3
        DO  J2=1,3
          TFVKT(J1,J2,K,NS)=C(J1,J2)
        ENDDO
      ENDDO
      IT1=IT1+1
C
 1220 I=I+1
      IF (I .LE. IT2) GO TO 1150
      IF (L .LT. ISKP(32)) GO TO 1130
      GO TO 999
C
  950 IF (ISKP(14)) 999,990,999
C
  990 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
  999 RETURN
      END
