C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         79              -----------------
                           SUBROUTINE ZVST
C  CY-ENG-                -----------------
C
C  Programm zur eingabe einer symmetrie in form von typ,nr,...
C
C                geschrieben: 200817 aug 1997  (Hundt)
C                   geaendert: 141442 APR 2000  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),I,J,K
      REAL    *4 RM(3,3),TEMP,TEMP2
      EQUIVALENCE (AIN(1),IAIN(1))
C
C                            Option STA
      IF (NTYP .EQ. 2) THEN
        CALL FLES (ISKP(62),ISKP(31),2HIE,
CYENG1
     1  36H1/0: ST-Symmetrie addieren ja/nein?$)
CYENG2
CYENGY     1  30H1/0: Add ST symmetrie yes/no?$)
        GO TO 999
      ENDIF
C                            ST
C
      IF (ISKP(14) .EQ. 0) THEN
        DO  I=11,21
          IAIN(I)=0
        ENDDO
        IAIN(12)=1
CYENG1
        CALL FLES (IAIN(11),ISKP(31),5H5I6FE,22Htyp,nr,achse,pkt,hub?$)
CYENG2
CYENGY        CALL FLES (IAIN(11),ISKP(31),5H5I6FE,22Htype,no,axis,pnt,gld?$)
      ENDIF
      IAIN(10)=ABS(IAIN(11))
      IF (IAIN(10) .EQ. 0 .OR. IAIN(10) .EQ. 5 .OR. IAIN(10) .GT. 6
     +  .OR. IAIN(12) .EQ. 0) THEN
        IERR=79002716
        GO TO 999
      ENDIF
C                            Wenn /type/ 1 ist, definiere eine eigene
C                            Achse.
C
      IF (IAIN(10) .EQ. 1) THEN
        IAIN(13)=1
        IAIN(14)=0
        IAIN(15)=0
      ELSE
        TEMP=FLOAT(IAIN(12))
        DO  I=1,3
          TEMP2=AIN(I+18)*TEMP
          GO TO 20
   10     TEMP2=TEMP2+1.
   20     IF (TEMP2) 10,60,40
   30     TEMP2=TEMP2-1.
   40     IF (TEMP2-.99999) 50,30,30
   50     IF (TEMP2 .LT. 0.) TEMP2=0.
   60     AIN(I+21)=TEMP2
        ENDDO
      ENDIF
C                            Erzeuge neuen punkt.
C
      IF (NAT(NS) .GE. NATDM) THEN
        IERR=79004102
        GO TO 999
      ENDIF
      NAT(NS)=NAT(NS)+1
      DO  I=1,3
        AT(I,NAT(NS),NS)=AIN(I+15)
      ENDDO
C                            Speichere koordinatensystem.
      NTYP=19
      CALL ZVK
C                            Definiere eine neues koordinatensystem.
      ICDS(1)=NAT(NS)
      ICDS(2)=NAT(NS)
      ICDS(3)=NAT(NS)*200000+((IAIN(13)*10+IAIN(14))*10+
     + IAIN(15)+555)*200+1
      ICDS(4)=0
      ISKP(31)=3
      ISKP(14)=1
      NTYP=1
      CALL ZVK
      ISKP(14)=0
      IF (IERR .NE. 0) GO TO 990
C
C                            Rotationsmatrix.
C
      IF (IAIN(10) .EQ. 1) THEN
        TEMP=0.
      ELSE
        TEMP=FLOAT(IAIN(12))*CONST(2)/FLOAT(IAIN(10))
      ENDIF
      DO  I=2,3
        RM(1,I)=0.
        RM(I,1)=0.
      ENDDO
      RM(1,1)=1.
      TEMP2=COS(TEMP)
      RM(2,2)=TEMP2
      RM(3,3)=TEMP2
      TEMP2=SIN(TEMP)
      RM(2,3)=-TEMP2
      RM(3,2)=TEMP2
      IF (IAIN(11) .LT. 0 .AND. MOD(IAIN(12),2) .NE. 0) THEN
        DO  I=1,3
          DO  J=1,3
            RM(I,J)=-RM(I,J)
          ENDDO
        ENDDO
      ENDIF
C                            Berechne den rotationsanteil.
      DO  I=1,3
        DO  J=1,3
          X(I,J)=RM(I,1)*TRA(1,J,NS)+RM(I,2)*TRA(2,J,NS)+
     +    RM(I,3)*TRA(3,J,NS)
        ENDDO
      ENDDO
      DO  I=1,3
        DO  J=1,3
          S(I,J)=TRAINV(I,1,NS)*X(1,J)+TRAINV(I,2,NS)*X(2,J)+
     +    TRAINV(I,3,NS)*X(3,J)
        ENDDO
        T(I)=0.
      ENDDO
C
      IF (IAIN(11) .EQ. -2 .OR. IAIN(11) .GT. 0) THEN
        IF (ABS(AIN(22))+ABS(AIN(23))+ABS(AIN(24)) .NE. 0) THEN
C
C                            Teste gleitkomponente auf gueltigkeit.
          DO  I=1,3
            X1(I)=TRA(I,1,NS)*AIN(22)+TRA(I,2,NS)*AIN(23)+
     +      TRA(I,3,NS)*AIN(24)
          ENDDO
          IF (IAIN(11) .EQ. -2) THEN
            IF (ABS(X1(1)) .GT. CONST(21)) THEN
              WRITE (WRLINE,'(A,3F10.5)')
CYENG1
     +        'ZVST0116 - Gleitkomponente nicht in der Spiegelebene:',
CYENG2
CYENGY     +        'ZVST0123 - Glide vector not parallel to mirror plane:',
     +        X1
              CALL KPWRTE (NTDISP)
              IERR=-1
              GO TO 130
            ENDIF
          ELSE
            IF (IAIN(11) .GT. 1) THEN
              IF (ABS(X1(2))+ABS(X1(3)) .GT. CONST(21)) THEN
                WRITE (WRLINE,'(A,A,3F10.5)')
CYENG1
     +          'ZVST0125 - Schraubrichtung nicht Richtung ',
     +          'der Drehachse.',X1
CYENG2
CYENGY     +          'ZVST0125 - Screw direction not parallel ',
CYENGY     +          'to rotation axis.',X1
                CALL KPWRTE (NTDISP)
                IERR=-1
                GO TO 130
              ENDIF
            ENDIF
          ENDIF
          DO  I=1,3
            T(I)=AIN(I+21)
          ENDDO
  130     CONTINUE
        ENDIF
      ENDIF
      IF (IAIN(11) .NE. 1) THEN
        DO  I=1,3
          X1(I)=AIN(I+15)
        ENDDO
        DO  I=1,3
          T(I)=T(I)+X1(I)-S(I,1)*X1(1)-S(I,2)*X1(2)-S(I,3)*X1(3)
        ENDDO
      ENDIF
C                            Hinterlege Ergebnis in KPTSY.
      K=16
      DO  I=1,3
        K=K+1
        AIN(K)=T(I)
        DO  J=1,3
          K=K+1
          AIN(K)=S(I,J)
        ENDDO
      ENDDO
      NTYP=3
      CALL ZVTSY
      IF (ISKP(62) .EQ. 0) GO TO 990
C
C                            Normiere translationsvektor
      DO  I=17,25,4
        GO TO 150
  140   AIN(I)=AIN(I)+1.
  150   IF (AIN(I) .LT. 0.) GO TO 140
        GO TO 170
  160   AIN(I)=AIN(I)-1.
  170   IF (AIN(I) .GE. 0.9999) GO TO 160
        IF (AIN(I) .LT. 0.) AIN(I)=0.
      ENDDO
      IF (NSYM(NS) .GE. NSYMDM) THEN
        IERR=79 0169 03
        GO TO 990
      ENDIF
      NSYM(NS)=NSYM(NS)+1
      DO  I=1,12
        SYM(I,NSYM(NS),NS)=AIN(I+16)
      ENDDO
      NHMSNR(1,NS)=ISKP(24)
      NHMSNR(2,NS)=ISKP(24)
      NHMSNR(3,NS)=0
C                            Restore koordinatensystem.
  990 NTYP=20
      CALL ZVK
      NAT(NS)=NAT(NS)-1
C
  999 RETURN
      END
