C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                      -------------------------
                        FUNCTION ZVTBDG(DTESTQ)
C                      -------------------------
C
C--- Die funktion KPTBDG testet, ob zwischen den atomen mit den
C    codes ICDS(1) und ICDS(2) eine bindung (laut plotbefehlen)
C    besteht. In diesem fall wird der funktionswert auf 1 ge-
C    setzt, andernfalls auf 0.
C
C                geschrieben: 181458 FEB 2000  (Hundt)
C
C                          -----------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
C
      INTEGER *4 ZVTBDG,IPKPNT,IPLTBF,I,J,NR1,NR2
      REAL    *4 VQ(IPKDIM,2),DMAX,DTESTQ
      EQUIVALENCE (IPK(1,1),VQ(1,1))
C
C                            Berechne nummern ...
C
      IF (ICDS(1) .LT. NAT(NS)) THEN
      NR1=ICDS(1)
      ICDS(1)=ICDS(1)*200000+111001
      ELSE
      NR1=ICDS(1)/200000
      ENDIF
      IF (ICDS(2) .LT. NAT(NS)) THEN
      NR2=ICDS(2)
      ICDS(2)=ICDS(2)*200000+111001
      ELSE
      NR2=ICDS(2)/200000
      ENDIF
C                          ... und suche einen geeigneten plotbefehl.
      IPKPNT=1
      GO TO 720
  660 IPLTBF=IPK(IPKPNT+1,NS)
      IF (IPLTBF .GE. 2 .AND. IPLTBF .LE. 4) THEN
C
C                          Bindung auf verbotsliste?
      DO  I=1,NPPOI(NS),2
        IF ((ICDS(2) .EQ. NPLST(I,NS) .AND. ICDS(1) .EQ. NPLST(I+1,NS))
     +  .OR.(ICDS(2) .EQ. NPLST(I+1,NS) .AND. ICDS(1) .EQ. NPLST(I,NS)))
     +  GO TO 730
      ENDDO
C                          Nummern korrekt?
C
        IF ((NR1 .GE. IPK(IPKPNT+2,NS) .AND.
     +       NR1 .LE. IPK(IPKPNT+3,NS) .AND.
     +       NR2 .GE. IPK(IPKPNT+4,NS) .AND.
     +       NR2 .LE. IPK(IPKPNT+5,NS)) .OR.
     +      (NR2 .GE. IPK(IPKPNT+2,NS) .AND.
     +       NR2 .LE. IPK(IPKPNT+3,NS) .AND.
     +       NR1 .GE. IPK(IPKPNT+4,NS) .AND.
     +       NR1 .LE. IPK(IPKPNT+5,NS))) THEN
C
C                          Stimmt der Abstand?
          DMAX=VQ(IPKPNT+7,NS)
          IF (DTESTQ .GT. DMAX*DMAX) GO TO 710
          IF (DTESTQ .LT. VQ(IPKPNT+6,NS)*VQ(IPKPNT+6,NS)) GO TO 710
          GO TO 700
        ENDIF
        GO TO 710
      ENDIF
      IF (IPLTBF .GE. 12 .AND. IPLTBF .LE. 14) THEN
C
C                          Verbinde direkt.  Teste, ob Paar
C                          im Befehl vorkommt.
        J=IPK(IPKPNT,NS)
        I=5
  670   IF (IPK(IPKPNT+I,NS) .EQ. ICDS(1)) GO TO 690
  680   I=I+1
        IF (I .LT. J) GO TO 670
        GO TO 710
C
  690   IF (IPK(IPKPNT+I+1,NS) .EQ. ICDS(2)) GO TO 700
        IF (IPK(IPKPNT+I-1,NS) .NE. ICDS(2)) GO TO 680
        GO TO 700
      ENDIF
      GO TO 710
C                          Nimm code auf, wenn noch moeglich.
C
  700 ZVTBDG=1
      GO TO 999
C
  710 IPKPNT=IPKPNT+IPK(IPKPNT,NS)
  720 IF (IPKPNT .LT. IPKP(NS)) GO TO 660
  730 ZVTBDG=0
C
  999 RETURN
      END
