C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         87     --------------------------------------
                  SUBROUTINE ZVTEAC (IZAEHL,IRCHT,IRC)
C CY-ENG-        --------------------------------------
C
C  Es wird getestet, ob die angegebene richtung mit der angegebenen
C  zaehligkeit fuer die symmetriesuche erlaubt ist.
C
C                geschrieben: 221030 JUL 1999  (Hundt)
C                --------------------------------------
C
      IMPLICIT NONE
      INTEGER *4 IRCHT,IZAEHL,IRC
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 ITDIM
      PARAMETER (ITDIM=39)
      INTEGER *4 ITAB(ITDIM),IPOI,I,KDA,KDE,KDL
      REAL    *4 TOL
      SAVE ITAB,IPOI
      DATA TOL/0.1/,KDA/4HA   /,KDE/4HE   /,KDL/4HL   /
C
      IF (IRC .EQ. 0) THEN
        IRC=1
        IF (IPOI .LE. 0) GO TO 999
        NC=1
        NTRY=26
        ICDS(1)=400001+IRCHT*200
        CALL ZVDEK
        DO  I=1,3
          X2(I)=X1(I)
        ENDDO
        NC=2
        DO  I=1,IPOI,3
          ICDS(2)=400001+ITAB(I+1)*200
          CALL ZVDEK
          IF (ITAB(I) .EQ. 1) THEN
            IF (ABS(X1(2)*X2(3)-X1(3)*X2(2))+
     +      ABS(X1(3)*X2(1)-X1(1)*X2(3))+
     +      ABS(X1(1)*X2(2)-X1(2)*X2(1)) .LT. TOL .AND.
     +      IZAEHL .LE. ITAB(I+2)) GO TO 999
          ELSE
            IF (ABS(X1(1)*X2(1)+X1(2)*X2(2)+X1(3)*X2(3)) .LT. TOL .AND.
     +      IZAEHL .LE. ITAB(I+2)) GO TO 999
          ENDIF
        ENDDO
        IRC=0
      ELSE
        IF (IRC .LT. 0) THEN
CYENG1
          WRITE (WRLINE,'(A)') 'Ausgzeichnete Richtungen:'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') 'Directions selected:'
          CALL KPWRTE (NTOUT)
          DO  I=1,IPOI,3
            ICDS(1)=KDA
            IF (ITAB(I) .EQ. 2) ICDS(1)=KDE
            WRITE (WRLINE,'(A,I5,I3)') ICDS(1),ITAB(I+1),ITAB(I+2)
            CALL KPWRTE (NTOUT)
          ENDDO
          CALL FLES (ICDS,ISKP(31),1HE,2H?$)
          GO TO 999
        ENDIF
C                            Speicher fuellen / leeren.
C
        IF (ISKP(14) .EQ. 0) THEN
          ICDS(3)=6
          CALL FLES (ICDS,ISKP(31),4HA2IE,
CYENG1
     +    39HA/E/L, Richtung, max. Zaehligkeit [6]?$)
CYENG2
CYENGY     +    31HA/E/L, direction, max no. [6]?$)
          CALL CNVTUP (ICDS,1,4)
        ELSE
          ISKP(14)=0
          ICDS(1)=KDL
        ENDIF
        IF (ICDS(1) .EQ. KDL) THEN
          IPOI=-2
          GO TO 999
        ENDIF
        IC=0
        IF (ICDS(1) .EQ. KDA) IC=1
        IF (ICDS(1) .EQ. KDE) IC=2
        IF (IC .EQ. 0 .OR. ICDS(2) .LT. 111 .OR. ICDS(2) .GT. 999) THEN
          IERR=87 0062 16
          GO TO 999
        ENDIF
        IF (IPOI .GT. ITDIM-3) THEN
          IERR= 87 0066 20
          GO TO 999
        ENDIF
        IPOI=IPOI+3
        ITAB(IPOI)=IC
        ITAB(IPOI+1)=ICDS(2)
        ITAB(IPOI+2)=ICDS(3)
      ENDIF
  999 RETURN
      END
