C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         78              -------------------
                           SUBROUTINE ZVTSZR
C  CY-ENG                 -------------------
C
C  Sucht in der elementarzelle nach weiteren rationalen
C  translationssymmetrien und fuegt sie als atome in der
C  parameterliste an.
C
C  NTYP=1  TSZ -  Translationssymmetrie suchen
C  NTYP=2         dito, input ueber AIN
C  NTYP=3  RDZ -  Reduziere Zelle
C  NTYP=4         Save symmetrieliste und bringe translationen nach vorn
C  NTYP=5         Restore symmetrieliste
C  NTYP=6  ITS    Importiere Translationssymmetrien
C  NTYP=7  (ITS)  ohne input
C  NTYP=8  (RDZ)  ohne input
C  NTYP=9  (RDZ)  ohne input und nur bis zur berechnung der t-matrix
C
C                 geschrieben: 240947 FEB 1999 (Hundt)
C                   geaendert: 151358 APR 2016 (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C                            Grenze fuer 1/n
      INTEGER *4 ITKDIM
      PARAMETER (ITKDIM=22)
      INTEGER *4 IAIN(72),I,J,K,L,IAIM(7),NCDSV,IAT(8,PARDIM,2)
      INTEGER *4 NTYPS,IBUT,ITK(3),ITKP(3),ITKPOI,IDURCH,ITKMAY(3)
      INTEGER *4 ITCNT,ITKLIM(7),ITKMAX,NSSTRT,NSYMSV,IV,IB,IZEN(4)
      REAL    *4 AIM(7),TK(3,ITKDIM),TEMP,TVV(3),TV(3),ABWX,ABWXX
      REAL    *4 ABWT,TKAND(21),SVGL(12),TOL,TEMP2,AL(3),ZM
      REAL    *4 SYMSAV(12,PARDIM/2)
      EQUIVALENCE (AIN(1),IAIN(1)),(AIM(1),IAIM(1))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1),SYMSAV(1,1)),(ISKP(77),ITCNT)
      SAVE NSSTRT,NSYMSV,IV,IB
      DATA IBUT/4HT   /,ITKLIM/1,3,5,9,11,17,21/,TOL/0.001/
      DATA (TKAND(I),I=1,21)/0.5,0.3333333,0.6666667,0.25,0.75,0.2,
     1 0.4,0.6,0.8,0.1666667,0.8333333,0.1428571,0.2857143,0.4285714,
     2 0.5714286,0.7142857,0.8571429,0.125,0.375,0.625,0.875/
      DATA SVGL/2.,1.,0.,0., 2.,0.,1.,0., 2.,0.,0.,1./,IV/1/,IB/0/
C
      NTYPS=NTYP
      GO TO (10,20,140,141,161,190,190,140,140),NTYPS
C             1  2   3   4   5   6   7   8   9
C                            TSZ - Translationssymetrie in zelle
   10 IAIM(1)=ISKP(53)
      IAIM(2)=NAT(NS)
      IAIM(3)=0
      AIM(4)=.25
      IAIM(5)=4
      CALL FLES (AIM,ISKP(31),6H2JAFIE,
CYENG1
     +28Hvon,bis,symb, tol[A],n[4]? $)
CYENG2
CYENGY     +28Hfrom,to,symb, tol[A],n[4]? $)
      GO TO 30
   20 DO  I=1,5
        IAIM(I)=IAIN(I)
      ENDDO
C
   30 IV=NAT(NS)+1
      IB=NAT(NS)
      IF (IAIM(1) .LE. 0 .OR. IAIM(2) .GT. NAT(NS) .OR.
     +  IAIM(1) .GT. IAIM(2)) THEN
        IERR=78 0065 16
        GO TO 999
      ENDIF
      ITKMAX=IAIM(5)-1
      IF (ITKMAX .LT. 1) ITKMAX=1
      IF (ITKMAX .GT. 7) ITKMAX=7
      K=ITKMAX
      ITKMAX=ITKLIM(ITKMAX)
C                            Toleranzen in gittereinheiten
      AIM(7)=AIM(4)*AIM(4)
      TEMP=AIM(4)
      DO  I=1,3
        AIM(I+3)=TEMP*RK(I,NS)
        ITKMAY(I)=ITKMAX
        DO  J=3,K
          IF ((1./FLOAT(J)-1./FLOAT(J+1)) .LE. AIM(I+3)) THEN
            ITKMAY(I)=ITKLIM(J)
            GO TO 35
          ENDIF
        ENDDO
   35   CONTINUE
      ENDDO
C                            Erzeuge inhalt einer elementarzelle.
      IAIN(1)=IAIM(1)
      IAIN(2)=IAIM(2)
      NTYP=3
      CALL ZVZLIN
      IF (IERR .NE. 0) GO TO 999
C
C                            Merke die zahl und ergaenze einen
C                            Randstreifen.
      NCDSV=NCD(NS)
      IF (IAIM(3) .EQ. 0) IAIM(3)=IAT(7,IAIM(1),NS)
      NAT(NS)=NAT(NS)+1
      DO  I=4,6
        AIN(I)=0.5001+AIM(I)
        AT(I,NAT(NS),NS)=0.5
      ENDDO
      IAIN(1)=NAT(NS)
      IAIN(2)=IAIM(1)
      IAIN(3)=IAIM(2)
      ISKP(14)=1
      NTYP=1
      CALL ZVAVBR
      NAT(NS)=NAT(NS)-1
      IF (IERR .NE. 0) GO TO 999
C
C                            Uebertrage die namen der atome in grosz-
C                            buchstaben dahinter.
C
      IF (2*NCD(NS) .GT. NCDDM) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVTSZR0089 - Unzureichende Arbeitsflaeche.'
CYENG2
CYENGY     +  'ZVTSZR0091 - Insufficient work space.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      DO  IC=1,NCD(NS)
        J=IAT(7,ICD(IC,NS)/200000,NS)
        ICD(IC+NCD(NS),NS)=J
      ENDDO
C                            Lege eine liste mit kandidaten fuer
C                            translationsvektorkomponenten an.
      DO  I=1,3
        TK(I,1)=0.
        ITK(I)=1
        ITKP(I)=1
        TVV(I)=0.
      ENDDO
      ITKPOI=3
      DO  I=1,3
        DO  J=1,ITKMAY(I)
          TEMP=TKAND(J)
          TK(I,J+1)=0.
          DO  K=1,NCDSV
            IF (ICD(K+NCD(NS),NS) .EQ. IAIM(3)) THEN
              DO  L=1,NCD(NS)
                IF (ICD(L+NCD(NS),NS) .EQ. IAIM(3)) THEN
                  IF (ABS(ABS(ATOMS(I,K,NS)-ATOMS(I,L,NS))-TEMP) .LE.
     +              AIM(I+3)) THEN
                    ITKP(I)=ITKP(I)+1
                    TK(I,ITKP(I))=TEMP
                    GO TO 40
                  ENDIF
                ENDIF
              ENDDO
            ENDIF
          ENDDO
   40     CONTINUE
        ENDDO
      ENDDO
C
      IF (ISKP(58) .GT. 1) THEN
        K=MAX0(ITKP(1),ITKP(2),ITKP(3))
        DO  I=1,K
          WRITE (WRLINE,'(I2,A,3F10.5)') I,')',(TK(J,I),J=1,3)
          CALL KPWRTE (NTDISP)
        ENDDO
      ENDIF
C                            Haenge jetzt die gefundenen vektoren
C                            positiv und negativ an alle atome
C                            der ausgangsmenge.
      ITCNT=0
C
C                            Konstruiere (naechsten) vektor.
C
   50 ITK(ITKPOI)=ITK(ITKPOI)+1
      IF (ITK(ITKPOI) .LE. ITKP(ITKPOI)) THEN
   60   TVV(ITKPOI)=TK(ITKPOI,ITK(ITKPOI))
        IF (ITKPOI .LT. 3) THEN
          ITKPOI=ITKPOI+1
          ITK(ITKPOI)=1
          GO TO 60
        ENDIF
      ELSE
        ITKPOI=ITKPOI-1
        IF (ITKPOI .GT. 0) GO TO 50
        GO TO 130
      ENDIF
C                            Im fall eines slabs teste, ob wir
C                            diesen vektor ueberhaupt wollen.
C
      IF (ISKP(95) .NE. 0 .AND. TVV(3) .NE. 0) GO TO 50
      DO  I=1,3
        TV(I)=TVV(I)
      ENDDO
      ABWX=0.
      DO  IDURCH=1,2
        DO  J=1,NCD(NS)
          DO  I=1,3
            T(I)=ATOMS(I,J,NS)+TV(I)
            GO TO 80
   70       T(I)=T(I)+1.
   80       IF (T(I) .LT. 0.0) GO TO 70
            GO TO 100
   90       T(I)=T(I)-1.
  100       IF (T(I) .GT. 0.9999) GO TO 90
          ENDDO
C                            Teste, ob sich an der stelle T
C                            ein atom gleichen namens befindet.
          DO  K=1,NCD(NS)
            DO  I=1,3
              ABWT=ABS(ATOMS(I,K,NS)-T(I))
              X1(I)=ABWT
              IF (ABWT .GT. AIM(I+3)) GO TO 110
            ENDDO
            DO  I=1,3
              X2(I)=DG(I,1,NS)*X1(1)+DG(I,2,NS)*X1(2)+DG(I,3,NS)*X1(3)
            ENDDO
            ABWXX=X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3)
            IF (ABWXX .GT. AIM(7)) GO TO 110
C
C                            Teste, ob fremdatome toleriert werden.
C
            IF (ICD(NCD(NS)+J,NS) .NE. ICD(NCD(NS)+K,NS)) THEN
              IF (ISKP(76) .EQ. 0) GO TO 50
              GO TO 110
            ENDIF
            IF (K .EQ. J) GO TO 50
C
C                            Gefunden, wenn hier. Naechstes atom.
C
            IF (ABWXX .GT. ABWX) ABWX=ABWXX
            GO TO 120
  110       CONTINUE
          ENDDO
C                            Kein atom gefunden. Naechster vektor.
          GO TO 50
  120     CONTINUE
        ENDDO
C                            Naechster durchgang. Teste jetzt den
C                            vektor in der anderen richtung.
        DO  I=1,3
          TV(I)=-TVV(I)
        ENDDO
      ENDDO
C                            Gueltigen vektor gefunden. Speichere,
C                            falls noch moeglich.
C
      IF (NAT(NS) .GE. NATDM) THEN
        IERR=78 0231 04
        GO TO 999
      ENDIF
      NAT(NS)=NAT(NS)+1
      ITCNT=ITCNT+1
      DO  I=1,3
        AT(I,NAT(NS),NS)=TVV(I)
      ENDDO
      AT(4,NAT(NS),NS)=SQRT(ABWX)
      IAT(5,NAT(NS),NS)=IBUT
      IAT(6,NAT(NS),NS)=IBUT
      I=0
      CALL KPNTOS (ITCNT,AT(6,NAT(NS),NS),I,0)
      IAT(7,NAT(NS),NS)=IAT(5,NAT(NS),NS)
      ICLRP(NAT(NS),NS)=0
      IPFLG(NAT(NS),NS)=0
      IB=NAT(NS)
      GO TO 50
C
  130 CONTINUE
      IF (NTYPS .EQ. 1) THEN
CYENG1
        WRITE (WRLINE,'(I3,A)') ITCNT,' Translationen gefunden.'
CYENG2
CYENGY        WRITE (WRLINE,'(I3,A)') ITCNT,' Translations found.'
        CALL KPWRTE (NTDISP)
      ENDIF
      GO TO 995
C                            RDZ - Reduziere Zelle
  140 IF (NAT(NS) .LT. 2) THEN
        IERR=78 0260 08
        GO TO 999
      ENDIF
      IF (ABS(AT(1,2,NS))+ABS(AT(2,2,NS))+ABS(AT(3,2,NS)) .GT. TOL) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVTSZR0251 - Ungueltige Koordinaten von Atom 2.'
CYENG2
CYENGY     +  'ZVTSZR0251 - Invalid coordinates of atom 2.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      IF (NSYM(NS) .LT. 1) THEN
        IERR=78 0290 05
        GO TO 999
      ENDIF
C                            Save die symmetrieliste und
C                            bringe zentrierungssymmetrien in der
C                            symmetrieliste nach vorn.
  141 NSSTRT=(PARDIM-1)/2-NSYMDM
      IF (2*NSSTRT .LE. NAT(NS)+1) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVTSZR0268 - Unzureichende Arbeitsflaeche.'
CYENG2
CYENGY     +  'ZVTSZR0268 - Insufficient work space.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      K=NSSTRT
      DO  J=1,NSYM(NS)
        DO  I=1,12
          SYMSAV(I,K)=SYM(I,J,NS)
        ENDDO
        K=K+1
      ENDDO
      NSYMSV=NSYM(NS)
C                            ... und bringe zentrierungssymmetrien
C                            in der symmetrieliste nach vorn.
      K=0
      DO  J=1,NSYM(NS)
        DO  I=1,12
          IF (SVGL(I) .LT. 1.5) THEN
            IF (ABS(SYM(I,J,NS)-SVGL(I)) .GT. TOL) GO TO 150
          ENDIF
        ENDDO
        K=K+1
        DO  I=1,12
          SYM(I,K,NS)=SYM(I,J,NS)
        ENDDO
        IF (NTYPS .EQ. 9) THEN
          IF (K .LE. 4) THEN
            IZEN(K)=J
          ELSE
            WRITE (WRLINE,'(A)')
CYENG1
     +      'ZVTSZR0334 - Mehr als 4 Zentrierungen.'
CYENG2
CYENGY     +      'ZVTSZR0334 - More than 4 centerings.'
          CALL KPWRTE (NTDISP)
            IERR=-1
            GO TO 999
          ENDIF
        ENDIF
  150   CONTINUE
      ENDDO
      NSYM(NS)=K
      IF (NTYPS .EQ. 4) GO TO 999
C
C                            Generiere punkte.
      NCD(NS)=0
      K8(NS)=0
      K9(NS)=0
C                            KS
      ISKP(14)=1
      NTYP=3
      CALL ZVZ
      ICDS(1)=2
      IZ1=2
      IZ2=2
      DQ=AMAX1(ZELLE(1,NS),ZELLE(2,NS),ZELLE(3,NS))+0.1
      ZM=DQ
      NTYP=3
      ISKP(14)=-2
      CONST(20)=0.
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 990
C
C                            Suche die zwei kuerzesten nicht
C                            koplanaren vektoren heraus.
      NC=0
      NTRY=26
      DO  IC=1,NCD(NS)
        NC=NC+1
        ICDS(NC)=ICD(IC,NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 990
        DO  I=1,3
          X(I,NC)=X1(I)
        ENDDO
        TEMP=X1(1)*X1(1)+X1(2)*X1(2)+X1(3)*X1(3)
        IF (TEMP .LT. TOL) THEN
          NC=NC-1
          ICD(IC,NS)=0
          GO TO 160
        ELSE
          TEMP=SQRT(TEMP)
        ENDIF
C
C                            Teste jetzt, ob dieser vektor parallel
C                            zu einem bereits vorhandenen ist.
        DO  I=1,NC-1
          TEMP2=(X1(1)*X(1,I)+X1(2)*X(2,I)+X1(3)*X(3,I))/(TEMP*AL(I))
          IF (ABS(1.-ABS(TEMP2)) .LT. TOL) THEN
C
C                            Parallelen gefunden. Verdraenge ihn,
C                            falls kuerzer.
C
            IF (TEMP .LT. AL(I)) THEN
              DO  J=1,3
                X(J,I)=X1(J)
              ENDDO
              AL(I)=TEMP
              ICDS(I)=ICDS(NC)
            ENDIF
            NC=NC-1
            GO TO 160
          ENDIF
        ENDDO
C                            Keinen parallelen gefunden. Verdraenge
C                            ggf. den laengsten vorhandenen.
        IF (NC .GT. 2) THEN
          TEMP2=AL(1)
          J=1
          IF (TEMP2 .LT. AL(2)) THEN
            TEMP2=AL(2)
            J=2
          ENDIF
          IF (TEMP .LT. TEMP2) THEN
            DO  I=1,3
              X(I,J)=X1(I)
            ENDDO
            AL(J)=TEMP
            ICDS(J)=ICDS(NC)
          ENDIF
          NC=NC-1
        ELSE
          AL(NC)=TEMP
        ENDIF
  160   CONTINUE
      ENDDO
C                            Komprimiere codeliste.
      J=0
      DO  I=1,NCD(NS)
        IF (ICD(I,NS) .NE. 0) THEN
          J=J+1
          ICD(J,NS)=ICD(I,NS)
        ENDIF
      ENDDO
      NCD(NS)=J
C                            Vertausche die beiden vektoren,
C                            wenn der zweite kleiner ist.
C
      IF (AL(2) .LT. AL(1)) THEN
        I=ICDS(1)
        ICDS(1)=ICDS(2)
        ICDS(2)=I
      ENDIF
C                            Lege koordinatensystem in die
C                            beiden gefundenen vektoren.
      ICDS(3)=ICDS(1)
      ICDS(5)=ICDS(2)
      ICDS(1)=2
      ICDS(2)=2
      ICDS(4)=2
      NTYP=1
      ISKP(14)=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 999
      ICDS(1)=ICDS(3)
      ICDS(2)=ICDS(5)
C                            Suche den kuerzesten vektor mit
C                            positiver z-koordinate
      NTRY=44
      NC=7
      DO  IC=1,NCD(NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        IF (X2(3) .GT. 1.) THEN
          TEMP=SQRT(X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3))
          IF (TEMP .LT. ZM) THEN
            ICDS(3)=ICD(IC,NS)
            ZM=TEMP
          ENDIF
        ENDIF
      ENDDO
C                            Berechne transformationsmatrix.
      J=0
      NTRY=24
      DO  NC=1,3
        CALL ZVDEK
        DO  I=1,3
          J=J+1
          AIN(J)=X(I,NC)
        ENDDO
        IF (NTYPS .EQ. 9) ICDS(NC)=ICDS(NC)-ISYNR+IZEN(ISYNR)
      ENDDO
C                            Restore symmetrien.
  161 K=NSSTRT
      DO  J=1,NSYMSV
        DO  I=1,12
          SYM(I,J,NS)=SYMSAV(I,K)
        ENDDO
        K=K+1
      ENDDO
      NSYM(NS)=NSYMSV
      IF (NTYPS .EQ. 5) GO TO 999
      IF (NTYPS .EQ. 9) GO TO 995
C
C                            Transformiere jetzt die zelle.
      NTYP=2
      ISKP(14)=1
      CALL ZVZ
      IF (IERR .NE. 0) GO TO 999
C
C                            Entferne ueberschuessige symmetrien (EDS)
      NTYP=3
      CALL ZVGRTS
C                            Teste, ob die winkel geeignet sind.
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        IF (ZELLE(I+3,NS) .GE. 90. .AND. ZELLE(J+3,NS) .LT. 90.
     +    .AND. ZELLE(K+3,NS) .LT. 90.) THEN
          L=I
          GO TO 170
        ENDIF
        IF (ABS(ZELLE(I+3,NS)-90.) .LT. TOL .AND. ZELLE(J+3,NS) .GE. 90.
     +    .AND. ZELLE(K+3,NS) .LT. 90.) THEN
          L=J
          GO TO 170
        ENDIF
        IF (ABS(ZELLE(I+3,NS)-90.) .LT. TOL .AND. ZELLE(J+3,NS) .LT. 90.
     +    .AND. ZELLE(K+3,NS) .GE. 90.) THEN
          L=K
          GO TO 170
        ENDIF
        IF (ZELLE(I+3,NS) .GT. 90. .AND. ZELLE(J+3,NS) .GT. 90.
     +    .AND. ZELLE(K+3,NS) .LT. 90.) THEN
          L=K
          GO TO 170
        ENDIF
      ENDDO
      GO TO 180
C                       245501,254501,255401,255501+10*10**(4-L)
  170 ICDS(1)=491001
      ICDS(2)=509001
      ICDS(3)=510801
      ICDS(L)=511001+20*10**(4-L)
      NTYP=9
      ISKP(14)=1
      CALL ZVZ
  180 CONTINUE
      IF (NTYPS .EQ. 2 .OR. NTYPS .EQ. 6 .OR. NTYPS .EQ. 8) GO TO 995
      GO TO 990
C                            ITS - Importiere Zentrierungen
  190 L=NSYM(NS)
      DO  I=IV,IB
        DO  J=1,3
          AIN(J)=AT(J,I,NS)
        ENDDO
        NTYP=2
        ISKP(14)=1
        CALL ZVGRTS
        IF (IERR .NE. 0) THEN
          NSYM(NS)=L
          GO TO 990
        ENDIF
      ENDDO
      NAT(NS)=IV-1
      ISKP(14)=0
      NTYP=1
      IF (NTYPS .EQ. 7) NTYP=4
      CALL ZVRPSY
      NTYPS=6
      GO TO 140
C
  990 IF (NTYPS .NE. 7) CALL FLES (AIN,ISKP(31),1HE,2H?$)
  995 ISKP(14)=0
      NCD(NS)=0
      K8(NS)=0
      K9(NS)=0
  999 CONTINUE
      RETURN
      END
