C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C                         -------------------
                           SUBROUTINE ZVZLIN
C CY-ENG-                 -------------------
C
C--- Programm erzeugt inhalt einer elementarzelle (ohne rechten rand).
C
C  NTYP
C     1  AZIN
C     2  UC  (Vorhandene codes zaehlen)
C     3  Zellinhalt generieren
C     4  dto, aber mit zaehlen
C
C                 geschrieben: 071133 FEB 2000 (Hundt)
C                   geaendert: 171101 FEB 2005 (Hundt)
C
C                         -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 I,J,K,K1,MTRBUF(2),IAIN(72),NTYPS,IATNAM(2),NMIN,NAME
      INTEGER *4 IT1,IT2,N,NATSV
      REAL    *4 ATNAM(2)
C
      EQUIVALENCE (AIN(1),IAIN(1)),(ATNAM(1),IATNAM(1))
C
      NTYPS=NTYP
      IF (NTYP .EQ. 2) GO TO 15
      IF (NTYP .EQ. 1) THEN
        IAIN(1)=ISKP(53)
        IAIN(2)=NAT(NS)
CYENG1
        CALL FLES (AIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY        CALL FLES (AIN,ISKP(31),3H2IE,9Hfrom,to?$)
      ENDIF
C                            Pruefe parameter
      MTRBUF(1)=IAIN(1)
      MTRBUF(2)=IAIN(2)
      IF ((MTRBUF(1) .LE. 0) .OR. (MTRBUF(2) .GT. NAT(NS)) .OR.
     +  (MTRBUF(1) .GT. MTRBUF(2))) THEN
        IERR=04 0028 16
        GO TO 999
      ENDIF
      IF (NSYM(NS) .LE. 0) THEN
        IERR=04 0032 05
        GO TO 999
      ENDIF
      IF (NAT(NS) .GE. NATDM) THEN
        IERR=04 0036 04
        GO TO 999
      ENDIF
      NATSV=NAT(NS)
      NAT(NS)=NAT(NS)+1
      DO  I=1,3
        AT(I,NAT(NS),NS)=0.5
        AIN(I+3)=0.5
      ENDDO
      NCD(NS)=NCDA(NS)-1
      K8(NS)=0
      K9(NS)=0
C                            Setze ATB auf.
      IAIN(1)=NAT(NS)
      IAIN(2)=MTRBUF(1)
      IAIN(3)=MTRBUF(2)
      NTYP=1
      ISKP(14)=1
      CALL ZVAVBR
      NAT(NS)=NAT(NS)-1
      IF (IERR .NE. 0) GO TO 999
C
C                            Entferne jetzt die Atome, die eine
C                            koordinate von 1 oder groesser haben.
      IZ1=NCDA(NS)-1
      DO  I=NCDA(NS),NCD(NS)
        DO  J=1,3
          IF (ATOMS(J,I,NS) .GT. 0.99999) GO TO 10
        ENDDO
C                            Kopiere Atom
        IZ1=IZ1+1
        DO  J=1,3
          ATOMS(J,IZ1,NS)=ATOMS(J,I,NS)
        ENDDO
        ICD(IZ1,NS)=ICD(I,NS)
   10   CONTINUE
      ENDDO
      NCD(NS)=IZ1
      K8(NS)=IZ1
C                            Zaehle Atomsorten, wenn NTYPS .LE. 2
C
   15 IF (NTYPS .LE. 2 .OR. NTYPS .EQ. 4) THEN
        NMIN=100000
        IT1=1
        K1=0
        NC=1
        NTRY=32
   20   N=0
        IT2=1
        DO  IC=1,NCD(NS)
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
          ATNAM(IT2)=AT(7,IANR,NS)
          IF (IT2 .EQ. 1) THEN
            IATNAM(2)=IATNAM(1)
            DO  K=1,K1
              IF (IAIN(K) .EQ. IATNAM(1)) GO TO 30
            ENDDO
            IF (K1 .LT. 72) THEN
              K1=K1+1
              IAIN(K1)=IATNAM(1)
            ELSE
              IERR=04 0102 20
              GO TO 999
            ENDIF
            IT2=IT2+1
          ENDIF
          IF (IATNAM(1) .EQ. IATNAM(2)) N=N+1
   30     CONTINUE
        ENDDO
        IF (N .EQ. 0) THEN
          IAIN(1)=NAME
          GO TO 999
        ENDIF
        IF (NTYPS .NE. 4) THEN
          WRITE (WRLINE,'(A4,I5)') IATNAM(1),N
          CALL KPWRTE (NTOUT)
        ENDIF
        IF (N .LT. NMIN) THEN
          NMIN=N
          NAME=IATNAM(1)
        ENDIF
        GO TO 20
      ENDIF
  999 NTYP=NTYPS
      RETURN
      END
