C KPLOT - A Program for Plotting and Analyzing Crystal Structures 
C Copyright (C) 1979-2019 Rudolf Hundt 
C KPLOT is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
C as published by the Free Software Foundation, version 3.
C KPLOT is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
C without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C See the GNU General Public License for more details.
C You should have received a copy of the GNU General Public License
C along with this program.  If not, see https://www.gnu.org/licenses/
C Contact: Rudolf Hundt, University of Bonn Klaus Pleuger,
C Co-Programmer, mailto:k.pleuger@t-online.de
C
C         43             -------------------
                          SUBROUTINE ZVZNTR
C  CY-ENG-               -------------------
C
C              Kommando  NTYP  Bedeutung
C              ZZ          1   Finde zentren in zelle
C              -           2   Finde zentren in zelle (kein input)
C
C               geschrieben: 191458 JAN 1998  (Hundt)
C                 geaendert: 061127 SEP 2005  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 I,J,K,IZENTR,IAIN(72),INBFR(5),IATNAM(3)
      INTEGER *4 IBUZ,N1,N2,IX,IY,IZ,NATSV,KEYIN,NTYPS,L
      INTEGER *4 IAT(8,PARDIM,2)
      REAL    *4 V(3),W(3),TOL(3),ABWT,ABWX,TOLEQ(3),TOLQ
C
      EQUIVALENCE (AIN(1),IAIN(1)),(AT(1,1,1),IAT(1,1,1))
C
      DATA IBUZ/4HZ   /,TOLEQ/0.1,0.1,0.1/
C                            Hole input.
      NTYPS=NTYP
      IF (NTYP .EQ. 1) THEN
        IAIN(1)=ISKP(53)
        IAIN(2)=NAT(NS)
        IAIN(3)=0
        AIN(4)=0.25
        IAIN(5)=999
        CALL FLES (AIN,ISKP(31),6H2IAFIE,
CYENG1
     +   25Hvon,bis,Symb,tol [A],nz?$)
CYENG2
CYENGY     +   25Hfrom,to,symb,tol [A],nz?$)
      ENDIF
      TOLQ=AIN(4)*AIN(4)
      DO  I=1,3
        TOL(I)=AIN(4)*RK(I,NS)
      ENDDO
      DO  I=1,2
        IF (IAIN(I) .LE. 0 .OR. IAIN(I) .GT. NAT(NS)) THEN
          IERR=43 0038 16
          GO TO 999
        ENDIF
      ENDDO
      IF (IAIN(1) .GT. IAIN(2)) THEN
        IERR=43 0043 16
        GO TO 999
      ENDIF
      IF (IAIN(3) .EQ. 0) IAIN(3)=IAT(7,IAIN(1),NS)
      DO  I=1,5
        INBFR(I)=IAIN(I)
      ENDDO
      IATNAM(1)=IAIN(3)
C
C                            Erzeuge den inhalt einer Zelle
      NTYP=3
      CALL ZVZLIN
      IF (IERR .NE. 0) GO TO 999
C
C                            Durchlaufe atome.
      IZENTR=0
      NATSV=NAT(NS)+1
      DO  N1=1,NCD(NS)
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 999
        ENDIF
C                            Referenzatom?
C
        IATNAM(2)=IAT(7,ICD(N1,NS)/200000,NS)
        IF (IATNAM(1) .NE. IATNAM(2)) GO TO 110
        DO  N2=N1,NCD(NS)
C
C                            Referenzatom?
C
          IATNAM(2)=IAT(7,ICD(N2,NS)/200000,NS)
          IF (IATNAM(1) .NE. IATNAM(2)) GO TO 100
C
C                            Loop fuer translationen.
          DO  IX=-1,1
            V(1)=(ATOMS(1,N1,NS)+ATOMS(1,N2,NS)+FLOAT(IX))*0.5
            IF (V(1) .LT. -TOL(1) .OR. V(1) .GT. 0.5+TOL(1)) GO TO 90
            W(1)=2.*V(1)
            DO  IY=-1,1
              V(2)=(ATOMS(2,N1,NS)+ATOMS(2,N2,NS)+FLOAT(IY))*0.5
              IF (V(2) .LT. -TOL(2) .OR. V(2) .GT. 0.5+TOL(2)) GO TO 80
              W(2)=2.*V(2)
              DO  IZ=-1,1
                V(3)=(ATOMS(3,N1,NS)+ATOMS(3,N2,NS)+FLOAT(IZ))*0.5
                IF (V(3) .LT. -TOL(3) .OR. V(3) .GT. 0.5+TOL(3))
     +            GO TO 70
C
C                            Wenn aktuell ein slab untersucht wird,
C                            teste, ob wir v ueberhaupt wollen.
C
                IF (ISKP(95) .NE. 0 
     +          .AND. ABS(V(3)-UR(3,NS)) .GT. 0.001) GO TO 70
                W(3)=2.*V(3)
C
C                             Teste, ob V ein zentrum ist.
C
                IF (ISKP(58) .GT. 1) THEN
CYENG1
                  WRITE (WRLINE,'(A,3F10.6)') 'Untersuche:',V
CYENG2
CYENGY                  WRITE (WRLINE,'(A,3F10.6)') 'Testing:',V
                  CALL KPWRTE (NTOUT)
                ENDIF
                ABWX=0.
                DO  I=1,NCD(NS)
                  IATNAM(3)=IAT(7,ICD(I,NS)/200000,NS)
                  DO  J=1,3
                    T(J)=W(J)-ATOMS(J,I,NS)
                    GO TO 20
   10               T(J)=T(J)+1.
   20               IF (T(J) .LT. 0) GO TO 10
                    GO TO 40
   30               T(J)=T(J)-1.
   40               IF (T(J) .GT. 0.99999) GO TO 30
                  ENDDO
C                            Suche hier ein atom gleichen namens.
                  DO  K=1,NCD(NS)
                    DO  J=1,3
                      DO  L=-1,1
                        ABWT=ABS(T(J)-ATOMS(J,K,NS)+FLOAT(L))
                        IF (ABWT .LE. TOL(J)) GO TO 48
                      ENDDO
                      GO TO 50
   48                 CONTINUE
                      X1(J)=ABWT
                    ENDDO
C                            Teste jetzt genau die toleranzbedingung
C
                    DO  J=1,3
                      X2(J)=DG(J,1,NS)*X1(1)+DG(J,2,NS)*X1(2)+
     +                DG(J,3,NS)*X1(3)
                    ENDDO
                    ABWT=X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3)
                    IF (ABWT .GT. TOLQ) GO TO 50
                    IATNAM(2)=IAT(7,ICD(K,NS)/200000,NS)
                    IF (IATNAM(3) .NE. IATNAM(2)) THEN
C
C                            Teste, ob fremdatome toleriert werden.
C
                      IF (ISKP(76) .EQ. 0) GO TO 70
                      GO TO 50
                    ENDIF
                    IF (ABWT .GT. ABWX) ABWX=ABWT
                    GO TO 60
   50               CONTINUE
                  ENDDO
C                            Kein passendes atom gefunden.
                  GO TO 70
   60             CONTINUE
                ENDDO
C                            Fuendig geworden. Merken, wenn nicht
C                            schon vorhanden.
C
                DO  I=NATSV,NAT(NS)
                  DO  J=1,3
                    IF (ABS(AT(J,I,NS)-V(J)) .LE. TOLEQ(J)) GO TO 61
                    IF (ABS(ABS(AT(J,I,NS)-V(J))-0.5) .LE. TOLEQ(J))
     +              GO TO 61
                    IF (ABS(ABS(AT(J,I,NS)-V(J))+0.5) .GT. TOLEQ(J))
     +              GO TO 62
   61               CONTINUE
                  ENDDO
                  J=I
C                            Verbesserung erzielt?
C
                  IF (SQRT(ABWX) .LT. AT(4,J,NS)) GO TO 63
                  GO TO 70
   62             CONTINUE
                ENDDO
                IF (NAT(NS) .GE. NATDM) THEN
                  IERR=43 0137 02
                  GO TO 999
                ENDIF
                NAT(NS)=NAT(NS)+1
                IZENTR=IZENTR+1
                J=NAT(NS)
                IAT(5,J,NS)=IBUZ
                IAT(6,J,NS)=ISKP(24)
                I=0
                CALL KPNTOS (IZENTR,AT(6,J,NS),I,0)
                IAT(7,J,NS)=IAT(5,J,NS)
                ICLRP(J,NS)=0
                IPFLG(J,NS)=0
   63           DO  I=1,3
                  AT(I,J,NS)=V(I)
                ENDDO
                AT(4,J,NS)=SQRT(ABWX)
                IF (IZENTR .GE. INBFR(5)) GO TO 120
   70           CONTINUE
              ENDDO
   80         CONTINUE
            ENDDO
   90       CONTINUE
          ENDDO
  100     CONTINUE
        ENDDO  ! NEXT N2
  110   CONTINUE
      ENDDO  ! NEXT N1
  120 IF (NTYPS .EQ. 1) THEN
        IF (IZENTR .LE. 0) THEN
CYENG1
          WRITE (WRLINE,'(A)') 'Kein Zentrum gefunden.'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') 'No centre found.'
        ELSE
CYENG1
          WRITE (WRLINE,'(I3,A)') IZENTR,' Zentren gefunden.'
CYENG2
CYENGY          WRITE (WRLINE,'(I3,A)') IZENTR,' centers found.'
        ENDIF
        CALL KPWRTE (NTOUT)
      ENDIF
C
  999 RETURN
      END
