#include "kplot.h"
#include "kplot2d.h"
#include "qpainter.h"
#include "fstream.h"
#include <qapplication.h>
#include <qprinter.h>
#include <qprintdialog.h>
#include <qimage.h>
#include <qfiledialog.h>

QColor * CKPlot2D::color[16];

#define P_X(x) (int)((x-x_ur)*x_fak)
#define P_Y(y) (y_pixel-((int)((y-y_ur)*y_fak)))

// extern bool interruptFlag;
extern QApplication *a;
extern "C" int  lese_(char * buf);

void CKPlot2D::mousePressEvent(QMouseEvent * ev)
{
   if (ev->button()==RightButton)
   {
	  if (holeCoord)
	  {
		 a->exit(3);
	  }
	  else
		 emit interrupt();
   }
   if (ev->button()==LeftButton)
   {
	  if (holeCoord)
	  {
		 a->exit(4);
		 aktX=ev->x();
		 aktY=ev->y();
	  }
   }
}

CKPlot2D::CKPlot2D(QWidget *parent,const char *name)
: QFrame(parent,name)
{
   setFrameStyle(QFrame::Panel | QFrame::Raised);
   setLineWidth(3);
   prt=0;
   printing=FALSE;
   exporting=FALSE;
   holeCoord=FALSE;
   cursorCross.setShape(CrossCursor);
   setCursor(cursorCross);
    
   p=new QPainter(this);
   
   for (int i=0;i<16;i++)
	  color[i]=NULL;
	  
   setDefaultColors();
//   polygon_anzahl=0;
   polygon_perimeter=0;


   x_cm=0;
   y_cm=0;
   x_pixel=0; 	
   y_pixel=0;
   x_ur=0;
   y_ur=0;


   x_fak=0;
   y_fak=0;
   f_color=ForeGroundIndex;   
}

void CKPlot2D::setDefaultColors()
{
	for(int i=0;i<16;i++)
	{
	   if (color[i]!=NULL)
		  delete color[i];
	}
	color[0]=new QColor("black");
	color[1]=new QColor("blue");
	color[2]=new QColor("green");
	color[3]=new QColor("cyan");
	color[4]=new QColor("red");
	color[5]=new QColor("darkMagenta");
	color[6]=new QColor("darkGray");
	color[7]=new QColor("gray");
	color[8]=new QColor("lightGray");
	color[9]=new QColor("darkBlue");
	color[10]=new QColor("darkGreen");
	color[11]=new QColor("darkCyan");
	color[12]=new QColor("darkRed");
	color[13]=new QColor("magenta");
	color[14]=new QColor("yellow");
	color[15]=new QColor("white");

}

void CKPlot2D::changeBackgroundColor()
{
   QColor *c=color[0];
   color[0]=color[15];
   color[15]=c;	
//   cout << "Change color" << endl;
}
 
CKPlot2D::~CKPlot2D()
{
	if (p)
	{
	  if (p->isActive())
	  {
		 p->end();
	  }
	  delete p;
	}
}

int testflag=0;

void CKPlot2D::processDrawCommand(float *ar ,long int *funcIn)
{
   char buf[81];
   float ar1,ar2,ar3,ar4;
   long int func;
   long int lwert;
   float t_x,t_y;
   int j;
   func=*funcIn;
  
  switch(func)
  {
    case 0:
		printing=FALSE;
		if (exporting)
		{
		   exporting=FALSE;
		   QImageIO iio;
		   QImage im;
		   p->end();
		   im=exportBuffer;
		   iio.setImage(im);
		   iio.setFileName(exportFile);
		   iio.setFormat(exportType);
		   iio.write();
		}
//		if (p->isActive())
		{
		   if (bufferedMode)
			 bitBlt(this,0,0,&offScreenBuffer);
//		   p->end();
		    
		}
        break;
    case 1:
		 if(p->isActive())
		 {
		   p->end();
		 }
		 offScreenBuffer.resize(frameRect().size());
		 if (exporting)
			p->begin(&exportBuffer);
		 else if (printing)
			p->begin(prt);
		 else if (bufferedMode)
			p->begin(&offScreenBuffer);
		 else
			p->begin(this);			
		 
		 p->setBackgroundColor(*(color[BackGroundIndex]));
		
		 x_pixel=offScreenBuffer.width();
		 y_pixel=offScreenBuffer.height();		 

		 if (x_pixel<y_pixel)
		    y_pixel=x_pixel;
		 else
		    x_pixel=y_pixel;
		    
		 if (exporting)
		 {
			p->eraseRect(0,0,exportBuffer.width(),exportBuffer.height());			 
		    x_pixel=exportBuffer.width();
			y_pixel=exportBuffer.height();		 
		 }
		 else if (bufferedMode)
			p->eraseRect(0,0,offScreenBuffer.width(),offScreenBuffer.height());
		 else
			p->eraseRect(0,0,frameRect().width(),frameRect().height());
		 			
 		 p->end();
    /*
        sprintf(buf,"Initialiserung Bildschirm\n");
        append_format_ausgabe(buf);
        XClearWindow(display,XtWindow(drawingArea));
        XGetWindowAttributes(display,XtWindow(drawingArea),&win_attr);
        x_pixel=win_attr.width;
        y_pixel=win_attr.height;
        */
	break;
    case 2:
		  ar1=ar[0];
		  ar2=ar[1];
		  p->drawLine(P_X(linie_x),P_Y(linie_y),P_X(ar1),P_Y(ar2));				  
		  linie_x=ar1;
		  linie_y=ar2;
//		  cout << "Linie " << P_X(linie_x) << " " << P_Y(linie_y) << endl;
    /*
          ar1=ar[0];
          ar2=ar[1];

        line_(P_X(linie_x),P_Y(linie_y),P_X(ar1),P_Y(ar2));
        linie_x=ar1;
        linie_y=ar2;
        */
	break;
    case 3:
          ar1=ar[0];
          ar2=ar[1];
        linie_x=ar1;
        linie_y=ar2;
    /*
          ar1=ar[0];
          ar2=ar[1];
        linie_x=ar1;
        linie_y=ar2;
        */
	break;
    case 4:
          ar1=ar[0];
          ar2=ar[1];
        x_ur=(-1)*ar1;
        y_ur=(-1)*ar2;
    /*
          ar1=ar[0];
          ar2=ar[1];
        x_ur=(-1)*ar1;
        y_ur=(-1)*ar2;
        */
	break;
    case 5:
          ar1=ar[0];
          ar2=ar[1];
        x_ur=x_ur-ar1;
        y_ur=y_ur-ar2;
    /*
          ar1=ar[0];
          ar2=ar[1];
        x_ur=x_ur-ar1;
        y_ur=y_ur-ar2;*/
	break;
    case 6:
		 if(p->isActive())
		 {
			p->end();
		 }

		 if (exporting)
			p->begin(&exportBuffer);
		 else if (printing)
			p->begin(prt);
		 else if (bufferedMode)
			p->begin(&offScreenBuffer);
		 else
			p->begin(this);			
		 p->setBackgroundColor(*(color[BackGroundIndex]));

		 x_pixel=offScreenBuffer.width();
		 y_pixel=offScreenBuffer.height();		 
		 
		 if (x_pixel<y_pixel)
		    y_pixel=x_pixel;
		 else
		    x_pixel=y_pixel;

		 if (exporting)
		 {
			p->eraseRect(0,0,exportBuffer.width(),exportBuffer.height());		
			x_pixel=exportBuffer.width();
			y_pixel=exportBuffer.height();		 
		 }	 
		 else if (bufferedMode)
			p->eraseRect(0,0,offScreenBuffer.width(),offScreenBuffer.height());
		 else
			p->eraseRect(0,0,frameRect().width(),frameRect().height());

		 x_fak=(float)x_pixel/x_cm;
		 y_fak=(float)y_pixel/y_cm;
    /*
        XClearWindow(display,XtWindow(drawingArea));
        XGetWindowAttributes(display,XtWindow(drawingArea),&win_attr);
        x_pixel=win_attr.width;
        y_pixel=win_attr.height;
        x_fak=(float)x_pixel/x_cm;
        y_fak=(float)y_pixel/y_cm;*/
	break;
    case 7:
    /*
          ar1=ar[0];
          ar2=ar[1];
        sprintf(buf,"%f %f %d\n",ar1,ar2,func);
        append_format_ausgabe(buf);*/
	break;
    case 8:
		{
		  char buf[100];
		  holeCoord=TRUE;
		  int erg=1;
		  while(erg==1)
		  {
			 erg=lese_(buf);
		  }
		  if (erg==3)
		  {
			((long int *)ar)[3]=33;    
		  }
		  else
		  {
			((long int *)ar)[3]=32;
			ar[0]=((aktX)/(x_fak))+x_ur;
			ar[1]=(((y_pixel-(aktY))/(y_fak))+y_ur);
		  }
		  holeCoord=FALSE;
		}
    /*
	in_hole_coord=1;
        eventLoop2();
        ar[0]=x_c;
        ar[1]=y_c;
        ((long int *)ar)[3]=button;*/
	break;
    case 9:
    /*
        sprintf(buf,"Cursor aus\n");
        append_format_ausgabe(buf);*/
	break;
    case 10:
	  lwert=*((long int*)(&(ar[0])));
	  f_color=((int)lwert)%16;
	  pen.setColor(*(color[f_color]));
	  brush.setColor(*(color[f_color]));
if (testflag)
{
	  p->setPen(pen);
	  p->setBrush(brush);
}
                testflag=1;
//	  cout << "Color : " << f_color << endl;
    /*
	  lwert=*((long int*)(&(ar[0])));
	XSetForeground(display,gc,d_color[((int)lwert)].pixel);
        f_color=((int)lwert);*/
	break;
    case 11:
    /*
	  lwert=*((long int*)(&(ar[0])));*/
	break;
    case 12:
	break;
    case 13:
    /*
          ar1=ar[0];
        sprintf(buf,"%f %d\n",ar1,func);
        append_format_ausgabe(buf);*/
	break;
    case 14:
          ar1=ar[0];
          ar2=ar[1];
          ar3=ar[2];
          ar4=ar[3];
        x_cm=ar2;
        y_cm=ar4;
        x_fak=(float)x_pixel/x_cm;
        y_fak=(float)y_pixel/y_cm;
    /*
          ar1=ar[0];
          ar2=ar[1];
          ar3=ar[2];
          ar4=ar[3];
        x_cm=ar2;
        y_cm=ar4;
        x_fak=(float)x_pixel/x_cm;
        y_fak=(float)y_pixel/y_cm;*/
	break;
    case 15:
	break;
    case 16:
    /*
	  lwert=*((long int*)(&(ar[0])));
        sprintf(buf,"%ld %d\n",lwert,func);
        append_format_ausgabe(buf);*/
	break;
    case 17:
	break;
    case 18:
	break;
    case 19:
	break;
    case 20:
	break;
    case 21:
	{	  
	  lwert=*((long int*)(&(ar[0])));
	  int tPen=f_color;
	  int tBrush=f_color;
	  if (lwert==0)
		  tBrush=BackGroundIndex;
	  if (polygon_perimeter==0)
		  tPen=tBrush;
		  		  
	  if (lwert<1)
	  {
		 brush.setStyle(SolidPattern);
	  }
	  else
	  {
		 brush.setStyle((BrushStyle)(lwert%16));
	  }
	  
	  pen.setColor(*(color[tPen]));
	  brush.setColor(*(color[tBrush]));
	  p->setPen(pen);
	  p->setBrush(brush);
	  
	  
	  p->drawPolygon(pointArray);
	   
    }
    /*
	  lwert=*((long int*)(&(ar[0])));

        point=NULL;
        point=(XPoint*)malloc(polygon_anzahl*sizeof(XPoint));
        for(j=0;j<polygon_anzahl;j++)
        {
                t_x=polygon_ptr[j].x;
                t_y=polygon_ptr[j].y;

		point[j].x=P_X(t_x);
		point[j].y=P_Y(t_y);

	}
        if (lwert<1)
  	   XSetForeground(display,gc,d_color[WHITE].pixel);

	polyfill_(polygon_anzahl,point);

  	XSetForeground(display,gc,d_color[f_color].pixel);

        if (polygon_perimeter!=0)
        {
        poly_(polygon_anzahl,point);
        }

	if (point!=NULL)
           free(point);



	if (polygon_ptr!=NULL)
           free(polygon_ptr);
        polygon_ptr=NULL;*/

	break;
    case 22:
    
	   ar1=ar[0];
	   ar2=ar[1];
	   
	   pointArray.putPoints(pointArray.size(),1,P_X(ar1),P_Y(ar2));
	   
/*	   if (polygon_ptr!=NULL)
	   {
		 polygon_anzahl+=1;
		 polygon_ptr=(POLYGON*)realloc((void*)polygon_ptr,(polygon_anzahl)*sizeof(POLYGON));
		 polygon_ptr[polygon_anzahl-1].x=ar1;
		 polygon_ptr[polygon_anzahl-1].y=ar2;
	   }*/
    /*
          ar1=ar[0];
          ar2=ar[1];
        if (polygon_ptr!=NULL)
        {
        polygon_anzahl+=1;
	polygon_ptr=(POLYGON*)realloc((void*)polygon_ptr,(polygon_anzahl)*sizeof(POLYGON));
	polygon_ptr[polygon_anzahl-1].x=ar1;
	polygon_ptr[polygon_anzahl-1].y=ar2;
	}*/
	break;
    case 23:
    
		ar1=ar[0];
		ar2=ar[1];

        if (!pointArray.isNull())
        {
            pointArray.resize(0);
		}
//        polygon_anzahl=1;

        pointArray.putPoints(0,1,P_X(ar1),P_Y(ar2));
//		polygon_ptr=(POLYGON*)malloc((polygon_anzahl)*sizeof(POLYGON));
//		polygon_ptr[polygon_anzahl-1].x=ar1;
//		polygon_ptr[polygon_anzahl-1].y=ar2;
    /*
          ar1=ar[0];
          ar2=ar[1];

        if (polygon_ptr!=NULL)
            free(polygon_ptr);

        polygon_anzahl=1;
	polygon_ptr=(POLYGON*)malloc((polygon_anzahl)*sizeof(POLYGON));
	polygon_ptr[polygon_anzahl-1].x=ar1;
	polygon_ptr[polygon_anzahl-1].y=ar2;*/

	break;
    case 24:
	  lwert=*((long int*)(&(ar[0])));
	  polygon_perimeter=(int)lwert;
/*	  lwert=*((long int*)(&(ar[0])));
        polygon_perimeter=(int)lwert;*/
	break;
    case 25:
    
		lwert=(long int)(ar[0]);
//		cout << "Cursor " << lwert << endl;
        if (lwert==0)
		   setCursor(cursorCross);
    	else
		   setCursor(cursorArrow);
	break;
    case 26:
    /*
	  lwert=*((long int*)(&(ar[0])));
        change_gc((int)lwert);*/
	break;
    case 27:
    /*
          ar1=ar[0];
          ar2=ar[1];
        sprintf(buf,"%f %f %d\n",ar1,ar2,func);
        append_format_ausgabe(buf);*/
	break;
    case 28:
    /*
	  lwert=*((long int*)(&(ar[0])));
        sprintf(buf,"%ld %d\n",lwert,func);
        append_format_ausgabe(buf);*/
	break;
    case 29:
	break;
    case 30:
	break;
    case 31:
    /*
	  lwert=*((long int*)(&(ar[0])));
        sprintf(buf,"%ld %d\n",lwert,func);
        append_format_ausgabe(buf);*/
	break;
    default :
//        fprintf(stdout,"Funktionsnummer fuer Grafikinterface unbekannt F-Nr.: %d\n",func);
		   ;
  }
}

void CKPlot2D::paintEvent( QPaintEvent * )
{
//    QPainter p( this );
	bool resizeFlag=FALSE;
	
	if (holeCoord)
	   a->exit(3);
	   
	if (printing || exporting)
	   return;
	   
	if (p)
	{
	  if (p->isActive())
	  {
		 p->end();
	  }
	  delete p;
	}
//resize(parentWidget()->frameSize());	
		
	if (!(offScreenBuffer.size()==frameRect().size()))
	   resizeFlag=TRUE;
	
//cout << parentWidget()->width() << " " << parentWidget()->height() << endl;  
	offScreenBuffer.resize(frameRect().size());
	if (bufferedMode)
	   p=new QPainter(&offScreenBuffer);
	else
	   p=new QPainter(this);

	if (resizeFlag)
	{	      
	   p->setBackgroundColor(*(color[BackGroundIndex]));
	   p->eraseRect(0,0,frameRect().width(),frameRect().height());
	}
	
    if (bufferedMode)
	   bitBlt(this,0,0,&offScreenBuffer);
	
	if (!bufferedMode || resizeFlag)
	  a->exit(2);
//    p.end();                    // explicit end() so any slots can paint too
//    cout << "Redraw" << endl;
//    emit update();
}

void CKPlot2D::print()
{

	if (prt)
	   delete prt;
	   
	prt=new QPrinter();

	if (QPrintDialog::getPrinterSetup(prt))
	{
//	   p=new QPainter(prt);
	   printing=TRUE;
	   a->exit(2);
	}
}

void CKPlot2D::exportBMP()
{
	   exporting=TRUE;
	   exportBuffer.resize(2000,2000);
	   QString f=QFileDialog::getSaveFileName(QString::null,"*.bmp",this);
	   if (!f.isEmpty())
	   {
		 exportType="BMP";
		 exportFile=f;
		 a->exit(2);	
	   }
}

void CKPlot2D::exportXPM()
{
	   exporting=TRUE;
	   exportBuffer.resize(2000,2000);
	   QString f=QFileDialog::getSaveFileName(QString::null,"*.xpm",this);
	   if (!f.isEmpty())
	   {
		 exportType="XPM";
		 exportFile=f;
		 a->exit(2);	
	   }
}
