      SUBROUTINE lubksb (a,n,np,indx,b)
      IMPLICIT NONE
      INTEGER *4 n,np,indx(n)
      REAL    *4 a(np,np),b(n)
C
C  Eine menge von n linearen gleichungen wird geloest: A.X=B . Hier ist
C  a input, nicht als matrix A sondern als seine LU-dekomposition,
C  berechnet durch die routine ludcmp. indx ist input als permutations-
C  vektor ebenfalls bestimmt durch ludcmp. b(1:n) ist input als bild-
C  vektor von B und liefert den ergebnisvektor X zurueck. a, n, np und
C  indx werden nicht veraendert und koennen bei wiederholtem aufruf
C  wieder verwendet werden. Dieses programm beruecksichtigt, dass der
C  Vektor b mit vielen nullen beginnt, so dass es effektiv zur matrix-
C  inversion verwendet werden kann.
C
      INTEGER *4 i,ii,j,ll
      REAL    *4 sum
C
      ii=0                   ! Nimmt ii einen positiven wert an,
      do  i=1,n              ! wird es der index des ersten nicht
        ll=indx(i)           ! verschwindenden elements von b. Jetzt
        sum=b(ll)            ! wird die vorwaertssubstitution aus-
        b(ll)=b(i)           ! gefuehrt. Der einzige neue trick ist
        if (ii .ne. 0) then  ! die permutation wieder rueckgaengig zu
          do  j=ii,i-1       ! machen.
            sum=sum-a(i,j)*b(j)
          enddo
        else if (sum .ne. 0) then
          ii=i               ! Element ungleich null gefunden; ab
        endif                ! sofort muessen die summen gebildet
        b(i)=sum             ! werden.
      enddo
      do  i=n,1,-1           ! Es folgt die rueckwaertssubstitution.
        sum=b(i)
        do  j=i+1,n
          sum=sum-a(i,j)*b(j)
        enddo
        b(i)=sum/a(i,i)      ! Eine komponente des ergebnisvektors X
      enddo
      return
      END
