/****************************************************************************
** $Id: main.cpp,v 1.6 1998/06/16 11:39:32 warwick Exp $
**
** Copyright (C) 1992-1998 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#include <qapplication.h>
#include <stdio.h>
#include <qstring.h>
#include <fstream.h>
#include <stdlib.h>
#include <qpushbutton.h>
#include "kplot.h"
//#include "wood.h"

class MyMain:  public QApplication
{
  public:
	MyMain(int argc, char** argv):QApplication(argc,argv){};
	~MyMain(){};
	bool eventFilter(QObject* qObj, QEvent * event){
	if (event->type()==QEvent::KeyPress)
	{
	  if (((QKeyEvent*)event)->key()==Qt::Key_Escape)
	  {
		 ((CKplotApp*)(mainWidget()))->interrupt();
		 return TRUE;
	  }		 
	}
	return FALSE;};
};

extern "C" void main2_();
extern "C" void kpmain_();
extern "C" int output_(char * );
extern "C" int uplinfc_(float *ar, long int *funcIn);
extern "C" int lese_(char * buf);
extern "C" int check_interupt_(int * erg);
extern "C" int myatom_(float *x,float *y, float *z, float *r, long int *nr,
long int * color); 
//extern "C" int kppbnd_(float *p1_x,float *p1_y,float*p1_z, 
//               float *p2_x, float *p2_y, float *p2_z, long int*color); 
extern "C" int kppbnd_(long int *p1, long int *p2i, long int *color, float
*radius, float * zPos);

MyMain *a;
CKplotApp * kplotApp;
// bool interruptFlag=FALSE;

void main2_(  ) {
    int argc=0;
    char *argv[2];
//              {{"12"},
//               {"123"}};
    a=new MyMain(argc,argv  );
    a->installEventFilter(a);
    a->setFont(QFont("courier",14),TRUE);
//    kpmain_();
    kplotApp = new CKplotApp();
    a->setMainWidget(kplotApp);
    kplotApp->setCaption( "KPlot" );
    kplotApp->show();
//    a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
//    kpmain_();
    return;// a.exec();
}

#include <unistd.h>
int check_interupt_(int * erg)
{
	*erg=0;
	kplotApp->interruptFlag=FALSE;
	a->quit_now=FALSE;

	if (a->app_exit_loop)
	{
	   a->app_exit_loop=FALSE;
	   a->processEvents();
	   a->app_exit_loop=TRUE;
	}
	else
	{
	   a->processEvents();
	}   
	
//cout << kplotApp->interruptFlag << endl;
	a->quit_now=TRUE;	
	if (kplotApp->interruptFlag==TRUE)
	   *erg=27;
	return 0;
}

int uplinfc_(float *ar, long int *funcIn)
{
   kplotApp->processDrawCommand(ar,funcIn);
//   cout << funcIn << endl;
   return 1;
}

int output_(char *buf)
{
   // cout << buf << endl;
   char buffer[200];
   int i=119;
   while (buf[i]==' ')
   {
     i--;
     if (i==0) break;
   } 
   strcpy(buffer,"");
   strncat(buffer,buf,i+1);
   kplotApp->output(QString(buffer));
   return 1;
}

int lese_(char * buf)
{
//   cout << "Lese anfang" << endl;
   int erg=1;
   int ret=a->exec();
//   cout << ret << endl;
   if (ret==3 || ret==4)
   {
	 erg=ret;
   }
   if (ret==0)
   {
     exit(0);
   }
   for(int i=0;i<80;i++)
       buf[i]=' ';
   if (ret==1)
   {
	 QString textBuf=kplotApp->getInput();
	 if (textBuf.length())
	 {
	 kplotApp->output(textBuf);
	 memcpy(buf,(const char*)textBuf,textBuf.length());
	 kplotApp->resetInput();
	 }
   }
   else if (ret==2)
   {
	 memcpy(buf,"rdrw",4);
   }
//   memcpy(buf,textBuf,strlen(textBuf));
   return erg;
}

#ifdef FALSE
int myatom_(float * x, float * y, float * z, float * r, long int *nr, long int
* color) {
/*
    QString str="Atom ";
    char t[100];
    sprintf(t,"%f",*x);
    str+=t;
    str+=" , ";
    sprintf(t,"%f",*y);
    str+=t;
    str+=" , ";
    sprintf(t,"%f",*z);
    str+=t;
    str+=" , ";
    sprintf(t,"%f",*r);
    str+=t;
    str+=" , ";
    sprintf(t,"Nr : %ld",*nr);
    str+=t;
    str+=" , ";
    sprintf(t,"Color : %ld",*color);
    str+=t;
//    cout << str << flush;
    kplotApp->output(str);
*/
//cout << "ANFATOM" << endl;
    kplotApp->SetAtom3D(x,y,z,r,nr,color);
//cout << "ENDATOM" << endl;
}

int kppbnd_(long int *p1, long int *p2, long int *color, float * radius,
float *zPos) {
/*
    QString str="Verb P1:";
    char t[100];
    sprintf(t,"Nr1 : %ld",*p1);
    str+=t;
    str+=" , ";
    sprintf(t,"Nr2 : %ld",*p2);
    str+=t;
    str+=" , Color ";
    sprintf(t,"%ld %f %f",*color,*radius,*zPos);
    str+=t;
//    cout << str << flush;
    kplotApp->output(str);
*/
//cout << "ANFBIND" << endl;

    kplotApp->SetBond3D(p1,p2,color,radius,zPos);

//cout << "ENDBIND" << endl;

}

int kppbnd_(float *p1_x,float *p1_y,float *p1_z,
           float *p2_x, float *p2_y, float *p2_z, long int *color)
{
/*
    QString str="Verb P1:";
    char t[100];
    sprintf(t,"%f",*p1_x);
    str+=t;
    str+=" , ";
    sprintf(t,"%f",*p1_y);
    str+=t;
    str+=" , ";
    sprintf(t,"%f",*p1_z);
    str+=t;
    str+="    P2:";
    sprintf(t,"%f",*p2_x);
    str+=t;
    str+=" , ";
    sprintf(t,"%f",*p2_y);
    str+=t;
    str+=" , ";
    sprintf(t,"%f",*p2_z);
    str+=t;
    str+="  Color:";
    sprintf(t,"%ld",*color);
    str+=t;
    kplotApp->output(str);
 */   

}
#endif
