c                   --------------------------------
                     subroutine misprd (isym,i,irc)
c                   --------------------------------
c
      integer *4 isym,i,irc
c
c--- Berechnet das produkt zweier symmetrien. Falls symmetrie
c    noch nicht vorhanden war, wird sie angefuegt.
c    Beim aufruf muss irc den wert 3 oder 4 enthalten; bei 3 wird
c    nur die rotationsmatrix getestet, bei 4 auch die translation.
c
c    irc=0: neue symmetrie erzeugt.
c    irc=-1: neue symmetrie war schon vorhanden.
c    irc=+1: fehler
c
c                 geschrieben: 291620 dec 1997 (Hundt)
c                 geaendert: 010913 dec 1998 (Hundt)
c
c                   --------------------------------
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 k,l,itflg
      REAL    *4 sy(3,4),tol,tol2
      data tol/0.001/,tol2/0.07/
c
      itflg=irc
      irc=0
c                            Wende Symmetrie isym auf symmetrie i an.
      do  k=1,3
        do  l=1,3
          sy(k,l)=sym(k,1,isym)*sym(1,l,i)+sym(k,2,isym)*sym(2,l,i)
     +    +sym(k,3,isym)*sym(3,l,i)
        enddo
        sy(k,4)=sym(k,1,isym)*sym(1,4,i)+sym(k,2,isym)*sym(2,4,i)
     +  +sym(k,3,isym)*sym(3,4,i)+sym(k,4,isym)
   10   if (sy(k,4) .gt. 1.-tol) then
          sy(k,4)=sy(k,4)-1.
          go to 10
        endif
   20   if (sy(k,4) .lt. .0) then
          sy(k,4)=sy(k,4)+1.
          go to 20
        endif
        if (sy(k,4) .gt. 1.-tol) sy(k,4)=0.
      enddo
c                        Hatten wir diese Symmetrie schon?
      do  m=1,nsym
        do  k=1,3
          do  l=1,3
            if (abs(sy(k,l)-sym(k,l,m)) .gt. tol2) go to 30
          enddo
          if (itflg .gt. 3) then
            if (abs(sy(k,4)-sym(k,4,m)) .gt. tol2 .and.
     +      abs(abs(sy(k,4)-sym(k,4,m))-1.) .gt. tol2) go to 30
          endif
        enddo
c                        Gefunden, wenn hier
        irc=-1
        return
   30   continue
      enddo
c                        Nicht gefunden, nimm auf.
c
      if (nsym .ge. nsymdm) then
        irc=1
        call misyou (irc)
        return
      endif
      nsym=nsym+1
      do  k=1,3
        do  l=1,4
          sym(k,l,nsym)=sy(k,l)
        enddo
      enddo
      call misyan (nsym,isytyp(1,nsym),iachsr(1,nsym),gleitk(1,nsym),
     + aupkt(1,nsym),irc)
      if (irc .gt. 0) then
        nsym=nsym-1
        return
      endif
      isytyp(2,nsym)=-irc
      irc=0
      return
      END
