c           ----------------------------------------------
             subroutine misyan (m,itt,iachse,hub,pkt,irc)
c           ----------------------------------------------
c
      IMPLICIT NONE
c
      INTEGER *4 m,iachse(3),irc
      REAL    *4 hub(3),pkt(3)
c
c--- Das programm analysiert die symmetrie nr. m und berechnet
c    die achse, die gleitkomponente hub und einen punkt pkt, der
c    auf dem symmetrieelement liegt. itt: symmetrietyp;
c    irc: 0 oder -1: symmetrie o.k ohne / mit intrinsischer
c    translation; >0 fehler (s. kommentare).
c
c                 geschrieben: 090850 feb 1997 (Hundt)
c                   geaendert: 070859 oct 1999 (Hundt)
c
c           -----------------------------------------------
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 j,k,k1,k2,k3,n,isp,itt,itypp(7),itypm(7),n1,n2,n3
      INTEGER *4 ipslst(145),kk
      REAL    *4 det,temp,temp2,tol,x1(3),x2(3),t(3),x(3,6)
      REAL    *4 tmin,q(3),p(3),a(3)
c
      DATA itypp/10,10,2,3,4,6,1/
      DATA itypm/-1,-6,-4,-3,-2,10,10/
      DATA tol/0.01/
      DATA (ipslst(j),j=1,145)/556,565,655,546,566,644,645,646,654,656,
     1 664,665,666,534,536,543,547,633,634,635,636,637,643,647,653,657,
     2 663,667,673,674,675,676,677,734,736,743,744,745,746,747,754,756,
     3 763,764,765,766,767,774,776,523,524,526,527,532,538,542,548,622,
     4 623,624,625,626,627,628,632,638,642,648,652,658,662,668,672,678,
     5 682,683,684,685,686,687,688,722,723,724,725,726,727,728,732,738,
     6 742,748,752,758,762,768,772,778,782,783,784,785,786,787,788,823,
     7 824,826,827,832,833,834,835,836,837,838,842,843,844,845,846,847,
     8 848,853,854,856,857,862,863,864,865,866,867,868,872,873,874,875,
     9 876,877,878,883,884,886,887/
c
      irc=0
c
c--- Berechne determinante und spur und hieraus den symmetrietyp.
c
      det=sym(1,1,m)*sym(2,2,m)*sym(3,3,m)+
     +    sym(1,2,m)*sym(2,3,m)*sym(3,1,m)+
     +    sym(1,3,m)*sym(2,1,m)*sym(3,2,m)-
     +    sym(1,3,m)*sym(2,2,m)*sym(3,1,m)-
     +    sym(1,1,m)*sym(2,3,m)*sym(3,2,m)-
     +    sym(1,2,m)*sym(2,1,m)*sym(3,3,m)
      if (abs(abs(det)-1.) .gt. tol) then
        irc=1
c
c--- Keine regulaere symmetrie, da /det/ != 1.
c
        go to 240
      endif
      temp=sym(1,1,m)+sym(2,2,m)+sym(3,3,m)
      isp=temp+4.1
      if (isp .le. 0 .or. isp .gt. 7) then
        irc=2
c
c--- Keine regulaere symmetrie, da die spur zwischen -3 und 3
c    liegen muss.
c
        go to 240
      endif
c
c--- Bestimme symmetrietyp.
c
      if (det .gt. 0.) then
        itt=itypp(isp)
      else
        itt=itypm(isp)
      endif
      if (abs(itt) .eq. 1) then
c
c--- Bei zentrum oder zentrierung gibt es keine ausgezeichnete achse.
c
        k1=0
        k2=0
        k3=0
        go to 170
      endif
c
c--- Suche den vektor, der in sich selbst bzw. in sein spiegelbild
c    ueberfuehrt wird.
c
      do  kk=1,145
        j=ipslst(kk)
        k1=j/100-5
        k2=mod(j/10,10)-5
        k3=mod(j,10)-5
        x1(1)=k1
        x1(2)=k2
        x1(3)=k3
        temp=0.
        do  j=1,3
          x2(j)=sym(j,1,m)*x1(1)+sym(j,2,m)*x1(2)+sym(j,3,m)*x1(3)
          if (itt .lt. 0) then
            temp=temp+abs(x2(j)+x1(j))
          else
            temp=temp+abs(x2(j)-x1(j))
          endif
          if (temp .gt. tol) go to 10
        enddo
        go to 20
   10   continue
      enddo
c
c---  Keine achse gefunden.
c
      irc=3
      go to 240
c
c--- Transformiere gefundene achse ins kartesische koordinatensystem.
c
   20 continue
      temp=0.
      do  j=1,3
        temp2=dgt(j,1)*x1(1)+dgt(j,2)*x1(2)+dgt(j,3)*x1(3)
        a(j)=temp2
        temp=temp+temp2*temp2
      enddo
      if ((itt .lt. -2) .or.
     +  (abs(sym(1,4,m))+abs(sym(2,4,m))+abs(sym(3,4,m)) .le. 0.)) then
c
c--- Drehinversionsachsen -3, -4 und -6 besitzen keinen hub.
c
        do  j=1,3
          x2(j)=0.
        enddo
        go to 170
      endif
c
c--- Bestimme hub.
c
      tmin=1000.
   30 do  n1=0,1
        q(1)=n1
        do  n2=0,1
          q(2)=n2
          do  n3=0,1
            q(3)=n3
            do  j=1,3
              t(j)=dgt(j,1)*(sym(1,4,m)-q(1))+
     +        dgt(j,2)*(sym(2,4,m)-q(2))+
     +        dgt(j,3)*(sym(3,4,m)-q(3))
            enddo
c
c--- Bei spiegelebenen: Teste, ob der symmetrieaequivalente
c    punkt auf der achse liegt. Falls IRC <0, ist das ausgeschlossen
c
            if (itt .eq. -2) then
              if (irc .eq. 0) then
                if (abs(t(2)*a(3)-t(3)*a(2))+abs(t(3)*a(1)-t(1)*a(3))+
     +            abs(t(1)*a(2)-t(2)*a(1)) .lt. tol) then
                  do  j=1,3
                    x2(j)=0.
                    t(j)=sym(j,4,m)*.5
                  enddo
                  go to 230
                endif
              else
c
c--- Projiziere den gespiegelten punkt auf den normalenvektor der
c    spiegelebene
c
        temp=(a(1)*t(1)+a(2)*t(2)+a(3)*t(3))/temp
        do  j=1,3
          x2(j)=a(j)*temp
        enddo
        do  j=1,3
          x1(j)=dginv(j,1)*x2(1)+dginv(j,2)*x2(2)+dginv(j,3)*x2(3)
        enddo
        do  j=1,3
          temp=sym(j,4,m)-x1(j)
          go to 50
   40     temp=temp+1.
   50     if (temp) 40,90,70
   60     temp=temp-1.
   70     if (temp-.9999) 80,60,60
   80     if (temp .lt. 0.) temp=0.
   90     x2(j)=temp
          temp=x1(j)*.5
          go to 110
  100     temp=temp+1.
  110     if (temp) 100,150,130
  120     temp=temp-1.
  130     if (temp-.9999) 140,120,120
  140     if (temp .lt. 0.) temp=0.
  150     t(j)=temp
        enddo
        go to 230
              endif
c
c--- Bei drehachsen: Projiziere den punkt, der sich durch
c    anwendung der symmetrie auf den nullpunkt ergibt auf
c    diese achse ...
c
            else
              temp2=(t(1)*a(1)+t(2)*a(2)+t(3)*a(3))/temp
              if (abs(temp2) .lt. abs(tmin)) then
                tmin=temp2
                if (abs(tmin) .lt. tol) go to 160
              endif
            endif
          enddo
        enddo
      enddo
      irc=-1
      if (itt .eq. -2) go to 30
c
c                          ... und berechne die gleitkomponente.
  160 do  j=1,3
        x2(j)=x1(j)*tmin
      enddo
      if (itt .eq. -2) then
        do  j=1,3
          x2(j)=sym(j,4,m)-x2(j)
        enddo
      endif
  170 continue
c
c--- Erzeuge jetzt gemaesz der zaehligkeit punkte, um einen punkt
c    auf dem symmetrieelement zu finden.
c
      if (itt .eq. 1) then
        do  j=1,3
          x2(j)=sym(j,4,m)
          t(j)=0.
        enddo
        if (abs(x2(1))+abs(x2(2))+abs(x2(3)) .gt. tol) irc=-1
        go to 230
      endif
c
      if (itt .eq. -1) then
        do  j=1,3
          t(j)=sym(j,4,m)*0.5
          x2(j)=0.
        enddo
        go to 230
      endif
c
      k=abs(itt)
      if (itt .eq. -3) k=6
      do  j=1,3
        x(j,1)=0.
        t(j)=0.
      enddo
      do  n=2,k
        do  j=1,3
          x(j,n)=sym(j,4,m)+sym(j,1,m)*x(1,n-1)+
     +    sym(j,2,m)*x(2,n-1)+sym(j,3,m)*x(3,n-1)-x2(j)
          if (itt .ge. -2) then
c
c--- Normiere auf zelle
c
            go to 190
  180       x(j,n)=x(j,n)+1.
  190       if (x(j,n) .lt. 0.) go to 180
            go to 210
  200       x(j,n)=x(j,n)-1.
  210       if (x(j,n) .gt. 0.9999) go to 200
          endif
        enddo
        if (itt .lt. -2) then
          do  j=1,3
            t(j)=t(j)+dgt(j,1)*x(1,n)+dgt(j,2)*x(2,n)+dgt(j,3)*x(3,n)
          enddo
        else
c
c--- Suche geeigneten punkt auf dem symmetrieelement.
c
          do  n1=0,1
            q(1)=x(1,n)-float(n1)
            do  n2=0,1
              q(2)=x(2,n)-float(n2)
              do  n3=0,1
                q(3)=x(3,n)-float(n3)
                do  j=1,3
                  p(j)=dgt(j,1)*q(1)+dgt(j,2)*q(2)+dgt(j,3)*q(3)
                enddo
                if (abs(p(1)*a(1)+p(2)*a(2)+p(3)*a(3))
     +            .lt. tol) go to 220
              enddo
            enddo
          enddo
c
c--- Kein punkt auf dem symmetrieelement gefunden. Das sollte
c    eigentlich nicht passieren!
c
          irc=4
          go to 240
c
c--- Bestimme einen ausgezeichneten punkt auf dem symmetrieelement.
c
  220     do  j=1,3
            t(j)=t(j)+p(j)
          enddo
        endif
      enddo
      temp2=1./float(k)
      do  j=1,3
        x1(j)=t(j)*temp2
      enddo
      do  j=1,3
        t(j)=dginv(j,1)*x1(1)+dginv(j,2)*x1(2)+dginv(j,3)*x1(3)
      enddo
c
c--- Teste, was aus dem gefundenen punkt bei anwendung der
c    symmetrie wird und ziehe originalpunkt ab.
c
      if (itt .ge. -2) then
        do  j=1,3
          x2(j)=sym(j,4,m)+sym(j,1,m)*t(1)+
     +    sym(j,2,m)*t(2)+sym(j,3,m)*t(3)-t(j)
          if (x2(j) .lt. -0.9999) x2(j)=x2(j)+1.
          if (x2(j) .gt.  0.9999) x2(j)=x2(j)-1.
        enddo
      endif
c
  230 continue
c
c--- Uebertrage die ergebnisse.
c
      do  j=1,3
        hub(j)=x2(j)
        pkt(j)=t(j)
      enddo
      iachse(1)=k1
      iachse(2)=k2
      iachse(3)=k3
      go to 999
c                            Fehler!
c
  240 continue
      if (iskp(4) .ne. 0) go to 999
      write (WRLINE,'(i3,a,3(f8.5,3f5.1))')
     + m,')',(sym(k,4,m),(sym(j,k,m),j=1,3),k=1,3)
      CALL KPWRTE (lptx)
      write (WRLINE,'(a,i4,a)') 'Cannot analyze symmetry',m,'. Reason:'
c
      go to (250,260,270,280),irc
  250 write (WRLINE(38:80),'(a,f10.5,a)')
     + 'Determinant:',det,' not +1 or -1.'
      go to 290
  260 write (WRLINE(38:80),'(a,f10.5,a)')
     +  'Trace:',temp,' must lie within -3,..,+3.'
      go to 290
  270 write (WRLINE(38:80),'(a)') 'No axis found.'
      go to 290
  280 write (WRLINE(38:80),'(a)') 'No point found on symmetry element.'
  290 CALL KPWRTE (lptx)
      if (iskp(13) .ne. 0) iskp(14)=4
c
  999 return
      END
