c                     ----------------------------
                       subroutine mitz (tmat,irc)
c                     ----------------------------
c
      IMPLICIT NONE
      INTEGER *4 irc
      REAL    *4 tmat(9)
c
c--- Unterprogramm, das gitterkonstanten und symmetrien transformiert.
c    Bei zellvergroesserungen werden automatisch zentrierungen dazu
c    generiert und bei zellverkleinerungen ggf. symmetrien entfernt.
c
c                 geschrieben: 281437 apr 1997 (Hundt)
c
c                     ----------------------------
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 i,j,k
      REAL    *4 st(4,4),stinv(4,4),sthilf(4,4),s(3,3),temp
      REAL    *4 arccos,volalt,volneu,temp2,t(3),aidn(9),tol
      DATA    aidn/1.,0.,0., 0.,1.,0., 0.,0.,1./,tol/0.01/
c
      irc=0
c                            Teste auf identitaet.
      do  i=1,9
        if (abs(tmat(i)-aidn(i)) .gt. tol) go to 2
      enddo
      return
   2  if (iskp(2) .gt. 0) then
        write (WRLINE,'(a,9f6.3,a)') 'TZ',tmat,' performed.'
        CALL KPWRTE (lptx)
      endif
      volalt=dgt(1,1)*dgt(2,2)*dgt(3,3)
c
c                            Kopiere eingabematrix ...
      k=1
      st(4,4)=1.
      do  i=1,3
        st(4,i)=0.
        st(i,4)=0.
        do  j=1,3
          st(j,i)=tmat(k)
          k=k+1
        enddo
      enddo
      do  i=1,4
        do  j=1,4
          stinv(i,j)=st(i,j)
        enddo
      enddo
C                            ... und invertiere.
C
      call minv (stinv,4,temp,s(1,1),s(2,2))
      if (temp .lt. 0.) then
        irc=1  ! Linkssystem
        write (WRLINE,'(a)')
     +  ' The transformation would generate a left-handed system.'
        CALL KPWRTE (lptx)
        return
      endif
      if (temp .lt. 0.001) then
        irc=2  ! Matrix singulaer
        write (WRLINE,'(a)') 'Matrix is singular.'
        CALL KPWRTE (lptx)
        return
      endif
C                            Drucke inverse Matrix
C
      if (iskp(2) .gt. 0) then
        write (WRLINE,'(a)') ' Inverted matrix:'
        CALL KPWRTE (lptx)
        do  j=1,3
          write (WRLINE,'('' '',3f10.5)') (stinv(j,i),i=1,3)
          CALL KPWRTE (lptx)
        enddo
      endif
c                            date trabij up.
      k=1
      do  j=1,3
        do  i=1,3
          s(i,j)=trabij(i,1)*tmat(k)+trabij(i,2)*tmat(k+1)+
     +    trabij(i,3)*tmat(k+2)
        enddo
        k=k+3
      enddo
      do  i=1,3
        do  j=1,3
          trabij(i,j)=s(i,j)
        enddo
      enddo
c                            Transformiere auch orgsh und die
c                            symmetrie-typangaben.
      do  i=1,3
        t(i)=stinv(i,1)*orgsh(1)+stinv(i,2)*orgsh(2)+
     +  stinv(i,3)*orgsh(3)
      enddo
      do  i=1,3
        orgsh(i)=t(i)
      enddo
      do  j=1,nsym
        do  i=1,3
          t(i)=aupkt(i,j)
        enddo
        do  i=1,3
          aupkt(i,j)=stinv(i,1)*t(1)+stinv(i,2)*t(2)+
     +    stinv(i,3)*t(3)
        enddo
        do  i=1,3
          t(i)=gleitk(i,j)
        enddo
        do  i=1,3
          gleitk(i,j)=stinv(i,1)*t(1)+stinv(i,2)*t(2)+
     +    stinv(i,3)*t(3)
        enddo
        do  i=1,3
          t(i)=iachsr(i,j)
        enddo
        do  i=1,3
          iachsr(i,j)=nint(stinv(i,1)*t(1)+stinv(i,2)*t(2)+
     +    stinv(i,3)*t(3))
        enddo
      enddo
      if (iskp(2) .gt. 1) then
        write (WRLINE,'(a)') '  '
        CALL KPWRTE (lptx)
        write (WRLINE,'(a)') 'Transformations performed so far:'
        CALL KPWRTE (lptx)
        write (WRLINE,'(a,3f10.6)') 'New origin ',(orgsh(i),i=1,3)
        CALL KPWRTE (lptx)
        write (WRLINE,'(a,9f8.4)') 'TZ ',((trabij(i,j),i=1,3),j=1,3)
        CALL KPWRTE (lptx)
      endif
C                            Transformiere.
      do  i=1,3
        do  j=1,3
          s(i,j)=dgt(i,1)*st(1,j)+dgt(i,2)*st(2,j)+dgt(i,3)*st(3,j)
        enddo
      enddo
C                            Bestimme die neuen Gitterkonstanten.
C                            Berechne Skalarprodukte.
      do  i=1,3
        do  j=i,3
          dgt(i,j)=s(1,i)*s(1,j)+s(2,i)*s(2,j)+s(3,i)*s(3,j)
        enddo
      enddo
      dgt(3,1)=dgt(1,3)
C                            Berechne Achsenlaengen.
      do  i=1,3
        zelle(i)=sqrt(dgt(i,i))
      enddo
C                            Berechne Winkel.
      do  i=1,3
        j=id2(i)
        k=id2(j)
        zelle(k+3)=arccos(dgt(i,j)/(zelle(i)*zelle(j)))
      enddo
      if (iskp(2) .gt. 0) then
        write (WRLINE,'(a)') 'The new unit-cell is now:'
        CALL KPWRTE (lptx)
        write (WRLINE,'(3f10.4,3f10.3)') zelle
        CALL KPWRTE (lptx)
      endif
      call miz
      volneu=dgt(1,1)*dgt(2,2)*dgt(3,3)
c
c
C                            Transformiere Koordinaten in der Atomliste.
c
c     IF (NAT-ISKP(53)) 510,510,470
c 470 DO 500 K=ISKP(53),NAT
c     DO 480 I=1,3
c 480 T(I)=STINV(I,1)*AT(1,K)+STINV(I,2)*AT(2,K)+STINV(I,3)*AT(3,K)
c     DO 490 I=1,3
c 490 AT(I,K)=T(I)
c 500 CONTINUE
C                            Transformiere Symmetrien
      if (nsym .le. 0) return
      do  i=1,nsym
        do  j=1,4
          do  k=1,3
          sthilf(k,j)=stinv(k,1)*sym(1,j,i)
     1               +stinv(k,2)*sym(2,j,i)+stinv(k,3)*sym(3,j,i)
          enddo
        enddo
        do  j=1,3
          do  k=1,4
            sym(j,k,i)=sthilf(j,1)*st(1,k)+sthilf(j,2)*st(2,k)
     1              +sthilf(j,3)*st(3,k)+sthilf(j,4)*st(4,k)
          enddo
          temp=sym(j,4,i)
          go to 20
   10     temp=temp+1.
   20     if (temp .lt. 0.) go to 10
          go to 40
   30     temp=temp-1.
   40     if (temp .gt. 0.999) go to 30
          if (temp .lt. 0.) temp=0.
          sym(j,4,i)=temp
        enddo
C
      enddo
c                            Teste, ob sich das zellvolumen veraendert
c                            hat.
      temp=volneu/volalt
      if (abs(temp-1.) .lt. 0.001) return
      if (iskp(2) .gt. 0) then
        write (WRLINE,'(a,f10.6,a)') 'The new cell-volume is',temp,
     +   ' times the old one.'
        CALL KPWRTE (lptx)
      endif
c                            Hat sich die zelle vergroessert?
      if (temp .gt. 1.01) then
        do  i=1,3
          temp2=0.
          do  j=1,3
            temp=stinv(j,i)
            go to 60
   50       temp=temp+1.
   60       if (temp .lt. 0.) go to 50
            go to 80
   70       temp=temp-1.
   80       if (temp .gt. 0.999) go to 70
            if (temp .lt. 0.) temp=0.
            stinv(j,i)=temp
            temp2=temp2+temp
          enddo
          if (temp2 .gt. 0) then
c
c                            Muss moeglicherweise als neue symmetrie
c                            aufgenommen werden, falls wir sie nicht
c                            schon hatten.
            do  j=1,i-1
              do  k=1,3
                if (abs(stinv(k,j)-stinv(k,i)) .gt. 0.001) go to 90
              enddo
              go to 100
   90         continue
            enddo
            nsym=nsym+1
            do  j=1,3
              do k=1,3
                sym(j,k,nsym)=0.
              enddo
              sym(j,j,nsym)=1.
              sym(j,4,nsym)=stinv(j,i)
            enddo
            if (iskp(2) .gt. 0) then
              write (WRLINE,'(a,i3,a,3(f6.4,a))')
     +        'New symmetry added (',nsym,'): ',stinv(1,i),' + x, ',
     +        stinv(2,i),' + y, ',stinv(3,i),' + z'
              CALL KPWRTE (lptx)
            endif
          endif
  100     continue
        enddo
      else
c                            Zelle hat sich verkleinert.
c                            Entferne ggf. symmetrien.
        call mirmsy (0)
      endif
      return
      END
