c                           ----------------
                             subroutine miz
c                           ----------------
c
c--- Berechnet aus den eingegebenen gitterkonstanten die matrizen
c    DGT und DGINV
c
c                 geschrieben: 140900 JAN 1997 (Hundt)
c                   geaendert: 291144 MAY 2002 (Hundt)
c
c                           ----------------
c
      IMPLICIT NONE
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
c
      INTEGER *4 i,j
      REAL    *4 temp
c
c                            Teste Plausibilitaet der Gitterkonstanten
C                            und der Winkel.
      temp=0.
      j=0
      do  i=1,3
        if ((zelle(i).lt. .9) .or.
     +      (zelle(i+3) .lt. 1.) .or. (zelle(i+3) .gt. 179.)) j=1
        temp=temp+zelle(i+3)
      enddo
      if (temp .ge. 360.) j=1
      if (j .gt. 0) then
        write (WRLINE,'(3f10.5,3f10.3)') zelle
        CALL KPWRTE (lptx)
        write (WRLINE,'(a)')
     +  'Lattice constants not plausible or invalid.'
        CALL KPWRTE (lptx)
        iskp(14)=1
        go to 999
      endif
C                            Basis des direkten Gitters.
      do  i=1,3
        do  j=1,3
          dgt(i,j)=0.
          dginv(i,j)=0.
        enddo
      enddo
      dgt(1,1)=zelle(1)
      dgt(1,2)=zelle(2)*cos(zelle(6)*const(3))
      dgt(2,2)=sqrt(zelle(2)*zelle(2)-dgt(1,2)*dgt(1,2))
      dgt(1,3)=zelle(3)*cos(zelle(5)*const(3))
      dgt(2,3)=(zelle(2)*zelle(3)*cos(zelle(4)*const(3))-
     +         dgt(1,2)*dgt(1,3))/dgt(2,2)
      dgt(3,3)=sqrt(zelle(3)*zelle(3)-
     +         dgt(1,3)*dgt(1,3)-dgt(2,3)*dgt(2,3))
c
C                            Basis des reziproken Gitters.
      dginv(1,1)=1./dgt(1,1)
      dginv(2,2)=1./dgt(2,2)
      dginv(3,3)=1./dgt(3,3)
      dginv(1,2)=-dgt(1,2)/(dgt(2,2)*dgt(1,1))
      dginv(2,3)=-dgt(2,3)/(dgt(2,2)*dgt(3,3))
      dginv(1,3)=(dgt(1,2)*dgt(2,3)/dgt(2,2)-dgt(1,3))
     +           /(dgt(1,1)*dgt(3,3))
c
      if (iskp(2) .gt. 2) then
        write (WRLINE,'(a)') 'Cell constants:'
        CALL KPWRTE (lptx)
        write (WRLINE,'(3f10.5,3f10.3)') zelle
        CALL KPWRTE (lptx)
        write (WRLINE,'(a)') ' '
        CALL KPWRTE (lptx)
        write (WRLINE,'(a)') 'Base of direct lattice:'
        CALL KPWRTE (lptx)
        do  i=1,3
          write (WRLINE,'(3f12.6)') (dgt(i,j),j=1,3)
          CALL KPWRTE (lptx)
        enddo
        write (WRLINE,'(a)') ' '
        CALL KPWRTE (lptx)
        write (WRLINE,'(a)') 'Basis of reciprocal lattice:'
        CALL KPWRTE (lptx)
        do  i=1,3
          write (WRLINE,'(3f12.6)') (dginv(i,j),j=1,3)
          CALL KPWRTE (lptx)
        enddo
      endif
c
      do  i=1,3
        do  j=1,3
          dreh(i,j)=0.
          tra(i,j)=dgt(i,j)
          trainv(i,j)=dginv(i,j)
        enddo
        dreh(i,i)=1.
      enddo
c
  999 return
      END
