c                          ------------------
                            subroutine mkgrp
c                          ------------------
c
c--- Das programm mkgrp benutzt die auf dem bereich sym uebergebenen
c    symmetrien als erzeugendensystem fuer eine raumgruppe.
c
c                 geschrieben: 300953 AUG 1996 (Hundt)
c                   geaendert: 191842 JAN 2010 (Hundt)
c
c                          ------------------
c
      implicit none
c
      include 'mispg.inc'
      INCLUDE 'WRBFR.INC'
c
      integer *4 itstmt,ivwmax
      parameter (itstmt=9, ivwmax=25)
      integer *4 nsyms,i,j,k,l,n,isym,itstz(itstmt)
      integer *4 iatyp,isverw(ivwmax)
      integer *4 iv(3),isynr,irc,i1,i2,i3
      real    *4 v(3),temp
c
      data itstz/-1,-6,-3,6,4,2,-4,-2,3/
c
c--- Berechne die transformationsmatrizen zur umrechnung ins
c    kartesische system und umgekehrt.
c
      if (nsym .lt. 0) then
        nsym=-nsym
        go to 60
      endif
      nsyms=nsym
c
c--- Teste, ob die symmetrien zellverkleinernde symmetrien enthalten.
c
      if (iskp(16) .ne. 0) go to 20
   10 do  i=1,nsym
        call mitsgz (i,irc)
        if (iskp(14) .ne. 0) go to 999
        if (irc .gt. 0) then
          iskp(12)=0
          go to 10
        endif
      enddo
   20 if (iskp(12) .eq. 0) then
        do  i=1,nsym
c
c--- Lege fuer jede symmetrie fest, welcher art die symmetrie ist,
c    ob sie einen fixpunkt besitzt, und bestimme
c    einen punkt, der auf dem symmetrieelement liegt.
c
          call misyan (i,isytyp(1,i),iachsr(1,i),gleitk(1,i),
     +    aupkt(1,i),irc)
          if (irc .gt. 0) then
            write (WRLINE,'(a)')
     +      'Invaldid symmetry encountered.'
            CALL KPWRTE (lptx)
            iskp(14)=2
            go to 999
          endif
          isytyp(2,i)=-irc
        enddo
      endif
c
c--- Suche ursprungsfixierende symmetrie(n) und transformiere ggf. so,
c    dass hieraus die position 0,0,0 wird, falls nicht verboten.
c
      if (iskp(11) .ne. 0 .or. iskp(16) .ne. 0) go to 60
      if (nsyms .gt. ivwmax) nsyms=ivwmax
      do  i=1,nsyms
        isverw(i)=0
      enddo
      do  i=1,3
        iv(i)=0
        v(i)=0.
      enddo
      if (nsym .ge. 2) then
c
c--- Teste den fall, dass es nur -4 achsen gibt und und keine anderen
c    symmetrien, die den ursprung fixieren (P-4, I-4 etc.).
c
        do  isynr=1,nsyms
          if (isytyp(1,isynr) .eq. -4) then
            i=isynr
            go to 21
          endif
        enddo
        go to 29
   21   continue
        j=0
        do  isynr=1,nsyms
          k=isytyp(1,isynr)
          if ((k .ne. -4) .and. (abs(k) .gt. 2)) go to 29
          if (k .eq. 2) j=j+1
        enddo
        if (j .gt. 2) go to 29
c
C--- Fuehre eine ursprungsfixierung durch.
c
        do  j=1,3
          v(j)=aupkt(j,i)
        enddo
        go to 50
c
   29   do  iatyp=1,itstmt
          do  isynr=1,nsyms
            if ((isverw(isynr) .eq. 0) .and.
     +          (isytyp(1,isynr) .eq. itstz(iatyp))) then
c
c--- Zentrum oder andere ursprungsbestimmende symmetrie gefunden.
c    Analysiere.
c
              if (iatyp .le. 3) then
c
c--- Im falle eines zentrums oder einer drehinversionsachse (ausser
c    -2=m) sind wir schon fertig.
c
                do  l=1,3
                  v(l)=aupkt(l,isynr)
                enddo
                go to 50
              endif
c
c--- Symmetrie liefert nur partiellen beitrag.
c
              if ((iatyp .ge. 4) .and. (iatyp .le. 7)) then
c
c--- Es handelt sich um eine drehachse. -4 -achsen werden
c    wie zweizaehlige achsen behandelt.
c
                do  i1=1,3
                  i2=id2(i1)
                  i3=id2(i2)
                  if ((iachsr(i1,isynr) .ne. 0)
     +              .and.(iachsr(i2,isynr) .eq. 0)
     +              .and.(iachsr(i3,isynr) .eq. 0)) then
                    if (iv(i2) .eq. 0) then
                      iv(i2)=1
                      v(i2)=aupkt(i2,isynr)
                    endif
                    if (iv(i3) .eq. 0) then
                      iv(i3)=1
                      v(i3)=aupkt(i3,isynr)
                    endif
                    if (iv(1)+iv(2)+iv(3) .eq. 3) go to 50
                    isverw(isynr)=1
                    go to 30
                  endif
                enddo
c
c--- Achse kann nicht verwendet werden
c
                go to 30
              endif
c
c--- Sonderfall: Spiegelebene. Benutze nur solche, die zu achsen
c    parallel liegen.
c
              if (iatyp .eq. 8) then
                do  i1=1,3
                  i2=id2(i1)
                  i3=id2(i2)
                  if ((iachsr(i1,isynr) .ne. 0)
     +              .and.(iachsr(i2,isynr) .eq. 0)
     +              .and.(iachsr(i3,isynr) .eq. 0)) then
                    if (iv(i1) .eq. 0) then
                      iv(i1)=1
                      v(i1)=aupkt(i1,isynr)
                      isverw(isynr)=1
                      if (iv(1)+iv(2)+iv(3) .eq. 3) go to 50
                      go to 30
                    endif
                  endif
                enddo
              endif
c
c--- Spezialfall: dreizaehlige achse.
c
              if (iatyp .eq. 9) then
                i=abs(iachsr(1,isynr))+abs(iachsr(2,isynr))+
     +          abs(iachsr(3,isynr))
                if (i .eq. 3) then
                  do  i=1,3
                    v(i)=aupkt(i,isynr)
                  enddo
                  go to 50
                endif
c
c--- Wenn i .ne. 1: nicht brauchbar
c
                if (i .ne. 1) go to 30
                do  i1=1,3
                  i2=id2(i1)
                  i3=id2(i2)
                  if (iachsr(i1,isynr) .ne. 0) then
                    if ((abs(zelle(i1+3)-120.) .lt. 0.5) .and.
     +              (abs(zelle(i2+3)-90.) .lt. 0.5) .and.
     +              (abs(zelle(i3+3)-90.) .lt. 0.5)) then
                      if (iv(i2) .eq. 0) then
                        iv(i2)=1
                        v(i2)=aupkt(i2,isynr)
                      endif
                      if (iv(i3) .eq. 0) then
                        iv(i3)=1
                        v(i3)=aupkt(i3,isynr)
                      endif
                      if (iv(1)+iv(2)+iv(3) .eq. 3) go to 50
                      isverw(isynr)=1
                      go to 30
                    endif
                  endif
                enddo
              endif
            endif
   30       continue
          enddo  ! next isynr
   40     continue
        enddo  ! next iatyp
      endif
c
   50 temp=0.
      do  i=1,3
        temp=temp+abs(v(i))
      enddo
      if (temp .eq. 0.) go to 60
c
      if (iskp(2) .gt. 0) then
        write (WRLINE,'(A,3F10.5,A)') 'TZUR',v,' applied (temporary).'
        CALL KPWRTE (lptx)
      endif
      call miexso (v)
c
c--- Durch rechenungenauigkeiten koennen nicht erlaubte translationen
c    entstehen. Diese werden gerundet.
c
   60 continue
      do  i=1,nsym
        do  j=1,3
          do  k=1,3
            do  n=-2,2
              temp=float(n)
              if (abs(sym(k,j,i)-temp) .lt. const(8)) then
                sym(k,j,i)=temp
                go to 70
              endif
            enddo
   70       continue
          enddo
          k=nint(sym(j,4,i)*12.)
          if (k .ge. 12) k=k-12
          sym(j,4,i)=float(k)/12.
        enddo
        call misyan (i,isytyp(1,i),iachsr(1,i),gleitk(1,i),
     +  aupkt(1,i),irc)
        if (irc .gt. 0) then
          write (WRLINE,'(a)')
     +    'Invaldid symmetry encountered.'
          CALL KPWRTE (lptx)
          iskp(14)=2
          go to 999
        endif
        isytyp(2,i)=-irc
      enddo
c
   80 if (nsym .ge. 2) then
        isym=2
c                            Wende Symmetrie isym auf alle bisherigen
c                            Symmetrien an.
   90   do  i=2,isym
          irc=4
          call misprd (isym,i,irc)
          if (iskp(14) .ne. 0) go to 999
          if (nsym .eq. nsymdm) go to 100
          if (irc .eq. 0 .and. iskp(16) .eq. 0) then
            call mitsgz (nsym,irc)
            if (iskp(14) .ne. 0) go to 999
            if (irc .gt. 0) then
              iskp(12)=0
              go to 10
            endif
          endif
        enddo
        isym=isym+1
        if (isym .le. nsym) go to 90
      endif
  100 continue
      write (WRLINE,'(a)') ' '
      CALL KPWRTE (lptx)
      write (WRLINE,'(i3,a,i3,a)')
     1 nsyms,' symmetries present,',nsym-nsyms,' symmetries generated.'
      CALL KPWRTE (lptx)
      write (WRLINE,'(a)') ' '
      CALL KPWRTE (lptx)
  999 return
      END
