C                  --------------------------------
                    SUBROUTINE PAXES (ICODE,ITYPE)
C                  --------------------------------
C
C                  BEARBEITET: 171129 JAN 90 (HUNDT)
C
      IMPLICIT NONE
      INTEGER *4 ICODE,ITYPE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
C
C     ***** ITYPE .LT.0 FOR COVARIANCE MATRIX IN Q *****
C     ***** ITYPE .GT.0 FOR ELLIPSOID QUADRATIC FORM IN Q *****
C     ***** XABSF(ITYPE)=1 BASED ON TRICLINIC COORDINATE SYSTEM *****
C     ***** =2 OR 3 FOR WORKING OR REFERENCE CARTESIAN SYSTEMS *****
C
      INTEGER *4 I,ITA,J,K,KS,II
      REAL    *4 W(3,3),XX(3),T1,TEMP,TEMP2,AATF(17,IATFDM),ZUSCHL
C
      EQUIVALENCE (IATF(1,1),AATF(1,1))
C
C                            Bestimme zuschlag fuers putzen.
      ZUSCHL=0.
      IF (ICDS(6) .EQ. 0) THEN
        IF (CONST(44) .LE. 0.) THEN
          ZUSCHL=T(1)
        ELSE
          ZUSCHL=T(1)+(AATF(15,ISKP(61))+
     +    AATF(16,ISKP(61))*X(1,3)*CONST(44))/O9
        ENDIF
      ENDIF
C
C     ***** CHECK ATOM CODE *****
C
      ITA=IABS(ITYPE)-1
      KS=MOD(ICODE,100)
      IF (KS .GT. NSYMDM) THEN
        NG=4
        RETURN
      ENDIF
      II=ICODE/200000
      IF ((II .GT. NATDM) .OR. (II .LE. 0)) THEN
        NG=5
        RETURN
      ENDIF
C
C     ***** CRYSTALLOGRAPHIC SYMMETRY ROTATION *****
C
C                            Speichere PA zurueck
C
      DO  J=1,3
        TEMP=0.
        DO  I=1,3
          TEMP2=TRA(I,1,NS)*TFVKT(1,J,II,NS)+
     +    TRA(I,2,NS)*TFVKT(2,J,II,NS)+TRA(I,3,NS)*TFVKT(3,J,II,NS)
          TEMP=TEMP+TEMP2*TEMP2
        ENDDO
        TEMP=SQRT(TEMP)
C
C                Beaufschlage die Eigenwerte, wenn geputzt wird.
C
        EV(J)=TEMP+ZUSCHL
        DO  I=1,3
          PA(I,J)=TFVKT(I,J,II,NS)/TEMP
        ENDDO
      ENDDO
C     CALL TMM (PA(1,1,II),FS(1,1,KS),PAT)  AUFGELOEST IN:
      DO  I=1,3
        K=2
        DO  J=1,3
          PAT(J,I)=SYM(K,KS,NS)*PA(1,I)+SYM(K+1,KS,NS)*PA(2,I)+
     +    SYM(K+2,KS,NS)*PA(3,I)
          K=K+4
        ENDDO
      ENDDO
      IF (ITA .EQ. 1) THEN
C
C     ***** TRANSFORM TO CARTESIAN SYSTEMS *****
C
        CALL TMM (PAT,AAWRK(1,1,NS),PAC)
      ELSE IF (ITA .GT. 1) THEN
        CALL TMM (PAT,AAREV(1,1,NS),PAC)
      ELSE
        IF (ITYPE .NE. 0) THEN
C
C     ***** (PAT)**(-1) * (AA)**(-1) *****
C
          CALL AXEQB (PAT,W,BB(1,1,NS),3)
        ENDIF
      ENDIF
C
C     ***** FORM DIAGONAL MATRIX OR ITS INVERSE *****
C
      DO  J=1,3
        T1=EV(J)
        IF (ITYPE .GT. 0) THEN
          XX(J)=1./(T1*T1)
        ELSE IF (ITYPE .LT. 0) THEN
          XX(J)=T1*T1
        ENDIF
        RMS(J)=T1
      ENDDO
C
C     ***** FORM QUADRATIC FORM *****
C
      DO  I=1,3
        DO  J=I,3
          T1=0.0
          IF (ITA .EQ. 0) THEN
C
C         ***** BASED ON TRICLINIC SYSTEM *****
C
            DO  K=1,3
              T1=T1+PAT(I,K)*W(K,J)*XX(K)
            ENDDO
          ELSE IF (ITA .GT. 0) THEN
C
C         ***** BASED ON CARTESIAN SYSTEM *****
C
            DO  K=1,3
              T1=T1+PAC(I,K)*PAC(J,K)*XX(K)
            ENDDO
          ELSE
            RETURN
          ENDIF
          Q(J,I)=T1
          Q(I,J)=T1
        ENDDO
      ENDDO
      RETURN
      END
