CKPAWTB   39             -------------------
                          SUBROUTINE ZVAWTB
C  CY-ENG-              -------------------
C
C                        Geschrieben: Hundt
C                  Geaendert 131724 JUL 2000 (Hundt)
C
C    Das Programm berechnet und druckt eine Abstandstabelle (ATAB)
C    oder eine Abstands- und Winkeltabelle (WTAB).
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 INPPAR(8),I,I1,I2,I3,I4,I5,ICDIC,IDQC,IDRCH,IPOI
      INTEGER *4 IPOIS,ISKP14,ITABP,ITABS,ITM1,J,J1,J2,J3,J4,J5,JH
      INTEGER *4 JPOI,K1,K2,K3,K4,K5,K8SV,KEYIN,KH,NCDASV,NCDSV
      INTEGER *4 NCHOPT,NTYPS
      REAL    *4 CDS(7),RNPPAR(8),ARCCOS,DMAX,DMINQ,DRCH,TEMP,V(3)
C
      EQUIVALENCE (CDS(1),ICDS(1)),(INPPAR(1),RNPPAR(1))
C
      CONST(39)=1000000.
      IF (ISKP(14) .EQ. 0) THEN
C
C                            Hole Input
        INPPAR(2)=0
        RNPPAR(5)=3.
        RNPPAR(6)=.0001
        RNPPAR(7)=0.
        RNPPAR(8)=181.
        CALL FLES (INPPAR,ISKP(31),7H2C2I4FE,
CYENG1
     1   42Hc1,c2,n1,n2,dmax <,dmin <,wmin <,wmax>>>?$)
CYENG2
CYENGY     1   42Hc1,c2,n1,n2,dmax <,dmin <,amin <,amax>>>?$)
        IF (ISKP(32) .LT. 2) THEN
          IERR=39 0041 16
          GO TO 999
        ENDIF
C
        IF (RNPPAR(5) .LT. RNPPAR(6)) THEN
          CDS(6)=RNPPAR(6)
          RNPPAR(6)=RNPPAR(5)
          RNPPAR(5)=CDS(6)
        ENDIF
C
        DO  I=1,6
          ICDS(I)=INPPAR(I)
        ENDDO
        IF (ICDS(2) .LE. 0.) ICDS(2)=ICDS(1)
      ENDIF
C
C                            Save Pointer
      NCDSV=NCD(NS)
      NCDASV=NCDA(NS)
      ISKP14=ISKP(14)
      NTYPS=NTYP
      K8SV=K8(NS)
      ISKP(14)=1
      NCDA(NS)=NCD(NS)+1
C
C                            Setze Nachbar-Molek.-Option
      NCHOPT=0
      IF (NTYP .EQ. 1 .AND. RNPPAR(7) .NE. 0. .AND.
     +    NCDSV .GE. NCDASV) NCHOPT=1
C
C                            Konstruiere Lauf der Urspr.-Atome
      NTRY=16
      NC=1
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 990
      I1=IANR
      I2=IT(1)
      I3=IT(2)
      I4=IT(3)
      I5=ISYNR
      NC=2
      IF (ICDS(NC) .LE. NATDM) THEN
        IANR=ICDS(2)
      ELSE
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 990
      ENDIF
      K1=MAX0(IANR,I1)
      K2=MAX0(IT(1),I2)
      K3=MAX0(IT(2),I3)
      K4=MAX0(IT(3),I4)
      K5=MAX0(ISYNR,I5)
      IZ1=ICDS(3)
      IZ2=ICDS(4)
      DMAX=CDS(5)
      DMINQ=CDS(6)*CDS(6)
      DO  J1=I1,K1
      DO  J2=I2,K2
      DO  J3=I3,K3
      DO  J4=I4,K4
      DO  J5=I5,K5
      NCD(NS)=NCDA(NS)-1
      K8(NS)=K8SV
      NC=1
      NTRY=24
      ICDS(NC)=(((J1*10+J2)*10+J3)*10+J4)*200+J5
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 990
      DO  I=1,3
        V(I)=X(I,1)
      ENDDO
      DQ=DMAX
      CONST(20)=DMINQ
      NTYP=3
      CALL ZVAVBR
C                            Berechne Abstaende
C
      IF (NCD(NS)-NCDA(NS) .GT. 70) THEN
        WRITE (WRLINE,'(A)') 'ZVAWTB0123 - Stack overflow.'
        CALL KPWRTE (NTDISP)
        GO TO 990
      ENDIF
      IDQC=0
      DO  IC=NCDA(NS),NCD(NS)
        IDQC=IDQC+1
        DO  I=1,3
          X1(I)=V(I)-ATOMS(I,IC,NS)
        ENDDO
        TEMP=0.
        DO  I=1,3
          TEMP=TEMP+(DG(I,1,NS)*X1(1)+DG(I,2,NS)*X1(2)+
     +    DG(I,3,NS)*X1(3))**2
        ENDDO
        AIN(IDQC)=TEMP
      ENDDO
C                            Sortiere gefundene Atome
      IPOI=0
      IPOIS=0
      ITABP=NCDA(NS)-1
      ITABS=ITABP
   10 IF (ITABP .GE. NCD(NS)) GO TO 40
      ITABP=ITABP+1
      IPOI=IPOI+1
      TEMP=AIN(IPOI)
      IF (TEMP .LT. DMINQ) GO TO 10
      ITM1=ICD(ITABP,NS)
      ITABS=ITABS+1
      IPOIS=IPOIS+1
      JH=IPOIS
      KH=ITABS
      GO TO 30
   20 AIN(JH+1)=AIN(JH)
      ICD(KH+1,NS)=ICD(KH,NS)
   30 JH=JH-1
      KH=KH-1
      IF (JH .GT. 0 .AND. TEMP .LT. AIN(JH)) GO TO 20
      AIN(JH+1)=TEMP
      ICD(KH+1,NS)=ITM1
      GO TO 10
C                            Merke kuerzesten Abstand
C
   40 IF (NCD(NS) .GE. NCDA(NS) .AND. AIN(1) .LT. CONST(39))
     + CONST(39)=AIN(1)
C
C                            Teste, ob nur Nachbarn gesucht
      ICDS(7)=ITABS
      IF (NTYPS .EQ. 3) GO TO 990
C
C                            Drucke Tabelle
C
      IF (ITABS-NCDA(NS) .LT. 0 .AND. ISKP(58) .EQ. 0) GO TO 180
      NC=1
      WRITE (WRLINE,50)
   50 FORMAT (' ')
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,60)
      CALL KPWRTE (NTOUT)
   60 FORMAT ('+',18(1H-),'+',10(1H-),'+',11(1H-),'+',32(1H-),'+')
      CALL KPCDST (ISKP(80),1,ICDS(NC))
      WRITE (WRLINE,70) AT(5,J1,NS),AT(6,J1,NS),(ISKP(JH),JH=80,82),
     +(X(JH,NC),JH=1,3)
      CALL KPWRTE (NTOUT)
   70 FORMAT (
CYENG1
     1 'I Abstand / Winkel I ',2A4,' I',2A4,A2,' I ',3F10.6,' I')
CYENG2
CYENGY     1 'I Distance / Angle I ',2A4,' I',2A4,A2,' I ',3F10.6,' I')
      WRITE (WRLINE,60)
      CALL KPWRTE (NTOUT)
      DRCH=0.
      IDRCH=0
      NC=2
      NTRY=42
      IC=NCDA(NS)-1
      IPOI=0
      GO TO 100
   80 IC=IC+1
      IPOI=IPOI+1
C                            Teste, ob das Atom gedruckt wird.
      IF (NCHOPT .NE. 0) THEN
C                            Teste, ob der Code vorkommt.
        ICDIC=ICD(IC,NS)
        DO  JH=NCDASV,NCDSV
          IF (ICD(JH,NS) .EQ. ICDIC) GO TO 100
        ENDDO
      ENDIF
C                            Nicht gefunden.  Drucke.
      CALL ZVDEK
      ATOMS(1,IC,NS)=X1(1)
      ATOMS(2,IC,NS)=X1(2)
      ATOMS(3,IC,NS)=X1(3)
      TEMP=SQRT(AIN(IPOI))
c      AIN(IPOI)=TEMP
      DRCH=DRCH+TEMP
      IDRCH=IDRCH+1
      CALL KPCDST (ISKP(80),1,ICD(IC,NS))
      WRITE (WRLINE,90) TEMP,AT(5,IANR,NS),AT(6,IANR,NS),
     1(ISKP(JH),JH=80,82),(X(JH,NC),JH=1,3)
      CALL KPWRTE (NTOUT)
   90 FORMAT ('I    =',F7.4,' A    I ',2A4,' I',2A4,A2,' I ',
     1 3F10.6,' I')
      IF (KEYIN(0) .EQ. ISKP(20)) THEN
        IERR=-1
        GO TO 990
      ENDIF
  100 IF (IC .LT. ITABS) GO TO 80
      IF (IDRCH .GT. 0) DRCH=DRCH/FLOAT(IDRCH)
C
C                            Teste, ob auch Winkel berechnet werden s.
C
      IF (NTYPS-2) 170,110,180
C
C                            Teste, ob welche berechnet werden koennen
C
  110 IF (ITABS .LT. NCDA(NS)+1) GO TO 170
C
C                            Ja.  Berechne die kart. Koord. des Z-atoms
      NC=1
      NTRY=26
      CALL ZVDEK
C                            Schreibe Trennzeile.
C
      WRITE (WRLINE,60)
      CALL KPWRTE (NTOUT)
      NTRY=32
      IPOI=0
      I=NCDA(NS)-1
      GO TO 160
C
  120 IPOI=IPOI+1
      JPOI=IPOI
      NC=2
      IC=I
      CALL ZVDEK
      ICDS(2)=IANR
      J=I
      GO TO 150
C
  130 JPOI=JPOI+1
c      TEMP=AIN(IPOI)*AIN(JPOI)
      TEMP=sqrt(AIN(IPOI)*AIN(JPOI))
      IF (TEMP .LE. 0.) GO TO 150
C
      NC=3
      IC=J
      CALL ZVDEK
      TEMP=((ATOMS(1,I,NS)-X1(1))*(ATOMS(1,J,NS)-X1(1))
     1     +(ATOMS(2,I,NS)-X1(2))*(ATOMS(2,J,NS)-X1(2))
     2     +(ATOMS(3,I,NS)-X1(3))*(ATOMS(3,J,NS)-X1(3)))/TEMP
      TEMP=ARCCOS(TEMP)
C
C                            Teste Zusatzbedingung
C
      IF (TEMP .GE. RNPPAR(7) .AND. TEMP .LE. RNPPAR(8)) THEN
        CALL KPCDST (ISKP(80),1,ICD(I,NS))
        IT(1)=ISKP(80)
        IT(2)=ISKP(81)
        IT(3)=ISKP(82)
        CALL KPCDST (ISKP(80),1,ICD(J,NS))
        WRITE (WRLINE,140) TEMP,AT(5,ICDS(2),NS),AT(6,ICDS(2),NS),
     +   AT(5,IANR,NS),AT(6,IANR,NS),IT,(ISKP(JH),JH=80,82)
        CALL KPWRTE (NTOUT)
CYENG1
  140   FORMAT ('I  =',F7.2,'  Grad  I ',2A4,' I  ',2A4,' I',
CYENG2
CYENGY  140   FORMAT ('I  =',F7.2,'  Deg.  I ',2A4,' I  ',2A4,' I',
     1   3X,3A4,2X,3A4,3X,'I')
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 990
        ENDIF
      ENDIF
C
  150 J=J+1
      IF (J .LE. ITABS) GO TO 130
C
  160 I=I+1
      IF (I .LT. ITABS) GO TO 120
  170 WRITE (WRLINE,60)
      CALL KPWRTE (NTOUT)
CYENG1
      WRITE (WRLINE,'(I3,A,F7.4)') IDRCH,' Abstaende. Mittelwert:',DRCH
CYENG2
CYENGY      WRITE (WRLINE,'(I3,A,F7.4)') IDRCH,' distances. Mean:',DRCH
      CALL KPWRTE (NTOUT)
C
  180 CONTINUE
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C                            Restore
  990 NCD(NS)=NCDSV
      NCDA(NS)=NCDASV
      ISKP(14)=ISKP14
      K8(NS)=K8SV
C                            Hinterlege kuerzesten Abstand
C
      CONST(39)=SQRT(CONST(39))
  999 RETURN
      END
