C         92              -------------------
                           SUBROUTINE ZVCMPS
C  CY-ENG-                -------------------
C
C  Es wird ein strukturfragment (finite gruppe) in einer struktur
C  (infiniten gruppe) gesucht. Die finite gruppe wird nicht als
C  starrer koerper behandelt.
C
C                geschrieben: 131100 MAR 2002  (Hundt)
C                  geaendert: 230906 DEC 2003  (Hundt)
C
C                         -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 NIDIM
      PARAMETER (NIDIM=48)
C
      INTEGER *4 INBFR(12),KDALLE,IAT(6,PARDIM,2),NAME,I,J,K,M,MERK
      INTEGER *4 NIDL(NIDIM),NIDLP,IK0,IK1,IK2,IAIN(72),ICPOI,II,JJ,MM
      INTEGER *4 ITF(9*PARDIM),ITFS,ITFE,ITFP,ITFQ,MP,ICEND,NFINIT
      INTEGER *4 IRLINE(30),C1,C2,C3,LSNG,MAXERL,KEYIN,NCDSAV,NFIORG
      INTEGER *4 NAFCNT
C
      REAL    *4 AINBFR(12),TEMP,TEMP2,SPKT(3),DIDL(3),DUQ
      REAL    *4 TR(3,2),A1(3,3),A2(3,3),B(3,3),TRV(3),AKBOX(3)
      REAL    *4 G(3,3),G1(4),G2(3),DAMAX0,DAMAX,E(4,4),EE(4,3)
      REAL    *4 TQV(3),DUMG,Y(3,8),Z(3,3),GMAX,GMIN
C
      SAVE INBFR,NFIORG
C
      EQUIVALENCE (INBFR(1),AINBFR(1)),(AT(1,1,1),IAT(1,1,1))
      EQUIVALENCE (AIN(1),IAIN(1)),(TFVKT(1,1,1,1),ITF(1))
      EQUIVALENCE (WRLINE,IRLINE(1))
C
      DATA AINBFR/6*0.,3.,0.,0.,0.25,0.,0./,KDALLE/4HALLE/
C
      IF (NTYP .EQ. 1) THEN
        NFIORG=0
        CALL FLES (INBFR,ISKP(31),13H2IA2IAF2IF2IE,
     +  44Hn1,n2,refs,m1,m2,reft,d,k1,k2,tol,opt,opt2?$)
      ELSE
        CALL FLES (INBFR(10),ISKP(31),4HF2IE,14Htol,opt,opt2?$)
      ENDIF
      IF (INBFR(1) .EQ. 0 .AND. INBFR(5) .NE. 0) INBFR(1)=INBFR(5)+1
      IF (INBFR(4) .EQ. 0 .AND. INBFR(2) .NE. 0) INBFR(4)=INBFR(2)+1
      IF (INBFR(1) .LE. 0 .OR. INBFR(2) .GT. NAT(NS) .OR.
     + INBFR(1) .GT. INBFR(2)) GO TO 990
      IF (INBFR(4) .LE. 0 .OR. INBFR(5) .GT. NAT(NS) .OR.
     + INBFR(4) .GT. INBFR(5)) GO TO 990
      CALL CNVTUP (INBFR(3),1,4)
      IF (INBFR(3) .EQ. KDALLE) INBFR(3)=0
      CALL CNVTUP (INBFR(6),1,4)
      IF (INBFR(6) .EQ. KDALLE) INBFR(6)=0
      NFINIT=INBFR(2)-INBFR(1)+1
      IF (NFIORG .EQ. 0) NFIORG=INBFR(2)
      ITFS=9*NAT(NS)+1
      ITFE=9*PARDIM
      DUMG=AINBFR(7)
      IF (AINBFR(7) .LE. 0.) THEN
        DUMG=1.6
        IF (AINBFR(7) .LT. 0.) DUMG=-AINBFR(7)
      ENDIF
      DUQ=DUMG*DUMG
C                            Kasten in die die toleranzbox passt.
      DO  I=1,3
        AKBOX(I)=AINBFR(10)*RK(I,NS)
      ENDDO
C                            Maximal erlaubte atome in diesem kasten.
      MAXERL=1
      IF (ISKP(76) .NE. 0) MAXERL=100
C
C                            Suche ein atom, das moeglichst in der
C                            mitte des fragments liegt.
      DO  J=1,3
        SPKT(J)=0.
      ENDDO
      IC=0
      NC=1
      NTRY=42
      DO  I=INBFR(1),INBFR(2)
        IC=IC+1
        ICD(IC,NS)=I*200000+111001
        CALL ZVDEK
        DO  J=1,3
          ATOMS(J,IC,NS)=X1(J)
          SPKT(J)=SPKT(J)+X1(J)
        ENDDO
      ENDDO
      NCD(NS)=IC
      TEMP=1./FLOAT(NCD(NS))
      DO  J=1,3
        SPKT(J)=SPKT(J)*TEMP
      ENDDO
C                            Suche einen punkt nahe beim schwerpunkt.
      TEMP=1.E6
      MERK=0
      DO  I=1,NCD(NS)
        IF (INBFR(3) .NE. 0) THEN
          IANR=ICD(I,NS)/200000
          NAME=IAT(5,IANR,NS)
          CALL CNVTUP (NAME,1,4)
          IF (NAME .NE. INBFR(3)) GO TO 10
        ENDIF
        DQ=(ATOMS(1,I,NS)-SPKT(1))**2+(ATOMS(2,I,NS)-SPKT(2))**2+
     +  (ATOMS(3,I,NS)-SPKT(3))**2
        IF (DQ .LT. TEMP) THEN
          TEMP=DQ
          MERK=I
        ENDIF
   10   CONTINUE
      ENDDO
      IF (MERK .EQ. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVCMPS0118 - Keinen Schwerpunkt gefunden.'
CYENG2
CYENGY     +  'KPCMPS0118 - No center of gravity found.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      IK0=ICD(MERK,NS)/200000
C                            Suche zwei weitere atome, die nahe
C                            beim schwerpunktsatom liegen, aber
C                            nicht auf einer geraden.
   20 NIDLP=0
      DQ=(DUMG+AINBFR(10))**2
      DO  K=1,NCD(NS)
        IF (K .NE. MERK) THEN
          TEMP=(ATOMS(1,K,NS)-ATOMS(1,MERK,NS))**2+
     +    (ATOMS(2,K,NS)-ATOMS(2,MERK,NS))**2+
     +    (ATOMS(3,K,NS)-ATOMS(3,MERK,NS))**2
          IF (TEMP .GT. 1.0 .AND. TEMP .LE. DUQ) THEN
            J=NIDLP
            GO TO 40
   30       IF (TEMP .GT. DIDL(J)) GO TO 50
            IF (J .LT. 3) THEN
              DIDL(J+1)=DIDL(J)
              NIDL(J+1)=NIDL(J)
            ENDIF
            J=J-1
   40       IF (J .GT. 0) GO TO 30
   50       IF (J .LT. 3) THEN
              DIDL(J+1)=TEMP
              NIDL(J+1)=K
            ENDIF
            IF (NIDLP .LT. 3) NIDLP=NIDLP+1
          ENDIF
        ENDIF
      ENDDO
      IF (NIDLP .LT. 2) GO TO 120
C
C                       Stelle fest, welche kombination einen
C                       winkel bildet, der moeglichst nahe an
C                       90 grad liegt.
      K=3
      TEMP=100.
      ICDS(2)=ICD(MERK,NS)
      DO  I=1,NIDLP-1
        IF (I .NE. MERK) THEN
          ICDS(1)=ICD(NIDL(I),NS)
          DO  J=I+1,NIDLP
            IF (J .NE. MERK) THEN
              ICDS(3)=ICD(NIDL(J),NS)
              NTYP=5
              ISKP(14)=1
              CALL ZVGE02
              IF (IERR .NE. 0) GO TO 999
              TEMP2=ABS(90.-CONST(6))
              IF (TEMP2 .LT. TEMP) THEN
                M=K
                TEMP=TEMP2
              ENDIF
              K=K-1
            ENDIF
          ENDDO
        ENDIF
      ENDDO
      IF (TEMP .GT. 70.) THEN
        IF (AINBFR(7) .LE. 0.) GO TO 120
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVCMPS0185 - Keine geeigneten Atome gefunden.'
CYENG2
CYENGY     +  'KPCMPS0185 - No suitable atoms found.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      J=ID2(M)
      K=ID2(J)
C                            IK1 und IK2 sind die ausgewaehlten atome.
C                            IK0 ist das referenzatom.
C
      IK1=ICD(NIDL(J),NS)/200000
      IK2=ICD(NIDL(K),NS)/200000
      II=IK0-INBFR(1)+1
      JJ=IK1-INBFR(1)+1
      K=IK2-INBFR(1)+1
C                            Berechne die matrix "SAVTRA"
      DO  I=1,3
        G1(I)=0.
      ENDDO
      DO  I=1,3
        TR(I,1)=AT(I,IK0,NS)
        S(1,I)=ATOMS(I,JJ,NS)-ATOMS(I,II,NS)
        X1(I)=ATOMS(I,K,NS)-ATOMS(I,II,NS)
        G1(1)=G1(1)+(ATOMS(I,K,NS)-ATOMS(I,JJ,NS))**2
        G1(2)=G1(2)+X1(I)**2
        G1(3)=G1(3)+S(1,I)**2
      ENDDO
C                            G1 enthaelt die abstaende
C                            ik1-ik2, ik0-ik2, ik0-ik1
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        S(3,I)=S(1,J)*X1(K)-S(1,K)*X1(J)
        X2(I)=0.
        G1(I)=SQRT(G1(I))
      ENDDO
C                            Lege testintervall fest.
      GMAX=G1(2)
      GMIN=G1(2)
      IF (G1(3) .GT. GMAX) GMAX=G1(3)
      IF (G1(3) .LT. GMIN) GMIN=G1(3)
      GMAX=(GMAX+AINBFR(10))**2
      GMIN=(GMIN-AINBFR(10))**2
C
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        S(2,I)=S(3,J)*S(1,K)-S(3,K)*S(1,J)
        DO  J=1,3
          X2(J)=S(J,I)**2+X2(J)
        ENDDO
      ENDDO
C                            Normiere
      DO  I=1,3
        TEMP=SQRT(X2(I))
        IF (TEMP .LE. 0.) THEN
          IERR=92 0243 06
          GO TO 999
        ENDIF
        DO  J=1,3
          S(I,J)=S(I,J)/TEMP
        ENDDO
      ENDDO
      DO  I=1,3
        DO  J=1,3
          A1(I,J)=S(I,1)*DG(1,J,NS)+S(I,2)*DG(2,J,NS)+S(I,3)*DG(3,J,NS)
        ENDDO
      ENDDO
C
C  Jetzt wird eine "arbeitsvorschrift" angelegt, wie die finite
C  gruppe mit der infiniten auf uebereinstimmung geprueft wird.
C
      ITFP=ITFS-1
      ITFQ=ITFS
      MP=IK0-INBFR(1)+1
      GO TO 90
   60 ITFP=ITFP+1
      ITF(ITFP)=-MP
      DO  IC=1,NCD(NS)
        DO  J=ITFS,ITFP
          IF (ABS(ITF(J)) .EQ. IC) GO TO 70
        ENDDO
        IF ((ATOMS(1,IC,NS)-ATOMS(1,MP,NS))**2+
     +    (ATOMS(2,IC,NS)-ATOMS(2,MP,NS))**2+
     +    (ATOMS(3,IC,NS)-ATOMS(3,MP,NS))**2 .LE. DUQ) THEN
          IF (ITFP .GE. ITFE) GO TO 100
          ITFP=ITFP+1
          ITF(ITFP)=IC
        ENDIF
   70   CONTINUE
      ENDDO
C                            Ist ueberhaupt etwas dazu gekommen?
C
      IF (ITF(ITFP) .LT. 0) ITFP=ITFP-1
C
C                            Suche neuen potentiellen ursprung.
C
   80 IF (ITFQ .GE. ITFP) GO TO 110
      ITFQ=ITFQ+1
      IF (ITF(ITFQ) .LT. 0) GO TO 80
      MP=ITF(ITFQ)
   90 IF (ITFP .LT. ITFE) GO TO 60
  100 WRITE (WRLINE,'(A)') 'ZVCMPS0288 - Overflow in ITF.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 999
C                            Teste, ob alle atome auch vorkommen.
  110 J=0
      DO  I=ITFS,ITFP
        IF (ITF(I) .GT. 0) THEN
          J=J+1
          ITF(I)=ITF(I)+INBFR(1)-1
        ELSE
          ITF(I)=ITF(I)-INBFR(1)+1
        ENDIF
      ENDDO
      IF (J+1 .EQ. NCD(NS)) GO TO 170
  120 IF (AINBFR(7) .LE. 0.) THEN
        DUMG=DUMG+0.2
        DUQ=DUMG*DUMG
        IF (DUMG .LE. 5.) GO TO 20
C
C  Die finite gruppe muss moeglicherweise ergaenzt werden. Teste das.
C
        IF (ISKP(89) .LE. 0 .OR. NFIORG .LT. INBFR(2)) GO TO 160
        TEMP=CONST(31)*CONST(31)
        DO  M=INBFR(1),NFIORG
        DO  I=-1,1
        DO  J=-1,1
        DO  K=-1,1
          IF (ABS(I)+ABS(J)+ABS(K) .EQ. 0) GO TO 150
          X1(1)=AT(1,M,NS)+I*AT(1,INBFR(8),NS)+J*AT(1,INBFR(8)+1,NS)+
     +    K*AT(1,INBFR(8)+2,NS)
          X1(2)=AT(2,M,NS)+I*AT(2,INBFR(8),NS)+J*AT(2,INBFR(8)+1,NS)+
     +    K*AT(2,INBFR(8)+2,NS)
          X1(3)=AT(3,M,NS)+I*AT(3,INBFR(8),NS)+J*AT(3,INBFR(8)+1,NS)+
     +    K*AT(3,INBFR(8)+2,NS)
C                            Teste, ob bereits vorhanden.
          DO  MM=INBFR(1),INBFR(2)
            DO  II=1,3
              IF (ABS(X1(II)-AT(II,MM,NS)) .GT. CONST(21)) GO TO 130
            ENDDO
            GO TO 150
  130       CONTINUE
          ENDDO
C                            Nicht gefunden. Teste, ob dieses atom
C                            wenigstens zwei nachbarn hat.
          CALL MV (DG(1,1,NS),X1,X2)
          II=0
          DO  IC=1,NCD(NS)
            IF ((X2(1)-ATOMS(1,IC,NS))**2+(X2(2)-ATOMS(2,IC,NS))**2+
     +      (X2(3)-ATOMS(3,IC,NS))**2 .LE. TEMP) THEN
              II=II+1
              IF (II .GE. 2) GO TO 140
            ENDIF
          ENDDO
C                            Keine zwei nachbarn. Verwerfe.
          GO TO 150
C                            Nimm auf, wenn noch moeglich.
C
  140     IF (NAT(NS) .GE. NATDM) THEN
            IERR=92 347 02
            GO TO 999
          ENDIF
          IF (NCD(NS) .GE. NCDDM) THEN
            IERR=92 351 01
            GO TO 999
          ENDIF
          NAT(NS)=NAT(NS)+1
          NCD(NS)=NCD(NS)+1
          INBFR(2)=INBFR(2)+1
          DO  II=1,3
            AT(II,NAT(NS),NS)=X1(II)
            AT(II+3,NAT(NS),NS)=AT(II+3,M,NS)
            ATOMS(II,NCD(NS),NS)=X2(II)
          ENDDO
          ICLRP(NAT(NS),NS)=ICLRP(M,NS)
          ICD(NCD(NS),NS)=M*200000+111001
  150     CONTINUE
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        IF (INBFR(2) .LE. NFIORG) GO TO 160
        DUMG=AINBFR(7)
        IF (AINBFR(7) .LE. 0.) THEN
          DUMG=1.6
          IF (AINBFR(7) .LT. 0.) DUMG=-AINBFR(7)
        ENDIF
        DUQ=DUMG*DUMG
        GO TO 20
      ENDIF
  160 WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVCMPS0380 - Finite Struktur nicht zusammenhaengend.'
CYENG2
CYENGY     + 'KPCMPS0380 - Finite structure not contiguous.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 999
C                            Fuelle jetzt codeliste mit der
C                            infiniten struktur.
C
  170 IF (AINBFR(7) .LE. 0.) THEN
        AINBFR(7)=DUMG
        WRITE (WRLINE,'(A,F5.2,A)')
CYENG1
     +  'D=',DUMG,' verwendet.'
CYENG2
CYENGY     +  'D=',DUMG,' used.'
        CALL KPWRTE (NTOUT)
      ENDIF
      ICPOI=0
      LSNG=0
  180 ICPOI=ICPOI+1
      IAIN(1)=INBFR(4)
      IAIN(2)=INBFR(5)
      NTYP=3
      CALL ZVZLIN
      IF (IERR .NE. 0) GO TO 999
      ICEND=NCD(NS)
C                            Wollen wir dieses atom ueberhaupt?
C
      IF (INBFR(6) .NE. 0) THEN
  190   IANR=ICD(ICPOI,NS)/200000
        NAME=IAT(5,IANR,NS)
        CALL CNVTUP (NAME,1,4)
        IF (NAME .NE. INBFR(6)) THEN
          ICPOI=ICPOI+1
          IF (ICPOI .LE. ICEND) GO TO 190
          GO TO 300
        ENDIF
      ENDIF
C                            Generiere um das aktuelle atom noch
C                            eine umgebung via AKS.
      ICDS(1)=ICD(ICPOI,NS)
      IZ1=INBFR(4)
      IZ2=INBFR(5)
      DQ=DUMG+AINBFR(10)
      CONST(20)=0.
      NTYP=3
      ISKP(14)=1
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 999
C
C  Jetzt muss eine kandidaten-liste aufgestellt werden mit denen die
C  ausgewaehlten atome zur deckung gebracht werden.
C
      NIDLP=0
      CALL MV (DG(1,1,NS),ATOMS(1,ICPOI,NS),X1)
      DO  IC=1,NCD(NS)
        IF (IC .NE. ICPOI) THEN
          CALL MV (DG(1,1,NS),ATOMS(1,IC,NS),X2)
          TEMP=(X2(1)-X1(1))**2+(X2(2)-X1(2))**2+(X2(3)-X1(3))**2
C         IF (TEMP .LE. DQ) THEN
          IF (TEMP .LE. GMAX .AND. TEMP .GE. GMIN) THEN
            IF (NIDLP .LT. NIDIM) THEN
C
C                            ICD(IC) ist kandidat.
              NIDLP=NIDLP+1
              NIDL(NIDLP)=IC
            ELSE
              WRITE (WRLINE,'(A)') 'ZVCMPS0448 - Overflow in NIDL.'
              CALL KPWRTE (NTDISP)
              IERR=-1
              GO TO 999
            ENDIF
          ENDIF
        ENDIF
      ENDDO
C
C  Teste, ob sich die finite gruppe in die infinite legen laesst.
C  Beginne mit den ausgewaehlten atomen, die die rotationsmatrix
C  definieren.
C
      C1=ICD(ICPOI,NS)
      ICDS(1)=C1
      NC=1
      NTRY=26
      CALL ZVDEK
      DO  I=1,3
        TR(I,2)=X(I,1)
        G(I,1)=X1(I)
      ENDDO
C                            Durchlaufe jetzt die kandidatenliste.
      DO  II=1,NIDLP
        C2=ICD(NIDL(II),NS)
        ICDS(2)=C2
        IF (C1 .EQ. C2) GO TO 260
        NC=2
        NTRY=26
        CALL ZVDEK
        G2(3)=0.
        DO  K=1,3
          G(K,2)=X1(K)
          G2(3)=G2(3)+(X1(K)-G(K,1))**2
        ENDDO
C                            Abstand C1 - C2 o.k.?
C
        DAMAX0=ABS(SQRT(G2(3))-G1(3))
        IF (DAMAX0 .GT. AINBFR(10)) GO TO 260
        DAMAX=DAMAX0
        DO  JJ=1,NIDLP
          C3=ICD(NIDL(JJ),NS)
          ICDS(3)=C3
          IF (C1 .EQ. C3) GO TO 250
          IF (C2 .EQ. C3) GO TO 250
          NC=3
          NTRY=26
          CALL ZVDEK
          G2(1)=0.
          G2(2)=0.
          DO  K=1,3
            G(K,3)=X1(K)
            G2(1)=G2(1)+(X1(K)-G(K,2))**2
            G2(2)=G2(2)+(X1(K)-G(K,1))**2
          ENDDO
C                            Abstaende C2 - C3 und C1 - C3 auch o.k.?
          DO  K=1,2
            TEMP=ABS(SQRT(G2(K))-G1(K))
            IF (TEMP .GT. AINBFR(10)) GO TO 250
            IF (TEMP .GT. DAMAX) DAMAX=TEMP
          ENDDO
C                            Erzeuge die matrix "TRAINV"
          DO  I=1,3
            S(1,I)=G(I,2)-G(I,1)
            X1(I)=G(I,3)-G(I,1)
          ENDDO
          DO  I=1,3
            J=ID2(I)
            K=ID2(J)
            S(3,I)=S(1,J)*X1(K)-S(1,K)*X1(J)
            X2(I)=0.
          ENDDO
          DO  I=1,3
            J=ID2(I)
            K=ID2(J)
            S(2,I)=S(3,J)*S(1,K)-S(3,K)*S(1,J)
            DO  J=1,3
              X2(J)=S(J,I)**2+X2(J)
            ENDDO
          ENDDO
C                             Normiere
          DO  I=1,3
            TEMP=SQRT(X2(I))
            IF (TEMP .LE. 0.) GO TO 250
            DO  J=1,3
              S(I,J)=S(I,J)/TEMP
            ENDDO
          ENDDO
          DO  I=1,3
            DO  J=1,3
              A2(J,I)=S(I,1)*RG(1,J,NS)+S(I,2)*RG(2,J,NS)+
     +        S(I,3)*RG(3,J,NS)
            ENDDO
          ENDDO
          DO  I=1,3
            DO  J=1,3
              B(J,I)=A2(J,1)*A1(1,I)+A2(J,2)*A1(2,I)+A2(J,3)*A1(3,I)
            ENDDO
          ENDDO
C                            Berechne gedrehten ersten ursprung.
          DO  I=1,3
            TRV(I)=TR(I,2)-B(I,1)*TR(1,1)-B(I,2)*TR(2,1)-B(I,3)*TR(3,1)
            TQV(I)=TRV(I)
          ENDDO
          IF (ISKP(58) .GT. 1) THEN
            WRITE (WRLINE,'(A)')
CYENG1
     +      'Transformationsmatrix          Vektor'
CYENG2
CYENGY     +      'Transformation matrix          vector'
            CALL KPWRTE (NTOUT)
            DO  I=1,3
              WRITE (WRLINE,'(3F10.5,2X,F10.5)') (B(I,J),J=1,3),TRV(I)
              CALL KPWRTE (NTOUT)
            ENDDO
          ENDIF
C                            Wende jetzt die operation auf die
C                            erste lokale gruppe an.
          ITFQ=ITFS
          I=-ITF(ITFQ)
          IPFLG(I,NS)=ICPOI
  200     IF (ITFQ .GE. ITFP) GO TO 220
          ITFQ=ITFQ+1
          I=ITF(ITFQ)
          IF (I .GT. 0) THEN
            DO  J=1,3
              X1(J)=B(J,1)*AT(1,I,NS)+B(J,2)*AT(2,I,NS)+
     +        B(J,3)*AT(3,I,NS)+TRV(J)
            ENDDO
            J=0
            TEMP2=100.
            DO  IC=1,NCD(NS)
              TEMP=ABS(ATOMS(1,IC,NS)-X1(1))
              IF (TEMP .GT. AKBOX(1)) GO TO 210
              X2(1)=TEMP
              TEMP=ABS(ATOMS(2,IC,NS)-X1(2))
              IF (TEMP .GT. AKBOX(2)) GO TO 210
              X2(2)=TEMP
              TEMP=ABS(ATOMS(3,IC,NS)-X1(3))
              IF (TEMP .LE. AKBOX(3)) THEN
                X2(3)=TEMP
                CALL MV (DG(1,1,NS),X2,T)
                TEMP=SQRT(T(1)*T(1)+T(2)*T(2)+T(3)*T(3))
                IF (TEMP .GT. AINBFR(10)) GO TO 210
                J=J+1
                IF (TEMP .LT. TEMP2) THEN
                  IPFLG(I,NS)=IC
                  TEMP2=TEMP
                ENDIF
              ENDIF
  210         CONTINUE
            ENDDO
C                            Genau oder mindestens einmal?
C
            IF (J .GE. 1 .AND. J .LE. MAXERL) THEN
              IF (TEMP2 .GT. DAMAX) DAMAX=TEMP2
              GO TO 200
            ENDIF
            GO TO 250
          ELSE
C                            Berechne TRV neu ...
            I=-I
            K=IPFLG(I,NS)
            DO  J=1,3
              TRV(J)=ATOMS(J,K,NS)-
     +        B(J,1)*AT(1,I,NS)-B(J,2)*AT(2,I,NS)-B(J,3)*AT(3,I,NS)
            ENDDO
C                            ... und generiere um das neue
C                            zentralatom noch eine umgebung via AKS.
            ICDS(1)=ICD(K,NS)
            IZ1=INBFR(4)
            IZ2=INBFR(5)
            DQ=DUMG+AINBFR(10)
            CONST(20)=0.
            NTYP=3
            ISKP(14)=1
            CALL ZVAVBR
            IF (IERR .NE. 0) GO TO 999
            GO TO 200
          ENDIF
  220     CONTINUE
C
C   Erfolg! Der bereich IPFLG enthaelt im bereich INBFR(1),..,INBFR(2)
C   zeiger auf die codeliste, in der steht, welches das entsprechende
C   atom ist.
C   Im fall eines zellvergleichs wird dieser raum daraufhin ueber-
C   prueft, ob er keine weiteren atome enthaelt.
C
          IF (ISKP(92) .GT. 0 .AND. ISKP(89) .GT. 0) THEN
C
C                            Berechne transformierte basis der
C                            finiten gruppe.
            K=INBFR(8)
            DO  I=1,3
              DO  J=1,3
                Y(J,I)=B(J,1)*AT(1,K,NS)+B(J,2)*AT(2,K,NS)+
     +          B(J,3)*AT(3,K,NS)
                Z(J,I)=Y(J,I)
              ENDDO
              K=K+1
            ENDDO
            CALL MINV (Y,3,TEMP,X(1,4),X(1,5))
C
C                            Berechne jetzt die koordinaten
C                            hinsichtlich dieser basis. Merke die
C                            extremen werte.
            DO  I=1,3
              Y(I,5)=100.
              Y(I,6)=-100.
            ENDDO
            NAFCNT=0
            NC=4
            NTRY=40
            DO  I=INBFR(1),NFIORG
              IC=IPFLG(I,NS)
              CALL ZVDEK
C                            Beruecksichtige nur atome mit r>0.01
C
              IF (AT(4,I,NS) .GT. 0.01) THEN
                NAFCNT=NAFCNT+1
                CALL MV (Y,X(1,4),X1)
                DO  J=1,3
                  IF (X1(J) .LT. Y(J,5)) Y(J,5)=X1(J)
                  IF (X1(J) .GT. Y(J,6)) Y(J,6)=X1(J)
                ENDDO
              ENDIF
            ENDDO
C                            Bestimme die entsprechenden punkte in
C                            der aktuellen zelle.
            DO  I=1,3
              Y(I,7)=100.
              Y(I,8)=-100.
            ENDDO
            DO  I=5,6
              X1(1)=Y(1,I)
              DO  J=5,6
                X1(2)=Y(2,J)
                DO  K=5,6
                  X1(3)=Y(3,K)
                  CALL MV (Z,X1,X2)
                  DO  M=1,3
                    IF (X2(M) .LT. Y(M,7)) Y(M,7)=X2(M)
                    IF (X2(M) .GT. Y(M,8)) Y(M,8)=X2(M)
                  ENDDO
                ENDDO
              ENDDO
            ENDDO
C                            Baue ein ATB zusammen.
C
            IF (NAT(NS) .GE. NATDM) THEN
              IERR=92 689 02
              GO TO 999
            ENDIF
            NAT(NS)=NAT(NS)+1
            DO  I=1,3
              AT(I,NAT(NS),NS)=(Y(I,7)+Y(I,8))*0.5
              AIN(I+3)=AT(I,NAT(NS),NS)-Y(I,7)+0.00001
            ENDDO
            IAIN(1)=NAT(NS)
            IAIN(2)=INBFR(4)
            IAIN(3)=INBFR(5)
            NTYP=1
            ISKP(14)=1
            NCDSAV=NCD(NS)
            NCDA(NS)=NCD(NS)+1
            CALL ZVAVBR
            NAT(NS)=NAT(NS)-1
C                            Zaehle jetzt die atome, die innerhalb
C                            der richtigen grenzen liegen.
            J=0
            DO  IC=NCDA(NS),NCD(NS)
              CALL MV (Y,ATOMS(1,IC,NS),X1)
              DO  I=1,3
                IF (X1(I) .LT. Y(I,5)-0.00001 .OR.
     +          X1(I) .GT. Y(I,6)+0.00001) GO TO 230
              ENDDO
              J=J+1
  230         CONTINUE
            ENDDO
            NCD(NS)=NCDSAV
            NCDA(NS)=1
            IF (J .GT. NAFCNT) GO TO 250
          ENDIF
C
          LSNG=LSNG+1
          ISKP(90)=ISKP(90)+1
          WRITE (WRLINE,'(A,I4,A,2X,3I5,35X,A,F7.4,A)')
CYENG1
     +    'Loesung',LSNG,':',IK0,IK1,IK2,'(',DAMAX,')'
CYENG2
CYENGY     +    'Solution',LSNG,':',IK0,IK1,IK2,'(',DAMAX,')'
          CALL KPCDST (IRLINE,30,C1)
          CALL KPCDST (IRLINE,40,C2)
          CALL KPCDST (IRLINE,50,C3)
          CALL KPWRTE (NTOUT)
          WRITE (WRLINE,'(A)')
CYENG1
     +    '     Transformationsmatrix         Vektor'
CYENG2
CYENGY     +    '     Transformation matrix         vector'
          CALL KPWRTE (NTOUT)
          DO  I=1,3
            WRITE (WRLINE,'(3F10.5,2X,F10.5)') (B(I,J),J=1,3),TQV(I)
            CALL KPWRTE (NTOUT)
          ENDDO
          WRLINE=' '
          CALL KPWRTE (NTOUT)
C                            Teste, wie darauf zu reagieren ist.
C
          IF (INBFR(11)) 250,300,240
C
C                            Fuehre KTG aus.
C
  240     IF (LSNG .GE. INBFR(11)) GO TO 280
  250     CONTINUE
          IF (KEYIN(0) .EQ. ISKP(20)) THEN
            IERR=-1
            GO TO 999
          ENDIF
          DAMAX=DAMAX0
        ENDDO
  260   CONTINUE
      ENDDO
C
  270 IF (ICPOI .LT. ICEND) GO TO 180
      GO TO 300
C
C                            Berechne wieder gedrehten ersten ursprung.
  280 DO  I=1,3
C       TRV(I)=TR(I,2)-B(I,1)*TR(1,1)-B(I,2)*TR(2,1)-B(I,3)*TR(3,1)
        TRV(I)=TQV(I)
      ENDDO
      DO  I=ISKP(53),NAT(NS)
        IF ((I .GE. INBFR(1) .AND. I .LE. INBFR(2)) .OR.
     +    (I .GE. INBFR(8) .AND. I .LE. INBFR(9))) THEN
          DO  J=1,3
            X1(J)=B(J,1)*AT(1,I,NS)+B(J,2)*AT(2,I,NS)+
     +      B(J,3)*AT(3,I,NS)+TRV(J)
          ENDDO
          DO  J=1,3
            AT(J,I,NS)=X1(J)
          ENDDO
        ENDIF
      ENDDO
C                   Soll noch ein affines bild berechnet werden?
C
      IF (INBFR(12) .NE. 1) GO TO 290
      DO  J=1,4
        DO  K=1,4
          E(K,J)=0.
        ENDDO
        DO  I=1,3
          EE(J,I)=0.
        ENDDO
      ENDDO
      DO  II=INBFR(1),INBFR(2)
        ICDS(1)=II
        ICDS(2)=ICD(IPFLG(II,NS),NS)
        NTRY=24
        DO  NC=1,2
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 999
        ENDDO
        DO  I=1,3
          G1(I)=X(I,1)
          G2(I)=X(I,2)
        ENDDO
        G1(4)=1.
        DO  J=1,4
          DO  K=1,4
            E(K,J)=E(K,J)+G1(K)*G1(J)
          ENDDO
          DO  K=1,3
            EE(J,K)=EE(J,K)+G1(J)*G2(K)
          ENDDO
        ENDDO
      ENDDO
      CALL LUDCMP (E,4,4,IAIN,AIN(5))
      IF (ABS(AIN(5)) .LT. 1.E-6) THEN
        WRITE (WRLINE,'(A,E12.5)')
CYENG1
     +  'ZVCMPS0819 - Determinante',AIN(5)
CYENG2
CYENGY     +  'KPCMPS0819 - Determinant',AIN(5)
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      DO  I=1,3
        CALL LUBKSB (E,4,4,IAIN,EE(1,I))
      ENDDO
      IF (ISKP(58) .GT. 0) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'Affine Abbildung:'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'Affine mapping:'
        CALL KPWRTE (NTDISP)
        DO  J=1,3
          WRITE (WRLINE,'(4F12.4)') (EE(I,J),I=1,4)
          CALL KPWRTE (NTDISP)
        ENDDO
      ENDIF
      TEMP=0.
      DO  II=ISKP(53),NAT(NS)
        IF ((II .GE. INBFR(1) .AND. II .LE. INBFR(2)) .OR.
     +    (II .GE. INBFR(8) .AND. II .LE. INBFR(9))) THEN
          DO  I=1,3
            T(I)=EE(1,I)*AT(1,II,NS)+EE(2,I)*AT(2,II,NS)+
     +      EE(3,I)*AT(3,II,NS)+EE(4,I)
          ENDDO
          DO  I=1,3
            AT(I,II,NS)=T(I)
          ENDDO
          IF (II .GE. INBFR(1) .AND. II .LE. INBFR(2)) THEN
            ICDS(1)=II
            ICDS(2)=ICD(IPFLG(II,NS),NS)
            NTRY=26
            DO  NC=1,2
              DO  J=1,3
                X2(J)=X1(J)
              ENDDO
              CALL ZVDEK
            ENDDO
            TEMP=TEMP+(X1(1)-X2(1))**2+(X1(2)-X2(2))**2+(X1(3)-X2(3))**2
          ENDIF
        ENDIF
      ENDDO
      TEMP=SQRT(TEMP/FLOAT(NFINIT))
CYENG1
      WRITE (WRLINE,'(A,F10.5)') 'RMS-Wert:',TEMP
CYENG2
CYENGY      WRITE (WRLINE,'(A,F10.5)') 'RMS value:',TEMP
      CALL KPWRTE (NTOUT)
      GO TO 300
C                             Koordinaten uebernehmen?
C
  290 IF (INBFR(12) .NE. 2) GO TO 300
      NC=2
      NTRY=24
      DO  II=INBFR(1),INBFR(2)
        ICDS(2)=ICD(IPFLG(II,NS),NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        IF (NAT(NS) .LT. NATDM) THEN
          NAT(NS)=NAT(NS)+1
          DO  J=1,3
            AT(J,NAT(NS),NS)=X(J,2)
            AT(J+3,NAT(NS),NS)=AT(J+3,IANR,NS)
          ENDDO
          IPFLG(NAT(NS),NS)=0
        ELSE
          IERR=92 0889 02
          GO TO 999
        ENDIF
      ENDDO
C
  300 IF (LSNG .LE. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +   'Keine Loesung gefunden.'
CYENG2
CYENGY     +   'No solution found.'
        CALL KPWRTE (NTOUT)
      ENDIF
      GO TO 999
C
  990 IERR=92 0904 16
  999 ISKP(14)=0
C                            Loesche status der finiten gruppe.
      DO  I=INBFR(1),INBFR(2)
        IPFLG(I,NS)=0
      ENDDO
      K8(NS)=0
      K9(NS)=0
      NCD(NS)=0
      RETURN
      END
