CZVDEK    05             ------------------
                          SUBROUTINE ZVDEK
C  CY-ENG-               ------------------
C
C                      Geschrieben: 1979 (Hundt)
C                  Geaendert: 030929 MAR 2004 (Hundt)
C
C   Das Programm erfuellt verschiedene Funktionen, aber in bestimmter
C   Reihenfolge.  NTRY darf nicht 32 und 16 enthalten.
C
C                  NTRY ergibt sich aus der Summe der Zahlen
C
C                    32  Code ICD(IC) entschluesseln
C                    16  Integer-zahl ICDS(NC) entschluesseln
C                     8  Trikline Koordinaten X(*,NC) berechnen
C                     4  Freie Koordinaten X2 berechnen
C                     2  Kart. Koordinaten X1 berechnen
C                     1  Code ICDS(NC) erzeugen aus IANR,IT,ISYNR
C
      IMPLICIT NONE
C
      INTEGER*4 NTRYS,ITEMP,I,IRLINE(30)
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      EQUIVALENCE (WRLINE,IRLINE(1))
C
      NTRYS=NTRY
C                            Teste auf erstes Bit (Code ICD(IC))
      IF (NTRYS-32) 30,10,10
C                            Entschluessele Code aus der Tabelle
   10 NTRYS=NTRYS-32
      ITEMP=ICD(IC,NS)
      IANR=ITEMP/200000
      ITEMP=ITEMP-IANR*200000
      IF (ITEMP-55501) 20,90,20
   20 IT(1)=ITEMP/20000
      ITEMP=ITEMP-IT(1)*20000
      IT(2)=ITEMP/2000
      ITEMP=ITEMP-IT(2)*2000
      IT(3)=ITEMP/200
      ISYNR=ITEMP-IT(3)*200
      GO TO 150
C                            Teste , ob Integerzahl ICDS(NC)
C                            entschluesselt wird.
   30 IF (NTRYS-16) 150,40,40
   40 NTRYS=NTRYS-16
      IANR=ICDS(NC)
      IF (IANR) 50,80,70
C                            Bei negativem Code wird der Code
C                            aus der Codeliste genommen.
   50 IANR=-IANR
      IF (IANR-NCD(NS)) 60,60,80
   60 IANR=ICD(IANR,NS)
      ICDS(NC)=IANR
      IF (IANR) 80,80,70
C
   70 IF (IANR .GT. NATDM) GO TO 110
      IF (IANR .LE. NAT(NS)) GO TO 90
   80 WRITE (WRLINE,'(A,I10)')
CYENG1
     + 'ZVDEK0061 - Atomnummer illegal:',IANR
CYENG2
CYENGY     + 'ZVDEK0061 - Illegal atom number:',IANR
      CALL KPWRTE (NTDISP)
      IERR=-1
      IANR=1
C
C                            Nur Nummer angegeben
   90 IT(1)=5
      IT(2)=5
      IT(3)=5
      ISYNR=1
C                            Vereinfachte Berechnung der triklinen
C                            Koordinaten, wenn gewuenscht
      IF (NTRYS-8) 180,100,100
  100 X(1,NC)=AT(1,IANR,NS)
      X(2,NC)=AT(2,IANR,NS)
      X(3,NC)=AT(3,IANR,NS)
      GO TO 170
C                            Entschluessele vollstaendigen Code
  110 ITEMP=IANR/200
      ISYNR=IANR-200*ITEMP
      IF ((ISYNR .LE. 0) .OR. (ISYNR .GT. NSYM(NS))) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +   'ZVDEK0088 - Code illegal (Symmetrienummer):'
CYENG2
CYENGY     +   'ZVDEK0088 - Illegal code (no. of symmetry):'
        CALL KPCDST (IRLINE,44,IANR)
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      IANR=ITEMP/10
      IT(3)=ITEMP-10*IANR
      ITEMP=IANR/10
      IT(2)=IANR-10*ITEMP
      IANR=ITEMP/10
      IT(1)=ITEMP-10*IANR
      IF (IANR) 80,80,140
  140 IF (IANR-NAT(NS)) 150,150,80
C
C                            Code ist entschluesselt,teste naechstes Bit
C
  150 IF (NTRYS-8) 180,160,160
C
C                            Trikline Koordinaten sollen berechnet
C                            werden.  Wende Symmetrie auf Atom an.
C
  160 X(1,NC)=SYM(1,ISYNR,NS)+FLOAT(IT(1)-5) +
     1 SYM( 2,ISYNR,NS)*AT(1,IANR,NS) + SYM( 3,ISYNR,NS)*AT(2,IANR,NS) +
     2 SYM( 4,ISYNR,NS)*AT(3,IANR,NS)
      X(2,NC)=SYM(5,ISYNR,NS)+FLOAT(IT(2)-5) +
     1 SYM( 6,ISYNR,NS)*AT(1,IANR,NS) + SYM( 7,ISYNR,NS)*AT(2,IANR,NS) +
     2 SYM( 8,ISYNR,NS)*AT(3,IANR,NS)
      X(3,NC)=SYM(9,ISYNR,NS)+FLOAT(IT(3)-5) +
     1 SYM(10,ISYNR,NS)*AT(1,IANR,NS) + SYM(11,ISYNR,NS)*AT(2,IANR,NS) +
     2 SYM(12,ISYNR,NS)*AT(3,IANR,NS)
  170 NTRYS=NTRYS-8
C                            Trikline Koordinaten sind berechnet.
C                            Teste naechstes Bit.
C
  180 IF (NTRYS-4) 220,190,190
C
C                            Berechne freie Koordinaten
  190 DO 200 I=1,3
  200 X1(I)=X(I,NC)-UR(I,NS)
      DO 210 I=1,3
      X2(I)=TRA(I,1,NS)*X1(1)+TRA(I,2,NS)*X1(2)+TRA(I,3,NS)*X1(3)
  210 CONTINUE
      NTRYS=NTRYS-4
C
  220 IF (NTRYS-2) 250,230,230
C
C                            Kartesische Koordinaten sollen ber. werden
  230 DO 240 I=1,3
      X1(I)=DG(I,1,NS)*X(1,NC)+DG(I,2,NS)*X(2,NC)+DG(I,3,NS)*X(3,NC)
  240 CONTINUE
      NTRYS=NTRYS-2
C
  250 IF (NTRYS-1) 999,260,260
C
C                            Verschluessele Code
C
  260 ICDS(NC)=(((IANR*10+IT(1))*10+IT(2))*10+IT(3))*200+ISYNR
C
  999 RETURN
      END
