CZVFNIN   58              -------------------
                           SUBROUTINE ZVFNIN
C                         -------------------
C  CY-ENG-VAX-Y
C
C  Das Programm verarbeitet die Eingabe von fundamentalen Variablen.
C
C  NTYP  Bedeutung
C    1   T - Titel
C    2-4 Atomparameter
C    2   AT
C    3   ATG
C    4   ATOM
C    5   GT - Gitter
C    6   N - Name
C    7   R - Radius
C    8   RS - Radius fuer Symbole
C    9   AE - Atomlistenende
C   10   KF - Kugelfaktor
C   11   S - Symmetrie
C   12   SE - Symmetrietab. Ende
C   13   ES - Entferne Symmetrie(n) aus der Liste
C   14   EPL - Entferne Punkt(e) aus der Liste
C   15   SQLS - Sequenz zum Schirmloeschen
C   16   SQTM - Sequenz zum Umschalten auf Textmodus
C   17   ATED - Editiere Atom
C   18   FRBN - Farbzeiger fuer Nummer(n)
C   19   FRBS - Farbzeiger fuer Symbol
C   20   RFRB - Radius bei Farbzeiger setzen
C   21   SFRB - Symbol bei Farbzeiger setzen
C   22   EPAR - Ellipsoid-Parameter
C   23   AINI - Animation initialisieren
C   24   CA   - Coloriere Atom
C   25   AK   - Atomparameter kartesisch
C   26   AAN  - Aendere arbeitsname
C   27   RAN  - Reset arbeitsnamen
C
C                geschrieben: 271748 APR 1987 (Hundt)
C                geaendert:   150911 JUN 2004 (Hundt)
C
C                         -------------------
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      REAL*4    ATPAR(9),ATNMPR(3),RADBF(4),BLANK
      INTEGER*4 NMATPR(3),IRADBF(4),IAIN(72),IATPAR(9)
      INTEGER*4 I,J,K,IBLANK,NATZL,IT1,IT2
C
      EQUIVALENCE (ATNMPR(1),NMATPR(1)),(RADBF(1),IRADBF(1))
      EQUIVALENCE (AIN(1),IAIN(1))
      EQUIVALENCE (BLANK,IBLANK),(ATPAR(1),IATPAR(1))
C
      SAVE ATPAR,ATNMPR,RADBF,BLANK
C
      DATA ATPAR/4HUNDE,4HFINI,3*0.,.3,4HUNDE,4HFINI,0./
      DATA ATNMPR/4HUNDE,4HFINI,0./,BLANK/4H    /
      DATA RADBF(1)/.3/,IRADBF(2)/3/
C
      GO TO (10,20,20,50,120,130,170,240,290,330,340,380,420,540,
C             1  2  3  4   5   6   7   8   9  10  11  12  13  14
     1 640,640,680,730,770,810,850,890,990,1000,50,1030,1040),NTYP
C       15  16  17  18  19  20  21  22  23   24 25   26   27
C
C                            (1) Titel
   10 CALL FLES (TITEL(1,NS),ISKP(31),4H18AE,7HTitel?$)
      GO TO 999
C                            (2,3) Kommando AT/ATG  - Atomparameter
C
   20 ATPAR(8)=BLANK
      IATPAR(9)=0
      CALL FLES (ATPAR(3),ISKP(31),6H4FAAIE,
CYENG1
     1 29Hx,y,z,r,Name,Untersch.,ncol?$)
CYENG2
CYENGY     1 24Hx,y,z,r,Name,ext.,ncol?$)
      ATPAR(1)=ATPAR(7)
      ATPAR(2)=ATPAR(8)
      IF (NTYP .GT. 2) THEN
        DO  I=3,5
          ATPAR(I)=ATPAR(I)/GRID(I-2)
        ENDDO
      ENDIF
      NATZL=NAT(NS)+1
      GO TO 80
C                            Kommando ATOM - Atomparameter
C
   50 ATPAR(2)=BLANK
      IATPAR(7)=0
      NATZL=NAT(NS)+1
   55 CALL FLES (ATPAR,ISKP(31),6HAA4FIE,
CYENG1
     1 29HName,Untersch.,x,y,z,r,ncol?$)
CYENG2
CYENGY     1 24HName,ext.,x,y,z,r,ncol?$)
      IF (NTYP .EQ. 25) THEN
        DO  I=1,3
          T(I)=RG(1,I,NS)*ATPAR(3)+RG(2,I,NS)*ATPAR(4)+
     +    RG(3,I,NS)*ATPAR(5)
        ENDDO
        DO  I=1,3
          ATPAR(I+2)=T(I)
        ENDDO
      ENDIF
      ATPAR(9)=ATPAR(7)
      ATPAR(7)=ATPAR(1)
      ATPAR(8)=ATPAR(2)
C
   80 IF (ISKP(48) .NE. 0) THEN
        DO  I=3,5
          IF (ABS(ATPAR(I)) .GE. 3.) THEN
            IERR=58 0101 21
            GO TO 999
          ENDIF
        ENDDO
        IF (ATPAR(6) .LE. 0) ATPAR(6)=0.001
      ENDIF
      IF (NTYP .NE. 17) THEN
        IF (NAT(NS) .GE. NATDM) THEN
          IERR=58 0109 02
          GO TO 999
        ENDIF
C
        NAT(NS)=NATZL
      ENDIF
      DO  I=1,6
        AT(I,NATZL,NS)=ATPAR(I+2)
      ENDDO
      AT(7,NATZL,NS)=ATPAR(7)
      CALL CNVTUP(AT(7,NATZL,NS),1,4)
      ICLRP(NATZL,NS)=IATPAR(9)
      IF (NTYP .NE. 17) IPFLG(NATZL,NS)=0
      GO TO 999
C
C                            Kommando GT - Gitterachseneinteilung
C
  120 CALL FLES (GRID,ISKP(31),3H3FE,10Hna,nb,nc?$)
      GO TO 999
C                            Kommando N - Name eines Atoms
  130 NMATPR(3)=NMATPR(3)+1
CYENG1
      CALL FLES (ATNMPR,ISKP(31),4HAAIE,19HName,Untersch.,nr?$)
CYENG2
CYENGY      CALL FLES (ATNMPR,ISKP(31),4HAAIE,15HName,ext.,no ?$)
      J=NMATPR(3)
      IF (J .LE. 0 .OR. J .GT. NAT(NS)) THEN
        IERR=58 0134 16
        GO TO 999
      ENDIF
C
      AT(5,J,NS)=ATNMPR(1)
      AT(6,J,NS)=ATNMPR(2)
      AT(7,J,NS)=ATNMPR(1)
      CALL CNVTUP(AT(7,J,NS),1,4)
      GO TO 999
C                            Kommando R - Radius von Atomen
  170 IRADBF(2)=0
      IRADBF(3)=0
      RADBF(4)=0.
CYENG1
      CALL FLES (RADBF,ISKP(31),5HF2IFE,19Hr,<von<,bis<,f>>>?$)
CYENG2
CYENGY      CALL FLES (RADBF,ISKP(31),5HF2IFE,19Hr,<from<,to<,f>>>?$)
      IF (IRADBF(3) .GT. NAT(NS)) IRADBF(3)=NAT(NS)
      IF (IRADBF(3) .LE. 0.) IRADBF(3)=IRADBF(2)
C
      I=IRADBF(2)-1
      IF (I .LT. 0) THEN
        IERR=58 0154 16
        GO TO 999
      ENDIF
      GO TO 230
C
  220 I=I+1
      AT(4,I,NS)=AT(4,I,NS)*RADBF(4)+RADBF(1)
  230 IF (I .LT. IRADBF(3)) GO TO 220
      GO TO 999
C
C                            Kommando RS - Radius fuer Symbol(e)
  240 AIN(1)=.3
      AIN(2)=BLANK
      IAIN(3)=1
      IAIN(4)=NAT(NS)
      AIN(5)=0.
      CALL FLES (AIN,ISKP(31),6HFA2IFE,
CYENG1
     1 21Hr,symb.<,von,bis,f>?$)
CYENG2
CYENGY     1 21Hr,symb.<,from,to,f>?$)
C
      CALL CNVTUP (AIN(2),1,4)
      I=IAIN(3)-1
      IF (I .LT. 0) I=0
      IF (IAIN(4) .GT. NAT(NS)) IAIN(4)=NAT(NS)
      GO TO 280
C
  270 I=I+1
      AIN(6)=AT(7,I,NS)
C      CALL CNVTUP (AIN(6),1,4)
      IF (IAIN(2) .EQ. IAIN(6)) AT(4,I,NS)=AT(4,I,NS)*AIN(5)+AIN(1)
  280 IF (I .LT. IAIN(4)) GO TO 270
      GO TO 999
C
C                            Kommando AE - Atomlistenende
C
  290 IAIN(1)=NAT(NS)
CYENG1
      CALL FLES (AIN,ISKP(31),2HIE,5HNr.?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),2HIE,5HNo.?$)
      IF (IAIN(1) .LT. 0) IAIN(1)=0
      IF (IAIN(1) .GT. NATDM) IAIN(1)=NATDM
      NAT(NS)=IAIN(1)
      K8(NS)=0
      K9(NS)=0
      GO TO 999
C                            Faktor fuer Kugel
C
  330 CALL FLES (FKGL,ISKP(31),2HFE,
CYENG1
     1 8HFaktor?$)
CYENG2
CYENGY     1 8Hfactor?$)
      GO TO 999
C                            Symmetrie (analytisch)
C
  340 CALL FLES (AIN,ISKP(31),4H12FE,28Ht1,s11,s12,s13, t2,...,s33?$)
      IF (ISKP(31) .LT. 12) THEN
        IERR=58 0216 16
        GO TO 999
      ENDIF
C
      IF (NSYM(NS) .LT. NSYMDM) THEN
        NSYM(NS)=NSYM(NS)+1
        DO  I=1,12
          SYM(I,NSYM(NS),NS)=AIN(I)
        ENDDO
      ELSE
        IERR=58 0226 03
      ENDIF
      GO TO 999
C                            Kommando SE
  380 IAIN(1)=NSYM(NS)
CYENG1
      CALL FLES (AIN,ISKP(31),2HIE,4HNr?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),2HIE,4HNo?$)
      IF (IAIN(1) .LT. 0) IAIN(1)=0
      IF (IAIN(1) .GT. NSYMDM) IAIN(1)=NSYMDM
C
  410 NSYM(NS)=IAIN(1)
  411 NHMSNR(1,NS)=IBLANK
      NHMSNR(2,NS)=IBLANK
      NHMSNR(3,NS)=0
      GO TO 999
C                            ES - Entferne Symmetrie(n)
  420 IAIN(2)=0
      CALL FLES (AIN,ISKP(31),3H2IE,
CYENG1
     1 11Hvon<,bis>?$)
CYENG2
CYENGY     1 11Hfrom<,to>?$)
      IF (IAIN(2)) 460,460,430
  430 IF (IAIN(2)-NSYM(NS)) 450,450,440
  440 IAIN(2)=NSYM(NS)
  450 IF (IAIN(1)-IAIN(2)) 470,470,490
  460 IAIN(2)=IAIN(1)
  470 IF (IAIN(1)) 490,490,480
  480 IF (IAIN(1)-NSYM(NS)) 520,520,490
  490 IERR=58 0259 16
      GO TO 999
C
  500 DO 510 J=1,12
  510 SYM(J,IAIN(1),NS)=SYM(J,IAIN(2),NS)
      IAIN(1)=IAIN(1)+1
  520 IAIN(2)=IAIN(2)+1
      IF (IAIN(2)-NSYM(NS)) 500,500,530
  530 NSYM(NS)=IAIN(1)-1
      GO TO 411
C                            Kommando EPL
C
  540 IF (ISKP(14) .NE. 0) GO TO 545
      IAIN(2)=0
      CALL FLES (AIN,ISKP(31),3H2IE,
CYENG1
     1 11Hvon<,bis>?$)
CYENG2
CYENGY     1 11Hfrom<,to>?$)
  545 IZ1=IAIN(1)
      IZ2=IAIN(2)
      IF (IZ2) 550,550,560
  550 IZ2=IZ1
      IAIN(2)=IZ2
  560 IF (IZ1 .LE. 0) IZ1=1
      IF (IZ2 .GT. NAT(NS)) IZ2=NAT(NS)
      IF (IZ1-IZ2) 600,600,590
  590 IERR=58 0286 16
      GO TO 999
C
  600 IAIN(3)=IZ1*200000
      IAIN(4)=IZ2*200000+199999
      IAIN(5)=(IZ2-IZ1+1)*200000
C
C                       Durchlaufe Codeliste
      I=NCDA(NS)-1
      J=I
      GO TO 603
C
  601 I=I+1
      IF (ICD(I,NS) .LT. IAIN(3)) GO TO 602
      IF (ICD(I,NS) .LE. IAIN(4)) GO TO 603
      ICD(I,NS)=ICD(I,NS)-IAIN(5)
  602 J=J+1
      ICD(J,NS)=ICD(I,NS)
  603 IF (I .LT. NCD(NS)) GO TO 601
      NCD(NS)=J
C
C                       Durchlaufe Parameterliste
  604 IZ2=IZ2+1
      IF (IZ2-NAT(NS)) 610,610,630
  610 DO 620 I=1,8
  620 AT(I,IZ1,NS)=AT(I,IZ2,NS)
      DO  I=1,3
        DO  J=1,3
          TFVKT(I,J,IZ1,NS)=TFVKT(I,J,IZ2,NS)
        ENDDO
      ENDDO
      ICLRP(IZ1,NS)=ICLRP(IZ2,NS)
      IPFLG(IZ1,NS)=IPFLG(IZ2,NS)
      IZ1=IZ1+1
      GO TO 604
  630 NAT(NS)=IZ1-1
      K8(NS)=0
      K9(NS)=0
C                        Durchsuche Liste mit Plotbefehlen nach VD
      I=1
  631 IF (I .GT. IPKP(NS)) GO TO 999
      IF (IPK(I+1,NS) .GE. 12 .AND. IPK(I+1,NS) .LE. 14) THEN
C
C                         Teste, ob unerlaubte Codes vorkommen ...
        IT1=I+8
        IT2=I+IPK(I,NS)-1
        DO  J=IT1,IT2
          IF (IPK(J,NS) .GT. IAIN(3) .AND. IPK(J,NS) .LE. IAIN(4)) THEN
C
C                        ... in diesem Fall maskiere den Befehl.
C
            IPK(I+1,NS)=-IPK(I+1,NS)
            GO TO 632
          ENDIF
        ENDDO
        DO  J=IT1,IT2
          IF (IPK(J,NS) .GT. IAIN(4)) IPK(J,NS)=IPK(J,NS)-IAIN(5)
        ENDDO
      ENDIF
  632 I=I+IPK(I,NS)
      GO TO 631
C
  640 CALL FLES (AIN(2),ISKP(31),4H32ZE,18Hhxch1,hxch2, ...?$)
      J=ISKP(31)
      AIN(1)=J
      IF (J) 670,670,650
  650 DO 660 I=1,J
CYVAX1
C      CALL COPYCH (AIN,I*4+4,1, AIN,I+4)
CYVAX2
CYVAXY
      CALL COPYCH (AIN,I*4+1,1, AIN,I+4)
  660 CONTINUE
  670 J=NTYP+5
      CALL UPLINF (AIN,19)
      GO TO 999
C                            Kommando ATED
  680 NATZL=0
CYENG1
      CALL FLES (NATZL,ISKP(31),2HIR,5HNr.?$)
CYENG2
CYENGY      CALL FLES (NATZL,ISKP(31),2HIR,5HNo.?$)
      IF (NATZL) 700,700,690
  690 IF (NATZL-NATDM) 710,710,700
  700 IERR=58 0370 16
      GO TO 999
C
  710 DO 720 I=1,6
  720 ATPAR(I+2)=AT(I,NATZL,NS)
      ATPAR(1)=ATPAR(7)
      ATPAR(2)=ATPAR(8)
      IATPAR(7)=ICLRP(NATZL,NS)
      GO TO 55
C                            (18) FRBN - Farbe fuer Nummern
  730 IAIN(1)=1
      IAIN(2)=ISKP(53)
      IAIN(3)=NAT(NS)
CYENG1
      CALL FLES (AIN,ISKP(31),3H3IE,13HNr.,von,bis?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),3H3IE,13HNo.,from,to?$)
      IF (ISKP(31) .EQ. 2) IAIN(3)=IAIN(2)
      I=IAIN(2)
      J=IAIN(3)
      IF (I .LE. 0) I=1
      IF (J .GT. NAT(NS)) J=NAT(NS)
      IF (I .LE. J) GO TO 750
  740 IERR=58 0393 16
      GO TO 999
C
  750 DO 760 K=I,J
  760 ICLRP(K,NS)=IAIN(1)
      GO TO 999
C                            (19) FRBS - Farbe fuer Symbol
  770 IAIN(3)=ISKP(53)
      IAIN(4)=NAT(NS)
CYENG1
      CALL FLES (AIN,ISKP(31),5HIA2IE,20HNr.,Symbol,von,bis?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),5HIA2IE,20HNo.,Symbol,from,to?$)
      I=IAIN(3)
      J=IAIN(4)
      IF (I .LE. 0) I=1
      IF (J .GT. NAT(NS)) J=NAT(NS)
      IF (I .LE. J) GO TO 790
  780 IERR=58 0411 16
      GO TO 999
C
  790 CALL CNVTUP (AIN(2),1,4)
      DO 800 K=I,J
      AIN(5)=AT(7,K,NS)
C      CALL CNVTUP (AIN(5),1,4)
      IF (IAIN(2) .NE. IAIN(5)) GO TO 800
      ICLRP(K,NS)=IAIN(1)
  800 CONTINUE
      GO TO 999
C                            (20) RFRB - Radius fuer Farbzeiger
  810 AIN(1)=0.3
      IAIN(2)=0
      IAIN(3)=0
      IAIN(4)=ISKP(53)
      IAIN(5)=NAT(NS)
      CALL FLES (AIN,ISKP(31),4HF4IE,
CYENG1
     + 30hr, frbz_von,frbz_bis,von,bis?$)
CYENG2
CYENGY     + 30hr, clrp_from,clrp_to,from,to?$)
      IF (IAIN(3) .EQ. 0) IAIN(3)=IAIN(2)
      I=IAIN(4)
      IF (I .LE. 0) I=1
      IF (IAIN(5) .GT. NAT(NS)) IAIN(5)=NAT(NS)
      IF (I .LE. IAIN(5)) GO TO 830
  820 IERR=58 0438 16
      GO TO 999
C
  830 IF (ICLRP(I,NS) .LT. IAIN(2)) GO TO 840
      IF (ICLRP(I,NS) .GT. IAIN(3)) GO TO 840
      AT(4,I,NS)=AIN(1)
  840 I=I+1
      IF (I .LE. IAIN(5)) GO TO 830
      GO TO 999
C                            (21) SFRB - Symbol bei Farbzeigern setzen
  850 AIN(1)=BLANK
      IAIN(2)=1
      IAIN(3)=0
      IAIN(4)=0
      IAIN(5)=ISKP(53)
      IAIN(6)=NAT(NS)
      CALL FLES (AIN,ISKP(31),4HA5IE,
CYENG1
     + 49HSymbol,IUntrsch.(1),frbz<,frbz_bis<,von<,bis>>>?$)
CYENG2
CYENGY     + 49HSymbol,Iext.[1],clrp_from<,clrp_to<,from<,to>>>?$)
      IF (IAIN(4) .EQ. 0) IAIN(4)=IAIN(3)
      IF (IAIN(2) .LE. 0) GO TO 860
      I=IAIN(5)
      IF (I .LE. 0) I=1
      IF (IAIN(6) .GT. NAT(NS)) IAIN(6)=NAT(NS)
      IF (I .LE. IAIN(6)) GO TO 870
  860 IERR=58 0465 16
      GO TO 999
C
  870 IF (ICLRP(I,NS) .LT. IAIN(3)) GO TO 880
      IF (ICLRP(I,NS) .GT. IAIN(4)) GO TO 880
      IF (IAIN(2) .GT. 9999) GO TO 860
      AT(6,I,NS)=BLANK
      J=0
      CALL KPNTOS (IAIN(2), AT(6,I,NS),J,0)
      AT(5,I,NS)=AIN(1)
      IAIN(2)=IAIN(2)+1
      AT(7,I,NS)=AIN(1)
      CALL CNVTUP (AT(7,I,NS),1,4)
  880 I=I+1
      IF (I .LE. IAIN(6)) GO TO 870
      GO TO 999
C                            EPAR - Ellipsoidparameter
C
  890 DO  I=1,6
        IAIN(I)=0
      ENDDO
CYENG1
      CALL FLES (AIN,ISKP(31),3H2IR,8Hnr,typ?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),3H2IR,9Hnr,type?$)
      IF (IAIN(1) .LE. 0 .OR. IAIN(1) .GT. IATFDM .OR.
     +  IAIN(2) .LE. 0 .OR. IAIN(2) .GT. 5) THEN
        IERR=58 0490 16
        GO TO 999
      ENDIF
      IAIN(7)=IATF(15,IAIN(1))
      IAIN(8)=IATF(16,IAIN(1))
      GO TO (900,920,930,940,970),IAIN(2)
  900 IAIN(5)=8
  920 IAIN(3)=4
      GO TO 960
  930 IAIN(3)=3
      IAIN(4)=-5
      IAIN(5)=1
      IAIN(6)=5
      GO TO 960
  940 IAIN(3)=1
  960 CALL FLES (AIN(7),ISKP(31),3H2FE,7Ha0,a1?$)
      GO TO 980
C
  970 DO  I=3,6
        IAIN(I)=IATF(I+8,IAIN(1))
      ENDDO
      CALL FLES (AIN(3),ISKP(31),5H4I2FE,20Hn1,n2,n3,n4, a0,a1?$)
  980 DO  I=3,8
        IATF(I+8,IAIN(1))=IAIN(I)
      ENDDO
      GO TO 999
C                            AINI
  990 IAIN(1)=1
      IAIN(2)=2
      IAIN(3)=1
      IAIN(4)=2
      CALL FLES (AIN,ISKP(31),3H4IE,16Hvmod,mbuf,bufn?$)
      CALL UPLINF (AIN,28)
      AIN(5)=5.
      IAIN(6)=ISKP(56)
      CALL UPLINF (AIN(5),19)
      CALL UPLINF(AIN(2),30)
      CALL UPLINF(AIN(3),31)
      GO TO 999
C                            (24) CA - Coloriere atom
 1000 IF (ISKP(14) .EQ. 0) THEN
        ICDS(3)=0
        ICDS(4)=ISKP(53)
        ICDS(5)=NAT(NS)
        ICDS(6)=15
        CALL FLES (ICDS,ISKP(31),4HA4IE,
CYENG1
     +  31HSymbol,Nr.,Block-Nr.,von,bis? $)
CYENG2
CYENGY     +  31HSymbol,No.,Block-No.,from,to? $)
      ENDIF
      IF (ICDS(2) .LT. 0) THEN
        ICDS(2)=-ICDS(2)
        ICDS(6)=0
      ENDIF
      IF (ICDS(4) .LE. 0) ICDS(4)=1
      IF (ICDS(5) .GT. NAT(NS)) ICDS(5)=NAT(NS)
      CALL CNVTUP (ICDS,1,4)
      IF (ICDS(3) .LE. 0 .OR. ICDS(3) .GT. IATFDM) THEN
C
C                            Suche einen noch nicht verwendeten
C                            ATF-block
        DO  J=1,IATFDM
          IAIN(J)=0
        ENDDO
        DO  IC=1,2
          DO  J=1,NAT(IC)
            IF (ICLRP(J,IC) .GT. 0 .AND. ICLRP(J,IC) .LE. IATFDM)
     +      IAIN(ICLRP(J,IC))=1
          ENDDO
          J=1
 1010     IF (J .LT. IPKP(IC)) THEN
            IF (IPK(J+1,IC) .GE. 2 .AND. IPK(J+1,IC) .LE. 4) THEN
              K=IPK(J+9,IC)
              IF (K .GE. 0 .AND. K .LE. IATFDM) IAIN(K)=1
            ENDIF
            IF (IPK(J+1,IC) .GE. 12 .AND. IPK(J+1,IC) .LE. 14) THEN
              K=IPK(J+3,IC)
              IF (K .GE. 0 .AND. K .LE. IATFDM) IAIN(K)=1
            ENDIF
            J=J+IPK(J,IC)
            GO TO 1010
          ENDIF
        ENDDO
        DO  J=1,IATFDM
          IF (IAIN(J) .EQ. 0) GO TO 1020
        ENDDO
        WRITE (WRLINE,'(A)')
CYENG1
     +   'ZVFNIN0577 - Keinen freien ATF-Block gefunden.'
CYENG2
CYENGY     +   'ZVFNIN0577 - No free ATF-block found.'
        CALL KPWRTE (NTDISP)
        GO TO 999
      ELSE
        J=ICDS(3)
      ENDIF
C
 1020 IATF(1,J)=ICDS(2)
      IATF(3,J)=ICDS(2)
      IATF(4,J)=1
      IATF(5,J)=ICDS(6)
      DO  I=ICDS(4),ICDS(5)
        AIN(1)=AT(7,I,NS)
C        CALL CNVTUP (IAIN,1,4)
        IF (IAIN(1) .EQ. ICDS(1)) ICLRP(I,NS)=J
      ENDDO
      GO TO 999
C                            AAN - Aendere arbeitsname
 1030 IAIN(3)=ISKP(53)
      IAIN(4)=NAT(NS)
      CALL FLES (IAIN,ISKP(31),5HAA2IE,
CYENG1
     + 23HName,Name_neu,von,bis?$)
CYENG2
CYENGY     + 23HName,Name_new,from,to?$)
      IF (IAIN(3) .LE. 0) IAIN(3)=1
      IF (IAIN(4) .GT. NAT(NS)) IAIN(4)=NAT(NS)
      CALL CNVTUP (IAIN,1,8)
      DO  I=IAIN(3),IAIN(4)
        AIN(5)=AT(5,I,NS)
        CALL CNVTUP (IAIN(5),1,4)
        IF (IAIN(5) .EQ. IAIN(1)) AT(7,I,NS)=AIN(2)
      ENDDO
      GO TO 999
C                            RAN - Setze arbeitsnamen zurueck
 1040 IAIN(3)=ISKP(53)
      IAIN(4)=NAT(NS)
CYENG1
      CALL FLES (IAIN(3),ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY      CALL FLES (IAIN(3),ISKP(31),3H2IE,9Hfrom,to?$)
      IF (IAIN(3) .LE. 0) IAIN(3)=1
      IF (IAIN(4) .GT. NAT(NS)) IAIN(4)=NAT(NS)
      DO  I=IAIN(3),IAIN(4)
        AIN(5)=AT(5,I,NS)
        CALL CNVTUP (IAIN(5),1,4)
        AT(7,I,NS)=AIN(5)
      ENDDO
C
  999 RETURN
      END
