CZVGE01   09             -------------------
                          SUBROUTINE ZVGE01
C  CY-ENG-               -------------------
C
C   Kommando  NTYP   Bedeutung
C   P           1    Punkt im freien System
C   PT          2    Punkt im triklinen System
C   OP          3    Drucke Punktregister
C   PL          4    Lade Punkt
C   DP          5    Drehe Punkt
C   DG          6    Drehe Gruppe
C   CPG         7    Kopiere Gruppe ans Ende
C   SP          8    Schwerpunkt
C   PP          9    Plotte Punkt
C   SPG        10    Spiegele Gruppe
C   ZG         11    Zentrische Gruppe
C   XP         12    Vertausche Parameter
C   XAT        13    Vertausche Atome
C   MVP        14    Verschiebe Gruppe
C              15    Berechnet trikline Koord.
C              16    Berechnet freie Koordinaten
C   PREL       17    Punkt im fr. System relativ zum alten
C   DGV        18    Drehe Gruppe um einen Vektor
C   SPC        19    Schwerpunkt ueber Codes
C   KUSP       20    Koordinatensystem ueber Schwerpunkt der Codes
C   DKV        21    Drehe Koordinatensystem um einen Vektor
C   DKV        22    Drehe Koordinatensystem um einen Vektor,
C                    Input auf AIN
C   DPV        23    Drehe Punkt einen Vektor
C   PTTR       24    Punkt im Punkregister: trikline Koordinaten nach
C                    reziprok.
C
C                          Geschrieben: Hundt
C                   Geaendert: 191540 MAY 2005  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 KONST(40),I,IACHSE,IAIN(72),IBIS,INBFR(3),INBFR2(6)
      INTEGER *4 ISKP14,IVON,J,K,KDR,L,NATSV,NTYPS
      REAL    *4 A(3,3),BOG,C(3,3),G,H,PF(3),PT(3),PU(3),SK(3,17)
      REAL    *4 SUM,TEMP,VA(3)
C
      SAVE INBFR,INBFR2
C
      EQUIVALENCE (AIN(1),IAIN(1)),(CONST(1),KONST(1))
      EQUIVALENCE (PTRIKL(1),PT(1)),(PFREI(1),PF(1))
      EQUIVALENCE (AIN(57),A(1,1)),(AIN(56),G),(AIN(55),TEMP)
      EQUIVALENCE (X(1,1),PU(1)),(X(1,2),VA(1)),(CONST(3),BOG)
      EQUIVALENCE (AIN(1),IVON),(AIN(2),IBIS),(AIN(3),IACHSE)
C
      DATA KDR/4HR   /
C
      NATSV=0
      NTYPS=NTYP
      GO TO (10,60,110,140,190,480,640,770,860,870,990,1100,1100,1190,
C             1  2   3   4   5   6   7   8   9  10  11   12   13   14
C
     1     20,70,1330,350,1360,1360,310,300,340,165), NTYP
C          15 16   17  18   19   20  21  22  23  24
C
C                            Kommando P
C
   10 CALL FLES (PF,ISKP(31),3H3FE,7Hx,y,z?$)
C
C                            Gleiche PT an.
   20 DO  I=1,3
        PT(I)=TRAINV(I,1,NS)*PF(1)+TRAINV(I,2,NS)*PF(2)+
     +  TRAINV(I,3,NS)*PF(3)+UR(I,NS)
      ENDDO
      IF (NTYPS .EQ. 20) THEN
        DO  I=1,3
          UR(I,NS)=PT(I)
        ENDDO
      ENDIF
      GO TO 9999
C                            Kommando PT
C
   60 CALL FLES (PT,ISKP(31),3H3FE,7Hx,y,z?$)
   70 DO  I=1,3
        X1(I)=PT(I)-UR(I,NS)
      ENDDO
      DO  I=1,3
        PF(I)=TRA(I,1,NS)*X1(1)+TRA(I,2,NS)*X1(2)+TRA(I,3,NS)*X1(3)
      ENDDO
C
      IF (NTYPS .NE. 20) GO TO 9999
      PF(3)=AIN(7)
      GO TO 20
C                            Kommando OP
  110 WRITE (WRLINE,120) PT,PF
      CALL KPWRTE (NTOUT)
  120 FORMAT (6F10.5)
  130 CALL FLES (AIN,ISKP(31),1HE,2H?$)
      GO TO 9999
C                            Kommando PL
C
  140 CALL FLES (ICDS,ISKP(31),2HCE,6HCode?$)
      NC=1
      IF (ICDS(1)) 160,150,160
  150 ICDS(1)=1
      NTYP=7
      CALL ZVGC01 (ICDS(1))
  160 NTRY=28
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 9999
      DO  I=1,3
        PT(I)=PU(I)
        PF(I)=X2(I)
      ENDDO
      KONST(27)=ICDS(1)
      KONST(28)=ICDS(1)
      GO TO 9999
C                            WPRS - Welcher Punkt im reziproken Syst.
  165 DO  I=1,3
        T(I)=DG(I,1,NS)*PTRIKL(1)+DG(I,2,NS)*PTRIKL(2)+
     +  DG(I,3,NS)*PTRIKL(3)
      ENDDO
      DO  I=1,3
        PTRIKL(I)=DG(1,I,NS)*T(1)+DG(2,I,NS)*T(2)+DG(3,I,NS)*T(3)
      ENDDO
      GO TO 130
C                            Kommando DP
C
  190 IF (ISKP(14) .NE. 0) GO TO 210
      AIN(2)=CONST(6)
CYENG1
      CALL FLES (AIN,ISKP(31),3HIFE,12HAchse,Grad?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),3HIFE,11HAxis,deg.?$)
  210 I=IAIN(1)
      G=AIN(2)
  220 IF (I .LE. 0 .OR. I .GT. 3) THEN
        IERR=9 0138 07
        IF (NTYPS .NE. 18) GO TO 9999
        GO TO 440
      ENDIF
C
      DO  J=1,3
        DO  K=1,3
          S(J,K)=0.
        ENDDO
      ENDDO
      S(I,I)=1.
      J=ID2(I)
      K=ID2(J)
      TEMP=COS(G*BOG)
      S(J,J)=TEMP
      S(K,K)=TEMP
      TEMP=SIN(G*BOG)
      S(K,J)=TEMP
      S(J,K)=-TEMP
      IF (NTYP-6) 270,490,9999
  270 DO  I=1,3
        PU(I)=S(I,1)*PF(1)+S(I,2)*PF(2)+S(I,3)*PF(3)
      ENDDO
      DO  I=1,3
        PF(I)=PU(I)
      ENDDO
      GO TO 20
C
C                            Kommando DKV - Drehe Koord.s. um Vektor.
  300 INBFR(1)=IAIN(1)
      INBFR(2)=IAIN(2)
      INBFR(3)=IAIN(3)
      NTYPS=21
      GO TO 330
C
  310 INBFR(3)=KONST(6)
CYENG1
      CALL FLES (INBFR,ISKP(31),4H2CFE,12Hp1,p2,Grad?$)
CYENG2
CYENGY      CALL FLES (INBFR,ISKP(31),4H2CFE,12Hp1,p2,deg.?$)
C
C                            Ersetze Codes ggf. aus Gruppenliste
  330 DO  I=1,2
        IF (INBFR(I) .EQ. 0) THEN
          J=I
          NTYP=7
          CALL ZVGC01 (J)
          INBFR(I)=J
        ENDIF
      ENDDO
C                            Save drei spezielle Punkte.
      DO  I=1,3
        IAIN(I+7)=INBFR(I)
        AIN(I+12)=UR(I,NS)
        AIN(I+15)=UR(I,NS)+TRAINV(I,1,NS)
        AIN(I+18)=UR(I,NS)+TRAINV(I,2,NS)
      ENDDO
      AIN(10)=-AIN(10)
      IAIN(6)=0
      IAIN(7)=0
      IAIN(11)=0
      GO TO 360
C                            Kommando DPV - Drehe Punkt um Vektor.
  340 IAIN(8)=0
      IAIN(9)=0
      AIN(10)=CONST(6)
CYENG1
      CALL FLES (AIN(8),ISKP(31),4H2CFE,13Hp1,p2,Grad? $)
CYENG2
CYENGY      CALL FLES (AIN(8),ISKP(31),4H2CFE,13Hp1,p2,deg.? $)
      GO TO 360
C                            Kommando DGV - Drehe Gruppe um Vektor.
C
  350 IF (ISKP(14)) 360,352,351
  351   DO  I=1,4
          INBFR2(I)=IAIN(I)
        ENDDO
        GO TO 9999
C
  352 INBFR2(5)=KONST(6)
      INBFR2(6)=KONST(38)
CYENG1
      CALL FLES (INBFR2,ISKP(31),5H4CFAE,24Hvon,bis,p1,p2,Grad,opt?$)
CYENG2
CYENGY      CALL FLES (INBFR2,ISKP(31),5H4CFAE,24Hfrom,to,p1,p2,deg.,opt?$)
      CALL CNVTUP (INBFR2(6),1,4)
      DO  I=1,6
        IAIN(I+5)=INBFR2(I)
      ENDDO
C                            Save Koordinatensystem ...
  360 DO  I=1,3
        DO  J=1,3
          SK(J,I)=TRA(J,I,1)
          SK(J,I+3)=TRAINV(J,I,1)
          SK(J,I+10)=TRA(J,I,2)
          SK(J,I+13)=TRAINV(J,I,2)
          SK(J,I+6)=DREH(J,I)
        ENDDO
        SK(I,10)=UR(I,1)
        SK(I,17)=UR(I,2)
      ENDDO
C                            ... und baue neues auf.
      DO 430 I=8,9
        J=IAIN(I)
        IF (J) 400,390,430
  390   J=I-7
        NTYP=7
        CALL ZVGC01 (J)
        IAIN(I)=J
        GO TO 430
C
  400   J=-J
        IF (J-NCD(NS)) 420,420,410
  410   IERR=9 0251 16
        GO TO 9999
C
  420   IAIN(I)=ICD(J,NS)
  430 CONTINUE
C
      ICDS(1)=IAIN(8)
      ICDS(2)=IAIN(8)
      ICDS(3)=IAIN(9)
      ICDS(4)=0
      I=1
      G=AIN(10)
      ISKP14=ISKP(14)
      ISKP(14)=1
      NTYP=1
      CALL ZVK
      ISKP(14)=ISKP14
      IF (IERR .NE. 0) GO TO 440
      NTYP=6
      IF (NTYPS .EQ. 23) GO TO 220
C
C                            Parameter fuer die Drehung.
      IZ1=IAIN(6)
      IZ2=IAIN(7)
      IF (IAIN(11) .EQ. KDR) NATSV=NAT(NS)
      GO TO 220
C
  630 IERR=9 0278 02
      IF (NTYPS .NE. 18) GO TO 9999
C
C                            Restore Koordinatensystem.
  440 DO  I=1,3
        DO  J=1,3
          TRA(J,I,1)=SK(J,I)
          TRAINV(J,I,1)=SK(J,I+3)
          TRA(J,I,2)=SK(J,I+10)
          TRAINV(J,I,2)=SK(J,I+13)
          DREH(J,I)=SK(J,I+6)
        ENDDO
        UR(I,1)=SK(I,10)
        UR(I,2)=SK(I,17)
      ENDDO
      IF (NTYPS .EQ. 23) GO TO 70
      GO TO 9990
C                            Kommando DG
  480 IF (ISKP(14) .EQ. 0) THEN
        DO  J=1,3
          IAIN(J)=0
        ENDDO
        AIN(5)=CONST(38)
        AIN(4)=CONST(6)
CYENG1
        CALL FLES (AIN,ISKP(31),5H3IFAE,24Hvon,bis,Achse,Grad,opt?$)
CYENG2
CYENGY        CALL FLES (AIN,ISKP(31),5H3IFAE,23Hfrom,to,axis,deg.,opt?$)
      ENDIF
      IF (IAIN(1) .LE. 0 .OR. IAIN(2) .GT. NAT(NS) .OR.
     +  IAIN(1) .GT. IAIN(2)) THEN
        IERR=9 0309 16
        GO TO 9999
      ENDIF
      CALL CNVTUP (AIN(5),1,4)
      IF (IAIN(5) .EQ. KDR) NATSV=NAT(NS)
      IZ1=IAIN(1)
      IZ2=IAIN(2)
      I=IAIN(3)
      G=AIN(4)
      GO TO 220
C                            Hilfsmatrix S = TRAINV * S * TRA
  490 DO  I=1,3
        DO  J=1,3
          A(I,J)=S(I,1)*TRA(1,J,NS)+S(I,2)*TRA(2,J,NS)+
     +    S(I,3)*TRA(3,J,NS)
        ENDDO
      ENDDO
      DO  I=1,3
        DO  J=1,3
          S(I,J)=TRAINV(I,1,NS)*A(1,J)+TRAINV(I,2,NS)*A(2,J)
     +                             +TRAINV(I,3,NS)*A(3,J)
        ENDDO
      ENDDO
C
C                            Verzweigung DGV / DKV / DPV
C
      IF (NTYPS .EQ. 23) THEN
        DO  J=1,3
          PU(J)=PT(J)-UR(J,NS)
        ENDDO
        DO  J=1,3
          PT(J)=S(J,1)*PU(1)+S(J,2)*PU(2)+S(J,3)*PU(3)+UR(J,NS)
        ENDDO
        GO TO 440
      ENDIF
      IF (NTYPS .NE. 21) GO TO 580
      K=12
      L=1
  530 DO  J=1,3
        K=K+1
        AIN(J+21)=AIN(K)-UR(J,NS)
      ENDDO
      DO  J=1,3
        X(J,L)=S(J,1)*AIN(22)+S(J,2)*AIN(23)+S(J,3)*AIN(24)+UR(J,NS)
      ENDDO
      L=L+2
      IF (L .LE. 5) GO TO 530
      DO  J=1,3
        X(J,2)=X(J,1)
        X(J,4)=X(J,1)
      ENDDO
      NTYP=12
      CALL ZVK
      IF (IERR) 440,9999,440
C
  580 IF (NATSV .GT. 0) NAT(NS)=IZ1-1
      DO  I=IZ1,IZ2
        IF (NAT(NS) .GE. NATDM) GO TO 630
        NAT(NS)=NAT(NS)+1
        DO  J=1,3
          PU(J)=AT(J,I,NS)-UR(J,NS)
        ENDDO
        DO  J=1,3
          AT(J,NAT(NS),NS)=S(J,1)*PU(1)+S(J,2)*PU(2)+
     +    S(J,3)*PU(3)+UR(J,NS)
          DO  K=1,3
            A(J,K)=TFVKT(J,K,I,NS)
          ENDDO
        ENDDO
        AT(4,NAT(NS),NS)=AT(4,I,NS)
        AT(5,NAT(NS),NS)=AT(5,I,NS)
        AT(6,NAT(NS),NS)=AT(6,I,NS)
        AT(7,NAT(NS),NS)=AT(5,I,NS)
        CALL CNVTUP (AT(7,NAT(NS),NS),1,4)
        ICLRP(NAT(NS),NS)=ICLRP(I,NS)
        IF (IPFLG(I,NS) .NE. 0) CALL MM (S,A,TFVKT(1,1,NAT(NS),NS))
        IPFLG(NAT(NS),NS)=IPFLG(I,NS)
      ENDDO
      IF (NATSV .GT. 0) NAT(NS)=NATSV
      IF (NTYPS-18) 9999,440,9999
C
C
C                            Kommando CPG
C
  640 CONTINUE
      IAIN(1)=ISKP(53)
      IAIN(2)=NAT(NS)
CYENG1
      CALL FLES (AIN,ISKP(31),3H2IE,9Hvon,bis?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),3H2IE,9Hfrom,to?$)
      IF (IAIN(2) .GT. NAT(NS)) IAIN(2)=NAT(NS)
      IF (IAIN(1) .LE. 0 .OR. IAIN(1) .GT. IAIN(2)) THEN
        IERR=09 0402 16
        GO TO 9999
      ENDIF
      DO  I=IAIN(1),IAIN(2)
        IF (NAT(NS) .LT. NATDM) THEN
          NAT(NS)=NAT(NS)+1
          DO  J=1,8
            AT(J,NAT(NS),NS)=AT(J,I,NS)
          ENDDO
          ICLRP(NAT(NS),NS)=ICLRP(I,NS)
          IPFLG(NAT(NS),NS)=IPFLG(I,NS)
          DO  J=1,3
            DO  K=1,3
              TFVKT(J,K,NAT(NS),NS)=TFVKT(J,K,I,NS)
            ENDDO
          ENDDO
        ELSE
          IERR=09 0419 02
          GO TO 9999
        ENDIF
      ENDDO
      GO TO 9999
C
C                            SP  Setze Defaults.
  770 DO 780 I=1,72
  780 IAIN(I)=100
CYENG1
      CALL FLES (AIN,ISKP(31),4H72CE,25HCode,Gewicht(100*I),...?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),4H72CE,24HCode,weight(100*I),...?$)
C
C                            Initialisiere.
      NC=1
      NTRY=24
      DO  I=1,3
        X1(I)=0.
      ENDDO
      SUM=0.
      J=((ISKP(31)+1)/2)*2
C                            Summiere.
      DO  I=2,J,2
        ICDS(1)=IAIN(I-1)
        H=FLOAT(IAIN(I))
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 9999
        SUM=SUM+H
        DO  K=1,3
          X1(K)=X1(K)+H*X(K,1)
        ENDDO
      ENDDO
C                            Teste auf Fehler.
      IF (SUM .LE. 0.) THEN
        IERR=9 0454 16
        GO TO 9999
      ENDIF
C                            Uebernimm Punkt.
      DO  K=1,3
        PTRIKL(K)=X1(K)/SUM
      ENDDO
      GO TO 70
C                            Kommando PP - Plotte Punkt
  860 TEMP=HOE/(HOE-PFREI(3))
      T(1)=PFREI(1)*TEMP*O9+CONST(11)
      T(2)=PFREI(2)*TEMP*O9+CONST(12)
      CALL UPLINF (T,7)
      GO TO 130
C                            SPG - Spiegele Gruppe
  870 continue
      IF (ISKP(14) .EQ. 0) THEN
      IACHSE=3
      AIN(4)=CONST(38)
CYENG1
      CALL FLES (AIN,ISKP(31),4H3IAE,19Hvon,bis,Achse,opt?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),4H3IAE,18Hfrom,to,axis,opt?$)
      ENDIF
      CALL CNVTUP (AIN(4),1,4)
C
C                            Pruefe Eingabe
      IF (IVON) 920,920,880
  880 IF (IBIS-NATDM) 890,890,920
  890 IF (IVON-IBIS) 900,900,920
  900 IF (IACHSE) 920,920,910
  910 IF (IACHSE-3) 930,930,920
  920 IERR=9 0483 16
      GO TO 9999
C                            Eingabe O.K.
  930 NC=1
      IF (IAIN(4) .NE. KDR) GO TO 940
      NATSV=NAT(NS)
      NAT(NS)=IVON-1
  940 NTRY=4
      DO  K=1,3
        DO  J=1,3
          X(K,J)=TRA(K,J,NS)
        ENDDO
      ENDDO
      X(IACHSE,IACHSE)=-X(IACHSE,IACHSE)
      CALL MM (TRAINV(1,1,NS),X,C)
      DO  IANR=IVON,IBIS
        IF (NAT(NS) .GE. NATDM) GO TO 630
        NAT(NS)=NAT(NS)+1
        DO  I=1,3
          X(I,1)=AT(I,IANR,NS)
        ENDDO
        CALL ZVDEK
        X2(IACHSE)=-X2(IACHSE)
        DO  I=1,3
          AT(I,NAT(NS),NS)=TRAINV(I,1,NS)*X2(1)+TRAINV(I,2,NS)*X2(2)+
     1    TRAINV(I,3,NS)*X2(3)+UR(I,NS)
          AT(I+3,NAT(NS),NS)=AT(I+3,IANR,NS)
        ENDDO
        AT(7,NAT(NS),NS)=AT(5,NAT(NS),NS)
        CALL CNVTUP (AT(7,NAT(NS),NS),1,4)
        ICLRP(NAT(NS),NS)=ICLRP(IANR,NS)
        IF (IPFLG(IANR,NS) .NE. 0) THEN
          DO  I=1,3
            DO  J=1,3
              X(I,J)=TFVKT(I,J,IANR,NS)
            ENDDO
          ENDDO
          CALL MM (C,X,TFVKT(1,1,NAT(NS),NS))
        ENDIF
        IPFLG(NAT(NS),NS)=IPFLG(IANR,NS)
      ENDDO
      GO TO 9990
C                            Kommando ZG - Zentrische Gruppe
  990 IBIS=0
      AIN(4)=CONST(38)
CYENG1
      CALL FLES (AIN,ISKP(31),5H2ICAE,19Hvon,bis,czent,opt?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),5H2ICAE,19Hfrom,to,ccent,opt?$)
      CALL CNVTUP (AIN(4),1,4)
      ICDS(1)=IAIN(3)
      NC=1
      NTRY=24
      IF (ICDS(1) .NE. 0) GO TO 1000
      NTYP=7
      ICDS(1)=1
      CALL ZVGC01 (ICDS(1))
 1000 CALL ZVDEK
      IF (IERR) 9999,1010,9999
 1010 I=IVON-1
      IF (IAIN(4) .NE. KDR) GO TO 1090
      NATSV=NAT(NS)
      NAT(NS)=I
      GO TO 1090
 1020 I=I+1
      IF (I) 1040,1040,1030
 1030 IF (I-NATDM) 1050,1050,1040
 1040 IERR=9 0550 04
      GO TO 9999
 1050 IF (NAT(NS)-NATDM) 1070,1060,1060
 1060 IERR=9 0553 02
      GO TO 9999
C
 1070 NAT(NS)=NAT(NS)+1
      DO  J=1,3
        AT(J,NAT(NS),NS)=2.*X(J,1)-AT(J,I,NS)
        AT(J+3,NAT(NS),NS)=AT(J+3,I,NS)
      ENDDO
      AT(7,NAT(NS),NS)=AT(5,I,NS)
      CALL CNVTUP (AT(7,NAT(NS),NS),1,4)
      ICLRP(NAT(NS),NS)=ICLRP(I,NS)
      IPFLG(NAT(NS),NS)=IPFLG(I,NS)
      DO  J=1,3
        DO  K=1,3
          TFVKT(J,K,NAT(NS),NS)=TFVKT(J,K,I,NS)
        ENDDO
      ENDDO
 1090 IF (I-IBIS) 1020,9990,9990
C
C                            Kommandos XP und XAT
C
 1100 CALL FLES (AIN,ISKP(31),3H2IE,7Hn1,n2?$)
      IF (IVON) 1140,1140,1110
 1110 IF (IVON-NATDM) 1120,1120,1140
 1120 IF (IBIS) 1140,1140,1130
 1130 IF (IBIS-NATDM) 1150,1150,1140
 1140 IERR=9 0579 04
      GO TO 9999
C                            Kommando XP - Vertausche Parameter
 1150 J=4
      IF (NTYP-13) 1170,1160,9999
C
C                            Kommando XAT - Vertausche Atome
 1160 J=6
 1170 DO  I=1,J
        H=AT(I,IVON,NS)
        AT(I,IVON,NS)=AT(I,IBIS,NS)
        AT(I,IBIS,NS)=H
      ENDDO
      DO  I=1,3
        DO  K=1,3
          H=TFVKT(I,K,IVON,NS)
          TFVKT(I,K,IVON,NS)=TFVKT(I,K,IBIS,NS)
          TFVKT(I,K,IBIS,NS)=H
        ENDDO
      ENDDO
      I=IPFLG(IVON,NS)
      IPFLG(IVON,NS)=IPFLG(IBIS,NS)
      IPFLG(IBIS,NS)=I
      IF (J .NE. 6) GO TO 9999
      J=ICLRP(IVON,NS)
      ICLRP(IVON,NS)=ICLRP(IBIS,NS)
      ICLRP(IBIS,NS)=J
      GO TO 9999
C                            MVP - Vertausche Gruppe
C
CYENG1
 1190 CALL FLES (AIN,ISKP(31),3H3IE,15Hvon<,bis>,vor?$)
CYENG2
CYENGY 1190 CALL FLES (AIN,ISKP(31),3H3IE,18Hfrom<,to>,before?$)
      IF (ISKP(31)-2) 1240,1200,1210
 1200 IAIN(3)=IAIN(2)
      IAIN(2)=IAIN(1)
 1210 IF (IAIN(1) .LE. 0) GO TO 1240
      IF (IAIN(1) .GT. IAIN(2)) GO TO 1240
      IF (IAIN(3) .GT. IAIN(2)) GO TO 1220
C
C                            Parameter umstellen.
      IAIN(4)=IAIN(3)
      IAIN(3)=IAIN(2)+1
      IAIN(2)=IAIN(1)-1
      IAIN(1)=IAIN(4)
      GO TO 1210
C
 1220 IAIN(3)=IAIN(3)-1
      IF (IAIN(2)-IAIN(3)) 1230,9999,1240
 1230 IF (IAIN(3) .LE. NATDM+1) GO TO 1260
 1240 IERR=9 0630 16
      GO TO 9999
C                            up/down
 1260 IAIN(7)=IAIN(1)-1
      IAIN(10)=IAIN(3)-IAIN(7)
      IAIN(5)=IAIN(2)-IAIN(7)
      IAIN(4)=IAIN(3)-IAIN(2)
      IAIN(6)=0
C
 1270 IAIN(7)=IAIN(7)+1
      IAIN(8)=IAIN(7)
      DO  I=1,8
        AIN(I+10)=AT(I,IAIN(7),NS)
      ENDDO
      IAIN(19)=ICLRP(IAIN(7),NS)
      DO  I=1,3
        DO  J=1,3
          S(I,J)=TFVKT(I,J,IAIN(7),NS)
        ENDDO
      ENDDO
      IAIN(20)=IPFLG(IAIN(7),NS)
      GO TO 1310
C                            Ring
 1290 DO  I=1,8
        AT(I,IAIN(8),NS)=AT(I,IAIN(9),NS)
      ENDDO
      ICLRP(IAIN(8),NS)=ICLRP(IAIN(9),NS)
      DO  I=1,3
        DO  J=1,3
          TFVKT(I,J,IAIN(8),NS)=TFVKT(I,J,IAIN(9),NS)
        ENDDO
      ENDDO
      IPFLG(IAIN(8),NS)=IPFLG(IAIN(9),NS)
      IAIN(8)=IAIN(9)
 1310 IAIN(6)=IAIN(6)+1
      IAIN(9)=IAIN(8)+IAIN(5)
      IF (IAIN(9) .GT. IAIN(3)) IAIN(9)=IAIN(8)-IAIN(4)
      IF (IAIN(9) .NE. IAIN(7)) GO TO 1290
C
      DO  I=1,8
        AT(I,IAIN(8),NS)=AIN(I+10)
      ENDDO
      ICLRP(IAIN(8),NS)=IAIN(19)
      DO  I=1,3
        DO  J=1,3
          TFVKT(I,J,IAIN(8),NS)=S(I,J)
        ENDDO
      ENDDO
      IPFLG(IAIN(8),NS)=IAIN(20)
      IF (IAIN(6) .LT. IAIN(10)) GO TO 1270
      GO TO 9999
C                            Kommando PREL - Punkt im freien Koordi-
C                            natensystem relativ zum alten fr. Punkt
 1330 DO  I=1,3
        AIN(I)=0.
      ENDDO
      CALL FLES (AIN,ISKP(31),3H3FE,7Hx,y,z?$)
      DO  I=1,3
        PF(I)=PF(I)+AIN(I)
      ENDDO
      GO TO 20
C                            Kommando SPC - Schwerpunkt ueber Codes
 1360 IAIN(1)=1
      IAIN(2)=NAT(NS)
      IF (ISKP(14) .EQ. 0) THEN
CYENG1
        CALL FLES (IAIN,ISKP(31),3H2IE,16Hn1,n2 (At-Nrn)?$)
CYENG2
CYENGY        CALL FLES (IAIN,ISKP(31),3H2IE,16Hn1,n2 (At-Nos)?$)
      ENDIF
      IF (NCD(NS) .LT. NCDA(NS)) THEN
        IERR=9 0701 12
        GO TO 9999
      ENDIF
C
      K9(NS)=0
      DO  J=3,6
        AIN(J)=0.
      ENDDO
      AIN(7)=-1000.
      NC=1
      DO 1470 IC=NCDA(NS),NCD(NS)
C
C                            Entschluessele Code
      NTRY=32
      CALL ZVDEK
      IF (IERR) 9999,1400,9999
 1400 IF (IANR-IVON) 1470,1410,1410
 1410 IF (IANR-IBIS) 1420,1420,1470
C
C                            Berechne trikline Koordinaten
 1420 NTRY=8
      IF (NTYPS-20) 1440,1430,1440
 1430 NTRY=12
 1440 CALL ZVDEK
      IF (IERR) 9999,1450,9999
 1450 TEMP=AT(4,IANR,NS)
      DO  J=3,5
        AIN(J)=AIN(J)+X(J-2,1)*TEMP
      ENDDO
      AIN(6)=AIN(6)+TEMP
      AIN(7)=AMAX1(AIN(7),X2(3))
 1470 CONTINUE
      IF (AIN(6)) 1490,1480,1490
 1480 IERR=9 0734 16
      GO TO 9999
C
 1490 DO  J=1,3
        PTRIKL(J)=AIN(J+2)/AIN(6)
      ENDDO
      GO TO 70
C
 9990 IF (NATSV .NE. 0) NAT(NS)=NATSV
 9999 RETURN
      END
