CZVGE02   10             -------------------
                          SUBROUTINE ZVGE02
C  CY-ENG-               -------------------
C
C   Kommando  NTYP  Bedeutung
C   MDM         1   Mittlere Distanzen im Molekuel
C   RTHO        2   Rhomboedrisch nach hexagonal obvers
C   PGM         3   Punkt durch Gerade und Maus
C   L           4   Laenge berechnen
C   W           5   Winkel berechnen
C   WVP         6   Winkel durch vier Punkte
C   EW          7   Ebenenwinkel
C   WVE         8   Winkel zwischen Vektor und x-y-Ebene des fr. S.
C   FK          9   Freie Koordinaten berechnen
C   TW         10   Torsionswinkel berechnen
C   AL         11   Aendere Laenge
C   AW         12   Aendere Winkel
C   AA         13   Addiere als Atom
C   DZA        14   Definiere Zelle a
C   DZB        15   Definiere Zelle b
C   VZAB       16   Vergleiche Zellen a und b
C   OZAB       17   Zeige Zellen a und b
C   AS         18   Abstaende nach Symbolen
C   MDMR       19   Mittlere Distanzen im Molekuel mit Reduktion
C   LZ         20   Lade zellen a<-z, b<-z, z<-a und z<-b
C   ASW        21   Abstaende und Winkel nach Symbolen
C
C                       geschrieben:  Hundt
C                 geaendert: 150917 JUN 2004  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 INBFR(5),NCDSV,NCDASV,K8SV,ITEMP,IVON,INACH
      INTEGER *4 IAIN(72),KDQ,NTYPS,I,J,J4,K,IPASS,ICNT,IS,IZ
      INTEGER *4 IRLINE(30),ID,KDAB(2),IOR,ISLST(20),J2,J3,IRC
      INTEGER *4 IRGZ(7)
      REAL    *4 RTH(9),BLANK,UND1,UND2,TEMP,T1,T2,T3,ARCCOS
      REAL    *4 DZAB(8,2),AINBFR(5),XH(3),XI(3)
C
      SAVE DZAB
C
      EQUIVALENCE (AIN(1),IAIN(1)),(WRLINE,IRLINE(1))
      EQUIVALENCE (TEMP,ITEMP),(INBFR(1),AINBFR(1))
C
      DATA BLANK,UND1,UND2/4H    ,4HUNDE,4HFINI/,KDQ/4HQ   /
      DATA RTH/-1.,0.,1., 1.,-1.,0., 1.,1.,1./,KDAB/4HA   ,4HB   /
      DATA DZAB/1.,1.,1.,90.,90.,90.,4HP   ,1.,
     +          1.,1.,1.,90.,90.,90.,4HP   ,1./
      DATA IRGZ/14601,14801,15501,16001,16101,16601,16701/
C
      NTYPS=NTYP
      GO TO (590,820,750,220,300,290,480,291,590,640,
C            1   2   3   4   5   6   7   8   9   10
     + 730,730,10,860,860,870,890,920,590,865,920), NTYPS
C      11  12  13 14  15  16  17  18  19  20  21
C
C                            Kommando AA
   10 DO  I=5,9
        IAIN(I)=0
      ENDDO
      CALL FLES (IAIN(5),ISKP(31),6HAAF2IE,
CYENG1
     1 28HName,Untersch.,r,Nr,Farbz.?$)
CYENG2
CYENGY     + 21HName,ext.,r,no,clrp?$)
      I=IAIN(8)
      IF (I) 120,30,40
   30 I=NAT(NS)+1
   40 IF (I .LE. NAT(NS)) GO TO 80
   50 IF (IAIN(5) .NE. 0) GO TO 60
      AIN(5)=UND1
      IF (IAIN(6) .EQ. 0) AIN(6)=UND2
      GO TO 70
   60 IF (IAIN(6) .EQ. 0) AIN(6)=BLANK
   70 IF (IAIN(7) .EQ. 0) AIN(7)=0.3
      GO TO 90
   80 IF (IAIN(5) .EQ. 0) AIN(5)=AT(5,I,NS)
      IF (IAIN(6) .EQ. 0) AIN(6)=AT(6,I,NS)
      IF (IAIN(7) .EQ. 0) AIN(7)=AT(4,I,NS)
      IF (IAIN(9) .EQ. 0) IAIN(9)=ICLRP(I,NS)
   90 IF (I .LE. NATDM) GO TO 130
  120 IERR=10012016
      GO TO 999
C
  130 DO  J=1,3
        AT(J,I,NS)=PTRIKL(J)
      ENDDO
      AT(4,I,NS)=AIN(7)
      AT(5,I,NS)=AIN(5)
      AT(6,I,NS)=AIN(6)
      CALL CNVTUP (AIN(5),1,4)
      AT(7,I,NS)=AIN(5)
      ICLRP(I,NS)=IAIN(9)
      IPFLG(I,NS)=0
  150 IF (I .GT. NAT(NS)) NAT(NS)=I
      GO TO 999
C                            Kommando L
C
  220 CALL FLES (ICDS,ISKP(31),3H2CE,7Hc1,c2?$)
      DO  I=1,2
        IF (ICDS(I).EQ. 0) THEN
          ICDS(I)=I
          NTYP=7
          CALL ZVGC01 (ICDS(I))
        ENDIF
      ENDDO
      NTRY=26
      NC=1
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      AIN(1)=AT(5,IANR,NS)
      AIN(2)=AT(6,IANR,NS)
      DO  I=1,3
        X2(I)=X1(I)
      ENDDO
      NC=2
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 999
      AIN(3)=AT(5,IANR,NS)
      AIN(4)=AT(6,IANR,NS)
      TEMP=0.
      DO  I=1,3
        AIN(10)=X1(I)-X2(I)
        TEMP=TEMP+AIN(10)*AIN(10)
      ENDDO
      TEMP=SQRT(TEMP)
      WRITE (WRLINE,270) (IAIN(I),I=1,4),TEMP
  270 FORMAT ('D: ',2A4,' (',10X,') ',2A4,' (',10X,') ',F10.5)
      CALL KPCDST (IRLINE,14,ICDS(1))
      CALL KPCDST (IRLINE,36,ICDS(2))
      CALL KPWRTE (NTOUT)
  280 CONST(5)=TEMP
      CONST(39)=TEMP
      GO TO 999
C                            Kommando WVP
C
  290 CALL FLES (ICDS,ISKP(31),3H4CE,18Hc1a,c2a, c1b,c2b?$)
      J4=4
      GO TO 310
C                       Kommando WVE
C
  291 CALL FLES (ICDS,ISKP(31),3H2CE,7Hc1,c2?$)
      J4=2
      GO TO 310
C                            Kommando W
C
  300 IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (ICDS,ISKP(31),3H3CE,10Hc1,cz,c2?$)
      ENDIF
      J4=3
  310 DO  I=1,J4
        IF (ICDS(I) .EQ. 0) THEN
          ICDS(I)=I
          NTYP=7
          CALL ZVGC01 (ICDS(I))
        ENDIF
      ENDDO
      NTRY=28
      DO  NC=1,J4
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        I=3*NC-2
        AIN(I)=AT(5,IANR,NS)
        AIN(I+1)=AT(6,IANR,NS)
        IAIN(I+2)=ICDS(NC)
        DO  I=1,3
          X(I,NC)=X2(I)
        ENDDO
      ENDDO
C                            W / WVP / WVE
      IF (J4-3) 351,380,360
  351 DO  I=1,3
        X(I,3)=X(I,1)-X(I,2)
        X(I,1)=X(I,3)
        X(I,2)=0.
      ENDDO
      X(3,3)=0.
      IF (ABS(X(1,1))+ABS(X(2,1)) .GT. 0.00001) GO TO 380
      TEMP=90.
      GO TO 471
C
  360 DO  I=1,3
        X(I,3)=X(I,4)+X(I,2)-X(I,3)
      ENDDO
C
  380 T1=0.
      T2=0.
      T3=0.
      DO  I=1,3
        AIN(20)=X(I,1)-X(I,2)
        T1=T1+AIN(20)*AIN(20)
        TEMP=X(I,3)-X(I,2)
        T2=T2+TEMP*TEMP
        T3=T3+AIN(20)*TEMP
      ENDDO
      T1=T1*T2
      IF (T1 .GT. 0.) GO TO 400
      IERR=10039006
      GO TO 999
C
  400 TEMP=ARCCOS(T3/SQRT(T1))
      IF (NTYPS .EQ. 10) GO TO 690
      IF (NTYPS .EQ. 7) GO TO 570
      IF (NTYPS .EQ. 6) GO TO 460
      IF (NTYPS .EQ. 8) GO TO 471
C
      IF (ISKP(14) .EQ. 0) THEN
        WRITE (WRLINE,440)
     1  (IAIN(I),I=1,2),(IAIN(I),I=4,5),(IAIN(I),I=7,8),TEMP
  440   FORMAT (
CYENG1
     1   'W: ',3(2A4,' (',10X,') '),F7.2)
CYENG2
CYENGY     1   'A: ',3(2A4,' (',10X,') '),F7.2)
        I=14
        DO  K=3,9,3
          CALL KPCDST (IRLINE,I,IAIN(K))
          I=I+22
        ENDDO
        CALL KPWRTE (NTOUT)
      ENDIF
  450 CONST(6)=TEMP
      GO TO 999
C                            WVP
CYENG1
  460 WRITE (WRLINE,'(''Winkel: '',2(2A4,'' ('',10X,'') ''))')
CYENG2
CYENGY  460 WRITE (WRLINE,'('' Angle: '',2(2A4,'' ('',10X,'') ''))')
     1 (IAIN(I),I=1,2),(IAIN(I),I=4,5)
      CALL KPCDST (IRLINE,19,IAIN(3))
      CALL KPCDST (IRLINE,41,IAIN(6))
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,'('' '',7X,2(2A4,'' ('',10X,'') ''),F7.2)')
     1 (IAIN(I),I=7,8),(IAIN(I),I=10,11),TEMP
      CALL KPCDST (IRLINE,19,IAIN(9))
      CALL KPCDST (IRLINE,41,IAIN(12))
      CALL KPWRTE (NTOUT)
      GO TO 450
C                       WVE
  471 WRITE (WRLINE,472) TEMP
      CALL KPWRTE (NTOUT)
CYENG1
  472 FORMAT ('Winkel:',F8.2)
CYENG2
CYENGY  472 FORMAT ('Angle:',F8.2)
      GO TO 450
C                            Ebenen-Winkel
C
  480 CALL FLES (ICDS,ISKP(31),3H6CE,20Hp1,p2,p3, p4,p5,p6?$)
      IF (ISKP(31) .GE. 6) GO TO 490
      IERR=10048016
      GO TO 999
C
  490 DO  I=1,6
        IF (ICDS(I) .EQ. 0) THEN
          ICDS(I)=I
          NTYP=7
          CALL ZVGC01 (ICDS(I))
        ENDIF
      ENDDO
  520 NTRY=26
      DO  NC=1,6
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        I=3*NC-2
        AIN(I)=AT(5,IANR,NS)
        AIN(I+1)=AT(6,IANR,NS)
        IAIN(I+2)=ICDS(NC)
        DO  J=1,3
          X(J,NC)=X1(J)
        ENDDO
      ENDDO
C                            Bestimme Vektoren.
      DO  I=1,3
        X(I,6)=X(I,5)-X(I,6)
        X(I,5)=X(I,5)-X(I,4)
        X1(I)= X(I,2)-X(I,1)
        X2(I)= X(I,2)-X(I,3)
      ENDDO
C                            Kreuzprodukt
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        X(I,1)=X1(J)*X2(K)-X1(K)*X2(J)
        X(I,2)=0.
        X(I,3)=X(J,5)*X(K,6)-X(K,5)*X(J,6)
      ENDDO
      GO TO 380
C
CYENG1
  570 WRITE (WRLINE,'(''W: '',3(2A4,'' ('',10X,'') ''))')
CYENG2
CYENGY  570 WRITE (WRLINE,'(''A: '',3(2A4,'' ('',10X,'') ''))')
     1 (IAIN(I),I=1,2),(IAIN(I),I=4,5),(IAIN(I),I=7,8)
      I=14
      DO  K=3,9,3
        CALL KPCDST (IRLINE,I,IAIN(K))
        I=I+22
      ENDDO
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,'(''   '',3(2A4,'' ('',10X,'') ''),F7.2)')
     1 (IAIN(I),I=10,11),(IAIN(I),I=13,14),(IAIN(I),I=16,17),TEMP
      I=14
      DO  K=12,18,3
        CALL KPCDST (IRLINE,I,IAIN(K))
        I=I+22
      ENDDO
      CALL KPWRTE (NTOUT)
      GO TO 450
C                            Kommando FK - Berechne freie Koordinaten
  590 K8(NS)=0
      NTRY=44
      NC=1
      IC=K9(NS)
      GO TO 620
C
  600 IC=IC+1
      CALL ZVDEK
      DO  I=1,3
        ATOMS(I,IC,NS)=X2(I)
      ENDDO
  620 IF (NCD(NS) .gt. IC) go to 600
      K9(NS)=NCD(NS)
      IF (NTYPS .EQ. 9) GO TO 999
      GO TO 830
C                            TW - Torsionswinkel
C
  640 IF (ISKP(14) .EQ. 0) then
        CALL FLES (ICDS,ISKP(31),3H4CE,13Hp1,p2,p3,p4?$)
        IF (ISKP(31) .LT. 4) THEN
          IERR=10065016
          GO TO 999
        ENDIF
      ENDIF
C
      DO  I=1,4
        IF (ICDS(I) .EQ. 0) THEN
          ICDS(I)=I
          NTYP=7
          CALL ZVGC01 (ICDS(I))
        ENDIF
      ENDDO
      ICDS(6)=ICDS(4)
      ICDS(5)=ICDS(3)
      ICDS(4)=ICDS(2)
      GO TO 520
C                            Bestimme Drehsinn
  690 T2=TEMP
      IF (X(1,1)*X(1,6)+X(2,1)*X(2,6)+X(3,1)*X(3,6) .LT. 0.) THEN
        TEMP=-TEMP
        T2=360.+TEMP
      ENDIF
      CONST(6)=T2
CYENG1
      WRITE (WRLINE,'('' Torsions-   '',3(2A4,'' -   ''),2A4,F11.2)')
CYENG2
CYENGY      WRITE (WRLINE,'('' Torsion     '',3(2A4,'' -  ''),2A4,F10.2)')
     1 IAIN(1),IAIN(2),IAIN(4),IAIN(5),IAIN(13),IAIN(14),IAIN(16),
     2 IAIN(17),TEMP
      CALL KPWRTE (NTOUT)
CYENG1
      WRITE (WRLINE,'('' winkel    '',4(''('',10X,'') ''),''('',
CYENG2
CYENGY      WRITE (WRLINE,'('' angle     '',4(''('',10X,'') ''),''('',
     1 F7.2,'')'')') T2
      CONST(6)=T2
      CALL KPCDST (IRLINE,13,IAIN(3))
      CALL KPCDST (IRLINE,26,IAIN(6))
      CALL KPCDST (IRLINE,39,IAIN(15))
      CALL KPCDST (IRLINE,52,IAIN(18))
      CALL KPWRTE (NTOUT)
      GO TO 999
C
C                            AL und AW - Aendere Laenge/Winkel
  730 AIN(1)=1.
      AIN(2)=0.
      CALL FLES (IAIN,ISKP(31),3H2FE,
CYENG1
     1 17HFaktor, Summand?$)
CYENG2
CYENGY     1 13Hfactor,add.?$)
      TEMP=CONST(NTYPS-6)*AIN(1)+AIN(2)
      WRITE (WRLINE,740) TEMP
      CALL KPWRTE (NTOUT)
CYENG1
  740 FORMAT ('Ergebnis:',F10.5)
CYENG2
CYENGY  740 FORMAT ('Result:',F10.5)
      IF (NTYPS-11) 999,280,450
C
C                       PGM - Punkt durch Gerade und Maus
C
  750 CALL FLES (ICDS,ISKP(31),3H2CE,7Hc1,c2?$)
      NTRY=28
      DO  NC=1,2
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=NC
          NTYP=7
          CALL ZVGC01 (ICDS(NC))
        ENDIF
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        TEMP=HOE/(HOE-X2(3))
        T(1)=X2(1)*TEMP
        T(2)=X2(2)*TEMP
C                         Unskalierte und ...
        X(1,NC+4)=T(1)
        X(2,NC+4)=T(2)
C                         ... skalierte freie Koordinaten
C
        X(1,NC+2)=T(1)*O9+CONST(11)
        X(2,NC+2)=T(2)*O9+CONST(12)
      ENDDO
      TEMP=(X(1,3)-X(1,4))**2+(X(2,3)-X(2,4))**2
      IF (TEMP .EQ. 0.) THEN
        IERR=10078016
        GO TO 999
      ENDIF
C                       Besorge Mauskoordinaten ...
      CALL UPLINF (AIN,8)
C                       ... und berechne freien Punkt
C
      TEMP=(TEMP+(AIN(1)-X(1,3))**2+(AIN(2)-X(2,3))**2
     +          -(AIN(1)-X(1,4))**2-(AIN(2)-X(2,4))**2)/(2.*TEMP)
      DO  I=1,2
        X2(I)=(X(I,6)-X(I,5))*TEMP+X(I,5)
      ENDDO
C
C                       Bestimme die triklinen Punkte
C                       zu (0,0,h) und X2
      DO  I=1,3
        X(I,3)=TRAINV(I,3,NS)*HOE+UR(I,NS)
        X(I,4)=TRAINV(I,1,NS)*X2(1)+TRAINV(I,2,NS)*X2(2)+UR(I,NS)
      ENDDO
C                       Bestimme den Schnittpunkt der Geraden
      NTYP=4
      CALL ZVSPVV
      GO TO 999
C                       RTHO - Rhomboedrisch nach hexagonal obvers
  820 DO  I=1,9
        AIN(I)=RTH(I)
      ENDDO
      J=NHMSNR(3,NS)
      ISKP(14)=1
      CALL ZVZ
      IF (IERR .NE. 0) GO TO 999
      DO  I=1,7
        IF (J .EQ. IRGZ(I)) THEN
          J=J+1
          IAIN(2)=ISKP(24)
          K=0
          CALL KPNTOS (J,IAIN,K,0)
          NTYP=2
          ISKP(14)=1
          CALL ZVHMS
          GO TO 825
        ENDIF
      ENDDO
      IAIN(1)=KDQ
      CALL ZVGTY
  825 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
      GO TO 940
C                            MDM - Mittlere distanzen im molekuel
  830 AIN(6)=0.
      CALL FLES (IAIN,ISKP(31),5H4I2FE,23Hu1,u2,z1,z2,dmin,dmax?$)
      IF (AIN(5) .GT. AIN(6)) THEN
        AIN(7)=AIN(6)
        AIN(6)=AIN(5)
        AIN(5)=AIN(7)
      ENDIF
C                            Durchlaufe codeliste.
      IPASS=0
      AIN(7)=0.
      AIN(8)=0.
  840 ICNT=0
      DO  I=1,NCD(NS)-1
        K=ICD(I,NS)/200000
        IS=0
        IF (IAIN(1) .LE. K .AND. K .LE. IAIN(2)) IS=1
        IF (IAIN(3) .LE. K .AND. K .LE. IAIN(4)) THEN
          IS=IS+2
          J4=K
        ENDIF
        IF (IS .NE. 0) THEN
          DO  J=I+1,NCD(NS)
            K=ICD(J,NS)/200000
            IZ=0
            IF (IAIN(1) .LE. K .AND. K .LE. IAIN(2)) IZ=1
            IF (IAIN(3) .LE. K .AND. K .LE. IAIN(4)) THEN
              IZ=IZ+2
              J4=K
            ENDIF
            IF (IZ .NE. 0 .AND. IOR(IZ,IS) .GE. 3) THEN
              DQ=SQRT((ATOMS(1,I,NS)-ATOMS(1,J,NS))**2+
     +        (ATOMS(2,I,NS)-ATOMS(2,J,NS))**2+
     +        (ATOMS(3,I,NS)-ATOMS(3,J,NS))**2)
              IF (AIN(5) .LE. DQ .AND. DQ .LE. AIN(6)) THEN
                IF (NTYPS .EQ. 19) DQ=DQ-AT(4,J4,NS)
                ICNT=ICNT+1
                IF (IPASS .EQ. 0) THEN
                  AIN(7)=AIN(7)+DQ
                  IF (ISKP(58) .GT. 0) THEN
                    WRITE (WRLINE,'(24X,A,F10.6)') ' D:',DQ
                    CALL KPCDST (IRLINE,1,ICD(I,NS))
                    CALL KPCDST (IRLINE,13,ICD(J,NS))
                    CALL KPWRTE (NTOUT)
                  ENDIF
                ELSE
                  AIN(8)=AIN(8)+(DQ-AIN(7))**2
                ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDIF
      ENDDO
      IF (ICNT .EQ. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'Keine passenden Abstaende gefunden.'
CYENG2
CYENGY     +  'No suitable distances found.'
        GO TO 850
      ELSE
        IF (IPASS .EQ. 0) THEN
          AIN(7)=AIN(7)/FLOAT(ICNT)
          IPASS=IPASS+1
          GO TO 840
        ELSE
          IF (ICNT .LT. 2) THEN
            AIN(8)=100.
          ELSE
            AIN(8)=SQRT(AIN(8)/FLOAT(ICNT-1))
          ENDIF
          WRITE (WRLINE,'(I4,A,F10.5,A,F10.5)')
CYENG1
     +    ICNT,' Abstaende. Mittelwert:',AIN(7),' Sigma:',AIN(8)
CYENG2
CYENGY     +    ICNT,' distances. Mean:',AIN(7),' Sigma:',AIN(8)
          CONST(5)=AIN(7)
        ENDIF
      ENDIF
  850 CALL KPWRTE (NTOUT)
      GO TO 999
C                            DZA UND DZB
  860 I=NTYP-13
      CALL FLES (DZAB(1,I),ISKP(31),4H6FAE,18Ha,b,..,gamma,Gty?$)
      DO  J=2,3
        IF (DZAB(J,I) .EQ. 0. .OR. DZAB(J,I) .EQ. 1.)
     +  DZAB(J,I)=DZAB(1,I)
      ENDDO
      DZAB(8,I)=0.
      GO TO 999
C                            LZ - Lade zelle
  865 IAIN(2)=0
      CALL FLES (IAIN,ISKP(31),3HIAE,7Hn,gty?$)
      IF (IAIN(1) .LE. 0 .OR. IAIN(1) .GT. 4) THEN
        IERR=10 0558 16
        GO TO 999
      ENDIF
      I=IAIN(1)
      IF (IAIN(1) .LT. 3) THEN
        DO  J=1,6
          DZAB(J,I)=ZELLE(J,NS)
        ENDDO
        IF (IAIN(2) .NE. 0) DZAB(7,I)=AIN(2)
        DZAB(8,I)=ZELLE(7,NS)
      ELSE
        I=I-2
        DO  J=1,6
          ZELLE(J,NS)=DZAB(J,I)
        ENDDO
        ISKP(14)=1
        NTYP=1
        CALL ZVZ
        ISKP(14)=0
      ENDIF
      GO TO 999
C                            VZAB - Vergleiche zellen a und b
C
  870 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
      ID=2
  880   NAT(NS)=2
C                            Reset TRABIJ in KPZ
        NTYP=16
        CALL ZVZ
C                            Z
        DO  I=1,6
          ZELLE(I,NS)=DZAB(I,ID)
        ENDDO
        ISKP(14)=1
        NTYP=1
        CALL ZVZ
        IF (IERR .NE. 0) GO TO 999
        DZAB(8,ID)=ZELLE(7,NS)
C                            GTY
        NSYM(NS)=1
        AIN(1)=DZAB(7,ID)
        ISKP(14)=1
        CALL ZVGTY
        IF (IERR .NE. 0) GO TO 999
C
C                            RDZ
        NTYP=8
        CALL ZVTSZR
        IF (IERR .NE. 0) GO TO 999
C
C                            SZXZ
        NTYP=15
        ISKP(14)=1
        CALL ZVZ
C                            Z
        DO  I=1,6
          ZELLE(I,NS)=DZAB(I,3-ID)
        ENDDO
        ISKP(14)=1
        NTYP=1
        CALL ZVZ
        IF (IERR .NE. 0) GO TO 999
        DZAB(8,3-ID)=ZELLE(7,NS)
C                            GTY
        NSYM(NS)=1
        AIN(1)=DZAB(7,3-ID)
        ISKP(14)=1
        CALL ZVGTY
        IF (IERR .NE. 0) GO TO 999
C
C                            SZA
        NTYP=11
        ISKP(14)=1
        CALL ZVZ
        IF (IERR .NE. 0) THEN
          IF (IERR .NE. -2) GO TO 999
          IERR=0
          GO TO 900
        ENDIF
        IF (AIN(31) .GE. 1.E5) GO TO 900
  890     DO  J=1,2
            WRITE (WRLINE,'(A1,A,3F8.4,3F9.2,1X,A1,A,F10.2)')
     +      KDAB(J),':',(DZAB(I,J),I=1,7),' Vol:',DZAB(8,J)
            CALL KPWRTE (NTOUT)
          ENDDO
          IF (NTYPS .EQ. 17) GO TO 825
          WRITE (WRLINE,'(6X,A,A2,A,A1,22X,A)')
     +    'Transformation ',KDAB(3-ID),'-> ',KDAB(ID),'Inverse Matrix'
          CALL KPWRTE (NTOUT)
          DO  I=1,3
            DO  J=1,3
              S(J,I)=X(J,I)
            ENDDO
          ENDDO
          CALL MINV (S,3,AIN(1),AIN(2),AIN(5))
          DO  I=1,3
            WRITE (WRLINE,'(3F10.5,10X,3F10.5)')
     +      (X(I,J),J=1,3),(S(I,J),J=1,3)
            CALL KPWRTE (NTOUT)
          ENDDO
          GO TO 940
  900   ID=ID-1
      IF (ID .GE. 1) GO TO 880
CYENG1
      WRITE (WRLINE,'(A)') 'Keine Loesung gefunden.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'No solution found.'
      CALL KPWRTE (NTOUT)
      GO TO 940
C                            AS - Hole input.
  920 AIN(41)=0.0001
      AIN(42)=0.0001
      CALL FLES (IAIN,ISKP(31),9H20A20A2FE,17Hs1,s2,dmin,dmax?$)
      CALL CNVTUP (IAIN,1,160)
      AINBFR(3)=AIN(41)
      AINBFR(4)=AIN(42)
C                            Zerlege die strings
      I=0
      J=0
      J4=80
  921 IRC=0
      CALL FCNV (IAIN(41),IAIN(61),2HAR,IAIN,I,J4,IRC)
      IF (IAIN(61) .EQ. 0) GO TO 922
      IF (IRC .NE. 0) THEN
        IERR=10 616 16
        GO TO 999
      ENDIF
      IF (IAIN(41) .NE. ISKP(24)) THEN
        IF (J .LT. 20) THEN
          J=J+1
          ISLST(J)=IAIN(41)
          GO TO 921
        ELSE
          IERR=10 625 20
          GO TO 999
        ENDIF
      ENDIF
  922 IF (J4 .EQ. 80) THEN
        J2=J
        I=80
        J4=160
        GO TO 921
      ELSE
        J3=J
      ENDIF
      IF (AINBFR(3) .GT. AINBFR(4)) THEN
        TEMP=AINBFR(3)
        AINBFR(3)=AINBFR(4)
        AINBFR(4)=TEMP
      ENDIF
      AINBFR(5)=AINBFR(3)*AINBFR(3)
C
C                            Save pointer
      NCDSV=NCD(NS)
      NCDASV=NCDA(NS)
      K8SV=K8(NS)
C                            (Naechstes) ursprungsatom.
      DO  IVON=ISKP(53),NAT(NS)
        NCDA(NS)=NCD(NS)+1
        K8(NS)=K8SV
        TEMP=AT(7,IVON,NS)
C        CALL CNVTUP (ITEMP,1,4)
        DO  I=1,J2
          IF (ITEMP .EQ. ISLST(I)) GO TO 923
        ENDDO
        GO TO 929
C
C                          Naechstes zielatom.
C
  923   INBFR(1)=ITEMP
        DO  INACH=ISKP(53),NAT(NS)
          TEMP=AT(7,INACH,NS)
C          CALL CNVTUP (ITEMP,1,4)
          DO  I=J2+1,J3
            IF (ITEMP .EQ. ISLST(I)) GO TO 924
          ENDDO
          GO TO 928
C
C                          Setze ein AKS auf.
  924     INBFR(2)=ITEMP
          ICDS(1)=IVON
          IZ1=INACH
          IZ2=INACH
          IF (ISKP(33) .LT. 1)
     +      CALL ZVDTAB (INBFR(1),INBFR(2),AINBFR(4),2)
          DQ=AINBFR(4)
          CONST(20)=AINBFR(5)
          NTYP=3
          ISKP(14)=1
          CALL ZVAVBR
          IF (IERR .NE. 0) GO TO 930
  928     CONTINUE
        ENDDO
  929   CONTINUE
C                            Berechne abstaende.
        ICDS(2)=ICDS(1)
        IF (NCD(NS)-NCDA(NS) .GE. 0) THEN
          NC=2
          NTRY=26
          CALL ZVDEK
          DO  I=1,3
            X2(I)=X1(I)
          ENDDO
          WRITE (WRLINE,'(A,2A4,A,I5,2X,3F10.6)')
CYENG1
     +    'Abstaende von  ',AT(5,IANR,NS),AT(6,IANR,NS),' Nr.',IANR,
CYENG2
CYENGY     +    'Distances from ',AT(5,IANR,NS),AT(6,IANR,NS),' No.',IANR,
     +    (X(I,2),I=1,3)
          CALL KPWRTE (NTOUT)
          NC=1
          NTRY=42
          DO  IC=NCDA(NS),NCD(NS)
            CALL ZVDEK
            ATOMS(1,IC,NS)=SQRT((X2(1)-X1(1))**2+(X2(2)-X1(2))**2+
     +      (X2(3)-X1(3))**2)
          ENDDO
C                            Sortiere abstaende.
C
          IF (NCD(NS)-NCDA(NS) .GT. 0) THEN
            IC=NCDA(NS)
  931       J=IC
            IC=IC+1
            TEMP=ATOMS(1,IC,NS)
            J4=ICD(IC,NS)
            GO TO 933
  932       ATOMS(1,J+1,NS)=ATOMS(1,J,NS)
            ICD(J+1,NS)=ICD(J,NS)
            J=J-1
            IF (J .LT. NCDA(NS)) GO TO 934
  933       IF (TEMP .LT. ATOMS(1,J,NS)) GO TO 932
  934       ATOMS(1,J+1,NS)=TEMP
            ICD(J+1,NS)=J4
            IF (IC .LT. NCD(NS)) GO TO 931
          ENDIF
          NTRY=40
          DO  IC=NCDA(NS),NCD(NS)
            CALL ZVDEK
            J=IC-NCDA(NS)+1
            WRITE (WRLINE,'(I3,A,F10.6,1X,2A4,11X,3F10.6)')
     +       J,')',ATOMS(1,IC,NS),AT(5,IANR,NS),AT(6,IANR,NS),
     +       (X(I,1),I=1,3)
            CALL KPCDST (IRLINE,23,ICD(IC,NS))
            CALL KPWRTE (NTOUT)
          ENDDO
          IF (NTYPS .GT. 18 .AND. NCD(NS)-NCDA(NS) .GT. 0) THEN
CYENG1
            WRITE (WRLINE,'(A)') 'Winkel:'
CYENG2
CYENGY            WRITE (WRLINE,'(A)') 'Angles:'
            CALL KPWRTE (NTOUT)
            K=0
            NTRY=42
            DO  I=NCDA(NS),NCD(NS)-1
              IC=I
              NC=1
              CALL ZVDEK
              IZ=IANR
              DO  J=1,3
                XH(J)=X2(J)-X1(J)
              ENDDO
              NC=3
              DO  IC=I+1,NCD(NS)
                T3=ATOMS(1,I,NS)*ATOMS(1,IC,NS)
                IF (T3 .NE. 0.) THEN
                  CALL ZVDEK
                  do  j=1,3
                    xi(j)=x2(j)-x1(j)
                  enddo
                  t2=arccos((xh(1)*xi(1)+xh(2)*xi(2)+xh(3)*xi(3))/
     +            sqrt((xh(1)*xh(1)+xh(2)*xh(2)+xh(3)*xh(3))*
     +            (xi(1)*xi(1)+xi(2)*xi(2)+xi(3)*xi(3))))
                  K=K+1
                  WRITE (WRLINE,'(I3,A,F10.3,2(1X,2A4,11X))')
     +            K,')',T2,AT(5,IZ,NS),AT(6,IZ,NS),AT(5,IANR,NS),
     +            AT(6,IANR,NS)
                  CALL KPCDST (IRLINE,23,ICD(I,NS))
                  CALL KPCDST (IRLINE,43,ICD(IC,NS))
                  CALL KPWRTE (NTOUT)
                ENDIF
              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ENDDO
C                            Restore
  930 NCD(NS)=NCDSV
      NCDA(NS)=NCDASV
      K8(NS)=K8SV
  940 ISKP(14)=0
C
  999 RETURN
      END
