C         96              -------------------
                           SUBROUTINE ZVGE05
C                         -------------------
C
C   ntyp = 1 UFR   Ueberlagere Fragment (weiter, wenn ohne args)
C   ntyp = 2 UFRA  Ueberlagere Fragment automatisch
C   ntyp = 3 ACAF  Fremde Codes als Atome laden
C   ntyp = 4 OUM   Zeige Ueberlagerungsmatrix
C   ntyp = 5 CFS   Kopiere Vordergrundstrukur
C   ntyp = 6 (CFS) fuer interne Zwecke
C   ntyp = 7 UFFL  Ueberlagere Fragment und fuelle, wenn leer
C
C                geschrieben: 160951 SEP 2004  (Hundt)
C                  geaendert: 021011 NOV 2011  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
      INTEGER *4 ICHDIM
      PARAMETER (ICHDIM=128)
      INTEGER *4 ICHND(ICHDIM)
      INTEGER *4 INBFR(8),I,J,K,NSE,NSA,IRLINE(30),ICPOI(4),NTYPS
      INTEGER *4 ICDSI(3),NCDSAV,NAMHND(3),IAT(8,PARDIM,2),INBUF2(10)
      INTEGER *4 IAIN(72),NLSG,NNSA,IDFLG,NEFP,JA,JB,INBUF3(8)
      INTEGER *4 NAME(3),J1,J2,J3
      REAL    *4 ANBFR(8),ARCCOS,ABWIH(5),ANBUF2(10),ANBUF3(8),XF(3)
      REAL    *4 TEMP,TEMP2
C
      EQUIVALENCE (WRLINE,IRLINE(1)),(INBFR(1),ANBFR(1))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1)),(INBUF2(1),ANBUF2(1))
      EQUIVALENCE (AIN(1),IAIN(1)),(INBUF3(1),ANBUF3(1))
C
      SAVE INBFR,ICPOI,ICHND,ABWIH,NSE,NSA,ICDSI,NAMHND,INBUF2,IDFLG
      SAVE INBUF3
C
      DATA NSA/0/,NSE/0/,(INBFR(I),I=1,8)/7*0,1/,IDFLG/1/
      DATA (INBUF2(I),I=1,10)/8*0,1,1/,ANBUF3(1)/0.25/,ANBUF3(2)/4.0/
      DATA INBUF3(3)/1/,INBUF3(4)/1/,INBUF3(5)/4H    /,INBUF3(6)/0/
      DATA INBUF3(7)/1/,ANBUF3(8)/1.0/
C
      NTYPS=NTYP
      GO TO (10,80,160,170,180,180,190),NTYPS
C             1  2   3   4   5   6   7
C
C                            UFR - Ueberlagere Fragment
C
   10 CALL FLES (INBFR,ISKP(31),7H3C2F3IE,
     + 30Hh1,h2,h3,told,tola,z1,z2,opt?$)
   20 IF (ISKP(31) .EQ. 0 .AND. IDFLG .EQ. 0) THEN
C
C                            Fortsetzung der Ueberlagerung
        NS=NSE
        GO TO 60
      ENDIF
C                            Reset "done" flag.
      IDFLG=0
      NSE=NS
      NSA=3-NS
      IF (INBFR(4) .EQ. 0) ANBFR(4)=0.25
      IF (INBFR(5) .EQ. 0) ANBFR(5)=4.00
      IF (INBFR(6) .EQ. 0) INBFR(6)=ISKP(53)
      IF (INBFR(7) .EQ. 0) INBFR(7)=NAT(NSA)
C
C    Berechne fuer die toleranzen abstaende und winkel des handels.
C
      DO  NC=1,3
        ICDS(NC)=INBFR(NC)
        IF (ICDS(NC) .EQ. 0) THEN
          ICDS(NC)=NC
          NTYP=7
          CALL ZVGC01 (ICDS(NC))
        ENDIF
        NTRY=26
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 990
        NAMHND(NC)=IAT(7,IANR,NS)
        INBFR(NC)=ICDS(NC)
        IF (NTYPS .EQ. 2) INBUF2(NC)=ICDS(NC)
        DO  I=1,3
          X(I,NC)=X1(I)
        ENDDO
      ENDDO
      DO  J=2,3
        DO  I=1,3
          S(I,J)=X(I,J)-X(I,1)
        ENDDO
      ENDDO
      DO  I=2,3
        ABWIH(I)=SQRT(S(1,I)**2+S(2,I)**2+S(3,I)**2)
      ENDDO
      ABWIH(1)=ARCCOS((S(1,2)*S(1,3)+S(2,2)*S(2,3)+S(3,2)*S(3,3))/
     +(ABWIH(2)*ABWIH(3)))
C
C  abwih enthaelt die abstaende (2,3) und den winkel (1) des handels.
C  Teste, ob die werte vernuenftig sind.
C
      ABWIH(4)=ABWIH(1)-ANBFR(5)
      ABWIH(5)=ABWIH(1)+ANBFR(5)
      IF (ABWIH(4) .LE. 5. .OR. ABWIH(5) .GT. 175. .OR.
     +    ABWIH(2)-ANBFR(4) .LE. 0. .OR.
     +    ABWIH(3)-ANBFR(4) .LE. 0.) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'ZVGE050109 - Handle unbrauchbar.'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'ZVGE050109 - Handle invalid.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 990
      ENDIF
C
C            Setze jetzt einen lauf ueber die zielatome auf.
C
      ICDSI(1)=INBFR(6)
   30 NS=NSA
C                            Teste ggf. den namen.
C
      IF (INBFR(8) .NE. 0 .AND.
     + NAMHND(1) .NE. IAT(7,ICDSI(1),NS)) GO TO 70
      NCDSAV=NCD(NSA)
      NCDA(NS)=NCDSAV+1
C
C          Suche hierum kandidaten fuer die beiden handelarme.
C
      ICPOI(1)=0
      DO  I=1,2
        ICDS(1)=ICDSI(1)
        IZ1=INBFR(6)
        IZ2=INBFR(7)
        DQ=ABWIH(I+1)+ANBFR(4)
        CONST(20)=(ABWIH(I+1)-ANBFR(4))**2
        NTYP=3
        ISKP(14)=1
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 990
C
C                Teste, ob namensscharf gesucht werden soll.
C
        IF (INBFR(8) .NE. 0) THEN
          K=NCDA(NS)-1
          DO  J=NCDA(NS),NCD(NS)
            IF (IAT(7,ICD(J,NS)/200000,NS) .EQ. NAMHND(I+1)) THEN
              K=K+1
              ICD(K,NS)=ICD(J,NS)
            ENDIF
          ENDDO
          NCD(NS)=K
        ENDIF
        IF (NCD(NS) .LT. NCDA(NS))  THEN
C
C             'Keinen Kandidaten fuer Handle Teil',i,' gefunden.'
C
          NCD(NS)=NCDSAV
          GO TO 70
        ENDIF
        ICPOI(I)=NCD(NS)-NCDSAV
        IF (I .LT. 2) THEN
          NCDA(NS)=NCD(NS)+1
        ELSE
          NCDA(NS)=1
        ENDIF
      ENDDO
C                            Schreibe die handle-atome ab.
C
      IF (NCD(NS)-NCDSAV .GT. ICHDIM) THEN
        WRITE (WRLINE,'(A)') 'ZVGE050171 - Overflow in ICHND.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 990
      ENDIF
      DO  I=NCDSAV+1,NCD(NS)
        ICHND(I-NCDSAV)=ICD(I,NS)
      ENDDO
C                            ICHND enthaelt die codes mit den handle-
C                            kandidanten. 1-ICPOI(1) und ICPOI(1)+1-
C                            ICPOI(2).  Restore NCD.
      NCD(NS)=NCDSAV
C                            Setze run auf.
      ICPOI(3)=1
   40 ICDSI(2)=ICHND(ICPOI(3))
      ICPOI(4)=ICPOI(1)+1
   50 ICDSI(3)=ICHND(ICPOI(4))
C
C       Die beiden vektoren duerfen nicht auf einer geraden liegen.
C
      NS=NSA
      IF (ICDSI(2) .EQ. ICDSI(3) .OR.
     +    ICDSI(2) .EQ. 1022002-ICDSI(3)) GO TO 60
C
C                Und auch der winkel sollte in etwa stimmen.
C
      NTRY=26
      DO  NC=4,6
        ICDS(NC)=ICDSI(NC-3)
        ICDS(NC-3)=INBFR(NC-3)
        CALL ZVDEK
        DO  I=1,3
          X(I,NC)=X1(I)
        ENDDO
      ENDDO
      DO  J=2,3
        DO  I=1,3
          S(I,J)=X(I,J+3)-X(I,4)
        ENDDO
      ENDDO
      DO  I=2,3
        T(I)=SQRT(S(1,I)**2+S(2,I)**2+S(3,I)**2)
      ENDDO
      T(1)=ARCCOS((S(1,2)*S(1,3)+S(2,2)*S(2,3)+S(3,2)*S(3,3))/
     + (T(2)*T(3)))
      IF (T(1) .LT. ABWIH(4) .OR. T(1) .GT. ABWIH(5)) GO TO 60
C
      IF (NTYPS .EQ. 1) THEN
        WRITE (WRLINE,'(A)') 'VZDP'
        J=5
        DO  I=1,6
          CALL KPCDST (IRLINE,J,ICDS(I))
          J=J+10
        ENDDO
        CALL KPWRTE (NTOUT)
      ENDIF
C                            Fuehre den befehl jetzt aus.
      NS=NSE
      NTYP=9
      CALL ZVGC05
      IF (NTYPS-2) 990,90,210
C
   60 ICPOI(4)=ICPOI(4)+1
      IF (ICPOI(4) .LE. ICPOI(2)) GO TO 50
      ICPOI(3)=ICPOI(3)+1
      IF (ICPOI(3) .LE. ICPOI(1)) GO TO 40
   70 ICDSI(1)=ICDSI(1)+1
      IF (ICDSI(1) .LE. INBFR(7)) GO TO 30
      IF (NTYPS .EQ. 1 .OR. NLSG .NE. 0) THEN
CYENG1
      WRITE (WRLINE,'(A)') 'Fertig.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'Done.'
      ELSE
CYENG1
      WRITE (WRLINE,'(A)') 'Keine Loesung gefunden.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'No solution found.'
      ENDIF
      CALL KPWRTE (NTOUT)
C                            Setze DONE flag.
      IDFLG=1
      IF (NTYPS .EQ. 7 .AND. INBUF3(6) .EQ. 2) GO TO 210
      GO TO 990
C
C                            UFRA - Ueberlagere Fragment automatisch
C
   80 IF (ISKP(14) .NE. 0) THEN
        DO  I=1,10
          INBUF2(I)=IAIN(I)
        ENDDO
        ISKP(14)=0
        GO TO 81
      ENDIF
      CALL FLES (INBUF2,ISKP(31),7H3C3F4IE,
     + 40Hh1,h2,h3,told,tola,toln,z1,z2,opt,nsol?$)
   81 NSE=NS
      NSA=3-NS
      NLSG=0
      NEFP=NCDDM+1
      IF (ISKP(31) .EQ. 0) THEN
        WRITE (WRLINE,'(30X,3F6.2,4I5)')
     +   (ANBUF2(I),I=4,6),(INBUF2(I),I=7,10)
        J=1
        DO  I=1,3
          CALL KPCDST (IRLINE,J,INBUF2(I))
          J=J+10
        ENDDO
        CALL KPWRTE (NTDISP)
        GO TO 990
      ENDIF
      IF (INBUF2(4) .EQ. 0) ANBUF2(4)=0.25
      IF (INBUF2(5) .EQ. 0) ANBUF2(5)=4.00
      IF (INBUF2(7) .EQ. 0) INBUF2(7)=ISKP(53)
      IF (INBUF2(8) .EQ. 0) INBUF2(8)=NAT(NSA)
C
C                            Stelle Puffer zusammen
      DO  I=1,5
        INBFR(I)=INBUF2(I)
      ENDDO
      DO  I=6,8
        INBFR(I)=INBUF2(I+1)
      ENDDO
      ISKP(31)=3
      NCD(NSA)=0
      GO TO 20
C                      Stelle fest, ob das eine loesung ist
   90 K=4
      NS=NSA
  100 IAIN(1)=ISKP(53)
      IAIN(2)=NAT(NSE)
      IAIN(3)=INBUF2(7)
      IAIN(4)=INBUF2(8)
C                          Auswahl tol_d oder tol_n
      IAIN(5)=INBUF2(K)
      NTYP=10
      ISKP(14)=1
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 990
      IF (K .EQ. 4) NNSA=NCD(NSA)
C
C         Teste, ob das eine loesung sein koennte (K=4) oder ist (K=6)
C
      IF (ISKP(76) .EQ. 0) THEN
        IF (NCD(NSE) .NE. NCD(NSA)) GO TO 150
      ELSE
        IF (K .EQ. 4) THEN
          IF (NCD(NSE) .GT. NNSA) GO TO 150
        ELSE
          IF (NCD(NSA) .GT. NNSA) GO TO 150
        ENDIF
      ENDIF
C
C            Teste, ob die umgebung noch abgesucht werden soll.
C
      IF (K .EQ. 4 .AND. INBUF2(6) .NE. 0) THEN
        K=6
        GO TO 100
      ENDIF
C                   Teste ggf., ob die namen uebereinstimmen.

      IF (INBUF2(9) .NE. 0) THEN
        DO  IC=1,NCD(NSA)
          IF (IAT(7,ICD(IC,1)/200000,1) .NE.
     1    IAT(7,ICD(IC,2)/200000,2)) GO TO 150
        ENDDO
      ENDIF
C                   Teste, ob das die gewuenschte loesung ist.
      NLSG=NLSG+1
      IF (INBUF2(10) .EQ. 0 .OR. NLSG .EQ. INBUF2(10)) THEN
        WRITE (WRLINE,'(A,I3,A)') '(',NLSG,') VZDP'
        J=12
        ICDS(1)=INBUF2(1)
        DO  I=1,6
          CALL KPCDST (IRLINE,J,ICDS(I))
          J=J+10
        ENDDO
        CALL KPWRTE (NTDISP)
        IF (INBUF2(10) .NE. 0) GO TO 990
C
C               Teste, ob diese loesung bereits vorhanden ist.
C
        J=NCDDM
  110   IF (J .GT. NEFP) THEN
          K=ICD(J,NSA)
          IF (K .EQ. NCD(NSA)) THEN
            JA=J-1
            JB=JA-K+1
          ENDIF
          DO  I=1,NCD(NSA)
            DO  J=JB,JA
              IF (ICD(J,NSA) .EQ. ICD(I,NSA)) GO TO 120
            ENDDO
            GO TO 130
  120       CONTINUE
          ENDDO
CYENG1
          WRITE (WRLINE,'(A)') 'Schon vorhanden.'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') 'Already present.'
          CALL KPWRTE (NTOUT )
          GO TO 140
  130     J=JB-1
          GO TO 110
        ENDIF
C                Speichere die loesung, falls noch moeglich.
C
        IF (NEFP-NCD(NSA)-1 .GT. NCD(NSA)) THEN
          NEFP=NEFP-1
          ICD(NEFP,NSA)=NCD(NSA)
          DO  I=1,NCD(NSA)
            NEFP=NEFP-1
            ICD(NEFP,NSA)=ICD(I,NSA)
          ENDDO
        ENDIF
  140   CONTINUE
      ENDIF
C                            Naechste kombination
  150 NS=NSE
      NCD(NSA)=0
      GO TO 60
C                            ACAF - Addiere fremde Codes als Atome
  160 NSE=NS
      NSA=3-NS
      IF (ISKP(14) .EQ. 0) THEN
        IAIN(1)=1
        IAIN(2)=NCD(NSA)
CYENG1
        CALL FLES (IAIN,ISKP(31),3H2IE,29Hvon,bis (Nrn. in Codeliste)?$)
CYENG2
CYENGY        CALL FLES (IAIN,ISKP(31),
CYENGY     +  3H2IE,29Hfrom,to (No's in code list)?$)
      ENDIF
      IF (IAIN(1) .LE. 0 .OR. IAIN(2) .GT. NCD(NSA) .OR.
     +  IAIN(1) .GT. IAIN(2)) THEN
        IERR=96 0390 16
        GO TO 999
      ENDIF
      NTRY=44
      NC=1
      NS=NSA
      DO  IC=IAIN(1),IAIN(2)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 990
        IF (NAT(NSE) .GE. NATDM) THEN
          IERR=96 0400 02
          GO TO 990
        ENDIF
        J=NAT(NSE)+1
        NAT(NSE)=J
        DO  I=4,8
          AT(I,J,NSE)=AT(I,IANR,NS)
        ENDDO
        DO  I=1,3
          AT(I,J,NSE)=TRAINV(I,1,NSE)*X2(1)+TRAINV(I,2,NSE)*X2(2)+
     +    TRAINV(I,3,NSE)*X2(3)+UR(I,NSE)
        ENDDO
        ICLRP(J,NSE)=ICLRP(IANR,NSA)
        IPFLG(J,NSE)=0
      ENDDO
      GO TO 990
C                            OUM - Zeige Ueberlagerungsmatrix
  170 NSA=3-NS
      DO  I=1,3
        X1(I)=-TRA(I,1,NSA)*UR(1,NSA)-TRA(I,2,NSA)*UR(2,NSA)-
     +  TRA(I,3,NSA)*UR(3,NSA)
      ENDDO
      DO  I=1,3
        T(I)=TRAINV(I,1,NS)*X1(1)+TRAINV(I,2,NS)*X1(2)+
     +  TRAINV(I,3,NS)*X1(3)+UR(I,NS)
        DO  J=1,3
          S(I,J)=RG(1,I,NS)*DG(1,J,NSA)+RG(2,I,NS)*DG(2,J,NSA)+
     +    RG(3,I,NS)*DG(3,J,NSA)
        ENDDO
        WRITE (WRLINE,'(3F10.5,5X,F10.5)') (S(I,J),J=1,3),T(I)
        CALL KPWRTE (NTOUT)
      ENDDO
      IF (ISKP(14) .EQ. 0) THEN
        IAIN(1)=0
        CALL FLES (IAIN,ISKP(31),2HIE,
CYENG1
     +  33HTransformation ausfuehren (0/1)?$)
CYENG2
CYENGY     +  30HExecute transformation (0/1)?$)
        IF (IAIN(1) .NE. 0) THEN
          IF (NAT(NS)+4 .GT. NATDM) THEN
            IERR=96 0441 02
            GO TO 999
          ENDIF
          DO  I=1,3
            AT(I,NAT(NS)+1,NS)=T(I)
            DO  J=1,3
              AT(I,NAT(NS)+J+1,NS)=S(I,J)
            ENDDO
          ENDDO
          NAT(NS)=NAT(NS)+1
          ISKP(14)=1
          NTYP=12
          ICDS(1)=NAT(NS)
          CALL ZVZ
          IF (IERR .NE. 0) GO TO 999
          NAT(NS)=NAT(NS)+3
          ICDS(1)=NAT(NS)-2
          ICDS(2)=NAT(NS)-1
          ICDS(3)=NAT(NS)
          ISKP(14)=1
          NTYP=18
          CALL ZVZ
          NAT(NS)=NAT(NS)-4
          DO  I=1,3
            UR(I,1)=0.
            UR(I,2)=0.
          ENDDO
        ENDIF
      ENDIF
      GO TO 999
C                            Kopiere vordergrundstrukur
  180 NSA=3-NS
      DO  I=1,18
        TITEL(I,NSA)=TITEL(I,NS)
      ENDDO
      DO  I=1,7
        ZELLE(I,NSA)=ZELLE(I,NS)
        RK(I,NSA)=RK(I,NS)
      ENDDO
      DO  I=1,3
        DO  J=1,3
          DG(J,I,NSA)=DG(J,I,NS)
          RG(J,I,NSA)=RG(J,I,NS)
          TRA(J,I,NSA)=TRA(J,I,NS)
          TRAINV(J,I,NSA)=TRAINV(J,I,NS)
        ENDDO
        UR(I,NSA)=UR(I,NS)
      ENDDO
      DO  I=1,NAT(NS)
        DO  J=1,8
          AT(J,I,NSA)=AT(J,I,NS)
        ENDDO
        ICLRP(I,NSA)=ICLRP(I,NS)
        DO  J=1,3
          DO  K=1,3
            TFVKT(K,J,I,NSA)=TFVKT(K,J,I,NS)
          ENDDO
        ENDDO
        IPFLG(I,NSA)=IPFLG(I,NS)
      ENDDO
      NAT(NSA)=NAT(NS)
      DO  I=1,NCD(NS)
        ICD(I,NSA)=ICD(I,NS)
        DO  J=1,3
          ATOMS(J,I,NSA)=ATOMS(J,I,NS)
        ENDDO
      ENDDO
      K8(NSA)=K8(NS)
      K9(NSA)=K9(NS)
      NCD(NSA)=NCD(NS)
      NCDA(NSA)=NCDA(NS)
      DO  I=1,NSYM(NS)
        DO  J=1,12
          SYM(J,I,NSA)=SYM(J,I,NS)
        ENDDO
      ENDDO
      NSYM(NSA)=NSYM(NS)
      DO  I=1,3
        NHMSNR(I,NSA)=NHMSNR(I,NS)
      ENDDO
      DO  I=1,IPKP(NS)
        IPK(I,NSA)=IPK(I,NS)
      ENDDO
      IPKP(NSA)=IPKP(NS)
      DO  I=1,NPPOI(NS)
        NPLST(I,NSA)=NPLST(I,NS)
      ENDDO
      NPPOI(NSA)=NPPOI(NS)
      IF (NTYPS .EQ. 5) CALL FLES (IAIN,IAIN,1HE,2H?$)
      GO TO 999
C
C             UFFL - Ueberlagere Fragment und fuelle, wenn leer
  190 NSE=NS
      NSA=3-NS
      CALL FLES (INBUF3,ISKP(31),9H2F2IA2IFE,
     + 37Htold,tola,opt,p,name,opt2,nlsg,tolc?$)
      IDFLG=0
      NLSG=0
C                            Setze Defaults
C
      IF (INBUF3(6) .GT. 0) ISKP(76)=0
      IF (INBUF3(1) .EQ. 0) ANBUF3(1)=0.25
      IF (INBUF3(2) .EQ. 0) ANBUF3(2)=4.00
C
      IF (INBUF3(4) .LE. 0 .OR. INBUF3(4) .GT. NAT(NSE)) THEN
        IERR=96 0544 16
        GO TO 990
      ENDIF
      NAME(3)=0
      NAME(1)=INBUF3(5)
      IF (NAME(1) .EQ. ISKP(24)) NAME(1)=IAT(5,INBUF3(4),NSE)
      NAME(2)=NAME(1)
      CALL CNVTUP (NAME,5,4)
C                            Ubertrage Parameter
      INBFR(4)=INBUF3(1)
      INBFR(5)=INBUF3(2)
      INBFR(6)=ISKP(53)
      INBFR(8)=INBUF3(3)
C                            Waehle unter den Handle-Atomen
C                            drei geeignete aus.
C                            Berechne kartesische Koordinaten ...
      K8(NS)=0
      K9(NS)=0
      NTRY=42
      NC=1
      DO  IC=1,NCD(NS)
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  I=1,3
          ATOMS(I,IC,NS)=X1(I)
        ENDDO
      ENDDO
C                            ... und berechne Kreuzprodukte.
      TEMP2=0.
      DO  J1=1,NCD(NS)-2
        DO  J2=J1+1,NCD(NS)-1
          DO  I=1,3
            X1(I)=ATOMS(I,J2,NS)-ATOMS(I,J1,NS)
          ENDDO
          DO  J3=J2+1,NCD(NS)
            DO  I=1,3
              X2(I)=ATOMS(I,J3,NS)-ATOMS(I,J1,NS)
            ENDDO
            TEMP=0.
            DO  I=1,3
              J=ID2(I)
              TEMP=TEMP+X1(I)*X2(J)-X1(J)*X2(I)
            ENDDO
            TEMP=ABS(TEMP)
            IF (TEMP .GT. TEMP2) THEN
              IT(1)=J1
              IT(2)=J2
              IT(3)=J3
              TEMP2=TEMP
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C
C                            Schreibe Handle ab
      IF (TEMP2 .LT. 0.1) THEN
      WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVGE050602 - Kein geeignetes Handle gefunden.'
CYENG2
CYENGY     +  'ZVGE050602 - No suitable handle found.'
        CALL KPWRTE (NTOUT)
        IERR=-1
        GO TO 990
      ENDIF
      INBFR(1)=ICD(IT(1),NS)
      INBFR(2)=ICD(IT(2),NS)
      INBFR(3)=ICD(IT(3),NS)
C                            Berechne die freien Koordinaten des
C                            Atoms, auf das p zeigt.
      NC=1
      ICDS(1)=INBUF3(4)
      NTRY=28
      CALL ZVDEK
      IF (IERR .NE. 0) GO TO 990
      DO  I=1,3
        XF(I)=X2(I)
      ENDDO
C                            Starte UFR
  200 INBFR(7)=NAT(NSA)
      NCD(NSA)=0
      GO TO 20
C                            Fertig?
C
  210 IF (IDFLG .NE. 0) then
        IF (INBUF3(7) .NE. NLSG) THEN
CYENG1
          WRITE (WRLINE,'(I4,A)') NLSG,' Loesungen gefunden.'
CYENG2
CYENGY          WRITE (WRLINE,'(I4,A)') NLSG,' solutions found.'
          CALL KPWRTE (NTOUT )
        ENDIF
        GO TO 990
      ENDIF
C                      Stelle fest, ob das eine loesung ist
      NS=NSA
  220 IAIN(1)=ISKP(53)
      IAIN(2)=NAT(NSE)
      IAIN(3)=ISKP(53)
      IAIN(4)=NAT(NSA)
      IAIN(5)=INBUF3(1)
      NTYP=10
      ISKP(14)=1
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 990
C
C         Teste, ob das eine loesung sein koennte.
C
      IF (ISKP(76) .EQ. 0) THEN
        IF (NCD(NSE) .NE. NCD(NSA)) GO TO 230
      ELSE
        IF (NCD(NSE) .GT. NCD(NSA)) GO TO 230
      ENDIF
C                      Teste ob weitere Option gesetzt.
C
      IF (INBUF3(6) .GT. 0) THEN
        DO  IC=1,NCD(NSE)
          IF (IAT(7,ICD(IC,NSE)/200000,NSE) .NE.
     +        IAT(7,ICD(IC,NSA)/200000,NSA)) GO TO 230
        ENDDO
      ENDIF
      NLSG=NLSG+1
      IF (INBUF3(6) .EQ. 2) THEN
        IF (NLSG .EQ. INBUF3(7)) THEN
CYENG1
          WRITE (WRLINE,'(A)') 'Erfolg.'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') 'Success.'
          CALL KPWRTE (NTOUT )
          GO TO 990
        ENDIF
        GO TO 230
      ENDIF
C             Berechne die Koordinaten in der Hintergrundsturktur.
C
      IANR=INBUF3(4)
      IF (NAT(NSA) .GE. NATDM) THEN
        IERR=96 0653 02
        GO TO 990
      ENDIF
      J=NAT(NSA)+1
      NAT(NSA)=J
      NAME(3)=NAME(3)+1
      AT(4,J,NSA)=0.3
      IAT(5,J,NSA)=NAME(1)
      IAT(6,J,NSA)=ISKP(24)
      I=0
      CALL KPNTOS (NAME(3),IAT(6,J,NSA),I,0)
      IAT(7,J,NSA)=NAME(2)
      IAT(5,J,NSA)=NAME(1)
      DO  I=1,3
        AT(I,J,NSA)=TRAINV(I,1,NSA)*XF(1)+TRAINV(I,2,NSA)*XF(2)+
     +  TRAINV(I,3,NSA)*XF(3)+UR(I,NSA)
      ENDDO
      ICLRP(J,NSA)=ICLRP(IANR,NSE)
      IPFLG(J,NSA)=0
C                     Teste, ob dieser Platz schon besetzt ist.
      NS=NSA
      ICDS(1)=J
      IZ1=ISKP(53)
      IZ2=J-1
      DQ=ANBUF3(8)
      CONST(20)=0.
      NTYP=3
      NCD(NS)=0
      ISKP(14)=1
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 990
C
C                    Wenn das ist der Fall ist, loesche Atom.
C
      IF (NCD(NS) .GT. 0) THEN
        NAT(NS)=NAT(NS)-1
        NAME(3)=NAME(3)-1
      ENDIF
C                            Naechster Versuch.
  230 NS=NSE
      NCD(NSA)=0
      ISKP(31)=0
      GO TO 20
C
  990 NS=NSE
      NCDA(NSA)=1
  999 RETURN
      END
