C         98              ------------------
                           SUBROUTINE ZVIDF
C                         ------------------
C
C Das Programm idealisiert ein Fragment (Kommando 'IDF'). Damit ist
C folgendes gemeint: Verglichen werden die Inhalte der Codelisten, die
C die gleiche Anzahl an Atomen enthalten m"ussen, die bereits
C hinreichend dicht beieinander liegen. Die Ursprungspunkte werden in
C die gewichteten Schwerpunkte gelegt und die Basisvektoren der
C Vordergrundstruktur so gedreht, dass nach der Methode der kleinsten
C Quadrate die Abst"ande sich entsprechender Atome minimal werden.  
C
C
C                 geschrieben: 121449 APR 2006  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 IAIN(72),I,J,K,NSV,NSH,I1,I2,INBFR(2),IDC,IE
      REAL    *4 DMAX,DMAXQ,SPK(6),TEMP,GEWSUM,AINBFR(2)
      EQUIVALENCE (AIN(1),IAIN(1)),(INBFR(1),AINBFR(1))
C
      NSV=NS
      NSH=3-NSV
      AINBFR(1)=0.5
      INBFR(2)=4
      CALL FLES (INBFR,ISKP(31),3HFIE,8Hdmax,n?$)
      IF (NCD(1) .LT. NCDA(1)+3 .OR. NCD(2) .LT. NCDA(2)+3) THEN
        IERR=98 0024 12
        GO TO 999
      ENDIF
      IF (NCDA(1) .NE. NCDA(2) .OR. NCD(1) .NE. NCD(2)) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'Zahl der Atome in beiden Codelisten stimme
     +n nicht ueberein.'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'Number of atoms in both codelists are not 
CYENGY     +equal.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
C                            Berechne gewichteten schwerpunkt
C                            der beiden strukturen ...
      NTRY=40
      DO  I=1,6
        SPK(I)=0.
      ENDDO
      DO  IC=NCDA(NSV),NCD(NSV)
        DO  NS=1,2
          NC=NS
          CALL ZVDEK
          IF (NS .EQ. NSV) TEMP=AT(4,IANR,NSV)
        ENDDO
        DO  I=1,3
          SPK(I)=SPK(I)+X(I,1)*TEMP
          SPK(I+3)=SPK(I+3)+X(I,2)*TEMP
        ENDDO
        GEWSUM=GEWSUM+TEMP
      ENDDO
C                            ... und definiere hier die urspruenge.
      DO  I=1,3
        UR(I,1)=SPK(I)/GEWSUM
        UR(I,2)=SPK(I+3)/GEWSUM
      ENDDO
C                            Berechne die koordinaten beider
C                            strukturen im "weltsystem".
      NC=1
      DO  NS=1,2
        DO  IC=NCDA(NS),NCD(NS)
          NTRY=40
          CALL ZVDEK
          DO  I=1,3
            X(I,1)=X(I,1)-UR(I,NS)
          ENDDO
          NTRY=2
          CALL ZVDEK
          DO  I=1,3
            ATOMS(I,IC,NS)=X1(I)
          ENDDO
        ENDDO
      ENDDO
C                            Teste, ob die atome dicht genug
C                            beieinander liegen. Sortiere ggf. um.
      DMAX=AINBFR(1)
      IDC=0
      IC=NCDA(NSH)
    2 IE=NCD(NSH)
        DMAXQ=DMAX*DMAX
        NS=NSH
    4   DO  J=IC,NCD(NSV)
          TEMP=(ATOMS(1,IC,NS)-ATOMS(1,J,NSV))**2+
     +    (ATOMS(2,IC,NS)-ATOMS(2,J,NSV))**2+
     +    (ATOMS(3,IC,NS)-ATOMS(3,J,NSV))**2
          IF (TEMP .LE. DMAXQ) THEN
            IF (J .EQ. IC) GO TO 10
              DO  I=1,3
                TEMP=ATOMS(I,J,NSV)
                ATOMS(I,J,NSV)=ATOMS(I,IC,NSV)
                ATOMS(I,IC,NSV)=TEMP
              ENDDO
              I=ICD(J,NSV)
              ICD(J,NSV)=ICD(IC,NSV)
              ICD(IC,NSV)=I
            GO TO 10
          ENDIF
        ENDDO
        IF (IC .LT. IE) THEN
          DO  I=1,3
            TEMP=ATOMS(I,IE,NSH)
            ATOMS(I,IE,NSH)=ATOMS(I,IC,NSH)
            ATOMS(I,IC,NSH)=TEMP
          ENDDO
          I=ICD(IE,NSH)
          ICD(IE,NSH)=ICD(IC,NSH)
          ICD(IC,NSH)=I
        ENDIF
        IE=IE-1
        IC=IC-1
   10   CONTINUE     
      IC=IC+1
      IF (IC .LE. IE) GO TO 4
      IF (IE .LT. NCD(NSH)) THEN
        IF (IDC .LT. INBFR(2)) THEN
          IDC=IDC+1
          DMAX=DMAX*1.25
          IC=IE+1
          GO TO 2
        ELSE
          I=NCD(NSH)-IE+1
CYENG1
          WRITE (WRLINE,'(I4,A)') I,' Atome nicht zuzuordnen.'
CYENG2
CYENGY          WRITE (WRLINE,'(A,I4,A)') 'No partner found for',I,' atoms.'
          CALL KPWRTE (NTDISP )
          IERR=-1
          GO TO 999
        ENDIF
      ENDIF
C                            ACAL
      NS=NSV
      I1=NAT(NS)+1
      IAIN(1)=NCDA(NS)
      IAIN(2)=NCD(NS)
      ISKP(14)=1
      NTYP=7
      CALL ZVGE03
      I2=NAT(NS)
C                            ACAF
      IAIN(1)=NCDA(NS)
      IAIN(2)=NCD(NS)
      ISKP(14)=1
      NTYP=3
      CALL ZVGE05
C                            ID
      IAIN(1)=I1
      IAIN(2)=I2
      IAIN(3)=I2+1
      ISKP(14)=1
      NTYP=1
      CALL ZVIDL2
C                            Pseudoatome wieder loeschen.
      NAT(NS)=I1+1
C                    Basisvektoren der vordergrundstruktur drehen.
      DO  I=1,3
        AT(I,NAT(NS)-1,NS)=CONST(I+59)
        AT(I,NAT(NS),NS)=UR(I,NS)
      ENDDO
      IAIN(1)=2
      IAIN(2)=NAT(NS)-1
      AIN(3)=CONST(59)
      ISKP(14)=1
      NTYP=5
      CALL ZVGC05
C                            Hole ursprung der vordergrundstruktur.
      DO  I=1,3
        UR(I,NS)=AT(I,NAT(NS),NS)
      ENDDO
      NAT(NS)=NAT(NS)-2
      ISKP(94)=1
C
  999 NS=NSV
      K8(1)=0
      K9(1)=0
      K8(2)=0
      K9(2)=0
      RETURN
      END
