CKPIDL2   26             -------------------
                          SUBROUTINE ZVIDL2
C  CY-ENG-               -------------------
C
C  Das Programm berechnet die Drehachse, den Drehwinkel und die
C  Translation, die angewendet werden muessen, um ein Molekuel
C  in ein anderes zu ueberfuehren.
C
C   Kommando  NTYP  Bedeutung
C   ID          1   Idealisiere
C   IDL         2   Idealisiere Liste
C   AI          3   Addiere idealisierte Parameter
C   IDG         4   Idealisiere Gruppe
C
C                 Geschrieben: 050784 JUL 1984 (Hundt)
C                 Geaendert:   111453 APR 2006 (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 INBFR(50),I,I1,I180GF,I2,I3,ISKP14,IZSP,IZSPC
      INTEGER *4 J,JP,K,L,M,N,NATSV,NRET,NTYPS,IAIN(72),NZ,NZ1,J2
      INTEGER *4 NATI,NATR,NIDLP,NIDL(6),IK1,IK2,NLSG,KDA,IUP
      INTEGER *4 IAT(8,PARDIM,2),NPASS,MERK,IAGRM,NATSV3,IOPTI
      REAL    *4 SPK(6),RICOS(3),VMERK(3),PSDSYM(3,4),PSDT(3,3)
      REAL    *4 ZSPKT(3,2,2),DET,DREHWK,GEWSUM,T1,T2,T3,T4,TEMP
      REAL    *4 TMERK,WCHTNG,AINBFR(50),SPK1(3),SPK2(3),DIDL(6)
      REAL    *4 TEMP2,DH2,TEMP3
C
      EQUIVALENCE (INBFR(1),I1),(INBFR(2),I2),(INBFR(3),I3)
      EQUIVALENCE (INBFR(1),AINBFR(1)),(AIN(1),IAIN(1))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1))
C
      SAVE INBFR,PSDSYM
C
      DATA INBFR/50*0/,KDA/4HA   /
      DATA PSDSYM/0.,0.,0.,  1.,0.,0.,  0.,1.,0.,  0.,0.,1./
C
      NATSV=NAT(NS)
      IOPTI=0
C                            Hole Eingabe
      NTYPS=NTYP
      GO TO (20,10,10,390), NTYPS
   10 CALL FLES (INBFR,ISKP(31),4H49IE,18Hi1,i2, r1,r2,...?$)
      JP=ISKP(31)+1
      GO TO 30
C
   20 IF (ISKP(14) .EQ. 0) THEN
        CALL FLES (INBFR,ISKP(31),3H3IE,10Hi1,i2,r1?$)
      ELSE
        INBFR(1)=IAIN(1)
        INBFR(2)=IAIN(2)
        INBFR(3)=IAIN(3)
        ISKP(14)=0
      ENDIF
   30 IF (I1 .LE. 0 .OR. I2 .GT. NAT(NS) .OR. I1 .GE. I2 .OR. I3 .LE. 0)
     + GO TO 50
      IF (NTYPS-2) 40,70,310
   40 IF (I3+I2-I1 .LE. NAT(NS)) GO TO 60
   50 IERR=26 0059 16
      GO TO 999
C                            Ausgleich fuer ehemalige Eingabe
   60 INBFR(4)=I1-I2-I3
      JP=5
   70 INBFR(JP)=0
C                            Berechne die gewichteten Schwerpunkte
      DREHWK=0.
      DO  I=1,6
        SPK(I)=0.
      ENDDO
      NTRY=2
      NC=1
      GEWSUM=0.
C
      I=I1-1
      JP=3
   80 J=INBFR(JP)
      JP=JP+1
   90 I=I+1
      IF (I .GT. I2) THEN
        IERR=26 0079 16
        GO TO 999
      ENDIF
C
      TEMP=AT(4,I,NS)
      DO  K=1,3
        SPK(K)=SPK(K)+AT(K,I,NS)*TEMP
        SPK(K+3)=SPK(K+3)+AT(K,J,NS)*TEMP
      ENDDO
      GEWSUM=GEWSUM+TEMP
C
      IF (INBFR(JP)) 120,100,80
  100 IF (I .EQ. I2) GO TO 130
  110 IERR=26 0090 16
      GO TO 999
C
  120 J=J+1
      IF (J .LE. -INBFR(JP)) GO TO 90
      JP=JP+1
      IF (INBFR(JP)) 110,100,80
  130 CONTINUE
C
      IF (GEWSUM .EQ. 0.) THEN
        IERR=26 0100 16
        GO TO 999
      ENDIF
      DO  I=1,6
        SPK(I)=SPK(I)/GEWSUM
      ENDDO
C                            Zahl der evtl. noetigen Zusaztpunkte.
      IZSP=I1-I2+3
      IF (IZSP .LT. 1) THEN
        IZSP=0
        GO TO 150
      ENDIF
C                            Teste, ob Hilfsatom hinten untergebracht
C                            werden kann.
C
      IF (NAT(NS) .GE. NATDM) GO TO 50
C
C                            Save Koordinatensystem.
      NAT(NS)=NATDM
      NTYP=19
      CALL ZVK
      ISKP14=ISKP(14)
      ISKP(14)=1
C                            Lege Koordinatensystem in Mol. 1
      DO  I=1,3
        AT(I,NATDM,NS)=SPK(I)
      ENDDO
      ICDS(1)=NATDM
      ICDS(2)=I1
      ICDS(3)=I1+1
      ICDS(4)=0
      IF (IZSP .EQ. 1) THEN
        ICDS(4)=I1+1
        ICDS(5)=I1+2
      ENDIF
      NTYP=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 140
C
C                            Basisvektor(en) als Hilfspunkt(e)
C                            verwenden.
      DO  I=1,3
        X(I,1)=TRAINV(I,3,NS)+UR(I,NS)-SPK(I)
        X(I,2)=TRAINV(I,2,NS)+UR(I,NS)-SPK(I)
      ENDDO
      DO  NC=1,2
        CALL ZVDEK
        DO  I=1,3
          ZSPKT(I,NC,1)=X1(I)
        ENDDO
      ENDDO
C
C                            Lege Koordinatensystem in Mol. 2
      DO  I=1,3
        AT(I,NATDM,NS)=SPK(I+3)
      ENDDO
      ICDS(2)=I3
      ICDS(3)=I3+1
      IF (INBFR(4) .GT. 0) ICDS(3)=INBFR(4)
      ICDS(4)=0
      IF (IZSP .EQ. 1) THEN
        ICDS(4)=ICDS(3)
        ICDS(5)=ICDS(4)+1
        IF (INBFR(4) .GT. 0) ICDS(5)=INBFR(5)
      ENDIF
      NTYP=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 140
C
C                            Basisvektor(en) als Hilfspunkt(e)
C                            verwenden.
      DO  I=1,3
        X(I,1)=TRAINV(I,3,NS)+UR(I,NS)-SPK(I+3)
        X(I,2)=TRAINV(I,2,NS)+UR(I,NS)-SPK(I+3)
      ENDDO
      DO  NC=1,2
        CALL ZVDEK
        DO  I=1,3
          ZSPKT(I,NC,2)=X1(I)
        ENDDO
      ENDDO
C
C                            Restore Koordinatensystem.
  140 NTYP=20
      CALL ZVK
      ISKP(14)=ISKP14
      IF (IERR .NE. 0) GO TO 999
C
  150 NC=5
C                            Loesche Matrix.
      DO  I=1,4
        DO  J=1,3
          X(J,I)=0.
        ENDDO
      ENDDO
C                            Schleife ueber die beiden Molekuele.
      IZSPC=0
      TMERK=0.
      I180GF=0.
C
  160 I=I1-1
      JP=3
  170 J=INBFR(JP)
      JP=JP+1
  180 I=I+1
C                            Berechne die Koordinaten der in den
C                            Ursprung verschobenen Atome.
      DO  K=1,3
        X(K,5)=AT(K,J,NS)-SPK(K+3)
      ENDDO
      CALL ZVDEK
      DO  K=1,3
        X2(K)=X1(K)
        X(K,5)=AT(K,I,NS)-SPK(K)
      ENDDO
      CALL ZVDEK
      WCHTNG=AT(4,I,NS)
C                            Normiere auf 1.
C
  190 T1=X1(1)*X1(1)+X1(2)*X1(2)+X1(3)*X1(3)
      IF (T1 .GT. 0.) THEN
        T1=SQRT(T1)
        DO  K=1,3
          X1(K)=X1(K)/T1
        ENDDO
      ENDIF
C
      T2=X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3)
      IF (T2 .GT. 0.) THEN
        T2=SQRT(T2)
        DO  K=1,3
          X2(K)=X2(K)/T2
        ENDDO
      ENDIF
C                            Speise in Matrix ein.
      TEMP=(T1+T2)*WCHTNG
      IF (I180GF .NE. 0) GO TO 230
      T3=0.
      DO  K=1,3
        T4=(X1(K)+X2(K))*TEMP
        AIN(K+6)=T4
        T3=T3+ABS(T4)
        AIN(K+9)=(X1(K)-X2(K))*TEMP
      ENDDO
      IF (T3 .GT. TMERK) THEN
        TMERK=T3
        DO  K=1,3
          VMERK(K)=AIN(K+6)
        ENDDO
      ENDIF
C
      AIN(13)=AIN(8)
      AIN(14)=-AIN(7)
      AIN(15)=0.
      AIN(16)=AIN(12)
      ASSIGN 210 TO NRET
C
  200 X(1,1)=X(1,1)+AIN(13)*AIN(13)
      X(1,2)=X(1,2)+AIN(13)*AIN(14)
      X(1,3)=X(1,3)+AIN(13)*AIN(15)
      X(1,4)=X(1,4)+AIN(13)*AIN(16)
C
      X(2,2)=X(2,2)+AIN(14)*AIN(14)
      X(2,3)=X(2,3)+AIN(14)*AIN(15)
      X(2,4)=X(2,4)+AIN(14)*AIN(16)
C
      X(3,3)=X(3,3)+AIN(15)*AIN(15)
      X(3,4)=X(3,4)+AIN(15)*AIN(16)
C
      GO TO NRET, (210,220,240)
C
  210 AIN(13)=-AIN(9)
      AIN(14)=0.
      AIN(15)=AIN(7)
      AIN(16)=AIN(11)
      ASSIGN 220 TO NRET
      GO TO 200
C
  220 AIN(13)=0.
      AIN(14)=AIN(9)
      AIN(15)=-AIN(8)
      AIN(16)=AIN(10)
      ASSIGN 240 TO NRET
      GO TO 200
C                            Summiere auf fuer Vektor.
  230 T2=0.
      T3=0.
      DO  K=1,3
        T4=(X1(K)+X2(K))*TEMP
        X(K,5)=VMERK(K)+T4
        T2=T2+ABS(X(K,5))
        X(K,6)=VMERK(K)-T4
        T3=T3+ABS(X(K,6))
      ENDDO
      L=5
      IF (T3 .GT. T2) L=6
      DO  K=1,3
        X(K,7)=X(K,7)+X(K,L)
      ENDDO
C                            Next I
C
  240 IF (INBFR(JP)) 250,260,170
C
  250 J=J+1
      IF (J .LE. -INBFR(JP)) GO TO 180
      JP=JP+1
      IF (INBFR(JP) .GT. 0) GO TO 170
  260 IF (IZSPC .LT. IZSP) THEN
C
C                            Beruecksichtige angelegte Zusatzpunkte.
        IZSPC=IZSPC+1
        DO  K=1,3
          X1(K)=ZSPKT(K,IZSPC,1)
          X2(K)=ZSPKT(K,IZSPC,2)
        ENDDO
        WCHTNG=1.
        GO TO 190
      ENDIF
C
      IF (I180GF .NE. 0) THEN
C                            Definiere Richtung.
        T3=0.
        DO  K=1,3
          X1(K)=X(K,7)
          T3=T3+X1(K)*X1(K)
        ENDDO
        T3=SQRT(T3)
        T2=CONST(1)
        GO TO 290
      ENDIF
C                            Ergaenze Rest der Matrix.
      X(2,1)=X(1,2)
      X(3,1)=X(1,3)
      X(3,2)=X(2,3)
C                            Invertiere Matrix.
C
      CALL MINV (X,3,DET,AIN(7),AIN(10))
C
C                            Berechne Loesung.
C
      IF (ABS(DET) .GT. 1.E-5) GO TO 280
CYENG1
      WRITE (WRLINE,'(A)') 'ZVIDL20390 - Matrix singulaer.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'ZVIDL20390 - Matrix singular.'
      CALL KPWRTE (NTDISP)
  270 I180GF=1
      DREHWK=180.
      DO  K=1,3
        X(K,7)=0.
      ENDDO
      GO TO 160
C
C                            Bestimme Drehachse.
  280 T1=0.
      DO  K=1,3
      TEMP=X(K,1)*X(1,4)+X(K,2)*X(2,4)+X(K,3)*X(3,4)
      T1=T1+TEMP*TEMP
      X1(K)=TEMP
      ENDDO
C
      T3=SQRT(T1)
      T2=2.*ATAN(T3)
      DREHWK=T2*CONST(4)
  290 CONTINUE
CYENG1
      WRITE (WRLINE,'(A,F7.2)') 'Drehwinkel=',DREHWK
CYENG2
CYENGY      WRITE (WRLINE,'(A,F7.2)') 'Angle:',DREHWK
      CALL KPWRTE (NTOUT)
C                            Der Drehwinkel und die Drehachse
C                            werden auch hinterlegt.
      CONST(59)=DREHWK
      IF (T2 .EQ. 0.) GO TO 300
C
C                            Bestimme Richtungscosinusse.
      DO  K=1,3
        RICOS(K)=X1(K)/T3
      ENDDO
CYENG1
      WRITE (WRLINE,'(A,3F10.5)') 'Richtungscosinusse:',RICOS
CYENG2
CYENGY      WRITE (WRLINE,'(A,3F10.5)') 'Direction cosini:',RICOS
      CALL KPWRTE (NTOUT)
      DO  K=1,3
        PTRIKL(K)=RG(1,K,NS)*RICOS(1)+
     +  RG(2,K,NS)*RICOS(2)+RG(3,K,NS)*RICOS(3)
        CONST(59+K)=PTRIKL(K)
      ENDDO
      NTYP=16
      CALL ZVGE01
C
C                            Wende Drehung an.  Baue Matrix auf.
      DO  L=1,3
        DO  M=2,4
          PSDSYM(L,M)=0.
        ENDDO
        PSDSYM(L,L+1)=1.
      ENDDO
C
      IF (DREHWK .NE. 0.) THEN
        T2=DREHWK*CONST(3)
        AIN(1)=COS(T2)
        AIN(2)=SIN(T2)
        AIN(3)=1.-AIN(1)
C
        DO  L=1,3
          M=ID2(L)
          N=ID2(M)
          AIN(4)=RICOS(L)*AIN(3)
          S(L,L)=RICOS(L)*AIN(4)+AIN(1)
          S(M,L)=RICOS(M)*AIN(4)-RICOS(N)*AIN(2)
          S(N,L)=RICOS(N)*AIN(4)+RICOS(M)*AIN(2)
        ENDDO
C
        DO  L=1,3
          DO  M=1,3
            PSDT(L,M)=RG(1,L,NS)*S(1,M)+
     +      RG(2,L,NS)*S(2,M)+RG(3,L,NS)*S(3,M)
          ENDDO
        ENDDO
        DO  L=1,3
          DO  M=1,3
            PSDSYM(L,M+1)=PSDT(L,1)*DG(1,M,NS)
     1      +PSDT(L,2)*DG(2,M,NS)+PSDT(L,3)*DG(3,M,NS)
          ENDDO
        ENDDO
      ENDIF
C
  300 DO  L=1,3
        PSDSYM(L,1)=SPK(L+3)-PSDSYM(L,2)*SPK(1)-PSDSYM(L,3)*SPK(2)-
     1  PSDSYM(L,4)*SPK(3)
      ENDDO
      WRITE (WRLINE,'(A)') ' Transformation:'
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,'(''      ('',F10.5,'' )   ('',3F10.5,'' )'')')
     1 (PSDSYM(1,M),M=1,4)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,'('' x'''' = ('',F10.5,'' ) + ('',3F10.5,'' ) * x''
     1)') (PSDSYM(2,M),M=1,4)
      CALL KPWRTE (NTOUT)
      WRITE (WRLINE,'(''      ('',F10.5,'' )   ('',3F10.5,'' )'')')
     1(PSDSYM(3,M),M=1,4)
      CALL KPWRTE (NTOUT)
C                            Hinterlege Ergebnis in KPTSY.
      K=16
      DO  I=1,3
        DO  J=1,4
          K=K+1
          AIN(K)=PSDSYM(I,J)
        ENDDO
      ENDDO
      NTYP=3
      CALL ZVTSY
C
  310 NTRY=2
      T1=0.
C                            Schleife ueber die Atome.
      I=I1-1
      JP=3
  320 J=INBFR(JP)
      JP=JP+1
  330 I=I+1
C
      DO  K=1,3
C                            "reales" Atom
        X(K,1)=AT(K,J,NS)
C                            "ideales" Atom
C
        X(K,2)=PSDSYM(K,2)*AT(1,I,NS)+PSDSYM(K,3)*AT(2,I,NS)
     1       +PSDSYM(K,4)*AT(3,I,NS)+PSDSYM(K,1)
      ENDDO
C                            Berechene kartesische Koordinaten
      NC=1
      CALL ZVDEK
      DO  K=1,3
        X2(K)=X1(K)
      ENDDO
      NC=2
      CALL ZVDEK
C                            Quadrate aufsummieren.
      TEMP=0.
      DO  K=1,3
        T2=X1(K)-X2(K)
        TEMP=TEMP+T2*T2
      ENDDO
      T1=T1+TEMP
      IF (ISKP(12) .NE. 0) THEN
C
C                            Ausschreiben.
        TEMP=SQRT(TEMP)
        WRITE (WRLINE,'(A)') ' '
        CALL KPWRTE (NTOUT)
        WRITE (WRLINE,'(I4,2X,2A4,3F10.6,F6.2)')
     +   J,(AT(K,J,NS),K=5,6),(AT(K,J,NS),K=1,4)
        CALL KPWRTE (NTOUT)
        WRITE (WRLINE,'(I4,2X,A,3F10.6,F6.2,A,F6.2)')
     +   I,'ideal   ',(X(K,2),K=1,3),AT(4,I,NS),'  D=',TEMP
        CALL KPWRTE (NTOUT)
      ENDIF
C                            Replace.
C
      IF (NTYPS .GT. 2) GO TO 350
      IF (ISKP(11)-1) 360,340,350
  340 IF (I180GF) 360,350,360
C
  350 DO  K=1,3
        AT(K,J,NS)=X(K,2)
      ENDDO
C                            Next I
C
  360 IF (INBFR(JP)) 370,380,320
C
  370 J=J+1
      IF (J .LE. -INBFR(JP)) GO TO 330
      JP=JP+1
      IF (INBFR(JP) .GT. 0) GO TO 320
  380 CONTINUE
C                            R.M.S. Ausgeben.
C
      T1=SQRT(T1/FLOAT(I2-I1+1))
CYENG1
      WRITE (WRLINE,'(A,F12.4)') 'R.M.S.-Wert:',T1
CYENG2
CYENGY      WRITE (WRLINE,'(A,F12.4)') 'R.M.S. value:',T1
      CALL KPWRTE (NTOUT)
      IF (NTYPS .EQ. 3) GO TO 999
      IF (DREHWK .GT. 0.1) GO TO 999
      IF (T1 .GT. 1.) GO TO 270
      GO TO 999
C                            IDG - Idealisiere gruppe
  390 AINBFR(4)=0.25
      INBFR(5)=1
      INBFR(6)=0
      CALL FLES (INBFR,ISKP(31),'3IF2IE','i1,i2,r1,d,opt,nz?$')
      NZ1=INBFR(2)-INBFR(1)
      NZ=NZ1+1
      IF (INBFR(6) .EQ. 0) INBFR(6)=NZ
      J2=INBFR(3)+NZ1
      IF (INBFR(1) .LE. 0 .OR. INBFR(2) .GT. NAT(NS) .OR.
     + INBFR(3) .LE. 0 .OR. J2 .GT. NAT(NS) .OR. NZ1 .LT. 2 .OR.
     + NAT(NS)+NZ1+3 .GT. NATDM .OR. NZ .GT. 47) THEN
        IERR=26 0503 16
        GO TO 999
      ENDIF
      NAT(NS)=NAT(NS)+2
      NATI=NATSV+1
      NATSV3=NATSV+3
      NATR=NAT(NS)
C                       Berechne gewichtete schwerpunkte als
C                       zwei neue atome.
      DO  I=1,3
        AT(I,NATI,NS)=0.
        AT(I,NATR,NS)=0.
      ENDDO
      GEWSUM=0.
      NTRY=2
      NC=1
      J=INBFR(3)
      DO  I=INBFR(1),INBFR(2)
        TEMP=AT(4,I,NS)
        DO  K=1,3
          AT(K,NATI,NS)=AT(K,NATI,NS)+AT(K,I,NS)*TEMP
          AT(K,NATR,NS)=AT(K,NATR,NS)+AT(K,J,NS)*TEMP
        ENDDO
        J=J+1
        GEWSUM=GEWSUM+TEMP
      ENDDO
      IF (GEWSUM .LE. 0.) THEN
        IERR=26 0530 16
        GO TO 999
      ENDIF
      DO  I=1,3
        AT(I,NATI,NS)=AT(I,NATI,NS)/GEWSUM
        AT(I,NATR,NS)=AT(I,NATR,NS)/GEWSUM
      ENDDO
C
C                       Suche bei der ideal-gruppe die beiden
C                       am weitesten innen liegenden atome, die
C                       zusammen mit dem schwerpunkt nicht auf
C                       einer geraden liegen.
C
      CALL MV (DG(1,1,NS),AT(1,NATI,NS),SPK1)
      CALL MV (DG(1,1,NS),AT(1,NATR,NS),SPK2)
      NIDLP=0
      DO  K=INBFR(1),INBFR(2)
        CALL MV (DG(1,1,NS),AT(1,K,NS),X1)
        TEMP=(X1(1)-SPK1(1))**2+(X1(2)-SPK1(2))**2+(X1(3)-SPK1(3))**2
        IF (TEMP .GT. 1.0) THEN
          J=NIDLP
          GO TO 410
  400     IF (TEMP .GT. DIDL(J)) GO TO 420
          IF (J .LT. 3) THEN
            DIDL(J+1)=DIDL(J)
            NIDL(J+1)=NIDL(J)
          ENDIF
          J=J-1
  410     IF (J .GT. 0) GO TO 400
  420     IF (J .LT. 3) THEN
            DIDL(J+1)=TEMP
            NIDL(J+1)=K
          ENDIF
          IF (NIDLP .LT. 3) NIDLP=NIDLP+1
        ENDIF
      ENDDO
      IF (NIDLP .LT. 3) THEN
        IERR=26 0567 16
        GO TO 999
      ENDIF
C                       Stelle fest, welche kombination einen
C                       winkel bildet, der moeglichst nahe an
C                       90 grad liegt.
      K=3
      TEMP=100.
      ICDS(2)=NATI
      DO  I=1,2
        ICDS(1)=NIDL(I)
        DO  J=I+1,3
          ICDS(3)=NIDL(J)
          NTYP=5
          ISKP(14)=1
          CALL ZVGE02
          IF (IERR .NE. 0) GO TO 999
          TEMP2=ABS(90.-CONST(6))
          IF (TEMP2 .LT. TEMP) THEN
            M=K
            TEMP=TEMP2
          ENDIF
          K=K-1
        ENDDO
      ENDDO
      J=ID2(M)
      K=ID2(J)
C                       IK1 und IK2 sind die ausgewaehlten atome.
      IK1=NIDL(J)
      IK2=NIDL(K)
C     PRINT *,'AUSGEWAEHLT:',IK1,IK2
C                       Nun werden bis zu sechs kandidaten der
C                       "realen" gruppe gesucht.
      NIDLP=0
      DO  K=INBFR(3),J2
        CALL MV (DG(1,1,NS),AT(1,K,NS),X1)
        TEMP=(X1(1)-SPK2(1))**2+(X1(2)-SPK2(2))**2+(X1(3)-SPK2(3))**2
        IF (TEMP .GT. 1.0) THEN
          J=NIDLP
          GO TO 440
  430     IF (TEMP .GT. DIDL(J)) GO TO 450
          IF (J .LT. 6) THEN
            DIDL(J+1)=DIDL(J)
            NIDL(J+1)=NIDL(J)
          ENDIF
          J=J-1
  440     IF (J .GT. 0) GO TO 430
  450     IF (J .LT. 6) THEN
            DIDL(J+1)=TEMP
            NIDL(J+1)=K
          ENDIF
          IF (NIDLP .LT. 6) NIDLP=NIDLP+1
        ENDIF
      ENDDO
C     PRINT *,'REALOS:'
C     PRINT *,(NIDL(I),I=1,NIDLP)
C                       Koordinatensystem in ideale gruppe
      DO  I=1,5
        ICDS(I)=NATI
      ENDDO
      ICDS(3)=IK1
      ICDS(5)=IK2
      ISKP(14)=1
      NTYP=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 999
      NTYP=4
      CALL ZVK
C
C                       Setze KTG's auf
      NLSG=0
      IAGRM=0
      DO  I=1,NIDLP
        DO  J=1,NIDLP
          IF (I .EQ. J) GO TO 480
          DO  K=1,5
            ICDS(K)=NATR
          ENDDO
          ICDS(3)=NIDL(I)
          ICDS(5)=NIDL(J)
          NTYP=1
          CALL ZVK
          IF (IERR .NE. 0) THEN
            IERR=0
            GO TO 480
          ENDIF
C                       Erzeuge neue gruppe
          NAT(NS)=NATSV+2
          IAIN(1)=INBFR(1)
          IAIN(2)=INBFR(2)
          IAIN(3)=KDA
          NTYP=10
          CALL ZVK
          IF (IERR .NE. 0) GO TO 999
C
C                       Teste, ob es zu jedem punkt genau eine
C                       entsprechung gibt.
C
          DH2=AINBFR(4)*AINBFR(4)
          DO  M=NATSV3,NAT(NS)
            ICLRP(M,NS)=0
          ENDDO
          DO  NPASS=1,8
            TEMP2=0.
            DO  K=INBFR(3),J2
              IUP=K-INBFR(3)+NATSV3
              IF (ICLRP(IUP,NS) .EQ. 0) THEN
                CALL MV (DG(1,1,NS),AT(1,K,NS),X1)
                TEMP3=100.
                MERK=0
                DO  M=NATSV3,NAT(NS)
                  CALL MV (DG(1,1,NS),AT(1,M,NS),X2)
                  TEMP=(X1(1)-X2(1))**2+(X1(2)-X2(2))**2+
     +            (X1(3)-X2(3))**2
                  IF (TEMP .LT. DH2) THEN
                    DO  N=NATSV3,NAT(NS)
                      IF (ICLRP(N,NS) .EQ. M) GO TO 460
                    ENDDO
C
C                      Verbesserung erzielt?
C
                    IF (TEMP .LT. TEMP3) THEN
                      MERK=M
                      TEMP3=TEMP
                    ENDIF
                  ENDIF
  460           CONTINUE
                ENDDO
                IF (MERK .NE. 0) THEN
                  ICLRP(IUP,NS)=MERK
                  TEMP2=TEMP2+TEMP3
                ENDIF
              ENDIF
            ENDDO
C           PRINT *,'PASS',NPASS
C           DO  K=NATSV3,NAT
C           PRINT *,'PLATZ',K,' ENTHAELT',ICLRP(K)
C           ENDDO
            N=0
            DO  K=NATSV3,NAT(NS)
              IF (ICLRP(K,NS) .NE. 0) THEN
                N=N+1
              ENDIF
            ENDDO
C                       Merke die maximalzahl an uebereinstimmung.
C
            IF (N .GT. IAGRM) IAGRM=N
            IF (N .GT. NZ1) GO TO 470
            IF (N .LT. INBFR(6)) GO TO 480
            DH2=DH2*2.
          ENDDO
          GO TO 480
C                       Erfolg! Wie soll darauf reagiert werden?
  470     NLSG=NLSG+1
          TEMP2=SQRT(TEMP2/FLOAT(NZ))
CYENG1
          WRITE (WRLINE,'(A,I3,F6.3)') 'Loesung',NLSG,TEMP2
CYENG2
CYENGY          WRITE (WRLINE,'(A,I3,F6.3)') 'Solution',NLSG,TEMP2
          CALL KPWRTE (NTOUT)
          IF (INBFR(5) .EQ. 0) GO TO 999
          IF (INBFR(5) .LT. 0) GO TO 480
          IF (NLSG .EQ. INBFR(5)) THEN
            INBFR(1)=INBFR(3)
            INBFR(2)=J2
            N=NATSV3
            DO  K=0,NZ1
              INBFR(K+3)=ICLRP(N,NS)
              ICLRP(N,NS)=0
              N=N+1
            ENDDO
            JP=NZ1+4
            IF (ISKP(11) .LT. 0) IOPTI=1
            NTYPS=2
            GO TO 70
          ENDIF
  480     CONTINUE
        ENDDO
      ENDDO
      IF (IAGRM .LT. NZ) THEN
        WRITE (WRLINE,'(A,I3,A,I3,A)')
CYENG1
     +  'Uebereinstimmung nur bei max.',IAGRM,' von',NZ,' Atomen.'
CYENG2
CYENGY     +  'Agreement at max.',IAGRM,' of',NZ,' atoms only.'
        CALL KPWRTE (NTDISP)
      ENDIF
C
  999 CONTINUE
      IF (IOPTI .GT. 0) THEN
        DO  I=1,3
          DO  J=1,3
            S(J,I)=PSDSYM(J,I+1)
          ENDDO
        ENDDO
        CALL MINV (S,3,DET,AIN(7),AIN(10))
        DO  I=NATSV3,NAT(NS)
          DO  J=1,3
            T(J)=AT(J,I,NS)-PSDSYM(J,1)
            AT(J+3,I-2,NS)=AT(J+3,I,NS)
          ENDDO
          CALL MV (S,T,AT(1,I-2,NS))
        ENDDO
        NATSV=NAT(NS)-2
      ENDIF
      NAT(NS)=NATSV
      RETURN
      END
