C                         -------------------
                           SUBROUTINE ZVMAIN
C                         -------------------
C  CY-ARI-ENG-
C               Version fuer Atari; begonnen: 19.6.1988
C               Stand: 261255 MAY 2017
C
C     Belegplan fuer ISKP
C     -------------------
C
C      1  Optionszahl fuer FM, FMA und FMZ
C      2  NOKD / OKD
C      3  Bit 0 = 1: Rahmen plotten
C      4  NTSO / TSO
C      5  NAO / AO
C      6  NPO / PO
C      7  NPLT / PLT
C      8  Zahl der Stuetzpunkte fuer PK
C      9  Zahl der Stuetzpunkte fuer VBR
C     10  Option fuer die Beschriftung der Atome
C     11  0:NRRI / 1:CRRI / 2:RRI
C     12  0:NOI / 1:OI
C     13  Option fuer Stereoplot: 0 Bilder nebeneinander, 1: ueberein.
C     14  <> 0  Keine Info von Karten holen
C     15  GLP / NGLP
C     16  Name des Referenzatoms bei SFND
C     17-18  unbenutzt
C     19  Wird bei Plotkommandos gebraucht
C     20  ASCII-Code, bei dem abgebrochen wird
C     21  Log. Nummer der Datei fuer Protokoll
C     22  Zahl der Codes, bei denen bei FM abgebrochen werden kann
C     23  Zahl der Atome, bei der bei FM abgebrochen wird
C     24  BLANK
C     25  =0 Ohne Beruecksichtigung von hidden lines
C     26  0: HP-Char.-Generator, 1: Plot-Char.-Gen.
C     27  =1: UDST-Option
C     28-30  In KPAVBR/KPADD  bei AUS gebraucht
C     31  - 40 Wird von FLES gebraucht
C     41  NPEN (Default)
C     42  NPEN aktuell
C     43  Option NZFQ / ZFQ
C     44  Option VEO
C     45  Stackpointer im Macro-Interpreter
C     46  1: Programm ist im Graphik-Mode
C     47  Default Fuellmuster
C     48  Optionen NPCK / PCK (Parameter-Check)
C     49  Strichstaerke
C     50  Option bei VEU: auch hintere Flaechen aufnehmen
C     51  Maximalzahl an Fehlerroutine Aufrufen
C     52  Symmetrieflag fuer KPLCFF
C     53  Defaultwert des logischen Anfangs in der Parameterliste
C     54  Pointer auf Mausliste
C     55  0 normaler, 1 .PCX file
C     56  0 schwarzer, 1 weisser Hintergrund
C     57  0: NIU  1: IU
C     58  MORE-Flag
C     59  Letzter Befehl war: 0: LS; 3: STPU; 4: EPU; 5 D.
C     60  <>0 ORTEP-Plot
C     61  Adresse des aktuellen ATF-Blocks
C     62  0 ST-Ergebnis nicht in Symmetrieliste speichern
C     63  Temperaturfaktoren als 'TL' Kommandos ausgeben (1)
C     64  Nummer der ersten Ebene bei GESP
C     65  Option fuer KPSFND
C     66  Kommentar 'Code-Ueberlauf' und 'Symmetrien O.K.' unterdruecken
C     67  1 oder 4 bei low- oder high-byte adressierenden Maschinen
C     68  KPEXMC soll befehl VDGR auf Puffer kopieren.
C     69  Maximalzahl der zu schreibenden Zeichen beim Beschriften
C         von Atomen
C     70  <> 0: GTY Z gesehen
C     71  LATT fuer SHELXL-Job
C     72  Anzahl der Symmetrien fuer SHELXL-Job
C     73  Stackpointer in KPK
C     74  Letzter Befehl war 0: DF  1: HF
C     75  <> 0: . als Filename nicht erlaubt
C     76  <> 0: Bei SFND: Fremdatome in der Suchbox erlaubt
C     77  ITCNT (Zahl der gef. Translationen in KPTSZR
C     78  >0 bei SFND Verbesserung erzielt; =0 unveraendert,
C         <0 Verschlechterung
C     79  Steuerung von SFND
C     80-82 reserviert fuer code-ausgabe
C     83  Wenn ungleich 0 wird bei mehrdeutigen Raumgruppen diese
C         Aufstellung gewaehlt (HMSO)
C     84  Steuerung von KPADD
C     85  Stackpointer in Macro-interpreter
C     86  MSAV 0/1
C     87  tols von SFND
C     88  Option IZA
C     89-92  Wird von KPGC04 gebraucht
C     93  Wird von KPGC02 gebraucht
C     94  CMPZ lief erfolgreich
C     95  SLAB-Flag. 1: Nur Symmetrien in slab suchen
C     96  0/1 Standardabweichung von ZERR mitfuehren
C     97-99 frei
C
C     Belegplan fuer CONST
C     --------------------
C     1) PI
C     2) 2*PI
C     3) PI/180 (BOG)
C     4) 180/PI (RAD)
C     5) Laenge
C     6) Winkel
C     7) Maxsh bei ID
C     8) Xdim des Zeichenfeldes
C     9) Ydim des Zeichenfeldes
C    10) Randbreite des Zeichenfeldes
C    11) x des Ursprungspunktes (Plotterkoordinaten)
C    12) y des Ursprungspunktes (Plotterkoordinaten)
C    13) Stereo-Winkel
C    14) Code des Ursprungs-Atoms
C    15) Schrifthoehe Default
C    16) -19) x,y,z kart. und dmax**2 bei Zusatz AUW
C    20) DMIN**2
C    21) Toleranz GLP / NGLP
C    22) NULL (Floating)
C    23) - 26) UDIST Abstand fuer die Abschattung
C    27) - 30)  Defaults fuer Kdos BA und BT
C    31) Distmax bei FM (Default Abstand)
C    32) XSIZE bei Max. Plotfeld
C    33) YSIZE
C    34) Default Bohrlochresttiefe
C    35) Toleranz fuer Ebenen in KPVLEK
C    36) Beschriftungstyp
C    37) frueher Zellvolumen, wird jetzt von ZVAVBR benutzt
C    38) GOPT (A oder R)
C    39) Kuerzester bei ATAB aufgetretener Abstand
C    40) Strichelungsparameter fuer Polyeder
C    41) Uebertreibungsfaktor fuer Bindungsstaebe
C    42) FACE-Faktor
C    43) Wahrscheinlichkeitsfaktor
C    44) Displacementfaktor
C    45) Toleranz bei Abstaenden in SFND
C    46) Toleranz bei Winkeln in SFND
C    47) Toleranz bei Ebenen in SFND
C    48) In KPSFND verwendet.
C    49) Toleranz in KPSMSY
C    50) Abstand der Augen
C    51) - 57) Inhalt der ZERR anweisung
C    58) Wellenlnge von der CELL anweisung
C    59) Drehwinkel bei ID, IDL etc.
C    60) - 62) Drehachse hierbei
C
C                          ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
      INTEGER *4 IOPT(8),KONST(100),IAIN(72),MBUF(3)
      INTEGER *4 I,J,K,KDNTSO,KDO,KDONUL,KDONUM,KDONUU,KDX,KEYIN,NTYKP
      INTEGER *4 IRGZ(7),IBUE
      CHARACTER *4 PROMPT
      REAL    *4 PLDEV(3)
      LOGICAL EXIST
      CHARACTER*1 CHAIN(288)
C
      INTEGER *4 KDOLEN
      PARAMETER (KDOLEN=1142)
      INTEGER *4 KDOLST(KDOLEN),KPSTP(3)
C
      EQUIVALENCE (CONST(1),KONST(1)),(CHAIN(1),AIN(1),IAIN(1))
C
      DATA IOPT/5,6,0,1, 0,0,1,80/,MBUF/1,1,1/,PROMPT/'0>$ '/
      DATA KPSTP/4HKPLO,4HT.ST,4HP   /,IBUE/4HE   /
      DATA PLDEV/4HSCRE,4HHPGL,4HPXLG/,KDNTSO/4HNTSO/,KDX/4HX   /
      DATA IRGZ/14601,14801,15501,16001,16101,16601,16701/
C
      DATA (KDOLST(I),I=1,101) /4H1   ,1905,4H2   ,1906,4H3   ,1907,
     1 4H4   ,1908,4H5   ,1909,4H6   ,1910,4H7   ,1911,4H8   ,1912,
     2 4H9   ,1913,4HAA  ,1013,4HAAN ,4126,4HACAF,8703,4HACAL,2507,
     3 4HACI ,301,4HACIM,304,4HACIZ,308,4HACT ,307,4HAE  ,4109,4HAF  ,
     4 2902,4HAFG ,5808,4HAFGC,5809,4HAFZ ,1223,4HAGC ,3002,4HAGCA,3010,
     5 4HAGCC,3014,4HAGCM,3005,4HAGCT,3017,4HAGLP,101,4HAI  ,2603,
     6 4HAIDZ,3505,4HAINI,4123,4HAKB ,402,4HAKRT,4125,4HAKS ,403,4HAL  ,
     7 1011,4HAMC ,2504,4HAO  ,102,4HAPBF,5702,4HAPK ,5701,4HAR  ,5902,
     8 4HARE ,5905,4HAS  ,1018,4HASW ,1021,4HAT  ,4102,4HATAB,3901,
     9 4HATB ,401,4HATED,4117,4HATF ,710,4HATG ,4103,4HATOM,4104,4HAU  /
      DATA (KDOLST(I),I=102,204) /404,4HAUF ,410,4HAUS ,407,4HAUW ,
     1 405,4HAUZ ,406,4HAW  ,1012,4HAZIN,6301,4HBA  ,1205,4HBAM ,2515,
     2 4HBF  ,2901,4HBSF ,192,4HBSN ,108,4HBST ,103,4HBT  ,1206,4HBTM ,
     3 2516,4HBUFN,104,4HBVLM,2520,4HC   ,2802,4HCA  ,4124,4HCC  ,105,
     4 4HCE  ,106,4HCFS ,8705,4HCLSE,181,4HCMPO,8602,4HCMPZ,8601,4HCNRM,
     5 8501,4HCNCL,4806,4HCPG ,907,4HCRRI,7902,4HCTGC,3015,4HCUTT,4805,
     6 4HCVDP,5803,4HCVNK,5114,4HCVNT,5113,4HCVRT,5506,4HD   ,3405,
     7 4HDCN ,305,4HDCS ,306,4HDELA,4114,4HDF  ,2907,4HDFMA,1915,4HDFTB,
     8 190,4HDG  ,906,4HDGC ,206,4HDGCC,3006,4HDGCV,207,4HDGV ,918,
     9 4HDISP,195,4HDK  ,1102,4HDKML,1115,4HDKOS,1118,4HDKSV,1113/
      DATA (KDOLST(I),I=205,307) /4HDKV ,921,4HDLG ,170,4HDP  ,905,
     1 4HDPV ,923,4HDRET,3407,4HDRMO,2701,4HDTG ,209,4HDZA ,1014,4HDZB ,
     2 1015,4HDZV ,8505,4HEAE ,109,4HEAR ,4405,4HECHO,110,4HEDS ,2803,
     3 4HEFTC,4002,4HEFTG,4004,4HEFTP,4001,4HEFTS,4003,4HEGCB,203,
     4 4HEGCP,3016,4HEHMS,6901,4HEL  ,5108,4HEMAC,1914,4HEML ,5102,
     5 4HEMP ,5103,4HEN  ,303,4HEND ,111,4HENP ,5115,4HEP  ,5101,4HEPAR,
     6 4122,4HEPK ,3603,4HEPL ,4114,4HEPU ,3404,4HES  ,4113,4HESC ,112,
     7 4HESP ,5109,4HEW  ,1007,4HEXP ,180,4HEXPU,179,4HF   ,113,4HFACE,
     8 5111,4HFACF,114,4HFDG ,2512,4HFDGC,6701,4HFGC ,3012,4HFK  ,1009,
     9 4HFL  ,608,4HFLGC,6703,4HFLM ,115,4HFLMB,116,4HFM  ,5402,4HFMA /
      DATA (KDOLST(I),I=308,409) /5401,4HFMDD,6805,4HFMDP,6803,4HFMDR,
     1 6804,4HFMMC,5406,4HFMOP,5408,4HFO  ,118,4HFRBN,4118,4HFRBS,4119,
     2 4HFRG ,2513,4HFRGC,6702,4HFZ  ,5405,4HG   ,7001,4HGASP,7702,
     3 4HGDTU,4601,4HGESP,5107,4HGET ,119,4HGETU,4604,4HGG  ,7002,
     4 4HGLP ,120,4HGNKO,5201,4HGNSX,3501,4HGNZL,5301,4HGOMX,603,4HGOPT,
     5 121,4HGP  ,3402,4HGPHU,4603,4HGPOL,1601,4HGREL,2519,4HGRTS,2801,
     6 4HGRZ ,5202,4HGSXF,191,4HGSXJ,3508,4HGT  ,4105,4HGTF ,5504,
     7 4HGTY ,801,4HGZTU,4602,4HH   ,122,4HHELP,185,4HHEND,123,4HHF  ,
     8 2906,4HHMS ,3101,4HHMSO,3104,4HHNH ,2406,4HHPGL,124,4HID  ,2601,
     9 4HIDA ,617,4HIDF ,8901,4HIDG ,2604,4HIDL ,2602,4HIGFA,197,4HIMAT/
      DATA (KDOLST(I),I=410,509) /1111,4HIMP ,117,4HINIT,7301,4HIOMX,
     1 5203,4HIPSY,4803,4HISST,616,4HITS ,6606,4HIU  ,186,4HIZA ,107,
     2 4HK   ,1101,4HKEE ,1109,4HKF  ,4110,4HKIG ,7900,4HKML ,1114,
     3 4HKOC ,1117,4HKS  ,1121,4HKTG ,1110,4HKUP ,1106,4HKUSP,920,
     4 4HL   ,1004,4HLAF ,605,4HLCFF,125,4HLCIF,8101,4HLEP ,5105,4HLGC ,
     5 3001,4HLGCC,3009,4HLNP ,702,4HLOG ,7801,4HLPK ,126,4HLS  ,127,
     6 4HLSWS,1803,4HLTF ,5502,4HLZ  ,1020,4HLZIN,7601,4HM   ,3004,
     7 4HMA  ,3005,4HMACC,1904,4HMACR,1901,4HMBUF,128,4HMDLS,5901,
     8 4HMDM ,1001,4HMDMR,1019,4HMFCE,5802,4HMILL,4902,4HMINO,4701,
     9 4HMLLE,4903,4HMNOV,3201,4HMORE,188,4HMPK ,3605,4HMSAV,199,4HMSIN/
      DATA (KDOLST(I),I=510,613) /3507,4HMTRI,408,4HMVOL,601,4HMVP ,
     1 914,4HMVPK,5804,4HN   ,4106,4HNAO ,129,4HNDLG,139,4HNGLP,130,
     2 4HNIU ,187,4HNKML,1116,4HNOI ,131,4HNOKD,132,4HNP  ,703,4HNPCK,
     3 133,4HNPEN,134,4HNPM ,708,4HNPN ,704,4HNPO ,136,4HNPR ,137,
     4 4HNPZ ,5805,4HNRCA,3506,4HNRRI,7901,4HNS  ,8401,4HNTSO,139,
     5 4HNZFQ,140,4HO   ,1401,4HOA  ,1303,4HOAS ,1312,4HOATF,711,4HOAWY,
     6 7701,4HOC  ,1304,4HOCG ,1306,4HOFCE,4905,4HOFMD,6801,4HOFN ,6401,
     7 4HOGC ,3003,4HOGCF,3011,4HOH  ,141,4HOI  ,142,4HOKD ,143,4HOMAC,
     8 1902,4HOMAT,1310,4HONRM,8502,4HOOPN,144,4HOOPT,1309,4HOOX ,8203,
     9 4HOP  ,903,4HOPEN,183,4HOPK ,3601,4HOPTR,1308,4HOR  ,5904,4HORIJ/
      DATA (KDOLST(I),I=614,715) /8207,4HORTF,2301,4HORTP,193,4HOS  ,
     1 1302,4HOSA ,1311,4HOSAR,7102,4HOSF ,145,4HOSKG,706,4HOSY ,2201,
     2 4HOT  ,1305,4HOTF ,5503,4HOTM ,2014,4HOUM ,8704,4HOVDD,614,
     3 4HOX  ,8202,4HOXL ,8204,4HOZ  ,1301,4HOZAB,1017,4HOZB ,2905,
     4 4HP   ,901,4HPAW ,1802,4HPCDS,5001,4HPCK ,146,4HPDA ,1801,4HPEEE,
     5 5104,4HPEZA,3301,4HPF  ,1221,4HPFD ,1222,4HPFMT,147,4HPFU ,1220,
     6 4HPGCE,5801,4HPGM ,1003,4HPK  ,1201,4HPKS ,1211,4HPL  ,904,
     7 4HPLDA,9002,4HPLDO,9001,4HPLT ,148,4HPM  ,205,4HPN  ,5002,4HPO  ,
     8 149,4HPP  ,909,4HPPFL,1210,4HPR  ,150,4HPREL,917,4HPROT,151,
     9 4HPSCD,5003,4HPSN ,5004,4HPST ,184,4HPT  ,902,4HPTTR,924,4HPUKC/
      DATA (KDOLST(I),I=716,813) /3723,4HPUT ,3720,4HPUTC,3721,4HPVA ,
     1 2501,4HPVE ,5106,4HPVOL,6706,4HPXCM,152,4HPXLE,153,4HPXLG,154,
     2 4HPZA ,1701,4HPZAA,1702,4HQA  ,3708,4HQAE ,3710,4HQBS ,3711,
     3 4HQC  ,3704,4HQDG ,2514,4HQFK ,3712,4HQK  ,3701,4HQMAC,1903,
     4 4HQORT,3703,4HQPK ,3702,4HQRW ,3707,4HQSF ,156,4HQSY ,3709,
     5 4HQT  ,3705,4HQTF ,3715,4HQUIT,157,4HQUP ,3714,4HQZ  ,3713,
     6 4HQZB ,3706,4HR   ,4107,4HRAN ,4127,4HRDRW,3406,4HRDZ ,6603,
     7 4HRFRB,4120,4HRG  ,3102,4HRGS ,7501,4HRIJ ,8206,4HRIJB,8210,
     8 4HRIJL,8208,4HRIJZ,8211,4HRK  ,1105,4HRPSY,4801,4HRRI ,7903,
     9 4HRS  ,4108,4HRSTR,159,4HRTHO,1002,4HRW  ,160,4HRZ  ,2005,4HS   /
      DATA (KDOLST(I),I=814,915) /4111,4HSAR ,7101,4HSCFF,196,4HSCI ,
     1 302,4HSDEL,6202,4HSE  ,4112,4HSEL ,6704,4HSF  ,161,4HSFND,6201,
     2 4HSFRB,4121,4HSGOG,7404,4HSH  ,162,4HSHKL,1501,4HSK  ,1104,
     3 4HSKE ,5112,4HSKG ,705,4HSLAB,135,4HSM  ,4201,4HSMSY,6501,4HSNS ,
     4 163,4HSNW ,164,4HSP  ,908,4HSPC ,919,4HSPG ,910,4HSPGC,3008,
     5 4HSPST,189,4HSPUG,7403,4HSQLS,4115,4HSQTM,4116,4HSRGS,3722,
     6 4HSRT ,2402,4HSRTC,2403,4HSRTF,2411,4HSRTL,2410,4HSRTN,2405,
     7 4HSRTP,2404,4HSRTT,2401,4HSSFD,6206,4HSSI ,609,4HSSR ,610,4HST  ,
     8 6101,4HSTA ,6102,4HSTP ,3401,4HSTPO,165,4HSTPU,3403,4HSTRD,166,
     9 4HSU  ,4802,4HSVE ,604,4HSVV ,4901,4HSW  ,167,4HSXAT,3504,4HSXL /
      DATA (KDOLST(I),I=916,1015) /5601,4HSY  ,2101,4HSYML,1502,4HSYS ,
     1 168,4HSYSW,7201,4HSZ  ,2008,4HSZA ,2011,4HSZAT,2010,4HSZXZ,2015,
     2 4HT   ,4101,4HTAPR,169,4HTF  ,5501,4HTFL ,198,4HTGL ,6708,4HTHEO,
     3 3502,4HTHPR,3503,4HTIM ,7402,4HTL  ,5507,4HTNRM,8503,4HTR  ,4404,
     4 4HTRSY,3103,4HTSO ,170,4HTSY ,4401,4HTSYI,4402,4HTSZ ,6601,
     5 4HTUG ,7401,4HTW  ,1010,4HTZ  ,2002,4HTZC ,2017,4HTZP ,2009,
     6 4HTZPC,2018,4HTZUP,2012,4HTZUR,2004,4HU   ,1307,4HUC  ,6302,
     7 4HUDST,171,4HUFFL,8707,4HUFR ,8701,4HUFRA,8702,4HUMPK,3606,
     8 4HUR  ,2904,4HUSR ,501,4HV   ,8100,4HVB  ,1202,4HVBR ,1204,
     9 4HVBS ,1203,4HVD  ,1215,4HVDG ,602,4HVDGC,5806,4HVDGD,613,4HVDGR/
      DATA (KDOLST(I),I=1016,1115) /5807,4HVDM ,1218,4HVDR ,1217,4HVDS ,
     1 1216,4HVDZ ,8508,4HVE  ,1214,4HVEH ,1212,4HVEO ,172,4HVER ,173,
     2 4HVEU ,1213,4HVF  ,174,4HVG  ,2518,4HVGC ,201,4HVGCT,204,4HVGDP,
     3 6705,4HVGV ,2517,4HVM  ,202,4HVMOD,175,4HVNRM,2508,4HVP  ,2503,
     4 4HVPV ,2502,4HVS  ,1207,4HVSFT,208,4HVSR ,1209,4HVSS ,1208,
     5 4HVSUM,8201,4HVZAB,1016,4HVZDP,8504,4HVZ  ,8506,4HVZG ,607,
     6 4HVZV ,8507,4HW   ,1005,4HWA  ,2505,4HWEE ,5110,4HWFKT,194,
     7 4HWK  ,1108,4HWPBF,176,4HWR  ,5903,4HWRE ,5906,4HWRGN,7405,
     8 4HWSU ,6709,4HWTAB,3902,4HWTB ,2510,4HWVE ,1008,4HWVP ,1006,
     9 4HX   ,155,4HXAT ,913,4HXC  ,177,4HXK  ,1107,4HXP  ,912,4HXZ  /
      DATA (KDOLST(I),I=1116,1142) /2007,4HXZF ,2908,4HY   ,182,4HZ   ,
     1 2001,4HZA  ,5005,4HZBAS,2020,4HZF  ,2903,4HZFND,3801,4HZFQ ,178,
     2 4HZG  ,911,4HZIDL,6203,4HZK  ,4501,4HZTAK,2006,4HZZ  ,4301/
C
CYARIY      OPEN (IOPT(1),FILE='CON:')
CYARIY      OPEN (IOPT(2),FILE='CON:')
      IOPT(1)=NTIN
      IOPT(2)=NTOUT
      NTDISP=NTOUT
      CALL UPLINF (PLDEV(1),1)
      WRITE (WRLINE,20)
CYENG1
   20 FORMAT ('KPLOT Version 9.6.23  07.06.2017 aktiv.')
CYENG2
CYENGY   20 FORMAT ('KPLOT version 9.6.23  (07.06.2017) active.')
      CALL KPWRTE (NTDISP)
      NTYP=-5
      CALL ZVEAEH
      IF (NTIN .NE. 5) THEN
        IOPT(1)=NTIN
        CALL FLES (I,IOPT,1HO,2H?$)
      ENDIF
      I=0
      GO TO 40
C                             ! RSTR
   30 I=0
      CALL FLES (I,ISKP(31),2HIE,5HOpt?$)
      IF (I .GT. 0) GO TO 40
      NTYP=-1           ! Schliesse alle offenen Einheiten
      CALL ZVEAEH
      NTIN=5
   40 IF (I .LT. 0) NS=0
      J=0
      IF (NS .NE. 0) GO TO 46
      J=1
   45 NS=NS+1
   46 CALL ZVPRIM
      NTYP=13
      CALL ZVPLDR(-5)
      CALL ZVEXPU
      CALL ZVZ
      NTYP=4
      CALL ZVSFND
      ISKP(14)=1
      CALL ZVTEAC (IAIN,IAIN,ISKP(14))
      NTYP=9
      CALL ZVGNSX
      NTYP=11
      CALL ZVGE04
      IF (J .EQ. 1) THEN
        IF (NS .EQ. 1) GO TO 45
        NS=1
      ENDIF
      IAIN(1)=ISKP(41)  ! Default Pen setzen
      CALL UPLINF (IAIN,10)
      ISKP(42)=ISKP(41) ! Update current pen
      INQUIRE (FILE='KPLOT.STP',EXIST=EXIST)
      IF (EXIST .AND. I .LE. 0) THEN
        DO  I=1,3
          IAIN(I)=KPSTP(I)
        ENDDO
        ISKP(14)=1
        NTYP=-6
        CALL ZVEAEH
        IOPT(1)=NTIN
      ENDIF
C
   50 NTIN=IOPT(1)
      NTDISP=IOPT(2)
      ISKP(21)=IOPT(3)
      NTYKP=-1
      CALL FLES (IOPT,IOPT,1HO,2H?$)
      GO TO 110
C
   60 IF (IERR) 100,70,90
   70 CALL FLES (IAIN,ISKP(31),1HE,2H?$)
C
   80 IF (IERR) 100,110,90
   90 CALL ZVERR
      IF (IERR) 100,100,1720
  100 IERR=0
      IF (NTYKP .GT. 0) GO TO 1230
      KARPOI=IOPT(8)
      ISKP(45)=0        ! Reset Stackpointer
      ISKP(85)=0        ! Reset Stackpointer
C
  110 CONTINUE
      I=100
      ISKP(14)=0
  120 CONTINUE
      IF (NTIN .NE. 5) THEN
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IOPT(1)=5
          KARPOI=IOPT(8)
          GO TO 50
        ENDIF
      ENDIF
      PROMPT(1:1)=CHAR(NS+48)
      CALL FLES (KDO,ISKP(31),2HAR,PROMPT)
      I=I-1
      IF (I .GT. 0) GO TO 140
      DO 135 I=1,20
        WRITE (WRLINE,130)
CYENG1
  130   FORMAT ('ZVMAIN2370 - Zu viele Leereingaben.')
CYENG2
CYENGY  130   FORMAT (' KPMAIN2370 - Too much blank lines.')
        CALL KPWRTE (NTDISP)
  135 CONTINUE
      GO TO 1720
  140 IF (ISKP(31) .LT. 0) THEN
C
C                            Eingabe signalisiert EOF. Close unit.
        NTYP=1
        IAIN(1)=NTIN
        GO TO 235
      ENDIF
      IF (ISKP(31) .EQ. 0) GO TO 120
C
      CALL CNVTUP (KDO,1,4)
      DO 150 I=1,KDOLEN,2
      IF (KDO .NE. KDOLST(I)) GO TO 150
      KDONUM=KDOLST(I+1)
      GO TO 170
  150 CONTINUE
C                            NOT FOUND
C
      CALL FLES (IAIN,IAIN,1HK,2H?$)
      WRITE (WRLINE,160) KDO
CYENG1
  160 FORMAT ('Kommando ''',A4,''' nicht vorgesehen.')
CYENG2
CYENGY  160 FORMAT (' No such command ''',A4,'''.')
      CALL KPWRTE (NTDISP)
      GO TO 100
C
  170 KDONUU=KDONUM/100
      KDONUL=KDONUM-100*KDONUU
      IF (KDONUU .GT. 1) GO TO 180
      NTYP=1
      GO TO (450,330,1200,1600,455,460,2060,184,200,1240,1720,1640,690,
C              1   2    3    4   5   6    7   8   9   10   11   12  13
     1 1630,1440,1420,187,740,190,420,1310,850,1380,1390,1210,470,
C        14   15   16  17  18  19  20   21  22   23   24   25  26
     2 720,1590,320,430,340,280,1490,970,2150,260,300,410,360,1270,1020,
C       27   28  29  30  31  32   33  34   35  36  37  38  39   40   41
     3 350,290,240,1350,1500,1610,490,270,310,500,760,1380,1390,1551,
C       42  43  44   45   46   47  48  49  50  51  52   53   54   55
     4 1340,1720,410,30,980,1360,990,1660,1650,1000,1510,1010,
C        56   57   X 59  60   61  62   63   64   65  66    67
     5 1550,1580,370,710,1330,1300,730,1520,1320,1620,1280,600,
C        68   69 70   71   72   73  74   75   76   77   78  79
     6 610,230,1230,220,60,1690,1680,1670,1730,1760,1780,2160,
C       80  81   82  83 84   85   86   87   88   89   90   91
     7 1800,1830,1840,1840,1205,1950,1870,1960),KDONUL
C        92   93   94   95   96   97   98   99
C
C                            Aufruf der Arbeitsprogramme
  180 NTYP=KDONUL
      GO TO (660,1560,540,550,1260,1570,620,560,650,660,570,580,
C               1   2   3   4    5    6   7   8   9  10  11  12
     1 520,800,1180,1290,890,900,1370,510,810,820,1040,700,
C       13  14   15   16  17  18   19  20  21  22   23  24
     2 670,830,630,1130,680,1190,1160,950,1170,840,1110,590,
C       25  26  27   28  29   30   31  32   33  34   35  36
     3 880,2140,640,790,530,1140,1150,1070,1090,910,960,1080,
C       37   38  39  40  41  42   43   44   45   46  47   48
     4 1060,940,920,1100,1120,780,1050,1480,1740,1750,1770,
C        49  50  51   52   53  54   55   56   57   58   59
     5   60,1810,1820,1860,185,1880,1890,1900,1910,1920,1930,
C       X60   61   62   63  64   65   66   67   68   69   70
     6 1940,1970,1980,2000,2010,2020,2030,2040,410,9999,2070,
C        71   72   73   74   75   76   77   78  79   80   81
     7 2080,9999,2100,2110,2120,2130,2150,2170,2180,2190),KDONUU
C        82    X   84   85   86   87   88   89   90   91
C =============================================================
C
C                         BSN - Beschriftungsnummer
CYENG1
  184 CALL FLES (ISKP(69),ISKP(31),2HIE,9HAnzahl? $)
CYENG2
CYENGY  184 CALL FLES (ISKP(69),ISKP(31),2HIE,6HNo.? $)
      IF (ISKP(69) .GT. 4) ISKP(69)=4
      IF (ISKP(69) .LT. 1) ISKP(69)=1
      GO TO 80
C                         OFN - Zeige filenamen
  185 NTYP=-4
      GO TO 250
C                         IMP - Importiere
  187 NTYP=-6
      GO TO 210
C                         GET und EAE
  190 NTYP=-3
      GO TO 210
C
  200 NTYP=0
  210 CALL ZVEAEH
      IOPT(1)=NTIN
      IOPT(2)=NTDISP
      GO TO 50
C                            OPEN
  220 NTYP=0
C                            CLSE
  230 IAIN(1)=NTIN
CYENG1
      CALL FLES (IAIN,ISKP(31),2HIR,9HUnit-Nr?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),2HIR,9HUnit-No?$)
  235 IF ((IAIN(1) .EQ. 5) .OR. (IAIN(1) .EQ. 6)) GO TO 80
      NTYP=IAIN(1)+100*NTYP
      CALL ZVEAEH
      IF (IERR .NE. 0) GO TO 80
      IF (IAIN(1) .NE. 0) THEN
        IOPT(1)=IAIN(1)
        NTIN=IAIN(1)
        CALL FLES (IOPT,IOPT,1HO,2H?$)
      ENDIF
      GO TO 80
C
  240 NTYP=-2        ! OOPN
  250 CALL ZVEAEH
      GO TO 80
C
  260 NTYP=0         ! NPO
  270 ISKP(6)=NTYP   ! PO
      GO TO 60
C
  280 NTYP=0         ! NOKD
  290 ISKP(2)=NTYP   ! OKD
      IOPT(5)=NTYP
      CALL FLES (IOPT,IOPT,1HO,2H?$)
      GO TO 60
C
  300 NTYP=0         ! NPR
  310 IAIN(1)=NTYP   ! PR
      CALL FLES (IAIN,ISKP(31),2HIE,5HOpt?$)
      ISKP(3)=IAIN(1)
      GO TO 80
C
  320 NTYP=0         ! NAO
  330 ISKP(5)=NTYP   ! AO
      GO TO 60
C
  340 NTYP=0         ! NOI
  350 ISKP(12)=NTYP  ! OI
      GO TO 60
C
  360 NTYP=0         ! NTSO
      IF (KDO .EQ. KDNTSO) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'Vorsicht! Keine KPLOT 9 Datei!'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'Caution! No KPLOT 9 file!'
        CALL KPWRTE (NTDISP)
      ENDIF
  370 IOPT(4)=NTYP   ! TSO
  380 ISKP(4)=IOPT(4)
      CALL FLES (IAIN,ISKP(31),1HE,2H?$)
      GO TO 50
C                            KIG NRRI CRRI RRI
  410 ISKP(11)=NTYP-1
      GO TO 60
C
  420 NTYP=0         ! GLP
  430 ISKP(15)=NTYP  ! NGLP
  440 CALL FLES (KONST(21),ISKP(31),2HFE,5HTol?$)
      GO TO 80
  450 ISKP(15)=-1    ! AGLP
      GO TO 60
C                    ! CE UND CC
  455 I=0
      GO TO 465
  460 I=NCD(NS)
CYENG1
      CALL FLES (I,ISKP(31),2HIE,6HAnz.?$)
CYENG2
CYENGY      CALL FLES (I,ISKP(31),2HIE,5HNo.?$)
      IF (I .LT. 0) I=0
      IF (I .GT. NCDDM) I=NCDDM
  465 NCD(NS)=I
      K8(I)=0
      K9(I)=0
      IF (KDONUL .EQ. 6) GO TO 80
      GO TO 60
C
  470 IPKP(NS)=0            ! LPK
      GO TO 60
C                             PLT
  490 CALL FLES (ISKP(7),ISKP(31),2HIE,6HOpt.?$)
      GO TO 80
C
CYENG1
  500 CALL FLES (IOPT(3),ISKP(31),2HIE,5HNr.?$) ! PROT
CYENG2
CYENGY  500 CALL FLES (IOPT(3),ISKP(31),2HIE,5HNo.?$) ! PROT
      IF (IOPT(3) .EQ. 0) GO TO 50
      NTYP=IOPT(3)
      CALL ZVEAEH
      GO TO 50
C
C               Z TZ KS TZUR RZ ZTAK XZ SZ SZA SZAT TZP TZUP ZBAS
  510 CALL ZVZ
      GO TO 80
C                         Oxx - Output Info
C                 OZ OS OA OC OT OCG U OPTR OOPT OMAT
  520 CALL ZVO
      GO TO 80
C                            Fundamental Input
C                T AT ATG ATOM GT N R RS AE KF S SE ES EPL SQLS
C                SQTM ATED FRBN FRBS RFRB SFRB EPAR AINI CA AAN RAN
  530 CALL ZVFNIN
      IF (NTYP .EQ. 23) THEN
        DO  I=1,3
          MBUF(I)=IAIN(I+1)
        ENDDO
        GO TO 1601
      ENDIF
      GO TO 80
C                     ACI SCI EN ACIM DCN DCS ACT
  540 CALL ZVASCI
      GO TO 80
C                      ATB AKB AKS AU AUW AUZ AUS MTRI
  550 CALL ZVAVBR
      GO TO 80
C                                 GTY
  560 CALL ZVGTY
      GO TO 80
C              K DK SK RK KUP XK WK KEE KTG IMAT DKSV KML
  570 CALL ZVK
      GO TO 80
C                 PK VB VBS VBR BA BT VS VSS VSR PPFL
C             PKS VEH VEU VE VD VDS VDR VDM PFU PF PFD AZF
  580 CALL ZVLPK
      GO TO 80
C                         OPK APK EPK MPK UMPK
  590 CALL ZVPKED
      GO TO 80
C                            EXP EXPU
  600 ISKP(25)=1
      GO TO 620
  610 ISKP(25)=0
C                LNP NP NPN SKG OSKG NPM ATF OATF QATF
  620 CALL ZVEXPU
      IF (KDONUL.EQ.79 .OR. KDONUL.EQ.80) CALL UPLINF(AIN,0)
      IF (NTYP-1) 80,60,80
C                                DRMO
  630 CALL ZVDRMO
      GO TO 80
C                              ATAB WTAB
  640 CALL ZVAWTB
      GO TO 80
C                   P PT OP PL DP DG TG SP PP SPG ZG
C                   XP XAT MVP PREL DGV SPC KUSP DKV
  650 CALL ZVGE01
      GO TO 80
C
C   MDM RTHO PGM L W WVP EW WVE FK TW AL AW AA DZA DZB VZAB OZAB AS MDMR
C
  660 CALL ZVGE02
      GO TO 80
C                PVA VPV VP AMC WA ACAL VNRM WTB
C                   FDG FRG BAM BTM VGV VG GREL
  670 CALL ZVGE03
      GO TO 80
C                      BF AF ZF UR OZB HF DF XZF
  680 CALL ZVFKTR
      GO TO 80
C                            F
CYENG1
  690 CALL FLES (IAIN,ISKP(31),2HFE,8HFaktor?$)
CYENG2
CYENGY  690 CALL FLES (IAIN,ISKP(31),2HFE,8HFactor?$)
      IF (AIN(1) .LE. 0.) THEN
        IERR=1069021
      ELSE
        O9=AIN(1)
        SCL=CONST(43)*O9
      ENDIF
      GO TO 80
C            SRTT SRT SRTC SRTP SRTN HNH UL UA US SRTL SRTF
  700 CALL ZVSRT
      GO TO 80
C                             UDST
  710 KONST(25)=0
CYENG1
      CALL FLES (KONST(23),ISKP(31),4H2FIE,11Hu0,u1,typ?$)
CYENG2
CYENGY      CALL FLES (KONST(23),ISKP(31),4H2FIE,12Hu0,u1,type?$)
      ISKP(27)=KONST(25)
      GO TO 80
C                             LS
  720 CALL UPLINF (AIN,6)
      ISKP(59)=0
      GO TO 60
C                            VF
  730 NTYP=5
      IF (ISKP(13) .EQ. 0) THEN
        AIN(1)=CONST(8)
        AIN(2)=0.
      ELSE
        AIN(1)=0.
        AIN(2)=CONST(9)
      ENDIF
      GO TO 745
C                            FO
  740 NTYP=4
      AIN(1)=0.
      AIN(2)=0.
  745 CALL FLES (IAIN,ISKP(31),3H2FE,5Hx,y?$)
  750 CALL UPLINF (AIN,NTYP)
      GO TO 80
C                            PXCM
  760 NTYP=14
      CALL FLES (IAIN,ISKP(31),3H4FE,25Hpx(x),cm(x),px(y),cm(y)?$)
      GO TO 750
C                  FMA FM FMDP FMDR FZ FMMC OFMD FMOP
  780 CALL ZVGOML
      GO TO 80
C
C                         EFTP EFTC EFTS EFTG
  790 CALL ZVEFIT
      GO TO 80
C                                  O
  800 CALL ZVORTN
      GO TO 60
C                                 SY
  810 CALL ZVSYDC
      GO TO 80
C                                 OSY
  820 CALL ZVSYOU
      GO TO 80
C                              ID IDL AI
  830 CALL ZVIDL2
      GO TO 80
C                          STP GP STPU EPU D RDRW
  840 CALL ZVMACR
      GO TO 80
C                            H
  850 AIN(1)=HOE
      AIN(2)=CONST(50)
      IAIN(3)=6
CYENG1
      CALL FLES (AIN,ISKP(31),4H2FIE,15HHoehe,d,nzykl?$)
CYENG2
CYENGY      CALL FLES (AIN,ISKP(31),4H2FIE,15HHight,d,ncycl?$)
      IF (AIN(2) .GT. 0.) CONST(50)=AIN(2)
      IF (AIN(1) .LT. 0.) THEN
        IF (O9 .LE. 0) GO TO 80
        DO  I=1,IAIN(3)
          HOE=-AIN(1)/O9
          NTYP=1
          K9(NS)=0
          CALL ZVFKTR
        ENDDO
C                            Berechne Stereowinkel neu
C
        CONST(13)=2.*CONST(4)*ATAN(CONST(50)/(2.*HOE*O9))
      ELSE
        HOE=AIN(1)
      ENDIF
      K9(1)=0
      K9(2)=0
      CALL UPLINF (HOE,33)
      GO TO 80
C
C       QK QPK Q QC QT QZB QRW QA QSY QAE QBS QFK QZ QUP QTF PUT PUTC
  880 CALL ZVBILF
      GO TO 80
C                               PZA PZAA
  890 CALL ZVP2A
      GO TO 80
C                             PDA PAW LSWS
  900 CALL ZVP3A
      GO TO 80
C                         GDTU GZTU GPHU GETU
  910 CALL ZVGUMN
      GO TO 80
C           EP EML EMP PEEE LEP PVE GESP EL ESP WEE FACE SKE
  920 CALL ZVEHND
      GO TO 80
C                           PCDS PN PSCD PSN ZA
  940 CALL ZVPNCD
      GO TO 80
C                                 MNOV
  950 CALL ZVMNOV
      GO TO 80
C                                 MINO
  960 CALL ZVMINO
      GO TO 80
C                                 NPEN
CYENG1
  970 CALL FLES (ISKP(41),ISKP(31),2HIE,9HPen-Nr.?$)
CYENG2
CYENGY  970 CALL FLES (ISKP(41),ISKP(31),2HIE,9HPen-No.?$)
      IAIN(1)=ISKP(41)
      CALL UPLINF (AIN,10)
      ISKP(42)=ISKP(41)
      GO TO 80
C                                 RW
  980 I=NTSCR
CYENG1
      CALL FLES (I,ISKP(31),2HIE,9HEinheit?$)
CYENG2
CYENGY      CALL FLES (I,ISKP(31),2HIE,10HUnit-No.?$)
      REWIND I
      GO TO 80
C                                 SH
CYENG1
  990 CALL FLES (KONST(15),ISKP(31),2HFE,11HSchrifth.?$)
CYENG2
CYENGY  990 CALL FLES (KONST(15),ISKP(31),2HFE,15HSize of chars?$)
      GO TO 80
C                                STPO
 1000 CALL FLES (ISKP(13),ISKP(31),2HIE,5HOpt?$)
      GO TO 80
C                                 SW
CYENG1
 1010 CALL FLES (KONST(13),ISKP(31),2HFE,8HWinkel?$)
CYENG2
CYENGY 1010 CALL FLES (KONST(13),ISKP(31),2HFE,7HAngle?$)
      GO TO 80
C                                 OH
 1020 AIN(1)=HOE*O9
      WRITE (WRLINE,1030) HOE,AIN(1)
CYENG1
 1030 FORMAT ('Betrachterabstand:',F10.1,' (',F10.1,')')
CYENG2
CYENGY 1030 FORMAT (' Viewing distance:',F10.1,' (',F10.1,')')
      CALL KPWRTE (NTOUT)
      GO TO 60
C                                ORTF
 1040 CALL ZVORT2
      GO TO 80
C                             TF LTF OTF GTF
 1050 CALL ZVTFHN
      GO TO 80
C                             SVV MILL MLLE CNML
 1060 CALL ZVSPVV
      GO TO 80
C                              TSY TSYI TR EAR
 1070 CALL ZVTSY
      GO TO 80
C                             RPSY SU IPSY CUTT
 1080 CALL ZVRPSY
      GO TO 80
C                                   ZK
 1090 CALL ZVZK
      GO TO 80
C                             GNKO GRZ IOMX
 1100 CALL ZVGNKO
      GO TO 80
C                        GNSX THEO THPR SXAT AIDZ
 1110 CALL ZVGNSX
      GO TO 80
C                                 GNZL
 1120 CALL ZVGNZL
      GO TO 80
C                                 GRTS C
 1130 CALL ZVGRTS
      GO TO 80
C                                  SM
 1140 CALL ZVSPG
      GO TO 80
C                                ZZ ZM
 1150 CALL ZVZNTR
      GO TO 80
C                                HMS RG TS
 1160 CALL ZVHMS
      GO TO 80
C                                 PEZA
 1170 CALL ZVPEZA
      GO TO 80
C                                 SHKL
 1180 CALL ZVSHKL
      GO TO 80
C           LGC AGC OGC M AGCM DGCC SPGC LGCC AGCA OGCF FGC
 1190 CALL ZVGC01 (I)
      GO TO 80
C                                 BST
CYENG1
 1200 CALL FLES (KONST(36),ISKP(31),2HIE,5HTyp?$)
CYENG2
CYENGY 1200 CALL FLES (KONST(36),ISKP(31),2HIE,6HType?$)
      GO TO 80
C                                SCFF LCFF
 1205 NTYP=2
      GO TO 1230
C
 1210 NTYKP=0
      IAIN(1)=0
      CALL FLES (IAIN,ISKP(31),2HIE,5HOpt?$)
      IF (IAIN(1)) 80,1220,80
 1220 I=ISKP(45)
      CALL ZVPRIM
      ISKP(45)=I
      I=NTYP
      NTYP=9
      CALL ZVGNSX
      NTYP=I
      ISKP(52)=0
      NAT(NS)=2
 1230 CALL ZVLCFF (NTYKP)
      GO TO 80
C                                ECHO
 1240 CALL FLES (IAIN,ISKP(31),4H18AE,6HText?$)
      J=ISKP(31)
      WRITE (WRLINE,1250) (AIN(I),I=1,J)
 1250 FORMAT (18A4)
      CALL KPWRTE (NTDISP)
      GO TO 80
C                                 USR
 1260 CALL ZVUSR
      GO TO 80
C                              ZFQ / NZFQ
 1270 NTYP=0
 1280 ISKP(43)=NTYP
      GO TO 60
C                                GPOL
 1290 CALL ZVPYER
      GO TO 80
C                                 VER
 1300 WRITE (WRLINE,20)
      CALL KPWRTE (NTOUT)
      GO TO 60
C                                GOPT
CYENG1
 1310 CALL FLES (KONST(38),ISKP(31),2HAE,10HA oder R?$)
CYENG2
CYENGY 1310 CALL FLES (KONST(38),ISKP(31),2HAE,8HA or R?$)
      GO TO 80
C                                WPBF
 1320 IAIN(1)=ISKP(55)
      CALL FLES (IAIN,ISKP(31),2HIE,18H0/1 (Normal/PCX)?$)
      CALL UPLINF (AIN,20)
      GO TO 80
C                                VEO
 1330 IAIN(1)=ISKP(44)
      AIN(2)=CONST(35)
      AIN(3)=CONST(40)
      IAIN(4)=ISKP(50)
      CALL FLES (IAIN,ISKP(31),5HI2FIE,25HOpt,tol,st-code,veu-opt?$)
      ISKP(44)=IAIN(1)
      CONST(35)=AIN(2)
      CONST(40)=AIN(3)
      ISKP(50)=IAIN(4)
      GO TO 80
C                             QSF OSF SF
 1340 NTYP=NTYP-1
 1350 NTYP=NTYP-1
 1360 NTYP=NTYP-2
      CALL ZVPLDR (NTYP)
      IF (NTYP) 80,80,60
C                      MACR OMAC QMAC MACC 1 2 3 4
 1370 CALL ZVEXMC
      GO TO 80
C                            HEND oder PXLE
 1380 NTYP=-1
      GO TO 1400
C                            HPGL oder PXLG
 1390 NTYP=20
      CALL ZVEAEH
      NTYP=1
 1400 I=2
      IF (KDONUL .EQ. 54) I=3
      IF (KDONUL .EQ. 53) I=3
      CALL UPLINF (PLDEV(I),NTYP)
      AIN(1)=4.
      IAIN(2)=1
      IF (ISKP(55) .NE. 0) IAIN(2)=2
      CALL UPLINF (AIN,19)
      IF (NTYP) 1410,80,80
 1410 NTYP=120
      CALL ZVEAEH
      GO TO 60
C                         FLMB - Fuellmuster (BYTE)
C
 1420 CALL FLES (IAIN(3),ISKP(31),3H8ZE,11HB1,...,B8?$)
      IAIN(1)=1
      IAIN(2)=8
      DO  I=12,40,4
        J=I+ISKP(67)-4
        CHAIN(I-2)=CHAIN(J)
        CHAIN(I-1)=CHAIN(J)
        CHAIN(I  )=CHAIN(J)
      ENDDO
      GO TO 1450
C                         FLM - Fuellmuster
C
 1440 CALL FLES (IAIN,ISKP(31),6H2I70ZE,15Hnw,nz,pattern?$)
      IF (IAIN(1)*IAIN(2) .NE. ISKP(32)) GO TO 1460
 1450 CALL UPLINF (AIN,15)
      IF (IAIN(1) .EQ. 0) GO TO 80
 1460 IERR=1313016
      GO TO 80
C                                 SXL
 1480 CALL ZVSXL
      GO TO 80
C                               PCK NPCK
 1490 NTYP=NTYP-1
 1500 ISKP(48)=NTYP
      GO TO 60
C                         STRD - Strichdicke
CYENG1
 1510 CALL FLES (ISKP(49),ISKP(31),2HIE,13HStrichdicke?$)
CYENG2
CYENGY 1510 CALL FLES (ISKP(49),ISKP(31),2HIE,10HThicknes?$)
      IAIN(1)=ISKP(49)
      GO TO 750
C                         VMOD - Videomodus
 1520 CONTINUE
CYENG1
      CALL FLES (IAIN,ISKP(31),2HIE,5HNr.?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),2HIE,5HNo.?$)
      IF (ISKP(31) .GT. 0) GO TO 1540
      WRITE (WRLINE,1530)
 1530 FORMAT ( '0=Default; 1=EGA 640 x 350; 2=SVGA 800 x 600; 3=SVGA 102
     14 x 768')
      CALL KPWRTE (NTDISP)
      GO TO 1520
C
 1540 CALL UPLINF (AIN,28)
      AIN(1)=5.
      IAIN(2)=ISKP(56)
      CALL UPLINF (AIN,19)
      GO TO 80
C                         SYS - Syscall
 1550 NTYP=29
      CALL FLES (IAIN,ISKP(31),4H20AE,9HDOS-Cmd?$)
      GO TO 750
C
 1551 NTYP=29
      CALL FLES (IAIN(2),ISKP(31),4H19AE,8HDatei? $)
      IAIN(1)=KDX
      GO TO 750
C                    VGC VGCM EGCB VGCT PM DGC DGCV VSFT
 1560 CALL ZVGC02
      IF (NTYP .EQ. 2) GO TO 60
      IF (NTYP .EQ. 3) GO TO 60
      IF (NTYP .EQ. 5) GO TO 60
      GO TO 80
C        MVOL VDG GOMX SVE VZG FL SSI ISSI VDGD OVDD QVDD ISST IDA
 1570 CALL ZVGE04
      GO TO 80
C                         TAPR
C
CYENG1
 1580 CALL FLES (KONST(41),ISKP(31),2HFE,8HFaktor?$)
CYENG2
CYENGY 1580 CALL FLES (KONST(41),ISKP(31),2HFE,8HFactor?$)
      GO TO 80
C                         MBUF
C
CYENG1
 1590 CALL FLES (MBUF,ISKP(31),2HIE,19HAnzahl der Puffer?$)
CYENG2
CYENGY 1590 CALL FLES (MBUF,ISKP(31),2HIE,19HNumber of buffers?$)
      CALL UPLINF(MBUF,30)
      MBUF(2)=1
      MBUF(3)=1
      WRITE (WRLINE,1595) MBUF(1)
      CALL KPWRTE (NTDISP)
CYENG1
 1595 FORMAT (I3,' Puffer verfuegbar.')
CYENG2
CYENGY 1595 FORMAT (' ',I3,' buffer available.')
      GO TO 80
C                         BUFN
C
 1600 IAIN(2)=0
      IAIN(3)=0
CYENG1
      CALL FLES (IAIN(2),ISKP(31),3H2IE,26HNr.-vis, Nr.-akt Puffer? $)
CYENG2
CYENGY      CALL FLES (IAIN(2),ISKP(31),3H2IE,26HNo.-vis, Nr.-act buffer? $)
 1601 IF (KEYIN(0) .EQ. ISKP(20)) THEN
        IERR=-1
        GO TO 80
      ENDIF
      DO 1605 I=2,3
        IF (IAIN(I) .EQ. 0) THEN
          MBUF(I)=MBUF(I)+1
          IF (MBUF(I) .GT. MBUF(1)) MBUF(I)=1
        ELSE IF (IAIN(I) .LT. 0) THEN
          MBUF(I)=MBUF(I)-1
          IF (MBUF(I) .LE. 0) MBUF(I)=MBUF(1)
        ELSE
          MBUF(I)=IAIN(I)
          IF (MBUF(I) .GT. MBUF(1)) MBUF(I)=MBUF(1)
        ENDIF
 1605 CONTINUE
      CALL UPLINF (MBUF(2),31)
      GO TO 80
C                         PFMT
C
CYENG1
 1610 CALL FLES (IAIN,ISKP(31),2HIE,25H0: Quer-, 1: Hochformat?$)
CYENG2
CYENGY 1610 CALL FLES (IAIN,ISKP(31),2HIE,30H0: Landscape, 1: vertical f.?$)
      CALL UPLINF (AIN,16)
      GO TO 80
C                         XC
C
 1620 CALL FLES (IAIN,ISKP(31),3H2IE,7Hc1,c2?$)
      IF (ISKP(41) .EQ. IAIN(1)) ISKP(41)=IAIN(2)
      NTYP=14
      CALL ZVEXPU
      NTYP=19
      CALL ZVLPK
      NTYP=-4
      CALL ZVPLDR (NTYP)
      GO TO 80
C                         FACF
C
 1630 CALL FLES (KONST(42),ISKP(31),2HFE,3Hf?$)
      GO TO 80
C                         ESC
C
CYENG1
 1640 CALL FLES (IAIN,ISKP(31),2HIE,5HAnz?$)
CYENG2
CYENGY 1640 CALL FLES (IAIN,ISKP(31),2HIE,5HNo.?$)
      I=KEYIN(IAIN)
      GO TO 80
C                         SNS / SNW
 1650 NTYP=NTYP-1
 1660 IAIN(2)=NTYP
      ISKP(56)=NTYP
      AIN(1)=5.
      CALL UPLINF (AIN,19)
      GO TO 60
C
 1670 NTYP=0
 1680 ISKP(57)=NTYP
      IF (NTYP .NE. 0) THEN
        NTYP=7
        CALL ZVO
      ENDIF
      GO TO 60
C                            HELP
 1690 DO 1710 I=1,KDOLEN,30
      K=MIN0(I+28,KDOLEN)
      WRITE (WRLINE,1700) (KDOLST(J),J=I,K,2)
      CALL KPWRTE (NTDISP)
 1700 FORMAT (15(' ',A4))
      IF (KEYIN(0) .EQ. ISKP(20)) GO TO 60
 1710 CONTINUE
      GO TO 60
C                            MORE
C
CYENG1
 1730 CALL FLES (ISKP(58),ISKP(31),2HIE,11HMORE-Zahl?$)
CYENG2
CYENGY 1730 CALL FLES (ISKP(58),ISKP(31),2HIE,13HMORE-Number?$)
      GO TO 80
C                            APK
 1740 CALL ZVAPK
      GO TO 80
C                            PGCE MFCE CVDP MVPK VDGC NPZ
 1750 CALL ZVGC03
      GO TO 80
C                            SPST
C
CYENG1
 1760 CALL FLES (ISKP(53),ISKP(31),2HIE,4HNr?$)
CYENG2
CYENGY 1760 CALL FLES (ISKP(53),ISKP(31),2HIE,4HNo?$)
      GO TO 80
C                            MDLS MDST DDF ODDF
 1770 CALL ZVMDLS
      GO TO 80
C                            DFTB
 1780 AIN(1)=6.
CYENG1
      CALL FLES (IAIN(2),ISKP(31),4H16IE,11H16 Zahlen?$)
CYENG2
CYENGY      CALL FLES (IAIN(2),ISKP(31),4H16IE,12H16 numbers?$)
      IF (ISKP(31) .NE. 16) AIN(1)=7.
      CALL UPLINF (AIN,19)
      GO TO 80
C                            BSF - Beschriftungsflag
CYENG1
 1800 CALL FLES (ISKP(10),ISKP(31),2HIE,4HNr?$)
CYENG2
CYENGY 1800 CALL FLES (ISKP(10),ISKP(31),2HIE,4HNo?$)
      GO TO 80
C                            ST - Symmetrie durch Typ
 1810 CALL ZVST
      GO TO 80
C                            SFND - Symmetrie finden
C
 1820 IF (NTYP .EQ. 6) THEN
        NTYP=1
      ELSE
        ISKP(79)=7
      ENDIF
      IF (NTYP .EQ. 3) THEN
        CALL ZVZIDL
      ELSE
        CALL ZVSFND
      ENDIF
      GO TO 80
C                            ORTP - Ortep ein/ausschalten
C
 1830 I=ISKP(60)
      CALL FLES (ISKP(60),ISKP(31),2HIE,9H1=ORTEP?$)
      IF (I .LT. 0 .AND. ISKP(60) .GE. 0 .OR.
     +    I .GE. 0 .AND. ISKP(60) .LT. 0)
     +    CALL UPLINF(ISKP(60),32)
      GO TO 80
C                            WFKT und DFKT
CYENG1
 1840 CALL FLES (KONST(KDONUL-51),ISKP(31),2HFE,6HWert?$)
CYENG2
CYENGY 1840 CALL FLES (KONST(KDONUL-51),ISKP(31),2HFE,7HValue?$)
      SCL=O9*CONST(43)
      GO TO 80
C                            AZIN - Generiere Zellinhalt
 1860 CALL ZVZLIN
      IF (NTYP .EQ. 2) GO TO 60
      GO TO 80
C                            TFL
CYENG1
 1870 CALL FLES (ISKP(63),ISKP(31),2HIE,14H1/0: Ja/Nein?$)
CYENG2
CYENGY 1870 CALL FLES (ISKP(63),ISKP(31),2HIE,13H1/0: Yes/No?$)
      GO TO 80
C
 1880 CONTINUE
C     CALL KPSMSY
      GO TO 80
C                            TSZ RDZ ITS
 1890 CALL ZVTSZR
      GO TO 80
C                            FDGC FRGC FLGC SEL VGDP PVOL TGL
 1900 CALL ZVGC04
      GO TO 80
C                            OFMD FMDP FMDR FMDD
 1910 CALL ZVDTAB (0,0,0.,NTYP)
      GO TO 80
C                            EHMS - Extra HMS
 1920 CALL ZVEHMS
      GO TO 80
C                            G = BF;EPU  GG = BF;STPU
 1930 IF (NTYP .EQ. 2) THEN
        ISKP(59)=3
        NTYP=1
      ENDIF
      CALL ZVFKTR
      IF (IERR .NE. 0) GO TO 80
      NTYP=4
      IF (ISKP(59) .EQ. 3) NTYP=3
      CALL ZVMACR
      GO TO 80
C                            SAR - Suche nur in ausgezeichneten Rchtg.
 1940 IAIN(1)=1
      IF (NTYP .EQ. 2) IAIN(1)=-1
      CALL ZVTEAC (IAIN,IAIN,IAIN)
      GO TO 80
C                            IGFA - Ignoriere Fremdatome
 1950 CALL FLES (ISKP(76),ISKP(31),2HIE,
CYENG1
     + 35H0/1: Ignoriere Fremdatome nein/ja?$)
CYENG2
CYENGY     + 34H0/1: Ignore foreign atoms no/yes?$)
      GO TO 80
C                            MSAV - Makros abspeichern
 1960 CALL FLES (ISKP(86),ISKP(31),2HIE,
CYENG1
     + 33H0/1: Makros abspeichern nein/ja?$)
CYENG2
CYENGY     + 25H0/1: Save macros no/yes?$)
      GO TO 80
C                            SYSW - SYS wait
 1970 IAIN(1)=0
CYENG1
      CALL FLES (IAIN(1),ISKP(31),2HIE,16H[0]/1: Nein/Ja?$)
CYENG2
CYENGY      CALL FLES (IAIN(1),ISKP(31),2HIE,15H[0]/1: No/Yes?$)
      CALL UPLINF (AIN,17)
      GO TO 80
C                            I - INIT
 1980 CALL ZVPRIM
      NTYP=2
      CALL ZVHMS
      IF (IERR .NE. 0) GO TO 80
      DO  I=1,3
        ZELLE(I,NS)=10.
      ENDDO
      I=NHMSNR(3,NS)
      IF (I .GT. 230) I=I/100
      IF (I .GE. 143 .AND. I .LE. 194) THEN
        DO  J=1,7
          IF (NHMSNR(3,NS) .EQ. IRGZ(J)) GO TO 1990
        ENDDO
        ZELLE(6,NS)=120.
        ZELLE(3,NS)=11.547005
      ENDIF
 1990 NTYP=1
      ISKP(14)=1
      CALL ZVZ
      NTYP=16
      CALL ZVZ
      NAT(NS)=2
      GO TO 80
C                            TUG - Transformiere in untergruppe
 2000 CALL ZVTUG
      GO TO 80
C                            RGS - RGS aktivieren.
 2010 IAIN(1)=1
      IF (ISKP(95) .NE. 0) IAIN(1)=2
      IF (ISKP(45) .NE. 0) KARTE(20)=ISKP(24)
      CALL FLES (IAIN(1),ISKP(31),2HIE,5HOpt?$)
      CALL KPRGS (IAIN)
      CALL FLES (I,IOPT,1HO,2H?$)
      KARPOI=IOPT(8)
      IF (IAIN(1) .NE. 0) THEN
        ISKP(45)=0
        IERR=-1
        GO TO 80
      ENDIF
C
C                            Ggf. macro fortsetzen
C
      IF (ISKP(45) .NE. 0) THEN
        NTYP=4
        GO TO 1370
      ENDIF
      GO TO 80
C                            LZIN
 2020 CALL ZVLZIN
      GO TO 80
C                            OAWY
 2030 CALL ZVOAWY
      GO TO 80
C                            LOG
 2040 I=NTDTEI
      CALL FLES (I,ISKP(31),2HJR,5HNr.?$)
      IF (I .LT. 0 .OR. I .GT. 99) THEN
        IERR=1128821
      ELSE
        IF (I .GT. 0) THEN
          NTYP=I
          CALL ZVEAEH
        ENDIF
        NTOSYS=I
      ENDIF
      GO TO 80
C                            IZA
 2060 CONTINUE
CYENG1
      CALL FLES (ISKP(88),ISKP(31),2HIE,13H0/1 nein/ja?$)
CYENG2
CYENGY      CALL FLES (ISKP(88),ISKP(31),2HIE,12H0/1 off/on?$)
      GO TO 80
C                            LCIF und V
 2070 CALL ZVLCIF
      GO TO 80
C                            VSUM OX OOX
 2080 CALL ZVVSUM
      GO TO 80
C                            NS
 2100 IAIN(1)=3-NS
      CALL FLES (IAIN,ISKP(31),2HIE,5H1/2?$)
      IF (IAIN(1) .LT. 1 .OR. IAIN(1) .GT. 2) GO TO 80
      NS=IAIN(1)
      NT=NS
      K9(NS)=0
      GO TO 80
C                            CNRM ONRM TNRM VZDP
 2110 CALL ZVGC05
      GO TO 80
C                            CMPZ CMPO
 2120 CALL ZVCMPC
      GO TO 80
C                            UFR UFRA ACAF OUM
 2130 CALL ZVGE05
      GO TO 80
C                            ZFND
 2140 CALL ZVZFND
      go to 80
C                            SLAB
 2150 CONTINUE
CYENG1
      CALL FLES (ISKP(95),ISKP(31),2HIE,13H0/1 nein/ja?$)
CYENG2
CYENGY      CALL FLES (ISKP(95),ISKP(31),2HIE,12H0/1 off/on?$)
      GO TO 80
C                            GSXF
 2160 CALL FLES (ISKP(96),ISKP(31),2HIE,5HOpt?$)
      GO TO 80
C                            IDF
 2170 CALL ZVIDF
      GO TO 80
C                            PFND
 2180 CALL ZVPFND
      GO TO 80
C                            CCL
 2190 CALL ZVGE06
      GO TO 80
C
 1720 NTYP=-1
      CALL UPLINF (PLDEV(1),NTYP)
      CALL ZVEAEH
 9999 RETURN
      END
