CKPMINO   47             -------------------
                          SUBROUTINE ZVMINO
C  CY-ENG-               -------------------
C
C   Das Programm sucht eine Orientierung fuer minimale Ueberdeckung.
C
C                 geschrieben: 190841 APR 1982  (Hundt)
C                 geaendert:   171101 MAY 2001  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 INBFR(3),IAIN(72),I,ICNT,ICNU,IDX,IDY,IEND
      INTEGER *4 J,JSTRT,KEYIN
      REAL    *4 DRSV(3,3),DRMRK(3,3),AINBFR(3),CX,CY,DISTQ,FDIST
      REAL    *4 SMIN,SUM,SX,SY,TEMP,TEMP2
C
      SAVE INBFR
C
      EQUIVALENCE (AIN(1),IAIN(1)),(INBFR(1),AINBFR(1))
C
      DATA AINBFR(1)/6./,INBFR(2)/5/,AINBFR(3)/1./
C
      IF (ISKP(14) .EQ. 0) THEN
CYENG1
        CALL FLES (INBFR,ISKP(31),4HFIFE,20HSchrittw.,npt,dist?$)
CYENG2
CYENGY        CALL FLES (INBFR,ISKP(31),4HFIFE,20HStepwidth,npt,dist?$)
      ELSE
        DO  I=1,3
          INBFR(I)=IAIN(I+10)
        ENDDO
      ENDIF
      DISTQ=AINBFR(3)*AINBFR(3)
C                            Teste, ob Berechnung moeglich.
      IF (NCD(NS) .LE. 1) THEN
        IERR=47003012
        GO TO 999
      ENDIF
C                            Save Orientierungsmatrix und setze
C                            Anfangswerte.
      DO  I=1,3
        DO  J=1,3
          DRSV(I,J)=DREH(I,J)
          DRMRK(I,J)=DREH(I,J)
        ENDDO
      ENDDO
      SMIN=1.E6
      ICNT=0
      IDX=0
      IDY=0
      GO TO 120
C                            Naechster Schritt
   60 ICNT=ICNT+1
C
      IDX=ICNT
C
   70 IDY=ICNT
C                            Nicht beide IDX und IDY duerfen
C                            dem Betrage nach kleiner ICNT sein.
C
   80 IF (IABS(IDX)-ICNT) 90,100,100
   90 IF (IABS(IDY)-ICNT) 260,100,100
C
C                            Berechne Transformationsmatrix fuer
C                            Atome.
C
  100 TEMP=FLOAT(IDX)*AINBFR(1)*CONST(3)
      SX=SIN(TEMP)
      CX=COS(TEMP)
      TEMP=FLOAT(IDY)*AINBFR(1)*CONST(3)
      SY=SIN(TEMP)
      CY=COS(TEMP)
      S(1,1)=CY
      S(1,2)=0.
      S(1,3)=SY
      S(2,1)=SX*SY
      S(2,2)=CX
      S(2,3)=-SX*CY
      S(3,1)=-CX*SY
      S(3,2)=SX
      S(3,3)=CX*CY
C
      DO 110 I=1,3
      DO 110 J=1,3
      DREH(I,J)=S(I,1)*DRSV(1,J)+S(I,2)*DRSV(2,J)+S(I,3)*DRSV(3,J)
  110 CONTINUE
      NTYP=3
      CALL ZVK
      K9(NS)=0
C                            Berechne freie Koordinaten.
  120 NTYP=9
      CALL ZVGE02
C                            Berechne Projektionen.
      K9(NS)=0
      DO 150 I=NCDA(NS),NCD(NS)
      TEMP=HOE-ATOMS(3,I,NS)
      IF (TEMP) 130,130,140
  130 IERR=47013018
      GO TO 999
C
  140 ATOMS(1,I,NS)=ATOMS(1,I,NS)*HOE/TEMP
      ATOMS(2,I,NS)=ATOMS(2,I,NS)*HOE/TEMP
  150 CONTINUE
C                            Stelle Overlap-Funktion zusammen.
      SUM=0.
      ICNU=(ISKP(53)-1)*200000+199999
      IEND=NCD(NS)-1
      DO 220 I=NCDA(NS),IEND
      IF (ICD(I,NS) .LT. ICNU) GO TO 220
      JSTRT=I+1
      DO 210 J=JSTRT,NCD(NS)
      IF (ICD(J,NS) .LT. ICNU) GO TO 210
      TEMP=ATOMS(1,I,NS)-ATOMS(1,J,NS)
      IF (ABS(TEMP)-AINBFR(3)) 160,160,210
  160 TEMP2=ATOMS(2,I,NS)-ATOMS(2,J,NS)
      IF (ABS(TEMP2)-AINBFR(3)) 170,170,210
  170 FDIST=TEMP*TEMP+TEMP2*TEMP2
      IF (FDIST-DISTQ) 180,200,210
  180 IF (FDIST - 0.0001) 190,190,200
  190 SUM=SUM+20000.-FDIST*1.E8
      GO TO 210
  200 SUM=SUM+1./FDIST
  210 CONTINUE
  220 CONTINUE
C                            Teste, ob Verbesserung erzielt.
C
  230 IF (KEYIN(0) .EQ. ISKP(20)) GO TO 310
      IF (SUM-SMIN) 240,260,260
C
C                            Ja.  Merke.
  240 SMIN=SUM
      DO 250 I=1,3
      DO 250 J=1,3
  250 DRMRK(I,J)=DREH(I,J)
      IF (ISKP(58) .GT. 0) THEN
CYENG1
        WRITE (WRLINE,'(A,F10.2)') ' Testsumme:',SUM
CYENG2
CYENGY        WRITE (WRLINE,'(A,F10.2)') ' Testsum:',SUM
        CALL KPWRTE (NTDISP)
      ENDIF
C                            Teste, ob fertig.
      IF (SUM) 310,310,260
C                            Naechstes IDY
  260 IDY=IDY-1
      IF (IDY+ICNT) 270,90,90
C                            Naechstes IDX
  270 IDX=IDX-1
      IF (IDX+ICNT) 280,70,70
C                            Naechstes ICNT
C
  280 IF (ICNT-INBFR(2)) 60,310,310
C
C                            Fertig mit der Suche
  310 CONTINUE
C                            Kopiere beste Matrix.
      DO 330 I=1,3
      DO 330 J=1,3
  330 DREH(I,J)=DRMRK(I,J)
      NTYP=3
      CALL ZVK
C
  999 RETURN
      END
