CKPMNOV   63             -------------------
                          SUBROUTINE ZVMNOV
C  CY-ENG-               -------------------
C
C   Das Programm sucht eine Orientierung fuer minimale Ueberdeckung.
C   Die Orientierung wird durch Drehung um eine vorgegebene Achse
C   ermittelt.
C
C                 geschrieben: 051054 APR 89  (Hundt)
C                 geaendert:   101619 DEC 99  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 INBFR(5),I,ICNT,ICNU,IEND,IVORZ,J,JSTRT,KEYIN
      REAL    *4 URMRK(3),DRMRK(3,3),AINBFR(5),DISTQ,FDIST,SMIN
      REAL    *4 SUM,TEMP,TEMP2,WSTEP
C
      SAVE INBFR
C
      EQUIVALENCE (INBFR(1),AINBFR(1))
C
      DATA INBFR(1)/1/,INBFR(2)/156501/,AINBFR(3)/10./,INBFR(4)/0/
      DATA AINBFR(5)/3.0/
C
      INBFR(4)=0
      CALL FLES (INBFR,ISKP(31),6H2CFIFE,18Hp1,p2,w,npt,dist?$)
      IF (INBFR(4) .LE. 0) INBFR(4)=AINBFR(3)+.1
C
C                            Teste, ob Berechnung moeglich.
      IF (NCDA(NS) .GE. NCD(NS)) THEN
        IERR=63 0036 12
        GO TO 999
      ENDIF
C                            Hole ggf. Gruppenelemente
      DO  I=1,2
        IF (INBFR(I) .EQ. 0) THEN
          INBFR(I)=I
          NTYP=7
          CALL ZVGC01 (INBFR(I))
        ENDIF
      ENDDO
      IF (INBFR(1) .EQ. INBFR(2)) THEN
        IERR=63 0048 06
        GO TO 999
      ENDIF
C                            Save Orientierungsmatrix und setze
C                            Anfangswerte.
      DO  I=1,3
        URMRK(I)=UR(I,NS)
        DO  J=1,3
          DRMRK(I,J)=DREH(I,J)
        ENDDO
      ENDDO
      DISTQ=AINBFR(5)*AINBFR(5)
      SMIN=1.E6
      WSTEP=AINBFR(3)/FLOAT(INBFR(4))
      ICNT=0
      IVORZ=-1
      ICNU=(ISKP(53)-1)*200000+199999
      GO TO 120
C                            Naechster Schritt
   60 ICNT=ICNT+1
      IVORZ=-IVORZ
      AIN(1)=AINBFR(1)
      AIN(2)=AINBFR(2)
      AIN(3)=FLOAT(ICNT*IVORZ)*WSTEP
C
C                            Kommando DKV
      NTYP=22
      CALL ZVGE01
      IF (IERR .NE. 0) GO TO 999
C                            Berechne freie Koordinaten.
  120 NTYP=9
      CALL ZVGE02
C                            Berechne Projektionen.
      K9(NS)=0
      DO 150 I=NCDA(NS),NCD(NS)
      IF (ICD(I,NS) .LT. ICNU) GO TO 150
      TEMP=HOE-ATOMS(3,I,NS)
      IF (TEMP) 130,130,140
  130 IERR=63013018
      GO TO 999
C
  140 ATOMS(1,I,NS)=ATOMS(1,I,NS)*HOE/TEMP
      ATOMS(2,I,NS)=ATOMS(2,I,NS)*HOE/TEMP
  150 CONTINUE
C                            Stelle Overlap-Funktion zusammen.
      SUM=0.
      IEND=NCD(NS)-1
      DO 220 I=NCDA(NS),IEND
      IF (ICD(I,NS) .LT. ICNU) GO TO 220
      JSTRT=I+1
      DO 210 J=JSTRT,NCD(NS)
      IF (ICD(J,NS) .LT. ICNU) GO TO 210
      TEMP=ATOMS(1,I,NS)-ATOMS(1,J,NS)
      IF (ABS(TEMP)-AINBFR(5)) 160,160,210
  160 TEMP2=ATOMS(2,I,NS)-ATOMS(2,J,NS)
      IF (ABS(TEMP2)-AINBFR(5)) 170,170,210
  170 FDIST=TEMP*TEMP+TEMP2*TEMP2
      IF (FDIST-DISTQ) 180,200,210
  180 IF (FDIST - 0.0001) 190,190,200
  190 SUM=SUM+20000.-FDIST*1.E8
      GO TO 210
  200 SUM=SUM+1./FDIST
  210 CONTINUE
  220 CONTINUE
C                            Teste, ob Verbesserung erzielt.
C
      IF (KEYIN(0) .EQ. ISKP(20)) GO TO 310
      IF (SUM-SMIN) 240,260,260
C
C                            Ja.  Merke.
  240 SMIN=SUM
      DO  I=1,3
        URMRK(I)=UR(I,NS)
        DO  J=1,3
          DRMRK(I,J)=DREH(I,J)
        ENDDO
      ENDDO
      IF (ISKP(58) .GT. 0) THEN
CYENG1
        WRITE (WRLINE,'(A,F10.2)') ' Testsumme:',SUM
CYENG2
CYENGY        WRITE (WRLINE,'(A,F10.2)') ' Testsum:',SUM
        CALL KPWRTE (NTDISP)
      ENDIF
C                            Teste, ob fertig.
      IF (SUM) 310,310,260
C                            Naechstes ICNT
C
  260 IF (ICNT-INBFR(4)) 60,310,310
C
C                            Fertig mit der Suche
  310 CONTINUE
C                            Kopiere beste Matrix.
      DO  I=1,3
        UR(I,NS)=URMRK(I)
        DO  J=1,3
          DREH(I,J)=DRMRK(I,J)
        ENDDO
      ENDDO
      NTYP=3
      CALL ZVK
C
  999 RETURN
      END
