CKPP2A    17             ------------------
                          SUBROUTINE ZVP2A
C CY-ENG-                ------------------
C
C  Es wird ein Punkt im Raum bestimmt, der von zwei Punkten c1 und c2
C  vorgegebene Abstaende d1 und d2 hat.  Der Punkt liegt in der Ebene
C  c1, c2, ch, und zwar auf der gleichen Seite wie ch, falls NTYP=1
C  ist, andernfalls auf der anderen Seite.
C
C                         Geschrieben: Hundt
C                    Geaendert: 071000 FEB 2000  (Hundt)
C
C                        ------------------
C
      IMPLICIT NONE
C
      INTEGER *4 I,J,K
      REAL    *4 PT(3),PF(3),PU(3),VA(3),VC(3),D1,D2,HQ,RCHTNG
      REAL    *4 T1,T2,TEMP
C
      INCLUDE 'ZVCOM.INC'
C
      EQUIVALENCE (X(1,1),PU(1)),(X(1,2),VA(1))
      EQUIVALENCE (X(1,3),VC(1))
      EQUIVALENCE (PTRIKL(1),PT(1)),(PFREI(1),PF(1))
      EQUIVALENCE (ICDS(4),D1),(ICDS(5),D2)
      EQUIVALENCE (AIN(62),TEMP),(AIN(61),T1),(AIN(60),T2),(AIN(59),HQ)
C
      RCHTNG=1.
      IF (NTYP .NE. 1) RCHTNG=-1.
      D1=CONST(5)
      D2=CONST(5)
      CALL FLES (ICDS,ISKP(31),5H3C2FE,16Hc1,c2,ch,d1,d2?$)
C
C                            Hole ggf. Codes aus sp. Liste
      DO  I=1,3
        IF (ICDS(I) .EQ. 0) THEN
          NTYP=7
          J=I
          CALL ZVGC01 (J)
          ICDS(I)=J
        ENDIF
      ENDDO
C
      IF (D2 .LE. 0.) D2=D1
      D1=D1*D1
      D2=D2*D2
C                            Hole freie Koordinaten.
      NTRY=28
      DO  NC=1,3
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  I=1,3
          X(I,NC)=X2(I)
        ENDDO
      ENDDO
C                            Berechne Vektoren mit Laenge.
      TEMP=0.
      DO  I=1,3
        T1=VA(I)-PU(I)
        TEMP=TEMP+T1*T1
        VA(I)=T1
        VC(I)=VC(I)-PU(I)
      ENDDO
      IF (TEMP .LE. 0.) THEN
        IERR=17006206
        GO TO 999
      ENDIF
C                            Berechne Fusspunkt und Hoehe.
      T1=SQRT(TEMP)
      T2=(TEMP-D2+D1)/(2.*TEMP)
      T1=T2*T1
      HQ=D1-T1*T1
      IF (HQ .LE. 0.) THEN
        IERR=17007115
        GO TO 999
      ENDIF
C
      DO  I=1,3
        PU(I)=PU(I)+T2*VA(I)
        J=ID2(I)
        K=ID2(J)
        T(I)=VA(J)*VC(K)-VA(K)*VC(J)
      ENDDO
      TEMP=0.
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        T1=T(J)*VA(K)-T(K)*VA(J)
        TEMP=TEMP+T1*T1
        VC(I)=T1
      ENDDO
C                            Bestimme Loesungspunkt.
      IF (TEMP .LE. 0.) THEN
        IERR=17009115
        GO TO 999
      ENDIF
      TEMP=SQRT(HQ/TEMP)*RCHTNG
      DO  I=1,3
        PF(I)=PU(I)+TEMP*VC(I)
      ENDDO
C
C                            Gleiche triklinen Punkt an.
      DO  I=1,3
        PT(I)=TRAINV(I,1,NS)*PF(1)+TRAINV(I,2,NS)*PF(2)+
     +  TRAINV(I,3,NS)*PF(3)+UR(I,NS)
      ENDDO
C
  999 RETURN
      END
