CKPP3A    18             ------------------
                          SUBROUTINE ZVP3A
C CY-ENG-                ------------------
C
C                        Geschrieben: Hundt
C                  Geaendert: 071039 FEB 2000  (Hundt)
C
C   Kommando  NTYP  Bedeutung
C   PDA         1   Punkt durch drei Abstaende
C   PAW         2   Punkt durch Abstand und zwei Winkel
C   LSWS        3   Dreiecksseite berechnen Seite-Winkel-Seite
C
C                        ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 I,J,K,NTYPS
      REAL    *4 PU(3),VA(3),VC(3),PF1(3),PF2(3),VAS(3),VBS(3)
      REAL    *4 PF(3),PT(3),A(2,2),B(2),CDS(7)
      REAL    *4 D1,D2,D3,H,HQ,T1,T2,T3,T4,TEMP
C
      EQUIVALENCE (X(1,1),PU(1)),(X(1,2),VA(1)),(X(1,3),VC(1))
      EQUIVALENCE (X(1,4),PF1(1)),(X(1,5),PF2(1)),(X(1,6),VAS(1))
      EQUIVALENCE (X(1,7),VBS(1)),(ICDS(4),D1),(ICDS(5),D2)
      EQUIVALENCE (PTRIKL(1),PT(1)),(PFREI(1),PF(1)),(ICDS(6),D3)
      EQUIVALENCE (AIN(7),T1),(AIN(8),T2),(AIN(9),T3),(AIN(10),T4)
      EQUIVALENCE (AIN(11),TEMP),(AIN(12),H),(AIN(13),A(1,1))
      EQUIVALENCE (AIN(17),B(1)),(AIN(19),HQ),(ICDS(1),CDS(1))
C
      NTYPS=NTYP
      GO TO (10,250,310),NTYPS
C             1   2   3
C                            PDA.  Lies Eingabe.
   10 DO  I=4,6
        CDS(I)=CONST(5)
      ENDDO
      CALL FLES (ICDS,ISKP(31),5H3C3FE,20Hc1,c2,c3, d1,d2,d3?$)
C
C                            Hole ggf. Codes aus sp. Liste
      DO  I=1,3
        IF (ICDS(I) .EQ. 0) THEN
          NTYP=7
          J=I
          CALL ZVGC01 (J)
          ICDS(I)=J
        ENDIF
      ENDDO
C
      DO  I=5,6
        IF (CDS(I) .LE. 0.) CDS(I)=CDS(I-1)
      ENDDO
      D1=D1*D1
      D2=D2*D2
      D3=D3*D3
C                            Berechne Koordinaten.
   80 NTRY=28
      DO  NC=1,3
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 999
        DO  I=1,3
          X(I,NC)=X2(I)
        ENDDO
      ENDDO
C                            Berechne Vektoren VA: P1,P2 und VC: P1,P3
C                            sowie deren Laengen.
      T1=0.
      T2=0.
      DO  I=1,3
        VA(I)=VA(I)-PU(I)
        VC(I)=VC(I)-PU(I)
        T1=T1+VA(I)**2
        T2=T2+VC(I)**2
      ENDDO
      IF (T1 .LE. 0.) THEN
        IERR=18007406
        GO TO 999
      ENDIF
      TEMP=SQRT(T1)
      IF (NTYPS .EQ. 2) THEN
        D2=D1+T1-2.*SQRT(D1*T1)*COS(D2*CONST(3))
        D3=D1+T2-2.*SQRT(D1*T2)*COS(D3*CONST(3))
      ENDIF
C                            Berechne Fusspunkte fuer die Schnitt-
C                            geraden.
      T3=(D1+T1-D2)/(2.*T1)
      T4=(D1+T2-D3)/(2.*T2)
      TEMP=T3*TEMP
      HQ=D1-TEMP*TEMP
      TEMP=0.
      DO  I=1,3
        PF1(I)=PU(I)+T3*VA(I)
        PF2(I)=PU(I)+T4*VC(I)
C                            Hoehenvektor.
        J=ID2(I)
        K=ID2(J)
        H=VA(J)*VC(K)-VA(K)*VC(J)
        T(I)=H
        TEMP=H*H+TEMP
      ENDDO
      IF (TEMP .LE. 0.) THEN
C                            Vektoren konplanar oder Nullvektor.
        IERR=18010106
        GO TO 999
      ENDIF
C                            Baue Matrix fuer Gleichungssystem und
C                            loese Gleichungssystem.
      DO  I=1,2
        A(I,1)=0.
        A(I,2)=0.
        B(I)=0.
      ENDDO
C                            Vektoren senkrecht zu VA und VB
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        VAS(I)=T(J)*VA(K)-T(K)*VA(J)
        VBS(I)=T(J)*VC(K)-T(K)*VC(J)
        PU(I)=PF2(I)-PF1(I)
        A(1,1)=A(1,1)+VAS(I)*VAS(I)
        A(1,2)=A(1,2)-VAS(I)*VBS(I)
        A(2,2)=A(2,2)+VBS(I)*VBS(I)
        B(1)=B(1)+PU(I)*VAS(I)
        B(2)=B(2)-PU(I)*VBS(I)
      ENDDO
      A(2,1)=A(1,2)
C                            Loese Gleichungssystem.
C
      T1=(B(1)*A(2,2)-B(2)*A(1,2))/(A(1,1)*A(2,2)-A(1,2)*A(2,1))
C
C                            Fusspunkt fuer Hoehenvektor
      T2=0.
      DO  I=1,3
        T3=T1*VAS(I)
        T2=T2+T3*T3
        PF1(I)=PF1(I)+T3
      ENDDO
      T3=(HQ-T2)/TEMP
      IF (T3 .LT. 0.) THEN
C                            Kein Schnittpunkt.
        IERR=18013915
        GO TO 999
      ENDIF
C
      T3=SQRT(T3)
C                            Berechne Koordinaten fuer PF.
      DO  I=1,3
        PF(I)=PF1(I)+T3*T(I)
      ENDDO
C                            Berechne trikline Koordinaten.
      DO  I=1,3
        PT(I)=TRAINV(I,1,NS)*PF(1)+TRAINV(I,2,NS)*PF(2)+
     +  TRAINV(I,3,NS)*PF(3)+UR(I,NS)
      ENDDO
      GO TO 999
C                            PAW.  Berechne Laengen.
  250 D1=CONST(5)
      D2=CONST(6)
      D3=CONST(6)
      CALL FLES (ICDS,ISKP(31),5H3C3FE,21Hc1,c2,c3, d1, w2,w3?$)
C
C                            Hole ggf. Codes aus sp. Liste
      DO  I=1,3
        IF (ICDS(I) .EQ. 0) THEN
          NTYP=7
          J=I
          CALL ZVGC01 (J)
          ICDS(I)=J
        ENDIF
      ENDDO
C
      IF (D3 .LE. 0.) D3=D2
      D1=D1*D1
      GO TO 80
C                             LSWS - Laenge durch Dreiecksberechnung
C
  310 AIN(7)=CONST(5)
      AIN(8)=CONST(6)
      AIN(9)=CONST(5)
      CALL FLES (AIN(7),ISKP(31),3H3FE,
CYENG1
     1 20HSeite,Winkel,Seite?$)
CYENG2
CYENGY     1 17Hside,angle,side?$)
      IF (AIN(9) .LE. 0.) AIN(9)=AIN(7)
      CONST(5)=SQRT(T1*T1+T3*T3-2.*T1*T3*COS(T2*CONST(3)))
      WRITE (WRLINE,'(A,F10.5)') 'L =',CONST(5)
      CALL KPWRTE (NTOUT)
C
  999 RETURN
      END
