C         99              -------------------
                           SUBROUTINE ZVPFND
C                         -------------------
C
C                  Programm zur Handhabung von Polyedern.
C                  geschrieben: 171529 APR 2007  (Hundt)
C                  geaendert:   140949 AUG 2007  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IPSTDM,IPSTP
      PARAMETER (IPSTDM=1000)
C
      INTEGER *4 NDDIM,NDPOI
      PARAMETER (NDDIM=2080)
C
      INTEGER *4 IPST(IPSTDM),IPZG(20)
      INTEGER *4 IAT(8,PARDIM,2),IAIN(72)
      INTEGER *4 I,J,K,N,M,IUR,NAM1,NAM2,ISPOI,IVPOI,INC,INC2,IHFLG
      INTEGER *4 IP1,IP2,IV1,IV2,ICP1,ICP2,ICP1M,ICP2M,IRLINE(30)
      INTEGER *4 IPGZ,IPOPT(3),NTYPS,IDURCH,ICM,LGA,IZALT
      INTEGER *4 NSTK(NDDIM),MSTK(NDDIM),ICNT(0:3),IRSN
C
      REAL    *4 AIDN(12),DMIN,TEMP,TEMP2,WMERK,A(3,3),B(3,3),Y(3,3)
      REAL    *4 TR(3,2),V(3),AINBFR(3),PST(IPSTDM),dstk(nddim)
C
      SAVE IPOPT,AINBFR
C
      EQUIVALENCE (AIN(1),IAIN(1)),(AT(1,1,1),IAT(1,1,1))
      EQUIVALENCE (WRLINE,IRLINE(1)),(IPST(1),PST(1))
C
      DATA AIDN/2.,1.,0.,0., 2.,0.,1.,0.,2.,0.,0.,1./
      DATA IPOPT/0,1,0/,AINBFR/0.25,85.,0./
C
      NTYPS=NTYP
C
C       Belegplan fuer die optionen:
C       (1) Strategie zur ermittlung der polyeder
C       (2) Auch inverse varianten werden geprueft
C       (3) Namen muessen auch stimmen 1: nur zentralatom, 2: alle
C
      IF (NTYPS .EQ. 1) THEN
        I=IPOPT(1)
        CALL FLES (IPOPT,ISKP(31),3H3IE,5HOpt?$)
        IF (ISKP(31) .EQ. 0) THEN
CYENG1
          WRITE (WRLINE,'(A,10I4)') 'Optionen:',IPOPT
CYENG2
CYENGY          WRITE (WRLINE,'(A,10I4)') 'Options:',IPOPT
          CALL KPWRTE (NTOUT)
        ELSE IF (IPOPT(1) .LT. 0) THEN
          WRITE (WRLINE,'(A)')
CYENG1
     +    '1: 0/1/2 Strategie'
CYENG2
CYENGY     +    '1: 0/1/2 Strategy'
          CALL KPWRTE (NTOUT)
          WRITE (WRLINE,'(A)')
CYENG1
     +    '2: 1: Auch invertierte Polyeder werden getestet.'
CYENG2
CYENGY     +    '2: 1: Inverted polyhedra will be tested too.'
          CALL KPWRTE (NTOUT)
          WRITE (WRLINE,'(A)')
CYENG1
     +    '3: 1/2: Arbeitsnamen muessen uebereinstimmen.'
CYENG2
CYENGY     +    '3: 1/2: Working names have to agree.'
          CALL KPWRTE (NTOUT)
          IPOPT(1)=I
        ENDIF
        GO TO 999
      ENDIF
C
      CALL FLES (AINBFR,ISKP(31),3H2FE,11Htols,tolw?$)
      IPSTP=0  ! Loesche Polyederbereich
      IF (IPOPT(1) .GT. 1) GO TO 30
C
C  Ermittle den kuerzesten abstand, der zu identischen atomen fuehrt.
C
      DMIN=MIN(ZELLE(1,NS),ZELLE(2,NS),ZELLE(3,NS))
C
C                   Suche noch bei den zentrierungen.
      NC=1
      NTRY=2
      DO  I=2,NSYM(NS)
        DO  J=1,12
          IF (AIDN(J) .LE. 1.) THEN
            IF (ABS(SYM(J,I,NS)-AIDN(J)) .GT. 0.0001) GO TO 10
          ENDIF
        ENDDO
C                            Zentrierung gefunden
        K=1
        DO  J=1,9,4
          X(K,NC)=SYM(J,I,NS)
          K=K+1
        ENDDO
        CALL ZVDEK
        DMIN=MIN(DMIN,SQRT(X1(1)*X1(1)+X1(2)*X1(2)+X1(3)*X1(3)))
   10   CONTINUE
      ENDDO
C                            Setze ein AKS auf.
C
      DO  IUR=ISKP(53),NAT(NS)
        NCD(NS)=1
        ICD(1,NS)=IUR*200000+111001
        K8(NS)=0
        ICDS(1)=IUR
        IZ1=ISKP(53)
        IZ2=NAT(NS)
        DQ=DMIN*0.99
        CONST(20)=0.
        NTYP=3
        ISKP(14)=1
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 999
C
C          Berechne abstaende und merke den kuerzesten, der zur
C          gleichen atomsorte auftritt.
C
        CALL MV(DG(1,1,NS),ATOMS(1,1,NS),X2)
        NAM1=IAT(7,IUR,NS)
        TEMP=DMIN
        DO  IC=2,NCD(NS)
          CALL MV(DG(1,1,NS),ATOMS(1,IC,NS),X1)
          TEMP2=SQRT((X1(1)-X2(1))**2+(X1(2)-X2(2))**2+
     +    (X1(3)-X2(3))**2)
          ATOMS(1,IC,NS)=TEMP2
          NAM2=IAT(7,ICD(IC,NS)/200000,NS)
          IF (NAM1 .EQ. NAM2) TEMP=MIN(TEMP,TEMP2)
        ENDDO
C
C        Eleminiere alle atome, die jetzt einen groesseren abstand
C        haben und die, die den gleichen namen tragen.
C
        J=1
        IF (IPOPT(1) .EQ. 0) THEN
          DO  IC=2,NCD(NS)
            IF (ATOMS(1,IC,NS) .LT. TEMP) THEN
              NAM2=IAT(7,ICD(IC,NS)/200000,NS)
              IF (NAM1 .NE. NAM2) THEN
                J=J+1
                ICD(J,NS)=ICD(IC,NS)
                ATOMS(1,J,NS)=ATOMS(1,IC,NS)
              ENDIF
            ENDIF
          ENDDO
C                Strategie 1: Abstaende aus tabelle
        ELSE
          DO  IC=2,NCD(NS)
            NAM2=IAT(7,ICD(IC,NS)/200000,NS)
            IF (NAM1 .NE. NAM2) THEN
              CALL ZVDTAB (NAM1,NAM2,TEMP,2)
              IF (ATOMS(1,IC,NS) .LT. TEMP) THEN
                J=J+1
                ICD(J,NS)=ICD(IC,NS)
                ATOMS(1,J,NS)=ATOMS(1,IC,NS)
              ENDIF
            ENDIF
          ENDDO
        ENDIF
        if (j .le. 1) go to 20
        NCD(NS)=J
C                     Speichere, falls noch moeglich
C
C         Aufbau der liste ipst bzw. pst (polyederstack):
C         offset  inhalt
C         0       laenge des records
C         1       maximalabstand vom zentralatom
C         2       zentralatom (code)
C         3ff     liganden
C
        IF (IPSTP+J+1 .GT. IPSTDM) THEN
CYENG1
          WRITE (WRLINE,'(A)') 'ZVPFND0181 - Speicherueberlauf ipst.'
CYENG2
CYENGY          WRITE (WRLINE,'(A)') 'ZVPFND0181 - Overflow of ipst.'
          CALL KPWRTE (NTOUT)
          IERR=-1
          GO TO 999
        ENDIF
        IPSTP=IPSTP+2
        IPST(IPSTP-1)=NCD(NS)+2
        DO  IC=1,NCD(NS)
          IPSTP=IPSTP+1
          IPST(IPSTP)=ICD(IC,NS)
        ENDDO
   20   continue
      ENDDO  ! IUR
      GO TO 50
C                           Vorgabe ueber die mausliste.
   30 DO  I=5,IPSTDM
        NTYP=7
        J=I-4
        CALL ZVGC01(J)
        IF (J .EQ. 0) GO TO 40
        IPST(I)=J
      ENDDO
   40 CONTINUE
      I=I-1
      IF (MOD(I,2) .NE. 0) THEN
        IERR=99 0208 16
        GO TO 999
      ENDIF
      IPSTP=I
      IPGZ=IPSTP/2
      IPST(1)=IPGZ
      DO  I=3,IPGZ
        IPST(I)=IPST(I+2)
      ENDDO
      IPST(IPGZ+1)=IPGZ
      IPSTP=IPGZ*2
   50 CONTINUE
      IF (IPSTP .EQ. 0) THEN
CYENG1
        WRITE (WRLINE,'(A)') 'ZVPFND0222 - Keine Polyeder gefunden.'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'ZVPFND0222 - No polyhedra found.'
        CALL KPWRTE (NTOUT )
        IERR=-1
        GO TO 999
      ENDIF
C              Berechne maximale abstaende innerhalb der polyeder.
      NDPOI=0
      NTRY=26
      ISPOI=1
      GO TO 80
   60 INC=IPST(ISPOI)
      NC=1
      ICDS(1)=IPST(ISPOI+2)
      CALL ZVDEK
      iz1=ianr
      DO  I=1,3
        X2(I)=X1(I)
      ENDDO
      NC=2
      TEMP=0.
      DO  IC=ISPOI+3,ISPOI+INC-1
        ICDS(2)=IPST(IC)
        CALL ZVDEK
        IZ2=IANR
        DQ=SQRT((X1(1)-X2(1))**2+(X1(2)-X2(2))**2+(X1(3)-X2(3))**2)
        TEMP=MAX(TEMP,DQ)
C
C               Hinterlege max. abstaende zwischen typen.
C
        DO  K=1,NDPOI
          IF ((NSTK(K) .EQ. IZ1) .AND. (MSTK(K) .EQ. IZ2) .OR.
     +      (NSTK(K) .EQ. IZ2) .AND. (MSTK(K) .EQ. IZ1)) THEN
            DSTK(K)=MAX(DSTK(K),DQ)
            GO TO 70
          ENDIF
        ENDDO
        IF (NDPOI .LT. NDDIM) THEN
          NDPOI=NDPOI+1
          DSTK(NDPOI)=DQ
          IF (IZ1 .LE. IZ2) THEN
            NSTK(NDPOI)=IZ1
            MSTK(NDPOI)=IZ2
          ELSE
            NSTK(NDPOI)=IZ2
            MSTK(NDPOI)=IZ1
          ENDIF
        ELSE
          WRITE (WRLINE,'(A)')
CYENG1
     +    'ZVPFND0273 - Stackueberlauf nstk/dstk.'
CYENG2
CYENGY     +    'ZVPFND0273 - Stack overflow nstk/dstk.'
          CALL KPWRTE (NTOUT )
          IERR=-1
          GO TO 999
        ENDIF
   70   CONTINUE
      ENDDO  ! IC
      PST(ISPOI+1)=TEMP
      ISPOI=ISPOI+INC
   80 IF (ISPOI .LT. IPSTP) GO TO 60
C
C                  Liste die gefundenen polyeder.
      NC=1
      NTRY=24
      I=0
      ISPOI=1
      GO TO 100
   90 INC=IPST(ISPOI)
      I=I+1
      WRITE (WRLINE,'(A,I4,A,F10.5,A)')
CYENG1
     +'Polyeder',I,' (Dmax=',PST(ISPOI+1),'):'
CYENG2
CYENGY     +'Polyhedron',I,' (Dmax=',PST(ISPOI+1),'):'
      CALL KPWRTE (NTOUT)
      DO  IC=ISPOI+2,ISPOI+INC-1
        ICDS(1)=IPST(IC)
        CALL ZVDEK
        WRITE (WRLINE,'(2A4,10X,3F10.6)') AT(5,IANR,NS),AT(6,IANR,NS),
     +  (X(J,1),J=1,3)
        CALL KPCDST (IRLINE,9,ICDS(1))
        CALL KPWRTE (NTOUT)
      ENDDO
      ISPOI=ISPOI+INC
  100 IF (ISPOI .LT. IPSTP) GO TO 90
C
C        Durchlaufe jetzt die polyeder und untersuche, ob sich
C        aehnliche darunter befinden.
C
CYENG1
      WRITE (WRLINE,'(A)') 'Vergleiche Polyeder'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'Comparing polyhedron'
      CALL KPWRTE (NTOUT )
      ISPOI=1
      GO TO 210
  110 INC=IPST(ISPOI)
      IP1=IPST(ISPOI+2)/200000
      NAM1=IAT(7,IP1,NS)
      IVPOI=ISPOI+INC
C                      Kopiere polyeder in codeliste und verschiebe
C                      so, dass das referenzatom in (0,0,0) liegt.
      IC=0
      NTRY=42
      DO  J=ISPOI+2,ISPOI+INC-1
        IC=IC+1
        ICD(IC,NS)=IPST(J)
        CALL ZVDEK
        IF (IC .EQ. 1) THEN
          DO  I=1,3
            V(I)=X1(I)
          ENDDO
        ENDIF
        DO  I=1,3
          ATOMS(I,IC,NS)=X1(I)-V(I)
        ENDDO
      ENDDO  ! J
      NCD(NS)=IC
      IPGZ=IC
      GO TO 190
  120 IP2=IPST(IVPOI+2)/200000
      NAM2=IAT(7,IP2,NS)
      INC2=IPST(IVPOI)
      WRITE (WRLINE,'(A,2A4,A,I4,A,2A4,A,I4,A)')
CYENG1
     +'um ',IAT(5,IP1,NS),IAT(6,IP1,NS),' (',IP1,') mit dem um ',
     +IAT(5,IP2,NS),IAT(6,IP2,NS),' (',IP2,'):'
CYENG2
CYENGY     +'around ',IAT(5,IP1,NS),IAT(6,IP1,NS),' (',IP1,
CYENGY     +') with that around ',
CYENGY     +IAT(5,IP2,NS),IAT(6,IP2,NS),' (',IP2,'):'
C      CALL KPWRTE (NTOUT)
      IRSN=0  ! Flag fuer den grund des scheiterns
C
      IHFLG=0
      IF (IPOPT(3) .GE. 1 .AND. NAM1 .NE. NAM2) THEN
        IRSN=1  ! Namenskonsizenz fuer zentralatom
        GO TO 170
      ENDIF
      IF (INC .NE. INC2) then
        IRSN=2 ! Anzahl der poyederatome stimmt nicht
        GO TO 170
      ENDIF
      IF (IPGZ .LT. 3) GO TO 200
C
C           Kopiere auch das vergleichspolyeder in die codeliste.
C
      IC=IPGZ
      NTRY=42
      DO  J=IVPOI+2,IVPOI+INC2-1
        IC=IC+1
        ICD(IC,NS)=IPST(J)
        CALL ZVDEK
        IF (IC .EQ. IPGZ+1) THEN
          DO  I=1,3
            V(I)=X1(I)
          ENDDO
        ENDIF
        DO  I=1,3
          ATOMS(I,IC,NS)=X1(I)-V(I)
        ENDDO
      ENDDO
      NCD(NS)=IC
C
C                 Lege handle an, falls noch nicht geschehen.
C
      IF (IHFLG .EQ. 0) THEN
C
C        Ermittele den winkel, der moeglichst nahe an 90 grad liegt.
C
        WMERK=180.
        ICDS(2)=ICD(1,NS)
        DO  ICP1=2,IPGZ-1
          ICDS(1)=ICD(ICP1,NS)
          DO  ICP2=ICP1+1,IPGZ
            ICDS(3)=ICD(ICP2,NS)
            ISKP(14)=1
            NTYP=5
            CALL ZVGE02
            TEMP=ABS(CONST(6)-90.)
            IF (TEMP .LT. WMERK) THEN
              WMERK=TEMP
              ICP1M=ICP1
              ICP2M=ICP2
            ENDIF
          ENDDO
        ENDDO
C                 Teste, ob das handle brauchbar ist.
C
        IF (WMERK .GT. AINBFR(2)) THEN
          CALL KPWRTE (NTOUT)
          WRITE (WRLINE,'(A)')
CYENG1
     +   'ZVPFND0418 - Kein brauchbares Handle gefunden.'
CYENG2
CYENGY     +   'ZVPFND0418 - No suitable handle found.'
          CALL KPWRTE (NTOUT)
          GO TO 200
        ENDIF
C
C           Handel ist: icd(1,ns), icd(icp1m,ns), icd(icp2m,ns)
C
C                  Konstruiere transponierte orthonormalmatrix.
        TEMP2=0.
        DO  I=1,3
          X1(I)=ATOMS(I,ICP2M,NS)-ATOMS(I,ICP1M,NS)
        ENDDO
        DO  I=1,3
          J=ID2(I)
          K=ID2(J)
          Y(3,I)=ATOMS(J,ICP1M,NS)*X1(K)-ATOMS(K,ICP1M,NS)*X1(J)
          TEMP2=TEMP2+Y(3,I)**2
        ENDDO
        TEMP2=SQRT(TEMP2)
        TEMP=SQRT(ATOMS(1,ICP1M,NS)**2+ATOMS(2,ICP1M,NS)**2+
     +  ATOMS(3,ICP1M,NS)**2)
        DO  I=1,3
          Y(1,I)=ATOMS(I,ICP1M,NS)/TEMP
          Y(3,I)=Y(3,I)/TEMP2
        ENDDO
        DO  I=1,3
          J=ID2(I)
          K=ID2(J)
          Y(2,I)=Y(3,J)*Y(1,K)-Y(3,K)*Y(1,J)
        ENDDO
      ENDIF
C               Durchlaufe jetzt die atome des vergleichspolyeders.
C
      DO  IV1=IPGZ+2,NCD(NS)
        DO  IV2=IPGZ+2,NCD(NS)
          IF (IV1 .EQ. IV2) GO TO 160
C
C                Konstruiere hier die orthonormalmatrix.
C
          TEMP2=0.
          DO  I=1,3
            X1(I)=ATOMS(I,IV2,NS)-ATOMS(I,IV1,NS)
          ENDDO
          DO  I=1,3
            J=ID2(I)
            K=ID2(J)
            B(I,3)=ATOMS(J,IV1,NS)*X1(K)-ATOMS(K,IV1,NS)*X1(J)
            TEMP2=TEMP2+B(I,3)**2
          ENDDO
          IF (TEMP2 .LT. 1.E-4) GO TO 150
          TEMP2=SQRT(TEMP2)
          TEMP=SQRT(ATOMS(1,IV1,NS)**2+ATOMS(2,IV1,NS)**2+
     +    ATOMS(3,IV1,NS)**2)
          DO  I=1,3
            B(I,1)=ATOMS(I,IV1,NS)/TEMP
            B(I,3)=B(I,3)/TEMP2
          ENDDO
          DO  I=1,3
            J=ID2(I)
            K=ID2(J)
            B(I,2)=B(J,3)*B(K,1)-B(K,3)*B(J,1)
          ENDDO
C                           Bilde A=B*Y
          IDURCH=0
  130     DO  I=1,3
            DO  J=1,3
              A(I,J)=B(I,1)*Y(1,J)+B(I,2)*Y(2,J)+B(I,3)*Y(3,J)
            ENDDO
          ENDDO
C
C      Teste jetzt, ob diese matrix das polyeder korrekt abbildet.
C
          IF (IPGZ .GT. 20) THEN
            CALL KPWRTE (NTOUT)
CYENG1
            WRITE (WRLINE,'(A)') 'ZVPFND0495 - Polyeder zu gross.'
CYENG2
CYENGY            WRITE (WRLINE,'(A)') 'ZVPFND0495 - Polyhedron too big.'
            CALL KPWRTE (NTOUT)
            IERR=-1
            GO TO 999
          ENDIF
          DO  I=1,IPGZ
            IPZG(I)=0
          ENDDO
          IPZG(1)=IPGZ+1
          DO  IC=2,IPGZ
            DO  I=1,3
              X1(I)=A(I,1)*ATOMS(1,IC,NS)+A(I,2)*ATOMS(2,IC,NS)+
     +        A(I,3)*ATOMS(3,IC,NS)
            ENDDO
            DO  K=IPGZ+2,NCD(NS)
              TEMP=SQRT((ATOMS(1,K,NS)-X1(1))**2+
     +        (ATOMS(2,K,NS)-X1(2))**2+(ATOMS(3,K,NS)-X1(3))**2)
              IF (TEMP .LT. AINBFR(1)) THEN
C
C            Teste, ob auch noch die namen stimmen muessen.
C
                IF ((IPOPT(3) .LT. 2) .OR.
     +            ((IAT(7,ICD(IC,NS)/200000,NS) .EQ.
     +            IAT(7,ICD(K,NS)/200000,NS)))) THEN
                  IPZG(IC)=K
                  GO TO 140
                ENDIF
              ENDIF
            ENDDO
C                          Passt nicht.
            GO TO 150
  140       CONTINUE
          ENDDO  ! IC
          IF (IDURCH .EQ. 0) THEN
CYENG1
            WRITE (WRLINE(48:48),'(A)') '+'
CYENG2
CYENGY            WRITE (WRLINE(58:58),'(A)') '+'
          ELSE
CYENG1
            WRITE (WRLINE(48:48),'(A)') '*'
CYENG2
CYENGY            WRITE (WRLINE(58:58),'(A)') '*'
          ENDIF
          CALL KPWRTE (NTOUT)
          GO TO 180
  150     CONTINUE
C
C         Teste, ob auch die inverse variante geprueft werden soll.
C
          IF (IPOPT(2) .NE. 0) THEN
            DO  I=1,3
              Y(3,I)=-Y(3,I)
            ENDDO
            IF (IDURCH .EQ. 0) THEN
              IDURCH=1
              GO TO 130
            ENDIF
          ENDIF
  160     CONTINUE
        ENDDO  ! IV2
      ENDDO  ! IV1
      IRSN=3 ! Geometrie oder / namen des Polyeders passen nicht.
  170 CONTINUE
CYENG1
      WRITE (WRLINE(48:50),'(A,I2)') '-',IRSN
CYENG2
CYENGY      WRITE (WRLINE(58:60),'(A,I2)') '-',IRSN
      CALL KPWRTE (NTOUT)
  180 IVPOI=IVPOI+INC2
  190 IF (IVPOI .LT. IPSTP) GO TO 120
  200 ISPOI=ISPOI+INC
  210 IF (ISPOI .LT. IPSTP) GO TO 110
C
C              Untersuche polyederverknuepfungen.
C
CYENG1
      WRITE (WRLINE,'(A)') 'Verknuepfungen:'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'Linking:'
      CALL KPWRTE (NTOUT )
      ISPOI=1
      GO TO 320
  220 INC=IPST(ISPOI)
C                      Kopiere polyeder in codeliste.
      ICM=0
      DO  I=ISPOI+2,ISPOI+INC-1
        ICM=ICM+1
        ICD(ICM,NS)=IPST(I)
      ENDDO
      NCD(NS)=ICM
      K8(NS)=0
      K9(NS)=0
      WRITE (WRLINE,'(A,11X,A)')
CYENG1
     +'Polyeder um','ist verknuepft mit Polyeder'
CYENG2
CYENGY     +'Polyhedron around','is linked to polyhedron'
CYENG1
      CALL KPCDST(IRLINE,12,IPST(ISPOI+2))
CYENG2
CYENGY      CALL KPCDST(IRLINE,18,IPST(ISPOI+2))
      CALL KPWRTE (NTOUT )
C
C                   Durchlaufe die ligandenatome ...
      DO  LGA=2,ICM
        IP1=ICD(LGA,NS)/200000
C
C  ... und suche geeignetes atom, was daran haengen koennte.
C
        IVPOI=1
        GO TO 260
  230   INC2=IPST(IVPOI)
        IP2=IPST(IVPOI+2)/200000
        IF (IP1 .EQ. IP2) THEN
C
C             Nimm auf, falls noch nicht vorhanden.
C
          DO  I=IVPOI+3,IVPOI+INC2-1
            J=IPST(I)/200000
            ICDS(1)=ICD(LGA,NS)
            K=ICDS(1)/200000
            IZ1=J
            IZ2=J
            DO  N=1,NDPOI
              IF ((J .EQ. NSTK(N) .AND. K .EQ. MSTK(N)) .OR.
     +          (K .EQ. NSTK(N) .AND. J .EQ. MSTK(N))) THEN
                DQ=DSTK(N)*1.001
                GO TO 240
              ENDIF
            ENDDO
            WRITE (WRLINE,'(A,2I4,A)')
CYENG1
     +      'ZVPFND0630 - Kombination',j,k,' nicht gefunden.'
CYENG2
CYENGY     +      'ZVPFND0630 - Combination',j,k,' not found.'
            CALL KPWRTE (NTOUT )
            IERR=-1
            GO TO 999
  240       CONST(20)=0.
            NTYP=3
            ISKP(14)=1
C                         'AKS',iz1,iz2,dq
            CALL ZVAVBR
            IF (IERR .NE. 0) GO TO 999
          enddo
        endif
  250   IVPOI=IVPOI+INC2
  260   IF (IVPOI .LT. IPSTP) GO TO 230
      ENDDO  ! LGA
C                       Sortiere die liste.
C
      DO  J=ICM+2,NCD(NS)
        K=ICD(J,NS)
        DO  I=J-1,ICM+1,-1
          IF (ICD(I,NS) .LE. K) GO TO 270
          ICD(I+1,NS)=ICD(I,NS)
        ENDDO
        I=ICM
  270   ICD(I+1,NS)=K
      ENDDO
C                 Untersuche jetzt, wie viele nachbarn
C                 die dazugefundenen atome haben.
      IZALT=0
      NTRY=26
      DO  J=0,3
        ICNT(J)=0
      ENDDO
      DO  IC=ICM+1,NCD(NS)
        ICDS(1)=ICD(IC,NS)
        NC=1
        CALL ZVDEK
        DO  J=1,3
          X2(J)=X1(J)
        ENDDO
        IZ1=IANR
        IF (IANR .NE. IZALT) THEN
           IF (IZALT .NE. 0) THEN
             WRITE (WRLINE,280) IZALT,(ICNT(I),I=1,3)
CYENG1
  280        FORMAT ('um Atom',i4,
     +       ', und zwar (Ecke/Kante/Flaeche):',3i4,' mal.')
CYENG2
CYENGY  280        FORMAT ('around atom',i4,
CYENGY     +       ', in fact (vertex/edge/face):',3i4,' times.')
             CALL KPWRTE (NTOUT )
           ENDIF
           IZALT=IANR
           DO  J=0,3
             ICNT(J)=0
           ENDDO
        ENDIF
        NC=2
        N=0
        DO  J=2,ICM
          ICDS(2)=ICD(J,NS)
          CALL ZVDEK
          IZ2=IANR
          DO  K=1,NDPOI
            IF ((NSTK(K) .EQ. IZ1 .AND. MSTK(K) .EQ. IZ2) .OR.
     +          (NSTK(K) .EQ. IZ2 .AND. MSTK(K) .EQ. IZ1)) THEN
              DQ=DSTK(K)*1.0001
              GO TO 290
            ENDIF
          ENDDO
C                   Ein nicht vorhandenes paar kann ignoriert werden.
          GO TO 300
  290     TEMP=SQRT((X1(1)-X2(1))**2+(X1(2)-X2(2))**2+(X1(3)-X2(3))**2)
          IF (TEMP .LE. DQ) N=N+1
  300     CONTINUE
        ENDDO
        IF (N .GT. 3) N=3
        ICNT(N)=ICNT(N)+1
      ENDDO
      WRITE (WRLINE,280) IZ1,(ICNT(I),I=1,3)
      CALL KPWRTE (NTOUT )
      IZALT=0
  310 ISPOI=ISPOI+INC
  320 IF (ISPOI .LT. IPSTP) GO TO 220
C
  999 RETURN
      END
