C         81              -------------------
                           SUBROUTINE ZVSFND
C   CY-ENG-               -------------------
C
C  Sucht symmetrien des gitters und idealisiert gitterkonstanten.
C
C                 geschrieben: 301137 NOV 1997 (Hundt)
C                   geaendert: 032100 JUL 2015 (Hundt)
C
C                         -------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),I,J,JU,K,L,M,KDR,NATS,I1,I2,I3,IROT,ITEST
      INTEGER *4 IRC,NATSAV,IZVFLG,ITEMP,ISCHL,KK,ISYMFL,ISKP79
      INTEGER *4 INBFR(8),NSYMSV,IAT(8,PARDIM,2),IATAB(2,6),KEYIN
      INTEGER *4 IPSLST(145),NTYPS,IAL(6)
      REAL    *4 AINBFR(8),GRAD,URSAV(3),SINV(3,3),SINVL(9),TEMP
C
      SAVE AINBFR,IAL
C
      EQUIVALENCE (AIN(1),IAIN(1)),(AINBFR(1),INBFR(1))
      EQUIVALENCE (AT(1,1,1),IAT(1,1,1)),(SINV(1,1),SINVL(1))
C
      DATA KDR/4HR   /,IATAB/-2,0, 2,1, 3,0, 4,2, 3,2, 6,5/
      DATA IAL/6*0/
      DATA (IPSLST(I),I=1,145)/556,565,655,546,566,644,645,646,654,656,
     1 664,665,666,534,536,543,547,633,634,635,636,637,643,647,653,657,
     2 663,667,673,674,675,676,677,734,736,743,744,745,746,747,754,756,
     3 763,764,765,766,767,774,776,523,524,526,527,532,538,542,548,622,
     4 623,624,625,626,627,628,632,638,642,648,652,658,662,668,672,678,
     5 682,683,684,685,686,687,688,722,723,724,725,726,727,728,732,738,
     6 742,748,752,758,762,768,772,778,782,783,784,785,786,787,788,823,
     7 824,826,827,832,833,834,835,836,837,838,842,843,844,845,846,847,
     8 848,853,854,856,857,862,863,864,865,866,867,868,872,873,874,875,
     9 876,877,878,883,884,886,887/
C
      DO  I=1,3
        URSAV(I)=AT(I,1,NS)
      ENDDO
      NTYPS=NTYP
      IF (NTYPS .EQ. 4) THEN
        AINBFR(4)=0.1
        AINBFR(5)=0.25
        AINBFR(6)=0.25
        INBFR(8)=1
        INBFR(7)=4
        ISYPOI=0
        IZEPOI=0
        ISKP(87)=INBFR(5)
        GO TO 999
      ENDIF
      IF (NTYPS .EQ. 5) THEN
        DO  I=1,3
          AINBFR(I+3)=AIN(I)
          IAL(I)=0
          IAL(I+3)=0
        ENDDO
        GO TO 999
      ENDIF
C                            Generiere punkte, sofern keine vorhanden.
      NATSAV=NAT(NS)
      IF (NAT(NS) .LT. 2) NAT(NS)=2
      NSYMSV=NSYM(NS)
      IF (NSYM(NS) .LT. 1) NSYM(NS)=1
      NATS=NAT(NS)
      GO TO (10,190,990),NTYPS
C                            SFND - Finde symmetrien.
   10 ISKP79=ISKP(79)
      IF (ISKP(14) .NE. 0) THEN
        DO  I=1,8
          INBFR(I)=IAIN(I)
        ENDDO
        GO TO 20
      ENDIF
      INBFR(1)=ISKP(53)
      INBFR(2)=NAT(NS)
      INBFR(3)=0
      CALL FLES (INBFR,ISKP(31),8H2IA3F2IE,
CYENG1
     + 35Hvon,bis,ref,tolg,tols,tolt,n,opt? $)
CYENG2
CYENGY     + 35Hfrom,to,ref,tolg,tols,tolt,n,opt? $)
   20 IF (INBFR(1) .LE. 0 .OR. INBFR(2) .GT. NAT(NS) .OR.
     +  INBFR(1) .GT. INBFR(2)) THEN
        IERR=81 0088 16
        GO TO 990
      ENDIF
      ISKP(87)=INBFR(5)
      CONST(45)=AINBFR(4)
      IF (INBFR(3) .EQ. 0) THEN
        IAIN(1)=INBFR(1)
        IAIN(2)=INBFR(2)
        NTYP=4
        CALL ZVZLIN
        AINBFR(3)=AIN(1)
      ENDIF
      ISKP(16)=INBFR(3)
      CALL CNVTUP (INBFR(3),1,4)
      WRITE (WRLINE,'(A,F7.4,A,F7.4,A,F7.4,A,A4)') 'Tols:',AINBFR(5),
     +' Tolt:',AINBFR(6),' Tolg:',AINBFR(4),' Ref: ',INBFR(3)
      CALL KPWRTE (NTOUT)
      IF (ABS(AT(1,2,NS))+ABS(AT(2,2,NS))+ABS(AT(3,2,NS)) .NE. 0.) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVSFND0108 - Koordinaten von Atom 2 nicht (0,0,0).'
CYENG2
CYENGY     +  'ZVSFND0108 - Coordinates of atom 2 not (0,0,0).'
        CALL KPWRTE (NTOUT)
        IERR=-1
        GO TO 990
      ENDIF
C                            Teste, ob genug platz da ist.
C
      IF (NAT(NS)+3 .GT. NATDM) THEN
        IERR=81 0118 02
        GO TO 990
      ENDIF
      ISYPOI=0
C                            Unterdruecke meldung: Code ueberlauf.
      ISKP(66)=1
C                            Benutze nur zentrierende symmetrien.
      NAT(NS)=NATS+3
      NTYP=4
      CALL ZVTSZR
      IF (IERR .NE. 0) GO TO 990
      ISYMFL=1
C                            Durchlaufe ggf. achsen.
      IZVFLG=0
      IF (ISKP79 .LT. 4) GO TO 70
      ISKP79=ISKP79-4
      DO  KK=1,145
        ISCHL=IPSLST(KK)
        IF (KEYIN(0) .EQ. ISKP(20)) THEN
          IERR=-1
          GO TO 990
        ENDIF
C                            Falls slabs untersucht werden
C
        JU=6
        IF (ISKP(95) .NE. 0) THEN
          IF (ISCHL .EQ. 556) GO TO 30
          IF (MOD(ISCHL,10) .EQ. 5) THEN
            JU=2
          ELSE
            GO TO 50
          ENDIF
        ENDIF
   30   CONTINUE
C                        Durchlaufe zaehligkeiten.
        DO  J=JU,2,-1
          IF (J .EQ. 5) GO TO 40
C
C                        Generiere drei punkte.
          NAT(NS)=NATS
          DO  K=1,3
            NAT(NS)=NAT(NS)+1
            DO  L=1,3
              AT(L,NAT(NS),NS)=0.
            ENDDO
            AT(K,NAT(NS),NS)=1.
          ENDDO
C                        Drehe diese punkte um den vektor v, der
C                        durch i1, i2 und i3 beschrieben wird.
C
          GRAD=360./FLOAT(J)
          DO  IROT=1,J-1
            IAIN(6)=NATS+1
            IAIN(7)=NAT(NS)
            IAIN(8)=2
            IAIN(9)=400001+ISCHL*200
            AIN(10)=GRAD
            IAIN(11)=KDR
            ISKP(14)=-1
            NTYP=18
            CALL ZVGE01
            IF (IERR .NE. 0) GO TO 990
C
C                     Setze jetzt fuer die drei punkte ein AKS auf
            L=0
            DO  ITEST=1,3
              NCD(NS)=0
              K8(NS)=0
              K9(NS)=0
              ICDS(1)=ITEST+NATS
              IZ1=2
              IZ2=2
              DQ=ZELLE(ITEST,NS)*AINBFR(4)
              ISKP(14)=-1
              NTYP=3
              CONST(20)=0.
              CALL ZVAVBR
              IF (IERR .NE. 0) GO TO 990
              IF (NCD(NS) .LE. 0) GO TO 40
              ITEMP=MOD(ICD(1,NS),10)
              IF (ITEMP .GT. 1) L=1
            ENDDO
          ENDDO
C                        Loesung gefunden.
C
          IF (ISYPOI .LT. ISYGDM) THEN
            ISYPOI=ISYPOI+1
            IDIRSV(ISYPOI)=ISCHL
            IROTSV(ISYPOI)=J
            IF (L .NE. 0) IZVFLG=1
          ENDIF
          GO TO 50
   40     CONTINUE
        ENDDO
   50   CONTINUE
      ENDDO
C                            Sortiere den stack
      DO  I=2,ISYPOI
        I1=IDIRSV(I)
        I2=IROTSV(I)
        DO  J=I-1,1,-1
          IF (I2 .GT. IROTSV(J)) THEN
            IROTSV(J+1)=IROTSV(J)
            IDIRSV(J+1)=IDIRSV(J)
          ELSE
            GO TO 60
          ENDIF
        ENDDO
   60   IROTSV(J+1)=I2
        IDIRSV(J+1)=I1
      ENDDO
C
      DO  I=1,ISYPOI
        IROTGT(I)=IROTSV(I)
C       IF (ISKP(58) .GT. 0) THEN
CYENG1
        WRITE (WRLINE,'(I1,A,I4,A)') IROTSV(I),'-Achse [',IDIRSV(I),' ]'
CYENG2
CYENGY        WRITE (WRLINE,'(I1,A,I4,A)')
CYENGY     +  IROTSV(I),'-Axis [',IDIRSV(I),' ]'
        CALL KPWRTE (NTOUT)
C       ENDIF
      ENDDO
      IF (IZVFLG .NE. 0) THEN
        IF (ISKP(58) .GT. 0) THEN
          WRITE (WRLINE,'(A)')
CYENG1
     +    'Es wurden Zentrierungspunkte mitverwendet.'
CYENG2
CYENGY     +    'Centering points also used.'
          CALL KPWRTE (NTOUT)
          WRITE (WRLINE,'(A)')
CYENG1
     +    'Moeglicherweise muss die Zelle reduziert werden.'
CYENG2
CYENGY     +    'Unit cell may have to be reduced.'
          CALL KPWRTE (NTOUT)
        ENDIF
      ENDIF
C                            Restore symmetrien.
   70 NTYP=5
      CALL ZVTSZR
      ISYMFL=0
      NAT(NS)=NATSAV
      NSYM(NS)=NSYMSV
      IF (NAT(NS) .LT. ISKP(53) .OR. NSYM(NS) .LE. 0) GO TO 990
C
C                            Suche das erste auftreten des ref-atoms.
      DO  I=INBFR(1),INBFR(2)
        IF (IAT(7,I,NS) .EQ. INBFR(3)) GO TO 80
      ENDDO
CYENG1
      WRITE (WRLINE,'(A)') 'ZVSFND0270 - Kein Ref-Atom gefunden.'
CYENG2
CYENGY      WRITE (WRLINE,'(A)') 'ZVSFND0270 - No Ref-atom found.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 990
C                            Setze ORGN um, und zwar so, dass ein
C                            referenzatom die koordinaten (0,0,0)
C                            bekommt, ...
   80 DO  J=1,3
        TEMP=AT(J,I,NS)+0.5
        GO TO 100
   90   TEMP=TEMP+1.
  100   IF (TEMP .LT. 0.) GO TO 90
        GO TO 120
  110   TEMP=TEMP-1.
  120   IF (TEMP .GE. 1.) GO TO 110
        AT(J,1,NS)=TEMP
      ENDDO
C                            ... bestimme z neu, falls ein
C                            slab untersucht wird ...
C
      IF (ISKP(95) .NE. 0) THEN
        IAIN(1)=INBFR(1)
        IAIN(2)=INBFR(2)
        NTYP=3
        CALL ZVZLIN
        IF (IERR .NE. 0) GO TO 999
        NC=1
        NTRY=40
        TEMP=0.
        DO  IC=1,NCD(NS)
          CALL ZVDEK
          TEMP=TEMP+X(3,1)
        ENDDO
        AT(3,1,NS)=TEMP/FLOAT(NCD(NS))
      ENDIF
C                            ... und setze ein ATB auf.
      IAIN(1)=1
      IAIN(2)=INBFR(1)
      IAIN(3)=INBFR(2)
      DO  I=4,6
        AIN(I)=0.5001
      ENDDO
      NCD(NS)=0
      K8(NS)=0
      K9(NS)=0
      NTYP=1
      ISKP(14)=1
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 990
C
C                            Erzeuge optional RGS file.
      ISKP(65)=INBFR(8)
      IF (ISKP(65) .NE. 0) THEN
        NTYP=NTPCH
        ISKP(75)=1
        CALL ZVEAEH
        IF (IERR .NE. 0) GO TO 990
        WRITE (WRLINE,'(A,3F10.5,3F10.3)') 'Z',(ZELLE(I,NS),I=1,6)
        CALL KPWRTE (NTPCH)
      ENDIF
C                            Durchlaufe jetzt die gefundenen
C                            richtungen und suche symmetrien.
      DO  I=1,ISYPOI
        M=IROTSV(I)
  130   J=IATAB(1,M)
C                            Teste, ob die richtung erlaubt ist.
        IRC=0
        CALL ZVTEAC (J,IDIRSV(I),IRC)
        IF (IRC .EQ. 0) GO TO 140
        IRC=INBFR(3)
        AIN(1)=AINBFR(5)
        CALL ZVAFND (J,I,IRC)
        IF (IERR .NE. 0) GO TO 990
  140   IROTSV(I)=IRC
        IF (IRC .EQ. 0) THEN
          IF (ABS(J) .EQ. 2) GO TO 150
C
C                          Falls nicht gefunden, nimm die
C                          naechst-niedere symmetrie.
          M=IATAB(2,M)
          IF (M .NE. 0) GO TO 130
        ENDIF
  150   CONTINUE
      ENDDO
C                            Teste zentren.
C
      IF (ISKP79 .LT. 2) GO TO 160
      ISKP79=ISKP79-2
      IF (ISKP(58) .GT. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'Suche Zentren.'
CYENG2
CYENGY     +  'Searching centers of symmetry.'
        CALL KPWRTE (NTDISP)
      ENDIF
      DO  I=1,3
        IAIN(I)=INBFR(I)
      ENDDO
      IAIN(4)=INBFR(5)
      AIN(5)=999
      NTYP=2
      L=NAT(NS)
      CALL ZVZNTR
      IZEPOI=0
      DO  I=L+1,NAT(NS)
        WRITE (WRLINE,'(2A2,3F10.5,A,F8.6,A)')
     +  AT(5,I,NS),AT(6,I,NS),(AT(J,I,NS),J=1,3),' (',AT(4,I,NS),')'
        CALL KPWRTE (NTOUT)
        IF (IZEPOI .LT. 4) THEN
          IZEPOI=IZEPOI+1
          DO  J=1,3
            ZENSV(J,IZEPOI)=AT(J,I,NS)
          ENDDO
        ENDIF
        IF (ISKP(65) .NE. 0) THEN
          WRITE (WRLINE,'(A,3F10.5)')'ST -1 * 0 0 0 ',(AT(J,I,NS),J=1,3)
          CALL KPWRTE (NTPCH)
        ENDIF
      ENDDO
      NAT(NS)=L
      IF (IERR .NE. 0) GO TO 990
C
C                            Teste translationssymmetrie.
C
  160 IF (ISKP79 .LT. 1) GO TO 170
      L=NAT(NS)
      IF (ISKP(58) .GT. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'Suche Translationssymmetrie.'
CYENG2
CYENGY     +  'Searching translation symmetry.'
        CALL KPWRTE (NTDISP)
      ENDIF
      DO  I=1,3
        IAIN(I)=INBFR(I)
      ENDDO
      AIN(4)=AINBFR(6)
      IAIN(5)=INBFR(7)
      NTYP=2
      CALL ZVTSZR
      M=0
      DO  I=L+1,NAT(NS)
        WRITE (WRLINE,'(2A2,3F10.5,A,F8.6,A)')
     +  AT(5,I,NS),AT(6,I,NS),(AT(J,I,NS),J=1,3),' (',AT(4,I,NS),')'
        K=0
        DO  J=1,3
          IF (AT(J,I,NS) .EQ. 0.) K=K+1
        ENDDO
        IF (K .EQ. 2) THEN
          WRLINE(48:48)='*'
          M=1
        ENDIF
        CALL KPWRTE (NTOUT)
        IF (ISKP(65) .NE. 0) THEN
          WRITE (WRLINE,'(A,3F10.5)') 'C ',(AT(J,I,NS),J=1,3)
          CALL KPWRTE (NTPCH)
        ENDIF
      ENDDO
      NAT(NS)=L
      IF (M .NE. 0) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  '*  Zellreduktion erforderlich.'
CYENG2
CYENGY     +  '*  Cell reduction mandatory.'
        CALL KPWRTE (NTOUT)
        IERR=-1
      ENDIF
C                            Schliesse den file.
C
  170 IF (ISKP(65) .NE. 0) THEN
        WRITE (WRLINE,'(A)') 'EOF'
        CALL KPWRTE (NTPCH)
        NTYP=NTPCH+100
        CALL ZVEAEH
      ENDIF
C                            Teste, ob bei den achsen eine 3 vorkommt.
      DO  I=1,ISYPOI
        IF (IROTSV(I) .NE. 0) THEN
          J=IDIRSV(I)
          I1=J/100-5
          I2=MOD(J/10,10)-5
          I3=MOD(J,10)-5
          IF (ABS(I1) .EQ. 3 .OR. ABS(I2) .EQ. 3 .OR.
     +      ABS(I3) .EQ. 3) THEN
CYENG1
            WRITE (WRLINE,'(A,A)') 'Zelle extrem verzerrt.',
     +      ' Sie muss zuerst transformiert werden.'
CYENG2
CYENGY            WRITE (WRLINE,'(A,A)') 'Cell extremely distorted.',
CYENGY     +      ' A transformation is necessary.'
            CALL KPWRTE (NTOUT)
            GO TO 180
          ENDIF
        ENDIF
      ENDDO
C                            Vergleiche mit dem vorherigen ergebnis.
  180 ISKP(78)=1
      M=0
      DO  J=6,2,-1
        IF (J .NE. 5) THEN
          K=0
          DO  I=1,ISYPOI
            IF (ABS(IROTSV(I)) .EQ. J) THEN
              K=K+1
              M=1
            ENDIF
          ENDDO
          IF (K .NE. IAL(J)) THEN
            IF (ISKP(78) .EQ. 1) THEN
              IF (K .LT. IAL(J)) THEN
                ISKP(78)=-1
              ELSE
                ISKP(78)=J
              ENDIF
            ENDIF
            IAL(J)=K
          ENDIF
        ENDIF
      ENDDO
C                            Hinterlege das ergebnis:
C                            -1 weniger als vorher
C                             0 ueberhaupt nichts
C                             1 gleich geblieben
C                            >1 mehr gefunden
C
      IF (M .EQ. 0) ISKP(78)=0
      GO TO 990
C                            SDEL - Delete symmetrie(n)
C
  190 CALL FLES (IAIN,ISKP(31),4H72IE,12Hs1,...,sn? $)
      DO  I=1,ISKP(31)
        DO  J=1,ISYPOI
          IF (IDIRSV(J) .EQ. IAIN(I)) THEN
            IROTSV(J)=0
            GO TO 200
          ENDIF
        ENDDO
        WRITE (WRLINE,'(A,I4,A)')
CYENG1
     +  'ZVSFND0513 -',IAIN(I),' nicht gefunden.'
CYENG2
CYENGY     +  'ZVSFND0513 -',IAIN(I),' not found.'
        CALL KPWRTE (NTDISP)
  200   CONTINUE
      ENDDO
C                            Reset ggf. koordinatensystem.
  990 IF (NTYPS .NE. 2) THEN
        ISKP(14)=1
        NTYP=3
        CALL ZVZ
      ENDIF
      IF (ISYMFL .NE. 0) THEN
        NTYP=5
        CALL ZVTSZR
      ENDIF
      NSYM(NS)=NSYMSV
      NAT(NS)=NATS
      ISKP(66)=0
      ISKP(14)=0
C
  999 DO  I=1,3
        AT(I,1,NS)=URSAV(I)
      ENDDO
      RETURN
      END
