C   67         -----------------------------------
                SUBROUTINE ZVSHFL (IPEDCB,IAKTFL)
C              -----------------------------------
C
C            Dies Programm schattiert Polyederflaechen.
C
C              geschrieben: 311232 Aug 1991  (Hundt)
C              geaendert:   121143 DEC 1999  (Hundt)
C
C              -----------------------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
C
      REAL    *4 PLVEKT(8,20),ORVEKT(3),TEMP,TEMP2,TEMP3,CW,CWM,DIST
      REAL    *4 SCHWEP(3),TMAT(3,3),TVEKT(3),DRWNKL
      REAL    *4 ROT(3,3),PLTBFR(2)
C
      INTEGER *4 IPEDCB(*),IAKTFL,NZ,I,I1,I2,J,K
      INTEGER *4 MERK,IDIST,IRVEKT(3)
      INTEGER *4 IDRWNK,IDRTMS,IDRSTR,IDRAKT,JSTART
      INTEGER *2 IWRK(6*ATODIM)
C
      EQUIVALENCE (ORVEKT(1),IRVEKT(1)),(DIST,IDIST)
      EQUIVALENCE (AT(1,1,1),IWRK(1)),(DRWNKL,IDRWNK)
C
C                       Baue Liste auf. Ermittle dabei den Vektor,
C                       der den groessten Winkel mit ORVEKT bildet.
      IDIST=IPEDCB(7)
      IF (DIST .LE. 0.) THEN
        IERR=67 0032 16
        GO TO 999
      ENDIF
C
      IDRWNK=IPEDCB(11)
      IDRTMS=IPEDCB(12)
      IDRSTR=IPEDCB(13)
      DO  I=1,3
        IRVEKT(I)=IPEDCB(I+13)
        SCHWEP(I)=0.
      ENDDO
      NZ=IWRK(IAKTFL)-3
      DO  J=1,NZ
        I1=IWRK(IAKTFL+J+2)
        DO  I=1,3
          TEMP=ATOMS(I,I1,NS)
          PLVEKT(I,J)=TEMP
          SCHWEP(I)=SCHWEP(I)+TEMP
        ENDDO
      ENDDO
      TEMP=NZ
      DO  I=1,3
        SCHWEP(I)=SCHWEP(I)/TEMP
      ENDDO
C
      CWM=1000.
      MERK=1
      DO  J=1,NZ
        I2=J+1
        IF (J .EQ. NZ) I2=1
        TEMP2=0.
        TEMP3=0.
        DO  K=1,3
          TEMP=PLVEKT(K,I2)-PLVEKT(K,J)
          TEMP2=TEMP2+TEMP*TEMP
          TEMP3=TEMP3+TEMP*ORVEKT(K)
        ENDDO
        PLVEKT(4,J)=TEMP2
        IF (TEMP2 .LE. 0.) GO TO 80
        CW=ABS(TEMP3/SQRT(TEMP2))
        IF (CW .GE. CWM) GO TO 80
        CWM=CW
        MERK=J
   80   CONTINUE
      ENDDO
C                       Baue Transformationsmatrix auf.
      I1=MERK+1
      IF (I1 .GT. NZ) I1=1
      TEMP=1./SQRT(PLVEKT(4,MERK))
      DO  I=1,3
        TMAT(1,I)=(PLVEKT(I,I1)-PLVEKT(I,MERK))*TEMP
        TVEKT(I)=PLVEKT(I,MERK)-SCHWEP(I)
      ENDDO
      TEMP2=0.
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        TEMP=TVEKT(J)*TMAT(1,K)-TVEKT(K)*TMAT(1,J)
        TMAT(3,I)=TEMP
        TEMP2=TEMP*TEMP+TEMP2
      ENDDO
      IF (TEMP2 .LE. 0.) THEN
        IERR=67 0094 09
        GO TO 999
      ENDIF
C
      TEMP2=1./SQRT(TEMP2)
      DO  I=1,3
        TMAT(3,I)=TMAT(3,I)*TEMP2
      ENDDO
      DO  I=1,3
        J=ID2(I)
        K=ID2(J)
        TMAT(2,I)=TMAT(3,J)*TMAT(1,K)-TMAT(3,K)*TMAT(1,J)
        TVEKT(I)=-PLVEKT(I,MERK)
      ENDDO
C                       Erzeuge lokale Koordinaten.
      IDRAKT=0
  150 IF (IDRAKT .LT. IDRSTR) GO TO 265
      X2(3)=1000.
      DO  I=1,NZ
        DO  J=1,3
          X1(J)=PLVEKT(J,I)+TVEKT(J)
        ENDDO
        DO  J=1,2
          X2(J)=TMAT(J,1)*X1(1)+TMAT(J,2)*X1(2)+TMAT(J,3)*X1(3)
        ENDDO
        PLVEKT(4,I)=X2(1)
        PLVEKT(5,I)=X2(2)
        IF (X2(2) .LE. X2(3)) THEN
          MERK=I
          X2(3)=X2(2)
        ENDIF
      ENDDO
      JSTART=X2(3)/DIST
      IF (JSTART .LT. 0) JSTART=JSTART-1
C
C                       Stelle Gradengleichungen auf.
      DO  I=1,NZ
        I1=I+1
        IF (I .EQ. NZ) I1=1
        PLVEKT(6,I)=PLVEKT(5,I1)-PLVEKT(5,I)
        PLVEKT(7,I)=-PLVEKT(4,I1)+PLVEKT(4,I)
        PLVEKT(8,I)=PLVEKT(6,I)*PLVEKT(4,I)+PLVEKT(7,I)*PLVEKT(5,I)
      ENDDO
C                       Setze Farbe.
      ISKP(42)=IPEDCB(3)
      CALL UPLINF(ISKP(42),10)
      CALL UPLINF(IPEDCB(4),11)
  200 CONTINUE
C                       Durchlaufe Gradenschar.
      J=JSTART
  210 J=J+1
      TEMP=FLOAT(J)*DIST
C                       Suche moegliche Grade.
      I1=0
      DO  I=1,NZ
        K=I+1
        IF (I .EQ. NZ) K=1
        IF (TEMP-PLVEKT(5,I)) 220,260,230
  220   IF (TEMP-PLVEKT(5,K)) 260,240,240
  230   IF (TEMP-PLVEKT(5,K)) 240,240,260
  240   IF (PLVEKT(6,I) .NE. 0.) THEN
          I1=I1+1
          X2(I1)=(PLVEKT(8,I)-PLVEKT(7,I)*TEMP)/PLVEKT(6,I)
          IF (I1 .GE. 2) GO TO 310
        ENDIF
  260   CONTINUE
      ENDDO
C                       Fertig. Noch eine Drehung?
C
  265 IF (IDRAKT .GE. IDRTMS) GO TO 999
      IDRAKT=IDRAKT+1
      IF (IDRAKT .NE. 1) GO TO 280
      DO  I=1,3
        DO  J=1,3
          ROT(I,J)=0.
        ENDDO
      ENDDO
      ROT(1,1)=COS(DRWNKL*CONST(3))
      ROT(2,2)=ROT(1,1)
      ROT(3,3)=1.
      ROT(1,2)=SIN(DRWNKL*CONST(3))
      ROT(2,1)=-ROT(1,2)
C
  280 DO  I=1,3
        DO  J=1,3
          S(I,J)=TMAT(I,J)
        ENDDO
      ENDDO
      DO  I=1,3
        DO  J=1,3
          TMAT(I,J)=ROT(I,1)*S(1,J)+ROT(I,2)*S(2,J)+ROT(I,3)*S(3,J)
        ENDDO
      ENDDO
      GO TO 150
C                       Plotte Linie.
  310 DO  I=1,3
        T(I)=TMAT(2,I)*TEMP-TVEKT(I)
      ENDDO
      DO  K=1,2
        DO  I=1,3
          X1(I)=TMAT(1,I)*X2(K)+T(I)
        ENDDO
        TEMP2=HOE/(HOE-X1(3))
        PLTBFR(1)=X1(1)*TEMP2*O9+CONST(11)
        PLTBFR(2)=X1(2)*TEMP2*O9+CONST(12)
        CALL UPLINF (PLTBFR,4-K)
      ENDDO
      GO TO 210
C
  999 RETURN
      END
