CZVSYDC   21             -------------------
                          SUBROUTINE ZVSYDC
C  CY-ENG-               -------------------
C
C     Das Programm decodieret symbolisch geschriebene Symmetrien.
C
C                        Fehlercodes
C                        -----------
C                    NR  Bedeutung
C                     1  x, y oder z fehlt
C                     3  Translation falsch codiert
C                     5  Nicht erlaubtes Zeichen
C                     6  Translation doppelt
C                     7  Vorzeichen illegal
C                     8  Vorzeichen mehrfach
C                     9  Symmetrie unvollstaendig
C                    10  Koeffizient nicht erlaubt
C
C                         geschrieben: Hundt
C                  geaendert: 071110 FEB 2000  (Hundt)
C
C                        -------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
      INTEGER *4 KARTE(20),KARPOI
      COMMON /KPFLIN/ KARTE,KARPOI
C
      INTEGER *4 IBUF(12),ITAB( 6),ITRANS(11),IFLG(4),IAIN(72)
      INTEGER *4 I,IGO,IH,IPKT,IRC,ITYP,IVORZ,IWDH,IZCH,IZFF
      INTEGER *4 J,K,KBUF,LENG,LINC,LPOI
      INTEGER *1 I1TAB(24),I1AIN(288),KARTE1(80)
C
      EQUIVALENCE (AIN(1),IAIN(1),I1AIN),(ITAB(1),I1TAB(1))
      EQUIVALENCE (KARTE(1),KARTE1(1))
C
      DATA ITAB/4H0123,4H4567,4H89,+,4H- ./,4HXYZx,4Hyz' /
      DATA ITRANS/112,16,14,13,512,12,712,23,34,56,1112/
C
C                            Hole Eingabe
C
      IF (ISKP(14) .NE. 0) GO TO 10
C
C                            Suche nach erlaubtem Zeichen
        DO  I=KARPOI+1,80
          DO  J=1,22
            IF (KARTE1(I) .EQ. I1TAB(J)) THEN
              IF (J .NE. 14) GO TO 1
              GO TO 4
            ENDIF
          ENDDO
          GO TO 9
    4     CONTINUE
        ENDDO
        GO TO 9
C                            Konvertiere ohne Apostroph
    1   KARPOI=I
        DO  J=1,18
          IAIN(J)=ISKP(24)
        ENDDO
        J=1
        DO  I=KARPOI,80
          DO  K=1,22
            IF (KARTE1(I) .EQ. I1TAB(K)) GO TO 2
          ENDDO
          GO TO 3
    2     I1AIN(J)=KARTE1(I)
          J=J+1
        ENDDO
        I=71
        J=71
    3   LENG=J+1
        KARPOI=I
        GO TO 11
    9   CONTINUE
CYENG1
      CALL FLES (IAIN,ISKP(31),4H18AE,11HSymmetrie?$)
CYENG2
CYENGY      CALL FLES (IAIN,ISKP(31),4H18AE,10HSymmetry?$)
C
   10 LENG=ISKP(31)*4+1
   11 IF (NSYM(NS) .GE. NSYMDM) THEN
        IERR=21001003
        GO TO 999
      ENDIF
C                            Loesche Puffer und Flags.
      DO  I=1,12
        IBUF(I)=0
      ENDDO
      NSYM(NS)=NSYM(NS)+1
      NHMSNR(1,NS)=ISKP(24)
      NHMSNR(2,NS)=ISKP(24)
      NHMSNR(3,NS)=0
      IH=I1TAB(14)
      IRC=0
      LINC=0
      IWDH=0
      LPOI=0
C
   40 DO  I=1,4
        IFLG(I)=0
      ENDDO
C
   60 ITYP=0
      IVORZ=0
      IZFF=0
      KBUF=0
      IPKT=0
C                            Hole Zeichen.
C
   70 IF (IWDH .EQ. 0) GO TO 80
      IWDH=0
      GO TO 110
C
   80 LPOI=LPOI+1
      IF (LPOI-LENG) 90,120,300
   90 IH=I1AIN(LPOI)
C
C                            Identifiziere Zeichen.
      DO  IZCH=1,22
        IF (IH .EQ. I1TAB(IZCH)) GO TO 110
      ENDDO
C                            Nicht gefunden, wenn hier.
      IRC=5
      GO TO 310
C                            Teste auf Ziffer.
C
  110 IF (IZCH .GT. 10) GO TO 130
C
C                            Setze Vorzeichen positiv, falls noch nicht
C                            gesetzt.
C
      IF (IVORZ .EQ. 0) IVORZ=1
      IZFF=1
      KBUF=KBUF*10+IZCH-1
      IPKT=IPKT*10
      GO TO 70
C                            Nicht Ziffer
  120 IZCH=11
  130 IGO=IZCH-10
      GO TO (140,240,240,70,330,260,280,280,280,270,270,270),IGO
C             ,   +   -  BL  .   /   X   Y   Z  KLX KLY KLZ
C
C                            Komma oder Ende
C
  140 IF (ITYP .NE. 0) GO TO 170
      IF (IVORZ .EQ. 0) GO TO 160
C
C                            x, y oder z fehlt
  150 IRC=1
      GO TO 310
C                            Erhoehe Segment.
C
  160 IF (IFLG(2)+IFLG(3)+IFLG(4) .LE. 0) GO TO 150
      LINC=LINC+4
      IF (LINC .LE. 8) GO TO 40
      GO TO 310
C                            Translation fertig.
C
  170 IF (IFLG(1) .EQ. 0) GO TO 190
C
C                            Translation doppelt.
  180 IRC=6
      GO TO 310
C
  190 IFLG(1)=1
C                            Teste Vorzeichen.
C
      IF (IVORZ .GT. 0) GO TO 200
      IRC=7
      GO TO 310
C
  200 IWDH=1
      IF (ITYP .GT. 0) GO TO 210
C
C                            Rechne um in Zwoelftel.
      ITYP=1
      I=(KBUF*12+IPKT/2)/IPKT
      GO TO 230
C                            Suche Translation in Tabelle.
  210 DO 220 I=1,11
      IF (KBUF .EQ. ITRANS(I)) GO TO 230
  220 CONTINUE
C                            Nicht gefunden.
      IRC=3
      GO TO 310
C                            Trage Translation ein.
  230 IBUF(LINC+1)=I
      GO TO 60
C                            Vorzeichen
C
  240 IF (IVORZ .EQ. 0) GO TO 250
      IF (ITYP .NE. 0) GO TO 170
C
C                            Mehrfach Vorzeichen
      IRC=8
C                            Setze Vorzeichen
  250 IVORZ=1
      IF (IGO .EQ. 3) IVORZ=-1
      GO TO 70
C                            Schraegstrich
  260 ITYP=1
      GO TO 70
C                            x, y oder z
  270 IGO=IGO-3
  280 IF (ITYP .NE. 0) GO TO 170
      ITYP=IGO-5
C                            Teste Flag
C
      IF (IFLG(ITYP) .NE. 0) GO TO 180
      IFLG(ITYP)=1
      IF (IVORZ .EQ. 0) IVORZ=1
      IF (IZFF .LE. 0) KBUF=1
C
      IBUF(LINC+ITYP)=KBUF*IVORZ
      GO TO 60
C                            Symmetrie unvollstaendig
  300 IRC=9
C
  310 IF (IRC .LE. 0) GO TO 340
      IF (ISKP(4) .EQ. 0) CALL FLES (IAIN,IAIN,1HK,2H?$)
      WRITE (WRLINE,320) IRC
      CALL KPWRTE (NTDISP)
CYENG1
  320 FORMAT ('ZVSYDC0320 - Symmetrie fehlerhaft. Code:',I2)
CYENG2
CYENGY  320 FORMAT ('ZVSYDC0320 - Error in symmetry. Code:',I2)
      NSYM(NS)=NSYM(NS)-1
      GO TO 999
C                            Punkt
  330 IPKT=1
      ITYP=-1
      IF (IVORZ .EQ. 0) IVORZ=1
      GO TO 70
C
  340 DO 350 I=1,12
  350 SYM(I,NSYM(NS),NS)=FLOAT(IBUF(I))
      SYM(1,NSYM(NS),NS)=SYM(1,NSYM(NS),NS)/12.
      SYM(5,NSYM(NS),NS)=SYM(5,NSYM(NS),NS)/12.
      SYM(9,NSYM(NS),NS)=SYM(9,NSYM(NS),NS)/12.
C
  999 RETURN
      END
