C         80              -------------------
                           SUBROUTINE ZVTFH2
C                         -------------------
C
C  Umwandlung der anisotropen auslenkungsparameter in eigenvektoren
C  und eigenwerte. (Urspruenglich ORTEP's PRELIM)
C
C                geschrieben: 240850 OCT 1997  (Hundt)
C                  geaendert: 201125 APR 2004  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'KPORC.INC'
C
      INTEGER *4 J,NG1,K,L,M,N
      REAL    *4 PAEQ(9),T1,T2,T6
      REAL    *4 T3,VMV
      EQUIVALENCE (PAEQ(1),PA(1,1))
C
      IF (ISKP(14) .NE. 0) THEN
        DO  J=1,7
          PAEQ(J)=AIN(J+2)
        ENDDO
        ISKP(14)=0
      ELSE
        CALL FLES (L,ISKP(31),2HIE,4HNR?$)
      ENDIF
C
C     ***** CONVERT TEMP FACTOR COEF TO STANDARD TYPE ZERO *****
C
      NG1=0
      T1=PAEQ(1)
      K=1.+PAEQ(7)
      IF (T1 .LE. 0.) THEN
        T1=.1
        GO TO 760
      ENDIF
      T6=.05066059
      GO TO (570,540,560,560,570,540,750,760,570,540,810),K
C              1   2   3   4   5   6   7   8   9  10  11
C
C     ***** TYPE 1 *****
C
  540 DO  J=4,6
        PAEQ(J)=PAEQ(J)*.5
      ENDDO
      GO TO 570
C
C     ***** TYPES 2 AND 3 (BASE 2 SYSTEMS) *****
C
  560 T6=.3511524
      IF (K .EQ. 4) GO TO 540
C
C     ***** TYPES 0 THROUGH 5 *****
C
  570 IF (PAEQ(2) .LT. 0.) GO TO 750
      DO  J=1,3
        DO  L=J,3
          T2=T6
          IF (K .LT. 5) GO TO 590
          IF (K .GT. 6) GO TO 580
C
C         ***** TYPES 4 AND 5 *****
C
          T2=RK(J,NS)*RK(L,NS)*T2*.25
          GO TO 590
C
C         ***** TYPES 8 AND 9 (U(I,J) TENSOR SYSTEMS) *****
C
  580     T2=RK(J,NS)*RK(L,NS)
  590     IF (J .EQ. L) THEN
            VT(J,J)=T2*PAEQ(J)
          ELSE
            M=J+L+1
            VT(J,L)=T2*PAEQ(M)
            VT(L,J)=VT(J,L)
          ENDIF
        ENDDO
      ENDDO
C
C     ***** FIND PRINCIPAL AXES *****
C
      CALL MM (VT,AA(1,1,NS),DA)
      CALL EIGENN (DA,RMS,PAT,NG)
C
C     ***** ARE EIGENVALUES POSITIVE *****
C
      IF (RMS(1) .LE. 0.) GO TO 620
      IF (NG) 670,720,630
  620 NG=3
  630 NG1=1
C
C     ***** 3 EQUAL EIGENVALUES, USE REFERENCE VECTORS *****
C
  640 T3=SIGN(SQRT(ABS(RMS(1)+RMS(2)+RMS(3))/3.),RMS(1))
      DO  J=1,3
        DO  K=1,3
          PA(J,K)=TRAINV(J,K,NS)
        ENDDO
        EV(J)=T3
      ENDDO
      GO TO 810
  670 IF (NG .LE.-6) GO TO 640
C
C     ***** TWO EQUAL EIGENVALUES *****
C
      N=NG+5
      CALL UNIT (PAT(1,N),V1,-1)
      DO  K=1,3
        IF (ABS(VMV(V1,AA(1,1,NS),TRAINV(1,K,NS))) .LT. .58) GO TO 690
      ENDDO
  690 CALL MM (AA(1,1,NS),DA,VT)
      CALL AXES (V1,TRAINV(1,K,NS),DA,-1)
      DO  K=1,3
        L= MOD(N+K-2,3)+1
        DO  J=1,3
          PA(J,L)=DA(J,K)
        ENDDO
        EV(L)=SIGN(SQRT(ABS(VMV(DA(1,K),VT,DA(1,K)))),RMS(L))
      ENDDO
      GO TO 810
C
C     ***** MAKE EIGENVECTORS 1 ANGSTROM LONG *****
C
  720 DO 730 J=1,3
  730 CALL UNIT (PAT(1,J),PA(1,J),-1)
      NG=0
C
C     ***** SQRT EIGENVALUE = RMS DISPLACEMENT *****
C
      DO 740 J=1,3
      T2=RMS(J)
  740 EV(J)=SIGN(SQRT(ABS(T2)),T2)
      GO TO 810
C
C     ***** TYPE 6 (ISOTROPIC TEMP FACTOR) *****
C
  750 T1=SQRT(T1*.0126651)
C
C     ***** TYPE 7 (DUMMY SPHERE) *****
C
  760 DO  J=1,3
        EV(J)=T1
      ENDDO
      IF (PA(3,1) .LE. 0.) GO TO 790
C
C     ***** DEFINED VECTORS FOR SPHERE *****
C
      NTRY=24
      DO  NC=1,4
        ICDS(NC)=PAEQ(NC+2)
        CALL ZVDEK
        IF (IERR .NE. 0) THEN
          CALL FLES (AIN,ISKP(31),1HK,2H?$)
          GO TO 790
        ENDIF
      ENDDO
      DO  J=1,3
        V1(J)=X(J,2)-X(J,1)
        V2(J)=X(J,4)-X(J,3)
      ENDDO
      CALL AXES (V1,V2,PA(1,1),-1)
      GO TO 810
C
C     ***** REFERENCE VECTORS FOR SPHERE *****
C
  790 DO  J=1,3
        DO  K=1,3
          PA(J,K)=RG(K,J,NS)
        ENDDO
      ENDDO
  810 NG=0
C
C     ***** WRITE OUT RMS VALUES *****
C
  850 CONTINUE
C     WRITE (NTOUT,'(A,3F10.5)') 'EIGENWERTE:',(EV(J),J=1,3)
  999 RETURN
      END
