C         97              -------------------
                           SUBROUTINE ZVZFND
C                         -------------------
C
C  Sucht in der struktur die kleinste subzelle und transformiert
C  auf diese.
C
C                  geschrieben: 261131 JUL 2005  (Hundt)
C                    geaendert: 181508 DEC 2006  (Hundt)
C
C                         ------------------
C
      IMPLICIT NONE
C
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'RDBFR.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAT(8,PARDIM,2),IAIN(72),IAIM(3),NATTL
      INTEGER *4 NTYPS,I,J,K,NA,NAP,NB,NBP,M,MA,MB,MC,NATSV
C
      REAL    *4 AIM(3),TEMP,TOL(3),SUM,TOLQ,Q(8)
C
      EQUIVALENCE (AIN(1),IAIN(1)),(AT(1,1,1),IAT(1,1,1))
      EQUIVALENCE (AIM(1),IAIM(1))
C
      NATSV=NAT(NS)
      NTYPS=NTYP
      GO TO (10,20),NTYPS
C             1  2
C
C                           ZFND - Subzelle finden
   10 AIM(1)=0.25
      IAIM(2)=3
      IAIM(3)=ISKP(24)
      CALL FLES (AIM,ISKP(31),4HFIAE,16Htol[A],opt,ref?$)
      GO TO 30
C
   20 DO  I=1,3
        IAIM(I)=IAIN(I)
      ENDDO
C
   30 IF (NSYM(NS) .NE. 1) THEN
        WRITE (WRLINE,'(A)')
CYENG1
     +  'ZVZFND46 - Struktur nicht triklin.'
CYENG2
CYENGY     +  'ZVZFND46 - Structure must be triclinic.'
        CALL KPWRTE (NTDISP)
        IERR=-1
        GO TO 999
      ENDIF
      IF (ISKP(53) .GT. NAT(NS)) THEN
        IERR=97 0054 16
        GO TO 999
      ENDIF
      DO  I=1,3
        TOL(I)=AIM(1)*RK(I,NS)
      ENDDO
      TOLQ=AIM(1)*AIM(1)
C
C              Bestimme die Referenzatomsorte, wenn keine angegeben.
C
      IF (IAIM(3) .EQ. ISKP(24) .OR. IAIM(3) .EQ. 0) THEN
        IAIN(1)=ISKP(53)
        IAIN(2)=NATSV
        NTYP=4
        CALL ZVZLIN
        IAIM(3)=IAIN(1)
      ENDIF
      ISKP(16)=IAIM(3)
      CALL CNVTUP (IAIM(3),1,4)
      WRITE (WRLINE,'(A,F8.5,A,I2,A,A4)')
     + 'Tol: ',AIM(1),' Opt:',IAIM(2),' Ref: ',IAIM(3)
      CALL KPWRTE (NTOUT)
C
C                Setze referenzatom auf (0,0,0) und normiere rest.
C
      DO  I=ISKP(53),NATSV
        IF (IAT(7,I,NS) .EQ. IAIM(3)) GO TO 40
      ENDDO
      WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVZFND83 - Referenzatom nicht gefunden.'
CYENG2
CYENGY     + 'ZVZFND83 - Reference atom not found.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 999
C
   40 DO  J=1,3
        T(J)=AT(J,I,NS)
      ENDDO
      DO  I=ISKP(53),NATSV
        DO  J=1,3
          TEMP=AT(J,I,NS)-T(J)
          GO TO 60
   50     TEMP=TEMP+1.
   60     IF (TEMP) 50,100,80
   70     TEMP=TEMP-1.
   80     IF (TEMP .GE. 1.) GO TO 70
   90     IF (TEMP .LT. 0.) TEMP=0.
  100     AT(J,I,NS)=TEMP
        ENDDO
      ENDDO
C
C   Fuelle codeliste mit den atomen und berechne kartesische koordinaten.
C
      NCD(NS)=0
      K8(NS)=0
      K9(NS)=0
C                            ATB um (0,0,0)
      IAIN(1)=2
      IAIN(2)=ISKP(53)
      IAIN(3)=NAT(NS)
      DO  I=4,6
        AIN(I)=1.
      ENDDO
      NTYP=1
      ISKP(14)=1
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 999
C
C                            Entferne die randatome.
      IC=0
      NC=1
      NTRY=42
      DO  J=1,NCD(NS)
        M=1
        DO  I=1,3
          IF (ABS(ATOMS(I,J,NS)) .GT. 0.999999) M=0
        ENDDO
        IF (M .NE. 0) THEN
          IC=IC+1
          ICD(IC,NS)=ICD(J,NS)
          CALL ZVDEK
          DO  I=1,3
            ATOMS(I,IC,NS)=X1(I)
          ENDDO
        ENDIF
      ENDDO
      NCD(NS)=IC
      K8(NS)=0
C                            Ergaenze die parameterliste fuer die suche.
      NATTL=NATSV
      DO  IC=ISKP(53),NATSV
        DO  I=-1,1
          T(1)=AT(1,IC,NS)+FLOAT(I)
          IF (T(1) .GE. -TOL(1) .AND. T(1) .LE. 1.+TOL(1)) THEN
            DO  J=-1,1
              T(2)=AT(2,IC,NS)+FLOAT(J)
              IF (T(2) .GE. -TOL(2) .AND. T(2) .LE. 1.+TOL(2)) THEN
                DO  K=-1,1
                  IF (ABS(I)+ABS(J)+ABS(K) .NE. 0) THEN
                    T(3)=AT(3,IC,NS)+FLOAT(K)
                    IF (T(3) .GE. -TOL(3) .AND. T(3) .LE. 1.+TOL(3))THEN
                      IF (NATTL .GE. NATDM) THEN
                        IERR=97 0158 02
                        GO TO 999
                      ENDIF
                      NATTL=NATTL+1
                      DO  M=1,3
                        AT(M,NATTL,NS)=T(M)
                      ENDDO
                      DO  M=4,8
                        AT(M,NATTL,NS)=AT(M,IC,NS)
                      ENDDO
                    ENDIF
                  ENDIF
                ENDDO
              ENDIF
            ENDDO
          ENDIF
        ENDDO
      ENDDO
      NAT(NS)=NATTL
C                            Baue speicher fuer vektoren auf.
C
      IF (NAT(NS)+2 .GE. NATDM) THEN
        IERR=97 0180 02
        GO TO 999
      ENDIF
      DO  I=1,3
        NAT(NS)=NAT(NS)+1
        DO  J=1,3
          AT(J,NAT(NS),NS)=0.
          AT(J+4,NAT(NS),NS)=DG(J,I,NS)
        ENDDO
        AT(I,NAT(NS),NS)=1.
        AT(4,NAT(NS),NS)=ZELLE(I,NS)
      ENDDO
C
C           Suche jetzt in der codeliste nach weiteren vektoren.
C
      DO  NA=1,NCD(NS)-1
        NAP=ICD(NA,NS)/200000
        IF (IAIM(3) .EQ. IAT(7,NAP,NS)) THEN
          DO  NB=NA+1,NCD(NS)
            NBP=ICD(NB,NS)/200000
            IF (IAIM(3) .EQ. IAT(7,NBP,NS)) THEN
C
C                            T ist kandidat.
              M=0
              DO  I=1,3
                TEMP=AT(I,NBP,NS)-AT(I,NAP,NS)
                T(I)=TEMP
                IF (TEMP .LT. TOL(I)) M=M+1
              ENDDO
C                            Vermeide Nullvektor
C
              IF (M .GE. 3) GO TO 210
C
C   Teste, ob T, angehaengt an alle atome, wieder auf ein gleiches trifft.
C
              DO  MA=ISKP(53),NATSV
                M=0
                DO  I=1,3
                  TEMP=AT(I,MA,NS)+T(I)
                  GO TO 120
  110             TEMP=TEMP+1.
  120             IF (TEMP) 110,160,140
  130             TEMP=TEMP-1.
  140             IF (TEMP .GE. 1.) GO TO 130
  150             IF (TEMP .LT. 0.) TEMP=0.
  160             X2(I)=TEMP
                ENDDO  ! NEXT I
C
C An der position X2 sollte sich ein atom namens IAT(7,MA,NS) befinden.
C
                DO  MB=ISKP(53),NATTL
C
C                            Stimmen der name und koordinaten?
                  DO  I=1,3
                    TEMP=X2(I)-AT(I,MB,NS)
                    IF (ABS(TEMP) .GT. TOL(I)) GO TO 170
                    X1(I)=TEMP
                  ENDDO
C
C          Rechne jetzt den abstand exakt aus und teste erneut.
C
                  SUM=0.
                  DO  I=1,3
                    SUM=SUM+DG(I,1,NS)*X1(1)+DG(I,2,NS)*X1(2)+
     +              DG(I,3,NS)*X1(3)
                  ENDDO
                  IF (SUM .GT. TOLQ) GO TO 170
                  M=M+1
C
C           Wenn die koordinaten uebereinstimmen, nicht aber die
C           namen, dann kommt dieser vektor nicht in frage.
C
                  IF (IAT(7,MA,NS) .NE. IAT(7,MB,NS)) GO TO 210
  170             CONTINUE
                ENDDO  ! NEXT MB
                IF (M .NE. 1) GO TO 210
  180           CONTINUE
              ENDDO  ! NEXT MA
C
C                     Teste, ob nicht schon vorhanden.
C
              DO  I=NATTL+1,NAT(NS)
                DO  J=1,3
                  IF (ABS(AT(J,I,NS)-T(J)) .GT. TOL(J)) GO TO 190
                ENDDO
                GO TO 210
  190           CONTINUE
              ENDDO
C
C       Berechne kartesische koordinaten und laenge und speichere.
C
  200         IF (NAT(NS) .GE. NATDM) THEN
                IERR=97 0169 02
                GO TO 999
              ENDIF
              NAT(NS)=NAT(NS)+1
              SUM=0.
              DO  I=1,3
                TEMP=DG(I,1,NS)*T(1)+DG(I,2,NS)*T(2)+DG(I,3,NS)*T(3)
                SUM=TEMP*TEMP+SUM
                AT(I,NAT(NS),NS)=T(I)
                AT(I+4,NAT(NS),NS)=TEMP
              ENDDO
              SUM=SQRT(SUM)
              AT(4,NAT(NS),NS)=SUM
              IF (SUM .LT. AIM(1)) THEN
                WRITE (WRLINE,'(A)')
CYENG1
     +          'ZVZFND194 - Warnung! Nullvektor ignoriert.'
CYENG2
CYENGY     +          'ZVZFND194 - Warning! Zero vector ignored.'
                CALL KPWRTE (NTOUT)
                NAT(NS)=NAT(NS)-1
              ENDIF
            ENDIF
  210       CONTINUE
          ENDDO  ! NEXT NB
        ENDIF
      ENDDO  ! NEXT NA
      I=NAT(NS)-NATTL-3
      WRITE (WRLINE,'(I4,A)')
CYENG1
     + I,' zusaetzliche Translationsvektoren gefunden.'
CYENG2
CYENGY     + I,' additional translation vectors found.'
      CALL KPWRTE (NTOUT )
      IF (I .EQ. 0) GO TO 999
C
C                            Sortiere die kandidaten.
      I=NATTL+1
  220 J=I
      I=I+1
      DO  K=1,8
        Q(K)=AT(K,I,NS)
      ENDDO
      GO TO 240
C
  230 DO  K=1,8
        IAT(K,J+1,NS)=IAT(K,J,NS)
      ENDDO
      J=J-1
      IF (J .LE. NATTL) GO TO 250
  240 IF (Q(4) .LT. AT(4,J,NS)) GO TO 230
  250 DO  K=1,8
        AT(K,J+1,NS)=Q(K)
      ENDDO
      IF (I .LT. NAT(NS)) GO TO 220
C
      IF (ISKP(58) .GT. 0) THEN
        DO  I=NATTL+1,NAT(NS)
          J=I-NATTL
          WRITE (WRLINE,'(I4,7F10.5)') J,(AT(J,I,NS),J=1,7)
          CALL KPWRTE (NTOUT )
        ENDDO
      ENDIF
C
C       Baue jetzt eine basis aus moeglichst kurzen vektoren auf.
C
      DO  MA=NATTL+1,NAT(NS)-2
        DO  I=1,3
          S(I,1)=AT(I+4,MA,NS)
          AIN(I)=AT(I,MA,NS)
        ENDDO
        DO  MB=MA+1,NAT(NS)-1
          SUM=0.
          DO  I=1,3
            S(I,2)=AT(I+4,MB,NS)
            AIN(I+3)=AT(I,MB,NS)
            SUM=SUM+S(I,1)*S(I,2)
          ENDDO
          IF (SUM/(AT(4,MA,NS)*AT(4,MB,NS)) .LT. 0.85) GO TO 260
        ENDDO  ! NEXT MB
        GO TO 270
  260   DO  MC=NATTL+1,NAT(NS)
          IF (MC .NE. MA .AND. MC .NE. MB) THEN
            DO  I=1,3
              S(I,3)=AT(I+4,MC,NS)
              AIN(I+6)=AT(I,MC,NS)
            ENDDO
C                            Berechne determinante.
            TEMP=0.
            DO  I=1,3
              J=ID2(I)
              K=ID2(J)
              TEMP=TEMP+S(I,1)*S(J,2)*S(K,3)-S(K,1)*S(J,2)*S(I,3)
            ENDDO
            IF (ABS(TEMP) .GT. 1.0) THEN
              IF (TEMP .LT. 0.) THEN
                DO  I=1,3
                  S(I,1)=-S(I,1)
                  AIN(I)=-AIN(I)
                ENDDO
              ENDIF
              GO TO 280
            ENDIF
          ENDIF
        ENDDO  ! NEXT MC
  270   CONTINUE
      ENDDO  ! NEXT MA
      WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVZFND381 - Es kann keine Basis konstruiert werden.'
CYENG2
CYENGY     + 'ZVZFND381 - Unable to construct a basis.'
      CALL KPWRTE (NTOUT )
      GO TO 999
C                            Fuehre TZ aus.
  280 CONTINUE
      ISKP(14)=1
      NTYP=2
      CALL ZVZ
      ISKP(14)=0
      IF (IERR .NE. 0) GO TO 999
      NAT(NS)=NATSV
      M=IAIM(2)
C                            NPZ?
      IF (M .GE. 2) THEN
        M=M-2
        NTYP=5
        ISKP(14)=1
        CALL ZVGC03
        ISKP(14)=0
        IF (IERR .NE. 0) GO TO 999
      ENDIF
C                            RPSY?
      IF (M .GE. 1) THEN
        IAIN(1)=ISKP(53)
        IAIN(2)=NAT(NS)
        AIN(3)=-2.
        IAIN(4)=-1
        IAIN(5)=-1
        ISKP(14)=1
        NTYP=1
        CALL ZVRPSY
        NATSV=NAT(NS)
      ENDIF
C
  999 CONTINUE
      NAT(NS)=NATSV
      RETURN
      END
