C         88              -------------------
                           SUBROUTINE ZVZIDL
C   CY-ENG-               -------------------
C
C                    Idealisiert gitterkonstanten.
C
C                 geschrieben: 301137 NOV 1997 (Hundt)
C                   geaendert: 270926 APR 2000 (Hundt)
C
C                         -------------------
C
      IMPLICIT NONE
      INCLUDE 'ZVCOM.INC'
      INCLUDE 'WRBFR.INC'
C
      INTEGER *4 IAIN(72),I,J,K,L,M,NATS,I1,I2,I3,I4,I6,IR,ICA(2)
      INTEGER *4 ITEMP,LTYP,IPMAX,I1M,I2M
      INTEGER *4 IAMERK,ICMERK(6),IPP,ISYMFL
      INTEGER *4 NSYMSV
      INTEGER *4 LOTYP,J1,J2,NTYPS
      REAL    *4 TEMP2,TEMP3,TOLCOL,TOLGT
      REAL    *4 SINV(3,3),SINVL(9),AL1,AL2,TEMP,ARCCOS,WKTAB(7)
      REAL    *4 TEMP4,TEMP5
C
      EQUIVALENCE (AIN(1),IAIN(1)),(SINV(1,1),SINVL(1))
C
      DATA WKTAB/30.,60.,120.,150.,45.,135.,90./
C
C                            ZIDL - Idealisiere zelle.
C                            Loesche liste mit ausgez. richtungen.
      NTYPS=NTYP
C                            Generiere punkte, sofern keine vorhanden.
      NATS=NAT(NS)
      IF (NAT(NS) .LT. 2) NAT(NS)=2
      NSYMSV=NSYM(NS)
      IF (NSYM(NS) .LT. 1) NSYM(NS)=1
      ISKP(14)=1
      CALL ZVTEAC (IAIN,IAIN,ISKP(14))
C
C                            Save symmetrien bis auf zentrierende.
      ISYMFL=0
      NTYP=4
      CALL ZVTSZR
      IF (IERR .NE. 0) GO TO 990
      ISYMFL=1
      NAT(NS)=2
      CONST(48)=2.
      CALL FLES (CONST(45),ISKP(31),3H4FE,
CYENG1
     + 34HTol. f. Abst.,Winkel,Ebenen,opt? $)
CYENG2
CYENGY     + 34HTol. f. dist.,angles,planes,opt? $)
      WRITE (WRLINE,'(A,F6.3,A,F7.3,A,F6.3,A,F4.1)')
CYENG1
     +'Toleranzen fuer Abstaende:',CONST(45),', Winkel:',
     +CONST(46),' und Ebenen:',CONST(47),' opt=',CONST(48)
CYENG2
CYENGY     +  'Tolerances for distances:',CONST(45),', angles:',
CYENGY     +  CONST(46),' and planes:',CONST(47),' opt=',CONST(48)
      CALL KPWRTE (NTOUT)
      TOLGT=CONST(45)*0.5
      TOLCOL=COS(CONST(46)*CONST(3))
      IPMAX=2
      LOTYP=0
C                            Unterdruecke meldung: Code ueberlauf.
      ISKP(66)=1
C                            Suche 6-zaehlige achse.
      DO  I=1,ISYPOI
        IF (ABS(IROTSV(I)) .EQ. 6) THEN
          LTYP=5
          IPMAX=3
          GO TO 230
        ENDIF
      ENDDO
C                            Suche zwei vierzaehlige achsen ...
      I=0
      DO  J=1,ISYPOI
        IF (ABS(IROTSV(J)) .EQ. 4) THEN
          IF (I .NE. 0) THEN
            LTYP=6
            GO TO 230
          ENDIF
          I=J
        ENDIF
      ENDDO
C                          ... oder suche magischen winkel zwischen
C                          dreizaehliger und 2- oder 4-zaehliger achse.
      NTRY=26
      NC=1
      ITEMP=0
      DO  I=1,ISYPOI
        IF (ABS(IROTSV(I)) .EQ. 4) ITEMP=I
        IF (ABS(IROTSV(I)) .EQ. 4 .OR. ABS(IROTSV(I)) .EQ. 2) THEN
          ICDS(1)=400001+IDIRSV(I)*200
          CALL ZVDEK
          DO  K=1,3
            X2(K)=X1(K)
          ENDDO
          AL1=SQRT(X2(1)*X2(1)+X2(2)*X2(2)+X2(3)*X2(3))
          DO  K=1,ISYPOI
            IF (ABS(IROTSV(K)) .EQ. 3) THEN
              ICDS(1)=400001+IDIRSV(K)*200
              CALL ZVDEK
              AL2=SQRT(X1(1)*X1(1)+X1(2)*X1(2)+X1(3)*X1(3))
              TEMP=AL1*AL2
              IF (TEMP .NE. 0.) THEN
                TEMP=ARCCOS((X1(1)*X2(1)+X1(2)*X2(2)+X1(3)*X2(3))/TEMP)
                IF (ABS(TEMP-54.7356) .LE. CONST(46) .OR.
     +          ABS(TEMP-125.2644) .LE. CONST(46)) THEN
                  LTYP=6
                  GO TO 230
                ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDIF
      ENDDO
      IF (ITEMP .NE. 0) THEN
        I=ITEMP
        LTYP=4
        GO TO 230
      ENDIF
C                            Suche nach dreizaehliger achse.
      DO  I=1,ISYPOI
        IF (ABS(IROTSV(I)) .EQ. 3) THEN
          LTYP=5
          IPMAX=3
          GO TO 230
        ENDIF
      ENDDO
C                            Suche nach mehreren zweizaehligen achsen.
      K=0
      DO  I=1,ISYPOI
        IF (ABS(IROTSV(I)) .EQ. 2) THEN
          IF (K .LT. 6) THEN
            K=K+1
            ICMERK(K)=I
          ENDIF
        ENDIF
      ENDDO
      IF (K .GE. 2) THEN
C                            Teste, inwieweit diese 2-achsen
C                            aufeinander senkrecht stehen.
        ITEMP=K
        I4=0
        I6=0
        IR=0
        I3=0
        J1=0
        J2=0
        DO  I1=1,ITEMP-1
          ICA(1)=400001+IDIRSV(ICMERK(I1))*200
          DO  I2=I1+1,ITEMP
            ICDS(1)=ICA(1)
            ICDS(2)=2
            ICA(2)=400001+IDIRSV(ICMERK(I2))*200
            ICDS(3)=ICA(2)
            NTYP=5
            ISKP(14)=1
            CALL ZVGE02
            IF (IERR .NE. 0) GO TO 990
            DO  I=1,7
              IF (ABS(CONST(6)-WKTAB(I)) .LE. CONST(46)) THEN
                IF (I .LE. 4) THEN
                  I6=I6+1
                  I3=6
                ELSE IF (I .LE. 6) THEN
                  I3=4
                  J1=I1
                  J2=I2
                  I4=I4+1
                ELSE
                  IR=IR+1
                ENDIF
                I1M=I1
                I2M=I2
                GO TO 10
              ENDIF
            ENDDO
            WRITE (WRLINE,'(A,A,F7.2,A,I4,A,I4,A)') 'ZVZIDL0180 - ',
CYENG1
     +      'Winkel',CONST(6),' zwischen',IDIRSV(ICMERK(I1)),' und',
     +      IDIRSV(ICMERK(I2)),' nicht zuzuordnen.'
CYENG2
CYENGY     +      'Angel',CONST(6),' between',IDIRSV(ICMERK(I1)),' and',
CYENGY     +      IDIRSV(ICMERK(I2)),' not assignable.'
            CALL KPWRTE (NTDISP)
            IERR=-1
   10       CONTINUE
          ENDDO
        ENDDO
        IF (IERR .NE. 0) GO TO 990
        IF (I4 .NE. 0 .AND. I6 .NE. 0) THEN
C
C                            System scheint kubisch zu sein.
          I1M=J1
          I2M=J2
          I3=4
        ENDIF
        ICA(1)=400001+IDIRSV(ICMERK(I1M))*200
        ICA(2)=400001+IDIRSV(ICMERK(I2M))*200
        IF (I4+I6 .NE. 0 .OR. ITEMP .EQ. 2) THEN
C
C                          Suche eine geeignete achse im gitter,
C                          die senkrecht auf den beiden achsen steht.
   20     DO  I=1,ISYPOI
            IF ((I3 .EQ. 0 .AND. MOD(IROTGT(I),2) .EQ. 0) .OR.
     +        IROTGT(I) .EQ. I3) THEN
              DO  I1=1,2
                ICDS(1)=ICA(I1)
                ICDS(2)=2
                ICDS(3)=400001+IDIRSV(I)*200
                NTYP=5
                ISKP(14)=1
                CALL ZVGE02
                IF (IERR .NE. 0) GO TO 990
                IF (ABS(CONST(6)-WKTAB(7)) .GT. CONST(46)) GO TO 30
              ENDDO
C                            Erfolg!
C
              IF (I4 .NE. 0 .AND. I6 .NE. 0) THEN
                LTYP=6
                GO TO 230
              ENDIF
              IF (I3 .EQ. 6) THEN
                LTYP=5
                IPMAX=3
                GO TO 230
              ENDIF
              IF (I3 .EQ. 4) THEN
                LTYP=4
                GO TO 230
              ENDIF
              ICMERK(3)=I
              GO TO 200
            ENDIF
   30       CONTINUE
          ENDDO
          GO TO 470
        ENDIF
  200   LTYP=3
C                            Orthorhombischer fall. Nimm
C                            die achsen selber.
        DO  I=1,3
          ICD(I,NS)=400001+IDIRSV(ICMERK(I))*200
        ENDDO
        NCD(NS)=3
C                          Definiere das koordinatensystem.
        ICDS(1)=2
        ICDS(2)=2
        ICDS(3)=ICD(3,NS)
        ICDS(4)=2
        ICDS(5)=ICD(1,NS)
        LOTYP=4
        GO TO 230
      ENDIF
      IF (K .EQ. 1) THEN
        LTYP=2
        I=ICMERK(1)
        GO TO 230
      ENDIF
C                            Triklin
      LTYP=1
  230 CONTINUE
CYENG1
      WRITE (WRLINE,'(A,I2)') 'Idealisierung erfolgt gemaess Typ',LTYP
CYENG2
CYENGY      WRITE (WRLINE,'(A,I2)') 'Idealisation according to type',LTYP
      CALL KPWRTE (NTOUT)
      IF (LTYP .LE. 1) GO TO 990
C
C                            Stelle koordinatensystem in die
C                            ermittelte richtung ...
      IF (LOTYP .LT. 2) THEN
        ICDS(1)=2
        ICDS(2)=2
        IAMERK=400001+IDIRSV(I)*200
        ICDS(3)=IAMERK
        ICDS(4)=0
      ENDIF
      ISKP(14)=1
      NTYP=1
      CALL ZVK
      IF (IERR .NE. 0) GO TO 990
      IF (LOTYP .EQ. 4) THEN
C                            Berechne freie Koordinaten.
        NTRY=44
        NC=1
        DO  IC=1,NCD(NS)
          CALL ZVDEK
          DO  I=1,3
            ATOMS(I,IC,NS)=X2(I)
          ENDDO
        ENDDO
        I1=1
        I2=2
        GO TO 400
      ENDIF
      IF (LOTYP .LT. 2) THEN
C                            ... berechne laenge von IAMERK via AKB ...
        NC=3
        NTRY=28
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 990
        AIN(3)=X2(1)*1.1
        L=5
      ELSE
        ISKP(14)=1
        NTYP=8
        CALL ZVK
        CALL ZVK
        AIN(3)=AMAX1(ZELLE(1,NS),ZELLE(2,NS),ZELLE(3,NS))*1.6
        L=1
      ENDIF
C                            ... und suche punkte via AKB.
  240 NCD(NS)=0
      IAIN(1)=2
      IAIN(2)=2
      AIN(4)=CONST(47)
      AIN(5)=CONST(47)
      ISKP(14)=1
      NTYP=2
      CALL ZVAVBR
      IF (IERR .NE. 0) GO TO 990
      IF (LOTYP .LT. 2) THEN
        IF (NCD(NS) .LT. 3) GO TO 330
C
C                            Wenn es nur drei punkte sind, brauchen
C                            wir uns keine muehe zu geben.
C
        IF (NCD(NS) .EQ. 3) GO TO 280
      ELSE
        IF (NCD(NS) .LT. 3) THEN
          L=L+1
          AIN(3)=AIN(3)*1.5
          IF (L .LT. 5) GO TO 240
          GO TO 330
        ENDIF
      ENDIF
      IAIN(1)=1
      NTYP=2
      ISKP(14)=1
      CALL ZVSRT
      IF (IERR .NE. 0) GO TO 990
C
C                            Suche code 255501 ...
      I=1
  250 IF (ICD(I,NS) .EQ. 511001) GO TO 270
      I=I+1
      IF (I .LE. NCD(NS)) GO TO 250
      GO TO 330
C
  260 IAMERK=ICD(I,NS)
      IF (LOTYP .EQ. 2) THEN
        IF (LTYP .EQ. 3) THEN
          K=1
          DO  I=1,3,2
            M=IDIRSV(ICMERK(K))*200
            ICD(I,NS)=400001+M
            ICD(I+1,NS)=400001+222000-M
            K=K+1
          ENDDO
          ICD(5,NS)=IAMERK
          NCD(NS)=5
        ELSE
          LOTYP=0
        ENDIF
      ENDIF
      GO TO 280
  270 I=I+1
      IF (I .LE. NCD(NS)) GO TO 260
      GO TO 330
C
  280 IF (ISKP(58) .GT. 0) THEN
        WRITE (WRLINE,'(A,I10)')
CYENG1
     +  'Als ausgezeichneten Punkt verwendet:',IAMERK
CYENG2
CYENGY     +  'Point used to define the direction:',IAMERK
        CALL KPWRTE (NTOUT)
      ENDIF
C
C                            Setze ein AKB fuer die flaeche auf ...
C
      TEMP=AMAX1(ZELLE(1,NS),ZELLE(2,NS),ZELLE(3,NS))*1.6
      L=1
      IF (LOTYP .NE. 0) GO TO 300
  290   NCD(NS)=0
        IAIN(1)=2
        IAIN(2)=2
        AIN(3)=CONST(47)
        AIN(4)=TEMP
        AIN(5)=TEMP
        ISKP(14)=1
        NTYP=2
        CALL ZVAVBR
        IF (IERR .NE. 0) GO TO 990
        IF (NCD(NS) .LT. 5) GO TO 330
C
C
C                            ... bringe den punkt der ausgezeichneten
C                            achse auf den letzten platz ...
        NCD(NS)=NCD(NS)+1
        ICD(NCD(NS),NS)=IAMERK
C                            ... und eleminiere 255501.
  300   IC=0
        NTRY=44
        DO  J=1,NCD(NS)
          IF (ICD(J,NS) .EQ. 511001) GO TO 310
          IC=IC+1
          ICD(IC,NS)=ICD(J,NS)
          CALL ZVDEK
          IF (IERR .NE. 0) GO TO 990
          DO  M=1,3
            ATOMS(M,IC,NS)=X2(M)
          ENDDO
  310     CONTINUE
        ENDDO
        NCD(NS)=IC
C                            Im hexagonalen (trigonalen) system
C                            sollten es mindestens 6 punkte in der
C                            ebene sein; sonst muss der suchbereich
C                            vergroessert werden.
        J=5
        IF (LTYP .EQ. 5) J=7
        IF (NCD(NS) .LT. J) GO TO 330
C
C                            Suche die IPMAX kleinsten vektoren,
C                            die nicht kollinear sind. Im kubischen
C                            fall brauchen wir noch die laenge von
C                            IAMERK.
C
        AL1=SQRT(ATOMS(1,NCD(NS),NS)**2+ATOMS(2,NCD(NS),NS)**2+
     +  ATOMS(3,NCD(NS),NS)**2)
        IPP=0
        DO  I=1,NCD(NS)-1
          AL2=SQRT(ATOMS(1,I,NS)**2+ATOMS(2,I,NS)**2+ATOMS(3,I,NS)**2)
          IF (LTYP .EQ. 6 .AND. ABS(AL1-AL2) .GT.
     +     (AL1+AL2)*TOLGT) GO TO 320
C
C                            Suche zuerst einen kollinearen vektor.
          DO  J=1,IPP
            M=ICMERK(J)
            IF (ABS((ATOMS(1,I,NS)*ATOMS(1,M,NS)+
     +        ATOMS(2,I,NS)*ATOMS(2,M,NS)+ATOMS(3,I,NS)*ATOMS(3,M,NS))/
     +        (AL2*X1(J))).GE.TOLCOL) THEN
C
C                            Gefunden. Ueberschreibe wenn kleiner.
C
              IF (AL2 .LT. X1(J)) THEN
                ICMERK(J)=I
                X1(J)=AL2
              ENDIF
              GO TO 320
            ENDIF
          ENDDO
C                            Nicht gefunden. Teste, ob noch
C                            aufnahmefaehig.
C
          IF (IPP .LT. IPMAX) THEN
            IPP=IPP+1
            ICMERK(IPP)=I
            X1(IPP)=AL2
            GO TO 320
          ELSE
C                            Nicht mehr aufnahmefaehig.
C                            Suche den groessten ...
            TEMP2=0.
            M=0
            DO  J=1,IPP
              IF (X1(J) .GT. TEMP2) THEN
                TEMP2=X1(J)
                M=J
              ENDIF
            ENDDO
            IF (AL2 .LT. TEMP2) THEN
              ICMERK(M)=I
              X1(M)=AL2
            ENDIF
          ENDIF
  320     CONTINUE
        ENDDO
        IF (IPP .GE. IPMAX) GO TO 340
C
C                            Bei hexagonalen, tetragonalen und
C                            kubischen zellen braucht nicht
C                            vergroessert zu werden.
C
        IF (LTYP .GT. 3) THEN
          IF (LTYP .NE. 6 .OR. NCD(NS) .GE. 9) GO TO 380
        ENDIF
C
C                            Nicht genung gefunden. Vergroessere den
C                            suchbereich.
  330   TEMP=TEMP*1.5
      L=L+1
      IF (L .LE. 5) GO TO 290
      WRITE (WRLINE,'(A)')
CYENG1
     + 'ZVZIDL0498 - Nicht genuegend Punkte gefunden.'
CYENG2
CYENGY     + 'ZVZIDL0498 - Not enough points found.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 990
C                            Teste jetzt auf plausibilitaet.
  340 CONTINUE
      TEMP3=1000.
      I3=0
      J1=1
      J2=2
      IF (LTYP .GE. 3) THEN
        TEMP=90.
        IF (LTYP .EQ. 5) TEMP=120.
        DO  I=1,IPP-1
          I1=ICMERK(I)
          DO  J=I+1,IPP
            I2=ICMERK(J)
            TEMP2=ARCCOS((ATOMS(1,I1,NS)*ATOMS(1,I2,NS)+
     +      ATOMS(2,I1,NS)*ATOMS(2,I2,NS)+
     +      ATOMS(3,I1,NS)*ATOMS(3,I2,NS))/(X1(I)*X1(J)))
            IF (ISKP(58) .GT. 0) THEN
              WRITE (WRLINE,'(A,F9.4,A)')
CYENG1
     +        'Winkel',TEMP2,' berechnet.'
CYENG2
CYENGY     +        'Angle',TEMP2,' calculated.'
              CALL KPWRTE (NTDISP)
            ENDIF
            TEMP4=ABS(TEMP2-TEMP)
            IF (TEMP4 .LT. TEMP3) THEN
              TEMP3=TEMP4
              TEMP5=TEMP2
            ENDIF
            IF (TEMP .EQ. 120.) THEN
              IF (TEMP2 .GE. 90.) THEN
                IF (TEMP4 .LE. CONST(46)) THEN
                  J1=I
                  J2=J
                  GO TO 350
                ENDIF
              ENDIF
            ELSE
              IF (TEMP4 .GT. CONST(46)) THEN
                IF (ABS(TEMP2-45.) .LT. CONST(46) .OR.
     +              ABS(TEMP2-135.) .LT. CONST(46)) I3=1
                IF (ABS(TEMP2-60.) .LT. CONST(46) .OR.
     +              ABS(TEMP2-120.) .LT. CONST(46)) I3=2
                TEMP2=TEMP5
                GO TO 360
              ELSE
                J1=I
                J2=J
                GO TO 350
              ENDIF
            ENDIF
          ENDDO
        ENDDO
        TEMP2=TEMP5
        GO TO 360
      ENDIF
C                            Teste jetzt die orthogonalitaet
C                            bezueglich der ausgezeichneten achse.
  350 TEMP=90.
      DO  I=1,IPP
        I1=ICMERK(I)
        TEMP2=ARCCOS((ATOMS(1,I1,NS)*ATOMS(1,NCD(NS),NS)+
     +  ATOMS(2,I1,NS)*ATOMS(2,NCD(NS),NS)+
     +  ATOMS(3,I1,NS)*ATOMS(3,NCD(NS),NS))/(X1(I)*AL1))
        IF (ISKP(58) .GT. 0) THEN
          WRITE (WRLINE,'(A,F9.4,A,F6.1,A)')
CYENG1
     +    'Winkel',TEMP2,' sollte',TEMP,' sein.'
CYENG2
CYENGY     +    'Angle',TEMP2,' should be',TEMP,' .'
          CALL KPWRTE (NTDISP)
        ENDIF
        IF (ABS(TEMP2-TEMP) .GT. CONST(46)) THEN
          IF (ABS(TEMP2-45.) .LT. CONST(46) .OR.
     +        ABS(TEMP2-135.) .LT. CONST(46)) I3=1
          IF (ABS(TEMP2-60.) .LT. CONST(46) .OR.
     +        ABS(TEMP2-120.) .LT. CONST(46)) I3=2
          GO TO 360
        ENDIF
      ENDDO
      GO TO 370
C
  360 WRITE (WRLINE,'(A,F7.2,A,F7.2,A)')
CYENG1
     +'ZVZIDL0588 - Der Winkel ',TEMP2,
     +' weicht zu stark vom Idealwert',TEMP,' ab. Keine Idealisierung.'
CYENG2
CYENGY     +  'ZVZIDL0588 - The deviation of the angle ',TEMP2,
CYENGY     +  ' from die ideal value',TEMP,' is too large. No idealisation.'
      CALL KPWRTE (NTDISP)
      IF (I3 .NE. 0) THEN
        IF (I3 .EQ. 1) WRITE (WRLINE,'(A)')
CYENG1
     +  'Das System scheint tetragonal zu sein.'
CYENG2
CYENGY     +  'System seems to be tetragonal.'
        IF (I3 .EQ. 2) WRITE (WRLINE,'(A)')
CYENG1
     +  'Das System scheint hexagonal zu sein.'
CYENG2
CYENGY     +  'System seems to be hexagonal.'
        CALL KPWRTE (NTDISP)
      ENDIF
      IERR=-1
      GO TO 990
C
  370 IF (LTYP .GE. 4) THEN
        IF (ABS(X1(J1)-X1(J2)) .GT. (X1(J1)+X1(J2))*TOLGT) GO TO 380
      ENDIF
      IF (LTYP .NE. 6 .OR.
     +  (ABS(AL1-X1(J1)) .LE. (AL1+X1(J1))*TOLGT .AND.
     +  ABS(AL1-X1(J2)) .LE. (AL1+X1(J2))*TOLGT)) GO TO 390
  380 WRITE (WRLINE,'(A,A)')
CYENG1
     +  'ZVZIDL0618 - Zwei Abstaende, die gleich sein sollten,',
     +  ' weichen zu stark voneinander ab. Keine Idealisierung.'
CYENG2
CYENGY     +  'ZVZIDL0618 - Two distances which should be equal ',
CYENGY     +  'are too different. No idealisation.'
      CALL KPWRTE (NTDISP)
      IERR=-1
      GO TO 990
C                            Stelle fest, ob die achsen richtig liegen.
  390 I1=ICMERK(J1)
      I2=ICMERK(J2)
  400 IF (ATOMS(2,I1,NS)*ATOMS(3,I2,NS)-ATOMS(3,I1,NS)*ATOMS(2,I2,NS)
     + .LT. 0) THEN
        M=I1
        I1=I2
        I2=M
      ENDIF
      ICDS(1)=ICD(I1,NS)
      ICDS(2)=ICD(I2,NS)
      ICDS(3)=ICD(NCD(NS),NS)
      NTRY=24
      K=0
      DO  NC=1,3
        CALL ZVDEK
        IF (IERR .NE. 0) GO TO 990
        DO  J=1,3
          K=K+1
          AIN(K)=X(J,NC)
        ENDDO
      ENDDO
C                            Restore symmetrien.
      NTYP=5
      CALL ZVTSZR
      ISYMFL=0
C                            Keine transformation der symmetrien und
C                            der koordinaten, wenn opt=0.
C
      IF (CONST(48) .EQ. 0.) THEN
        NAT(NS)=2
        NSYM(NS)=1
      ELSE
        NSYM(NS)=NSYMSV
        NAT(NS)=NATS
      ENDIF
C                            Fuehre transformation aus.
  410 ISKP(14)=1
      NTYP=2
      ISKP(31)=9
      IF (ISKP(58) .GT. 0 .OR. CONST(48) .NE. 0.) THEN
        WRITE (WRLINE,'(A,9F8.5)') 'TZ',(AIN(I),I=1,9)
        CALL KPWRTE (NTDISP)
      ENDIF
      TEMP=ZELLE(7,NS)
      CALL ZVZ
      IF (IERR .NE. 0) GO TO 990
C
C                            Kopiere inverse matrix ...
      L=40
      DO  J=1,3
        DO  K=1,3
          SINV(K,J)=AIN(L)
          L=L+1
        ENDDO
        L=L+1
      ENDDO
C
      IF (CONST(48) .NE. 0.) THEN
        TEMP=ZELLE(7,NS)/TEMP
        IF (ABS(TEMP-1.) .GT. 0.01) THEN
          WRITE (WRLINE,'(A,F10.5,A)')
CYENG1
     +    'Das neue Zellvolumen ist',TEMP,' mal das alte.'
CYENG2
CYENGY     +    'The new cell volume is',TEMP,' times the old one.'
          CALL KPWRTE (NTOUT)
        ENDIF
CYENG1
        WRITE (WRLINE,'(A)') 'Transformierte alte Basis:'
CYENG2
CYENGY        WRITE (WRLINE,'(A)') 'Transformed old basis:'
        CALL KPWRTE (NTOUT)
        WRITE (WRLINE,'(3(3F7.4,2X))') (SINVL(J),J=1,9)
        CALL KPWRTE (NTOUT)
        IF (CONST(48) .GT. 1.) THEN
          IF (TEMP .GT. 0.95) THEN
C
C                            Entferne ggf. doppelte symmetrien ...
            NTYP=3
            CALL ZVGRTS
C                            ... und fuehre zentrierungen ein.
            DO  J=1,3
              DO  I=1,3
                TEMP=SINV(I,J)
                GO TO 430
  420           TEMP=TEMP+1.
  430           IF (TEMP .LT. 0.) GO TO 420
                GO TO 450
  440           TEMP=TEMP-1.
  450           IF (TEMP .GE. 1.) GO TO 440
                IF (TEMP .LT. 0.) TEMP=0.
                AIN(I)=TEMP
              ENDDO
              NSYMSV=NSYM(NS)
              ISKP(14)=1
              NTYP=2
              CALL ZVGRTS
              IF (IERR .NE. 0) THEN
                WRITE (WRLINE,'(A,A)') 'ZVZIDL0724 - ',
CYENG1
     +          'Kann Zentrierung nicht einfuehren.'
CYENG2
CYENGY     +          'Unable to introduce centering symmetry.'
                CALL KPWRTE (NTDISP)
                GO TO 990
              ENDIF
              NSYMSV=NSYM(NS)
            ENDDO
C                            Gab es zelle-verkleinernde symmetrien?
            NTYP=4
            CALL ZVGRTS
            IF (IAIN(10) .NE. 0) GO TO 410
C
C                            Vervollstaendige vorsichtshalber
C                            die symmetrien zu einer gruppe.
            ISKP(14)=1
            NTYP=1
            CALL ZVGRTS
            NSYMSV=NSYM(NS)
            IF (IERR .NE. 0) GO TO 990
          ELSE
            IF (TEMP .LT. 0.99) THEN
C
C                            Entferne ggf. doppelt vorhandene
C                            symmetrien und redundante atome.
              NTYP=3
              CALL ZVGRTS
              NSYMSV=NSYM(NS)
              IAIN(1)=ISKP(53)
              IAIN(2)=NAT(NS)
              AIN(3)=0.5
              IAIN(4)=-1
              IAIN(5)=0
              ISKP(14)=1
              NTYP=1
              CALL ZVRPSY
              NATS=NAT(NS)
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C                            ... buegele winkel ...
      ZELLE(4,NS)=90.
      ZELLE(5,NS)=90.
      IF (LTYP .GE. 3) THEN
        TEMP=90.
        IF (LTYP .EQ. 5) TEMP=120.
        IF (ABS(ZELLE(6,NS)-60.) .LT. CONST(46)) TEMP=60.
        ZELLE(6,NS)=TEMP
      ENDIF
C                            ... und ggf. achsen ...
      IF (LTYP .GE. 4) THEN
        IF (LTYP .EQ. 6) THEN
          TEMP=(ZELLE(1,NS)+ZELLE(2,NS)+ZELLE(3,NS))/3.
          J=3
        ELSE
          TEMP=(ZELLE(1,NS)+ZELLE(2,NS))/2.
          J=2
        ENDIF
        DO  I=1,J
          ZELLE(I,NS)=TEMP
        ENDDO
      ENDIF
      IF (ISKP(58) .GT. 0) THEN
        WRITE (WRLINE,'(A,3F8.4,3F8.3)') 'Z',(ZELLE(I,NS),I=1,6)
        CALL KPWRTE (NTDISP)
      ENDIF
      ISKP(14)=1
      NTYP=1
      CALL ZVZ
      ISYPOI=0
      IZEPOI=0
C                            ... und transformiere wieder zurueck,
C                            aber nur, falls opt = 0.
C
      IF (CONST(48) .NE. 0.) GO TO 460
      DO  I=1,9
        AIN(I)=SINVL(I)
      ENDDO
      IF (ISKP(58) .GT. 0) THEN
        WRITE (WRLINE,'(A,9F8.5)') 'TZ',(AIN(I),I=1,9)
        CALL KPWRTE (NTDISP)
      ENDIF
      ISKP(14)=1
      NTYP=2
      ISKP(31)=9
      CALL ZVZ
      GO TO 460
C
  470 WRITE (WRLINE,'(A,A)')
CYENG1
     +'ZVZIDL0816 - Keine geeignete dritte Achse gefunden.',
     +' Keine Idealisierung.'
CYENG2
CYENGY     +'ZVZIDL0816 - No suitable third axis found.',
CYENGY     +' No idealisation.'
      CALL KPWRTE (NTDISP)
      IERR=-1
C                            Restore.
  460 NCD(NS)=0
C                            Reset ggf. koordinatensystem.
  990 IF (NTYPS .NE. 2) THEN
        ISKP(14)=1
        NTYP=3
        CALL ZVZ
      ENDIF
      IF (ISYMFL .NE. 0) THEN
        NTYP=5
        CALL ZVTSZR
      ENDIF
      NSYM(NS)=NSYMSV
      NAT(NS)=NATS
      ISKP(66)=0
      ISKP(14)=0
C
  999 RETURN
      END
